"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Te=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/nls","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/uuid","fs","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/base/node/pfs","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","os","vs/base/common/process","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/charCode","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/iterator","vs/platform/telemetry/common/telemetryUtils","vs/platform/contextkey/common/contextkey","vs/base/common/json","vs/base/common/stopwatch","vs/base/common/performance","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/editor/common/core/range","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc","vs/platform/files/common/watcher","vs/platform/terminal/common/terminal","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/platform/product/common/product","vs/base/common/semver/semver","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/hash","vs/base/common/ternarySearchTree","path","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/glob","vs/base/node/zip","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/storage/common/storage","vs/server/node/serverConnectionToken","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/encodedTokenAttributes","vs/nls.messages","vs/amdX","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/cssDev/node/cssDevService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/terminal/common/remote/terminal","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/collections","vs/base/common/equals","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/macAddress","vs/base/node/nls","vs/base/node/ports","vs/base/parts/request/common/request","vs/editor/common/core/editOperation","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/editor/common/languages","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/config/editorOptions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/chat/common/languageModels","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","readline","util","minimist","assert","https","http","vs/server/node/server.main"],Oe=function(ue){for(var e=[],t=0,r=ue.length;t<r;t++)e[t]=Te[ue[t]];return e};define(Te[64],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=e.LoaderEventType=e.$W=e.$V=void 0,e.$V=!1,e.$W=!0;var t;(function(E){E[E.LoaderAvailable=1]="LoaderAvailable",E[E.BeginLoadingScript=10]="BeginLoadingScript",E[E.EndLoadingScriptOK=11]="EndLoadingScriptOK",E[E.EndLoadingScriptError=12]="EndLoadingScriptError",E[E.BeginInvokeFactory=21]="BeginInvokeFactory",E[E.EndInvokeFactory=22]="EndInvokeFactory",E[E.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",E[E.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",E[E.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",E[E.NodeEndNativeRequire=34]="NodeEndNativeRequire",E[E.CachedDataFound=60]="CachedDataFound",E[E.CachedDataMissed=61]="CachedDataMissed",E[E.CachedDataRejected=62]="CachedDataRejected",E[E.CachedDataCreated=63]="CachedDataCreated"})(t||(e.LoaderEventType=t={}));class r{static get(){const P=new Map,D=new Map,T=new Map,v=new Map;function s(a,c){a.has(c.detail)||a.set(c.detail,-c.timestamp)}function S(a,c){const m=a.get(c.detail);m&&(m>=0||a.set(c.detail,m+c.timestamp))}let y=[];typeof ue=="function"&&typeof ue.getStats=="function"&&(y=ue.getStats().slice(0).sort((a,c)=>a.timestamp-c.timestamp));for(const a of y)switch(a.type){case t.BeginLoadingScript:s(P,a);break;case t.EndLoadingScriptOK:case t.EndLoadingScriptError:S(P,a);break;case t.BeginInvokeFactory:s(D,a);break;case t.EndInvokeFactory:S(D,a);break;case t.NodeBeginNativeRequire:s(T,a);break;case t.NodeEndNativeRequire:S(T,a);break;case t.NodeBeginEvaluatingScript:s(v,a);break;case t.NodeEndEvaluatingScript:S(v,a);break}let $=0;T.forEach(a=>$+=a);function g(a){const c=[];return a.forEach((m,b)=>c.push([b,m])),c}return{amdLoad:g(P),amdInvoke:g(D),nodeRequire:g(T),nodeEval:g(v),nodeRequireTotal:$}}static toMarkdownTable(P,D){let T="";const v=[];return P.forEach((s,S)=>{v[S]=s.length}),D.forEach(s=>{s.forEach((S,y)=>{typeof S>"u"&&(S=s[y]="-");const $=S.toString().length;v[y]=Math.max($,v[y])})}),P.forEach((s,S)=>{T+=`| ${s+" ".repeat(v[S]-s.toString().length)} `}),T+=`|
`,P.forEach((s,S)=>{T+=`| ${"-".repeat(v[S])} `}),T+=`|
`,D.forEach(s=>{s.forEach((S,y)=>{typeof S<"u"&&(T+=`| ${S+" ".repeat(v[y]-S.toString().length)} `)}),T+=`|
`}),T}}e.$X=r}),define(Te[104],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=void 0,e.$jb=t,e.$kb=r,e.$lb=E,e.$mb=P,e.$nb=D,e.$ob=T,e.$pb=v,e.$rb=S,e.$sb=y,e.$tb=$,e.$ub=g,e.$vb=a;function t(c,m){const b=r(c,m);if(b!==-1)return c[b]}function r(c,m,b=c.length-1){for(let p=b;p>=0;p--){const d=c[p];if(m(d))return p}return-1}function E(c,m){const b=P(c,m);return b===-1?void 0:c[b]}function P(c,m,b=0,p=c.length){let d=b,w=p;for(;d<w;){const o=Math.floor((d+w)/2);m(c[o])?d=o+1:w=o}return d-1}function D(c,m){const b=T(c,m);return b===c.length?void 0:c[b]}function T(c,m,b=0,p=c.length){let d=b,w=p;for(;d<w;){const o=Math.floor((d+w)/2);m(c[o])?w=o:d=o+1}return d}function v(c,m,b=0,p=c.length){const d=T(c,m,b,p);return d===c.length?-1:d}class s{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(s.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!m(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const b=P(this.e,m,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}e.$qb=s;function S(c,m){if(c.length===0)return;let b=c[0];for(let p=1;p<c.length;p++){const d=c[p];m(d,b)>0&&(b=d)}return b}function y(c,m){if(c.length===0)return;let b=c[0];for(let p=1;p<c.length;p++){const d=c[p];m(d,b)>=0&&(b=d)}return b}function $(c,m){return S(c,(b,p)=>-m(b,p))}function g(c,m){if(c.length===0)return-1;let b=0;for(let p=1;p<c.length;p++){const d=c[p];m(d,c[b])>0&&(b=p)}return b}function a(c,m){for(const b of c){const p=m(b);if(p!==void 0)return p}}}),define(Te[34],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var t;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(t||(e.CharCode=t={}))}),define(Te[159],Oe([1,0]),function(ue,e){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$i=void 0,e.$e=r,e.$f=E,e.$g=P,e.$h=D;function r(v,s){const S=Object.create(null);for(const y of v){const $=s(y);let g=S[$];g||(g=S[$]=[]),g.push(y)}return S}function E(v,s){const S=[],y=[];for(const $ of v)s.has($)||S.push($);for(const $ of s)v.has($)||y.push($);return{removed:S,added:y}}function P(v,s){const S=[],y=[];for(const[$,g]of v)s.has($)||S.push(g);for(const[$,g]of s)v.has($)||y.push(g);return{removed:S,added:y}}function D(v,s){const S=new Set;for(const y of s)v.has(y)&&S.add(y);return S}class T{static{t=Symbol.toStringTag}constructor(s,S){this.b=S,this.a=new Map,this[t]="SetWithKey";for(const y of s)this.add(y)}get size(){return this.a.size}add(s){const S=this.b(s);return this.a.set(S,s),this}delete(s){return this.a.delete(this.b(s))}has(s){return this.a.has(this.b(s))}*entries(){for(const s of this.a.values())yield[s,s]}keys(){return this.values()}*values(){for(const s of this.a.values())yield s}clear(){this.a.clear()}forEach(s,S){this.a.forEach(y=>s.call(S,y,y,this))}[Symbol.iterator](){return this.values()}}e.$i=T}),define(Te[79],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=r,e.$di=E,e.$ei=P;function t(D){return(T,v,s)=>{let S=null,y=null;if(typeof s.value=="function"?(S="value",y=s.value):typeof s.get=="function"&&(S="get",y=s.get),!y)throw new Error("not supported");s[S]=D(y,v)}}function r(D,T,v){let s=null,S=null;if(typeof v.value=="function"?(s="value",S=v.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(s="get",S=v.get),!S)throw new Error("not supported");const y=`$memoize$${T}`;v[s]=function(...$){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,$)}),this[y]}}function E(D,T,v){return t((s,S)=>{const y=`$debounce$${S}`,$=`$debounce$result$${S}`;return function(...g){this[$]||(this[$]=v?v():void 0),clearTimeout(this[y]),T&&(this[$]=T(this[$],...g),g=[this[$]]),this[y]=setTimeout(()=>{s.apply(this,g),this[$]=v?v():void 0},D)}})}function P(D,T,v){return t((s,S)=>{const y=`$throttle$timer$${S}`,$=`$throttle$result$${S}`,g=`$throttle$lastRun$${S}`,a=`$throttle$pending$${S}`;return function(...c){if(this[$]||(this[$]=v?v():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),T&&(this[$]=T(this[$],...c)),this[a])return;const m=this[g]+D;m<=Date.now()?(this[g]=Date.now(),s.apply(this,[this[$]]),this[$]=v?v():void 0):(this[a]=!0,this[y]=setTimeout(()=>{this[a]=!1,this[g]=Date.now(),s.apply(this,[this[$]]),this[$]=v?v():void 0},m-Date.now()))}})}}),define(Te[9],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=e.$fb=e.$eb=e.$db=e.$cb=e.$ab=e.$9=e.$1=e.$Z=void 0,e.setUnexpectedErrorHandler=r,e.$3=E,e.$4=P,e.$5=D,e.$6=T,e.$7=v,e.$8=S,e.$0=$,e.$$=g,e.$_=a,e.$bb=m;class t{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?w.isErrorNoTelemetry(n)?new w(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(u=>{u(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$Z=t,e.$1=new t;function r(l){e.$1.setUnexpectedErrorHandler(l)}function E(l){if(!l||typeof l!="object")return!1;const n=l;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function P(l){S(l)||e.$1.onUnexpectedError(l)}function D(l){S(l)||e.$1.onUnexpectedExternalError(l)}function T(l){if(l instanceof Error){const{name:n,message:u}=l,i=l.stacktrace||l.stack;return{$isError:!0,name:n,message:u,stack:i,noTelemetry:w.isErrorNoTelemetry(l)}}return l}function v(l){let n;return l.noTelemetry?n=new w:(n=new Error,n.name=l.name),n.message=l.message,n.stack=l.stack,n}const s="Canceled";function S(l){return l instanceof y?!0:l instanceof Error&&l.name===s&&l.message===s}class y extends Error{constructor(){super(s),this.name=this.message}}e.$9=y;function $(){const l=new Error(s);return l.name=l.message,l}function g(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function a(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class c extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$ab=c;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class b extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$cb=b;class p extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$db=p;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$eb=d;class w extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof w)return n;const u=new w;return u.message=n.message,u.stack=n.stack,u}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$fb=w;class o extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$gb=o}),define(Te[17],Oe([1,0,9,104]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.$cc=e.$ac=e.$_b=e.CompareResult=void 0,e.$wb=E,e.$xb=P,e.$yb=D,e.$zb=T,e.$Ab=v,e.$Bb=s,e.$Cb=S,e.$Db=y,e.$Eb=$,e.$Fb=g,e.$Gb=a,e.$Hb=c,e.$Ib=m,e.top=b,e.$Kb=p,e.$Lb=w,e.$Mb=o,e.$Nb=l,e.$Ob=n,e.$Pb=u,e.$Qb=i,e.$Rb=f,e.$Sb=h,e.$Tb=k,e.$Ub=I,e.$Vb=O,e.$Wb=C,e.$Xb=L,e.$Yb=R,e.$Zb=M,e.$1b=G,e.$2b=Q,e.$3b=te,e.$4b=ve,e.$5b=be,e.$6b=le,e.$7b=K,e.$8b=B,e.$9b=j,e.$0b=ae,e.$$b=ye,e.$bc=X,e.$fc=pe;function E(x,ie=0){return x[x.length-(1+ie)]}function P(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function D(x,ie,W=(Z,ce)=>Z===ce){if(x===ie)return!0;if(!x||!ie||x.length!==ie.length)return!1;for(let Z=0,ce=x.length;Z<ce;Z++)if(!W(x[Z],ie[Z]))return!1;return!0}function T(x,ie){const W=x.length-1;ie<W&&(x[ie]=x[W]),x.pop()}function v(x,ie,W){return s(x.length,Z=>W(x[Z],ie))}function s(x,ie){let W=0,Z=x-1;for(;W<=Z;){const ce=(W+Z)/2|0,we=ie(ce);if(we<0)W=ce+1;else if(we>0)Z=ce-1;else return ce}return-(W+1)}function S(x,ie,W){if(x=x|0,x>=ie.length)throw new TypeError("invalid index");const Z=ie[Math.floor(ie.length*Math.random())],ce=[],we=[],Le=[];for(const ze of ie){const qe=W(ze,Z);qe<0?ce.push(ze):qe>0?we.push(ze):Le.push(ze)}return x<ce.length?S(x,ce,W):x<ce.length+Le.length?Le[0]:S(x-(ce.length+Le.length),we,W)}function y(x,ie){const W=[];let Z;for(const ce of x.slice(0).sort(ie))!Z||ie(Z[0],ce)!==0?(Z=[ce],W.push(Z)):Z.push(ce);return W}function*$(x,ie){let W,Z;for(const ce of x)Z!==void 0&&ie(Z,ce)?W.push(ce):(W&&(yield W),W=[ce]),Z=ce;W&&(yield W)}function g(x,ie){for(let W=0;W<=x.length;W++)ie(W===0?void 0:x[W-1],W===x.length?void 0:x[W])}function a(x,ie){for(let W=0;W<x.length;W++)ie(W===0?void 0:x[W-1],x[W],W+1===x.length?void 0:x[W+1])}function c(x,ie,W){const Z=[];function ce(ze,qe,Re){if(qe===0&&Re.length===0)return;const Ne=Z[Z.length-1];Ne&&Ne.start+Ne.deleteCount===ze?(Ne.deleteCount+=qe,Ne.toInsert.push(...Re)):Z.push({start:ze,deleteCount:qe,toInsert:Re})}let we=0,Le=0;for(;;){if(we===x.length){ce(we,0,ie.slice(Le));break}if(Le===ie.length){ce(we,x.length-we,[]);break}const ze=x[we],qe=ie[Le],Re=W(ze,qe);Re===0?(we+=1,Le+=1):Re<0?(ce(we,1,[]),we+=1):Re>0&&(ce(we,0,[qe]),Le+=1)}return Z}function m(x,ie,W){const Z=c(x,ie,W),ce=[],we=[];for(const Le of Z)ce.push(...x.slice(Le.start,Le.start+Le.deleteCount)),we.push(...Le.toInsert);return{removed:ce,added:we}}function b(x,ie,W){if(W===0)return[];const Z=x.slice(0,W).sort(ie);return d(x,ie,Z,W,x.length),Z}function p(x,ie,W,Z,ce){return W===0?Promise.resolve([]):new Promise((we,Le)=>{(async()=>{const ze=x.length,qe=x.slice(0,W).sort(ie);for(let Re=W,Ne=Math.min(W+Z,ze);Re<ze;Re=Ne,Ne=Math.min(Ne+Z,ze)){if(Re>W&&await new Promise(De=>setTimeout(De)),ce&&ce.isCancellationRequested)throw new t.$9;d(x,ie,qe,Re,Ne)}return qe})().then(we,Le)})}function d(x,ie,W,Z,ce){for(const we=W.length;Z<ce;Z++){const Le=x[Z];if(ie(Le,W[we-1])<0){W.pop();const ze=(0,r.$ob)(W,qe=>ie(Le,qe)<0);W.splice(ze,0,Le)}}}function w(x){return x.filter(ie=>!!ie)}function o(x){let ie=0;for(let W=0;W<x.length;W++)x[W]&&(x[ie]=x[W],ie+=1);x.length=ie}function l(x,ie,W){x.splice(W,0,x.splice(ie,1)[0])}function n(x){return!Array.isArray(x)||x.length===0}function u(x){return Array.isArray(x)&&x.length>0}function i(x,ie=W=>W){const W=new Set;return x.filter(Z=>{const ce=ie(Z);return W.has(ce)?!1:(W.add(ce),!0)})}function f(x){const ie=new Set;return W=>{const Z=x(W);return ie.has(Z)?!1:(ie.add(Z),!0)}}function h(x,ie){return x.length>0?x[0]:ie}function k(x,ie){return x.length>0?x[x.length-1]:ie}function I(x,ie,W=(Z,ce)=>Z===ce){let Z=0;for(let ce=0,we=Math.min(x.length,ie.length);ce<we&&W(x[ce],ie[ce]);ce++)Z++;return Z}function O(x,ie){let W=typeof ie=="number"?x:0;typeof ie=="number"?W=x:(W=0,ie=x);const Z=[];if(W<=ie)for(let ce=W;ce<ie;ce++)Z.push(ce);else for(let ce=W;ce>ie;ce--)Z.push(ce);return Z}function C(x,ie,W){return x.reduce((Z,ce)=>(Z[ie(ce)]=W?W(ce):ce,Z),Object.create(null))}function L(x,ie){return x.push(ie),()=>R(x,ie)}function R(x,ie){const W=x.indexOf(ie);if(W>-1)return x.splice(W,1),ie}function M(x,ie,W){const Z=x.slice(0,ie),ce=x.slice(ie);return Z.concat(W,ce)}function G(x,ie){let W;if(typeof ie=="number"){let Z=ie;W=()=>{const ce=Math.sin(Z++)*179426549;return ce-Math.floor(ce)}}else W=Math.random;for(let Z=x.length-1;Z>0;Z-=1){const ce=Math.floor(W()*(Z+1)),we=x[Z];x[Z]=x[ce],x[ce]=we}}function Q(x,ie){const W=x.indexOf(ie);W>-1&&(x.splice(W,1),x.unshift(ie))}function te(x,ie){const W=x.indexOf(ie);W>-1&&(x.splice(W,1),x.push(ie))}function ve(x,ie){for(const W of ie)x.push(W)}function be(x,ie){return Array.isArray(x)?x.map(ie):ie(x)}function le(x){return Array.isArray(x)?x:[x]}function K(x){return x[Math.floor(Math.random()*x.length)]}function B(x,ie,W){const Z=U(x,ie),ce=x.length,we=W.length;x.length=ce+we;for(let Le=ce-1;Le>=Z;Le--)x[Le+we]=x[Le];for(let Le=0;Le<we;Le++)x[Le+Z]=W[Le]}function j(x,ie,W,Z){const ce=U(x,ie);let we=x.splice(ce,W);return we===void 0&&(we=[]),B(x,ce,Z),we}function U(x,ie){return ie<0?Math.max(ie+x.length,0):Math.min(ie,x.length)}var ee;(function(x){function ie(we){return we<0}x.isLessThan=ie;function W(we){return we<=0}x.isLessThanOrEqual=W;function Z(we){return we>0}x.isGreaterThan=Z;function ce(we){return we===0}x.isNeitherLessOrGreaterThan=ce,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function ae(x,ie){return(W,Z)=>ie(x(W),x(Z))}function ye(...x){return(ie,W)=>{for(const Z of x){const ce=Z(ie,W);if(!ee.isNeitherLessOrGreaterThan(ce))return ce}return ee.neitherLessOrGreaterThan}}const se=(x,ie)=>x-ie;e.$_b=se;const ne=(x,ie)=>(0,e.$_b)(x?1:0,ie?1:0);e.$ac=ne;function X(x){return(ie,W)=>-x(ie,W)}class z{constructor(ie){this.g=ie,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let W=this.c;for(;W<this.g.length&&ie(this.g[W]);)W++;const Z=W===this.c?null:this.g.slice(this.c,W);return this.c=W,Z}takeFromEndWhile(ie){let W=this.d;for(;W>=0&&ie(this.g[W]);)W--;const Z=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,Z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ie=this.g[this.c];return this.c++,ie}removeLast(){const ie=this.g[this.d];return this.d--,ie}takeCount(ie){const W=this.g.slice(this.c,this.c+ie);return this.c+=ie,W}}e.$cc=z;class A{static{this.empty=new A(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(W=>(ie(W),!0))}toArray(){const ie=[];return this.iterate(W=>(ie.push(W),!0)),ie}filter(ie){return new A(W=>this.iterate(Z=>ie(Z)?W(Z):!0))}map(ie){return new A(W=>this.iterate(Z=>W(ie(Z))))}some(ie){let W=!1;return this.iterate(Z=>(W=ie(Z),!W)),W}findFirst(ie){let W;return this.iterate(Z=>ie(Z)?(W=Z,!1):!0),W}findLast(ie){let W;return this.iterate(Z=>(ie(Z)&&(W=Z),!0)),W}findLastMaxBy(ie){let W,Z=!0;return this.iterate(ce=>((Z||ee.isGreaterThan(ie(ce,W)))&&(Z=!1,W=ce),!0)),W}}e.$dc=A;class Y{constructor(ie){this.c=ie}static createSortPermutation(ie,W){const Z=Array.from(ie.keys()).sort((ce,we)=>W(ie[ce],ie[we]));return new Y(Z)}apply(ie){return ie.map((W,Z)=>ie[this.c[Z]])}inverse(){const ie=this.c.slice();for(let W=0;W<this.c.length;W++)ie[this.c[W]]=W;return new Y(ie)}}e.$ec=Y;async function pe(x,ie){return(await Promise.all(x.map(async(Z,ce)=>({element:Z,ok:await ie(Z,ce)})))).find(Z=>Z.ok)?.element}}),define(Te[105],Oe([1,0,9]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$jd=E,e.$kd=P,e.$ld=D,e.$md=T,e.$nd=v;function r(s,S){if(!s)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}function E(s,S="Unreachable"){throw new Error(S)}function P(s,S="unexpected state"){if(!s)throw new t.$gb(`Assertion Failed: ${S}`)}function D(s){s||(0,t.$4)(new t.$gb("Soft Assertion Failed"))}function T(s){if(!s()){debugger;s(),(0,t.$4)(new t.$gb("Assertion Failed"))}}function v(s,S){let y=0;for(;y<s.length-1;){const $=s[y],g=s[y+1];if(!S($,g))return!1;y++}return!0}});var Ci=this&&this.__createBinding||(Object.create?function(ue,e,t,r){r===void 0&&(r=t);var E=Object.getOwnPropertyDescriptor(e,t);(!E||("get"in E?!e.__esModule:E.writable||E.configurable))&&(E={enumerable:!0,get:function(){return e[t]}}),Object.defineProperty(ue,r,E)}:function(ue,e,t,r){r===void 0&&(r=t),ue[r]=e[t]}),Ni=this&&this.__setModuleDefault||(Object.create?function(ue,e){Object.defineProperty(ue,"default",{enumerable:!0,value:e})}:function(ue,e){ue.default=e}),Ve=this&&this.__importStar||function(ue){if(ue&&ue.__esModule)return ue;var e={};if(ue!=null)for(var t in ue)t!=="default"&&Object.prototype.hasOwnProperty.call(ue,t)&&Ci(e,ue,t);return Ni(e,ue),e};define(Te[160],Oe([1,0,17]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$c=void 0,e.$_c=E,e.$ad=P,e.$bd=D,e.$cd=T,e.$dd=v,e.$ed=s,t=Ve(t);const r=(g,a)=>g===a;e.$$c=r;function E(g=e.$$c){return(a,c)=>t.$yb(a,c,g)}function P(){return(g,a)=>JSON.stringify(g)===JSON.stringify(a)}function D(){return(g,a)=>g.equals(a)}function T(g,a,c){if(c!==void 0){const m=g;return m==null||a===void 0||a===null?a===m:c(m,a)}else{const m=g;return(b,p)=>b==null||p===void 0||p===null?p===b:m(b,p)}}function v(g,a){if(g===a)return!0;if(Array.isArray(g)&&Array.isArray(a)){if(g.length!==a.length)return!1;for(let c=0;c<g.length;c++)if(!v(g[c],a[c]))return!1;return!0}if(g&&typeof g=="object"&&a&&typeof a=="object"&&Object.getPrototypeOf(g)===Object.prototype&&Object.getPrototypeOf(a)===Object.prototype){const c=g,m=a,b=Object.keys(c),p=Object.keys(m),d=new Set(p);if(b.length!==p.length)return!1;for(const w of b)if(!d.has(w)||!v(c[w],m[w]))return!1;return!0}return!1}function s(g){return JSON.stringify($(g))}let S=0;const y=new WeakMap;function $(g){if(Array.isArray(g))return g.map($);if(g&&typeof g=="object")if(Object.getPrototypeOf(g)===Object.prototype){const a=g,c=Object.create(null);for(const m of Object.keys(a).sort())c[m]=$(a[m]);return c}else{let a=y.get(g);return a===void 0&&(a=S++,y.set(g,a)),a+"----2b76a038c20c4bcc"}return g}}),define(Te[80],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hb=t;function t(r,E){const P=this;let D=!1,T;return function(){if(D)return T;if(D=!0,E)try{T=r.apply(P,arguments)}finally{E()}else T=r.apply(P,arguments);return T}}}),define(Te[39],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var t;(function(r){function E(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}r.is=E;const P=Object.freeze([]);function D(){return P}r.empty=D;function*T(n){yield n}r.single=T;function v(n){return E(n)?n:T(n)}r.wrap=v;function s(n){return n||P}r.from=s;function*S(n){for(let u=n.length-1;u>=0;u--)yield n[u]}r.reverse=S;function y(n){return!n||n[Symbol.iterator]().next().done===!0}r.isEmpty=y;function $(n){return n[Symbol.iterator]().next().value}r.first=$;function g(n,u){let i=0;for(const f of n)if(u(f,i++))return!0;return!1}r.some=g;function a(n,u){for(const i of n)if(u(i))return i}r.find=a;function*c(n,u){for(const i of n)u(i)&&(yield i)}r.filter=c;function*m(n,u){let i=0;for(const f of n)yield u(f,i++)}r.map=m;function*b(n,u){let i=0;for(const f of n)yield*u(f,i++)}r.flatMap=b;function*p(...n){for(const u of n)yield*u}r.concat=p;function d(n,u,i){let f=i;for(const h of n)f=u(f,h);return f}r.reduce=d;function*w(n,u,i=n.length){for(u<0&&(u+=n.length),i<0?i+=n.length:i>n.length&&(i=n.length);u<i;u++)yield n[u]}r.slice=w;function o(n,u=Number.POSITIVE_INFINITY){const i=[];if(u===0)return[i,n];const f=n[Symbol.iterator]();for(let h=0;h<u;h++){const k=f.next();if(k.done)return[i,r.empty()];i.push(k.value)}return[i,{[Symbol.iterator](){return f}}]}r.consume=o;async function l(n){const u=[];for await(const i of n)u.push(i);return Promise.resolve(u)}r.asyncToArray=l})(t||(e.Iterable=t={}))}),define(Te[42],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$3n=D,e.$4n=y,e.$5n=$,e.$6n=g,e.$7n=a,e.$8n=c,e.$9n=m,e.$0n=b,e.$$n=p,e.$_n=d,e.$ao=w;var t;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(t||(e.ScanError=t={}));var r;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var E;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(E||(e.ParseErrorCode=E={}));var P;(function(o){o.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function D(o,l=!1){let n=0;const u=o.length;let i="",f=0,h=r.Unknown,k=t.None;function I(Q){let te=0,ve=0;for(;te<Q;){const be=o.charCodeAt(n);if(be>=S._0&&be<=S._9)ve=ve*16+be-S._0;else if(be>=S.A&&be<=S.F)ve=ve*16+be-S.A+10;else if(be>=S.a&&be<=S.f)ve=ve*16+be-S.a+10;else break;n++,te++}return te<Q&&(ve=-1),ve}function O(Q){n=Q,i="",f=0,h=r.Unknown,k=t.None}function C(){const Q=n;if(o.charCodeAt(n)===S._0)n++;else for(n++;n<o.length&&s(o.charCodeAt(n));)n++;if(n<o.length&&o.charCodeAt(n)===S.dot)if(n++,n<o.length&&s(o.charCodeAt(n)))for(n++;n<o.length&&s(o.charCodeAt(n));)n++;else return k=t.UnexpectedEndOfNumber,o.substring(Q,n);let te=n;if(n<o.length&&(o.charCodeAt(n)===S.E||o.charCodeAt(n)===S.e))if(n++,(n<o.length&&o.charCodeAt(n)===S.plus||o.charCodeAt(n)===S.minus)&&n++,n<o.length&&s(o.charCodeAt(n))){for(n++;n<o.length&&s(o.charCodeAt(n));)n++;te=n}else k=t.UnexpectedEndOfNumber;return o.substring(Q,te)}function L(){let Q="",te=n;for(;;){if(n>=u){Q+=o.substring(te,n),k=t.UnexpectedEndOfString;break}const ve=o.charCodeAt(n);if(ve===S.doubleQuote){Q+=o.substring(te,n),n++;break}if(ve===S.backslash){if(Q+=o.substring(te,n),n++,n>=u){k=t.UnexpectedEndOfString;break}switch(o.charCodeAt(n++)){case S.doubleQuote:Q+='"';break;case S.backslash:Q+="\\";break;case S.slash:Q+="/";break;case S.b:Q+="\b";break;case S.f:Q+="\f";break;case S.n:Q+=`
`;break;case S.r:Q+="\r";break;case S.t:Q+="	";break;case S.u:{const le=I(4);le>=0?Q+=String.fromCharCode(le):k=t.InvalidUnicode;break}default:k=t.InvalidEscapeCharacter}te=n;continue}if(ve>=0&&ve<=31)if(v(ve)){Q+=o.substring(te,n),k=t.UnexpectedEndOfString;break}else k=t.InvalidCharacter;n++}return Q}function R(){if(i="",k=t.None,f=n,n>=u)return f=u,h=r.EOF;let Q=o.charCodeAt(n);if(T(Q)){do n++,i+=String.fromCharCode(Q),Q=o.charCodeAt(n);while(T(Q));return h=r.Trivia}if(v(Q))return n++,i+=String.fromCharCode(Q),Q===S.carriageReturn&&o.charCodeAt(n)===S.lineFeed&&(n++,i+=`
`),h=r.LineBreakTrivia;switch(Q){case S.openBrace:return n++,h=r.OpenBraceToken;case S.closeBrace:return n++,h=r.CloseBraceToken;case S.openBracket:return n++,h=r.OpenBracketToken;case S.closeBracket:return n++,h=r.CloseBracketToken;case S.colon:return n++,h=r.ColonToken;case S.comma:return n++,h=r.CommaToken;case S.doubleQuote:return n++,i=L(),h=r.StringLiteral;case S.slash:{const te=n-1;if(o.charCodeAt(n+1)===S.slash){for(n+=2;n<u&&!v(o.charCodeAt(n));)n++;return i=o.substring(te,n),h=r.LineCommentTrivia}if(o.charCodeAt(n+1)===S.asterisk){n+=2;const ve=u-1;let be=!1;for(;n<ve;){if(o.charCodeAt(n)===S.asterisk&&o.charCodeAt(n+1)===S.slash){n+=2,be=!0;break}n++}return be||(n++,k=t.UnexpectedEndOfComment),i=o.substring(te,n),h=r.BlockCommentTrivia}return i+=String.fromCharCode(Q),n++,h=r.Unknown}case S.minus:if(i+=String.fromCharCode(Q),n++,n===u||!s(o.charCodeAt(n)))return h=r.Unknown;case S._0:case S._1:case S._2:case S._3:case S._4:case S._5:case S._6:case S._7:case S._8:case S._9:return i+=C(),h=r.NumericLiteral;default:for(;n<u&&M(Q);)n++,Q=o.charCodeAt(n);if(f!==n){switch(i=o.substring(f,n),i){case"true":return h=r.TrueKeyword;case"false":return h=r.FalseKeyword;case"null":return h=r.NullKeyword}return h=r.Unknown}return i+=String.fromCharCode(Q),n++,h=r.Unknown}}function M(Q){if(T(Q)||v(Q))return!1;switch(Q){case S.closeBrace:case S.closeBracket:case S.openBrace:case S.openBracket:case S.doubleQuote:case S.colon:case S.comma:case S.slash:return!1}return!0}function G(){let Q;do Q=R();while(Q>=r.LineCommentTrivia&&Q<=r.Trivia);return Q}return{setPosition:O,getPosition:()=>n,scan:l?G:R,getToken:()=>h,getTokenValue:()=>i,getTokenOffset:()=>f,getTokenLength:()=>n-f,getTokenError:()=>k}}function T(o){return o===S.space||o===S.tab||o===S.verticalTab||o===S.formFeed||o===S.nonBreakingSpace||o===S.ogham||o>=S.enQuad&&o<=S.zeroWidthSpace||o===S.narrowNoBreakSpace||o===S.mathematicalSpace||o===S.ideographicSpace||o===S.byteOrderMark}function v(o){return o===S.lineFeed||o===S.carriageReturn||o===S.lineSeparator||o===S.paragraphSeparator}function s(o){return o>=S._0&&o<=S._9}var S;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(S||(S={}));function y(o,l){const n=[],u=new Object;let i;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function k(I,O,C,L){f.value=I,f.offset=O,f.length=C,f.type=L,f.colonOffset=void 0,i=f}try{d(o,{onObjectBegin:(I,O)=>{if(l<=I)throw u;i=void 0,h=l>I,n.push("")},onObjectProperty:(I,O,C)=>{if(l<O||(k(I,O,C,"property"),n[n.length-1]=I,l<=O+C))throw u},onObjectEnd:(I,O)=>{if(l<=I)throw u;i=void 0,n.pop()},onArrayBegin:(I,O)=>{if(l<=I)throw u;i=void 0,n.push(0)},onArrayEnd:(I,O)=>{if(l<=I)throw u;i=void 0,n.pop()},onLiteralValue:(I,O,C)=>{if(l<O||(k(I,O,C,w(I)),l<=O+C))throw u},onSeparator:(I,O,C)=>{if(l<=O)throw u;if(I===":"&&i&&i.type==="property")i.colonOffset=O,h=!1,i=void 0;else if(I===","){const L=n[n.length-1];typeof L=="number"?n[n.length-1]=L+1:(h=!0,n[n.length-1]=""),i=void 0}}})}catch(I){if(I!==u)throw I}return{path:n,previousNode:i,isAtPropertyKey:h,matches:I=>{let O=0;for(let C=0;O<I.length&&C<n.length;C++)if(I[O]===n[C]||I[O]==="*")O++;else if(I[O]!=="**")return!1;return O===I.length}}}function $(o,l=[],n=P.DEFAULT){let u=null,i=[];const f=[];function h(I){Array.isArray(i)?i.push(I):u!==null&&(i[u]=I)}return d(o,{onObjectBegin:()=>{const I={};h(I),f.push(i),i=I,u=null},onObjectProperty:I=>{u=I},onObjectEnd:()=>{i=f.pop()},onArrayBegin:()=>{const I=[];h(I),f.push(i),i=I,u=null},onArrayEnd:()=>{i=f.pop()},onLiteralValue:h,onError:(I,O,C)=>{l.push({error:I,offset:O,length:C})}},n),i[0]}function g(o,l=[],n=P.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(I){u.type==="property"&&(u.length=I-u.offset,u=u.parent)}function f(I){return u.children.push(I),I}d(o,{onObjectBegin:I=>{u=f({type:"object",offset:I,length:-1,parent:u,children:[]})},onObjectProperty:(I,O,C)=>{u=f({type:"property",offset:O,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:I,offset:O,length:C,parent:u})},onObjectEnd:(I,O)=>{u.length=I+O-u.offset,u=u.parent,i(I+O)},onArrayBegin:(I,O)=>{u=f({type:"array",offset:I,length:-1,parent:u,children:[]})},onArrayEnd:(I,O)=>{u.length=I+O-u.offset,u=u.parent,i(I+O)},onLiteralValue:(I,O,C)=>{f({type:w(I),offset:O,length:C,parent:u,value:I}),i(O+C)},onSeparator:(I,O,C)=>{u.type==="property"&&(I===":"?u.colonOffset=O:I===","&&i(O))},onError:(I,O,C)=>{l.push({error:I,offset:O,length:C})}},n);const k=u.children[0];return k&&delete k.parent,k}function a(o,l){if(!o)return;let n=o;for(const u of l)if(typeof u=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const f of n.children)if(Array.isArray(f.children)&&f.children[0].value===u){n=f.children[1],i=!0;break}if(!i)return}else{const i=u;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}function c(o){if(!o.parent||!o.parent.children)return[];const l=c(o.parent);if(o.parent.type==="property"){const n=o.parent.children[0].value;l.push(n)}else if(o.parent.type==="array"){const n=o.parent.children.indexOf(o);n!==-1&&l.push(n)}return l}function m(o){switch(o.type){case"array":return o.children.map(m);case"object":{const l=Object.create(null);for(const n of o.children){const u=n.children[1];u&&(l[n.children[0].value]=m(u))}return l}case"null":case"string":case"number":case"boolean":return o.value;default:return}}function b(o,l,n=!1){return l>=o.offset&&l<o.offset+o.length||n&&l===o.offset+o.length}function p(o,l,n=!1){if(b(o,l,n)){const u=o.children;if(Array.isArray(u))for(let i=0;i<u.length&&u[i].offset<=l;i++){const f=p(u[i],l,n);if(f)return f}return o}}function d(o,l,n=P.DEFAULT){const u=D(o,!1);function i(ae){return ae?()=>ae(u.getTokenOffset(),u.getTokenLength()):()=>!0}function f(ae){return ae?ye=>ae(ye,u.getTokenOffset(),u.getTokenLength()):()=>!0}const h=i(l.onObjectBegin),k=f(l.onObjectProperty),I=i(l.onObjectEnd),O=i(l.onArrayBegin),C=i(l.onArrayEnd),L=f(l.onLiteralValue),R=f(l.onSeparator),M=i(l.onComment),G=f(l.onError),Q=n&&n.disallowComments,te=n&&n.allowTrailingComma;function ve(){for(;;){const ae=u.scan();switch(u.getTokenError()){case t.InvalidUnicode:be(E.InvalidUnicode);break;case t.InvalidEscapeCharacter:be(E.InvalidEscapeCharacter);break;case t.UnexpectedEndOfNumber:be(E.UnexpectedEndOfNumber);break;case t.UnexpectedEndOfComment:Q||be(E.UnexpectedEndOfComment);break;case t.UnexpectedEndOfString:be(E.UnexpectedEndOfString);break;case t.InvalidCharacter:be(E.InvalidCharacter);break}switch(ae){case r.LineCommentTrivia:case r.BlockCommentTrivia:Q?be(E.InvalidCommentToken):M();break;case r.Unknown:be(E.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return ae}}}function be(ae,ye=[],se=[]){if(G(ae),ye.length+se.length>0){let ne=u.getToken();for(;ne!==r.EOF;){if(ye.indexOf(ne)!==-1){ve();break}else if(se.indexOf(ne)!==-1)break;ne=ve()}}}function le(ae){const ye=u.getTokenValue();return ae?L(ye):k(ye),ve(),!0}function K(){switch(u.getToken()){case r.NumericLiteral:{let ae=0;try{ae=JSON.parse(u.getTokenValue()),typeof ae!="number"&&(be(E.InvalidNumberFormat),ae=0)}catch{be(E.InvalidNumberFormat)}L(ae);break}case r.NullKeyword:L(null);break;case r.TrueKeyword:L(!0);break;case r.FalseKeyword:L(!1);break;default:return!1}return ve(),!0}function B(){return u.getToken()!==r.StringLiteral?(be(E.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(le(!1),u.getToken()===r.ColonToken?(R(":"),ve(),ee()||be(E.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):be(E.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function j(){h(),ve();let ae=!1;for(;u.getToken()!==r.CloseBraceToken&&u.getToken()!==r.EOF;){if(u.getToken()===r.CommaToken){if(ae||be(E.ValueExpected,[],[]),R(","),ve(),u.getToken()===r.CloseBraceToken&&te)break}else ae&&be(E.CommaExpected,[],[]);B()||be(E.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),ae=!0}return I(),u.getToken()!==r.CloseBraceToken?be(E.CloseBraceExpected,[r.CloseBraceToken],[]):ve(),!0}function U(){O(),ve();let ae=!1;for(;u.getToken()!==r.CloseBracketToken&&u.getToken()!==r.EOF;){if(u.getToken()===r.CommaToken){if(ae||be(E.ValueExpected,[],[]),R(","),ve(),u.getToken()===r.CloseBracketToken&&te)break}else ae&&be(E.CommaExpected,[],[]);ee()||be(E.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),ae=!0}return C(),u.getToken()!==r.CloseBracketToken?be(E.CloseBracketExpected,[r.CloseBracketToken],[]):ve(),!0}function ee(){switch(u.getToken()){case r.OpenBracketToken:return U();case r.OpenBraceToken:return j();case r.StringLiteral:return le(!0);default:return K()}}return ve(),u.getToken()===r.EOF?n.allowEmptyContent?!0:(be(E.ValueExpected,[],[]),!1):ee()?(u.getToken()!==r.EOF&&be(E.EndOfFileExpected,[],[]),!0):(be(E.ValueExpected,[],[]),!1)}function w(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}}),define(Te[161],Oe([1,0,42]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=r,e.$co=E,e.$do=T,e.$eo=v;function r(s,S,y){let $,g,a,c,m;if(S){for(c=S.offset,m=c+S.length,a=c;a>0&&!v(s,a-1);)a--;let k=m;for(;k<s.length&&!v(s,k);)k++;g=s.substring(a,k),$=D(g,y)}else g=s,$=0,a=0,c=0,m=s.length;const b=T(y,s);let p=!1,d=0,w;y.insertSpaces?w=P(" ",y.tabSize||4):w="	";const o=(0,t.$3n)(g,!1);let l=!1;function n(){return b+P(w,$+d)}function u(){let k=o.scan();for(p=!1;k===t.SyntaxKind.Trivia||k===t.SyntaxKind.LineBreakTrivia;)p=p||k===t.SyntaxKind.LineBreakTrivia,k=o.scan();return l=k===t.SyntaxKind.Unknown||o.getTokenError()!==t.ScanError.None,k}const i=[];function f(k,I,O){!l&&I<m&&O>c&&s.substring(I,O)!==k&&i.push({offset:I,length:O-I,content:k})}let h=u();if(h!==t.SyntaxKind.EOF){const k=o.getTokenOffset()+a,I=P(w,$);f(I,a,k)}for(;h!==t.SyntaxKind.EOF;){let k=o.getTokenOffset()+o.getTokenLength()+a,I=u(),O="";for(;!p&&(I===t.SyntaxKind.LineCommentTrivia||I===t.SyntaxKind.BlockCommentTrivia);){const L=o.getTokenOffset()+a;f(" ",k,L),k=o.getTokenOffset()+o.getTokenLength()+a,O=I===t.SyntaxKind.LineCommentTrivia?n():"",I=u()}if(I===t.SyntaxKind.CloseBraceToken)h!==t.SyntaxKind.OpenBraceToken&&(d--,O=n());else if(I===t.SyntaxKind.CloseBracketToken)h!==t.SyntaxKind.OpenBracketToken&&(d--,O=n());else{switch(h){case t.SyntaxKind.OpenBracketToken:case t.SyntaxKind.OpenBraceToken:d++,O=n();break;case t.SyntaxKind.CommaToken:case t.SyntaxKind.LineCommentTrivia:O=n();break;case t.SyntaxKind.BlockCommentTrivia:p?O=n():O=" ";break;case t.SyntaxKind.ColonToken:O=" ";break;case t.SyntaxKind.StringLiteral:if(I===t.SyntaxKind.ColonToken){O="";break}case t.SyntaxKind.NullKeyword:case t.SyntaxKind.TrueKeyword:case t.SyntaxKind.FalseKeyword:case t.SyntaxKind.NumericLiteral:case t.SyntaxKind.CloseBraceToken:case t.SyntaxKind.CloseBracketToken:I===t.SyntaxKind.LineCommentTrivia||I===t.SyntaxKind.BlockCommentTrivia?O=" ":I!==t.SyntaxKind.CommaToken&&I!==t.SyntaxKind.EOF&&(l=!0);break;case t.SyntaxKind.Unknown:l=!0;break}p&&(I===t.SyntaxKind.LineCommentTrivia||I===t.SyntaxKind.BlockCommentTrivia)&&(O=n())}const C=o.getTokenOffset()+a;f(O,k,C),h=I}return i}function E(s,S){const y=JSON.stringify(s,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?y.replace(/\r\n|\r|\n/g,S.eol):y}function P(s,S){let y="";for(let $=0;$<S;$++)y+=s;return y}function D(s,S){let y=0,$=0;const g=S.tabSize||4;for(;y<s.length;){const a=s.charAt(y);if(a===" ")$++;else if(a==="	")$+=g;else break;y++}return Math.floor($/g)}function T(s,S){for(let y=0;y<S.length;y++){const $=S.charAt(y);if($==="\r")return y+1<S.length&&S.charAt(y+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return s&&s.eol||`
`}function v(s,S){return`\r
`.indexOf(s.charAt(S))!==-1}}),define(Te[162],Oe([1,0,42,161]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=E,e.$go=P,e.$ho=D,e.$io=T,e.$jo=v;function E(s,S,y){return P(s,S,void 0,y)}function P(s,S,y,$,g){const a=S.slice(),c=[],m=(0,t.$6n)(s,c);let b,p;for(;a.length>0&&(p=a.pop(),b=(0,t.$7n)(m,a),b===void 0&&y!==void 0);)typeof p=="string"?y={[p]:y}:y=[y];if(b)if(b.type==="object"&&typeof p=="string"&&Array.isArray(b.children)){const d=(0,t.$7n)(b,[p]);if(d!==void 0)if(y===void 0){if(!d.parent)throw new Error("Malformed AST");const w=b.children.indexOf(d.parent);let o,l=d.parent.offset+d.parent.length;if(w>0){const n=b.children[w-1];o=n.offset+n.length}else o=b.offset+1,b.children.length>1&&(l=b.children[1].offset);return D(s,{offset:o,length:l-o,content:""},$)}else return D(s,{offset:d.offset,length:d.length,content:JSON.stringify(y)},$);else{if(y===void 0)return[];const w=`${JSON.stringify(p)}: ${JSON.stringify(y)}`,o=g?g(b.children.map(n=>n.children[0].value)):b.children.length;let l;if(o>0){const n=b.children[o-1];l={offset:n.offset+n.length,length:0,content:","+w}}else b.children.length===0?l={offset:b.offset+1,length:0,content:w}:l={offset:b.offset+1,length:0,content:w+","};return D(s,l,$)}}else if(b.type==="array"&&typeof p=="number"&&Array.isArray(b.children))if(y!==void 0){const d=`${JSON.stringify(y)}`;let w;if(b.children.length===0||p===0)w={offset:b.offset+1,length:0,content:b.children.length===0?d:d+","};else{const o=p===-1||p>b.children.length?b.children.length:p,l=b.children[o-1];w={offset:l.offset+l.length,length:0,content:","+d}}return D(s,w,$)}else{const d=p,w=b.children[d];let o;if(b.children.length===1)o={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===d){const l=b.children[d-1],n=l.offset+l.length,u=b.offset+b.length;o={offset:n,length:u-2-n,content:""}}else o={offset:w.offset,length:b.children[d+1].offset-w.offset,content:""};return D(s,o,$)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${b.type}`);else return y===void 0?[]:D(s,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(y)},$)}function D(s,S,y){let $=T(s,S),g=S.offset,a=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;g>0&&!(0,r.$eo)($,g-1);)g--;for(;a<$.length&&!(0,r.$eo)($,a);)a++}const c=(0,r.$bo)($,{offset:g,length:a-g},y);for(let b=c.length-1;b>=0;b--){const p=c[b];$=T($,p),g=Math.min(g,p.offset),a=Math.max(a,p.offset+p.length),a+=p.content.length-p.length}const m=s.length-($.length-a)-g;return[{offset:g,length:m,content:$.substring(g,a)}]}function T(s,S){return s.substring(0,S.offset)+S.content+s.substring(S.offset+S.length)}function v(s,S){const y=S.slice(0).sort((g,a)=>{const c=g.offset-a.offset;return c===0?g.length-a.length:c});let $=s.length;for(let g=y.length-1;g>=0;g--){const a=y[g];if(a.offset+a.length<=$)s=T(s,a);else throw new Error("Overlapping edit");$=a.offset}return s}}),define(Te[163],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=t;function t(P){let D=!1;const T=new Map,v=new Map;if(E(P,c=>{if(P===c)return!0;const m=JSON.stringify(c);if(m.length<30)return!0;const b=T.get(m);if(!b){const p={schemas:[c]};return T.set(m,p),v.set(c,p),!0}return b.schemas.push(c),v.set(c,b),D=!0,!1}),T.clear(),!D)return JSON.stringify(P);let S="$defs";for(;P.hasOwnProperty(S);)S+="_";const y=[];function $(c){return JSON.stringify(c,(m,b)=>{if(b!==c){const p=v.get(b);if(p&&p.schemas.length>1)return p.id||(p.id=`_${y.length}`,y.push(p.schemas[0])),{$ref:`#/${S}/${p.id}`}}return b})}const g=$(P),a=[];for(let c=0;c<y.length;c++)a.push(`"_${c}":${$(y[c])}`);return a.length?`${g.substring(0,g.length-1)},"${S}":{${a.join(",")}}}`:g}function r(P){return typeof P=="object"&&P!==null}function E(P,D){if(!P||typeof P!="object")return;const T=(...g)=>{for(const a of g)r(a)&&y.push(a)},v=(...g)=>{for(const a of g)if(r(a))for(const c in a){const m=a[c];r(m)&&y.push(m)}},s=(...g)=>{for(const a of g)if(Array.isArray(a))for(const c of a)r(c)&&y.push(c)},S=g=>{if(Array.isArray(g))for(const a of g)r(a)&&y.push(a);else r(g)&&y.push(g)},y=[P];let $=y.pop();for(;$;)D($)&&(T($.additionalItems,$.additionalProperties,$.not,$.contains,$.propertyNames,$.if,$.then,$.else,$.unevaluatedItems,$.unevaluatedProperties),v($.definitions,$.$defs,$.properties,$.patternProperties,$.dependencies,$.dependentSchemas),s($.anyOf,$.allOf,$.oneOf,$.prefixItems),S($.items)),$=y.pop()}}),define(Te[65],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y=void 0;class t{constructor(E){this.d=E,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$Y=t}),define(Te[81],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=void 0;class t{static{this.Undefined=new t(void 0)}constructor(P){this.element=P,this.next=t.Undefined,this.prev=t.Undefined}}class r{constructor(){this.a=t.Undefined,this.b=t.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===t.Undefined}clear(){let P=this.a;for(;P!==t.Undefined;){const D=P.next;P.prev=t.Undefined,P.next=t.Undefined,P=D}this.a=t.Undefined,this.b=t.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,D){const T=new t(P);if(this.a===t.Undefined)this.a=T,this.b=T;else if(D){const s=this.b;this.b=T,T.prev=s,s.next=T}else{const s=this.a;this.a=T,T.next=s,s.prev=T}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(T))}}shift(){if(this.a!==t.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==t.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==t.Undefined&&P.next!==t.Undefined){const D=P.prev;D.next=P.next,P.next.prev=D}else P.prev===t.Undefined&&P.next===t.Undefined?(this.a=t.Undefined,this.b=t.Undefined):P.next===t.Undefined?(this.b=this.b.prev,this.b.next=t.Undefined):P.prev===t.Undefined&&(this.a=this.a.next,this.a.prev=t.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==t.Undefined;)yield P.element,P=P.next}}e.$0c=r}),define(Te[25],Oe([1,0]),function(ue,e){"use strict";var t,r,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.Touch=e.$Gc=e.$Fc=void 0,e.$Cc=P,e.$Dc=D,e.$Ec=T,e.$Nc=w;function P(o,l,n){let u=o.get(l);return u===void 0&&(u=n,o.set(l,u)),u}function D(o){const l=[];return o.forEach((n,u)=>{l.push(`${u} => ${n}`)}),`Map(${o.size}) {${l.join(", ")}}`}function T(o){const l=[];return o.forEach(n=>{l.push(n)}),`Set(${o.size}) {${l.join(", ")}}`}class v{constructor(l,n){this.uri=l,this.value=n}}function s(o){return Array.isArray(o)}class S{static{this.c=l=>l.toString()}constructor(l,n){if(this[t]="ResourceMap",l instanceof S)this.d=new Map(l.d),this.e=n??S.c;else if(s(l)){this.d=new Map,this.e=n??S.c;for(const[u,i]of l)this.set(u,i)}else this.d=new Map,this.e=l??S.c}set(l,n){return this.d.set(this.e(l),new v(l,n)),this}get(l){return this.d.get(this.e(l))?.value}has(l){return this.d.has(this.e(l))}get size(){return this.d.size}clear(){this.d.clear()}delete(l){return this.d.delete(this.e(l))}forEach(l,n){typeof n<"u"&&(l=l.bind(n));for(const[u,i]of this.d)l(i.value,i.uri,this)}*values(){for(const l of this.d.values())yield l.value}*keys(){for(const l of this.d.values())yield l.uri}*entries(){for(const l of this.d.values())yield[l.uri,l.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.d)yield[l.uri,l.value]}}e.$Fc=S;class y{constructor(l,n){this[r]="ResourceSet",!l||typeof l=="function"?this.c=new S(l):(this.c=new S(n),l.forEach(this.add,this))}get size(){return this.c.size}add(l){return this.c.set(l,l),this}clear(){this.c.clear()}delete(l){return this.c.delete(l)}forEach(l,n){this.c.forEach((u,i)=>l.call(n,i,i,this))}has(l){return this.c.has(l)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Gc=y;var $;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})($||(e.Touch=$={}));class g{constructor(){this[E]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(l){return this.c.has(l)}get(l,n=$.None){const u=this.c.get(l);if(u)return n!==$.None&&this.m(u,n),u.value}set(l,n,u=$.None){let i=this.c.get(l);if(i)i.value=n,u!==$.None&&this.m(i,u);else{switch(i={key:l,value:n,next:void 0,previous:void 0},u){case $.None:this.k(i);break;case $.AsOld:this.j(i);break;case $.AsNew:this.k(i);break;default:this.k(i);break}this.c.set(l,i),this.f++}return this}delete(l){return!!this.remove(l)}remove(l){const n=this.c.get(l);if(n)return this.c.delete(l),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const l=this.d;return this.c.delete(l.key),this.l(l),this.f--,l.value}forEach(l,n){const u=this.g;let i=this.d;for(;i;){if(n?l.bind(n)(i.value,i.key,this):l(i.value,i.key,this),this.g!==u)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const l=this,n=this.g;let u=this.d;const i={[Symbol.iterator](){return i},next(){if(l.g!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.key,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return i}values(){const l=this,n=this.g;let u=this.d;const i={[Symbol.iterator](){return i},next(){if(l.g!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.value,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return i}entries(){const l=this,n=this.g;let u=this.d;const i={[Symbol.iterator](){return i},next(){if(l.g!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:[u.key,u.value],done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return i}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(l){if(l>=this.size)return;if(l===0){this.clear();return}let n=this.d,u=this.size;for(;n&&u>l;)this.c.delete(n.key),n=n.next,u--;this.d=n,this.f=u,n&&(n.previous=void 0),this.g++}i(l){if(l>=this.size)return;if(l===0){this.clear();return}let n=this.e,u=this.size;for(;n&&u>l;)this.c.delete(n.key),n=n.previous,u--;this.e=n,this.f=u,n&&(n.next=void 0),this.g++}j(l){if(!this.d&&!this.e)this.e=l;else if(this.d)l.next=this.d,this.d.previous=l;else throw new Error("Invalid list");this.d=l,this.g++}k(l){if(!this.d&&!this.e)this.d=l;else if(this.e)l.previous=this.e,this.e.next=l;else throw new Error("Invalid list");this.e=l,this.g++}l(l){if(l===this.d&&l===this.e)this.d=void 0,this.e=void 0;else if(l===this.d){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.d=l.next}else if(l===this.e){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.e=l.previous}else{const n=l.next,u=l.previous;if(!n||!u)throw new Error("Invalid list");n.previous=u,u.next=n}l.next=void 0,l.previous=void 0,this.g++}m(l,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==$.AsOld&&n!==$.AsNew)){if(n===$.AsOld){if(l===this.d)return;const u=l.next,i=l.previous;l===this.e?(i.next=void 0,this.e=i):(u.previous=i,i.next=u),l.previous=void 0,l.next=this.d,this.d.previous=l,this.d=l,this.g++}else if(n===$.AsNew){if(l===this.e)return;const u=l.next,i=l.previous;l===this.d?(u.previous=void 0,this.d=u):(u.previous=i,i.next=u),l.next=void 0,l.previous=this.e,this.e.next=l,this.e=l,this.g++}}}toJSON(){const l=[];return this.forEach((n,u)=>{l.push([u,n])}),l}fromJSON(l){this.clear();for(const[n,u]of l)this.set(n,u)}}e.$Hc=g;class a extends g{constructor(l,n=1){super(),this.n=l,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(l){this.n=l,this.p()}get ratio(){return this.o}set ratio(l){this.o=Math.min(Math.max(0,l),1),this.p()}get(l,n=$.AsNew){return super.get(l,n)}peek(l){return super.get(l,$.None)}set(l,n){return super.set(l,n,$.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class c extends a{constructor(l,n=1){super(l,n)}q(l){this.h(l)}set(l,n){return super.set(l,n),this.p(),this}}e.$Ic=c;class m extends a{constructor(l,n=1){super(l,n)}q(l){this.i(l)}set(l,n){return this.n<=this.size&&!this.has(l)&&this.q(Math.round(this.n*this.o)-1),super.set(l,n),this}}e.$Jc=m;class b{constructor(){this.c=new Map}add(l){return this.c.set(l,(this.c.get(l)||0)+1),this}delete(l){let n=this.c.get(l)||0;return n===0?!1:(n--,n===0?this.c.delete(l):this.c.set(l,n),!0)}has(l){return this.c.has(l)}}e.$Kc=b;class p{constructor(l){if(this.c=new Map,this.d=new Map,l)for(const[n,u]of l)this.set(n,u)}clear(){this.c.clear(),this.d.clear()}set(l,n){this.c.set(l,n),this.d.set(n,l)}get(l){return this.c.get(l)}getKey(l){return this.d.get(l)}delete(l){const n=this.c.get(l);return n===void 0?!1:(this.c.delete(l),this.d.delete(n),!0)}forEach(l,n){this.c.forEach((u,i)=>{l.call(n,u,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Lc=p;class d{constructor(){this.c=new Map}add(l,n){let u=this.c.get(l);u||(u=new Set,this.c.set(l,u)),u.add(n)}delete(l,n){const u=this.c.get(l);u&&(u.delete(n),u.size===0&&this.c.delete(l))}forEach(l,n){const u=this.c.get(l);u&&u.forEach(n)}get(l){const n=this.c.get(l);return n||new Set}}e.$Mc=d;function w(o,l){if(o===l)return!0;if(o.size!==l.size)return!1;for(const[n,u]of o)if(!l.has(n)||l.get(n)!==u)return!1;for(const[n]of l)if(!o.has(n))return!1;return!0}}),define(Te[2],Oe([1,0,17,159,25,80,39]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Oc=void 0,e.$Pc=S,e.$Qc=y,e.$Rc=$,e.$Sc=c,e.$Tc=m,e.$Uc=b,e.$Vc=p,e.$Wc=d,e.$Xc=w,e.$8c=O;const T=!1;let v=null;class s{constructor(){this.b=new Map}static{this.a=0}c(R){let M=this.b.get(R);return M||(M={parent:null,source:null,isSingleton:!1,value:R,idx:s.a++},this.b.set(R,M)),M}trackDisposable(R){const M=this.c(R);M.source||(M.source=new Error().stack)}setParent(R,M){const G=this.c(R);G.parent=M}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,M){const G=M.get(R);if(G)return G;const Q=R.parent?this.f(this.c(R.parent),M):R;return M.set(R,Q),Q}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,G])=>G.source!==null&&!this.f(G,R).isSingleton).flatMap(([G])=>G)}computeLeakingDisposables(R=10,M){let G;if(M)G=M;else{const le=new Map,K=[...this.b.values()].filter(j=>j.source!==null&&!this.f(j,le).isSingleton);if(K.length===0)return;const B=new Set(K.map(j=>j.value));if(G=K.filter(j=>!(j.parent&&B.has(j.parent))),G.length===0)throw new Error("There are cyclic diposable chains!")}if(!G)return;function Q(le){function K(j,U){for(;j.length>0&&U.some(ee=>typeof ee=="string"?ee===j[0]:j[0].match(ee));)j.shift()}const B=le.source.split(`
`).map(j=>j.trim().replace("at ","")).filter(j=>j!=="");return K(B,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),B.reverse()}const te=new E.$Mc;for(const le of G){const K=Q(le);for(let B=0;B<=K.length;B++)te.add(K.slice(0,B).join(`
`),le)}G.sort((0,t.$0b)(le=>le.idx,t.$_b));let ve="",be=0;for(const le of G.slice(0,R)){be++;const K=Q(le),B=[];for(let j=0;j<K.length;j++){let U=K[j];U=`(shared with ${te.get(K.slice(0,j+1).join(`
`)).size}/${G.length} leaks) at ${U}`;const ae=te.get(K.slice(0,j).join(`
`)),ye=(0,r.$e)([...ae].map(se=>Q(se)[j]),se=>se);delete ye[K[j]];for(const[se,ne]of Object.entries(ye))B.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${se}`);B.unshift(U)}ve+=`


==================== Leaking disposable ${be}/${G.length}: ${le.value.constructor.name} ====================
${B.join(`
`)}
============================================================

`}return G.length>R&&(ve+=`


... and ${G.length-R} more leaking disposables

`),{leaks:G,details:ve}}}e.$Oc=s;function S(L){v=L}if(T){const L="__is_disposable_tracked__";S(new class{trackDisposable(R){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[L]||console.log(M)},3e3)}setParent(R,M){if(R&&R!==l.None)try{R[L]=!0}catch{}}markAsDisposed(R){if(R&&R!==l.None)try{R[L]=!0}catch{}}markAsSingleton(R){}})}function y(L){return v?.trackDisposable(L),L}function $(L){v?.markAsDisposed(L)}function g(L,R){v?.setParent(L,R)}function a(L,R){if(v)for(const M of L)v.setParent(M,R)}function c(L){return v?.markAsSingleton(L),L}function m(L){return typeof L=="object"&&L!==null&&typeof L.dispose=="function"&&L.dispose.length===0}function b(L){if(D.Iterable.is(L)){const R=[];for(const M of L)if(M)try{M.dispose()}catch(G){R.push(G)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}function p(L){for(const R of L)m(R)&&R.dispose();return[]}function d(...L){const R=w(()=>b(L));return a(L,R),R}function w(L){const R=y({dispose:(0,P.$hb)(()=>{$(R),L()})});return R}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return g(R,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(R),R.dispose()}}deleteAndLeak(R){R&&this.f.has(R)&&(this.f.delete(R),g(R,null))}}e.$Yc=o;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,y(this),g(this.q,this)}dispose(){$(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}e.$Zc=l;class n{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&g(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&g(R,null),R}}e.$1c=n;class u{constructor(R){this.a=new n,this.b=!1,this.a.value=R}get value(){return this.a.value}set value(R){this.b||R===this.a.value||(this.a.value=R)}dispose(){this.b=!0,this.a.dispose()}}e.$2c=u;class i{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$3c=i;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(R){let M=R;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,$(this))},this}}e.$4c=f;class h{constructor(){this.a=new Map}acquire(R,...M){let G=this.a.get(R);G||(G={counter:0,object:this.b(R,...M)},this.a.set(R,G));const{object:Q}=G,te=(0,P.$hb)(()=>{--G.counter===0&&(this.c(R,G.object),this.a.delete(R))});return G.counter++,{object:Q,dispose:te}}}e.$5c=h;class k{constructor(R){this.a=R}async acquire(R,...M){const G=this.a.acquire(R,...M);try{return{object:await G.object,dispose:()=>G.dispose()}}catch(Q){throw G.dispose(),Q}}}e.$6c=k;class I{constructor(R){this.object=R}dispose(){}}e.$7c=I;function O(L){const R=new o;try{L(R)}finally{R.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,M,G=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),G||this.a.get(R)?.dispose(),this.a.set(R,M)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}deleteAndLeak(R){const M=this.a.get(R);return this.a.delete(R),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$9c=C}),function(ue,e){typeof define=="function"&&define.amd?define(Te[164],Oe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ue=typeof globalThis<"u"?globalThis:ue||self,e(ue.marked={}))}(this,function(ue){"use strict";function e(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}ue.defaults=e();function t(Je){ue.defaults=Je}const r=/[&<>"']/,E=new RegExp(r.source,"g"),P=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,D=new RegExp(P.source,"g"),T={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=Je=>T[Je];function s(Je,me){if(me){if(r.test(Je))return Je.replace(E,v)}else if(P.test(Je))return Je.replace(D,v);return Je}const S=/(^|[^\[])\^/g;function y(Je,me){let V=typeof Je=="string"?Je:Je.source;me=me||"";const _={replace:(fe,re)=>{let he=typeof re=="string"?re:re.source;return he=he.replace(S,"$1"),V=V.replace(fe,he),_},getRegex:()=>new RegExp(V,me)};return _}function $(Je){try{Je=encodeURI(Je).replace(/%25/g,"%")}catch{return null}return Je}const g={exec:()=>null};function a(Je,me){const V=Je.replace(/\|/g,(re,he,H)=>{let J=!1,$e=he;for(;--$e>=0&&H[$e]==="\\";)J=!J;return J?"|":" |"}),_=V.split(/ \|/);let fe=0;if(_[0].trim()||_.shift(),_.length>0&&!_[_.length-1].trim()&&_.pop(),me)if(_.length>me)_.splice(me);else for(;_.length<me;)_.push("");for(;fe<_.length;fe++)_[fe]=_[fe].trim().replace(/\\\|/g,"|");return _}function c(Je,me,V){const _=Je.length;if(_===0)return"";let fe=0;for(;fe<_;){const re=Je.charAt(_-fe-1);if(re===me&&!V)fe++;else if(re!==me&&V)fe++;else break}return Je.slice(0,_-fe)}function m(Je,me){if(Je.indexOf(me[1])===-1)return-1;let V=0;for(let _=0;_<Je.length;_++)if(Je[_]==="\\")_++;else if(Je[_]===me[0])V++;else if(Je[_]===me[1]&&(V--,V<0))return _;return-1}function b(Je,me,V,_){const fe=me.href,re=me.title?s(me.title):null,he=Je[1].replace(/\\([\[\]])/g,"$1");if(Je[0].charAt(0)!=="!"){_.state.inLink=!0;const H={type:"link",raw:V,href:fe,title:re,text:he,tokens:_.inlineTokens(he)};return _.state.inLink=!1,H}return{type:"image",raw:V,href:fe,title:re,text:s(he)}}function p(Je,me){const V=Je.match(/^(\s+)(?:```)/);if(V===null)return me;const _=V[1];return me.split(`
`).map(fe=>{const re=fe.match(/^\s+/);if(re===null)return fe;const[he]=re;return he.length>=_.length?fe.slice(_.length):fe}).join(`
`)}class d{options;rules;lexer;constructor(me){this.options=me||ue.defaults}space(me){const V=this.rules.block.newline.exec(me);if(V&&V[0].length>0)return{type:"space",raw:V[0]}}code(me){const V=this.rules.block.code.exec(me);if(V){const _=V[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:V[0],codeBlockStyle:"indented",text:this.options.pedantic?_:c(_,`
`)}}}fences(me){const V=this.rules.block.fences.exec(me);if(V){const _=V[0],fe=p(_,V[3]||"");return{type:"code",raw:_,lang:V[2]?V[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):V[2],text:fe}}}heading(me){const V=this.rules.block.heading.exec(me);if(V){let _=V[2].trim();if(/#$/.test(_)){const fe=c(_,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(_=fe.trim())}return{type:"heading",raw:V[0],depth:V[1].length,text:_,tokens:this.lexer.inline(_)}}}hr(me){const V=this.rules.block.hr.exec(me);if(V)return{type:"hr",raw:c(V[0],`
`)}}blockquote(me){const V=this.rules.block.blockquote.exec(me);if(V){let _=c(V[0],`
`).split(`
`),fe="",re="";const he=[];for(;_.length>0;){let H=!1;const J=[];let $e;for($e=0;$e<_.length;$e++)if(/^ {0,3}>/.test(_[$e]))J.push(_[$e]),H=!0;else if(!H)J.push(_[$e]);else break;_=_.slice($e);const Fe=J.join(`
`),He=Fe.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");fe=fe?`${fe}
${Fe}`:Fe,re=re?`${re}
${He}`:He;const xe=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(He,he,!0),this.lexer.state.top=xe,_.length===0)break;const et=he[he.length-1];if(et?.type==="code")break;if(et?.type==="blockquote"){const it=et,ft=it.raw+`
`+_.join(`
`),gt=this.blockquote(ft);he[he.length-1]=gt,fe=fe.substring(0,fe.length-it.raw.length)+gt.raw,re=re.substring(0,re.length-it.text.length)+gt.text;break}else if(et?.type==="list"){const it=et,ft=it.raw+`
`+_.join(`
`),gt=this.list(ft);he[he.length-1]=gt,fe=fe.substring(0,fe.length-et.raw.length)+gt.raw,re=re.substring(0,re.length-it.raw.length)+gt.raw,_=ft.substring(he[he.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:fe,tokens:he,text:re}}}list(me){let V=this.rules.block.list.exec(me);if(V){let _=V[1].trim();const fe=_.length>1,re={type:"list",raw:"",ordered:fe,start:fe?+_.slice(0,-1):"",loose:!1,items:[]};_=fe?`\\d{1,9}\\${_.slice(-1)}`:`\\${_}`,this.options.pedantic&&(_=fe?_:"[*+-]");const he=new RegExp(`^( {0,3}${_})((?:[	 ][^\\n]*)?(?:\\n|$))`);let H=!1;for(;me;){let J=!1,$e="",Fe="";if(!(V=he.exec(me))||this.rules.block.hr.test(me))break;$e=V[0],me=me.substring($e.length);let He=V[2].split(`
`,1)[0].replace(/^\t+/,Et=>" ".repeat(3*Et.length)),xe=me.split(`
`,1)[0],et=!He.trim(),it=0;if(this.options.pedantic?(it=2,Fe=He.trimStart()):et?it=V[1].length+1:(it=V[2].search(/[^ ]/),it=it>4?1:it,Fe=He.slice(it),it+=V[1].length),et&&/^ *$/.test(xe)&&($e+=xe+`
`,me=me.substring(xe.length+1),J=!0),!J){const Et=new RegExp(`^ {0,${Math.min(3,it-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),Rt=new RegExp(`^ {0,${Math.min(3,it-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),mt=new RegExp(`^ {0,${Math.min(3,it-1)}}(?:\`\`\`|~~~)`),pt=new RegExp(`^ {0,${Math.min(3,it-1)}}#`);for(;me;){const wt=me.split(`
`,1)[0];if(xe=wt,this.options.pedantic&&(xe=xe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),mt.test(xe)||pt.test(xe)||Et.test(xe)||Rt.test(me))break;if(xe.search(/[^ ]/)>=it||!xe.trim())Fe+=`
`+xe.slice(it);else{if(et||He.search(/[^ ]/)>=4||mt.test(He)||pt.test(He)||Rt.test(He))break;Fe+=`
`+xe}!et&&!xe.trim()&&(et=!0),$e+=wt+`
`,me=me.substring(wt.length+1),He=xe.slice(it)}}re.loose||(H?re.loose=!0:/\n *\n *$/.test($e)&&(H=!0));let ft=null,gt;this.options.gfm&&(ft=/^\[[ xX]\] /.exec(Fe),ft&&(gt=ft[0]!=="[ ] ",Fe=Fe.replace(/^\[[ xX]\] +/,""))),re.items.push({type:"list_item",raw:$e,task:!!ft,checked:gt,loose:!1,text:Fe,tokens:[]}),re.raw+=$e}re.items[re.items.length-1].raw=re.items[re.items.length-1].raw.trimEnd(),re.items[re.items.length-1].text=re.items[re.items.length-1].text.trimEnd(),re.raw=re.raw.trimEnd();for(let J=0;J<re.items.length;J++)if(this.lexer.state.top=!1,re.items[J].tokens=this.lexer.blockTokens(re.items[J].text,[]),!re.loose){const $e=re.items[J].tokens.filter(He=>He.type==="space"),Fe=$e.length>0&&$e.some(He=>/\n.*\n/.test(He.raw));re.loose=Fe}if(re.loose)for(let J=0;J<re.items.length;J++)re.items[J].loose=!0;return re}}html(me){const V=this.rules.block.html.exec(me);if(V)return{type:"html",block:!0,raw:V[0],pre:V[1]==="pre"||V[1]==="script"||V[1]==="style",text:V[0]}}def(me){const V=this.rules.block.def.exec(me);if(V){const _=V[1].toLowerCase().replace(/\s+/g," "),fe=V[2]?V[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",re=V[3]?V[3].substring(1,V[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):V[3];return{type:"def",tag:_,raw:V[0],href:fe,title:re}}}table(me){const V=this.rules.block.table.exec(me);if(!V||!/[:|]/.test(V[2]))return;const _=a(V[1]),fe=V[2].replace(/^\||\| *$/g,"").split("|"),re=V[3]&&V[3].trim()?V[3].replace(/\n[ \t]*$/,"").split(`
`):[],he={type:"table",raw:V[0],header:[],align:[],rows:[]};if(_.length===fe.length){for(const H of fe)/^ *-+: *$/.test(H)?he.align.push("right"):/^ *:-+: *$/.test(H)?he.align.push("center"):/^ *:-+ *$/.test(H)?he.align.push("left"):he.align.push(null);for(let H=0;H<_.length;H++)he.header.push({text:_[H],tokens:this.lexer.inline(_[H]),header:!0,align:he.align[H]});for(const H of re)he.rows.push(a(H,he.header.length).map((J,$e)=>({text:J,tokens:this.lexer.inline(J),header:!1,align:he.align[$e]})));return he}}lheading(me){const V=this.rules.block.lheading.exec(me);if(V)return{type:"heading",raw:V[0],depth:V[2].charAt(0)==="="?1:2,text:V[1],tokens:this.lexer.inline(V[1])}}paragraph(me){const V=this.rules.block.paragraph.exec(me);if(V){const _=V[1].charAt(V[1].length-1)===`
`?V[1].slice(0,-1):V[1];return{type:"paragraph",raw:V[0],text:_,tokens:this.lexer.inline(_)}}}text(me){const V=this.rules.block.text.exec(me);if(V)return{type:"text",raw:V[0],text:V[0],tokens:this.lexer.inline(V[0])}}escape(me){const V=this.rules.inline.escape.exec(me);if(V)return{type:"escape",raw:V[0],text:s(V[1])}}tag(me){const V=this.rules.inline.tag.exec(me);if(V)return!this.lexer.state.inLink&&/^<a /i.test(V[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(V[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(V[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(V[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:V[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:V[0]}}link(me){const V=this.rules.inline.link.exec(me);if(V){const _=V[2].trim();if(!this.options.pedantic&&/^</.test(_)){if(!/>$/.test(_))return;const he=c(_.slice(0,-1),"\\");if((_.length-he.length)%2===0)return}else{const he=m(V[2],"()");if(he>-1){const J=(V[0].indexOf("!")===0?5:4)+V[1].length+he;V[2]=V[2].substring(0,he),V[0]=V[0].substring(0,J).trim(),V[3]=""}}let fe=V[2],re="";if(this.options.pedantic){const he=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(fe);he&&(fe=he[1],re=he[3])}else re=V[3]?V[3].slice(1,-1):"";return fe=fe.trim(),/^</.test(fe)&&(this.options.pedantic&&!/>$/.test(_)?fe=fe.slice(1):fe=fe.slice(1,-1)),b(V,{href:fe&&fe.replace(this.rules.inline.anyPunctuation,"$1"),title:re&&re.replace(this.rules.inline.anyPunctuation,"$1")},V[0],this.lexer)}}reflink(me,V){let _;if((_=this.rules.inline.reflink.exec(me))||(_=this.rules.inline.nolink.exec(me))){const fe=(_[2]||_[1]).replace(/\s+/g," "),re=V[fe.toLowerCase()];if(!re){const he=_[0].charAt(0);return{type:"text",raw:he,text:he}}return b(_,re,_[0],this.lexer)}}emStrong(me,V,_=""){let fe=this.rules.inline.emStrongLDelim.exec(me);if(!fe||fe[3]&&_.match(/[\p{L}\p{N}]/u))return;if(!(fe[1]||fe[2]||"")||!_||this.rules.inline.punctuation.exec(_)){const he=[...fe[0]].length-1;let H,J,$e=he,Fe=0;const He=fe[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(He.lastIndex=0,V=V.slice(-1*me.length+he);(fe=He.exec(V))!=null;){if(H=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!H)continue;if(J=[...H].length,fe[3]||fe[4]){$e+=J;continue}else if((fe[5]||fe[6])&&he%3&&!((he+J)%3)){Fe+=J;continue}if($e-=J,$e>0)continue;J=Math.min(J,J+$e+Fe);const xe=[...fe[0]][0].length,et=me.slice(0,he+fe.index+xe+J);if(Math.min(he,J)%2){const ft=et.slice(1,-1);return{type:"em",raw:et,text:ft,tokens:this.lexer.inlineTokens(ft)}}const it=et.slice(2,-2);return{type:"strong",raw:et,text:it,tokens:this.lexer.inlineTokens(it)}}}}codespan(me){const V=this.rules.inline.code.exec(me);if(V){let _=V[2].replace(/\n/g," ");const fe=/[^ ]/.test(_),re=/^ /.test(_)&&/ $/.test(_);return fe&&re&&(_=_.substring(1,_.length-1)),_=s(_,!0),{type:"codespan",raw:V[0],text:_}}}br(me){const V=this.rules.inline.br.exec(me);if(V)return{type:"br",raw:V[0]}}del(me){const V=this.rules.inline.del.exec(me);if(V)return{type:"del",raw:V[0],text:V[2],tokens:this.lexer.inlineTokens(V[2])}}autolink(me){const V=this.rules.inline.autolink.exec(me);if(V){let _,fe;return V[2]==="@"?(_=s(V[1]),fe="mailto:"+_):(_=s(V[1]),fe=_),{type:"link",raw:V[0],text:_,href:fe,tokens:[{type:"text",raw:_,text:_}]}}}url(me){let V;if(V=this.rules.inline.url.exec(me)){let _,fe;if(V[2]==="@")_=s(V[0]),fe="mailto:"+_;else{let re;do re=V[0],V[0]=this.rules.inline._backpedal.exec(V[0])?.[0]??"";while(re!==V[0]);_=s(V[0]),V[1]==="www."?fe="http://"+V[0]:fe=V[0]}return{type:"link",raw:V[0],text:_,href:fe,tokens:[{type:"text",raw:_,text:_}]}}}inlineText(me){const V=this.rules.inline.text.exec(me);if(V){let _;return this.lexer.state.inRawBlock?_=V[0]:_=s(V[0]),{type:"text",raw:V[0],text:_}}}}const w=/^(?: *(?:\n|$))+/,o=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,l=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,n=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,u=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,i=/(?:[*+-]|\d{1,9}[.)])/,f=y(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,i).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),h=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,k=/^[^\n]+/,I=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O=y(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",I).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),C=y(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,i).getRegex(),L="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",R=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,M=y("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",R).replace("tag",L).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G=y(h).replace("hr",n).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L).getRegex(),te={blockquote:y(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",G).getRegex(),code:o,def:O,fences:l,heading:u,hr:n,html:M,lheading:f,list:C,newline:w,paragraph:G,table:g,text:k},ve=y("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",n).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L).getRegex(),be={...te,table:ve,paragraph:y(h).replace("hr",n).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",ve).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L).getRegex()},le={...te,html:y(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",R).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:y(h).replace("hr",n).replace("heading",` *#{1,6} *[^
]`).replace("lheading",f).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},K=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,B=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,j=/^( {2,}|\\)\n(?!\s*$)/,U=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,ee="\\p{P}\\p{S}",ae=y(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,ee).getRegex(),ye=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,se=y(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,ee).getRegex(),ne=y("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,ee).getRegex(),X=y("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,ee).getRegex(),z=y(/\\([punct])/,"gu").replace(/punct/g,ee).getRegex(),A=y(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),Y=y(R).replace("(?:-->|$)","-->").getRegex(),pe=y("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",Y).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),x=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie=y(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",x).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),W=y(/^!?\[(label)\]\[(ref)\]/).replace("label",x).replace("ref",I).getRegex(),Z=y(/^!?\[(ref)\](?:\[\])?/).replace("ref",I).getRegex(),ce=y("reflink|nolink(?!\\()","g").replace("reflink",W).replace("nolink",Z).getRegex(),we={_backpedal:g,anyPunctuation:z,autolink:A,blockSkip:ye,br:j,code:B,del:g,emStrongLDelim:se,emStrongRDelimAst:ne,emStrongRDelimUnd:X,escape:K,link:ie,nolink:Z,punctuation:ae,reflink:W,reflinkSearch:ce,tag:pe,text:U,url:g},Le={...we,link:y(/^!?\[(label)\]\((.*?)\)/).replace("label",x).getRegex(),reflink:y(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",x).getRegex()},ze={...we,escape:y(K).replace("])","~|])").getRegex(),url:y(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},qe={...ze,br:y(j).replace("{2,}","*").getRegex(),text:y(ze.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},Re={normal:te,gfm:be,pedantic:le},Ne={normal:we,gfm:ze,breaks:qe,pedantic:Le};class De{tokens;options;state;tokenizer;inlineQueue;constructor(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||ue.defaults,this.options.tokenizer=this.options.tokenizer||new d,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const V={block:Re.normal,inline:Ne.normal};this.options.pedantic?(V.block=Re.pedantic,V.inline=Ne.pedantic):this.options.gfm&&(V.block=Re.gfm,this.options.breaks?V.inline=Ne.breaks:V.inline=Ne.gfm),this.tokenizer.rules=V}static get rules(){return{block:Re,inline:Ne}}static lex(me,V){return new De(V).lex(me)}static lexInline(me,V){return new De(V).inlineTokens(me)}lex(me){me=me.replace(/\r\n|\r/g,`
`),this.blockTokens(me,this.tokens);for(let V=0;V<this.inlineQueue.length;V++){const _=this.inlineQueue[V];this.inlineTokens(_.src,_.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(me,V=[],_=!1){this.options.pedantic?me=me.replace(/\t/g,"    ").replace(/^ +$/gm,""):me=me.replace(/^( *)(\t+)/gm,(H,J,$e)=>J+"    ".repeat($e.length));let fe,re,he;for(;me;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(H=>(fe=H.call({lexer:this},me,V))?(me=me.substring(fe.raw.length),V.push(fe),!0):!1))){if(fe=this.tokenizer.space(me)){me=me.substring(fe.raw.length),fe.raw.length===1&&V.length>0?V[V.length-1].raw+=`
`:V.push(fe);continue}if(fe=this.tokenizer.code(me)){me=me.substring(fe.raw.length),re=V[V.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+fe.raw,re.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=re.text):V.push(fe);continue}if(fe=this.tokenizer.fences(me)){me=me.substring(fe.raw.length),V.push(fe);continue}if(fe=this.tokenizer.heading(me)){me=me.substring(fe.raw.length),V.push(fe);continue}if(fe=this.tokenizer.hr(me)){me=me.substring(fe.raw.length),V.push(fe);continue}if(fe=this.tokenizer.blockquote(me)){me=me.substring(fe.raw.length),V.push(fe);continue}if(fe=this.tokenizer.list(me)){me=me.substring(fe.raw.length),V.push(fe);continue}if(fe=this.tokenizer.html(me)){me=me.substring(fe.raw.length),V.push(fe);continue}if(fe=this.tokenizer.def(me)){me=me.substring(fe.raw.length),re=V[V.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+fe.raw,re.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=re.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(me)){me=me.substring(fe.raw.length),V.push(fe);continue}if(fe=this.tokenizer.lheading(me)){me=me.substring(fe.raw.length),V.push(fe);continue}if(he=me,this.options.extensions&&this.options.extensions.startBlock){let H=1/0;const J=me.slice(1);let $e;this.options.extensions.startBlock.forEach(Fe=>{$e=Fe.call({lexer:this},J),typeof $e=="number"&&$e>=0&&(H=Math.min(H,$e))}),H<1/0&&H>=0&&(he=me.substring(0,H+1))}if(this.state.top&&(fe=this.tokenizer.paragraph(he))){re=V[V.length-1],_&&re?.type==="paragraph"?(re.raw+=`
`+fe.raw,re.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):V.push(fe),_=he.length!==me.length,me=me.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(me)){me=me.substring(fe.raw.length),re=V[V.length-1],re&&re.type==="text"?(re.raw+=`
`+fe.raw,re.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):V.push(fe);continue}if(me){const H="Infinite loop on byte: "+me.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return this.state.top=!0,V}inline(me,V=[]){return this.inlineQueue.push({src:me,tokens:V}),V}inlineTokens(me,V=[]){let _,fe,re,he=me,H,J,$e;if(this.tokens.links){const Fe=Object.keys(this.tokens.links);if(Fe.length>0)for(;(H=this.tokenizer.rules.inline.reflinkSearch.exec(he))!=null;)Fe.includes(H[0].slice(H[0].lastIndexOf("[")+1,-1))&&(he=he.slice(0,H.index)+"["+"a".repeat(H[0].length-2)+"]"+he.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(H=this.tokenizer.rules.inline.blockSkip.exec(he))!=null;)he=he.slice(0,H.index)+"["+"a".repeat(H[0].length-2)+"]"+he.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(H=this.tokenizer.rules.inline.anyPunctuation.exec(he))!=null;)he=he.slice(0,H.index)+"++"+he.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;me;)if(J||($e=""),J=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(Fe=>(_=Fe.call({lexer:this},me,V))?(me=me.substring(_.raw.length),V.push(_),!0):!1))){if(_=this.tokenizer.escape(me)){me=me.substring(_.raw.length),V.push(_);continue}if(_=this.tokenizer.tag(me)){me=me.substring(_.raw.length),fe=V[V.length-1],fe&&_.type==="text"&&fe.type==="text"?(fe.raw+=_.raw,fe.text+=_.text):V.push(_);continue}if(_=this.tokenizer.link(me)){me=me.substring(_.raw.length),V.push(_);continue}if(_=this.tokenizer.reflink(me,this.tokens.links)){me=me.substring(_.raw.length),fe=V[V.length-1],fe&&_.type==="text"&&fe.type==="text"?(fe.raw+=_.raw,fe.text+=_.text):V.push(_);continue}if(_=this.tokenizer.emStrong(me,he,$e)){me=me.substring(_.raw.length),V.push(_);continue}if(_=this.tokenizer.codespan(me)){me=me.substring(_.raw.length),V.push(_);continue}if(_=this.tokenizer.br(me)){me=me.substring(_.raw.length),V.push(_);continue}if(_=this.tokenizer.del(me)){me=me.substring(_.raw.length),V.push(_);continue}if(_=this.tokenizer.autolink(me)){me=me.substring(_.raw.length),V.push(_);continue}if(!this.state.inLink&&(_=this.tokenizer.url(me))){me=me.substring(_.raw.length),V.push(_);continue}if(re=me,this.options.extensions&&this.options.extensions.startInline){let Fe=1/0;const He=me.slice(1);let xe;this.options.extensions.startInline.forEach(et=>{xe=et.call({lexer:this},He),typeof xe=="number"&&xe>=0&&(Fe=Math.min(Fe,xe))}),Fe<1/0&&Fe>=0&&(re=me.substring(0,Fe+1))}if(_=this.tokenizer.inlineText(re)){me=me.substring(_.raw.length),_.raw.slice(-1)!=="_"&&($e=_.raw.slice(-1)),J=!0,fe=V[V.length-1],fe&&fe.type==="text"?(fe.raw+=_.raw,fe.text+=_.text):V.push(_);continue}if(me){const Fe="Infinite loop on byte: "+me.charCodeAt(0);if(this.options.silent){console.error(Fe);break}else throw new Error(Fe)}}return V}}class Ce{options;parser;constructor(me){this.options=me||ue.defaults}space(me){return""}code({text:me,lang:V,escaped:_}){const fe=(V||"").match(/^\S*/)?.[0],re=me.replace(/\n$/,"")+`
`;return fe?'<pre><code class="language-'+s(fe)+'">'+(_?re:s(re,!0))+`</code></pre>
`:"<pre><code>"+(_?re:s(re,!0))+`</code></pre>
`}blockquote({tokens:me}){return`<blockquote>
${this.parser.parse(me)}</blockquote>
`}html({text:me}){return me}heading({tokens:me,depth:V}){return`<h${V}>${this.parser.parseInline(me)}</h${V}>
`}hr(me){return`<hr>
`}list(me){const V=me.ordered,_=me.start;let fe="";for(let H=0;H<me.items.length;H++){const J=me.items[H];fe+=this.listitem(J)}const re=V?"ol":"ul",he=V&&_!==1?' start="'+_+'"':"";return"<"+re+he+`>
`+fe+"</"+re+`>
`}listitem(me){let V="";if(me.task){const _=this.checkbox({checked:!!me.checked});me.loose?me.tokens.length>0&&me.tokens[0].type==="paragraph"?(me.tokens[0].text=_+" "+me.tokens[0].text,me.tokens[0].tokens&&me.tokens[0].tokens.length>0&&me.tokens[0].tokens[0].type==="text"&&(me.tokens[0].tokens[0].text=_+" "+me.tokens[0].tokens[0].text)):me.tokens.unshift({type:"text",raw:_+" ",text:_+" "}):V+=_+" "}return V+=this.parser.parse(me.tokens,!!me.loose),`<li>${V}</li>
`}checkbox({checked:me}){return"<input "+(me?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:me}){return`<p>${this.parser.parseInline(me)}</p>
`}table(me){let V="",_="";for(let re=0;re<me.header.length;re++)_+=this.tablecell(me.header[re]);V+=this.tablerow({text:_});let fe="";for(let re=0;re<me.rows.length;re++){const he=me.rows[re];_="";for(let H=0;H<he.length;H++)_+=this.tablecell(he[H]);fe+=this.tablerow({text:_})}return fe&&(fe=`<tbody>${fe}</tbody>`),`<table>
<thead>
`+V+`</thead>
`+fe+`</table>
`}tablerow({text:me}){return`<tr>
${me}</tr>
`}tablecell(me){const V=this.parser.parseInline(me.tokens),_=me.header?"th":"td";return(me.align?`<${_} align="${me.align}">`:`<${_}>`)+V+`</${_}>
`}strong({tokens:me}){return`<strong>${this.parser.parseInline(me)}</strong>`}em({tokens:me}){return`<em>${this.parser.parseInline(me)}</em>`}codespan({text:me}){return`<code>${me}</code>`}br(me){return"<br>"}del({tokens:me}){return`<del>${this.parser.parseInline(me)}</del>`}link({href:me,title:V,tokens:_}){const fe=this.parser.parseInline(_),re=$(me);if(re===null)return fe;me=re;let he='<a href="'+me+'"';return V&&(he+=' title="'+V+'"'),he+=">"+fe+"</a>",he}image({href:me,title:V,text:_}){const fe=$(me);if(fe===null)return _;me=fe;let re=`<img src="${me}" alt="${_}"`;return V&&(re+=` title="${V}"`),re+=">",re}text(me){return"tokens"in me&&me.tokens?this.parser.parseInline(me.tokens):me.text}}class ge{strong({text:me}){return me}em({text:me}){return me}codespan({text:me}){return me}del({text:me}){return me}html({text:me}){return me}text({text:me}){return me}link({text:me}){return""+me}image({text:me}){return""+me}br(){return""}}class Se{options;renderer;textRenderer;constructor(me){this.options=me||ue.defaults,this.options.renderer=this.options.renderer||new Ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new ge}static parse(me,V){return new Se(V).parse(me)}static parseInline(me,V){return new Se(V).parseInline(me)}parse(me,V=!0){let _="";for(let fe=0;fe<me.length;fe++){const re=me[fe];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]){const H=re,J=this.options.extensions.renderers[H.type].call({parser:this},H);if(J!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type)){_+=J||"";continue}}const he=re;switch(he.type){case"space":{_+=this.renderer.space(he);continue}case"hr":{_+=this.renderer.hr(he);continue}case"heading":{_+=this.renderer.heading(he);continue}case"code":{_+=this.renderer.code(he);continue}case"table":{_+=this.renderer.table(he);continue}case"blockquote":{_+=this.renderer.blockquote(he);continue}case"list":{_+=this.renderer.list(he);continue}case"html":{_+=this.renderer.html(he);continue}case"paragraph":{_+=this.renderer.paragraph(he);continue}case"text":{let H=he,J=this.renderer.text(H);for(;fe+1<me.length&&me[fe+1].type==="text";)H=me[++fe],J+=`
`+this.renderer.text(H);V?_+=this.renderer.paragraph({type:"paragraph",raw:J,text:J,tokens:[{type:"text",raw:J,text:J}]}):_+=J;continue}default:{const H='Token with "'+he.type+'" type was not found.';if(this.options.silent)return console.error(H),"";throw new Error(H)}}}return _}parseInline(me,V){V=V||this.renderer;let _="";for(let fe=0;fe<me.length;fe++){const re=me[fe];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]){const H=this.options.extensions.renderers[re.type].call({parser:this},re);if(H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(re.type)){_+=H||"";continue}}const he=re;switch(he.type){case"escape":{_+=V.text(he);break}case"html":{_+=V.html(he);break}case"link":{_+=V.link(he);break}case"image":{_+=V.image(he);break}case"strong":{_+=V.strong(he);break}case"em":{_+=V.em(he);break}case"codespan":{_+=V.codespan(he);break}case"br":{_+=V.br(he);break}case"del":{_+=V.del(he);break}case"text":{_+=V.text(he);break}default:{const H='Token with "'+he.type+'" type was not found.';if(this.options.silent)return console.error(H),"";throw new Error(H)}}}return _}}class Pe{options;constructor(me){this.options=me||ue.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(me){return me}postprocess(me){return me}processAllTokens(me){return me}}class Ue{defaults=e();options=this.setOptions;parse=this.parseMarkdown(De.lex,Se.parse);parseInline=this.parseMarkdown(De.lexInline,Se.parseInline);Parser=Se;Renderer=Ce;TextRenderer=ge;Lexer=De;Tokenizer=d;Hooks=Pe;constructor(...me){this.use(...me)}walkTokens(me,V){let _=[];for(const fe of me)switch(_=_.concat(V.call(this,fe)),fe.type){case"table":{const re=fe;for(const he of re.header)_=_.concat(this.walkTokens(he.tokens,V));for(const he of re.rows)for(const H of he)_=_.concat(this.walkTokens(H.tokens,V));break}case"list":{const re=fe;_=_.concat(this.walkTokens(re.items,V));break}default:{const re=fe;this.defaults.extensions?.childTokens?.[re.type]?this.defaults.extensions.childTokens[re.type].forEach(he=>{const H=re[he].flat(1/0);_=_.concat(this.walkTokens(H,V))}):re.tokens&&(_=_.concat(this.walkTokens(re.tokens,V)))}}return _}use(...me){const V=this.defaults.extensions||{renderers:{},childTokens:{}};return me.forEach(_=>{const fe={..._};if(fe.async=this.defaults.async||fe.async||!1,_.extensions&&(_.extensions.forEach(re=>{if(!re.name)throw new Error("extension name required");if("renderer"in re){const he=V.renderers[re.name];he?V.renderers[re.name]=function(...H){let J=re.renderer.apply(this,H);return J===!1&&(J=he.apply(this,H)),J}:V.renderers[re.name]=re.renderer}if("tokenizer"in re){if(!re.level||re.level!=="block"&&re.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const he=V[re.level];he?he.unshift(re.tokenizer):V[re.level]=[re.tokenizer],re.start&&(re.level==="block"?V.startBlock?V.startBlock.push(re.start):V.startBlock=[re.start]:re.level==="inline"&&(V.startInline?V.startInline.push(re.start):V.startInline=[re.start]))}"childTokens"in re&&re.childTokens&&(V.childTokens[re.name]=re.childTokens)}),fe.extensions=V),_.renderer){const re=this.defaults.renderer||new Ce(this.defaults);for(const he in _.renderer){if(!(he in re))throw new Error(`renderer '${he}' does not exist`);if(["options","parser"].includes(he))continue;const H=he,J=_.renderer[H],$e=re[H];re[H]=(...Fe)=>{let He=J.apply(re,Fe);return He===!1&&(He=$e.apply(re,Fe)),He||""}}fe.renderer=re}if(_.tokenizer){const re=this.defaults.tokenizer||new d(this.defaults);for(const he in _.tokenizer){if(!(he in re))throw new Error(`tokenizer '${he}' does not exist`);if(["options","rules","lexer"].includes(he))continue;const H=he,J=_.tokenizer[H],$e=re[H];re[H]=(...Fe)=>{let He=J.apply(re,Fe);return He===!1&&(He=$e.apply(re,Fe)),He}}fe.tokenizer=re}if(_.hooks){const re=this.defaults.hooks||new Pe;for(const he in _.hooks){if(!(he in re))throw new Error(`hook '${he}' does not exist`);if(he==="options")continue;const H=he,J=_.hooks[H],$e=re[H];Pe.passThroughHooks.has(he)?re[H]=Fe=>{if(this.defaults.async)return Promise.resolve(J.call(re,Fe)).then(xe=>$e.call(re,xe));const He=J.call(re,Fe);return $e.call(re,He)}:re[H]=(...Fe)=>{let He=J.apply(re,Fe);return He===!1&&(He=$e.apply(re,Fe)),He}}fe.hooks=re}if(_.walkTokens){const re=this.defaults.walkTokens,he=_.walkTokens;fe.walkTokens=function(H){let J=[];return J.push(he.call(this,H)),re&&(J=J.concat(re.call(this,H))),J}}this.defaults={...this.defaults,...fe}}),this}setOptions(me){return this.defaults={...this.defaults,...me},this}lexer(me,V){return De.lex(me,V??this.defaults)}parser(me,V){return Se.parse(me,V??this.defaults)}parseMarkdown(me,V){return(fe,re)=>{const he={...re},H={...this.defaults,...he},J=this.onError(!!H.silent,!!H.async);if(this.defaults.async===!0&&he.async===!1)return J(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof fe>"u"||fe===null)return J(new Error("marked(): input parameter is undefined or null"));if(typeof fe!="string")return J(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected"));if(H.hooks&&(H.hooks.options=H),H.async)return Promise.resolve(H.hooks?H.hooks.preprocess(fe):fe).then($e=>me($e,H)).then($e=>H.hooks?H.hooks.processAllTokens($e):$e).then($e=>H.walkTokens?Promise.all(this.walkTokens($e,H.walkTokens)).then(()=>$e):$e).then($e=>V($e,H)).then($e=>H.hooks?H.hooks.postprocess($e):$e).catch(J);try{H.hooks&&(fe=H.hooks.preprocess(fe));let $e=me(fe,H);H.hooks&&($e=H.hooks.processAllTokens($e)),H.walkTokens&&this.walkTokens($e,H.walkTokens);let Fe=V($e,H);return H.hooks&&(Fe=H.hooks.postprocess(Fe)),Fe}catch($e){return J($e)}}}onError(me,V){return _=>{if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,me){const fe="<p>An error occurred:</p><pre>"+s(_.message+"",!0)+"</pre>";return V?Promise.resolve(fe):fe}if(V)return Promise.reject(_);throw _}}}const Ge=new Ue;function Qe(Je,me){return Ge.parse(Je,me)}Qe.options=Qe.setOptions=function(Je){return Ge.setOptions(Je),Qe.defaults=Ge.defaults,t(Qe.defaults),Qe},Qe.getDefaults=e,Qe.defaults=ue.defaults,Qe.use=function(...Je){return Ge.use(...Je),Qe.defaults=Ge.defaults,t(Qe.defaults),Qe},Qe.walkTokens=function(Je,me){return Ge.walkTokens(Je,me)},Qe.parseInline=Ge.parseInline,Qe.Parser=Se,Qe.parser=Se.parse,Qe.Renderer=Ce,Qe.TextRenderer=ge,Qe.Lexer=De,Qe.lexer=De.lex,Qe.Tokenizer=d,Qe.Hooks=Pe,Qe.parse=Qe;const Ze=Qe.options,Xe=Qe.setOptions,tt=Qe.use,lt=Qe.walkTokens,ct=Qe.parseInline,rt=Qe,ut=Se.parse,st=De.lex;ue.Hooks=Pe,ue.Lexer=De,ue.Marked=Ue,ue.Parser=Se,ue.Renderer=Ce,ue.TextRenderer=ge,ue.Tokenizer=d,ue.getDefaults=e,ue.lexer=st,ue.marked=Qe,ue.options=Ze,ue.parse=rt,ue.parseInline=ct,ue.parser=ut,ue.setOptions=Xe,ue.use=tt,ue.walkTokens=lt}),define(Te[82],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var t;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(t||(e.MarshalledId=t={}))}),define(Te[165],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=t;function t(c){const m=P(c);if(m&&m.length>0)return new Uint32Array(m)}let r=0;const E=new Uint32Array(10);function P(c){if(r=0,D(c,y,v.InitialConsonant),r>0||(D(c,$,v.Vowel),r>0)||(D(c,g,v.FinalConsonant),r>0)||(D(c,a,v.CompatibilityJamo),r))return E.subarray(0,r);if(c>=44032&&c<=55203){const m=c-44032,b=m%588,p=Math.floor(m/588),d=Math.floor(b/28),w=b%28-1;if(p<y.length?D(p,y,0):v.InitialConsonant+p-v.CompatibilityJamo<a.length&&D(v.InitialConsonant+p,a,v.CompatibilityJamo),d<$.length?D(d,$,0):v.Vowel+d-v.CompatibilityJamo<a.length&&D(v.Vowel+d-v.CompatibilityJamo,a,v.CompatibilityJamo),w>=0&&(w<g.length?D(w,g,0):v.FinalConsonant+w-v.CompatibilityJamo<a.length&&D(v.FinalConsonant+w-v.CompatibilityJamo,a,v.CompatibilityJamo)),r>0)return E.subarray(0,r)}}function D(c,m,b){c>=b&&c<b+m.length&&T(m[c-b])}function T(c){c!==s.NUL&&(E[r++]=c&255,c>>8&&(E[r++]=c>>8&255),c>>16&&(E[r++]=c>>16&255))}var v;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var s;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(s||(s={}));var S;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(S||(S={}));const y=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),$=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,S.hk,S.ho,S.hl,s.y,s.n,S.nj,S.np,S.nl,s.b,s.m,S.ml,s.l]),g=new Uint16Array([s.r,s.R,S.rt,s.s,S.sw,S.sg,s.e,s.f,S.fr,S.fa,S.fq,S.ft,S.fx,S.fv,S.fg,s.a,s.q,S.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),a=new Uint16Array([s.r,s.R,S.rt,s.s,S.sw,S.sg,s.e,s.E,s.f,S.fr,S.fa,S.fq,S.ft,S.fx,S.fv,S.fg,s.a,s.q,s.Q,S.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,S.hk,S.ho,S.hl,s.y,s.n,S.nj,S.np,S.nl,s.b,s.m,S.ml,s.l])}),define(Te[106],Oe([1,0,25]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=void 0,e.$sm=E,e.$tm=D;const r=new t.$Ic(1e4);function E(s){return v(s,"NFC",r)}const P=new t.$Ic(1e4);function D(s){return v(s,"NFD",P)}const T=/[^\u0000-\u0080]/;function v(s,S,y){if(!s)return s;const $=y.get(s);if($)return $;let g;return T.test(s)?g=s.normalize(S):g=s,y.set(s,g),g}e.$um=function(){const s=/[\u0300-\u036f]/g;return function(S){return D(S).replace(s,"")}}()}),define(Te[166],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Qm=t,e.rot=r,e.$Vm=T;function t(v,s,S){return Math.min(Math.max(v,s),S)}function r(v,s){return(s+v%s)%s}class E{constructor(){this.a=0}getNext(){return this.a++}}e.$Sm=E;class P{constructor(){this.a=1,this.b=0}update(s){return this.b=this.b+(s-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Tm=P;class D{constructor(s){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(s),this.c.fill(0,0,s)}update(s){const S=this.c[this.d];return this.c[this.d]=s,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=s,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Um=D;function T(v,s,S,y,$,g,a,c){const m=a-S,b=c-y,p=$-S,d=g-y,w=v-S,o=s-y,l=m*m+b*b,n=m*p+b*d,u=m*w+b*o,i=p*p+d*d,f=p*w+d*o,h=1/(l*i-n*n),k=(i*u-n*f)*h,I=(l*f-n*u)*h;return k>=0&&I>=0&&k+I<1}}),define(Te[167],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fd=void 0,e.$gd=P,e.$hd=$;class t{constructor(a,c,m){this.owner=a,this.debugNameSource=c,this.referenceFn=m}getDebugName(a){return P(a,this)}}e.$fd=t;const r=new Map,E=new WeakMap;function P(g,a){const c=E.get(g);if(c)return c;const m=D(g,a);if(m){let b=r.get(m)??0;b++,r.set(m,b);const p=b===1?m:`${m}#${b}`;return E.set(g,p),p}}function D(g,a){const c=E.get(g);if(c)return c;const m=a.owner?S(a.owner)+".":"";let b;const p=a.debugNameSource;if(p!==void 0)if(typeof p=="function"){if(b=p(),b!==void 0)return m+b}else return m+p;const d=a.referenceFn;if(d!==void 0&&(b=$(d),b!==void 0))return m+b;if(a.owner!==void 0){const w=T(a.owner,g);if(w!==void 0)return m+w}}function T(g,a){for(const c in g)if(g[c]===a)return c}const v=new Map,s=new WeakMap;function S(g){const a=s.get(g);if(a)return a;const c=y(g);let m=v.get(c)??0;m++,v.set(c,m);const b=m===1?c:`${c}#${m}`;return s.set(g,b),b}function y(g){const a=g.constructor;return a?a.name:"Object"}function $(g){const a=g.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(a);return(m?m[1]:void 0)?.trim()}}),define(Te[168],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0,e.$Pd=r,e.$Qd=E;let t;function r(c){t=c}function E(){return t}class P{constructor(){this.a=0,this.d=new WeakMap}b(m){return D([T(g("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[T(" "),s(S(m.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),s(S(m.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),s(S(m.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(m,b){console.log(...this.b([v("observable value changed"),s(m.debugName,{color:"BlueViolet"}),...this.c(b)]))}formatChanges(m){if(m.size!==0)return s(" (changed deps: "+[...m].map(b=>b.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const b=m.handleChange;this.d.set(m,new Set),m.handleChange=(p,d)=>(this.d.get(m).add(p),b.apply(m,[p,d]))}handleDerivedRecomputed(m,b){const p=this.d.get(m);console.log(...this.b([v("derived recomputed"),s(m.debugName,{color:"BlueViolet"}),...this.c(b),this.formatChanges(p),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),p.clear()}handleFromEventObservableTriggered(m,b){console.log(...this.b([v("observable from event triggered"),s(m.debugName,{color:"BlueViolet"}),...this.c(b),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const b=m.handleChange;this.d.set(m,new Set),m.handleChange=(p,d)=>(this.d.get(m).add(p),b.apply(m,[p,d]))}handleAutorunTriggered(m){const b=this.d.get(m);console.log(...this.b([v("autorun"),s(m.debugName,{color:"BlueViolet"}),this.formatChanges(b),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),b.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let b=m.getDebugName();b===void 0&&(b=""),console.log(...this.b([v("transaction"),s(b,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Rd=P;function D(c){const m=new Array,b=[];let p="";function d(o){if("length"in o)for(const l of o)l&&d(l);else"text"in o?(p+=`%c${o.text}`,m.push(o.style),o.data&&b.push(...o.data)):"data"in o&&b.push(...o.data)}d(c);const w=[p,...m];return w.push(...b),w}function T(c){return s(c,{color:"black"})}function v(c){return s(a(`${c}: `,10),{color:"black",bold:!0})}function s(c,m={color:"black"}){function b(d){return Object.entries(d).reduce((w,[o,l])=>`${w}${o}:${l};`,"")}const p={color:m.color};return m.strikeThrough&&(p["text-decoration"]="line-through"),m.bold&&(p["font-weight"]="bold"),{text:c,style:b(p)}}function S(c,m){switch(typeof c){case"number":return""+c;case"string":return c.length+2<=m?`"${c}"`:`"${c.substr(0,m-7)}"+...`;case"boolean":return c?"true":"false";case"undefined":return"undefined";case"object":return c===null?"null":Array.isArray(c)?y(c,m):$(c,m);case"symbol":return c.toString();case"function":return`[[Function${c.name?" "+c.name:""}]]`;default:return""+c}}function y(c,m){let b="[ ",p=!0;for(const d of c){if(p||(b+=", "),b.length-5>m){b+="...";break}p=!1,b+=`${S(d,m-b.length)}`}return b+=" ]",b}function $(c,m){let b="{ ",p=!0;for(const[d,w]of Object.entries(c)){if(p||(b+=", "),b.length-5>m){b+="...";break}p=!1,b+=`${d}: ${S(w,m-b.length)}`}return b+=" }",b}function g(c,m){let b="";for(let p=1;p<=m;p++)b+=c;return b}function a(c,m){for(;c.length<m;)c+=" ";return c}}),define(Te[169],Oe([1,0,160,167,168]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$_d=e.$0d=e.$5d=e.$4d=void 0,e.$1d=D,e.$2d=v,e.$3d=S,e.$6d=g,e.$7d=c,e.$8d=m,e.$9d=b,e.$$d=d,e.$ae=o;let P;function D(n){P=n}let T;function v(n){T=n}let s;function S(n){s=n}class y{get TChange(){return null}reportChanges(){this.get()}read(u){return u?u.readObservable(this):this.get()}map(u,i){const f=i===void 0?void 0:u,h=i===void 0?u:i;return s({owner:f,debugName:()=>{const k=(0,r.$hd)(h);if(k!==void 0)return k;const O=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(h.toString());if(O)return`${this.debugName}.${O[2]}`;if(!f)return`${this.debugName} (mapped)`},debugReferenceFn:h},k=>h(this.read(k),k))}flatten(){return s({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},u=>this.read(u).read(u))}recomputeInitiallyAndOnChange(u,i){return u.add(P(this,i)),this}keepObserved(u){return u.add(T(this)),this}get a(){return this.get()}}e.$4d=y;class $ extends y{constructor(){super(...arguments),this.b=new Set}addObserver(u){const i=this.b.size;this.b.add(u),i===0&&this.c()}removeObserver(u){this.b.delete(u)&&this.b.size===0&&this.f()}c(){}f(){}}e.$5d=$;function g(n,u){const i=new p(n,u);try{n(i)}finally{i.finish()}}let a;function c(n){if(a)n(a);else{const u=new p(n,void 0);a=u;try{n(u)}finally{u.finish(),a=void 0}}}async function m(n,u){const i=new p(n,u);try{await n(i)}finally{i.finish()}}function b(n,u,i){n?u(n):g(u,i)}class p{constructor(u,i){this._fn=u,this.b=i,this.a=[],(0,E.$Qd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,r.$hd)(this._fn)}updateObserver(u,i){this.a.push({observer:u,observable:i}),u.beginUpdate(i)}finish(){const u=this.a;for(let i=0;i<u.length;i++){const{observer:f,observable:h}=u[i];f.endUpdate(h)}this.a=null,(0,E.$Qd)()?.handleEndTransaction()}}e.$0d=p;function d(n,u){let i;return typeof n=="string"?i=new r.$fd(void 0,n,void 0):i=new r.$fd(n,void 0,void 0),new w(i,u,t.$$c)}class w extends ${get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(u,i,f){super(),this.e=u,this.g=f,this.d=i}get(){return this.d}set(u,i,f){if(f===void 0&&this.g(this.d,u))return;let h;i||(i=h=new p(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(u),(0,E.$Qd)()?.handleObservableChanged(this,{oldValue:k,newValue:u,change:f,didChange:!0,hadValue:!0});for(const I of this.b)i.updateObserver(I,this),I.handleChange(this,f)}finally{h&&h.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(u){this.d=u}}e.$_d=w;function o(n,u){let i;return typeof n=="string"?i=new r.$fd(void 0,n,void 0):i=new r.$fd(n,void 0,void 0),new l(i,u,t.$$c)}class l extends w{h(u){this.d!==u&&(this.d&&this.d.dispose(),this.d=u)}dispose(){this.d?.dispose()}}e.$be=l}),function(){function ue(E){const P=[];typeof E=="number"&&P.push("code/timeOrigin",E);function D(v){P.push(v,Date.now())}function T(){const v=[];for(let s=0;s<P.length;s+=2)v.push({name:P[s],startTime:P[s+1]});return v}return{mark:D,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ue():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const D of performance.getEntriesByType("mark"))P.push({name:D.name,startTime:Math.round(E+D.startTime)});return P}};if(typeof process=="object"){const E=performance?.timeOrigin;return ue(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),ue()}function t(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return t(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=t(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=t(r))}(),define(Te[170],Oe([1,0,39]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=void 0;const r=Symbol("unset");class E{constructor(){this.a=new D,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||t.Iterable.empty()}get entries(){return this.a.children?.entries()||t.Iterable.empty()}insert(v,s,S){this.d(v,y=>y._value=s,S)}mutate(v,s){this.d(v,S=>S._value=s(S._value===r?void 0:S._value))}mutatePath(v,s){this.d(v,()=>{},S=>s(S))}delete(v){const s=this.c(v);if(!s)return;let S=s.length-1;const y=s[S].node._value;if(y!==r){for(this.b--,s[S].node._value=r;S>0;S--){const{node:$,part:g}=s[S];if($.children?.size||$._value!==r)break;s[S-1].node.children.delete(g)}return y}}*deleteRecursive(v){const s=this.c(v);if(!s)return;const S=s[s.length-1].node;for(let y=s.length-1;y>0;y--){const $=s[y-1];if($.node.children.delete(s[y].part),$.node.children.size>0||$.node._value!==r)break}for(const y of P(S))y._value!==r&&(this.b--,yield y._value)}find(v){let s=this.a;for(const S of v){const y=s.children?.get(S);if(!y)return;s=y}return s._value===r?void 0:s._value}hasKeyOrParent(v){let s=this.a;for(const S of v){const y=s.children?.get(S);if(!y)return!1;if(y._value!==r)return!0;s=y}return!1}hasKeyOrChildren(v){let s=this.a;for(const S of v){const y=s.children?.get(S);if(!y)return!1;s=y}return!0}hasKey(v){let s=this.a;for(const S of v){const y=s.children?.get(S);if(!y)return!1;s=y}return s._value!==r}c(v){const s=[{part:"",node:this.a}];let S=0;for(const y of v){const $=s[S].node.children?.get(y);if(!$)return;s.push({part:y,node:$}),S++}return s}d(v,s,S){let y=this.a;for(const a of v){if(y.children)if(y.children.has(a))y=y.children.get(a);else{const c=new D;y.children.set(a,c),y=c}else{const c=new D;y.children=new Map([[a,c]]),y=c}S?.(y)}const $=y._value===r?0:1;s(y);const g=y._value===r?0:1;this.b+=g-$}*values(){for(const{_value:v}of P(this.a))v!==r&&(yield v)}}e.$qJ=E;function*P(T){const v=[T];for(;v.length>0;){const s=v.pop();if(yield s,s.children)for(const S of s.children.values())v.push(S)}}class D{constructor(){this._value=r}get value(){return this._value===r?void 0:this._value}set value(v){this._value=v===void 0?r:v}}}),function(ue,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var t=e();for(var r in t)(typeof exports=="object"?exports:ue)[r]=t[r]}}(typeof self<"u"?self:this,function(){return function(ue){var e={};function t(r){if(e[r])return e[r].exports;var E=e[r]={i:r,l:!1,exports:{}};return ue[r].call(E.exports,E,E.exports,t),E.l=!0,E.exports}return t.m=ue,t.c=e,t.d=function(r,E,P){t.o(r,E)||Object.defineProperty(r,E,{enumerable:!0,get:P})},t.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},t.t=function(r,E){if(1&E&&(r=t(r)),8&E||4&E&&typeof r=="object"&&r&&r.__esModule)return r;var P=Object.create(null);if(t.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:r}),2&E&&typeof r!="string")for(var D in r)t.d(P,D,function(T){return r[T]}.bind(null,D));return P},t.n=function(r){var E=r&&r.__esModule?function(){return r.default}:function(){return r};return t.d(E,"a",E),E},t.o=function(r,E){return Object.prototype.hasOwnProperty.call(r,E)},t.p="",t(t.s=0)}([function(ue,e,t){(function(r){var E;e=ue.exports=ne,E=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],v=e.src=[],s=0,S=s++;v[S]="0|[1-9]\\d*";var y=s++;v[y]="[0-9]+";var $=s++;v[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=s++;v[g]="("+v[S]+")\\.("+v[S]+")\\.("+v[S]+")";var a=s++;v[a]="("+v[y]+")\\.("+v[y]+")\\.("+v[y]+")";var c=s++;v[c]="(?:"+v[S]+"|"+v[$]+")";var m=s++;v[m]="(?:"+v[y]+"|"+v[$]+")";var b=s++;v[b]="(?:-("+v[c]+"(?:\\."+v[c]+")*))";var p=s++;v[p]="(?:-?("+v[m]+"(?:\\."+v[m]+")*))";var d=s++;v[d]="[0-9A-Za-z-]+";var w=s++;v[w]="(?:\\+("+v[d]+"(?:\\."+v[d]+")*))";var o=s++,l="v?"+v[g]+v[b]+"?"+v[w]+"?";v[o]="^"+l+"$";var n="[v=\\s]*"+v[a]+v[p]+"?"+v[w]+"?",u=s++;v[u]="^"+n+"$";var i=s++;v[i]="((?:<|>)?=?)";var f=s++;v[f]=v[y]+"|x|X|\\*";var h=s++;v[h]=v[S]+"|x|X|\\*";var k=s++;v[k]="[v=\\s]*("+v[h]+")(?:\\.("+v[h]+")(?:\\.("+v[h]+")(?:"+v[b]+")?"+v[w]+"?)?)?";var I=s++;v[I]="[v=\\s]*("+v[f]+")(?:\\.("+v[f]+")(?:\\.("+v[f]+")(?:"+v[p]+")?"+v[w]+"?)?)?";var O=s++;v[O]="^"+v[i]+"\\s*"+v[k]+"$";var C=s++;v[C]="^"+v[i]+"\\s*"+v[I]+"$";var L=s++;v[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=s++;v[R]="(?:~>?)";var M=s++;v[M]="(\\s*)"+v[R]+"\\s+",T[M]=new RegExp(v[M],"g");var G=s++;v[G]="^"+v[R]+v[k]+"$";var Q=s++;v[Q]="^"+v[R]+v[I]+"$";var te=s++;v[te]="(?:\\^)";var ve=s++;v[ve]="(\\s*)"+v[te]+"\\s+",T[ve]=new RegExp(v[ve],"g");var be=s++;v[be]="^"+v[te]+v[k]+"$";var le=s++;v[le]="^"+v[te]+v[I]+"$";var K=s++;v[K]="^"+v[i]+"\\s*("+n+")$|^$";var B=s++;v[B]="^"+v[i]+"\\s*("+l+")$|^$";var j=s++;v[j]="(\\s*)"+v[i]+"\\s*("+n+"|"+v[k]+")",T[j]=new RegExp(v[j],"g");var U=s++;v[U]="^\\s*("+v[k]+")\\s+-\\s+("+v[k]+")\\s*$";var ee=s++;v[ee]="^\\s*("+v[I]+")\\s+-\\s+("+v[I]+")\\s*$";var ae=s++;v[ae]="(<|>)?=?\\s*\\*";for(var ye=0;ye<35;ye++)E(ye,v[ye]),T[ye]||(T[ye]=new RegExp(v[ye]));function se(ge,Se){if(ge instanceof ne)return ge;if(typeof ge!="string"||ge.length>P||!(Se?T[u]:T[o]).test(ge))return null;try{return new ne(ge,Se)}catch{return null}}function ne(ge,Se){if(ge instanceof ne){if(ge.loose===Se)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof ne))return new ne(ge,Se);E("SemVer",ge,Se),this.loose=Se;var Pe=ge.trim().match(Se?T[u]:T[o]);if(!Pe)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+Pe[1],this.minor=+Pe[2],this.patch=+Pe[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");Pe[4]?this.prerelease=Pe[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var Ge=+Ue;if(Ge>=0&&Ge<D)return Ge}return Ue}):this.prerelease=[],this.build=Pe[5]?Pe[5].split("."):[],this.format()}e.parse=se,e.valid=function(ge,Se){var Pe=se(ge,Se);return Pe?Pe.version:null},e.clean=function(ge,Se){var Pe=se(ge.trim().replace(/^[=v]+/,""),Se);return Pe?Pe.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(ge){return E("SemVer.compare",this.version,this.loose,ge),ge instanceof ne||(ge=new ne(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},ne.prototype.compareMain=function(ge){return ge instanceof ne||(ge=new ne(ge,this.loose)),z(this.major,ge.major)||z(this.minor,ge.minor)||z(this.patch,ge.patch)},ne.prototype.comparePre=function(ge){if(ge instanceof ne||(ge=new ne(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var Se=0;do{var Pe=this.prerelease[Se],Ue=ge.prerelease[Se];if(E("prerelease compare",Se,Pe,Ue),Pe===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(Pe===void 0)return-1;if(Pe!==Ue)return z(Pe,Ue)}while(++Se)},ne.prototype.inc=function(ge,Se){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Pe=this.prerelease.length;--Pe>=0;)typeof this.prerelease[Pe]=="number"&&(this.prerelease[Pe]++,Pe=-2);Pe===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,Se,Pe,Ue){typeof Pe=="string"&&(Ue=Pe,Pe=void 0);try{return new ne(ge,Pe).inc(Se,Ue).version}catch{return null}},e.diff=function(ge,Se){if(x(ge,Se))return null;var Pe=se(ge),Ue=se(Se);if(Pe.prerelease.length||Ue.prerelease.length){for(var Ge in Pe)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&Pe[Ge]!==Ue[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in Pe)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&Pe[Ge]!==Ue[Ge])return Ge},e.compareIdentifiers=z;var X=/^[0-9]+$/;function z(ge,Se){var Pe=X.test(ge),Ue=X.test(Se);return Pe&&Ue&&(ge=+ge,Se=+Se),Pe&&!Ue?-1:Ue&&!Pe?1:ge<Se?-1:ge>Se?1:0}function A(ge,Se,Pe){return new ne(ge,Pe).compare(new ne(Se,Pe))}function Y(ge,Se,Pe){return A(ge,Se,Pe)>0}function pe(ge,Se,Pe){return A(ge,Se,Pe)<0}function x(ge,Se,Pe){return A(ge,Se,Pe)===0}function ie(ge,Se,Pe){return A(ge,Se,Pe)!==0}function W(ge,Se,Pe){return A(ge,Se,Pe)>=0}function Z(ge,Se,Pe){return A(ge,Se,Pe)<=0}function ce(ge,Se,Pe,Ue){var Ge;switch(Se){case"===":typeof ge=="object"&&(ge=ge.version),typeof Pe=="object"&&(Pe=Pe.version),Ge=ge===Pe;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof Pe=="object"&&(Pe=Pe.version),Ge=ge!==Pe;break;case"":case"=":case"==":Ge=x(ge,Pe,Ue);break;case"!=":Ge=ie(ge,Pe,Ue);break;case">":Ge=Y(ge,Pe,Ue);break;case">=":Ge=W(ge,Pe,Ue);break;case"<":Ge=pe(ge,Pe,Ue);break;case"<=":Ge=Z(ge,Pe,Ue);break;default:throw new TypeError("Invalid operator: "+Se)}return Ge}function we(ge,Se){if(ge instanceof we){if(ge.loose===Se)return ge;ge=ge.value}if(!(this instanceof we))return new we(ge,Se);E("comparator",ge,Se),this.loose=Se,this.parse(ge),this.semver===Le?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}e.rcompareIdentifiers=function(ge,Se){return z(Se,ge)},e.major=function(ge,Se){return new ne(ge,Se).major},e.minor=function(ge,Se){return new ne(ge,Se).minor},e.patch=function(ge,Se){return new ne(ge,Se).patch},e.compare=A,e.compareLoose=function(ge,Se){return A(ge,Se,!0)},e.rcompare=function(ge,Se,Pe){return A(Se,ge,Pe)},e.sort=function(ge,Se){return ge.sort(function(Pe,Ue){return e.compare(Pe,Ue,Se)})},e.rsort=function(ge,Se){return ge.sort(function(Pe,Ue){return e.rcompare(Pe,Ue,Se)})},e.gt=Y,e.lt=pe,e.eq=x,e.neq=ie,e.gte=W,e.lte=Z,e.cmp=ce,e.Comparator=we;var Le={};function ze(ge,Se){if(ge instanceof ze)return ge.loose===Se?ge:new ze(ge.raw,Se);if(ge instanceof we)return new ze(ge.value,Se);if(!(this instanceof ze))return new ze(ge,Se);if(this.loose=Se,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(Pe){return this.parseRange(Pe.trim())},this).filter(function(Pe){return Pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function qe(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function Re(ge,Se,Pe,Ue,Ge,Qe,Ze,Xe,tt,lt,ct,rt,ut){return((Se=qe(Pe)?"":qe(Ue)?">="+Pe+".0.0":qe(Ge)?">="+Pe+"."+Ue+".0":">="+Se)+" "+(Xe=qe(tt)?"":qe(lt)?"<"+(+tt+1)+".0.0":qe(ct)?"<"+tt+"."+(+lt+1)+".0":rt?"<="+tt+"."+lt+"."+ct+"-"+rt:"<="+Xe)).trim()}function Ne(ge,Se){for(var Pe=0;Pe<ge.length;Pe++)if(!ge[Pe].test(Se))return!1;if(Se.prerelease.length){for(Pe=0;Pe<ge.length;Pe++)if(E(ge[Pe].semver),ge[Pe].semver!==Le&&ge[Pe].semver.prerelease.length>0){var Ue=ge[Pe].semver;if(Ue.major===Se.major&&Ue.minor===Se.minor&&Ue.patch===Se.patch)return!0}return!1}return!0}function De(ge,Se,Pe){try{Se=new ze(Se,Pe)}catch{return!1}return Se.test(ge)}function Ce(ge,Se,Pe,Ue){var Ge,Qe,Ze,Xe,tt;switch(ge=new ne(ge,Ue),Se=new ze(Se,Ue),Pe){case">":Ge=Y,Qe=Z,Ze=pe,Xe=">",tt=">=";break;case"<":Ge=pe,Qe=W,Ze=Y,Xe="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(De(ge,Se,Ue))return!1;for(var lt=0;lt<Se.set.length;++lt){var ct=Se.set[lt],rt=null,ut=null;if(ct.forEach(function(st){st.semver===Le&&(st=new we(">=0.0.0")),rt=rt||st,ut=ut||st,Ge(st.semver,rt.semver,Ue)?rt=st:Ze(st.semver,ut.semver,Ue)&&(ut=st)}),rt.operator===Xe||rt.operator===tt||(!ut.operator||ut.operator===Xe)&&Qe(ge,ut.semver)||ut.operator===tt&&Ze(ge,ut.semver))return!1}return!0}we.prototype.parse=function(ge){var Se=this.loose?T[K]:T[B],Pe=ge.match(Se);if(!Pe)throw new TypeError("Invalid comparator: "+ge);this.operator=Pe[1],this.operator==="="&&(this.operator=""),Pe[2]?this.semver=new ne(Pe[2],this.loose):this.semver=Le},we.prototype.toString=function(){return this.value},we.prototype.test=function(ge){return E("Comparator.test",ge,this.loose),this.semver===Le||(typeof ge=="string"&&(ge=new ne(ge,this.loose)),ce(ge,this.operator,this.semver,this.loose))},we.prototype.intersects=function(ge,Se){if(!(ge instanceof we))throw new TypeError("a Comparator is required");var Pe;if(this.operator==="")return Pe=new ze(ge.value,Se),De(this.value,Pe,Se);if(ge.operator==="")return Pe=new ze(this.value,Se),De(ge.semver,Pe,Se);var Ue=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),Qe=this.semver.version===ge.semver.version,Ze=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),Xe=ce(this.semver,"<",ge.semver,Se)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),tt=ce(this.semver,">",ge.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return Ue||Ge||Qe&&Ze||Xe||tt},e.Range=ze,ze.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},ze.prototype.toString=function(){return this.range},ze.prototype.parseRange=function(ge){var Se=this.loose;ge=ge.trim(),E("range",ge,Se);var Pe=Se?T[ee]:T[U];ge=ge.replace(Pe,Re),E("hyphen replace",ge),ge=ge.replace(T[j],"$1$2$3"),E("comparator trim",ge,T[j]),ge=(ge=(ge=ge.replace(T[M],"$1~")).replace(T[ve],"$1^")).split(/\s+/).join(" ");var Ue=Se?T[K]:T[B],Ge=ge.split(" ").map(function(Qe){return function(Ze,Xe){return E("comp",Ze),Ze=function(tt,lt){return tt.trim().split(/\s+/).map(function(ct){return function(rt,ut){E("caret",rt,ut);var st=ut?T[le]:T[be];return rt.replace(st,function(Je,me,V,_,fe){var re;return E("caret",rt,Je,me,V,_,fe),qe(me)?re="":qe(V)?re=">="+me+".0.0 <"+(+me+1)+".0.0":qe(_)?re=me==="0"?">="+me+"."+V+".0 <"+me+"."+(+V+1)+".0":">="+me+"."+V+".0 <"+(+me+1)+".0.0":fe?(E("replaceCaret pr",fe),fe.charAt(0)!=="-"&&(fe="-"+fe),re=me==="0"?V==="0"?">="+me+"."+V+"."+_+fe+" <"+me+"."+V+"."+(+_+1):">="+me+"."+V+"."+_+fe+" <"+me+"."+(+V+1)+".0":">="+me+"."+V+"."+_+fe+" <"+(+me+1)+".0.0"):(E("no pr"),re=me==="0"?V==="0"?">="+me+"."+V+"."+_+" <"+me+"."+V+"."+(+_+1):">="+me+"."+V+"."+_+" <"+me+"."+(+V+1)+".0":">="+me+"."+V+"."+_+" <"+(+me+1)+".0.0"),E("caret return",re),re})}(ct,lt)}).join(" ")}(Ze,Xe),E("caret",Ze),Ze=function(tt,lt){return tt.trim().split(/\s+/).map(function(ct){return function(rt,ut){var st=ut?T[Q]:T[G];return rt.replace(st,function(Je,me,V,_,fe){var re;return E("tilde",rt,Je,me,V,_,fe),qe(me)?re="":qe(V)?re=">="+me+".0.0 <"+(+me+1)+".0.0":qe(_)?re=">="+me+"."+V+".0 <"+me+"."+(+V+1)+".0":fe?(E("replaceTilde pr",fe),fe.charAt(0)!=="-"&&(fe="-"+fe),re=">="+me+"."+V+"."+_+fe+" <"+me+"."+(+V+1)+".0"):re=">="+me+"."+V+"."+_+" <"+me+"."+(+V+1)+".0",E("tilde return",re),re})}(ct,lt)}).join(" ")}(Ze,Xe),E("tildes",Ze),Ze=function(tt,lt){return E("replaceXRanges",tt,lt),tt.split(/\s+/).map(function(ct){return function(rt,ut){rt=rt.trim();var st=ut?T[C]:T[O];return rt.replace(st,function(Je,me,V,_,fe,re){E("xRange",rt,Je,me,V,_,fe,re);var he=qe(V),H=he||qe(_),J=H||qe(fe);return me==="="&&J&&(me=""),he?Je=me===">"||me==="<"?"<0.0.0":"*":me&&J?(H&&(_=0),J&&(fe=0),me===">"?(me=">=",H?(V=+V+1,_=0,fe=0):J&&(_=+_+1,fe=0)):me==="<="&&(me="<",H?V=+V+1:_=+_+1),Je=me+V+"."+_+"."+fe):H?Je=">="+V+".0.0 <"+(+V+1)+".0.0":J&&(Je=">="+V+"."+_+".0 <"+V+"."+(+_+1)+".0"),E("xRange return",Je),Je})}(ct,lt)}).join(" ")}(Ze,Xe),E("xrange",Ze),Ze=function(tt,lt){return E("replaceStars",tt,lt),tt.trim().replace(T[ae],"")}(Ze,Xe),E("stars",Ze),Ze}(Qe,Se)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(Qe){return!!Qe.match(Ue)})),Ge=Ge.map(function(Qe){return new we(Qe,Se)})},ze.prototype.intersects=function(ge,Se){if(!(ge instanceof ze))throw new TypeError("a Range is required");return this.set.some(function(Pe){return Pe.every(function(Ue){return ge.set.some(function(Ge){return Ge.every(function(Qe){return Ue.intersects(Qe,Se)})})})})},e.toComparators=function(ge,Se){return new ze(ge,Se).set.map(function(Pe){return Pe.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},ze.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new ne(ge,this.loose));for(var Se=0;Se<this.set.length;Se++)if(Ne(this.set[Se],ge))return!0;return!1},e.satisfies=De,e.maxSatisfying=function(ge,Se,Pe){var Ue=null,Ge=null;try{var Qe=new ze(Se,Pe)}catch{return null}return ge.forEach(function(Ze){Qe.test(Ze)&&(Ue&&Ge.compare(Ze)!==-1||(Ge=new ne(Ue=Ze,Pe)))}),Ue},e.minSatisfying=function(ge,Se,Pe){var Ue=null,Ge=null;try{var Qe=new ze(Se,Pe)}catch{return null}return ge.forEach(function(Ze){Qe.test(Ze)&&(Ue&&Ge.compare(Ze)!==1||(Ge=new ne(Ue=Ze,Pe)))}),Ue},e.validRange=function(ge,Se){try{return new ze(ge,Se).range||"*"}catch{return null}},e.ltr=function(ge,Se,Pe){return Ce(ge,Se,"<",Pe)},e.gtr=function(ge,Se,Pe){return Ce(ge,Se,">",Pe)},e.outside=Ce,e.prerelease=function(ge,Se){var Pe=se(ge,Se);return Pe&&Pe.prerelease.length?Pe.prerelease:null},e.intersects=function(ge,Se,Pe){return ge=new ze(ge,Pe),Se=new ze(Se,Pe),ge.intersects(Se)},e.coerce=function(ge){if(ge instanceof ne)return ge;if(typeof ge!="string")return null;var Se=ge.match(T[L]);return Se==null?null:se((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,t(1))},function(ue,e){var t,r,E=ue.exports={};function P(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function T(m){if(t===setTimeout)return setTimeout(m,0);if((t===P||!t)&&setTimeout)return t=setTimeout,setTimeout(m,0);try{return t(m,0)}catch{try{return t.call(null,m,0)}catch{return t.call(this,m,0)}}}(function(){try{t=typeof setTimeout=="function"?setTimeout:P}catch{t=P}try{r=typeof clearTimeout=="function"?clearTimeout:D}catch{r=D}})();var v,s=[],S=!1,y=-1;function $(){S&&v&&(S=!1,v.length?s=v.concat(s):y=-1,s.length&&g())}function g(){if(!S){var m=T($);S=!0;for(var b=s.length;b;){for(v=s,s=[];++y<b;)v&&v[y].run();y=-1,b=s.length}v=null,S=!1,function(p){if(r===clearTimeout)return clearTimeout(p);if((r===D||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(p);try{r(p)}catch{try{return r.call(null,p)}catch{return r.call(this,p)}}}(m)}}function a(m,b){this.fun=m,this.array=b}function c(){}E.nextTick=function(m){var b=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)b[p-1]=arguments[p];s.push(new a(m,b)),s.length!==1||S||T(g)},a.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=c,E.addListener=c,E.once=c,E.off=c,E.removeListener=c,E.removeAllListeners=c,E.emit=c,E.prependListener=c,E.prependOnceListener=c,E.listeners=function(m){return[]},E.binding=function(m){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(m){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(Te[171],Oe([1,0]),function(ue,e){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0;class r{constructor(T,v,s){this.level=T,this.key=v,this.value=s,this.forward=[]}}const E=void 0;class P{constructor(T,v=2**16){this.comparator=T,this[t]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new r(this.c,E,E)}get size(){return this.f}clear(){this.e=new r(this.c,E,E),this.f=0}has(T){return!!P.g(this,T,this.comparator)}get(T){return P.g(this,T,this.comparator)?.value}set(T,v){return P.h(this,T,v,this.comparator)&&(this.f+=1),this}delete(T){const v=P.k(this,T,this.comparator);return v&&(this.f-=1),v}forEach(T,v){let s=this.e.forward[0];for(;s;)T.call(v,s.value,s.key,this),s=s.forward[0]}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let T=this.e.forward[0];for(;T;)yield[T.key,T.value],T=T.forward[0]}*keys(){let T=this.e.forward[0];for(;T;)yield T.key,T=T.forward[0]}*values(){let T=this.e.forward[0];for(;T;)yield T.value,T=T.forward[0]}toString(){let T="[SkipList]:",v=this.e.forward[0];for(;v;)T+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return T}static g(T,v,s){let S=T.e;for(let y=T.d-1;y>=0;y--)for(;S.forward[y]&&s(S.forward[y].key,v)<0;)S=S.forward[y];if(S=S.forward[0],S&&s(S.key,v)===0)return S}static h(T,v,s,S){const y=[];let $=T.e;for(let g=T.d-1;g>=0;g--){for(;$.forward[g]&&S($.forward[g].key,v)<0;)$=$.forward[g];y[g]=$}if($=$.forward[0],$&&S($.key,v)===0)return $.value=s,!1;{const g=P.j(T);if(g>T.d){for(let a=T.d;a<g;a++)y[a]=T.e;T.d=g}$=new r(g,v,s);for(let a=0;a<g;a++)$.forward[a]=y[a].forward[a],y[a].forward[a]=$;return!0}}static j(T,v=.5){let s=1;for(;Math.random()<v&&s<T.c;)s+=1;return s}static k(T,v,s){const S=[];let y=T.e;for(let $=T.d-1;$>=0;$--){for(;y.forward[$]&&s(y.forward[$].key,v)<0;)y=y.forward[$];S[$]=y}if(y=y.forward[0],!y||s(y.key,v)!==0)return!1;for(let $=0;$<T.d&&S[$].forward[$]===y;$++)S[$].forward[$]=y.forward[$];for(;T.d>0&&T.e.forward[T.d-1]===E;)T.d-=1;return!0}}e.$2s=P}),define(Te[43],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=void 0;const t=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(P){return new r(P)}constructor(P){this.c=t&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ke=r}),define(Te[6],Oe([1,0,9,80,2,81,43]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$me=e.Event=void 0,e.$ne=g;const T=!1,v=!1,s=!1;var S;(function(Q){Q.None=()=>E.$Zc.None;function te(De){if(s){const{onDidAddListener:Ce}=De,ge=c.create();let Se=0;De.onDidAddListener=()=>{++Se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ge.print()),Ce?.()}}}function ve(De,Ce){return ne(De,()=>{},0,void 0,!0,void 0,Ce)}Q.defer=ve;function be(De){return(Ce,ge=null,Se)=>{let Pe=!1,Ue;return Ue=De(Ge=>{if(!Pe)return Ue?Ue.dispose():Pe=!0,Ce.call(ge,Ge)},null,Se),Pe&&Ue.dispose(),Ue}}Q.once=be;function le(De,Ce){return Q.once(Q.filter(De,Ce))}Q.onceIf=le;function K(De,Ce,ge){return ye((Se,Pe=null,Ue)=>De(Ge=>Se.call(Pe,Ce(Ge)),null,Ue),ge)}Q.map=K;function B(De,Ce,ge){return ye((Se,Pe=null,Ue)=>De(Ge=>{Ce(Ge),Se.call(Pe,Ge)},null,Ue),ge)}Q.forEach=B;function j(De,Ce,ge){return ye((Se,Pe=null,Ue)=>De(Ge=>Ce(Ge)&&Se.call(Pe,Ge),null,Ue),ge)}Q.filter=j;function U(De){return De}Q.signal=U;function ee(...De){return(Ce,ge=null,Se)=>{const Pe=(0,E.$Wc)(...De.map(Ue=>Ue(Ge=>Ce.call(ge,Ge))));return se(Pe,Se)}}Q.any=ee;function ae(De,Ce,ge,Se){let Pe=ge;return K(De,Ue=>(Pe=Ce(Pe,Ue),Pe),Se)}Q.reduce=ae;function ye(De,Ce){let ge;const Se={onWillAddFirstListener(){ge=De(Pe.fire,Pe)},onDidRemoveLastListener(){ge?.dispose()}};Ce||te(Se);const Pe=new n(Se);return Ce?.add(Pe),Pe.event}function se(De,Ce){return Ce instanceof Array?Ce.push(De):Ce&&Ce.add(De),De}function ne(De,Ce,ge=100,Se=!1,Pe=!1,Ue,Ge){let Qe,Ze,Xe,tt=0,lt;const ct={leakWarningThreshold:Ue,onWillAddFirstListener(){Qe=De(ut=>{tt++,Ze=Ce(Ze,ut),Se&&!Xe&&(rt.fire(Ze),Ze=void 0),lt=()=>{const st=Ze;Ze=void 0,Xe=void 0,(!Se||tt>1)&&rt.fire(st),tt=0},typeof ge=="number"?(clearTimeout(Xe),Xe=setTimeout(lt,ge)):Xe===void 0&&(Xe=0,queueMicrotask(lt))})},onWillRemoveListener(){Pe&&tt>0&&lt?.()},onDidRemoveLastListener(){lt=void 0,Qe.dispose()}};Ge||te(ct);const rt=new n(ct);return Ge?.add(rt),rt.event}Q.debounce=ne;function X(De,Ce=0,ge){return Q.debounce(De,(Se,Pe)=>Se?(Se.push(Pe),Se):[Pe],Ce,void 0,!0,void 0,ge)}Q.accumulate=X;function z(De,Ce=(Se,Pe)=>Se===Pe,ge){let Se=!0,Pe;return j(De,Ue=>{const Ge=Se||!Ce(Ue,Pe);return Se=!1,Pe=Ue,Ge},ge)}Q.latch=z;function A(De,Ce,ge){return[Q.filter(De,Ce,ge),Q.filter(De,Se=>!Ce(Se),ge)]}Q.split=A;function Y(De,Ce=!1,ge=[],Se){let Pe=ge.slice(),Ue=De(Ze=>{Pe?Pe.push(Ze):Qe.fire(Ze)});Se&&Se.add(Ue);const Ge=()=>{Pe?.forEach(Ze=>Qe.fire(Ze)),Pe=null},Qe=new n({onWillAddFirstListener(){Ue||(Ue=De(Ze=>Qe.fire(Ze)),Se&&Se.add(Ue))},onDidAddFirstListener(){Pe&&(Ce?setTimeout(Ge):Ge())},onDidRemoveLastListener(){Ue&&Ue.dispose(),Ue=null}});return Se&&Se.add(Qe),Qe.event}Q.buffer=Y;function pe(De,Ce){return(Se,Pe,Ue)=>{const Ge=Ce(new ie);return De(function(Qe){const Ze=Ge.evaluate(Qe);Ze!==x&&Se.call(Pe,Ze)},void 0,Ue)}}Q.chain=pe;const x=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(Ce){return this.f.push(Ce),this}forEach(Ce){return this.f.push(ge=>(Ce(ge),ge)),this}filter(Ce){return this.f.push(ge=>Ce(ge)?ge:x),this}reduce(Ce,ge){let Se=ge;return this.f.push(Pe=>(Se=Ce(Se,Pe),Se)),this}latch(Ce=(ge,Se)=>ge===Se){let ge=!0,Se;return this.f.push(Pe=>{const Ue=ge||!Ce(Pe,Se);return ge=!1,Se=Pe,Ue?Pe:x}),this}evaluate(Ce){for(const ge of this.f)if(Ce=ge(Ce),Ce===x)break;return Ce}}function W(De,Ce,ge=Se=>Se){const Se=(...Qe)=>Ge.fire(ge(...Qe)),Pe=()=>De.on(Ce,Se),Ue=()=>De.removeListener(Ce,Se),Ge=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:Ue});return Ge.event}Q.fromNodeEventEmitter=W;function Z(De,Ce,ge=Se=>Se){const Se=(...Qe)=>Ge.fire(ge(...Qe)),Pe=()=>De.addEventListener(Ce,Se),Ue=()=>De.removeEventListener(Ce,Se),Ge=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:Ue});return Ge.event}Q.fromDOMEventEmitter=Z;function ce(De){return new Promise(Ce=>be(De)(Ce))}Q.toPromise=ce;function we(De){const Ce=new n;return De.then(ge=>{Ce.fire(ge)},()=>{Ce.fire(void 0)}).finally(()=>{Ce.dispose()}),Ce.event}Q.fromPromise=we;function Le(De,Ce){return De(ge=>Ce.fire(ge))}Q.forward=Le;function ze(De,Ce,ge){return Ce(ge),De(Se=>Ce(Se))}Q.runAndSubscribe=ze;class qe{constructor(Ce,ge){this._observable=Ce,this.f=0,this.g=!1;const Se={onWillAddFirstListener:()=>{Ce.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{Ce.removeObserver(this)}};ge||te(Se),this.emitter=new n(Se),ge&&ge.add(this.emitter)}beginUpdate(Ce){this.f++}handlePossibleChange(Ce){}handleChange(Ce,ge){this.g=!0}endUpdate(Ce){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Re(De,Ce){return new qe(De,Ce).emitter.event}Q.fromObservable=Re;function Ne(De){return(Ce,ge,Se)=>{let Pe=0,Ue=!1;const Ge={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(De.reportChanges(),Ue&&(Ue=!1,Ce.call(ge)))},handlePossibleChange(){},handleChange(){Ue=!0}};De.addObserver(Ge),De.reportChanges();const Qe={dispose(){De.removeObserver(Ge)}};return Se instanceof E.$Yc?Se.add(Qe):Array.isArray(Se)&&Se.push(Qe),Qe}}Q.fromObservableLight=Ne})(S||(e.Event=S={}));class y{static{this.all=new Set}static{this.f=0}constructor(te){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${te}_${y.f++}`,y.all.add(this)}start(te){this.g=new D.$ke,this.listenerCount=te}stop(){if(this.g){const te=this.g.elapsed();this.durations.push(te),this.elapsedOverall+=te,this.invocationCount+=1,this.g=void 0}}}e.$me=y;let $=-1;function g(Q){const te=$;return $=Q,{dispose(){$=te}}}class a{static{this.f=1}constructor(te,ve,be=(a.f++).toString(16).padStart(3,"0")){this.j=te,this.threshold=ve,this.name=be,this.h=0}dispose(){this.g?.clear()}check(te,ve){const be=this.threshold;if(be<=0||ve<be)return;this.g||(this.g=new Map);const le=this.g.get(te.value)||0;if(this.g.set(te.value,le+1),this.h-=1,this.h<=0){this.h=be*.5;const[K,B]=this.getMostFrequentStack(),j=`[${this.name}] potential listener LEAK detected, having ${ve} listeners already. MOST frequent listener (${B}):`;console.warn(j),console.warn(K);const U=new m(j,K);this.j(U)}return()=>{const K=this.g.get(te.value)||0;this.g.set(te.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let te,ve=0;for(const[be,le]of this.g)(!te||ve<le)&&(te=[be,le],ve=le);return te}}class c{static create(){const te=new Error;return new c(te.stack??"")}constructor(te){this.value=te}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(te,ve){super(te),this.name="ListenerLeakError",this.stack=ve}}e.$oe=m;class b extends Error{constructor(te,ve){super(te),this.name="ListenerRefusalError",this.stack=ve}}e.$pe=b;let p=0;class d{constructor(te){this.value=te,this.id=p++}}const w=2,o=(Q,te)=>{if(Q instanceof d)te(Q);else for(let ve=0;ve<Q.length;ve++){const be=Q[ve];be&&te(be)}};let l;if(T){const Q=[];setInterval(()=>{Q.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(Q.join(`
`)),Q.length=0)},3e3),l=new FinalizationRegistry(te=>{typeof te=="string"&&Q.push(te)})}class n{constructor(te){this.z=0,this.f=te,this.g=$>0||this.f?.leakWarningThreshold?new a(te?.onListenerError??t.$4,this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(v){const te=this.u;queueMicrotask(()=>{o(te,ve=>ve.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(te,ve,be)=>{if(this.g&&this.z>this.g.threshold**2){const U=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(U);const ee=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ae=new b(`${U}. HINT: Stack shows most frequent listener (${ee[1]}-times)`,ee[0]);return(this.f?.onListenerError||t.$4)(ae),E.$Zc.None}if(this.m)return E.$Zc.None;ve&&(te=te.bind(ve));const le=new d(te);let K,B;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(le.stack=c.create(),K=this.g.check(le.stack,this.z+1)),v&&(le.stack=B??c.create()),this.u?this.u instanceof d?(this.w??=new i,this.u=[this.u,le]):this.u.push(le):(this.f?.onWillAddFirstListener?.(this),this.u=le,this.f?.onDidAddFirstListener?.(this)),this.z++;const j=(0,E.$Xc)(()=>{l?.unregister(j),K?.(),this.A(le)});if(be instanceof E.$Yc?be.add(j):Array.isArray(be)&&be.push(j),l){const U=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ee=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(U);l.register(j,ee?.[2]??U,j)}return j},this.q}A(te){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const ve=this.u,be=ve.indexOf(te);if(be===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,ve[be]=void 0;const le=this.w.current===this;if(this.z*w<=ve.length){let K=0;for(let B=0;B<ve.length;B++)ve[B]?ve[K++]=ve[B]:le&&(this.w.end--,K<this.w.i&&this.w.i--);ve.length=K}}B(te,ve){if(!te)return;const be=this.f?.onListenerError||t.$4;if(!be){te.value(ve);return}try{te.value(ve)}catch(le){be(le)}}C(te){const ve=te.current.u;for(;te.i<te.end;)this.B(ve[te.i++],te.value);te.reset()}fire(te){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof d)this.B(this.u,te);else{const ve=this.w;ve.enqueue(this,te,this.u.length),this.C(ve)}this.j?.stop()}hasListeners(){return this.z>0}}e.$qe=n;const u=()=>new i;e.$re=u;class i{constructor(){this.i=-1,this.end=0}enqueue(te,ve,be){this.i=0,this.end=be,this.current=te,this.value=ve}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class f extends n{async fireAsync(te,ve,be){if(this.u)for(this.h||(this.h=new P.$0c),o(this.u,le=>this.h.push([le.value,te]));this.h.size>0&&!ve.isCancellationRequested;){const[le,K]=this.h.shift(),B=[],j={...K,token:ve,waitUntil:U=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");be&&(U=be(U,le)),B.push(U)}};try{le(j)}catch(U){(0,t.$4)(U);continue}Object.freeze(B),await Promise.allSettled(B).then(U=>{for(const ee of U)ee.status==="rejected"&&(0,t.$4)(ee.reason)})}}}e.$se=f;class h extends n{get isPaused(){return this.h!==0}constructor(te){super(te),this.h=0,this.s=new P.$0c,this.t=te?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const te=Array.from(this.s);this.s.clear(),super.fire(this.t(te))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(te){this.z&&(this.h!==0?this.s.push(te):super.fire(te))}}e.$te=h;class k extends h{constructor(te){super(te),this.k=te.delay??100}fire(te){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(te)}}e.$ue=k;class I extends n{constructor(te){super(te),this.h=[],this.k=te?.merge}fire(te){this.hasListeners()&&(this.h.push(te),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ve=>super.fire(ve)),this.h=[]}))}}e.$ve=I;class O{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(te){const ve={event:te,listener:null};this.h.push(ve),this.g&&this.m(ve);const be=()=>{this.g&&this.o(ve);const le=this.h.indexOf(ve);this.h.splice(le,1)};return(0,E.$Xc)((0,r.$hb)(be))}j(){this.g=!0,this.h.forEach(te=>this.m(te))}k(){this.g=!1,this.h.forEach(te=>this.o(te))}m(te){te.listener=te.event(ve=>this.f.fire(ve))}o(te){te.listener?.dispose(),te.listener=null}dispose(){this.f.dispose();for(const te of this.h)te.listener?.dispose();this.h=[]}}e.$we=O;class C{constructor(te,ve,be,le){this.f=new E.$Yc;const K=this.f.add(new O),B=this.f.add(new E.$9c);function j(U){B.set(U,K.add(le(U)))}for(const U of te)j(U);this.f.add(ve(U=>{j(U)})),this.f.add(be(U=>{B.deleteAndDispose(U)})),this.event=K.event}dispose(){this.f.dispose()}}e.$xe=C;class L{constructor(){this.f=[]}wrapEvent(te,ve,be){return(le,K,B)=>te(j=>{const U=this.f[this.f.length-1];if(!ve){U?U.buffers.push(()=>le.call(K,j)):le.call(K,j);return}const ee=U;if(!ee){le.call(K,ve(be,j));return}ee.items??=[],ee.items.push(j),ee.buffers.length===0&&U.buffers.push(()=>{ee.reducedResult??=be?ee.items.reduce(ve,be):ee.items.reduce(ve),le.call(K,ee.reducedResult)})},void 0,B)}bufferEvents(te){const ve={buffers:new Array};this.f.push(ve);const be=te();return this.f.pop(),ve.buffers.forEach(le=>le()),be}}e.$ye=L;class R{constructor(){this.f=!1,this.g=S.None,this.h=E.$Zc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(te){this.g=te,this.f&&(this.h.dispose(),this.h=te(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ze=R;class M{static const(te){return new G(te)}constructor(te){this.g=te,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(te){te!==this.g&&(this.g=te,this.f.fire(void 0))}}e.$Ae=M;class G{constructor(te){this.value=te,this.onDidChange=S.None}}}),define(Te[18],Oe([1,0,6]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.CancellationToken=void 0,e.$Ce=T;const r=Object.freeze(function(v,s){const S=setTimeout(v.bind(s),0);return{dispose(){clearTimeout(S)}}});var E;(function(v){function s(S){return S===v.None||S===v.Cancelled||S instanceof P?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}v.isCancellationToken=s,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:t.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(E||(e.CancellationToken=E={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new t.$qe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(s){this.f=void 0,this.g=void 0,this.g=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=E.Cancelled}dispose(s=!1){s&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=E.None}}e.$Be=D;function T(v){const s=new D;return v.add({dispose(){s.cancel()}}),s.token}}),define(Te[172],Oe([1,0,18]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ef=e.$df=e.$bf=void 0,e.$cf=E;class r{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new t.$Be,s=this.b(v.token);return this.a={promise:s,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}e.$bf=r;function E(T){return T}class P{constructor(v,s){this.a=void 0,this.b=void 0,typeof v=="function"?(this.c=v,this.d=E):(this.c=s,this.d=v.getCacheKey)}get(v){const s=this.d(v);return this.b!==s&&(this.b=s,this.a=this.c(v)),this.a}}e.$df=P;class D{get cachedValues(){return this.a}constructor(v,s){this.a=new Map,this.b=new Map,typeof v=="function"?(this.c=v,this.d=E):(this.c=s,this.d=v.getCacheKey)}get(v){const s=this.d(v);if(this.b.has(s))return this.b.get(s);const S=this.c(v);return this.a.set(v,S),this.b.set(s,S),S}}e.$ef=D}),define(Te[173],Oe([1,0,6,2]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.$nt=e.$mt=e.$lt=e.ScrollbarVisibility=void 0;var E;(function(g){g[g.Auto=1]="Auto",g[g.Hidden=2]="Hidden",g[g.Visible=3]="Visible"})(E||(e.ScrollbarVisibility=E={}));class P{constructor(a,c,m,b,p,d,w){this.c=a,this._scrollStateBrand=void 0,this.c&&(c=c|0,m=m|0,b=b|0,p=p|0,d=d|0,w=w|0),this.rawScrollLeft=b,this.rawScrollTop=w,c<0&&(c=0),b+c>m&&(b=m-c),b<0&&(b=0),p<0&&(p=0),w+p>d&&(w=d-p),w<0&&(w=0),this.width=c,this.scrollWidth=m,this.scrollLeft=b,this.height=p,this.scrollHeight=d,this.scrollTop=w}equals(a){return this.rawScrollLeft===a.rawScrollLeft&&this.rawScrollTop===a.rawScrollTop&&this.width===a.width&&this.scrollWidth===a.scrollWidth&&this.scrollLeft===a.scrollLeft&&this.height===a.height&&this.scrollHeight===a.scrollHeight&&this.scrollTop===a.scrollTop}withScrollDimensions(a,c){return new P(this.c,typeof a.width<"u"?a.width:this.width,typeof a.scrollWidth<"u"?a.scrollWidth:this.scrollWidth,c?this.rawScrollLeft:this.scrollLeft,typeof a.height<"u"?a.height:this.height,typeof a.scrollHeight<"u"?a.scrollHeight:this.scrollHeight,c?this.rawScrollTop:this.scrollTop)}withScrollPosition(a){return new P(this.c,this.width,this.scrollWidth,typeof a.scrollLeft<"u"?a.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof a.scrollTop<"u"?a.scrollTop:this.rawScrollTop)}createScrollEvent(a,c){const m=this.width!==a.width,b=this.scrollWidth!==a.scrollWidth,p=this.scrollLeft!==a.scrollLeft,d=this.height!==a.height,w=this.scrollHeight!==a.scrollHeight,o=this.scrollTop!==a.scrollTop;return{inSmoothScrolling:c,oldWidth:a.width,oldScrollWidth:a.scrollWidth,oldScrollLeft:a.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:a.height,oldScrollHeight:a.scrollHeight,oldScrollTop:a.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:b,scrollLeftChanged:p,heightChanged:d,scrollHeightChanged:w,scrollTopChanged:o}}}e.$lt=P;class D extends r.$Zc{constructor(a){super(),this._scrollableBrand=void 0,this.j=this.B(new t.$qe),this.onScroll=this.j.event,this.c=a.smoothScrollDuration,this.f=a.scheduleAtNextAnimationFrame,this.g=new P(a.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(a){this.c=a}validateScrollPosition(a){return this.g.withScrollPosition(a)}getScrollDimensions(){return this.g}setScrollDimensions(a,c){const m=this.g.withScrollDimensions(a,c);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(a){const c=this.g.withScrollPosition(a);this.h&&(this.h.dispose(),this.h=null),this.n(c,!1)}setScrollPositionSmooth(a,c){if(this.c===0)return this.setScrollPositionNow(a);if(this.h){a={scrollLeft:typeof a.scrollLeft>"u"?this.h.to.scrollLeft:a.scrollLeft,scrollTop:typeof a.scrollTop>"u"?this.h.to.scrollTop:a.scrollTop};const m=this.g.withScrollPosition(a);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let b;c?b=new S(this.h.from,m,this.h.startTime,this.h.duration):b=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=b}else{const m=this.g.withScrollPosition(a);this.h=S.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const a=this.h.tick(),c=this.g.withScrollPosition(a);if(this.n(c,!0),!!this.h){if(a.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(a,c){const m=this.g;m.equals(a)||(this.g=a,this.j.fire(this.g.createScrollEvent(m,c)))}}e.$mt=D;class T{constructor(a,c,m){this.scrollLeft=a,this.scrollTop=c,this.isDone=m}}e.$nt=T;function v(g,a){const c=a-g;return function(m){return g+c*$(m)}}function s(g,a,c){return function(m){return m<c?g(m/c):a((m-c)/(1-c))}}class S{constructor(a,c,m,b){this.from=a,this.to=c,this.duration=b,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(a,c,m){if(Math.abs(a-c)>2.5*m){let p,d;return a<c?(p=a+.75*m,d=c-.75*m):(p=a-.75*m,d=c+.75*m),s(v(a,p),v(d,c),.33)}return v(a,c)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(a){this.to=a.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(a){const c=(a-this.startTime)/this.duration;if(c<1){const m=this.c(c),b=this.d(c);return new T(m,b,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(a,c,m){return S.start(a,c,m)}static start(a,c,m){m=m+10;const b=Date.now()-10;return new S(a,c,b,m)}}e.$ot=S;function y(g){return Math.pow(g,3)}function $(g){return 1-y(1-g)}}),define(Te[56],Oe([1,0,9,2]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=E,e.$Ee=P,e.$Fe=D,e.$Ge=T,e.$He=s,e.$Ie=S,e.$Je=y,e.$Ke=$,e.$Le=g,e.$Me=a,e.$Ne=c,e.$Oe=m,e.$Pe=b,e.$Qe=p,e.$Re=d;function E(w){const o=w;return o?typeof o.read=="function":!1}function P(w){const o=w;return o?[o.on,o.pause,o.resume,o.destroy].every(l=>typeof l=="function"):!1}function D(w){const o=w;return o?P(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function T(w,o){return new v(w,o)}class v{constructor(o,l){this.e=o,this.f=l,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(l=>this.d.push(l))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(l=>l(o))}h(o){this.c.error.length===0?(0,t.$4)(o):this.c.error.slice(0).forEach(l=>l(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,l){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(l),this.resume();break;case"end":this.c.end.push(l),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(l),this.a.flowing&&this.k();break}}removeListener(o,l){if(this.a.destroyed)return;let n;switch(o){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const u=n.indexOf(l);u>=0&&n.splice(u,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const l=[...this.d];this.d.length=0,l.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(w,o){const l=[];let n;for(;(n=w.read())!==null;)l.push(n);return o(l)}function S(w,o,l){const n=[];let u;for(;(u=w.read())!==null&&n.length<l;)n.push(u);return u===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof u<"u"){const i=u;return u=void 0,i}return w.read()}}}function y(w,o){return new Promise((l,n)=>{const u=[];$(w,{onData:i=>{o&&u.push(i)},onError:i=>{o?n(i):l(void 0)},onEnd:()=>{l(o?o(u):void 0)}})})}function $(w,o,l){w.on("error",n=>{l?.isCancellationRequested||o.onError(n)}),w.on("end",()=>{l?.isCancellationRequested||o.onEnd()}),w.on("data",n=>{l?.isCancellationRequested||o.onData(n)})}function g(w,o){return new Promise((l,n)=>{const u=new r.$Yc,i=[],f=I=>{if(i.push(I),i.length>o)return u.dispose(),w.pause(),l({stream:w,buffer:i,ended:!1})},h=I=>(u.dispose(),n(I)),k=()=>(u.dispose(),l({stream:w,buffer:i,ended:!0}));u.add((0,r.$Xc)(()=>w.removeListener("error",h))),w.on("error",h),u.add((0,r.$Xc)(()=>w.removeListener("end",k))),w.on("end",k),u.add((0,r.$Xc)(()=>w.removeListener("data",f))),w.on("data",f)})}function a(w,o){const l=T(o);return l.end(w),l}function c(){const w=T(()=>{throw new Error("not supported")});return w.end(),w}function m(w){let o=!1;return{read:()=>o?null:(o=!0,w)}}function b(w,o,l){const n=T(l);return $(w,{onData:u=>n.write(o.data(u)),onError:u=>n.error(o.error?o.error(u):u),onEnd:()=>n.end()}),n}function p(w,o,l){let n=!1;return{read:()=>{const u=o.read();return n?u:(n=!0,u!==null?l([w,u]):w)}}}function d(w,o,l){let n=!1;const u=T(l);return $(o,{onData:i=>n?u.write(i):(n=!0,u.write(l([w,i]))),onError:i=>u.error(i),onEnd:()=>{n||(n=!0,u.write(w)),u.end()}}),u}}),define(Te[14],Oe([1,0,65,56]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=void 0,e.$Te=s,e.$Ue=S,e.$Ve=y,e.$We=$,e.$Xe=g,e.$Ye=a,e.$Ze=c,e.$1e=m,e.$2e=b,e.$3e=p,e.$4e=d,e.$5e=w,e.$6e=o,e.$7e=l,e.$8e=n,e.$9e=u,e.$0e=i,e.$$e=f,e.$_e=h,e.$af=O,r=Ve(r);const E=typeof Buffer<"u",P=new t.$Y(()=>new Uint8Array(256));let D,T;class v{static alloc(L){return E?new v(Buffer.allocUnsafe(L)):new v(new Uint8Array(L))}static wrap(L){return E&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new v(L)}static fromString(L,R){return!(R?.dontUseNodeBuffer||!1)&&E?new v(Buffer.from(L)):(D||(D=new TextEncoder),new v(D.encode(L)))}static fromByteArray(L){const R=v.alloc(L.length);for(let M=0,G=L.length;M<G;M++)R.buffer[M]=L[M];return R}static concat(L,R){if(typeof R>"u"){R=0;for(let Q=0,te=L.length;Q<te;Q++)R+=L[Q].byteLength}const M=v.alloc(R);let G=0;for(let Q=0,te=L.length;Q<te;Q++){const ve=L[Q];M.set(ve,G),G+=ve.byteLength}return M}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=v.alloc(this.byteLength);return L.set(this),L}toString(){return E?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(L,R){return new v(this.buffer.subarray(L,R))}set(L,R){if(L instanceof v)this.buffer.set(L.buffer,R);else if(L instanceof Uint8Array)this.buffer.set(L,R);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),R);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return $(this.buffer,L)}writeUInt32BE(L,R){g(this.buffer,L,R)}readUInt32LE(L){return a(this.buffer,L)}writeUInt32LE(L,R){c(this.buffer,L,R)}readUInt8(L){return m(this.buffer,L)}writeUInt8(L,R){b(this.buffer,L,R)}indexOf(L,R=0){return s(this.buffer,L instanceof v?L.buffer:L,R)}}e.$Se=v;function s(C,L,R=0){const M=L.byteLength,G=C.byteLength;if(M===0)return 0;if(M===1)return C.indexOf(L[0]);if(M>G-R)return-1;const Q=P.value;Q.fill(L.length);for(let le=0;le<L.length;le++)Q[L[le]]=L.length-le-1;let te=R+L.length-1,ve=te,be=-1;for(;te<G;)if(C[te]===L[ve]){if(ve===0){be=te;break}te--,ve--}else te+=Math.max(L.length-ve,Q[C[te]]),ve=L.length-1;return be}function S(C,L){return C[L+0]<<0>>>0|C[L+1]<<8>>>0}function y(C,L,R){C[R+0]=L&255,L=L>>>8,C[R+1]=L&255}function $(C,L){return C[L]*2**24+C[L+1]*2**16+C[L+2]*2**8+C[L+3]}function g(C,L,R){C[R+3]=L,L=L>>>8,C[R+2]=L,L=L>>>8,C[R+1]=L,L=L>>>8,C[R]=L}function a(C,L){return C[L+0]<<0>>>0|C[L+1]<<8>>>0|C[L+2]<<16>>>0|C[L+3]<<24>>>0}function c(C,L,R){C[R+0]=L&255,L=L>>>8,C[R+1]=L&255,L=L>>>8,C[R+2]=L&255,L=L>>>8,C[R+3]=L&255}function m(C,L){return C[L]}function b(C,L,R){C[R]=L}function p(C){return r.$He(C,L=>v.concat(L))}function d(C){return r.$Oe(C)}function w(C){return r.$Je(C,L=>v.concat(L))}async function o(C){return C.ended?v.concat(C.buffer):v.concat([...C.buffer,await w(C.stream)])}function l(C){return r.$Me(C,L=>v.concat(L))}function n(C){return r.$Pe(C,{data:L=>typeof L=="string"?v.fromString(L):v.wrap(L)},L=>v.concat(L))}function u(C){return r.$Ge(L=>v.concat(L),C)}function i(C,L){return r.$Qe(C,L,R=>v.concat(R))}function f(C,L){return r.$Re(C,L,R=>v.concat(R))}function h(C){let L=0,R=0,M=0;const G=new Uint8Array(Math.floor(C.length/4*3)),Q=ve=>{switch(R){case 3:G[M++]=L|ve,R=0;break;case 2:G[M++]=L|ve>>>2,L=ve<<6,R=3;break;case 1:G[M++]=L|ve>>>4,L=ve<<4,R=2;break;default:L=ve<<2,R=1}};for(let ve=0;ve<C.length;ve++){const be=C.charCodeAt(ve);if(be>=65&&be<=90)Q(be-65);else if(be>=97&&be<=122)Q(be-97+26);else if(be>=48&&be<=57)Q(be-48+52);else if(be===43||be===45)Q(62);else if(be===47||be===95)Q(63);else{if(be===61)break;throw new SyntaxError(`Unexpected base64 character ${C[ve]}`)}}const te=M;for(;R>0;)Q(0);return v.wrap(G).slice(0,te)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:C},L=!0,R=!1){const M=R?I:k;let G="";const Q=C.byteLength%3;let te=0;for(;te<C.byteLength-Q;te+=3){const ve=C[te+0],be=C[te+1],le=C[te+2];G+=M[ve>>>2],G+=M[(ve<<4|be>>>4)&63],G+=M[(be<<2|le>>>6)&63],G+=M[le&63]}if(Q===1){const ve=C[te+0];G+=M[ve>>>2],G+=M[ve<<4&63],L&&(G+="==")}else if(Q===2){const ve=C[te+0],be=C[te+1];G+=M[ve>>>2],G+=M[(ve<<4|be>>>4)&63],G+=M[be<<2&63],L&&(G+="=")}return G}}),define(Te[174],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=void 0,e.$le=Symbol("MicrotaskDelay")}),define(Te[10],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=t,e.$kg=r,e.$lg=E,e.$mg=P,e.$ng=D,e.$og=T,e.$pg=v,e.$qg=s,e.$rg=S,e.$sg=y,e.$tg=$,e.$ug=g,e.$vg=a,e.$wg=m,e.$xg=b,e.$yg=p,e.$zg=d,e.$Ag=w,e.$Bg=o;function t(l){return typeof l=="string"}function r(l){return Array.isArray(l)&&l.every(n=>t(n))}function E(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function P(l){const n=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof n}function D(l){return typeof l=="number"&&!isNaN(l)}function T(l){return!!l&&typeof l[Symbol.iterator]=="function"}function v(l){return l===!0||l===!1}function s(l){return typeof l>"u"}function S(l){return!y(l)}function y(l){return s(l)||l===null}function $(l,n){if(!l)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function g(l){if(y(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function a(...l){const n=[];for(let u=0;u<l.length;u++){const i=l[u];if(y(i))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);n.push(i)}return n}const c=Object.prototype.hasOwnProperty;function m(l){if(!E(l))return!1;for(const n in l)if(c.call(l,n))return!1;return!0}function b(l){return typeof l=="function"}function p(...l){return l.length>0&&l.every(b)}function d(l,n){const u=Math.min(l.length,n.length);for(let i=0;i<u;i++)w(l[i],n[i])}function w(l,n){if(t(n)){if(typeof l!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(b(n)){try{if(l instanceof n)return}catch{}if(!y(l)&&l.constructor===n||n.length===1&&n.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function o(l){return l}}),define(Te[107],Oe([1,0,10]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=E,e.$6j=P;const r=Object.create(null);function E(D,T){if((0,t.$jg)(T)){const v=r[T];if(v===void 0)throw new Error(`${D} references an unknown codicon: ${T}`);T=v}return r[D]=T,{id:D}}function P(){return r}}),define(Te[175],Oe([1,0,107]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=void 0,e.$7j={add:(0,t.$5j)("add",6e4),plus:(0,t.$5j)("plus",6e4),gistNew:(0,t.$5j)("gist-new",6e4),repoCreate:(0,t.$5j)("repo-create",6e4),lightbulb:(0,t.$5j)("lightbulb",60001),lightBulb:(0,t.$5j)("light-bulb",60001),repo:(0,t.$5j)("repo",60002),repoDelete:(0,t.$5j)("repo-delete",60002),gistFork:(0,t.$5j)("gist-fork",60003),repoForked:(0,t.$5j)("repo-forked",60003),gitPullRequest:(0,t.$5j)("git-pull-request",60004),gitPullRequestAbandoned:(0,t.$5j)("git-pull-request-abandoned",60004),recordKeys:(0,t.$5j)("record-keys",60005),keyboard:(0,t.$5j)("keyboard",60005),tag:(0,t.$5j)("tag",60006),gitPullRequestLabel:(0,t.$5j)("git-pull-request-label",60006),tagAdd:(0,t.$5j)("tag-add",60006),tagRemove:(0,t.$5j)("tag-remove",60006),person:(0,t.$5j)("person",60007),personFollow:(0,t.$5j)("person-follow",60007),personOutline:(0,t.$5j)("person-outline",60007),personFilled:(0,t.$5j)("person-filled",60007),gitBranch:(0,t.$5j)("git-branch",60008),gitBranchCreate:(0,t.$5j)("git-branch-create",60008),gitBranchDelete:(0,t.$5j)("git-branch-delete",60008),sourceControl:(0,t.$5j)("source-control",60008),mirror:(0,t.$5j)("mirror",60009),mirrorPublic:(0,t.$5j)("mirror-public",60009),star:(0,t.$5j)("star",60010),starAdd:(0,t.$5j)("star-add",60010),starDelete:(0,t.$5j)("star-delete",60010),starEmpty:(0,t.$5j)("star-empty",60010),comment:(0,t.$5j)("comment",60011),commentAdd:(0,t.$5j)("comment-add",60011),alert:(0,t.$5j)("alert",60012),warning:(0,t.$5j)("warning",60012),search:(0,t.$5j)("search",60013),searchSave:(0,t.$5j)("search-save",60013),logOut:(0,t.$5j)("log-out",60014),signOut:(0,t.$5j)("sign-out",60014),logIn:(0,t.$5j)("log-in",60015),signIn:(0,t.$5j)("sign-in",60015),eye:(0,t.$5j)("eye",60016),eyeUnwatch:(0,t.$5j)("eye-unwatch",60016),eyeWatch:(0,t.$5j)("eye-watch",60016),circleFilled:(0,t.$5j)("circle-filled",60017),primitiveDot:(0,t.$5j)("primitive-dot",60017),closeDirty:(0,t.$5j)("close-dirty",60017),debugBreakpoint:(0,t.$5j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,t.$5j)("debug-breakpoint-disabled",60017),debugHint:(0,t.$5j)("debug-hint",60017),terminalDecorationSuccess:(0,t.$5j)("terminal-decoration-success",60017),primitiveSquare:(0,t.$5j)("primitive-square",60018),edit:(0,t.$5j)("edit",60019),pencil:(0,t.$5j)("pencil",60019),info:(0,t.$5j)("info",60020),issueOpened:(0,t.$5j)("issue-opened",60020),gistPrivate:(0,t.$5j)("gist-private",60021),gitForkPrivate:(0,t.$5j)("git-fork-private",60021),lock:(0,t.$5j)("lock",60021),mirrorPrivate:(0,t.$5j)("mirror-private",60021),close:(0,t.$5j)("close",60022),removeClose:(0,t.$5j)("remove-close",60022),x:(0,t.$5j)("x",60022),repoSync:(0,t.$5j)("repo-sync",60023),sync:(0,t.$5j)("sync",60023),clone:(0,t.$5j)("clone",60024),desktopDownload:(0,t.$5j)("desktop-download",60024),beaker:(0,t.$5j)("beaker",60025),microscope:(0,t.$5j)("microscope",60025),vm:(0,t.$5j)("vm",60026),deviceDesktop:(0,t.$5j)("device-desktop",60026),file:(0,t.$5j)("file",60027),fileText:(0,t.$5j)("file-text",60027),more:(0,t.$5j)("more",60028),ellipsis:(0,t.$5j)("ellipsis",60028),kebabHorizontal:(0,t.$5j)("kebab-horizontal",60028),mailReply:(0,t.$5j)("mail-reply",60029),reply:(0,t.$5j)("reply",60029),organization:(0,t.$5j)("organization",60030),organizationFilled:(0,t.$5j)("organization-filled",60030),organizationOutline:(0,t.$5j)("organization-outline",60030),newFile:(0,t.$5j)("new-file",60031),fileAdd:(0,t.$5j)("file-add",60031),newFolder:(0,t.$5j)("new-folder",60032),fileDirectoryCreate:(0,t.$5j)("file-directory-create",60032),trash:(0,t.$5j)("trash",60033),trashcan:(0,t.$5j)("trashcan",60033),history:(0,t.$5j)("history",60034),clock:(0,t.$5j)("clock",60034),folder:(0,t.$5j)("folder",60035),fileDirectory:(0,t.$5j)("file-directory",60035),symbolFolder:(0,t.$5j)("symbol-folder",60035),logoGithub:(0,t.$5j)("logo-github",60036),markGithub:(0,t.$5j)("mark-github",60036),github:(0,t.$5j)("github",60036),terminal:(0,t.$5j)("terminal",60037),console:(0,t.$5j)("console",60037),repl:(0,t.$5j)("repl",60037),zap:(0,t.$5j)("zap",60038),symbolEvent:(0,t.$5j)("symbol-event",60038),error:(0,t.$5j)("error",60039),stop:(0,t.$5j)("stop",60039),variable:(0,t.$5j)("variable",60040),symbolVariable:(0,t.$5j)("symbol-variable",60040),array:(0,t.$5j)("array",60042),symbolArray:(0,t.$5j)("symbol-array",60042),symbolModule:(0,t.$5j)("symbol-module",60043),symbolPackage:(0,t.$5j)("symbol-package",60043),symbolNamespace:(0,t.$5j)("symbol-namespace",60043),symbolObject:(0,t.$5j)("symbol-object",60043),symbolMethod:(0,t.$5j)("symbol-method",60044),symbolFunction:(0,t.$5j)("symbol-function",60044),symbolConstructor:(0,t.$5j)("symbol-constructor",60044),symbolBoolean:(0,t.$5j)("symbol-boolean",60047),symbolNull:(0,t.$5j)("symbol-null",60047),symbolNumeric:(0,t.$5j)("symbol-numeric",60048),symbolNumber:(0,t.$5j)("symbol-number",60048),symbolStructure:(0,t.$5j)("symbol-structure",60049),symbolStruct:(0,t.$5j)("symbol-struct",60049),symbolParameter:(0,t.$5j)("symbol-parameter",60050),symbolTypeParameter:(0,t.$5j)("symbol-type-parameter",60050),symbolKey:(0,t.$5j)("symbol-key",60051),symbolText:(0,t.$5j)("symbol-text",60051),symbolReference:(0,t.$5j)("symbol-reference",60052),goToFile:(0,t.$5j)("go-to-file",60052),symbolEnum:(0,t.$5j)("symbol-enum",60053),symbolValue:(0,t.$5j)("symbol-value",60053),symbolRuler:(0,t.$5j)("symbol-ruler",60054),symbolUnit:(0,t.$5j)("symbol-unit",60054),activateBreakpoints:(0,t.$5j)("activate-breakpoints",60055),archive:(0,t.$5j)("archive",60056),arrowBoth:(0,t.$5j)("arrow-both",60057),arrowDown:(0,t.$5j)("arrow-down",60058),arrowLeft:(0,t.$5j)("arrow-left",60059),arrowRight:(0,t.$5j)("arrow-right",60060),arrowSmallDown:(0,t.$5j)("arrow-small-down",60061),arrowSmallLeft:(0,t.$5j)("arrow-small-left",60062),arrowSmallRight:(0,t.$5j)("arrow-small-right",60063),arrowSmallUp:(0,t.$5j)("arrow-small-up",60064),arrowUp:(0,t.$5j)("arrow-up",60065),bell:(0,t.$5j)("bell",60066),bold:(0,t.$5j)("bold",60067),book:(0,t.$5j)("book",60068),bookmark:(0,t.$5j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,t.$5j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,t.$5j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,t.$5j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,t.$5j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,t.$5j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,t.$5j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,t.$5j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,t.$5j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,t.$5j)("debug-breakpoint-log-disabled",60075),briefcase:(0,t.$5j)("briefcase",60076),broadcast:(0,t.$5j)("broadcast",60077),browser:(0,t.$5j)("browser",60078),bug:(0,t.$5j)("bug",60079),calendar:(0,t.$5j)("calendar",60080),caseSensitive:(0,t.$5j)("case-sensitive",60081),check:(0,t.$5j)("check",60082),checklist:(0,t.$5j)("checklist",60083),chevronDown:(0,t.$5j)("chevron-down",60084),chevronLeft:(0,t.$5j)("chevron-left",60085),chevronRight:(0,t.$5j)("chevron-right",60086),chevronUp:(0,t.$5j)("chevron-up",60087),chromeClose:(0,t.$5j)("chrome-close",60088),chromeMaximize:(0,t.$5j)("chrome-maximize",60089),chromeMinimize:(0,t.$5j)("chrome-minimize",60090),chromeRestore:(0,t.$5j)("chrome-restore",60091),circleOutline:(0,t.$5j)("circle-outline",60092),circle:(0,t.$5j)("circle",60092),debugBreakpointUnverified:(0,t.$5j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,t.$5j)("terminal-decoration-incomplete",60092),circleSlash:(0,t.$5j)("circle-slash",60093),circuitBoard:(0,t.$5j)("circuit-board",60094),clearAll:(0,t.$5j)("clear-all",60095),clippy:(0,t.$5j)("clippy",60096),closeAll:(0,t.$5j)("close-all",60097),cloudDownload:(0,t.$5j)("cloud-download",60098),cloudUpload:(0,t.$5j)("cloud-upload",60099),code:(0,t.$5j)("code",60100),collapseAll:(0,t.$5j)("collapse-all",60101),colorMode:(0,t.$5j)("color-mode",60102),commentDiscussion:(0,t.$5j)("comment-discussion",60103),creditCard:(0,t.$5j)("credit-card",60105),dash:(0,t.$5j)("dash",60108),dashboard:(0,t.$5j)("dashboard",60109),database:(0,t.$5j)("database",60110),debugContinue:(0,t.$5j)("debug-continue",60111),debugDisconnect:(0,t.$5j)("debug-disconnect",60112),debugPause:(0,t.$5j)("debug-pause",60113),debugRestart:(0,t.$5j)("debug-restart",60114),debugStart:(0,t.$5j)("debug-start",60115),debugStepInto:(0,t.$5j)("debug-step-into",60116),debugStepOut:(0,t.$5j)("debug-step-out",60117),debugStepOver:(0,t.$5j)("debug-step-over",60118),debugStop:(0,t.$5j)("debug-stop",60119),debug:(0,t.$5j)("debug",60120),deviceCameraVideo:(0,t.$5j)("device-camera-video",60121),deviceCamera:(0,t.$5j)("device-camera",60122),deviceMobile:(0,t.$5j)("device-mobile",60123),diffAdded:(0,t.$5j)("diff-added",60124),diffIgnored:(0,t.$5j)("diff-ignored",60125),diffModified:(0,t.$5j)("diff-modified",60126),diffRemoved:(0,t.$5j)("diff-removed",60127),diffRenamed:(0,t.$5j)("diff-renamed",60128),diff:(0,t.$5j)("diff",60129),diffSidebyside:(0,t.$5j)("diff-sidebyside",60129),discard:(0,t.$5j)("discard",60130),editorLayout:(0,t.$5j)("editor-layout",60131),emptyWindow:(0,t.$5j)("empty-window",60132),exclude:(0,t.$5j)("exclude",60133),extensions:(0,t.$5j)("extensions",60134),eyeClosed:(0,t.$5j)("eye-closed",60135),fileBinary:(0,t.$5j)("file-binary",60136),fileCode:(0,t.$5j)("file-code",60137),fileMedia:(0,t.$5j)("file-media",60138),filePdf:(0,t.$5j)("file-pdf",60139),fileSubmodule:(0,t.$5j)("file-submodule",60140),fileSymlinkDirectory:(0,t.$5j)("file-symlink-directory",60141),fileSymlinkFile:(0,t.$5j)("file-symlink-file",60142),fileZip:(0,t.$5j)("file-zip",60143),files:(0,t.$5j)("files",60144),filter:(0,t.$5j)("filter",60145),flame:(0,t.$5j)("flame",60146),foldDown:(0,t.$5j)("fold-down",60147),foldUp:(0,t.$5j)("fold-up",60148),fold:(0,t.$5j)("fold",60149),folderActive:(0,t.$5j)("folder-active",60150),folderOpened:(0,t.$5j)("folder-opened",60151),gear:(0,t.$5j)("gear",60152),gift:(0,t.$5j)("gift",60153),gistSecret:(0,t.$5j)("gist-secret",60154),gist:(0,t.$5j)("gist",60155),gitCommit:(0,t.$5j)("git-commit",60156),gitCompare:(0,t.$5j)("git-compare",60157),compareChanges:(0,t.$5j)("compare-changes",60157),gitMerge:(0,t.$5j)("git-merge",60158),githubAction:(0,t.$5j)("github-action",60159),githubAlt:(0,t.$5j)("github-alt",60160),globe:(0,t.$5j)("globe",60161),grabber:(0,t.$5j)("grabber",60162),graph:(0,t.$5j)("graph",60163),gripper:(0,t.$5j)("gripper",60164),heart:(0,t.$5j)("heart",60165),home:(0,t.$5j)("home",60166),horizontalRule:(0,t.$5j)("horizontal-rule",60167),hubot:(0,t.$5j)("hubot",60168),inbox:(0,t.$5j)("inbox",60169),issueReopened:(0,t.$5j)("issue-reopened",60171),issues:(0,t.$5j)("issues",60172),italic:(0,t.$5j)("italic",60173),jersey:(0,t.$5j)("jersey",60174),json:(0,t.$5j)("json",60175),kebabVertical:(0,t.$5j)("kebab-vertical",60176),key:(0,t.$5j)("key",60177),law:(0,t.$5j)("law",60178),lightbulbAutofix:(0,t.$5j)("lightbulb-autofix",60179),linkExternal:(0,t.$5j)("link-external",60180),link:(0,t.$5j)("link",60181),listOrdered:(0,t.$5j)("list-ordered",60182),listUnordered:(0,t.$5j)("list-unordered",60183),liveShare:(0,t.$5j)("live-share",60184),loading:(0,t.$5j)("loading",60185),location:(0,t.$5j)("location",60186),mailRead:(0,t.$5j)("mail-read",60187),mail:(0,t.$5j)("mail",60188),markdown:(0,t.$5j)("markdown",60189),megaphone:(0,t.$5j)("megaphone",60190),mention:(0,t.$5j)("mention",60191),milestone:(0,t.$5j)("milestone",60192),gitPullRequestMilestone:(0,t.$5j)("git-pull-request-milestone",60192),mortarBoard:(0,t.$5j)("mortar-board",60193),move:(0,t.$5j)("move",60194),multipleWindows:(0,t.$5j)("multiple-windows",60195),mute:(0,t.$5j)("mute",60196),noNewline:(0,t.$5j)("no-newline",60197),note:(0,t.$5j)("note",60198),octoface:(0,t.$5j)("octoface",60199),openPreview:(0,t.$5j)("open-preview",60200),package:(0,t.$5j)("package",60201),paintcan:(0,t.$5j)("paintcan",60202),pin:(0,t.$5j)("pin",60203),play:(0,t.$5j)("play",60204),run:(0,t.$5j)("run",60204),plug:(0,t.$5j)("plug",60205),preserveCase:(0,t.$5j)("preserve-case",60206),preview:(0,t.$5j)("preview",60207),project:(0,t.$5j)("project",60208),pulse:(0,t.$5j)("pulse",60209),question:(0,t.$5j)("question",60210),quote:(0,t.$5j)("quote",60211),radioTower:(0,t.$5j)("radio-tower",60212),reactions:(0,t.$5j)("reactions",60213),references:(0,t.$5j)("references",60214),refresh:(0,t.$5j)("refresh",60215),regex:(0,t.$5j)("regex",60216),remoteExplorer:(0,t.$5j)("remote-explorer",60217),remote:(0,t.$5j)("remote",60218),remove:(0,t.$5j)("remove",60219),replaceAll:(0,t.$5j)("replace-all",60220),replace:(0,t.$5j)("replace",60221),repoClone:(0,t.$5j)("repo-clone",60222),repoForcePush:(0,t.$5j)("repo-force-push",60223),repoPull:(0,t.$5j)("repo-pull",60224),repoPush:(0,t.$5j)("repo-push",60225),report:(0,t.$5j)("report",60226),requestChanges:(0,t.$5j)("request-changes",60227),rocket:(0,t.$5j)("rocket",60228),rootFolderOpened:(0,t.$5j)("root-folder-opened",60229),rootFolder:(0,t.$5j)("root-folder",60230),rss:(0,t.$5j)("rss",60231),ruby:(0,t.$5j)("ruby",60232),saveAll:(0,t.$5j)("save-all",60233),saveAs:(0,t.$5j)("save-as",60234),save:(0,t.$5j)("save",60235),screenFull:(0,t.$5j)("screen-full",60236),screenNormal:(0,t.$5j)("screen-normal",60237),searchStop:(0,t.$5j)("search-stop",60238),server:(0,t.$5j)("server",60240),settingsGear:(0,t.$5j)("settings-gear",60241),settings:(0,t.$5j)("settings",60242),shield:(0,t.$5j)("shield",60243),smiley:(0,t.$5j)("smiley",60244),sortPrecedence:(0,t.$5j)("sort-precedence",60245),splitHorizontal:(0,t.$5j)("split-horizontal",60246),splitVertical:(0,t.$5j)("split-vertical",60247),squirrel:(0,t.$5j)("squirrel",60248),starFull:(0,t.$5j)("star-full",60249),starHalf:(0,t.$5j)("star-half",60250),symbolClass:(0,t.$5j)("symbol-class",60251),symbolColor:(0,t.$5j)("symbol-color",60252),symbolConstant:(0,t.$5j)("symbol-constant",60253),symbolEnumMember:(0,t.$5j)("symbol-enum-member",60254),symbolField:(0,t.$5j)("symbol-field",60255),symbolFile:(0,t.$5j)("symbol-file",60256),symbolInterface:(0,t.$5j)("symbol-interface",60257),symbolKeyword:(0,t.$5j)("symbol-keyword",60258),symbolMisc:(0,t.$5j)("symbol-misc",60259),symbolOperator:(0,t.$5j)("symbol-operator",60260),symbolProperty:(0,t.$5j)("symbol-property",60261),wrench:(0,t.$5j)("wrench",60261),wrenchSubaction:(0,t.$5j)("wrench-subaction",60261),symbolSnippet:(0,t.$5j)("symbol-snippet",60262),tasklist:(0,t.$5j)("tasklist",60263),telescope:(0,t.$5j)("telescope",60264),textSize:(0,t.$5j)("text-size",60265),threeBars:(0,t.$5j)("three-bars",60266),thumbsdown:(0,t.$5j)("thumbsdown",60267),thumbsup:(0,t.$5j)("thumbsup",60268),tools:(0,t.$5j)("tools",60269),triangleDown:(0,t.$5j)("triangle-down",60270),triangleLeft:(0,t.$5j)("triangle-left",60271),triangleRight:(0,t.$5j)("triangle-right",60272),triangleUp:(0,t.$5j)("triangle-up",60273),twitter:(0,t.$5j)("twitter",60274),unfold:(0,t.$5j)("unfold",60275),unlock:(0,t.$5j)("unlock",60276),unmute:(0,t.$5j)("unmute",60277),unverified:(0,t.$5j)("unverified",60278),verified:(0,t.$5j)("verified",60279),versions:(0,t.$5j)("versions",60280),vmActive:(0,t.$5j)("vm-active",60281),vmOutline:(0,t.$5j)("vm-outline",60282),vmRunning:(0,t.$5j)("vm-running",60283),watch:(0,t.$5j)("watch",60284),whitespace:(0,t.$5j)("whitespace",60285),wholeWord:(0,t.$5j)("whole-word",60286),window:(0,t.$5j)("window",60287),wordWrap:(0,t.$5j)("word-wrap",60288),zoomIn:(0,t.$5j)("zoom-in",60289),zoomOut:(0,t.$5j)("zoom-out",60290),listFilter:(0,t.$5j)("list-filter",60291),listFlat:(0,t.$5j)("list-flat",60292),listSelection:(0,t.$5j)("list-selection",60293),selection:(0,t.$5j)("selection",60293),listTree:(0,t.$5j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,t.$5j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,t.$5j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,t.$5j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,t.$5j)("debug-stackframe-active",60297),circleSmallFilled:(0,t.$5j)("circle-small-filled",60298),debugStackframeDot:(0,t.$5j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,t.$5j)("terminal-decoration-mark",60298),debugStackframe:(0,t.$5j)("debug-stackframe",60299),debugStackframeFocused:(0,t.$5j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,t.$5j)("debug-breakpoint-unsupported",60300),symbolString:(0,t.$5j)("symbol-string",60301),debugReverseContinue:(0,t.$5j)("debug-reverse-continue",60302),debugStepBack:(0,t.$5j)("debug-step-back",60303),debugRestartFrame:(0,t.$5j)("debug-restart-frame",60304),debugAlt:(0,t.$5j)("debug-alt",60305),callIncoming:(0,t.$5j)("call-incoming",60306),callOutgoing:(0,t.$5j)("call-outgoing",60307),menu:(0,t.$5j)("menu",60308),expandAll:(0,t.$5j)("expand-all",60309),feedback:(0,t.$5j)("feedback",60310),gitPullRequestReviewer:(0,t.$5j)("git-pull-request-reviewer",60310),groupByRefType:(0,t.$5j)("group-by-ref-type",60311),ungroupByRefType:(0,t.$5j)("ungroup-by-ref-type",60312),account:(0,t.$5j)("account",60313),gitPullRequestAssignee:(0,t.$5j)("git-pull-request-assignee",60313),bellDot:(0,t.$5j)("bell-dot",60314),debugConsole:(0,t.$5j)("debug-console",60315),library:(0,t.$5j)("library",60316),output:(0,t.$5j)("output",60317),runAll:(0,t.$5j)("run-all",60318),syncIgnored:(0,t.$5j)("sync-ignored",60319),pinned:(0,t.$5j)("pinned",60320),githubInverted:(0,t.$5j)("github-inverted",60321),serverProcess:(0,t.$5j)("server-process",60322),serverEnvironment:(0,t.$5j)("server-environment",60323),pass:(0,t.$5j)("pass",60324),issueClosed:(0,t.$5j)("issue-closed",60324),stopCircle:(0,t.$5j)("stop-circle",60325),playCircle:(0,t.$5j)("play-circle",60326),record:(0,t.$5j)("record",60327),debugAltSmall:(0,t.$5j)("debug-alt-small",60328),vmConnect:(0,t.$5j)("vm-connect",60329),cloud:(0,t.$5j)("cloud",60330),merge:(0,t.$5j)("merge",60331),export:(0,t.$5j)("export",60332),graphLeft:(0,t.$5j)("graph-left",60333),magnet:(0,t.$5j)("magnet",60334),notebook:(0,t.$5j)("notebook",60335),redo:(0,t.$5j)("redo",60336),checkAll:(0,t.$5j)("check-all",60337),pinnedDirty:(0,t.$5j)("pinned-dirty",60338),passFilled:(0,t.$5j)("pass-filled",60339),circleLargeFilled:(0,t.$5j)("circle-large-filled",60340),circleLarge:(0,t.$5j)("circle-large",60341),circleLargeOutline:(0,t.$5j)("circle-large-outline",60341),combine:(0,t.$5j)("combine",60342),gather:(0,t.$5j)("gather",60342),table:(0,t.$5j)("table",60343),variableGroup:(0,t.$5j)("variable-group",60344),typeHierarchy:(0,t.$5j)("type-hierarchy",60345),typeHierarchySub:(0,t.$5j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,t.$5j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,t.$5j)("git-pull-request-create",60348),runAbove:(0,t.$5j)("run-above",60349),runBelow:(0,t.$5j)("run-below",60350),notebookTemplate:(0,t.$5j)("notebook-template",60351),debugRerun:(0,t.$5j)("debug-rerun",60352),workspaceTrusted:(0,t.$5j)("workspace-trusted",60353),workspaceUntrusted:(0,t.$5j)("workspace-untrusted",60354),workspaceUnknown:(0,t.$5j)("workspace-unknown",60355),terminalCmd:(0,t.$5j)("terminal-cmd",60356),terminalDebian:(0,t.$5j)("terminal-debian",60357),terminalLinux:(0,t.$5j)("terminal-linux",60358),terminalPowershell:(0,t.$5j)("terminal-powershell",60359),terminalTmux:(0,t.$5j)("terminal-tmux",60360),terminalUbuntu:(0,t.$5j)("terminal-ubuntu",60361),terminalBash:(0,t.$5j)("terminal-bash",60362),arrowSwap:(0,t.$5j)("arrow-swap",60363),copy:(0,t.$5j)("copy",60364),personAdd:(0,t.$5j)("person-add",60365),filterFilled:(0,t.$5j)("filter-filled",60366),wand:(0,t.$5j)("wand",60367),debugLineByLine:(0,t.$5j)("debug-line-by-line",60368),inspect:(0,t.$5j)("inspect",60369),layers:(0,t.$5j)("layers",60370),layersDot:(0,t.$5j)("layers-dot",60371),layersActive:(0,t.$5j)("layers-active",60372),compass:(0,t.$5j)("compass",60373),compassDot:(0,t.$5j)("compass-dot",60374),compassActive:(0,t.$5j)("compass-active",60375),azure:(0,t.$5j)("azure",60376),issueDraft:(0,t.$5j)("issue-draft",60377),gitPullRequestClosed:(0,t.$5j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,t.$5j)("git-pull-request-draft",60379),debugAll:(0,t.$5j)("debug-all",60380),debugCoverage:(0,t.$5j)("debug-coverage",60381),runErrors:(0,t.$5j)("run-errors",60382),folderLibrary:(0,t.$5j)("folder-library",60383),debugContinueSmall:(0,t.$5j)("debug-continue-small",60384),beakerStop:(0,t.$5j)("beaker-stop",60385),graphLine:(0,t.$5j)("graph-line",60386),graphScatter:(0,t.$5j)("graph-scatter",60387),pieChart:(0,t.$5j)("pie-chart",60388),bracket:(0,t.$5j)("bracket",60175),bracketDot:(0,t.$5j)("bracket-dot",60389),bracketError:(0,t.$5j)("bracket-error",60390),lockSmall:(0,t.$5j)("lock-small",60391),azureDevops:(0,t.$5j)("azure-devops",60392),verifiedFilled:(0,t.$5j)("verified-filled",60393),newline:(0,t.$5j)("newline",60394),layout:(0,t.$5j)("layout",60395),layoutActivitybarLeft:(0,t.$5j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,t.$5j)("layout-activitybar-right",60397),layoutPanelLeft:(0,t.$5j)("layout-panel-left",60398),layoutPanelCenter:(0,t.$5j)("layout-panel-center",60399),layoutPanelJustify:(0,t.$5j)("layout-panel-justify",60400),layoutPanelRight:(0,t.$5j)("layout-panel-right",60401),layoutPanel:(0,t.$5j)("layout-panel",60402),layoutSidebarLeft:(0,t.$5j)("layout-sidebar-left",60403),layoutSidebarRight:(0,t.$5j)("layout-sidebar-right",60404),layoutStatusbar:(0,t.$5j)("layout-statusbar",60405),layoutMenubar:(0,t.$5j)("layout-menubar",60406),layoutCentered:(0,t.$5j)("layout-centered",60407),target:(0,t.$5j)("target",60408),indent:(0,t.$5j)("indent",60409),recordSmall:(0,t.$5j)("record-small",60410),errorSmall:(0,t.$5j)("error-small",60411),terminalDecorationError:(0,t.$5j)("terminal-decoration-error",60411),arrowCircleDown:(0,t.$5j)("arrow-circle-down",60412),arrowCircleLeft:(0,t.$5j)("arrow-circle-left",60413),arrowCircleRight:(0,t.$5j)("arrow-circle-right",60414),arrowCircleUp:(0,t.$5j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,t.$5j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,t.$5j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,t.$5j)("layout-sidebar-left-off",60418),blank:(0,t.$5j)("blank",60419),heartFilled:(0,t.$5j)("heart-filled",60420),map:(0,t.$5j)("map",60421),mapHorizontal:(0,t.$5j)("map-horizontal",60421),foldHorizontal:(0,t.$5j)("fold-horizontal",60421),mapFilled:(0,t.$5j)("map-filled",60422),mapHorizontalFilled:(0,t.$5j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,t.$5j)("fold-horizontal-filled",60422),circleSmall:(0,t.$5j)("circle-small",60423),bellSlash:(0,t.$5j)("bell-slash",60424),bellSlashDot:(0,t.$5j)("bell-slash-dot",60425),commentUnresolved:(0,t.$5j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,t.$5j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,t.$5j)("git-pull-request-new-changes",60428),searchFuzzy:(0,t.$5j)("search-fuzzy",60429),commentDraft:(0,t.$5j)("comment-draft",60430),send:(0,t.$5j)("send",60431),sparkle:(0,t.$5j)("sparkle",60432),insert:(0,t.$5j)("insert",60433),mic:(0,t.$5j)("mic",60434),thumbsdownFilled:(0,t.$5j)("thumbsdown-filled",60435),thumbsupFilled:(0,t.$5j)("thumbsup-filled",60436),coffee:(0,t.$5j)("coffee",60437),snake:(0,t.$5j)("snake",60438),game:(0,t.$5j)("game",60439),vr:(0,t.$5j)("vr",60440),chip:(0,t.$5j)("chip",60441),piano:(0,t.$5j)("piano",60442),music:(0,t.$5j)("music",60443),micFilled:(0,t.$5j)("mic-filled",60444),repoFetch:(0,t.$5j)("repo-fetch",60445),copilot:(0,t.$5j)("copilot",60446),lightbulbSparkle:(0,t.$5j)("lightbulb-sparkle",60447),robot:(0,t.$5j)("robot",60448),sparkleFilled:(0,t.$5j)("sparkle-filled",60449),diffSingle:(0,t.$5j)("diff-single",60450),diffMultiple:(0,t.$5j)("diff-multiple",60451),surroundWith:(0,t.$5j)("surround-with",60452),share:(0,t.$5j)("share",60453),gitStash:(0,t.$5j)("git-stash",60454),gitStashApply:(0,t.$5j)("git-stash-apply",60455),gitStashPop:(0,t.$5j)("git-stash-pop",60456),vscode:(0,t.$5j)("vscode",60457),vscodeInsiders:(0,t.$5j)("vscode-insiders",60458),codeOss:(0,t.$5j)("code-oss",60459),runCoverage:(0,t.$5j)("run-coverage",60460),runAllCoverage:(0,t.$5j)("run-all-coverage",60461),coverage:(0,t.$5j)("coverage",60462),githubProject:(0,t.$5j)("github-project",60463),mapVertical:(0,t.$5j)("map-vertical",60464),foldVertical:(0,t.$5j)("fold-vertical",60464),mapVerticalFilled:(0,t.$5j)("map-vertical-filled",60465),foldVerticalFilled:(0,t.$5j)("fold-vertical-filled",60465),goToSearch:(0,t.$5j)("go-to-search",60466),percentage:(0,t.$5j)("percentage",60467),sortPercentage:(0,t.$5j)("sort-percentage",60467),attach:(0,t.$5j)("attach",60468)}}),define(Te[57],Oe([1,0,107,175]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=void 0,e.$8j=E;function E(){return Object.values(e.$0j)}e.$9j={dialogError:(0,t.$5j)("dialog-error","error"),dialogWarning:(0,t.$5j)("dialog-warning","warning"),dialogInfo:(0,t.$5j)("dialog-info","info"),dialogClose:(0,t.$5j)("dialog-close","close"),treeItemExpanded:(0,t.$5j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,t.$5j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,t.$5j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,t.$5j)("tree-filter-clear","close"),treeItemLoading:(0,t.$5j)("tree-item-loading","loading"),menuSelection:(0,t.$5j)("menu-selection","check"),menuSubmenu:(0,t.$5j)("menu-submenu","chevron-right"),menuBarMore:(0,t.$5j)("menubar-more","more"),scrollbarButtonLeft:(0,t.$5j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,t.$5j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,t.$5j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,t.$5j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,t.$5j)("toolbar-more","more"),quickInputBack:(0,t.$5j)("quick-input-back","arrow-left"),dropDownButton:(0,t.$5j)("drop-down-button",60084),symbolCustomColor:(0,t.$5j)("symbol-customcolor",60252),exportIcon:(0,t.$5j)("export",60332),workspaceUnspecified:(0,t.$5j)("workspace-unspecified",60355),newLine:(0,t.$5j)("newline",60394),thumbsDownFilled:(0,t.$5j)("thumbsdown-filled",60435),thumbsUpFilled:(0,t.$5j)("thumbsup-filled",60436),gitFetch:(0,t.$5j)("git-fetch",60445),lightbulbSparkleAutofix:(0,t.$5j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,t.$5j)("debug-breakpoint-pending",60377)},e.$0j={...r.$7j,...e.$9j}}),define(Te[20],Oe([1,0,10]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=r,e.$lo=E,e.$mo=D,e.$no=v,e.$oo=s,e.$po=S,e.$qo=y,e.$ro=$,e.$so=g,e.$to=a,e.$uo=c,e.$vo=m,e.$wo=b;function r(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const d=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([w,o])=>{d[w]=o&&typeof o=="object"?r(o):o}),d}function E(p){if(!p||typeof p!="object")return p;const d=[p];for(;d.length>0;){const w=d.shift();Object.freeze(w);for(const o in w)if(P.call(w,o)){const l=w[o];typeof l=="object"&&!Object.isFrozen(l)&&!(0,t.$mg)(l)&&d.push(l)}}return p}const P=Object.prototype.hasOwnProperty;function D(p,d){return T(p,d,new Set)}function T(p,d,w){if((0,t.$sg)(p))return p;const o=d(p);if(typeof o<"u")return o;if(Array.isArray(p)){const l=[];for(const n of p)l.push(T(n,d,w));return l}if((0,t.$lg)(p)){if(w.has(p))throw new Error("Cannot clone recursive data-structure");w.add(p);const l={};for(const n in p)P.call(p,n)&&(l[n]=T(p[n],d,w));return w.delete(p),l}return p}function v(p,d,w=!0){return(0,t.$lg)(p)?((0,t.$lg)(d)&&Object.keys(d).forEach(o=>{o in p?w&&((0,t.$lg)(p[o])&&(0,t.$lg)(d[o])?v(p[o],d[o],w):p[o]=d[o]):p[o]=d[o]}),p):d}function s(p,d){if(p===d)return!0;if(p==null||d===null||d===void 0||typeof p!=typeof d||typeof p!="object"||Array.isArray(p)!==Array.isArray(d))return!1;let w,o;if(Array.isArray(p)){if(p.length!==d.length)return!1;for(w=0;w<p.length;w++)if(!s(p[w],d[w]))return!1}else{const l=[];for(o in p)l.push(o);l.sort();const n=[];for(o in d)n.push(o);if(n.sort(),!s(l,n))return!1;for(w=0;w<l.length;w++)if(!s(p[l[w]],d[l[w]]))return!1}return!0}function S(p){const d=new Set;return JSON.stringify(p,(w,o)=>{if((0,t.$lg)(o)||Array.isArray(o)){if(d.has(o))return"[Circular]";d.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function y(p,d){const w=Object.create(null);return!p||!d||Object.keys(d).forEach(l=>{const n=p[l],u=d[l];s(n,u)||(w[l]=u)}),w}function $(p,d){const w=d.toLowerCase(),o=Object.keys(p).find(l=>l.toLowerCase()===w);return o?p[o]:p[d]}function g(p,d){const w=Object.create(null);for(const[o,l]of Object.entries(p))d(o,l)&&(w[o]=l);return w}function a(p){let d=[];for(;Object.prototype!==p;)d=d.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return d}function c(p){const d=[];for(const w of a(p))typeof p[w]=="function"&&d.push(w);return d}function m(p,d){const w=l=>function(){const n=Array.prototype.slice.call(arguments,0);return d(l,n)},o={};for(const l of p)o[l]=w(l);return o}function b(p,d){const w={};for(const[o,l]of Object.entries(p))w[o]=d(l,o);return w}}),define(Te[83],Oe([1,0,57]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$$j=E;var r;(function(D){function T(v){return v&&typeof v=="object"&&typeof v.id=="string"}D.isThemeColor=T})(r||(e.ThemeColor=r={}));function E(D){return{id:D}}var P;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function v(p){const d=T.exec(p.id);if(!d)return v(t.$0j.error);const[,w,o]=d,l=["codicon","codicon-"+w];return o&&l.push("codicon-modifier-"+o.substring(1)),l}D.asClassNameArray=v;function s(p){return v(p).join(" ")}D.asClassName=s;function S(p){return"."+v(p).join(".")}D.asCSSSelector=S;function y(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||r.isThemeColor(p.color))}D.isThemeIcon=y;const $=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function g(p){const d=$.exec(p);if(!d)return;const[,w]=d;return{id:w}}D.fromString=g;function a(p){return{id:p}}D.fromId=a;function c(p,d){let w=p.id;const o=w.lastIndexOf("~");return o!==-1&&(w=w.substring(0,o)),d&&(w=`${w}~${d}`),{id:w}}D.modify=c;function m(p){const d=p.id.lastIndexOf("~");if(d!==-1)return p.id.substring(d+1)}D.getModifier=m;function b(p,d){return p.id===d.id&&p.color?.id===d.color?.id}D.isEqual=b})(P||(e.ThemeIcon=P={}))}),define(Te[108],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$ff=r,e.$gf=E;var t;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(t||(e.Constants=t={}));function r(P){return P<0?0:P>t.MAX_UINT_8?t.MAX_UINT_8:P|0}function E(P){return P<0?0:P>t.MAX_UINT_32?t.MAX_UINT_32:P|0}}),define(Te[16],Oe([1,0,172,34,65,108]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=e.GraphemeBreakType=e.$9f=e.$1f=e.$Tf=e.$Sf=void 0,e.$hf=D,e.$if=v,e.$jf=S,e.$kf=y,e.$lf=$,e.$mf=g,e.$nf=a,e.$of=c,e.$pf=m,e.$qf=b,e.$rf=p,e.$sf=d,e.$tf=w,e.$uf=o,e.$vf=l,e.$wf=n,e.$xf=u,e.$yf=i,e.$zf=f,e.$Af=h,e.$Bf=k,e.$Cf=I,e.$Df=O,e.$Ef=C,e.$Ff=L,e.$Gf=R,e.$Hf=M,e.$If=G,e.$Jf=Q,e.$Kf=te,e.$Lf=ve,e.$Mf=be,e.$Nf=le,e.$Of=K,e.$Pf=B,e.$Qf=j,e.$Rf=U,e.$Uf=se,e.$Vf=ne,e.$Wf=X,e.$Xf=z,e.$Yf=pe,e.$Zf=ie,e.$2f=W,e.$3f=Z,e.$4f=ce,e.$5f=we,e.$6f=ze,e.$7f=qe,e.$8f=Ne,e.$0f=De,e.$$f=Ce,e.$_f=ge,e.$ag=Se,e.$bg=Pe,e.$cg=Ue,e.$dg=Ge,e.$eg=Qe,e.$fg=ct;function D(V){return!V||typeof V!="string"?!0:V.trim().length===0}const T=/{(\d+)}/g;function v(V,..._){return _.length===0?V:V.replace(T,function(fe,re){const he=parseInt(re,10);return isNaN(he)||he<0||he>=_.length?fe:_[he]})}const s=/{([^}]+)}/g;function S(V,_){return Object.keys(_).length===0?V:V.replace(s,(fe,re)=>_[re]??fe)}function y(V){return V.replace(/[<>"'&]/g,_=>{switch(_){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return _})}function $(V){return V.replace(/[<>&]/g,function(_){switch(_){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return _}})}function g(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function a(V,_){let fe=0,re=V.indexOf(_);for(;re!==-1;)fe++,re=V.indexOf(_,re+_.length);return fe}function c(V,_,fe="\u2026"){return V.length<=_?V:`${V.substr(0,_)}${fe}`}function m(V,_,fe="\u2026"){if(V.length<=_)return V;const re=Math.ceil(_/2)-fe.length/2,he=Math.floor(_/2)-fe.length/2;return`${V.substr(0,re)}${fe}${V.substr(V.length-he)}`}function b(V,_=" "){const fe=p(V,_);return d(fe,_)}function p(V,_){if(!V||!_)return V;const fe=_.length;if(fe===0||V.length===0)return V;let re=0;for(;V.indexOf(_,re)===re;)re=re+fe;return V.substring(re)}function d(V,_){if(!V||!_)return V;const fe=_.length,re=V.length;if(fe===0||re===0)return V;let he=re,H=-1;for(;H=V.lastIndexOf(_,he-1),!(H===-1||H+fe!==he);){if(H===0)return"";he=H}return V.substring(0,he)}function w(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function o(V){return V.replace(/\*/g,"")}function l(V,_,fe={}){if(!V)throw new Error("Cannot create regex from empty string");_||(V=g(V)),fe.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let re="";return fe.global&&(re+="g"),fe.matchCase||(re+="i"),fe.multiline&&(re+="m"),fe.unicode&&(re+="u"),new RegExp(V,re)}function n(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}function u(V){return V.split(/\r\n|\r|\n/)}function i(V){const _=[],fe=V.split(/(\r\n|\r|\n)/);for(let re=0;re<Math.ceil(fe.length/2);re++)_.push(fe[2*re]+(fe[2*re+1]??""));return _}function f(V){for(let _=0,fe=V.length;_<fe;_++){const re=V.charCodeAt(_);if(re!==r.CharCode.Space&&re!==r.CharCode.Tab)return _}return-1}function h(V,_=0,fe=V.length){for(let re=_;re<fe;re++){const he=V.charCodeAt(re);if(he!==r.CharCode.Space&&he!==r.CharCode.Tab)return V.substring(_,re)}return V.substring(_,fe)}function k(V,_=V.length-1){for(let fe=_;fe>=0;fe--){const re=V.charCodeAt(fe);if(re!==r.CharCode.Space&&re!==r.CharCode.Tab)return fe}return-1}function I(V,_,fe){const re=[];let he=0;for(const H of V.matchAll(_)){if(re.push(V.slice(he,H.index)),H.index===void 0)throw new Error("match.index should be defined");he=H.index+H[0].length,re.push(fe(H[0],...H.slice(1),H.index,V,H.groups))}return re.push(V.slice(he)),Promise.all(re).then(H=>H.join(""))}function O(V,_){return V<_?-1:V>_?1:0}function C(V,_,fe=0,re=V.length,he=0,H=_.length){for(;fe<re&&he<H;fe++,he++){const Fe=V.charCodeAt(fe),He=_.charCodeAt(he);if(Fe<He)return-1;if(Fe>He)return 1}const J=re-fe,$e=H-he;return J<$e?-1:J>$e?1:0}function L(V,_){return R(V,_,0,V.length,0,_.length)}function R(V,_,fe=0,re=V.length,he=0,H=_.length){for(;fe<re&&he<H;fe++,he++){let Fe=V.charCodeAt(fe),He=_.charCodeAt(he);if(Fe===He)continue;if(Fe>=128||He>=128)return C(V.toLowerCase(),_.toLowerCase(),fe,re,he,H);G(Fe)&&(Fe-=32),G(He)&&(He-=32);const xe=Fe-He;if(xe!==0)return xe}const J=re-fe,$e=H-he;return J<$e?-1:J>$e?1:0}function M(V){return V>=r.CharCode.Digit0&&V<=r.CharCode.Digit9}function G(V){return V>=r.CharCode.a&&V<=r.CharCode.z}function Q(V){return V>=r.CharCode.A&&V<=r.CharCode.Z}function te(V,_){return V.length===_.length&&R(V,_)===0}function ve(V,_){const fe=_.length;return _.length>V.length?!1:R(V,_,0,fe)===0}function be(V,_){const fe=Math.min(V.length,_.length);let re;for(re=0;re<fe;re++)if(V.charCodeAt(re)!==_.charCodeAt(re))return re;return fe}function le(V,_){const fe=Math.min(V.length,_.length);let re;const he=V.length-1,H=_.length-1;for(re=0;re<fe;re++)if(V.charCodeAt(he-re)!==_.charCodeAt(H-re))return re;return fe}function K(V){return 55296<=V&&V<=56319}function B(V){return 56320<=V&&V<=57343}function j(V,_){return(V-55296<<10)+(_-56320)+65536}function U(V,_,fe){const re=V.charCodeAt(fe);if(K(re)&&fe+1<_){const he=V.charCodeAt(fe+1);if(B(he))return j(re,he)}return re}function ee(V,_){const fe=V.charCodeAt(_-1);if(B(fe)&&_>1){const re=V.charCodeAt(_-2);if(K(re))return j(re,fe)}return fe}class ae{get offset(){return this.e}constructor(_,fe=0){this.c=_,this.d=_.length,this.e=fe}setOffset(_){this.e=_}prevCodePoint(){const _=ee(this.c,this.e);return this.e-=_>=P.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,_}nextCodePoint(){const _=U(this.c,this.d,this.e);return this.e+=_>=P.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,_}eol(){return this.e>=this.d}}e.$Sf=ae;class ye{get offset(){return this.c.offset}constructor(_,fe=0){this.c=new ae(_,fe)}nextGraphemeLength(){const _=tt.getInstance(),fe=this.c,re=fe.offset;let he=_.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const H=fe.offset,J=_.getGraphemeBreakType(fe.nextCodePoint());if(Ze(he,J)){fe.setOffset(H);break}he=J}return fe.offset-re}prevGraphemeLength(){const _=tt.getInstance(),fe=this.c,re=fe.offset;let he=_.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const H=fe.offset,J=_.getGraphemeBreakType(fe.prevCodePoint());if(Ze(J,he)){fe.setOffset(H);break}he=J}return re-fe.offset}eol(){return this.c.eol()}}e.$Tf=ye;function se(V,_){return new ye(V,_).nextGraphemeLength()}function ne(V,_){return new ye(V,_).prevGraphemeLength()}function X(V,_){_>0&&B(V.charCodeAt(_))&&_--;const fe=_+se(V,_);return[fe-ne(V,fe),fe]}function z(V){const _=new ye(V);let fe=0;for(;!_.eol();)fe++,_.nextGraphemeLength();return fe}let A;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function pe(V){return A||(A=Y()),A.test(V)}const x=/^[\t\n\r\x20-\x7E]*$/;function ie(V){return x.test(V)}e.$1f=/[\u2028\u2029]/;function W(V){return e.$1f.test(V)}function Z(V){return V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}function ce(V){return V>=127462&&V<=127487||V===8986||V===8987||V===9200||V===9203||V>=9728&&V<=10175||V===11088||V===11093||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129008||V>=129280&&V<=129535||V>=129648&&V<=129782}function we(V,_,fe=""){const re=V.trimStart();if(re.length<_)return re;const he=/\b/g;let H=0;for(;he.test(re)&&!(re.length-he.lastIndex<_);)H=he.lastIndex,he.lastIndex+=1;return H===0?re:fe+re.substring(H).trimStart()}const Le=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ze(V){let _=0;for(const fe of V.matchAll(Le))_!==fe.index&&(yield{isCode:!1,str:V.substring(_,fe.index)}),yield{isCode:!0,str:fe[0]},_=fe.index+fe[0].length;_!==V.length&&(yield{isCode:!1,str:V.substring(_)})}function qe(V){return V&&(V=V.replace(Le,"")),V}const Re=/\\\[.*?\\\]/g;function Ne(V){return qe(V).replace(Re,"")}e.$9f=String.fromCharCode(r.CharCode.UTF8_BOM);function De(V){return!!(V&&V.length>0&&V.charCodeAt(0)===r.CharCode.UTF8_BOM)}function Ce(V){return De(V)?V.substr(1):V}function ge(V,_){if(!V||!_||V.length<_.length)return!1;const fe=_.length,re=V.toLowerCase();let he=0,H=-1;for(;he<fe;){const J=re.indexOf(_[he],H+1);if(J<0)return!1;H=J,he++}return!0}function Se(V,_=!1){return V?(_&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}function Pe(V){return V.charAt(0).toUpperCase()+V.slice(1)}function Ue(V,_=1){if(_===0)return"";let fe=-1;do fe=V.indexOf(`
`,fe+1),_--;while(_>0&&fe>=0);return fe===-1?V:(V[fe-1]==="\r"&&fe--,V.substr(0,fe))}function Ge(V){const _=r.CharCode.Z-r.CharCode.A+1;return V=V%(2*_),V<_?String.fromCharCode(r.CharCode.a+V):String.fromCharCode(r.CharCode.A+V-_)}function Qe(V){return tt.getInstance().getGraphemeBreakType(V)}function Ze(V,_){return V===Xe.Other?_!==Xe.Extend&&_!==Xe.SpacingMark:V===Xe.CR&&_===Xe.LF?!1:V===Xe.Control||V===Xe.CR||V===Xe.LF||_===Xe.Control||_===Xe.CR||_===Xe.LF?!0:!(V===Xe.L&&(_===Xe.L||_===Xe.V||_===Xe.LV||_===Xe.LVT)||(V===Xe.LV||V===Xe.V)&&(_===Xe.V||_===Xe.T)||(V===Xe.LVT||V===Xe.T)&&_===Xe.T||_===Xe.Extend||_===Xe.ZWJ||_===Xe.SpacingMark||V===Xe.Prepend||V===Xe.ZWJ&&_===Xe.Extended_Pictographic||V===Xe.Regional_Indicator&&_===Xe.Regional_Indicator)}var Xe;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(Xe||(e.GraphemeBreakType=Xe={}));class tt{static{this.c=null}static getInstance(){return tt.c||(tt.c=new tt),tt.c}constructor(){this.d=lt()}getGraphemeBreakType(_){if(_<32)return _===r.CharCode.LineFeed?Xe.LF:_===r.CharCode.CarriageReturn?Xe.CR:Xe.Control;if(_<127)return Xe.Other;const fe=this.d,re=fe.length/3;let he=1;for(;he<=re;)if(_<fe[3*he])he=2*he;else if(_>fe[3*he+1])he=2*he+1;else return fe[3*he+2];return Xe.Other}}function lt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ct(V,_){if(V===0)return 0;const fe=rt(V,_);if(fe!==void 0)return fe;const re=new ae(_,V);return re.prevCodePoint(),re.offset}function rt(V,_){const fe=new ae(_,V);let re=fe.prevCodePoint();for(;ut(re)||re===st.emojiVariantSelector||re===st.enclosingKeyCap;){if(fe.offset===0)return;re=fe.prevCodePoint()}if(!ce(re))return;let he=fe.offset;return he>0&&fe.prevCodePoint()===st.zwj&&(he=fe.offset),he}function ut(V){return 127995<=V&&V<=127999}var st;(function(V){V[V.zwj=8205]="zwj",V[V.emojiVariantSelector=65039]="emojiVariantSelector",V[V.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),e.$gg="\xA0";class Je{static{this.c=new E.$Y(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new t.$df({getCacheKey:JSON.stringify},_=>{function fe(xe){const et=new Map;for(let it=0;it<xe.length;it+=2)et.set(xe[it],xe[it+1]);return et}function re(xe,et){const it=new Map(xe);for(const[ft,gt]of et)it.set(ft,gt);return it}function he(xe,et){if(!xe)return et;const it=new Map;for(const[ft,gt]of xe)et.has(ft)&&it.set(ft,gt);return it}const H=this.c.value;let J=_.filter(xe=>!xe.startsWith("_")&&xe in H);J.length===0&&(J=["_default"]);let $e;for(const xe of J){const et=fe(H[xe]);$e=he($e,et)}const Fe=fe(H._common),He=re(Fe,$e);return new Je(He)})}static getInstance(_){return Je.d.get(Array.from(_))}static{this.e=new E.$Y(()=>Object.keys(Je.c.value).filter(_=>!_.startsWith("_")))}static getLocales(){return Je.e.value}constructor(_){this.f=_}isAmbiguous(_){return this.f.has(_)}containsAmbiguousCharacter(_){for(let fe=0;fe<_.length;fe++){const re=_.codePointAt(fe);if(typeof re=="number"&&this.isAmbiguous(re))return!0}return!1}getPrimaryConfusable(_){return this.f.get(_)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hg=Je;class me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(me.c())),this.d}static isInvisibleCharacter(_){return me.e().has(_)}static containsInvisibleCharacter(_){for(let fe=0;fe<_.length;fe++){const re=_.codePointAt(fe);if(typeof re=="number"&&me.isInvisibleCharacter(re))return!0}return!1}static get codePoints(){return me.e()}}e.$ig=me}),define(Te[176],Oe([1,0,34,25,165,16]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.FuzzyScore=e.$Nk=e.$Mk=void 0,e.or=D,e.$Ok=v,e.$Pk=s,e.$Qk=$,e.$Rk=k,e.$Sk=I,e.$Tk=G,e.$Uk=Q,e.$Vk=te,e.$Wk=ve,e.$Xk=Y,e.$Zk=W,e.$1k=we,e.$2k=Le,P=Ve(P);function D(...Re){return function(Ne,De){for(let Ce=0,ge=Re.length;Ce<ge;Ce++){const Se=Re[Ce](Ne,De);if(Se)return Se}return null}}e.$Mk=T.bind(void 0,!1),e.$Nk=T.bind(void 0,!0);function T(Re,Ne,De){if(!De||De.length<Ne.length)return null;let Ce;return Re?Ce=P.$Lf(De,Ne):Ce=De.indexOf(Ne)===0,Ce?Ne.length>0?[{start:0,end:Ne.length}]:[]:null}function v(Re,Ne){const De=Ne.toLowerCase().indexOf(Re.toLowerCase());return De===-1?null:[{start:De,end:De+Re.length}]}function s(Re,Ne){return S(Re.toLowerCase(),Ne.toLowerCase(),0,0)}function S(Re,Ne,De,Ce){if(De===Re.length)return[];if(Ce===Ne.length)return null;if(Re[De]===Ne[Ce]){let ge=null;return(ge=S(Re,Ne,De+1,Ce+1))?o({start:Ce,end:Ce+1},ge):null}return S(Re,Ne,De,Ce+1)}function y(Re){return t.CharCode.a<=Re&&Re<=t.CharCode.z}function $(Re){return t.CharCode.A<=Re&&Re<=t.CharCode.Z}function g(Re){return t.CharCode.Digit0<=Re&&Re<=t.CharCode.Digit9}function a(Re){return Re===t.CharCode.Space||Re===t.CharCode.Tab||Re===t.CharCode.LineFeed||Re===t.CharCode.CarriageReturn}const c=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Re=>c.add(Re.charCodeAt(0)));function m(Re){return a(Re)||c.has(Re)}function b(Re,Ne){return Re===Ne||m(Re)&&m(Ne)}const p=new Map;function d(Re){if(p.has(Re))return p.get(Re);let Ne;const De=(0,E.$Kk)(Re);return De&&(Ne=De),p.set(Re,Ne),Ne}function w(Re){return y(Re)||$(Re)||g(Re)}function o(Re,Ne){return Ne.length===0?Ne=[Re]:Re.end===Ne[0].start?Ne[0].start=Re.start:Ne.unshift(Re),Ne}function l(Re,Ne){for(let De=Ne;De<Re.length;De++){const Ce=Re.charCodeAt(De);if($(Ce)||g(Ce)||De>0&&!w(Re.charCodeAt(De-1)))return De}return Re.length}function n(Re,Ne,De,Ce){if(De===Re.length)return[];if(Ce===Ne.length)return null;if(Re[De]!==Ne[Ce].toLowerCase())return null;{let ge=null,Se=Ce+1;for(ge=n(Re,Ne,De+1,Ce+1);!ge&&(Se=l(Ne,Se))<Ne.length;)ge=n(Re,Ne,De+1,Se),Se++;return ge===null?null:o({start:Ce,end:Ce+1},ge)}}function u(Re){let Ne=0,De=0,Ce=0,ge=0,Se=0;for(let Ze=0;Ze<Re.length;Ze++)Se=Re.charCodeAt(Ze),$(Se)&&Ne++,y(Se)&&De++,w(Se)&&Ce++,g(Se)&&ge++;const Pe=Ne/Re.length,Ue=De/Re.length,Ge=Ce/Re.length,Qe=ge/Re.length;return{upperPercent:Pe,lowerPercent:Ue,alphaPercent:Ge,numericPercent:Qe}}function i(Re){const{upperPercent:Ne,lowerPercent:De}=Re;return De===0&&Ne>.6}function f(Re){const{upperPercent:Ne,lowerPercent:De,alphaPercent:Ce,numericPercent:ge}=Re;return De>.2&&Ne<.8&&Ce>.6&&ge<.2}function h(Re){let Ne=0,De=0,Ce=0,ge=0;for(let Se=0;Se<Re.length;Se++)Ce=Re.charCodeAt(Se),$(Ce)&&Ne++,y(Ce)&&De++,a(Ce)&&ge++;return(Ne===0||De===0)&&ge===0?Re.length<=30:Ne<=5}function k(Re,Ne){if(!Ne||(Ne=Ne.trim(),Ne.length===0)||!h(Re))return null;Ne.length>60&&(Ne=Ne.substring(0,60));const De=u(Ne);if(!f(De)){if(!i(De))return null;Ne=Ne.toLowerCase()}let Ce=null,ge=0;for(Re=Re.toLowerCase();ge<Ne.length&&(Ce=n(Re,Ne,0,ge))===null;)ge=l(Ne,ge+1);return Ce}function I(Re,Ne,De=!1){if(!Ne||Ne.length===0)return null;let Ce=null,ge=0;for(Re=Re.toLowerCase(),Ne=Ne.toLowerCase();ge<Ne.length&&(Ce=O(Re,Ne,0,ge,De),Ce===null);)ge=C(Ne,ge+1);return Ce}function O(Re,Ne,De,Ce,ge){let Se=0;if(De===Re.length)return[];if(Ce===Ne.length)return null;if(!b(Re.charCodeAt(De),Ne.charCodeAt(Ce))){const Ge=d(Re.charCodeAt(De));if(!Ge)return null;for(let Qe=0;Qe<Ge.length;Qe++)if(!b(Ge[Qe],Ne.charCodeAt(Ce+Qe)))return null;Se+=Ge.length-1}let Pe=null,Ue=Ce+Se+1;if(Pe=O(Re,Ne,De+1,Ue,ge),!ge)for(;!Pe&&(Ue=C(Ne,Ue))<Ne.length;)Pe=O(Re,Ne,De+1,Ue,ge),Ue++;if(!Pe)return null;if(Re.charCodeAt(De)!==Ne.charCodeAt(Ce)){const Ge=d(Re.charCodeAt(De));if(!Ge)return Pe;for(let Qe=0;Qe<Ge.length;Qe++)if(Ge[Qe]!==Ne.charCodeAt(Ce+Qe))return Pe}return o({start:Ce,end:Ce+Se+1},Pe)}function C(Re,Ne){for(let De=Ne;De<Re.length;De++)if(m(Re.charCodeAt(De))||De>0&&m(Re.charCodeAt(De-1)))return De;return Re.length}const L=D(e.$Nk,k,v),R=D(e.$Nk,k,s),M=new r.$Ic(1e4);function G(Re,Ne,De=!1){if(typeof Re!="string"||typeof Ne!="string")return null;let Ce=M.get(Re);Ce||(Ce=new RegExp(P.$tf(Re),"i"),M.set(Re,Ce));const ge=Ce.exec(Ne);return ge?[{start:ge.index,end:ge.index+ge[0].length}]:De?R(Re,Ne):L(Re,Ne)}function Q(Re,Ne){const De=W(Re,Re.toLowerCase(),0,Ne,Ne.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return De?ve(De):null}function te(Re,Ne,De,Ce,ge,Se){const Pe=Math.min(13,Re.length);for(;De<Pe;De++){const Ue=W(Re,Ne,De,Ce,ge,Se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ue)return Ue}return[0,Se]}function ve(Re){if(typeof Re>"u")return[];const Ne=[],De=Re[1];for(let Ce=Re.length-1;Ce>1;Ce--){const ge=Re[Ce]+De,Se=Ne[Ne.length-1];Se&&Se.end===ge?Se.end=ge+1:Ne.push({start:ge,end:ge+1})}return Ne}const be=128;function le(){const Re=[],Ne=[];for(let De=0;De<=be;De++)Ne[De]=0;for(let De=0;De<=be;De++)Re.push(Ne.slice(0));return Re}function K(Re){const Ne=[];for(let De=0;De<=Re;De++)Ne[De]=0;return Ne}const B=K(2*be),j=K(2*be),U=le(),ee=le(),ae=le(),ye=!1;function se(Re,Ne,De,Ce,ge){function Se(Ue,Ge,Qe=" "){for(;Ue.length<Ge;)Ue=Qe+Ue;return Ue}let Pe=` |   |${Ce.split("").map(Ue=>Se(Ue,3)).join("|")}
`;for(let Ue=0;Ue<=De;Ue++)Ue===0?Pe+=" |":Pe+=`${Ne[Ue-1]}|`,Pe+=Re[Ue].slice(0,ge+1).map(Ge=>Se(Ge.toString(),3)).join("|")+`
`;return Pe}function ne(Re,Ne,De,Ce){Re=Re.substr(Ne),De=De.substr(Ce),console.log(se(ee,Re,Re.length,De,De.length)),console.log(se(ae,Re,Re.length,De,De.length)),console.log(se(U,Re,Re.length,De,De.length))}function X(Re,Ne){if(Ne<0||Ne>=Re.length)return!1;const De=Re.codePointAt(Ne);switch(De){case t.CharCode.Underline:case t.CharCode.Dash:case t.CharCode.Period:case t.CharCode.Space:case t.CharCode.Slash:case t.CharCode.Backslash:case t.CharCode.SingleQuote:case t.CharCode.DoubleQuote:case t.CharCode.Colon:case t.CharCode.DollarSign:case t.CharCode.LessThan:case t.CharCode.GreaterThan:case t.CharCode.OpenParen:case t.CharCode.CloseParen:case t.CharCode.OpenSquareBracket:case t.CharCode.CloseSquareBracket:case t.CharCode.OpenCurlyBrace:case t.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!P.$4f(De)}}function z(Re,Ne){if(Ne<0||Ne>=Re.length)return!1;switch(Re.charCodeAt(Ne)){case t.CharCode.Space:case t.CharCode.Tab:return!0;default:return!1}}function A(Re,Ne,De){return Ne[Re]!==De[Re]}function Y(Re,Ne,De,Ce,ge,Se,Pe=!1){for(;Ne<De&&ge<Se;)Re[Ne]===Ce[ge]&&(Pe&&(B[Ne]=ge),Ne+=1),ge+=1;return Ne===De}var pe;(function(Re){Re[Re.Diag=1]="Diag",Re[Re.Left=2]="Left",Re[Re.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var x;(function(Re){Re.Default=[-100,0];function Ne(De){return!De||De.length===2&&De[0]===-100&&De[1]===0}Re.isDefault=Ne})(x||(e.FuzzyScore=x={}));class ie{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ne,De){this.firstMatchCanBeWeak=Ne,this.boostFullMatch=De}}e.$Yk=ie;function W(Re,Ne,De,Ce,ge,Se,Pe=ie.default){const Ue=Re.length>be?be:Re.length,Ge=Ce.length>be?be:Ce.length;if(De>=Ue||Se>=Ge||Ue-De>Ge-Se||!Y(Ne,De,Ue,ge,Se,Ge,!0))return;Z(Ue,Ge,De,Se,Ne,ge);let Qe=1,Ze=1,Xe=De,tt=Se;const lt=[!1];for(Qe=1,Xe=De;Xe<Ue;Qe++,Xe++){const Je=B[Xe],me=j[Xe],V=Xe+1<Ue?j[Xe+1]:Ge;for(Ze=Je-Se+1,tt=Je;tt<V;Ze++,tt++){let _=Number.MIN_SAFE_INTEGER,fe=!1;tt<=me&&(_=ce(Re,Ne,Xe,De,Ce,ge,tt,Ge,Se,U[Qe-1][Ze-1]===0,lt));let re=0;_!==Number.MAX_SAFE_INTEGER&&(fe=!0,re=_+ee[Qe-1][Ze-1]);const he=tt>Je,H=he?ee[Qe][Ze-1]+(U[Qe][Ze-1]>0?-5:0):0,J=tt>Je+1&&U[Qe][Ze-1]>0,$e=J?ee[Qe][Ze-2]+(U[Qe][Ze-2]>0?-5:0):0;if(J&&(!he||$e>=H)&&(!fe||$e>=re))ee[Qe][Ze]=$e,ae[Qe][Ze]=pe.LeftLeft,U[Qe][Ze]=0;else if(he&&(!fe||H>=re))ee[Qe][Ze]=H,ae[Qe][Ze]=pe.Left,U[Qe][Ze]=0;else if(fe)ee[Qe][Ze]=re,ae[Qe][Ze]=pe.Diag,U[Qe][Ze]=U[Qe-1][Ze-1]+1;else throw new Error("not possible")}}if(ye&&ne(Re,De,Ce,Se),!lt[0]&&!Pe.firstMatchCanBeWeak)return;Qe--,Ze--;const ct=[ee[Qe][Ze],Se];let rt=0,ut=0;for(;Qe>=1;){let Je=Ze;do{const me=ae[Qe][Je];if(me===pe.LeftLeft)Je=Je-2;else if(me===pe.Left)Je=Je-1;else break}while(Je>=1);rt>1&&Ne[De+Qe-1]===ge[Se+Ze-1]&&!A(Je+Se-1,Ce,ge)&&rt+1>U[Qe][Je]&&(Je=Ze),Je===Ze?rt++:rt=1,ut||(ut=Je),Qe--,Ze=Je-1,ct.push(Ze)}Ge-Se===Ue&&Pe.boostFullMatch&&(ct[0]+=2);const st=ut-Ue;return ct[0]-=st,ct}function Z(Re,Ne,De,Ce,ge,Se){let Pe=Re-1,Ue=Ne-1;for(;Pe>=De&&Ue>=Ce;)ge[Pe]===Se[Ue]&&(j[Pe]=Ue,Pe--),Ue--}function ce(Re,Ne,De,Ce,ge,Se,Pe,Ue,Ge,Qe,Ze){if(Ne[De]!==Se[Pe])return Number.MIN_SAFE_INTEGER;let Xe=1,tt=!1;return Pe===De-Ce?Xe=Re[De]===ge[Pe]?7:5:A(Pe,ge,Se)&&(Pe===0||!A(Pe-1,ge,Se))?(Xe=Re[De]===ge[Pe]?7:5,tt=!0):X(Se,Pe)&&(Pe===0||!X(Se,Pe-1))?Xe=5:(X(Se,Pe-1)||z(Se,Pe-1))&&(Xe=5,tt=!0),Xe>1&&De===Ce&&(Ze[0]=!0),tt||(tt=A(Pe,ge,Se)||X(Se,Pe-1)||z(Se,Pe-1)),De===Ce?Pe>Ge&&(Xe-=tt?3:5):Qe?Xe+=tt?2:0:Xe+=tt?0:1,Pe+1===Ue&&(Xe-=tt?3:5),Xe}function we(Re,Ne,De,Ce,ge,Se,Pe){return ze(Re,Ne,De,Ce,ge,Se,!0,Pe)}function Le(Re,Ne,De,Ce,ge,Se,Pe){return ze(Re,Ne,De,Ce,ge,Se,!1,Pe)}function ze(Re,Ne,De,Ce,ge,Se,Pe,Ue){let Ge=W(Re,Ne,De,Ce,ge,Se,Ue);if(Ge&&!Pe)return Ge;if(Re.length>=3){const Qe=Math.min(7,Re.length-1);for(let Ze=De+1;Ze<Qe;Ze++){const Xe=qe(Re,Ze);if(Xe){const tt=W(Xe,Xe.toLowerCase(),De,Ce,ge,Se,Ue);tt&&(tt[0]-=3,(!Ge||tt[0]>Ge[0])&&(Ge=tt))}}}return Ge}function qe(Re,Ne){if(Ne+1>=Re.length)return;const De=Re[Ne],Ce=Re[Ne+1];if(De!==Ce)return Re.slice(0,Ne)+Ce+De+Re.slice(Ne+2)}}),define(Te[66],Oe([1,0,16]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Cj=void 0,e.$yj=r,e.$zj=E,e.$Aj=P,e.$Bj=T,e.$Dj=c,t=Ve(t);function r(b){return E(b,0)}function E(b,p){switch(typeof b){case"object":return b===null?P(349,p):Array.isArray(b)?v(b,p):s(b,p);case"string":return T(b,p);case"boolean":return D(b,p);case"number":return P(b,p);case"undefined":return P(937,p);default:return P(617,p)}}function P(b,p){return(p<<5)-p+b|0}function D(b,p){return P(b?433:863,p)}function T(b,p){p=P(149417,p);for(let d=0,w=b.length;d<w;d++)p=P(b.charCodeAt(d),p);return p}function v(b,p){return p=P(104579,p),b.reduce((d,w)=>E(w,d),p)}function s(b,p){return p=P(181387,p),Object.keys(b).sort().reduce((d,w)=>(d=T(w,d),E(b[w],d)),p)}class S{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=E(p,this.g),this.g}}e.$Cj=S;var y;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function $(b,p,d=32){const w=d-p,o=~((1<<w)-1);return(b<<p|(o&b)>>>w)>>>0}function g(b,p=0,d=b.byteLength,w=0){for(let o=0;o<d;o++)b[p+o]=w}function a(b,p,d="0"){for(;b.length<p;)b=d+b;return b}function c(b,p=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(d=>d.toString(16).padStart(2,"0")).join(""):a((b>>>0).toString(16),p/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(y.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const d=p.length;if(d===0)return;const w=this.p;let o=this.r,l=this.u,n,u;for(l!==0?(n=l,u=-1,l=0):(n=p.charCodeAt(0),u=0);;){let i=n;if(t.$Of(n))if(u+1<d){const f=p.charCodeAt(u+1);t.$Pf(f)?(u++,i=t.$Qf(n,f)):i=y.UNICODE_REPLACEMENT}else{l=n;break}else t.$Pf(n)&&(i=y.UNICODE_REPLACEMENT);if(o=this.w(w,o,i),u++,u<d)n=p.charCodeAt(u);else break}this.r=o,this.u=l}w(p,d,w){return w<128?p[d++]=w:w<2048?(p[d++]=192|(w&1984)>>>6,p[d++]=128|(w&63)>>>0):w<65536?(p[d++]=224|(w&61440)>>>12,p[d++]=128|(w&4032)>>>6,p[d++]=128|(w&63)>>>0):(p[d++]=240|(w&1835008)>>>18,p[d++]=128|(w&258048)>>>12,p[d++]=128|(w&4032)>>>6,p[d++]=128|(w&63)>>>0),d>=y.BLOCK_SIZE&&(this.y(),d-=y.BLOCK_SIZE,this.t+=y.BLOCK_SIZE,p[0]=p[y.BLOCK_SIZE+0],p[1]=p[y.BLOCK_SIZE+1],p[2]=p[y.BLOCK_SIZE+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,y.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=m.g,d=this.q;for(let k=0;k<64;k+=4)p.setUint32(k,d.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)p.setUint32(k,$(p.getUint32(k-12,!1)^p.getUint32(k-32,!1)^p.getUint32(k-56,!1)^p.getUint32(k-64,!1),1),!1);let w=this.h,o=this.l,l=this.m,n=this.n,u=this.o,i,f,h;for(let k=0;k<80;k++)k<20?(i=o&l|~o&n,f=1518500249):k<40?(i=o^l^n,f=1859775393):k<60?(i=o&l|o&n|l&n,f=2400959708):(i=o^l^n,f=3395469782),h=$(w,5)+i+u+f+p.getUint32(k*4,!1)&4294967295,u=n,n=l,l=$(o,30),o=w,w=h;this.h=this.h+w&4294967295,this.l=this.l+o&4294967295,this.m=this.m+l&4294967295,this.n=this.n+n&4294967295,this.o=this.o+u&4294967295}}e.$Ej=m}),define(Te[177],Oe([1,0,176,16,83]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=v,e.$4k=S,e.$5k=$,e.$6k=g,e.$7k=c,e.$8k=m;const P="$(",D=new RegExp(`\\$\\(${E.ThemeIcon.iconNameExpression}(?:${E.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${D.source}`,"g");function v(b){return b.replace(T,(p,d)=>d?p:`\\${p}`)}const s=new RegExp(`\\\\${D.source}`,"g");function S(b){return b.replace(s,p=>`\\${p}`)}const y=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function $(b){return b.indexOf(P)===-1?b:b.replace(y,(p,d,w,o)=>w?p:d||o||"")}function g(b){return b?b.replace(/\$\((.*?)\)/g,(p,d)=>` ${d} `).trim():""}const a=new RegExp(`\\$\\(${E.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(b){a.lastIndex=0;let p="";const d=[];let w=0;for(;;){const o=a.lastIndex,l=a.exec(b),n=b.substring(o,l?.index);if(n.length>0){p+=n;for(let u=0;u<n.length;u++)d.push(w)}if(!l)break;w+=l[0].length}return{text:p,iconOffsets:d}}function m(b,p,d=!1){const{text:w,iconOffsets:o}=p;if(!o||o.length===0)return(0,t.$Tk)(b,w,d);const l=(0,r.$rf)(w," "),n=w.length-l.length,u=(0,t.$Tk)(b,l,d);if(u)for(const i of u){const f=o[i.start+n]+n;i.start+=f,i.end+=f}return u}}),define(Te[58],Oe([1,0,16]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),t=Ve(t);var r;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(r||(r={})),function(E){const P="error",D="warning",T="warn",v="info",s="ignore";function S($){return $?t.$Kf(P,$)?E.Error:t.$Kf(D,$)||t.$Kf(T,$)?E.Warning:t.$Kf(v,$)?E.Info:E.Ignore:E.Ignore}E.fromValue=S;function y($){switch($){case E.Error:return P;case E.Warning:return D;case E.Info:return v;default:return s}}E.toString=y}(r||(r={})),e.default=r}),define(Te[67],Oe([1,0,17,34,16]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class P{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const c=a.charCodeAt(0),m=this.b.charCodeAt(this.c);return c-m}value(){return this.b[this.c]}}e.$Mi=P;class D{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,E.$Ef)(a,this.b,0,a.length,this.c,this.d):(0,E.$Gf)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ni=D;class T{constructor(a=!0,c=!0){this.f=a,this.g=c}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let c=a.length-1;c>=0;c--,this.c--){const m=this.b.charCodeAt(c);if(!(m===r.CharCode.Slash||this.f&&m===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===r.CharCode.Slash||this.f&&c===r.CharCode.Backslash)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,E.$Ef)(a,this.b,0,a.length,this.d,this.e):(0,E.$Gf)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Oi=T;var v;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(v||(v={}));class s{constructor(a,c){this.f=a,this.g=c,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(v.Scheme),this.c.authority&&this.d.push(v.Authority),this.c.path&&(this.b=new T(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(v.Path)),this.g(a)||(this.c.query&&this.d.push(v.Query),this.c.fragment&&this.d.push(v.Fragment)),this.e=0,this}next(){return this.d[this.e]===v.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===v.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===v.Scheme)return(0,E.$Ff)(a,this.c.scheme);if(this.d[this.e]===v.Authority)return(0,E.$Ff)(a,this.c.authority);if(this.d[this.e]===v.Path)return this.b.cmp(a);if(this.d[this.e]===v.Query)return(0,E.$Df)(a,this.c.query);if(this.d[this.e]===v.Fragment)return(0,E.$Df)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===v.Scheme)return this.c.scheme;if(this.d[this.e]===v.Authority)return this.c.authority;if(this.d[this.e]===v.Path)return this.b.value();if(this.d[this.e]===v.Query)return this.c.query;if(this.d[this.e]===v.Fragment)return this.c.fragment;throw new Error}}e.$Pi=s;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(y||(y={}));class ${static forUris(a=()=>!1,c=()=>!1){return new $(new s(a,c))}static forPaths(a=!1){return new $(new T(void 0,!a))}static forStrings(){return new $(new P)}static forConfigKeys(){return new $(new D)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,c){if(c){const m=c.slice(0);(0,t.$1b)(m);for(const b of m)this.set(b,a)}else{const m=a.slice(0);(0,t.$1b)(m);for(const b of m)this.set(b[0],b[1])}}set(a,c){const m=this.b.reset(a);let b;this.c||(this.c=new S,this.c.segment=m.value());const p=[];for(b=this.c;;){const w=m.cmp(b.segment);if(w>0)b.left||(b.left=new S,b.left.segment=m.value()),p.push([y.Left,b]),b=b.left;else if(w<0)b.right||(b.right=new S,b.right.segment=m.value()),p.push([y.Right,b]),b=b.right;else if(m.hasNext())m.next(),b.mid||(b.mid=new S,b.mid.segment=m.value()),p.push([y.Mid,b]),b=b.mid;else break}const d=b.value;b.value=c,b.key=a;for(let w=p.length-1;w>=0;w--){const o=p[w][1];o.updateHeight();const l=o.balanceFactor();if(l<-1||l>1){const n=p[w][0],u=p[w+1][0];if(n===y.Right&&u===y.Right)p[w][1]=o.rotateLeft();else if(n===y.Left&&u===y.Left)p[w][1]=o.rotateRight();else if(n===y.Right&&u===y.Left)o.right=p[w+1][1]=p[w+1][1].rotateRight(),p[w][1]=o.rotateLeft();else if(n===y.Left&&u===y.Right)o.left=p[w+1][1]=p[w+1][1].rotateLeft(),p[w][1]=o.rotateRight();else throw new Error;if(w>0)switch(p[w-1][0]){case y.Left:p[w-1][1].left=p[w][1];break;case y.Right:p[w-1][1].right=p[w][1];break;case y.Mid:p[w-1][1].mid=p[w][1];break}else this.c=p[0][1]}}return d}get(a){return this.d(a)?.value}d(a){const c=this.b.reset(a);let m=this.c;for(;m;){const b=c.cmp(m.segment);if(b>0)m=m.left;else if(b<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else break}return m}has(a){const c=this.d(a);return!(c?.value===void 0&&c?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,c){const m=this.b.reset(a),b=[];let p=this.c;for(;p;){const d=m.cmp(p.segment);if(d>0)b.push([y.Left,p]),p=p.left;else if(d<0)b.push([y.Right,p]),p=p.right;else if(m.hasNext())m.next(),b.push([y.Mid,p]),p=p.mid;else break}if(p){if(c?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const d=this.f(p.right);if(d.key){const{key:w,value:o,segment:l}=d;this.e(d.key,!1),p.key=w,p.value=o,p.segment=l}}else{const d=p.left??p.right;if(b.length>0){const[w,o]=b[b.length-1];switch(w){case y.Left:o.left=d;break;case y.Mid:o.mid=d;break;case y.Right:o.right=d;break}}else this.c=d}for(let d=b.length-1;d>=0;d--){const w=b[d][1];w.updateHeight();const o=w.balanceFactor();if(o>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),b[d][1]=w.rotateLeft()):o<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),b[d][1]=w.rotateRight()),d>0)switch(b[d-1][0]){case y.Left:b[d-1][1].left=b[d][1];break;case y.Right:b[d-1][1].right=b[d][1];break;case y.Mid:b[d-1][1].mid=b[d][1];break}else this.c=b[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const c=this.b.reset(a);let m=this.c,b;for(;m;){const p=c.cmp(m.segment);if(p>0)m=m.left;else if(p<0)m=m.right;else if(c.hasNext())c.next(),b=m.value||b,m=m.mid;else break}return m&&m.value||b}findSuperstr(a){return this.g(a,!1)}g(a,c){const m=this.b.reset(a);let b=this.c;for(;b;){const p=m.cmp(b.segment);if(p>0)b=b.left;else if(p<0)b=b.right;else if(m.hasNext())m.next(),b=b.mid;else return b.mid?this.h(b.mid):c?b.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[c,m]of this)a(m,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const c=[];return this.j(a,c),c[Symbol.iterator]()}j(a,c){a&&(a.left&&this.j(a.left,c),a.value&&c.push([a.key,a.value]),a.mid&&this.j(a.mid,c),a.right&&this.j(a.right,c))}_isBalanced(){const a=c=>{if(!c)return!0;const m=c.balanceFactor();return m<-1||m>1?!1:a(c.left)&&a(c.right)};return a(this.c)}}e.$Qi=$}),define(Te[22],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=void 0,e.$6g=r;const t=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(E){return t.test(E)}e.$7g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(T){for(let v=0;v<T.length;v++)T[v]=Math.floor(Math.random()*256);return T};const P=new Uint8Array(16),D=[];for(let T=0;T<256;T++)D.push(T.toString(16).padStart(2,"0"));return function(){E(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let v=0,s="";return s+=D[P[v++]],s+=D[P[v++]],s+=D[P[v++]],s+=D[P[v++]],s+="-",s+=D[P[v++]],s+=D[P[v++]],s+="-",s+=D[P[v++]],s+=D[P[v++]],s+="-",s+=D[P[v++]],s+=D[P[v++]],s+="-",s+=D[P[v++]],s+=D[P[v++]],s+=D[P[v++]],s+=D[P[v++]],s+=D[P[v++]],s+=D[P[v++]],s}}()}),define(Te[178],Oe([1,0,17,39,22]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bu=e.$zu=void 0,e.$xu=P,e.$yu=D,e.$Au=s;function P(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function D(y,$,g){const a={id:(0,E.$7g)(),name:y,uri:$,data:g};return{asString:async()=>"",asFile:()=>a,value:void 0}}class T{constructor(){this.a=new Map}get size(){let $=0;for(const g of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const g=[...this.a.keys()];return r.Iterable.some(this,([a,c])=>c.asFile())&&g.push("files"),S(v($),g)}get($){return this.a.get(this.b($))?.[0]}append($,g){const a=this.a.get($);a?a.push(g):this.a.set(this.b($),[g])}replace($,g){this.a.set(this.b($),[g])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,g]of this.a)for(const a of g)yield[$,a]}b($){return v($)}}e.$zu=T;function v(y){return y.toLowerCase()}function s(y,$){return S(v(y),$.map(v))}function S(y,$){if(y==="*/*")return $.length>0;if($.includes(y))return!0;const g=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!g)return!1;const[a,c,m]=g;return m==="*"?$.some(b=>b.startsWith(c+"/")):!1}e.$Bu=Object.freeze({create:y=>(0,t.$Qb)(y.map($=>$.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$Bu.split(y).filter($=>!$.startsWith("#"))})}),define(Te[179],Oe([1,0,31]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=P;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function E(D){const T=D.replace(/\-/g,":").toLowerCase();return!r.has(T)}function P(){const D=(0,t.networkInterfaces)();for(const T in D){const v=D[T];if(v){for(const{mac:s}of v)if(E(s))return s}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),function(){function ue(e,t,r){async function E(S){try{return await t.promises.access(S),!0}catch{return!1}}function P(S){const y=new Date;return t.promises.utimes(S,y,y)}async function D(S){const y=e.join(S,"languagepacks.json");try{return JSON.parse(await t.promises.readFile(y,"utf-8"))}catch{return}}function T(S,y){try{for(;y;){if(S[y])return y;const $=y.lastIndexOf("-");if($>0)y=y.substring(0,$);else return}}catch($){console.error("Resolving language pack configuration failed.",$)}}function v(S,y,$){return r.mark("code/didGenerateNls"),{userLocale:S,osLocale:y,resolvedLanguage:"en",defaultMessagesFile:e.join($,"nls.messages.json"),locale:S,availableLanguages:{}}}async function s({userLocale:S,osLocale:y,userDataPath:$,commit:g,nlsMetadataPath:a}){if(r.mark("code/willGenerateNls"),process.env.VSCODE_DEV||S==="pseudo"||S.startsWith("en")||!g||!$)return v(S,y,a);try{const c=await D($);if(!c)return v(S,y,a);const m=T(c,S);if(!m)return v(S,y,a);const b=c[m],p=b?.translations?.vscode;if(!b||typeof b.hash!="string"||!b.translations||typeof p!="string"||!await E(p))return v(S,y,a);const d=`${b.hash}.${m}`,w=e.join($,"clp",d),o=e.join(w,g),l=e.join(o,"nls.messages.json"),n=e.join(w,"tcf.json"),u=e.join(w,"corrupted.info");await E(u)&&await t.promises.rm(w,{recursive:!0,force:!0,maxRetries:3});const i={userLocale:S,osLocale:y,resolvedLanguage:m,defaultMessagesFile:e.join(a,"nls.messages.json"),languagePack:{translationsConfigFile:n,messagesFile:l,corruptMarkerFile:u},locale:S,availableLanguages:{"*":m},_languagePackId:d,_languagePackSupport:!0,_translationsConfigFile:n,_cacheRoot:w,_resolvedLanguagePackCoreLocation:o,_corruptedFile:u};if(await E(o))return P(o).catch(()=>{}),r.mark("code/didGenerateNls"),i;const[,f,h,k]=await Promise.all([t.promises.mkdir(o,{recursive:!0}),JSON.parse(await t.promises.readFile(e.join(a,"nls.keys.json"),"utf-8")),JSON.parse(await t.promises.readFile(e.join(a,"nls.messages.json"),"utf-8")),JSON.parse(await t.promises.readFile(p,"utf-8"))]),I=[];let O=0;for(const[C,L]of f){const R=k.contents[C];for(const M of L)I.push(R?.[M]||h[O]),O++}return await Promise.all([t.promises.writeFile(l,JSON.stringify(I),"utf-8"),t.promises.writeFile(n,JSON.stringify(b.translations),"utf-8")]),r.mark("code/didGenerateNls"),i}catch(c){console.error("Generating translation files failed.",c)}return v(S,y,a)}return{resolveNLSConfiguration:s}}if(typeof define=="function")define(Te[180],Oe([68,23,44]),function(e,t,r){return ue(e,t,r)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),t=require("fs"),r=require("../common/performance");module.exports=ue(e,t,r)}else throw new Error("vs/base/node/nls defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(Te[181],Oe([1,0,84]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=void 0,e.$9g=r,e.$$g=P,t=Ve(t);function r(T,v,s,S=1){let y=!1;return new Promise($=>{const g=setTimeout(()=>{if(!y)return y=!0,$(0)},s);E(T,v,S,a=>{if(!y)return y=!0,clearTimeout(g),$(a)})})}function E(T,v,s,S){if(v===0)return S(0);const y=new t.Socket;y.once("connect",()=>(D(y),E(T+s,v-1,s,S))),y.once("data",()=>{}),y.once("error",$=>(D(y),$.code!=="ECONNREFUSED"?E(T+s,v-1,s,S):S(T))),y.connect(T,"127.0.0.1")}e.$0g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(T,v,s,S="127.0.0.1"){let y=!1,$,g=1;const a=t.createServer({pauseOnConnect:!0});function c(m,b){y||(y=!0,a.removeAllListeners(),a.close(),$&&clearTimeout($),b(m))}return new Promise(m=>{$=setTimeout(()=>{c(0,m)},s),a.on("listening",()=>{c(T,m)}),a.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&g<v?(T++,g++,a.listen(T,S)):c(0,m)}),a.on("close",()=>{c(0,m)}),a.listen(T,S)})}function D(T){try{T.removeAllListeners("connect"),T.removeAllListeners("error"),T.end(),T.destroy(),T.unref()}catch(v){console.error(v)}}}),function(){function ue(){function e(){return process.uncHostAllowlist}function t(v){const s=new Set;if(Array.isArray(v))for(const S of v)typeof S=="string"&&s.add(S);return Array.from(s)}function r(){const v=e();return v?Array.from(v):[]}function E(v){if(process.platform!=="win32")return;const s=e();if(s)if(typeof v=="string")s.add(v.toLowerCase());else for(const S of t(v))E(S)}function P(v){if(typeof v!="string")return;const s=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let S;for(const y of s){if(v.indexOf(y)!==0)continue;const g=v.indexOf("\\",y.length);if(g===-1)continue;const a=v.substring(y.length,g);if(a){S=a;break}}return S}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function T(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:E,getUNCHost:P,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:T}}typeof define=="function"?define("vs/base/node/unc",[],function(){return ue()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=ue():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(Te[182],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0,e.$cp=r;const t="Offline";function r(P){return P instanceof E?!0:P instanceof Error&&P.name===t&&P.message===t}class E extends Error{constructor(){super(t),this.name=this.message}}e.$dp=E}),define(Te[85],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=void 0;class t{constructor(E,P){this.lineNumber=E,this.column=P}with(E=this.lineNumber,P=this.column){return E===this.lineNumber&&P===this.column?this:new t(E,P)}delta(E=0,P=0){return this.with(this.lineNumber+E,this.column+P)}equals(E){return t.equals(this,E)}static equals(E,P){return!E&&!P?!0:!!E&&!!P&&E.lineNumber===P.lineNumber&&E.column===P.column}isBefore(E){return t.isBefore(this,E)}static isBefore(E,P){return E.lineNumber<P.lineNumber?!0:P.lineNumber<E.lineNumber?!1:E.column<P.column}isBeforeOrEqual(E){return t.isBeforeOrEqual(this,E)}static isBeforeOrEqual(E,P){return E.lineNumber<P.lineNumber?!0:P.lineNumber<E.lineNumber?!1:E.column<=P.column}static compare(E,P){const D=E.lineNumber|0,T=P.lineNumber|0;if(D===T){const v=E.column|0,s=P.column|0;return v-s}return D-T}clone(){return new t(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(E){return new t(E.lineNumber,E.column)}static isIPosition(E){return E&&typeof E.lineNumber=="number"&&typeof E.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Vt=t}),define(Te[48],Oe([1,0,85]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wt=void 0;class r{constructor(P,D,T,v){P>T||P===T&&D>v?(this.startLineNumber=T,this.startColumn=v,this.endLineNumber=P,this.endColumn=D):(this.startLineNumber=P,this.startColumn=D,this.endLineNumber=T,this.endColumn=v)}isEmpty(){return r.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return r.containsPosition(this,P)}static containsPosition(P,D){return!(D.lineNumber<P.startLineNumber||D.lineNumber>P.endLineNumber||D.lineNumber===P.startLineNumber&&D.column<P.startColumn||D.lineNumber===P.endLineNumber&&D.column>P.endColumn)}static strictContainsPosition(P,D){return!(D.lineNumber<P.startLineNumber||D.lineNumber>P.endLineNumber||D.lineNumber===P.startLineNumber&&D.column<=P.startColumn||D.lineNumber===P.endLineNumber&&D.column>=P.endColumn)}containsRange(P){return r.containsRange(this,P)}static containsRange(P,D){return!(D.startLineNumber<P.startLineNumber||D.endLineNumber<P.startLineNumber||D.startLineNumber>P.endLineNumber||D.endLineNumber>P.endLineNumber||D.startLineNumber===P.startLineNumber&&D.startColumn<P.startColumn||D.endLineNumber===P.endLineNumber&&D.endColumn>P.endColumn)}strictContainsRange(P){return r.strictContainsRange(this,P)}static strictContainsRange(P,D){return!(D.startLineNumber<P.startLineNumber||D.endLineNumber<P.startLineNumber||D.startLineNumber>P.endLineNumber||D.endLineNumber>P.endLineNumber||D.startLineNumber===P.startLineNumber&&D.startColumn<=P.startColumn||D.endLineNumber===P.endLineNumber&&D.endColumn>=P.endColumn)}plusRange(P){return r.plusRange(this,P)}static plusRange(P,D){let T,v,s,S;return D.startLineNumber<P.startLineNumber?(T=D.startLineNumber,v=D.startColumn):D.startLineNumber===P.startLineNumber?(T=D.startLineNumber,v=Math.min(D.startColumn,P.startColumn)):(T=P.startLineNumber,v=P.startColumn),D.endLineNumber>P.endLineNumber?(s=D.endLineNumber,S=D.endColumn):D.endLineNumber===P.endLineNumber?(s=D.endLineNumber,S=Math.max(D.endColumn,P.endColumn)):(s=P.endLineNumber,S=P.endColumn),new r(T,v,s,S)}intersectRanges(P){return r.intersectRanges(this,P)}static intersectRanges(P,D){let T=P.startLineNumber,v=P.startColumn,s=P.endLineNumber,S=P.endColumn;const y=D.startLineNumber,$=D.startColumn,g=D.endLineNumber,a=D.endColumn;return T<y?(T=y,v=$):T===y&&(v=Math.max(v,$)),s>g?(s=g,S=a):s===g&&(S=Math.min(S,a)),T>s||T===s&&v>S?null:new r(T,v,s,S)}equalsRange(P){return r.equalsRange(this,P)}static equalsRange(P,D){return!P&&!D?!0:!!P&&!!D&&P.startLineNumber===D.startLineNumber&&P.startColumn===D.startColumn&&P.endLineNumber===D.endLineNumber&&P.endColumn===D.endColumn}getEndPosition(){return r.getEndPosition(this)}static getEndPosition(P){return new t.$Vt(P.endLineNumber,P.endColumn)}getStartPosition(){return r.getStartPosition(this)}static getStartPosition(P){return new t.$Vt(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,D){return new r(this.startLineNumber,this.startColumn,P,D)}setStartPosition(P,D){return new r(P,D,this.endLineNumber,this.endColumn)}collapseToStart(){return r.collapseToStart(this)}static collapseToStart(P){return new r(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return r.collapseToEnd(this)}static collapseToEnd(P){return new r(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new r(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,D=P){return new r(P.lineNumber,P.column,D.lineNumber,D.column)}static lift(P){return P?new r(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,D){return!(P.endLineNumber<D.startLineNumber||P.endLineNumber===D.startLineNumber&&P.endColumn<D.startColumn||D.endLineNumber<P.startLineNumber||D.endLineNumber===P.startLineNumber&&D.endColumn<P.startColumn)}static areIntersecting(P,D){return!(P.endLineNumber<D.startLineNumber||P.endLineNumber===D.startLineNumber&&P.endColumn<=D.startColumn||D.endLineNumber<P.startLineNumber||D.endLineNumber===P.startLineNumber&&D.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,D){if(P&&D){const s=P.startLineNumber|0,S=D.startLineNumber|0;if(s===S){const y=P.startColumn|0,$=D.startColumn|0;if(y===$){const g=P.endLineNumber|0,a=D.endLineNumber|0;if(g===a){const c=P.endColumn|0,m=D.endColumn|0;return c-m}return g-a}return y-$}return s-S}return(P?1:0)-(D?1:0)}static compareRangesUsingEnds(P,D){return P.endLineNumber===D.endLineNumber?P.endColumn===D.endColumn?P.startLineNumber===D.startLineNumber?P.startColumn-D.startColumn:P.startLineNumber-D.startLineNumber:P.endColumn-D.endColumn:P.endLineNumber-D.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$Wt=r}),define(Te[183],Oe([1,0,48]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=void 0;class r{static insert(P,D){return{range:new t.$Wt(P.lineNumber,P.column,P.lineNumber,P.column),text:D,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,D){return{range:P,text:D}}static replaceMove(P,D){return{range:P,text:D,forceMoveMarkers:!0}}}e.$Xt=r}),define(Te[184],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0,e.$tt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Te[185],Oe([1,0,39,2,81]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=e.$ut=void 0,e.$wt=D,e.$xt=v,e.$yt=s,e.$ut="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(y=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const g of e.$ut)y.indexOf(g)>=0||($+="\\"+g);return $+="\\s]+)",new RegExp($,"g")}e.$vt=P();function D(y){let $=e.$vt;if(y&&y instanceof RegExp)if(y.global)$=y;else{let g="g";y.ignoreCase&&(g+="i"),y.multiline&&(g+="m"),y.unicode&&(g+="u"),$=new RegExp(y.source,g)}return $.lastIndex=0,$}const T=new E.$0c;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(y){const $=T.unshift(y);return(0,r.$Xc)($)}function s(y,$,g,a,c){if($=D($),c||(c=t.Iterable.first(T)),g.length>c.maxLen){let w=y-c.maxLen/2;return w<0?w=0:a+=w,g=g.substring(w,y+c.maxLen/2),s(y,$,g,a,c)}const m=Date.now(),b=y-1-a;let p=-1,d=null;for(let w=1;!(Date.now()-m>=c.timeBudget);w++){const o=b-c.windowSize*w;$.lastIndex=Math.max(0,o);const l=S($,g,b,p);if(!l&&d||(d=l,o<=0))break;p=o}if(d){const w={word:d[0],startColumn:a+1+d.index,endColumn:a+1+d.index+d[0].length};return $.lastIndex=0,w}return null}function S(y,$,g,a){let c;for(;c=y.exec($);){const m=c.index||0;if(m<=g&&y.lastIndex>=g)return c;if(a>0&&m>a)return null}return null}}),define(Te[109],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Du=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var t;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(t||(e.LanguageId=t={}));var r;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline",v[v.Strikethrough=8]="Strikethrough"})(r||(e.FontStyle=r={}));var E;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(E||(e.ColorId=E={}));var P;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=3]="RegEx"})(P||(e.StandardTokenType=P={}));var D;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",v[v.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",v[v.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",v[v.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(D||(e.MetadataConsts=D={}));class T{static getLanguageId(s){return(s&D.LANGUAGEID_MASK)>>>D.LANGUAGEID_OFFSET}static getTokenType(s){return(s&D.TOKEN_TYPE_MASK)>>>D.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(s){return(s&D.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(s){return(s&D.FONT_STYLE_MASK)>>>D.FONT_STYLE_OFFSET}static getForeground(s){return(s&D.FOREGROUND_MASK)>>>D.FOREGROUND_OFFSET}static getBackground(s){return(s&D.BACKGROUND_MASK)>>>D.BACKGROUND_OFFSET}static getClassNameFromMetadata(s){let y="mtk"+this.getForeground(s);const $=this.getFontStyle(s);return $&r.Italic&&(y+=" mtki"),$&r.Bold&&(y+=" mtkb"),$&r.Underline&&(y+=" mtku"),$&r.Strikethrough&&(y+=" mtks"),y}static getInlineStyleFromMetadata(s,S){const y=this.getForeground(s),$=this.getFontStyle(s);let g=`color: ${S[y]};`;$&r.Italic&&(g+="font-style: italic;"),$&r.Bold&&(g+="font-weight: bold;");let a="";return $&r.Underline&&(a+=" underline"),$&r.Strikethrough&&(a+=" line-through"),a&&(g+=`text-decoration:${a};`),g}static getPresentationFromMetadata(s){const S=this.getForeground(s),y=this.getFontStyle(s);return{foreground:S,italic:!!(y&r.Italic),bold:!!(y&r.Bold),underline:!!(y&r.Underline),strikethrough:!!(y&r.Strikethrough)}}}e.$Du=T}),define(Te[186],Oe([1,0,20]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rw=e.$qw=e.$pw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$nw=e.$mw=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$ow=a,e.$sw=w;var r;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(r||(e.OverviewRulerLane=r={}));var E;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=3]="Right"})(E||(e.GlyphMarginLane=E={}));var P;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(P||(e.MinimapPosition=P={}));var D;(function(o){o[o.Normal=1]="Normal",o[o.Underlined=2]="Underlined"})(D||(e.MinimapSectionHeaderStyle=D={}));var T;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(T||(e.InjectedTextCursorStops=T={}));var v;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var s;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(s||(e.DefaultEndOfLine=s={}));var S;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(S||(e.EndOfLineSequence=S={}));class y{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,l.indentSize|0),this.a=!1),this.insertSpaces=!!l.insertSpaces,this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=!!l.trimAutoWhitespace,this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.a===l.a&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,t.$oo)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.$mw=y;class ${constructor(l,n){this._findMatchBrand=void 0,this.range=l,this.matches=n}}e.$nw=$;var g;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(g||(e.TrackedRangeStickiness=g={}));function a(o){return o&&typeof o.read=="function"}var c;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(c||(e.PositionAffinity=c={}));var m;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class b{constructor(l,n,u,i,f,h){this.identifier=l,this.range=n,this.text=u,this.forceMoveMarkers=i,this.isAutoWhitespaceEdit=f,this._isTracked=h}}e.$pw=b;class p{constructor(l,n,u){this.regex=l,this.wordSeparators=n,this.simpleSearch=u}}e.$qw=p;class d{constructor(l,n,u){this.reverseEdits=l,this.changes=n,this.trimAutoWhitespaceLineNumbers=u}}e.$rw=d;function w(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}}),define(Te[187],Oe([1,0,6,2,109]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gu=void 0;class P{constructor(){this.a=new Map,this.b=new Map,this.c=new t.$qe,this.onDidChange=this.c.event,this.d=null}handleChange(v){this.c.fire({changedLanguages:v,changedColorMap:!1})}register(v,s){return this.a.set(v,s),this.handleChange([v]),(0,r.$Xc)(()=>{this.a.get(v)===s&&(this.a.delete(v),this.handleChange([v]))})}get(v){return this.a.get(v)||null}registerFactory(v,s){this.b.get(v)?.dispose();const S=new D(this,v,s);return this.b.set(v,S),(0,r.$Xc)(()=>{const y=this.b.get(v);!y||y!==S||(this.b.delete(v),y.dispose())})}async getOrCreate(v){const s=this.get(v);if(s)return s;const S=this.b.get(v);return!S||S.isResolved?null:(await S.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const S=this.b.get(v);return!!(!S||S.isResolved)}setColorMap(v){this.d=v,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>E.ColorId.DefaultBackground?this.d[E.ColorId.DefaultBackground]:null}}e.$Gu=P;class D extends r.$Zc{get isResolved(){return this.c}constructor(v,s,S){super(),this.f=v,this.g=s,this.h=S,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const v=await this.h.tokenizationSupport;this.c=!0,v&&!this.a&&this.B(this.f.register(this.g,v))}}}),define(Te[110],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a=t,e.$b=r;function t(){return globalThis._VSCODE_NLS_MESSAGES}function r(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(Te[7],Oe([1,0,110,110]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=D,e.localize2=v,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return r.$b}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return r.$a}});const E=(0,t.$b)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function P(s,S){let y;return S.length===0?y=s:y=s.replace(/\{(\d+)\}/g,($,g)=>{const a=g[0],c=S[a];let m=$;return typeof c=="string"?m=c:(typeof c=="number"||typeof c=="boolean"||c===void 0||c===null)&&(m=String(c)),m}),E&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function D(s,S,...y){return P(typeof s=="number"?T(s,S):S,y)}function T(s,S){const y=(0,t.$a)()?.[s];if(typeof y!="string"){if(typeof S=="string")return S;throw new Error(`!!! NLS MISSING: ${s} !!!`)}return y}function v(s,S,...y){let $;typeof s=="number"?$=T(s,S):$=S;const g=P($,y);return{value:g,original:S===$?g:P(S,y)}}}),define(Te[188],Oe([1,0,6,2,7]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0,e.$uj=S,E=Ve(E);class P extends r.$Zc{constructor($,g="",a="",c=!0,m){super(),this.j=this.B(new t.$qe),this.onDidChange=this.j.event,this.z=!0,this.m=$,this.n=g,this.w=a,this.z=c,this.D=m}get id(){return this.m}get label(){return this.n}set label($){this.F($)}F($){this.n!==$&&(this.n=$,this.j.fire({label:$}))}get tooltip(){return this.u||""}set tooltip($){this.G($)}G($){this.u!==$&&(this.u=$,this.j.fire({tooltip:$}))}get class(){return this.w}set class($){this.H($)}H($){this.w!==$&&(this.w=$,this.j.fire({class:$}))}get enabled(){return this.z}set enabled($){this.I($)}I($){this.z!==$&&(this.z=$,this.j.fire({enabled:$}))}get checked(){return this.C}set checked($){this.J($)}J($){this.C!==$&&(this.C=$,this.j.fire({checked:$}))}async run($,g){this.D&&await this.D($)}}e.$pj=P;class D extends r.$Zc{constructor(){super(...arguments),this.f=this.B(new t.$qe),this.onWillRun=this.f.event,this.m=this.B(new t.$qe),this.onDidRun=this.m.event}async run($,g){if(!$.enabled)return;this.f.fire({action:$});let a;try{await this.u($,g)}catch(c){a=c}this.m.fire({action:$,error:a})}async u($,g){await $.run(g)}}e.$qj=D;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let g=[];for(const a of $)a.length&&(g.length?g=[...g,new T,...a]:g=a);return g}static{this.ID="vs.actions.separator"}async run(){}}e.$rj=T;class v{get actions(){return this.a}constructor($,g,a,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=g,this.class=c,this.a=a}async run(){}}e.$sj=v;class s extends P{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,E.localize(41,null),void 0,!1)}}e.$tj=s;function S(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...$)=>y.run(...$)}}}),define(Te[189],Oe([1,0,7]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=s,e.$8m=S,e.$9m=y,e.$0m=$;const r=60,E=r*60,P=E*24,D=P*7,T=P*30,v=P*365;function s(g,a,c,m){typeof g!="number"&&(g=g.getTime());const b=Math.round((new Date().getTime()-g)/1e3);if(b<-30)return(0,t.localize)(42,null,s(new Date().getTime()+b*1e3,!1));if(!m&&b<30)return(0,t.localize)(43,null);let p;return b<r?(p=b,a?p===1?c?(0,t.localize)(44,null,p):(0,t.localize)(45,null,p):c?(0,t.localize)(46,null,p):(0,t.localize)(47,null,p):p===1?c?(0,t.localize)(48,null,p):(0,t.localize)(49,null,p):c?(0,t.localize)(50,null,p):(0,t.localize)(51,null,p)):b<E?(p=Math.floor(b/r),a?p===1?c?(0,t.localize)(52,null,p):(0,t.localize)(53,null,p):c?(0,t.localize)(54,null,p):(0,t.localize)(55,null,p):p===1?c?(0,t.localize)(56,null,p):(0,t.localize)(57,null,p):c?(0,t.localize)(58,null,p):(0,t.localize)(59,null,p)):b<P?(p=Math.floor(b/E),a?p===1?c?(0,t.localize)(60,null,p):(0,t.localize)(61,null,p):c?(0,t.localize)(62,null,p):(0,t.localize)(63,null,p):p===1?c?(0,t.localize)(64,null,p):(0,t.localize)(65,null,p):c?(0,t.localize)(66,null,p):(0,t.localize)(67,null,p)):b<D?(p=Math.floor(b/P),a?p===1?(0,t.localize)(68,null,p):(0,t.localize)(69,null,p):p===1?(0,t.localize)(70,null,p):(0,t.localize)(71,null,p)):b<T?(p=Math.floor(b/D),a?p===1?c?(0,t.localize)(72,null,p):(0,t.localize)(73,null,p):c?(0,t.localize)(74,null,p):(0,t.localize)(75,null,p):p===1?c?(0,t.localize)(76,null,p):(0,t.localize)(77,null,p):c?(0,t.localize)(78,null,p):(0,t.localize)(79,null,p)):b<v?(p=Math.floor(b/T),a?p===1?c?(0,t.localize)(80,null,p):(0,t.localize)(81,null,p):c?(0,t.localize)(82,null,p):(0,t.localize)(83,null,p):p===1?c?(0,t.localize)(84,null,p):(0,t.localize)(85,null,p):c?(0,t.localize)(86,null,p):(0,t.localize)(87,null,p)):(p=Math.floor(b/v),a?p===1?c?(0,t.localize)(88,null,p):(0,t.localize)(89,null,p):c?(0,t.localize)(90,null,p):(0,t.localize)(91,null,p):p===1?c?(0,t.localize)(92,null,p):(0,t.localize)(93,null,p):c?(0,t.localize)(94,null,p):(0,t.localize)(95,null,p))}function S(g,a,c){typeof g!="number"&&(g=g.getTime());const m=new Date;m.setHours(0,0,0,0);const b=new Date(m.getTime());return b.setDate(b.getDate()-1),g>m.getTime()?(0,t.localize)(96,null):g>b.getTime()?(0,t.localize)(97,null):s(g,a,c)}function y(g,a){const c=Math.abs(g/1e3);return c<1?a?(0,t.localize)(98,null,g):(0,t.localize)(99,null,g):c<r?a?(0,t.localize)(100,null,Math.round(g)/1e3):(0,t.localize)(101,null,Math.round(g)/1e3):c<E?a?(0,t.localize)(102,null,Math.round(g/(1e3*r))):(0,t.localize)(103,null,Math.round(g/(1e3*r))):c<P?a?(0,t.localize)(104,null,Math.round(g/(1e3*E))):(0,t.localize)(105,null,Math.round(g/(1e3*E))):(0,t.localize)(106,null,Math.round(g/(1e3*P)))}function $(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Te[45],Oe([1,0,17,10,7]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=v,e.$wj=s,e.$xj=S,t=Ve(t),r=Ve(r),E=Ve(E);function P(y,$){return $&&(y.stack||y.stacktrace)?E.localize(107,null,T(y),D(y.stack)||D(y.stacktrace)):T(y)}function D(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?E.localize(108,null,y.message):y.message||E.localize(109,null)}function v(y=null,$=!1){if(!y)return E.localize(110,null);if(Array.isArray(y)){const g=t.$Lb(y),a=v(g[0],$);return g.length>1?E.localize(111,null,a,g.length):a}if(r.$jg(y))return y;if(y.detail){const g=y.detail;if(g.error)return P(g.error,$);if(g.exception)return P(g.exception,$)}return y.stack?P(y,$):y.message?y.message:E.localize(112,null)}function s(y){const $=y;return $ instanceof Error&&Array.isArray($.actions)}function S(y,$){let g;return typeof y=="string"?g=new Error(y):g=y,g.actions=$,g}}),define(Te[190],Oe([1,0,7,42]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=E;function E(P){switch(P){case r.ParseErrorCode.InvalidSymbol:return(0,t.localize)(113,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,t.localize)(114,null);case r.ParseErrorCode.PropertyNameExpected:return(0,t.localize)(115,null);case r.ParseErrorCode.ValueExpected:return(0,t.localize)(116,null);case r.ParseErrorCode.ColonExpected:return(0,t.localize)(117,null);case r.ParseErrorCode.CommaExpected:return(0,t.localize)(118,null);case r.ParseErrorCode.CloseBraceExpected:return(0,t.localize)(119,null);case r.ParseErrorCode.CloseBracketExpected:return(0,t.localize)(120,null);case r.ParseErrorCode.EndOfFileExpected:return(0,t.localize)(121,null);default:return""}}}),define(Te[3],Oe([1,0,7]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=e.$H=e.OS=e.OperatingSystem=e.$E=e.$D=e.$C=e.$B=e.$A=e.Language=e.$z=e.$y=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.Platform=e.$j=void 0,e.$k=n,e.$G=I,e.$M=O,t=Ve(t),e.$j="en";let r=!1,E=!1,P=!1,D=!1,T=!1,v=!1,s=!1,S=!1,y=!1,$=!1,g,a=e.$j,c=e.$j,m,b;const p=globalThis;let d;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?d=p.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(d=process);const w=typeof d?.versions?.electron=="string",o=w&&d?.type==="renderer";if(typeof d=="object"){r=d.platform==="win32",E=d.platform==="darwin",P=d.platform==="linux",D=P&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,s=w,y=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.$j,a=e.$j;const C=d.env.VSCODE_NLS_CONFIG;if(C)try{const L=JSON.parse(C);g=L.userLocale,c=L.osLocale,a=L.resolvedLanguage||e.$j,m=L.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!o?(b=navigator.userAgent,r=b.indexOf("Windows")>=0,E=b.indexOf("Macintosh")>=0,S=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=b.indexOf("Linux")>=0,$=b?.indexOf("Mobi")>=0,v=!0,a=t.getNLSLanguage()||e.$j,g=navigator.language.toLowerCase(),c=g):console.error("Unable to resolve platform.");var l;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(l||(e.Platform=l={}));function n(C){switch(C){case l.Web:return"Web";case l.Mac:return"Mac";case l.Linux:return"Linux";case l.Windows:return"Windows"}}let u=l.Web;E?u=l.Mac:r?u=l.Windows:P&&(u=l.Linux),e.$l=r,e.$m=E,e.$n=P,e.$o=D,e.$p=T,e.$q=s,e.$r=v,e.$s=v&&typeof p.importScripts=="function",e.$t=e.$s?p.origin:void 0,e.$u=S,e.$v=$,e.$w=y,e.$x=u,e.$y=b,e.$z=a;var i;(function(C){function L(){return e.$z}C.value=L;function R(){return e.$z.length===2?e.$z==="en":e.$z.length>=3?e.$z[0]==="e"&&e.$z[1]==="n"&&e.$z[2]==="-":!1}C.isDefaultVariant=R;function M(){return e.$z==="en"}C.isDefault=M})(i||(e.Language=i={})),e.$A=g,e.$B=c,e.$C=m,e.$D=typeof p.postMessage=="function"&&!p.importScripts,e.$E=(()=>{if(e.$D){const C=[];p.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let M=0,G=C.length;M<G;M++){const Q=C[M];if(Q.id===R.data.vscodeScheduleAsyncWork){C.splice(M,1),Q.callback();return}}});let L=0;return R=>{const M=++L;C.push({id:M,callback:R}),p.postMessage({vscodeScheduleAsyncWork:M},"*")}}return C=>setTimeout(C)})();var f;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(f||(e.OperatingSystem=f={})),e.OS=E||S?f.Macintosh:r?f.Windows:f.Linux;let h=!0,k=!1;function I(){if(!k){k=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,h=new Uint16Array(C.buffer)[0]===513}return h}e.$H=!!(e.$y&&e.$y.indexOf("Chrome")>=0),e.$I=!!(e.$y&&e.$y.indexOf("Firefox")>=0),e.$J=!!(!e.$H&&e.$y&&e.$y.indexOf("Safari")>=0),e.$K=!!(e.$y&&e.$y.indexOf("Edg/")>=0),e.$L=!!(e.$y&&e.$y.indexOf("Android")>=0);function O(C){return parseFloat(C)>=20}}),define(Te[32],Oe([1,0,3]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jc=e.$ic=e.env=e.cwd=void 0;let r;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const P=E.process;r={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return t.$l?"win32":t.$m?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$ic=r.platform,e.$jc=r.arch}),define(Te[8],Oe([1,0,32]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.sep=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=void 0,t=Ve(t);const r=65,E=97,P=90,D=122,T=46,v=47,s=92,S=58,y=63;class $ extends Error{constructor(u,i,f){let h;typeof i=="string"&&i.indexOf("not ")===0?(h="must not be",i=i.replace(/^not /,"")):h="must be";const k=u.indexOf(".")!==-1?"property":"argument";let I=`The "${u}" ${k} ${h} of type ${i}`;I+=`. Received type ${typeof f}`,super(I),this.code="ERR_INVALID_ARG_TYPE"}}function g(n,u){if(n===null||typeof n!="object")throw new $(u,"Object",n)}function a(n,u){if(typeof n!="string")throw new $(u,"string",n)}const c=t.$ic==="win32";function m(n){return n===v||n===s}function b(n){return n===v}function p(n){return n>=r&&n<=P||n>=E&&n<=D}function d(n,u,i,f){let h="",k=0,I=-1,O=0,C=0;for(let L=0;L<=n.length;++L){if(L<n.length)C=n.charCodeAt(L);else{if(f(C))break;C=v}if(f(C)){if(!(I===L-1||O===1))if(O===2){if(h.length<2||k!==2||h.charCodeAt(h.length-1)!==T||h.charCodeAt(h.length-2)!==T){if(h.length>2){const R=h.lastIndexOf(i);R===-1?(h="",k=0):(h=h.slice(0,R),k=h.length-1-h.lastIndexOf(i)),I=L,O=0;continue}else if(h.length!==0){h="",k=0,I=L,O=0;continue}}u&&(h+=h.length>0?`${i}..`:"..",k=2)}else h.length>0?h+=`${i}${n.slice(I+1,L)}`:h=n.slice(I+1,L),k=L-I-1;I=L,O=0}else C===T&&O!==-1?++O:O=-1}return h}function w(n){return n?`${n[0]==="."?"":"."}${n}`:""}function o(n,u){g(u,"pathObject");const i=u.dir||u.root,f=u.base||`${u.name||""}${w(u.ext)}`;return i?i===u.root?`${i}${f}`:`${i}${n}${f}`:f}e.$kc={resolve(...n){let u="",i="",f=!1;for(let h=n.length-1;h>=-1;h--){let k;if(h>=0){if(k=n[h],a(k,`paths[${h}]`),k.length===0)continue}else u.length===0?k=t.cwd():(k=t.env[`=${u}`]||t.cwd(),(k===void 0||k.slice(0,2).toLowerCase()!==u.toLowerCase()&&k.charCodeAt(2)===s)&&(k=`${u}\\`));const I=k.length;let O=0,C="",L=!1;const R=k.charCodeAt(0);if(I===1)m(R)&&(O=1,L=!0);else if(m(R))if(L=!0,m(k.charCodeAt(1))){let M=2,G=M;for(;M<I&&!m(k.charCodeAt(M));)M++;if(M<I&&M!==G){const Q=k.slice(G,M);for(G=M;M<I&&m(k.charCodeAt(M));)M++;if(M<I&&M!==G){for(G=M;M<I&&!m(k.charCodeAt(M));)M++;(M===I||M!==G)&&(C=`\\\\${Q}\\${k.slice(G,M)}`,O=M)}}}else O=1;else p(R)&&k.charCodeAt(1)===S&&(C=k.slice(0,2),O=2,I>2&&m(k.charCodeAt(2))&&(L=!0,O=3));if(C.length>0)if(u.length>0){if(C.toLowerCase()!==u.toLowerCase())continue}else u=C;if(f){if(u.length>0)break}else if(i=`${k.slice(O)}\\${i}`,f=L,L&&u.length>0)break}return i=d(i,!f,"\\",m),f?`${u}\\${i}`:`${u}${i}`||"."},normalize(n){a(n,"path");const u=n.length;if(u===0)return".";let i=0,f,h=!1;const k=n.charCodeAt(0);if(u===1)return b(k)?"\\":n;if(m(k))if(h=!0,m(n.charCodeAt(1))){let O=2,C=O;for(;O<u&&!m(n.charCodeAt(O));)O++;if(O<u&&O!==C){const L=n.slice(C,O);for(C=O;O<u&&m(n.charCodeAt(O));)O++;if(O<u&&O!==C){for(C=O;O<u&&!m(n.charCodeAt(O));)O++;if(O===u)return`\\\\${L}\\${n.slice(C)}\\`;O!==C&&(f=`\\\\${L}\\${n.slice(C,O)}`,i=O)}}}else i=1;else p(k)&&n.charCodeAt(1)===S&&(f=n.slice(0,2),i=2,u>2&&m(n.charCodeAt(2))&&(h=!0,i=3));let I=i<u?d(n.slice(i),!h,"\\",m):"";return I.length===0&&!h&&(I="."),I.length>0&&m(n.charCodeAt(u-1))&&(I+="\\"),f===void 0?h?`\\${I}`:I:h?`${f}\\${I}`:`${f}${I}`},isAbsolute(n){a(n,"path");const u=n.length;if(u===0)return!1;const i=n.charCodeAt(0);return m(i)||u>2&&p(i)&&n.charCodeAt(1)===S&&m(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let u,i;for(let k=0;k<n.length;++k){const I=n[k];a(I,"path"),I.length>0&&(u===void 0?u=i=I:u+=`\\${I}`)}if(u===void 0)return".";let f=!0,h=0;if(typeof i=="string"&&m(i.charCodeAt(0))){++h;const k=i.length;k>1&&m(i.charCodeAt(1))&&(++h,k>2&&(m(i.charCodeAt(2))?++h:f=!1))}if(f){for(;h<u.length&&m(u.charCodeAt(h));)h++;h>=2&&(u=`\\${u.slice(h)}`)}return e.$kc.normalize(u)},relative(n,u){if(a(n,"from"),a(u,"to"),n===u)return"";const i=e.$kc.resolve(n),f=e.$kc.resolve(u);if(i===f||(n=i.toLowerCase(),u=f.toLowerCase(),n===u))return"";let h=0;for(;h<n.length&&n.charCodeAt(h)===s;)h++;let k=n.length;for(;k-1>h&&n.charCodeAt(k-1)===s;)k--;const I=k-h;let O=0;for(;O<u.length&&u.charCodeAt(O)===s;)O++;let C=u.length;for(;C-1>O&&u.charCodeAt(C-1)===s;)C--;const L=C-O,R=I<L?I:L;let M=-1,G=0;for(;G<R;G++){const te=n.charCodeAt(h+G);if(te!==u.charCodeAt(O+G))break;te===s&&(M=G)}if(G!==R){if(M===-1)return f}else{if(L>R){if(u.charCodeAt(O+G)===s)return f.slice(O+G+1);if(G===2)return f.slice(O+G)}I>R&&(n.charCodeAt(h+G)===s?M=G:G===2&&(M=3)),M===-1&&(M=0)}let Q="";for(G=h+M+1;G<=k;++G)(G===k||n.charCodeAt(G)===s)&&(Q+=Q.length===0?"..":"\\..");return O+=M,Q.length>0?`${Q}${f.slice(O,C)}`:(f.charCodeAt(O)===s&&++O,f.slice(O,C))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const u=e.$kc.resolve(n);if(u.length<=2)return n;if(u.charCodeAt(0)===s){if(u.charCodeAt(1)===s){const i=u.charCodeAt(2);if(i!==y&&i!==T)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(p(u.charCodeAt(0))&&u.charCodeAt(1)===S&&u.charCodeAt(2)===s)return`\\\\?\\${u}`;return n},dirname(n){a(n,"path");const u=n.length;if(u===0)return".";let i=-1,f=0;const h=n.charCodeAt(0);if(u===1)return m(h)?n:".";if(m(h)){if(i=f=1,m(n.charCodeAt(1))){let O=2,C=O;for(;O<u&&!m(n.charCodeAt(O));)O++;if(O<u&&O!==C){for(C=O;O<u&&m(n.charCodeAt(O));)O++;if(O<u&&O!==C){for(C=O;O<u&&!m(n.charCodeAt(O));)O++;if(O===u)return n;O!==C&&(i=f=O+1)}}}}else p(h)&&n.charCodeAt(1)===S&&(i=u>2&&m(n.charCodeAt(2))?3:2,f=i);let k=-1,I=!0;for(let O=u-1;O>=f;--O)if(m(n.charCodeAt(O))){if(!I){k=O;break}}else I=!1;if(k===-1){if(i===-1)return".";k=i}return n.slice(0,k)},basename(n,u){u!==void 0&&a(u,"suffix"),a(n,"path");let i=0,f=-1,h=!0,k;if(n.length>=2&&p(n.charCodeAt(0))&&n.charCodeAt(1)===S&&(i=2),u!==void 0&&u.length>0&&u.length<=n.length){if(u===n)return"";let I=u.length-1,O=-1;for(k=n.length-1;k>=i;--k){const C=n.charCodeAt(k);if(m(C)){if(!h){i=k+1;break}}else O===-1&&(h=!1,O=k+1),I>=0&&(C===u.charCodeAt(I)?--I===-1&&(f=k):(I=-1,f=O))}return i===f?f=O:f===-1&&(f=n.length),n.slice(i,f)}for(k=n.length-1;k>=i;--k)if(m(n.charCodeAt(k))){if(!h){i=k+1;break}}else f===-1&&(h=!1,f=k+1);return f===-1?"":n.slice(i,f)},extname(n){a(n,"path");let u=0,i=-1,f=0,h=-1,k=!0,I=0;n.length>=2&&n.charCodeAt(1)===S&&p(n.charCodeAt(0))&&(u=f=2);for(let O=n.length-1;O>=u;--O){const C=n.charCodeAt(O);if(m(C)){if(!k){f=O+1;break}continue}h===-1&&(k=!1,h=O+1),C===T?i===-1?i=O:I!==1&&(I=1):i!==-1&&(I=-1)}return i===-1||h===-1||I===0||I===1&&i===h-1&&i===f+1?"":n.slice(i,h)},format:o.bind(null,"\\"),parse(n){a(n,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return u;const i=n.length;let f=0,h=n.charCodeAt(0);if(i===1)return m(h)?(u.root=u.dir=n,u):(u.base=u.name=n,u);if(m(h)){if(f=1,m(n.charCodeAt(1))){let M=2,G=M;for(;M<i&&!m(n.charCodeAt(M));)M++;if(M<i&&M!==G){for(G=M;M<i&&m(n.charCodeAt(M));)M++;if(M<i&&M!==G){for(G=M;M<i&&!m(n.charCodeAt(M));)M++;M===i?f=M:M!==G&&(f=M+1)}}}}else if(p(h)&&n.charCodeAt(1)===S){if(i<=2)return u.root=u.dir=n,u;if(f=2,m(n.charCodeAt(2))){if(i===3)return u.root=u.dir=n,u;f=3}}f>0&&(u.root=n.slice(0,f));let k=-1,I=f,O=-1,C=!0,L=n.length-1,R=0;for(;L>=f;--L){if(h=n.charCodeAt(L),m(h)){if(!C){I=L+1;break}continue}O===-1&&(C=!1,O=L+1),h===T?k===-1?k=L:R!==1&&(R=1):k!==-1&&(R=-1)}return O!==-1&&(k===-1||R===0||R===1&&k===O-1&&k===I+1?u.base=u.name=n.slice(I,O):(u.name=n.slice(I,k),u.base=n.slice(I,O),u.ext=n.slice(k,O))),I>0&&I!==f?u.dir=n.slice(0,I-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(c){const n=/\\/g;return()=>{const u=t.cwd().replace(n,"/");return u.slice(u.indexOf("/"))}}return()=>t.cwd()})();e.$lc={resolve(...n){let u="",i=!1;for(let f=n.length-1;f>=-1&&!i;f--){const h=f>=0?n[f]:l();a(h,`paths[${f}]`),h.length!==0&&(u=`${h}/${u}`,i=h.charCodeAt(0)===v)}return u=d(u,!i,"/",b),i?`/${u}`:u.length>0?u:"."},normalize(n){if(a(n,"path"),n.length===0)return".";const u=n.charCodeAt(0)===v,i=n.charCodeAt(n.length-1)===v;return n=d(n,!u,"/",b),n.length===0?u?"/":i?"./":".":(i&&(n+="/"),u?`/${n}`:n)},isAbsolute(n){return a(n,"path"),n.length>0&&n.charCodeAt(0)===v},join(...n){if(n.length===0)return".";let u;for(let i=0;i<n.length;++i){const f=n[i];a(f,"path"),f.length>0&&(u===void 0?u=f:u+=`/${f}`)}return u===void 0?".":e.$lc.normalize(u)},relative(n,u){if(a(n,"from"),a(u,"to"),n===u||(n=e.$lc.resolve(n),u=e.$lc.resolve(u),n===u))return"";const i=1,f=n.length,h=f-i,k=1,I=u.length-k,O=h<I?h:I;let C=-1,L=0;for(;L<O;L++){const M=n.charCodeAt(i+L);if(M!==u.charCodeAt(k+L))break;M===v&&(C=L)}if(L===O)if(I>O){if(u.charCodeAt(k+L)===v)return u.slice(k+L+1);if(L===0)return u.slice(k+L)}else h>O&&(n.charCodeAt(i+L)===v?C=L:L===0&&(C=0));let R="";for(L=i+C+1;L<=f;++L)(L===f||n.charCodeAt(L)===v)&&(R+=R.length===0?"..":"/..");return`${R}${u.slice(k+C)}`},toNamespacedPath(n){return n},dirname(n){if(a(n,"path"),n.length===0)return".";const u=n.charCodeAt(0)===v;let i=-1,f=!0;for(let h=n.length-1;h>=1;--h)if(n.charCodeAt(h)===v){if(!f){i=h;break}}else f=!1;return i===-1?u?"/":".":u&&i===1?"//":n.slice(0,i)},basename(n,u){u!==void 0&&a(u,"ext"),a(n,"path");let i=0,f=-1,h=!0,k;if(u!==void 0&&u.length>0&&u.length<=n.length){if(u===n)return"";let I=u.length-1,O=-1;for(k=n.length-1;k>=0;--k){const C=n.charCodeAt(k);if(C===v){if(!h){i=k+1;break}}else O===-1&&(h=!1,O=k+1),I>=0&&(C===u.charCodeAt(I)?--I===-1&&(f=k):(I=-1,f=O))}return i===f?f=O:f===-1&&(f=n.length),n.slice(i,f)}for(k=n.length-1;k>=0;--k)if(n.charCodeAt(k)===v){if(!h){i=k+1;break}}else f===-1&&(h=!1,f=k+1);return f===-1?"":n.slice(i,f)},extname(n){a(n,"path");let u=-1,i=0,f=-1,h=!0,k=0;for(let I=n.length-1;I>=0;--I){const O=n.charCodeAt(I);if(O===v){if(!h){i=I+1;break}continue}f===-1&&(h=!1,f=I+1),O===T?u===-1?u=I:k!==1&&(k=1):u!==-1&&(k=-1)}return u===-1||f===-1||k===0||k===1&&u===f-1&&u===i+1?"":n.slice(u,f)},format:o.bind(null,"/"),parse(n){a(n,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return u;const i=n.charCodeAt(0)===v;let f;i?(u.root="/",f=1):f=0;let h=-1,k=0,I=-1,O=!0,C=n.length-1,L=0;for(;C>=f;--C){const R=n.charCodeAt(C);if(R===v){if(!O){k=C+1;break}continue}I===-1&&(O=!1,I=C+1),R===T?h===-1?h=C:L!==1&&(L=1):h!==-1&&(L=-1)}if(I!==-1){const R=k===0&&i?1:k;h===-1||L===0||L===1&&h===I-1&&h===k+1?u.base=u.name=n.slice(R,I):(u.name=n.slice(R,h),u.base=n.slice(R,I),u.ext=n.slice(h,I))}return k>0?u.dir=n.slice(0,k-1):i&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.$lc.win32=e.$kc.win32=e.$kc,e.$lc.posix=e.$kc.posix=e.$lc,e.$mc=c?e.$kc.normalize:e.$lc.normalize,e.$nc=c?e.$kc.isAbsolute:e.$lc.isAbsolute,e.$oc=c?e.$kc.join:e.$lc.join,e.$pc=c?e.$kc.resolve:e.$lc.resolve,e.$qc=c?e.$kc.relative:e.$lc.relative,e.$rc=c?e.$kc.dirname:e.$lc.dirname,e.$sc=c?e.$kc.basename:e.$lc.basename,e.$tc=c?e.$kc.extname:e.$lc.extname,e.$uc=c?e.$kc.format:e.$lc.format,e.$vc=c?e.$kc.parse:e.$lc.parse,e.$wc=c?e.$kc.toNamespacedPath:e.$lc.toNamespacedPath,e.sep=c?e.$kc.sep:e.$lc.sep,e.$yc=c?e.$kc.delimiter:e.$lc.delimiter}),define(Te[36],Oe([1,0,34,8,3,16,10]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=T,e.$Dg=v,e.$Eg=s,e.$Fg=S,e.$Gg=y,e.$Hg=c,e.$Ig=m,e.$Jg=b,e.$Kg=p,e.$Lg=d,e.$Mg=w,e.$Ng=o,e.$Og=l,e.$Pg=n,e.$Qg=u,e.$Rg=i,e.$Sg=k;function T(I){return I===t.CharCode.Slash||I===t.CharCode.Backslash}function v(I){return I.replace(/[\\/]/g,r.$lc.sep)}function s(I){return I.indexOf("/")===-1&&(I=v(I)),/^[a-zA-Z]:(\/|$)/.test(I)&&(I="/"+I),I}function S(I,O=r.$lc.sep){if(!I)return"";const C=I.length,L=I.charCodeAt(0);if(T(L)){if(T(I.charCodeAt(1))&&!T(I.charCodeAt(2))){let M=3;const G=M;for(;M<C&&!T(I.charCodeAt(M));M++);if(G!==M&&!T(I.charCodeAt(M+1))){for(M+=1;M<C;M++)if(T(I.charCodeAt(M)))return I.slice(0,M+1).replace(/[\\/]/g,O)}}return O}else if(p(L)&&I.charCodeAt(1)===t.CharCode.Colon)return T(I.charCodeAt(2))?I.slice(0,2)+O:I.slice(0,2);let R=I.indexOf("://");if(R!==-1){for(R+=3;R<C;R++)if(T(I.charCodeAt(R)))return I.slice(0,R+1)}return""}function y(I){if(!E.$l||!I||I.length<5)return!1;let O=I.charCodeAt(0);if(O!==t.CharCode.Backslash||(O=I.charCodeAt(1),O!==t.CharCode.Backslash))return!1;let C=2;const L=C;for(;C<I.length&&(O=I.charCodeAt(C),O!==t.CharCode.Backslash);C++);return!(L===C||(O=I.charCodeAt(C+1),isNaN(O)||O===t.CharCode.Backslash))}const $=/[\\/:\*\?"<>\|]/g,g=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(I,O=E.$l){const C=O?$:g;return!(!I||I.length===0||/^\s+$/.test(I)||(C.lastIndex=0,C.test(I))||O&&a.test(I)||I==="."||I===".."||O&&I[I.length-1]==="."||O&&I.length!==I.trim().length||I.length>255)}function m(I,O,C){const L=I===O;return!C||L?L:!I||!O?!1:(0,P.$Kf)(I,O)}function b(I,O,C,L=r.sep){if(I===O)return!0;if(!I||!O||O.length>I.length)return!1;if(C){if(!(0,P.$Lf)(I,O))return!1;if(O.length===I.length)return!0;let M=O.length;return O.charAt(O.length-1)===L&&M--,I.charAt(M)===L}return O.charAt(O.length-1)!==L&&(O+=L),I.indexOf(O)===0}function p(I){return I>=t.CharCode.A&&I<=t.CharCode.Z||I>=t.CharCode.a&&I<=t.CharCode.z}function d(I,O){return E.$l&&I.endsWith(":")&&(I+=r.sep),(0,r.$nc)(I)||(I=(0,r.$oc)(O,I)),I=(0,r.$mc)(I),w(I)}function w(I){return E.$l?(I=(0,P.$sf)(I,r.sep),I.endsWith(":")&&(I+=r.sep)):(I=(0,P.$sf)(I,r.sep),I||(I=r.sep)),I}function o(I){const O=(0,r.$mc)(I);return E.$l?I.length>3?!1:l(O)&&(I.length===2||O.charCodeAt(2)===t.CharCode.Backslash):O===r.$lc.sep}function l(I,O=E.$l){return O?p(I.charCodeAt(0))&&I.charCodeAt(1)===t.CharCode.Colon:!1}function n(I,O=E.$l){return l(I,O)?I[0]:void 0}function u(I,O,C){return O.length>I.length?-1:I===O?0:(C&&(I=I.toLowerCase(),O=O.toLowerCase()),I.indexOf(O))}function i(I){const O=I.split(":");let C,L,R;for(const M of O){const G=Number(M);(0,D.$ng)(G)?L===void 0?L=G:R===void 0&&(R=G):C=C?[C,M].join(":"):M}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:L!==void 0?L:void 0,column:R!==void 0?R:L!==void 0?1:void 0}}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function k(I,O,C=8){let L="";for(let M=0;M<C;M++){let G;M===0&&E.$l&&!O&&(C===3||C===4)?G=h:G=f,L+=G.charAt(Math.floor(Math.random()*G.length))}let R;return O?R=`${O}-${L}`:R=L,I?(0,r.$oc)(I,R):R}}),define(Te[69],Oe([1,0,8]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=void 0,e.$ht=P,e.$it=D,e.$jt=T,e.$kt=s,e.$gt=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const r={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},E={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(S){const y=(0,t.$tc)(S),$=r[y.toLowerCase()];return $!==void 0?$:D(S)}function D(S){const y=(0,t.$tc)(S);return E[y.toLowerCase()]}function T(S){for(const y in E)if(E[y]===S)return y}const v=/^(.+)\/(.+?)(;.+)?$/;function s(S,y){const $=v.exec(S);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:y?void 0:S}}),define(Te[70],Oe([1,0,3]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=P,e.$rm=D;var r;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(r||(e.Source=r={}));var E;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function P(T,...v){const s=v.reduce(($,g)=>($[g]=!0,$),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter($=>!s[$]).forEach($=>{for(let g=0;g<S.length;g++)if($.search(S[g])!==-1){delete T[$];break}})}function D(T){T&&(delete T.DEBUG,t.$n&&delete T.LD_PRELOAD)}}),define(Te[4],Oe([1,0,34,82,8,3]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$Ac=m,e.$Bc=l,E=Ve(E);const D=/^\w[\w\d+.-]*$/,T=/^\//,v=/^\/\//;function s(h,k){if(!h.scheme&&k)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!D.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!T.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(h,k){return!h&&!k?"file":h}function y(h,k){switch(h){case"https":case"http":case"file":k?k[0]!==g&&(k=g+k):k=g;break}return k}const $="",g="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(k){return k instanceof c?!0:k?typeof k.authority=="string"&&typeof k.fragment=="string"&&typeof k.path=="string"&&typeof k.query=="string"&&typeof k.scheme=="string"&&typeof k.fsPath=="string"&&typeof k.with=="function"&&typeof k.toString=="function":!1}constructor(k,I,O,C,L,R=!1){typeof k=="object"?(this.scheme=k.scheme||$,this.authority=k.authority||$,this.path=k.path||$,this.query=k.query||$,this.fragment=k.fragment||$):(this.scheme=S(k,R),this.authority=I||$,this.path=y(this.scheme,O||$),this.query=C||$,this.fragment=L||$,s(this,R))}get fsPath(){return l(this,!1)}with(k){if(!k)return this;let{scheme:I,authority:O,path:C,query:L,fragment:R}=k;return I===void 0?I=this.scheme:I===null&&(I=$),O===void 0?O=this.authority:O===null&&(O=$),C===void 0?C=this.path:C===null&&(C=$),L===void 0?L=this.query:L===null&&(L=$),R===void 0?R=this.fragment:R===null&&(R=$),I===this.scheme&&O===this.authority&&C===this.path&&L===this.query&&R===this.fragment?this:new p(I,O,C,L,R)}static parse(k,I=!1){const O=a.exec(k);return O?new p(O[2]||$,f(O[4]||$),f(O[5]||$),f(O[7]||$),f(O[9]||$),I):new p($,$,$,$,$)}static file(k){let I=$;if(P.$l&&(k=k.replace(/\\/g,g)),k[0]===g&&k[1]===g){const O=k.indexOf(g,2);O===-1?(I=k.substring(2),k=g):(I=k.substring(2,O),k=k.substring(O)||g)}return new p("file",I,k,$,$)}static from(k,I){return new p(k.scheme,k.authority,k.path,k.query,k.fragment,I)}static joinPath(k,...I){if(!k.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let O;return P.$l&&k.scheme==="file"?O=c.file(E.$kc.join(l(k,!0),...I)).path:O=E.$lc.join(k.path,...I),k.with({path:O})}toString(k=!1){return n(this,k)}toJSON(){return this}static revive(k){if(k){if(k instanceof c)return k;{const I=new p(k);return I._formatted=k.external??null,I._fsPath=k._sep===b?k.fsPath??null:null,I}}else return k}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=c;function m(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const b=P.$l?1:void 0;class p extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(k=!1){return k?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const k={$mid:r.MarshalledId.Uri};return this._fsPath&&(k.fsPath=this._fsPath,k._sep=b),this._formatted&&(k.external=this._formatted),this.path&&(k.path=this.path),this.scheme&&(k.scheme=this.scheme),this.authority&&(k.authority=this.authority),this.query&&(k.query=this.query),this.fragment&&(k.fragment=this.fragment),k}}const d={[t.CharCode.Colon]:"%3A",[t.CharCode.Slash]:"%2F",[t.CharCode.QuestionMark]:"%3F",[t.CharCode.Hash]:"%23",[t.CharCode.OpenSquareBracket]:"%5B",[t.CharCode.CloseSquareBracket]:"%5D",[t.CharCode.AtSign]:"%40",[t.CharCode.ExclamationMark]:"%21",[t.CharCode.DollarSign]:"%24",[t.CharCode.Ampersand]:"%26",[t.CharCode.SingleQuote]:"%27",[t.CharCode.OpenParen]:"%28",[t.CharCode.CloseParen]:"%29",[t.CharCode.Asterisk]:"%2A",[t.CharCode.Plus]:"%2B",[t.CharCode.Comma]:"%2C",[t.CharCode.Semicolon]:"%3B",[t.CharCode.Equals]:"%3D",[t.CharCode.Space]:"%20"};function w(h,k,I){let O,C=-1;for(let L=0;L<h.length;L++){const R=h.charCodeAt(L);if(R>=t.CharCode.a&&R<=t.CharCode.z||R>=t.CharCode.A&&R<=t.CharCode.Z||R>=t.CharCode.Digit0&&R<=t.CharCode.Digit9||R===t.CharCode.Dash||R===t.CharCode.Period||R===t.CharCode.Underline||R===t.CharCode.Tilde||k&&R===t.CharCode.Slash||I&&R===t.CharCode.OpenSquareBracket||I&&R===t.CharCode.CloseSquareBracket||I&&R===t.CharCode.Colon)C!==-1&&(O+=encodeURIComponent(h.substring(C,L)),C=-1),O!==void 0&&(O+=h.charAt(L));else{O===void 0&&(O=h.substr(0,L));const M=d[R];M!==void 0?(C!==-1&&(O+=encodeURIComponent(h.substring(C,L)),C=-1),O+=M):C===-1&&(C=L)}}return C!==-1&&(O+=encodeURIComponent(h.substring(C))),O!==void 0?O:h}function o(h){let k;for(let I=0;I<h.length;I++){const O=h.charCodeAt(I);O===t.CharCode.Hash||O===t.CharCode.QuestionMark?(k===void 0&&(k=h.substr(0,I)),k+=d[O]):k!==void 0&&(k+=h[I])}return k!==void 0?k:h}function l(h,k){let I;return h.authority&&h.path.length>1&&h.scheme==="file"?I=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===t.CharCode.Slash&&(h.path.charCodeAt(1)>=t.CharCode.A&&h.path.charCodeAt(1)<=t.CharCode.Z||h.path.charCodeAt(1)>=t.CharCode.a&&h.path.charCodeAt(1)<=t.CharCode.z)&&h.path.charCodeAt(2)===t.CharCode.Colon?k?I=h.path.substr(1):I=h.path[1].toLowerCase()+h.path.substr(2):I=h.path,P.$l&&(I=I.replace(/\//g,"\\")),I}function n(h,k){const I=k?o:w;let O="",{scheme:C,authority:L,path:R,query:M,fragment:G}=h;if(C&&(O+=C,O+=":"),(L||C==="file")&&(O+=g,O+=g),L){let Q=L.indexOf("@");if(Q!==-1){const te=L.substr(0,Q);L=L.substr(Q+1),Q=te.lastIndexOf(":"),Q===-1?O+=I(te,!1,!1):(O+=I(te.substr(0,Q),!1,!1),O+=":",O+=I(te.substr(Q+1),!1,!0)),O+="@"}L=L.toLowerCase(),Q=L.lastIndexOf(":"),Q===-1?O+=I(L,!1,!0):(O+=I(L.substr(0,Q),!1,!0),O+=L.substr(Q))}if(R){if(R.length>=3&&R.charCodeAt(0)===t.CharCode.Slash&&R.charCodeAt(2)===t.CharCode.Colon){const Q=R.charCodeAt(1);Q>=t.CharCode.A&&Q<=t.CharCode.Z&&(R=`/${String.fromCharCode(Q+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===t.CharCode.Colon){const Q=R.charCodeAt(0);Q>=t.CharCode.A&&Q<=t.CharCode.Z&&(R=`${String.fromCharCode(Q+32)}:${R.substr(2)}`)}O+=I(R,!0,!1)}return M&&(O+="?",O+=I(M,!1,!1)),G&&(O+="#",O+=k?G:w(G,!1,!1)),O}function u(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+u(h.substr(3)):h}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(h){return h.match(i)?h.replace(i,k=>u(k)):h}}),define(Te[191],Oe([1,0,4]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=r,e.$mr=E,e.$nr=P,e.log=T;function r(s){const S=s;return S&&typeof S.type=="string"&&typeof S.severity=="string"}function E(s){const S=[];let y;try{const $=JSON.parse(s.arguments),g=$[$.length-1];g&&g.__$stack&&($.pop(),y=g.__$stack),S.push(...$)}catch{S.push("Unable to log remote console arguments",s.arguments)}return{args:S,stack:y}}function P(s){if(typeof s!="string")return P(E(s).stack);const S=s;if(S){const y=D(S),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if($&&$.length===4)return{uri:t.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function D(s){if(!s)return s;const S=s.indexOf(`
`);return S===-1?s:s.substring(0,S)}function T(s,S){const{args:y,stack:$}=E(s),g=typeof y[0]=="string"&&y.length===1;let a=D($);a&&(a=`(${a.trim()})`);let c=[];if(typeof y[0]=="string"?a&&g?c=[`%c[${S}] %c${y[0]} %c${a}`,v("blue"),v(""),v("grey")]:c=[`%c[${S}] %c${y[0]}`,v("blue"),v(""),...y.slice(1)]:c=[`%c[${S}]%`,v("blue"),...y],a&&!g&&c.push(a),typeof console[s.severity]!="function")throw new Error("Unknown console method");console[s.severity].apply(console,c)}function v(s){return`color: ${s}`}}),define(Te[49],Oe([1,0,14,4,82]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=P,e.$gi=D,e.$hi=v;function P(s){return JSON.stringify(s,T)}function D(s){let S=JSON.parse(s);return S=v(S),S}function T(s,S){return S instanceof RegExp?{$mid:E.MarshalledId.Regexp,source:S.source,flags:S.flags}:S}function v(s,S=0){if(!s||S>200)return s;if(typeof s=="object"){switch(s.$mid){case E.MarshalledId.Uri:return r.URI.revive(s);case E.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case E.MarshalledId.Date:return new Date(s.source)}if(s instanceof t.$Se||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let y=0;y<s.length;++y)s[y]=v(s[y],S+1);else for(const y in s)Object.hasOwnProperty.call(s,y)&&(s[y]=v(s[y],S+1))}return s}}),define(Te[12],Oe([1,0,9,3,16,4,8]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Xg=e.$Wg=e.$Vg=e.Schemas=void 0,e.$Tg=v,e.$Ug=s,e.$Yg=y,t=Ve(t),r=Ve(r),D=Ve(D);var T;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",a.vscodeNotebookMetadata="vscode-notebook-metadata",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting",a.outputChannel="output"})(T||(e.Schemas=T={}));function v(a,c){return P.URI.isUri(a)?(0,E.$Kf)(a.scheme,c):(0,E.$Lf)(a,c+":")}function s(a,...c){return c.some(m=>v(a,m))}e.$Vg="vscode-tkn",e.$Wg="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,m){this.f=y(c,m)}getServerRootPath(){return this.f}get g(){return D.$lc.join(this.f,T.vscodeRemoteResource)}set(c,m,b){this.a[c]=m,this.b[c]=b}setConnectionToken(c,m){this.c[c]=m}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(o){return t.$4(o),c}const m=c.authority;let b=this.a[m];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const p=this.b[m],d=this.c[m];let w=`path=${encodeURIComponent(c.path)}`;return typeof d=="string"&&(w+=`&${e.$Wg}=${encodeURIComponent(d)}`),P.URI.from({scheme:r.$r?this.d:T.vscodeRemoteResource,authority:`${b}:${p}`,path:this.g,query:w})}}e.$Xg=new S;function y(a,c){return D.$lc.join(c??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.$Zg="vs/../../extensions",e.$1g="vs/../../node_modules",e.$2g="vs/../../node_modules.asar",e.$3g="vs/../../node_modules.asar.unpacked",e.$4g="vscode-app";class ${static{this.a=e.$4g}asBrowserUri(c){const m=this.b(c,ue);return this.uriToBrowserUri(m)}uriToBrowserUri(c){return c.scheme===T.vscodeRemote?e.$Xg.rewrite(c):c.scheme===T.file&&(r.$p||r.$t===`${T.vscodeFileResource}://${$.a}`)?c.with({scheme:T.vscodeFileResource,authority:c.authority||$.a,query:null,fragment:null}):c}asFileUri(c){const m=this.b(c,ue);return this.uriToFileUri(m)}uriToFileUri(c){return c.scheme===T.vscodeFileResource?c.with({scheme:T.file,authority:c.authority!==$.a?c.authority:null,query:null,fragment:null}):c}b(c,m){if(P.URI.isUri(c))return c;if(globalThis._VSCODE_FILE_ROOT){const b=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(b))return P.URI.joinPath(P.URI.parse(b,!0),c);const p=D.$oc(b,c);return P.URI.file(p)}return P.URI.parse(m.toUrl(c))}}e.$5g=new $;var g;(function(a){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(c.get("3"));const m="vscode-coi";function b(d){let w;typeof d=="string"?w=new URL(d).searchParams:d instanceof URL?w=d.searchParams:P.URI.isUri(d)&&(w=new URL(d.toString(!0)).searchParams);const o=w?.get(m);if(o)return c.get(o)}a.getHeadersFromQuery=b;function p(d,w,o){if(!globalThis.crossOriginIsolated)return;const l=w&&o?"3":o?"2":"1";d instanceof URLSearchParams?d.set(m,l):d[m]=l}a.addSearchParam=p})(g||(e.COI=g={}))}),define(Te[111],Oe([1,0,64,12,3,10,4]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=S,e.$Aq=y,E=Ve(E);class T{constructor(g,a,c){this.id=g,this.dependencies=a,this.callback=c}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,a,c)=>{typeof g!="string"&&(c=a,a=g,g=null),(typeof a!="object"||!Array.isArray(a))&&(c=a,a=null),this.c.push(new T(g,a,c))},globalThis.define.amd=!0,this.b?this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith(`${r.Schemas.vscodeFileResource}://${r.$4g}`))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const a=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!a){console.warn(`Did not receive a define call from script ${g}`);return}const c={},m=[],b=[];if(Array.isArray(a.dependencies))for(const p of a.dependencies)p==="exports"?m.push(c):b.push(p);if(b.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${b.join(", ")}`);return typeof a.callback=="function"?a.callback(...m)??c:a.callback}h(g){return new Promise((a,c)=>{const m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript");const b=()=>{m.removeEventListener("load",p),m.removeEventListener("error",d)},p=w=>{b(),a(this.c.pop())},d=w=>{b(),c(w)};m.addEventListener("load",p),m.addEventListener("error",d),this.f&&(g=this.f.createScriptURL(g)),m.setAttribute("src",g),window.document.getElementsByTagName("head")[0].appendChild(m)})}async i(g){return this.f&&(g=this.f.createScriptURL(g)),t.$V?await new Promise((a,c)=>{ue([g],a,c)}).then(Ve):importScripts(g),this.c.pop()}async j(g){try{const a=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,m=globalThis._VSCODE_NODE_MODULES.module,b=D.URI.parse(g).fsPath,p=a.readFileSync(b).toString(),d=m.wrap(p.replace(/^#!.*/,""));return new c.Script(d).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const s=new Map;async function S($,g,a){if(t.$V){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit);const c=g?`${$}/${g}`:$;if(s.has(c))return s.get(c);let m;if(/^\w[\w\d+.-]*:\/\//.test(c))m=c;else{const w=`${t.$W&&a&&!E.$r?r.$2g:r.$1g}/${c}`;m=r.$5g.asBrowserUri(w).toString(!0)}const b=v.INSTANCE.load(m);return s.set(c,b),b}else return await new Promise((c,m)=>{ue([$],c,m)}).then(Ve)}function y($,g){(0,P.$tg)(t.$V);const c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,m=t.$W&&c&&!E.$r,b=`${$}/${g}`,d=`${m?r.$2g:r.$1g}/${b}`;return r.$5g.asBrowserUri(d).toString(!0)}}),define(Te[19],Oe([1,0,34,36,12,8,3,16,4]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$_g=s,e.$uh=y,e.$vh=g,r=Ve(r),P=Ve(P);function s(a){return(0,v.$Bc)(a,!0)}class S{constructor(c){this.a=c}compare(c,m,b=!1){return c===m?0:(0,T.$Df)(this.getComparisonKey(c,b),this.getComparisonKey(m,b))}isEqual(c,m,b=!1){return c===m?!0:!c||!m?!1:this.getComparisonKey(c,b)===this.getComparisonKey(m,b)}getComparisonKey(c,m=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,m,b=!1){if(c.scheme===m.scheme){if(c.scheme===E.Schemas.file)return r.$Jg(s(c),s(m),this.a(c))&&c.query===m.query&&(b||c.fragment===m.fragment);if((0,e.$qh)(c.authority,m.authority))return r.$Jg(c.path,m.path,this.a(c),"/")&&c.query===m.query&&(b||c.fragment===m.fragment)}return!1}joinPath(c,...m){return v.URI.joinPath(c,...m)}basenameOrAuthority(c){return(0,e.$ih)(c)||c.authority}basename(c){return P.$lc.basename(c.path)}extname(c){return P.$lc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let m;return c.scheme===E.Schemas.file?m=v.URI.file(P.$rc(s(c))).path:(m=P.$lc.dirname(c.path),c.authority&&m.length&&m.charCodeAt(0)!==t.CharCode.Slash&&(console.error(`dirname("${c.toString})) resulted in a relative path`),m="/")),c.with({path:m})}normalizePath(c){if(!c.path.length)return c;let m;return c.scheme===E.Schemas.file?m=v.URI.file(P.$mc(s(c))).path:m=P.$lc.normalize(c.path),c.with({path:m})}relativePath(c,m){if(c.scheme!==m.scheme||!(0,e.$qh)(c.authority,m.authority))return;if(c.scheme===E.Schemas.file){const d=P.$qc(s(c),s(m));return D.$l?r.$Dg(d):d}let b=c.path||"/";const p=m.path||"/";if(this.a(c)){let d=0;for(const w=Math.min(b.length,p.length);d<w&&!(b.charCodeAt(d)!==p.charCodeAt(d)&&b.charAt(d).toLowerCase()!==p.charAt(d).toLowerCase());d++);b=p.substr(0,d)+b.substr(d)}return P.$lc.relative(b,p)}resolvePath(c,m){if(c.scheme===E.Schemas.file){const b=v.URI.file(P.$pc(s(c),m));return c.with({authority:b.authority,path:b.path})}return m=r.$Eg(m),c.with({path:P.$lc.resolve(c.path,m)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,m){return c===m||c!==void 0&&m!==void 0&&(0,T.$Kf)(c,m)}hasTrailingPathSeparator(c,m=P.sep){if(c.scheme===E.Schemas.file){const b=s(c);return b.length>r.$Fg(b).length&&b[b.length-1]===m}else{const b=c.path;return b.length>1&&b.charCodeAt(b.length-1)===t.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,m=P.sep){return(0,e.$rh)(c,m)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,m=P.sep){let b=!1;if(c.scheme===E.Schemas.file){const p=s(c);b=p!==void 0&&p.length===r.$Fg(p).length&&p[p.length-1]===m}else{m="/";const p=c.path;b=p.length===1&&p.charCodeAt(p.length-1)===t.CharCode.Slash}return!b&&!(0,e.$rh)(c,m)?c.with({path:c.path+"/"}):c}}e.$ah=S,e.$bh=new S(()=>!1),e.$ch=new S(a=>a.scheme===E.Schemas.file?!D.$n:!0),e.$dh=new S(a=>!0),e.$eh=e.$bh.isEqual.bind(e.$bh),e.$fh=e.$bh.isEqualOrParent.bind(e.$bh),e.$gh=e.$bh.getComparisonKey.bind(e.$bh),e.$hh=e.$bh.basenameOrAuthority.bind(e.$bh),e.$ih=e.$bh.basename.bind(e.$bh),e.$jh=e.$bh.extname.bind(e.$bh),e.$kh=e.$bh.dirname.bind(e.$bh),e.$lh=e.$bh.joinPath.bind(e.$bh),e.$mh=e.$bh.normalizePath.bind(e.$bh),e.$nh=e.$bh.relativePath.bind(e.$bh),e.$oh=e.$bh.resolvePath.bind(e.$bh),e.$ph=e.$bh.isAbsolutePath.bind(e.$bh),e.$qh=e.$bh.isEqualAuthority.bind(e.$bh),e.$rh=e.$bh.hasTrailingPathSeparator.bind(e.$bh),e.$sh=e.$bh.removeTrailingPathSeparator.bind(e.$bh),e.$th=e.$bh.addTrailingPathSeparator.bind(e.$bh);function y(a,c){const m=[];for(let b=0;b<a.length;b++){const p=c(a[b]);a.some((d,w)=>w===b?!1:(0,e.$fh)(p,c(d)))||m.push(a[b])}return m}var $;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function c(m){const b=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(w=>{const[o,l]=w.split(":");o&&l&&b.set(o,l)});const d=m.path.substring(0,m.path.indexOf(";"));return d&&b.set(a.META_DATA_MIME,d),b}a.parseMetaData=c})($||(e.DataUri=$={}));function g(a,c,m){if(c){let b=a.path;return b&&b[0]!==P.$lc.sep&&(b=P.$lc.sep+b),a.with({scheme:m,authority:c,path:b})}return a.with({scheme:m})}}),define(Te[13],Oe([1,0,18,9,6,2,19,3,174,65]),function(ue,e,t,r,E,P,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$_h=e.$$h=e.$0h=e.$9h=e.Promises=e.$8h=e.$7h=e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0,e.$wh=S,e.$xh=y,e.$yh=$,e.$zh=g,e.$Ah=a,e.$Bh=c,e.$Ch=m,e.$Dh=b,e.$Lh=h,e.$Mh=k,e.$Nh=I,e.$Oh=O,e.$Ph=C,e.$5h=U,e.$ai=x;function S(W){return!!W&&typeof W.then=="function"}function y(W){const Z=new t.$Be,ce=W(Z.token),we=new Promise((Le,ze)=>{const qe=Z.token.onCancellationRequested(()=>{qe.dispose(),ze(new r.$9)});Promise.resolve(ce).then(Re=>{qe.dispose(),Z.dispose(),Le(Re)},Re=>{qe.dispose(),Z.dispose(),ze(Re)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(Le,ze){return we.then(Le,ze)}catch(Le){return this.then(void 0,Le)}finally(Le){return we.finally(Le)}}}function $(W,Z,ce){return new Promise((we,Le)=>{const ze=Z.onCancellationRequested(()=>{ze.dispose(),we(ce)});W.then(we,Le).finally(()=>ze.dispose())})}function g(W,Z){return new Promise((ce,we)=>{const Le=Z.onCancellationRequested(()=>{Le.dispose(),we(new r.$9)});W.then(ce,we).finally(()=>Le.dispose())})}async function a(W){let Z=-1;const ce=W.map((we,Le)=>we.then(ze=>(Z=Le,ze)));try{return await Promise.race(ce)}finally{W.forEach((we,Le)=>{Le!==Z&&we.cancel()})}}function c(W,Z,ce){let we;const Le=setTimeout(()=>{we?.(void 0),ce?.()},Z);return Promise.race([W.finally(()=>clearTimeout(Le)),new Promise(ze=>we=ze)])}function m(W){return new Promise((Z,ce)=>{const we=W();S(we)?we.then(Z,ce):Z(we)})}function b(){let W,Z;return{promise:new Promise((we,Le)=>{W=we,Z=Le}),resolve:W,reject:Z}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const ce=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(ce,ce).then(we)})}return new Promise((ce,we)=>{this.b.then(ce,we)})}return this.a=Z(),new Promise((ce,we)=>{this.a.then(Le=>{this.a=null,ce(Le)},Le=>{this.a=null,we(Le)})})}dispose(){this.f=!0}}e.$Eh=p;class d{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$Fh=d;class w{constructor(){this.a=new Map}queue(Z,ce){const Le=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(ce).finally(()=>{this.a.get(Z)===Le&&this.a.delete(Z)});return this.a.set(Z,Le),Le}}e.$Gh=w;const o=(W,Z)=>{let ce=!0;const we=setTimeout(()=>{ce=!1,Z()},W);return{isTriggered:()=>ce,dispose:()=>{clearTimeout(we),ce=!1}}},l=W=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,W())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class n{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,ce=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((Le,ze)=>{this.d=Le,this.f=ze}).then(()=>{if(this.b=null,this.d=null,this.g){const Le=this.g;return this.g=null,Le()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=ce===v.$le?l(we):o(ce,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$9),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Hh=n;class u{constructor(Z){this.a=new n(Z),this.b=new p}trigger(Z,ce){return this.a.trigger(()=>this.b.queue(Z),ce)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ih=u;class i{constructor(){this.a=!1,this.b=new Promise((Z,ce)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Jh=i;class f extends i{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Kh=f;function h(W,Z){return Z?new Promise((ce,we)=>{const Le=setTimeout(()=>{ze.dispose(),ce()},W),ze=Z.onCancellationRequested(()=>{clearTimeout(Le),ze.dispose(),we(new r.$9)})}):y(ce=>h(W,ce))}function k(W,Z=0,ce){const we=setTimeout(()=>{W(),ce&&Le.dispose()},Z),Le=(0,P.$Xc)(()=>{clearTimeout(we),ce?.deleteAndLeak(Le)});return ce?.add(Le),Le}function I(W){const Z=[];let ce=0;const we=W.length;function Le(){return ce<we?W[ce++]():null}function ze(qe){qe!=null&&Z.push(qe);const Re=Le();return Re?Re.then(ze):Promise.resolve(Z)}return Promise.resolve(null).then(ze)}function O(W,Z=we=>!!we,ce=null){let we=0;const Le=W.length,ze=()=>{if(we>=Le)return Promise.resolve(ce);const qe=W[we++];return Promise.resolve(qe()).then(Ne=>Z(Ne)?Promise.resolve(Ne):ze())};return ze()}function C(W,Z=we=>!!we,ce=null){if(W.length===0)return Promise.resolve(ce);let we=W.length;const Le=()=>{we=-1;for(const ze of W)ze.cancel?.()};return new Promise((ze,qe)=>{for(const Re of W)Re.then(Ne=>{--we>=0&&Z(Ne)?(Le(),ze(Ne)):we===0&&ze(ce)}).catch(Ne=>{--we>=0&&(Le(),qe(Ne))})})}class L{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new E.$qe}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ce,we)=>{this.g.push({factory:Z,c:ce,e:we}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const ce=Z.factory();ce.then(Z.c,Z.e),ce.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Qh=L;class R extends L{constructor(){super(1)}}e.$Rh=R;class M{constructor(){this.a=new ee,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Sh=M;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new se;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,ce=D.$bh){const we=ce.getComparisonKey(Z);return this.a.get(we)?.size??0}queueFor(Z,ce,we=D.$bh){const Le=we.getComparisonKey(Z);let ze=this.a.get(Le);if(!ze){ze=new R;const qe=this.f++,Re=E.Event.once(ze.onDrained)(()=>{ze?.dispose(),this.a.delete(Le),this.h(),this.d?.deleteAndDispose(qe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$9c),this.d.set(qe,Re),this.a.set(Le,ze)}return ze.queue(ce)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Th=G;class Q{constructor(Z,ce){this.b=!1,this.a=-1,typeof Z=="function"&&typeof ce=="number"&&this.setIfNotSet(Z,ce)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,ce){if(this.b)throw new r.$gb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},ce)}setIfNotSet(Z,ce){if(this.b)throw new r.$gb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},ce))}}e.$Uh=Q;class te{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,ce,we=globalThis){if(this.f)throw new r.$gb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const Le=we.setInterval(()=>{Z()},ce);this.d=(0,P.$Xc)(()=>{we.clearInterval(Le),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Vh=te;class ve{constructor(Z,ce){this.b=-1,this.a=Z,this.d=ce,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Wh=ve;class be{constructor(Z,ce){ce%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ce}ms is not a multiple of 1000ms.`),this.a=Z,this.b=ce,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Xh=be;class le extends ve{constructor(Z,ce){super(Z,ce),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Yh=le;class K extends P.$Zc{constructor(Z,ce){super(),this.g=Z,this.h=ce,this.a=[],this.b=this.B(new P.$1c),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ce of Z)this.a.push(ce);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ve(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Zh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$2h=(W,Z)=>{(0,T.$E)(()=>{if(ce)return;const we=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,we-Date.now())}}))});let ce=!1;return{dispose(){ce||(ce=!0)}}}:e.$2h=(W,Z,ce)=>{const we=W.requestIdleCallback(Z,typeof ce=="number"?{timeout:ce}:void 0);let Le=!1;return{dispose(){Le||(Le=!0,W.cancelIdleCallback(we))}}},e.$1h=W=>(0,e.$2h)(globalThis,W)}();class B{constructor(Z,ce){this.g=!1,this.d=()=>{try{this.j=ce()}catch(we){this.l=we}finally{this.g=!0}},this.f=(0,e.$2h)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$3h=B;class j extends B{constructor(Z){super(globalThis,Z)}}e.$4h=j;async function U(W,Z,ce){let we;for(let Le=0;Le<ce;Le++)try{return await W()}catch(ze){we=ze,await h(Z)}throw we}class ee{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,ce,we){return this.a={taskId:Z,cancel:()=>we?.(),promise:ce},ce.then(()=>this.d(Z),()=>this.d(Z)),ce}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:ce,resolve:we,reject:Le}=b();this.b={run:Z,promise:ce,promiseResolve:we,promiseReject:Le}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$6h=ee;class ae{constructor(Z,ce=()=>Date.now()){this.d=Z,this.f=ce,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$7h=ae;var ye;(function(W){W[W.Resolved=0]="Resolved",W[W.Rejected=1]="Rejected"})(ye||(ye={}));class se{get isRejected(){return this.d?.outcome===ye.Rejected}get isResolved(){return this.d?.outcome===ye.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ye.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,ce)=>{this.a=Z,this.b=ce})}complete(Z){return new Promise(ce=>{this.a(Z),this.d={outcome:ye.Resolved,value:Z},ce()})}error(Z){return new Promise(ce=>{this.b(Z),this.d={outcome:ye.Rejected,value:Z},ce()})}cancel(){return this.error(new r.$9)}}e.$8h=se;var ne;(function(W){async function Z(we){let Le;const ze=await Promise.all(we.map(qe=>qe.then(Re=>Re,Re=>{Le||(Le=Re)})));if(typeof Le<"u")throw Le;return ze}W.settled=Z;function ce(we){return new Promise(async(Le,ze)=>{try{await we(Le,ze)}catch(qe){ze(qe)}})}W.withAsyncBody=ce})(ne||(e.Promises=ne={}));class X{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(ce=>(this.a=ce,this.d=!0,ce),ce=>{throw this.b=ce,this.d=!0,ce})}requireValue(){if(!this.d)throw new r.$gb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$9h=X;class z{constructor(Z){this.b=Z,this.a=new s.$Y(()=>new X(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$0h=z;var A;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(A||(A={}));class Y{static fromArray(Z){return new Y(ce=>{ce.emitMany(Z)})}static fromPromise(Z){return new Y(async ce=>{ce.emitMany(await Z)})}static fromPromises(Z){return new Y(async ce=>{await Promise.all(Z.map(async we=>ce.emitOne(await we)))})}static merge(Z){return new Y(async ce=>{await Promise.all(Z.map(async we=>{for await(const Le of we)ce.emitOne(Le)}))})}static{this.EMPTY=Y.fromArray([])}constructor(Z,ce){this.a=A.Initial,this.b=[],this.d=null,this.f=ce,this.g=new E.$qe,queueMicrotask(async()=>{const we={emitOne:Le=>this.h(Le),emitMany:Le=>this.j(Le),reject:Le=>this.l(Le)};try{await Promise.resolve(Z(we)),this.k()}catch(Le){this.l(Le)}finally{we.emitOne=void 0,we.emitMany=void 0,we.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===A.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===A.DoneOK)return{done:!0,value:void 0};await E.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,ce){return new Y(async we=>{for await(const Le of Z)we.emitOne(ce(Le))})}map(Z){return Y.map(this,Z)}static filter(Z,ce){return new Y(async we=>{for await(const Le of Z)ce(Le)&&we.emitOne(Le)})}filter(Z){return Y.filter(this,Z)}static coalesce(Z){return Y.filter(Z,ce=>!!ce)}coalesce(){return Y.coalesce(this)}static async toPromise(Z){const ce=[];for await(const we of Z)ce.push(we);return ce}toPromise(){return Y.toPromise(this)}h(Z){this.a===A.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===A.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===A.Initial&&(this.a=A.DoneOK,this.g.fire())}l(Z){this.a===A.Initial&&(this.a=A.DoneError,this.d=Z,this.g.fire())}}e.$$h=Y;class pe extends Y{constructor(Z,ce){super(ce),this.m=Z}cancel(){this.m.cancel()}}e.$_h=pe;function x(W){const Z=new t.$Be,ce=W(Z.token);return new pe(Z,async we=>{const Le=Z.token.onCancellationRequested(()=>{Le.dispose(),Z.dispose(),we.reject(new r.$9)});try{for await(const ze of ce){if(Z.token.isCancellationRequested)return;we.emitOne(ze)}Le.dispose(),Z.dispose()}catch(ze){Le.dispose(),Z.dispose(),we.reject(ze)}})}class ie{constructor(Z){this.a=new se,this.b=new Y(Le=>{if(ce){Le.reject(ce);return}return we&&Le.emitMany(we),this.d=ze=>Le.reject(ze),this.f=ze=>Le.emitOne(ze),this.a.p},Z);let ce,we;this.f=Le=>{we||(we=[]),we.push(Le)},this.d=Le=>{ce||(ce=Le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$bi=ie}),define(Te[86],Oe([1,0,17,13,34,36,25,8,3,16]),function(ue,e,t,r,E,P,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=void 0,e.$Ak=S,e.$Dk=c,e.$Ek=M,e.$Fk=G,e.$Gk=Q,e.$Hk=te,e.$Ik=ve,e.$Jk=B;function S(){return Object.create(null)}e.$Bk="**",e.$Ck="/";const y="[/\\\\]",$="[^/\\\\]",g=/\//g;function a(j,U){switch(j){case 0:return"";case 1:return`${$}*?`;default:return`(?:${y}|${$}+${y}${U?`|${y}${$}+`:""})*?`}}function c(j,U){if(!j)return[];const ee=[];let ae=!1,ye=!1,se="";for(const ne of j){switch(ne){case U:if(!ae&&!ye){ee.push(se),se="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}se+=ne}return se&&ee.push(se),ee}function m(j){if(!j)return"";let U="";const ee=c(j,e.$Ck);if(ee.every(ae=>ae===e.$Bk))U=".*";else{let ae=!1;ee.forEach((ye,se)=>{if(ye===e.$Bk){if(ae)return;U+=a(2,se===ee.length-1)}else{let ne=!1,X="",z=!1,A="";for(const Y of ye){if(Y!=="}"&&ne){X+=Y;continue}if(z&&(Y!=="]"||!A)){let pe;Y==="-"?pe=Y:(Y==="^"||Y==="!")&&!A?pe="^":Y===e.$Ck?pe="":pe=(0,s.$mf)(Y),A+=pe;continue}switch(Y){case"{":ne=!0;continue;case"[":z=!0;continue;case"}":{const x=`(?:${c(X,",").map(ie=>m(ie)).join("|")})`;U+=x,ne=!1,X="";break}case"]":{U+="["+A+"]",z=!1,A="";break}case"?":U+=$;continue;case"*":U+=a(1);continue;default:U+=(0,s.$mf)(Y)}}se<ee.length-1&&(ee[se+1]!==e.$Bk||se+2<ee.length)&&(U+=y)}ae=ye===e.$Bk})}return U}const b=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new D.$Ic(1e4),u=function(){return!1},i=function(){return null};function f(j,U){if(!j)return i;let ee;typeof j!="string"?ee=j.pattern:ee=j,ee=ee.trim();const ae=`${ee}_${!!U.trimForExclusions}`;let ye=n.get(ae);if(ye)return h(ye,j);let se;return b.test(ee)?ye=I(ee.substr(4),ee):(se=p.exec(k(ee,U)))?ye=O(se[1],ee):(U.trimForExclusions?w:d).test(ee)?ye=C(ee,U):(se=o.exec(k(ee,U)))?ye=L(se[1].substr(1),ee,!0):(se=l.exec(k(ee,U)))?ye=L(se[1],ee,!1):ye=R(ee),n.set(ae,ye),h(ye,j)}function h(j,U){if(typeof U=="string")return j;const ee=function(ae,ye){return(0,P.$Jg)(ae,U.base,!v.$n)?j((0,s.$rf)(ae.substr(U.base.length),T.sep),ye):null};return ee.allBasenames=j.allBasenames,ee.allPaths=j.allPaths,ee.basenames=j.basenames,ee.patterns=j.patterns,ee}function k(j,U){return U.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function I(j,U){return function(ee,ae){return typeof ee=="string"&&ee.endsWith(j)?U:null}}function O(j,U){const ee=`/${j}`,ae=`\\${j}`,ye=function(ne,X){return typeof ne!="string"?null:X?X===j?U:null:ne===j||ne.endsWith(ee)||ne.endsWith(ae)?U:null},se=[j];return ye.basenames=se,ye.patterns=[U],ye.allBasenames=se,ye}function C(j,U){const ee=K(j.slice(1,-1).split(",").map(X=>f(X,U)).filter(X=>X!==i),j),ae=ee.length;if(!ae)return i;if(ae===1)return ee[0];const ye=function(X,z){for(let A=0,Y=ee.length;A<Y;A++)if(ee[A](X,z))return j;return null},se=ee.find(X=>!!X.allBasenames);se&&(ye.allBasenames=se.allBasenames);const ne=ee.reduce((X,z)=>z.allPaths?X.concat(z.allPaths):X,[]);return ne.length&&(ye.allPaths=ne),ye}function L(j,U,ee){const ae=T.sep===T.$lc.sep,ye=ae?j:j.replace(g,T.sep),se=T.sep+ye,ne=T.$lc.sep+j;let X;return ee?X=function(z,A){return typeof z=="string"&&(z===ye||z.endsWith(se)||!ae&&(z===j||z.endsWith(ne)))?U:null}:X=function(z,A){return typeof z=="string"&&(z===ye||!ae&&z===j)?U:null},X.allPaths=[(ee?"*/":"./")+j],X}function R(j){try{const U=new RegExp(`^${m(j)}$`);return function(ee){return U.lastIndex=0,typeof ee=="string"&&U.test(ee)?j:null}}catch{return i}}function M(j,U,ee){return!j||typeof U!="string"?!1:G(j)(U,void 0,ee)}function G(j,U={}){if(!j)return u;if(typeof j=="string"||Q(j)){const ee=f(j,U);if(ee===i)return u;const ae=function(ye,se){return!!ee(ye,se)};return ee.allBasenames&&(ae.allBasenames=ee.allBasenames),ee.allPaths&&(ae.allPaths=ee.allPaths),ae}return be(j,U)}function Q(j){const U=j;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}function te(j){return j.allBasenames||[]}function ve(j){return j.allPaths||[]}function be(j,U){const ee=K(Object.getOwnPropertyNames(j).map(X=>le(X,j[X],U)).filter(X=>X!==i)),ae=ee.length;if(!ae)return i;if(!ee.some(X=>!!X.requiresSiblings)){if(ae===1)return ee[0];const X=function(Y,pe){let x;for(let ie=0,W=ee.length;ie<W;ie++){const Z=ee[ie](Y,pe);if(typeof Z=="string")return Z;(0,r.$wh)(Z)&&(x||(x=[]),x.push(Z))}return x?(async()=>{for(const ie of x){const W=await ie;if(typeof W=="string")return W}return null})():null},z=ee.find(Y=>!!Y.allBasenames);z&&(X.allBasenames=z.allBasenames);const A=ee.reduce((Y,pe)=>pe.allPaths?Y.concat(pe.allPaths):Y,[]);return A.length&&(X.allPaths=A),X}const ye=function(X,z,A){let Y,pe;for(let x=0,ie=ee.length;x<ie;x++){const W=ee[x];W.requiresSiblings&&A&&(z||(z=(0,T.$sc)(X)),Y||(Y=z.substr(0,z.length-(0,T.$tc)(X).length)));const Z=W(X,z,Y,A);if(typeof Z=="string")return Z;(0,r.$wh)(Z)&&(pe||(pe=[]),pe.push(Z))}return pe?(async()=>{for(const x of pe){const ie=await x;if(typeof ie=="string")return ie}return null})():null},se=ee.find(X=>!!X.allBasenames);se&&(ye.allBasenames=se.allBasenames);const ne=ee.reduce((X,z)=>z.allPaths?X.concat(z.allPaths):X,[]);return ne.length&&(ye.allPaths=ne),ye}function le(j,U,ee){if(U===!1)return i;const ae=f(j,ee);if(ae===i)return i;if(typeof U=="boolean")return ae;if(U){const ye=U.when;if(typeof ye=="string"){const se=(ne,X,z,A)=>{if(!A||!ae(ne,X))return null;const Y=ye.replace("$(basename)",()=>z),pe=A(Y);return(0,r.$wh)(pe)?pe.then(x=>x?j:null):pe?j:null};return se.requiresSiblings=!0,se}}return ae}function K(j,U){const ee=j.filter(X=>!!X.basenames);if(ee.length<2)return j;const ae=ee.reduce((X,z)=>{const A=z.basenames;return A?X.concat(A):X},[]);let ye;if(U){ye=[];for(let X=0,z=ae.length;X<z;X++)ye.push(U)}else ye=ee.reduce((X,z)=>{const A=z.patterns;return A?X.concat(A):X},[]);const se=function(X,z){if(typeof X!="string")return null;if(!z){let Y;for(Y=X.length;Y>0;Y--){const pe=X.charCodeAt(Y-1);if(pe===E.CharCode.Slash||pe===E.CharCode.Backslash)break}z=X.substr(Y)}const A=ae.indexOf(z);return A!==-1?ye[A]:null};se.basenames=ae,se.patterns=ye,se.allBasenames=ae;const ne=j.filter(X=>!X.basenames);return ne.push(se),ne}function B(j,U){return(0,t.$yb)(j,U,(ee,ae)=>typeof ee=="string"&&typeof ae=="string"?ee===ae:typeof ee!="string"&&typeof ae!="string"?ee.base===ae.base&&ee.pattern===ae.pattern:!1)}}),define(Te[112],Oe([1,0,9,177,19,16,4]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.MarkdownStringTextNewlineStyle=void 0,e.$0k=s,e.$$k=S,e.$_k=y,e.$al=$,e.$bl=g,e.$cl=a,e.$dl=c,e.$el=m;var T;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class v{constructor(p="",d=!1){if(this.value=p,typeof this.value!="string")throw(0,t.$$)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(p,d=T.Paragraph){return this.value+=$(this.supportThemeIcons?(0,r.$3k)(p):p).replace(/([ \t]+)/g,(w,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===T.Break?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,d){return this.value+=`
${g(d,p)}
`,this}appendLink(p,d,w){return this.value+="[",this.value+=this.c(d,"]"),this.value+="](",this.value+=this.c(String(p),")"),w&&(this.value+=` "${this.c(this.c(w,'"'),")")}"`),this.value+=")",this}c(p,d){const w=new RegExp((0,P.$mf)(d),"g");return p.replace(w,(o,l)=>p.charAt(l-1)!=="\\"?`\\${o}`:o)}}e.$9k=v;function s(b){return S(b)?!b.value:Array.isArray(b)?b.every(s):!0}function S(b){return b instanceof v?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||typeof b.isTrusted=="object"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}function y(b,p){return b===p?!0:!b||!p?!1:b.value===p.value&&b.isTrusted===p.isTrusted&&b.supportThemeIcons===p.supportThemeIcons&&b.supportHtml===p.supportHtml&&(b.baseUri===p.baseUri||!!b.baseUri&&!!p.baseUri&&(0,E.$eh)(D.URI.from(b.baseUri),D.URI.from(p.baseUri)))}function $(b){return b.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function g(b,p){const d=b.match(/^`+/gm)?.reduce((o,l)=>o.length>l.length?o:l).length??0,w=d>=3?d+1:3;return[`${"`".repeat(w)}${p}`,b,`${"`".repeat(w)}`].join(`
`)}function a(b){return b.replace(/"/g,"&quot;")}function c(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(b){const p=[],d=b.split("|").map(o=>o.trim());b=d[0];const w=d[1];if(w){const o=/height=(\d+)/.exec(w),l=/width=(\d+)/.exec(w),n=o?o[1]:"",u=l?l[1]:"",i=isFinite(parseInt(u)),f=isFinite(parseInt(n));i&&p.push(`width="${u}"`),f&&p.push(`height="${n}"`)}return{href:b,dimensions:p}}}),define(Te[192],Oe([1,0,17,36,8,3,19,16]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9w=v,e.$0w=S,e.$$w=$,e.$_w=g,e.$ax=b,e.$bx=d,e.$cx=w,e.$dx=o,e.$ex=l,e.$fx=n;function v(i,f){const{os:h,tildify:k,relative:I}=f;if(I){const L=s(i,I,h);if(typeof L=="string")return L}let O=i.fsPath;if(h===P.OperatingSystem.Windows&&!P.$l?O=O.replace(/\//g,"\\"):h!==P.OperatingSystem.Windows&&P.$l&&(O=O.replace(/\\/g,"/")),h!==P.OperatingSystem.Windows&&k?.userHome){const L=k.userHome.fsPath;let R;i.scheme!==k.userHome.scheme&&i.path[0]===E.$lc.sep&&i.path[1]!==E.$lc.sep?R=k.userHome.with({path:i.path}).fsPath:R=O,O=$(R,L,h)}return(h===P.OperatingSystem.Windows?E.$kc:E.$lc).normalize(S(O,h===P.OperatingSystem.Windows))}function s(i,f,h){const k=h===P.OperatingSystem.Windows?E.$kc:E.$lc,I=h===P.OperatingSystem.Linux?D.$bh:D.$dh,O=f.getWorkspace(),C=(0,t.$Sb)(O.folders);if(!C)return;i.scheme!==C.uri.scheme&&i.path[0]===E.$lc.sep&&i.path[1]!==E.$lc.sep&&(i=C.uri.with({path:i.path}));const L=f.getWorkspaceFolder(i);if(!L)return;let R;if(I.isEqual(L.uri,i)?R="":R=I.relativePath(L.uri,i)??"",R&&(R=k.normalize(R)),O.folders.length>1&&!f.noPrefix){const M=L.name?L.name:I.basenameOrAuthority(L.uri);R=R?`${M} \u2022 ${R}`:M}return R}function S(i,f=P.$l){return(0,r.$Og)(i,f)?i.charAt(0).toUpperCase()+i.slice(1):i}let y=Object.create(null);function $(i,f,h=P.OS){if(h===P.OperatingSystem.Windows||!i||!f)return i;let k=y.original===f?y.normalized:void 0;k||(k=f,P.$l&&(k=(0,r.$Dg)(k)),k=`${(0,T.$sf)(k,E.$lc.sep)}${E.$lc.sep}`,y={original:f,normalized:k});let I=i;return P.$l&&(I=(0,r.$Dg)(I)),(h===P.OperatingSystem.Linux?I.startsWith(k):(0,T.$Lf)(I,k))?`~/${I.substr(k.length)}`:i}function g(i,f){return i.replace(/^~($|\/|\\)/,`${f}$1`)}const a="\u2026",c="\\\\",m="~";function b(i,f=E.sep){const h=new Array(i.length);let k=!1;for(let I=0;I<i.length;I++){const O=i[I];if(O===""){h[I]=`.${f}`;continue}if(!O){h[I]=O;continue}k=!0;let C="",L=O;L.indexOf(c)===0?(C=L.substr(0,L.indexOf(c)+c.length),L=L.substr(L.indexOf(c)+c.length)):L.indexOf(f)===0?(C=L.substr(0,L.indexOf(f)+f.length),L=L.substr(L.indexOf(f)+f.length)):L.indexOf(m)===0&&(C=L.substr(0,L.indexOf(m)+m.length),L=L.substr(L.indexOf(m)+m.length));const R=L.split(f);for(let M=1;k&&M<=R.length;M++)for(let G=R.length-M;k&&G>=0;G--){k=!1;let Q=R.slice(G,G+M).join(f);for(let te=0;!k&&te<i.length;te++)if(te!==I&&i[te]&&i[te].indexOf(Q)>-1){const ve=G+M===R.length,be=G>0&&i[te].indexOf(f)>-1?f+Q:Q,le=i[te].endsWith(be);k=!ve||le}if(!k){let te="";(R[0].endsWith(":")||C!=="")&&(G===1&&(G=0,M++,Q=R[0]+f+Q),G>0&&(te=R[0]+f),te=C+te),G>0&&(te=te+a+f),te=te+Q,G+M<R.length&&(te=te+f+a),h[I]=te}}k&&(h[I]=O)}return h}var p;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function d(i,f=Object.create(null)){const h=[];let k=!1,I="";for(const O of i)if(O==="$"||k&&O==="{")I&&h.push({value:I,type:p.TEXT}),I="",k=!0;else if(O==="}"&&k){const C=f[I];if(typeof C=="string")C.length&&h.push({value:C,type:p.VARIABLE});else if(C){const L=h[h.length-1];(!L||L.type!==p.SEPARATOR)&&h.push({value:C.label,type:p.SEPARATOR})}I="",k=!1}else I+=O;return I&&!k&&h.push({value:I,type:p.TEXT}),h.filter((O,C)=>{if(O.type===p.SEPARATOR){const L=h[C-1],R=h[C+1];return[L,R].every(M=>M&&(M.type===p.VARIABLE||M.type===p.TEXT)&&M.value.length>0)}return!0}).map(O=>O.value).join("")}function w(i,f){return P.$m||f?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$m?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}function o(i,f){return P.$m||f?i.replace(/\(&&\w\)|&&/g,""):P.$l?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}function l(i){return i.replace(/&/g,"&&")}function n(i){if(i.endsWith("]")){const f=i.lastIndexOf(" [",i.length-2);if(f!==-1){const h=u(i.substring(0,f)),k=i.substring(f);return{name:h.name+k,parentPath:h.parentPath}}}return u(i)}function u(i){const f=i.indexOf("/")!==-1?E.$lc:E.$kc,h=f.basename(i),k=f.dirname(i);return h.length?{name:h,parentPath:k}:{name:k,parentPath:""}}}),define(Te[59],Oe([1,0,14,82,4]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=void 0,e.$Un=v,e.$Vn=S,e.$Wn=y;function P($){return $.toJSON()}class D{constructor(g){this.a=g}transformIncoming(g){const a=this.a.transformIncoming(g);return a===g?g:P(E.URI.from(a))}transformOutgoing(g){const a=this.a.transformOutgoing(g);return a===g?g:P(E.URI.from(a))}transformOutgoingURI(g){const a=this.a.transformOutgoing(g);return a===g?g:E.URI.from(a)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.$Sn=D,e.$Tn=new class{transformIncoming($){return $}transformOutgoing($){return $}transformOutgoingURI($){return $}transformOutgoingScheme($){return $}};function T($,g,a){if(!$||a>200)return null;if(typeof $=="object"){if($ instanceof E.URI)return g.transformOutgoing($);for(const c in $)if(Object.hasOwnProperty.call($,c)){const m=T($[c],g,a+1);m!==null&&($[c]=m)}}return null}function v($,g){const a=T($,g,0);return a===null?$:a}function s($,g,a,c){if(!$||c>200)return null;if(typeof $=="object"){if($.$mid===r.MarshalledId.Uri)return a?E.URI.revive(g.transformIncoming($)):g.transformIncoming($);if($ instanceof t.$Se)return null;for(const m in $)if(Object.hasOwnProperty.call($,m)){const b=s($[m],g,a,c+1);b!==null&&($[m]=b)}}return null}function S($,g){const a=s($,g,!1,0);return a===null?$:a}function y($,g){const a=s($,g,!0,0);return a===null?$:a}}),define(Te[113],Oe([1,0,31,67,22,179,3]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Zn=v,e.$1n=y,e.$2n=$,E=Ve(E),e.$Yn=new class{c(g){return this.a||(this.a=r.$Qi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,a=0;const c=(0,t.networkInterfaces)();for(const m in c){const b=c[m];if(b)for(const{mac:p,internal:d}of b)d||(a+=1,this.c(p.toUpperCase())&&(g+=1))}this.b=a>0?g/a:0}return this.b}};let T;async function v(g){return T||(T=(async()=>await s(g)||E.$7g())()),T}async function s(g){try{const a=await new Promise((m,b)=>{ue(["crypto"],m,b)}).then(Ve),c=(0,P.$Xn)();return a.createHash("sha256").update(c,"utf8").digest("hex")}catch(a){g(a);return}}const S="Software\\Microsoft\\SQMClient";async function y(g){if(D.$l){const a=await new Promise((c,m)=>{ue(["@vscode/windows-registry"],c,m)}).then(Ve);try{return a.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(c){return g(c),""}}return""}async function $(g){try{return await(await new Promise((m,b)=>{ue(["@vscode/deviceid"],m,b)}).then(Ve)).getDeviceId()}catch(a){return g(a),""}}}),define(Te[193],Oe([1,0,23,288,3]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=P,E=Ve(E);async function P(D){if(E.$m||E.$l)return;let T;for(const v of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{T=await t.promises.open(v,t.constants.R_OK);break}catch{}if(!T){D("Unable to retrieve release information from known identifier paths.");return}try{const v=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),s={id:"unknown"};for await(const S of(0,r.createInterface)({input:T.createReadStream(),crlfDelay:1/0})){if(!S.includes("="))continue;const y=S.split("=")[0].toUpperCase().trim();if(v.has(y)){const $=S.split("=")[1].replace(/"/g,"").toLowerCase().trim();y==="ID"||y==="DISTRIB_ID"?s.id=$:y==="ID_LIKE"?s.id_like=$:(y==="VERSION_ID"||y==="DISTRIB_RELEASE")&&(s.version_id=$)}}return s}catch(v){D(v)}}}),define(Te[26],Oe([1,0,23,31,289,13,36,106,8,3,19,4]),function(ue,e,t,r,E,P,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=d,e.whenDeleted=l,e.configureFlushOnWrite=h,e.writeFileSync=I,t=Ve(t);var $;(function(be){be[be.UNLINK=0]="UNLINK",be[be.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function g(be,le=$.UNLINK,K){if((0,D.$Ng)(be))throw new Error("rimraf - will refuse to recursively delete root");return le===$.UNLINK?c(be):a(be,K)}async function a(be,le=(0,D.$Sg)((0,r.tmpdir)())){try{try{await t.promises.rename(be,le)}catch(K){return K.code==="ENOENT"?void 0:c(be)}c(le).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function c(be){return t.promises.rm(be,{recursive:!0,force:!0,maxRetries:3})}function m(be){if((0,D.$Ng)(be))throw new Error("rimraf - will refuse to recursively delete root");t.rmSync(be,{recursive:!0,force:!0,maxRetries:3})}async function b(be,le){return w(await(le?p(be):t.promises.readdir(be)))}async function p(be){try{return await t.promises.readdir(be,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const le=[],K=await b(be);for(const B of K){let j=!1,U=!1,ee=!1;try{const ae=await t.promises.lstat((0,v.$oc)(be,B));j=ae.isFile(),U=ae.isDirectory(),ee=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}le.push({name:B,isFile:()=>j,isDirectory:()=>U,isSymbolicLink:()=>ee})}return le}function d(be){return w(t.readdirSync(be))}function w(be){return be.map(le=>typeof le=="string"?s.$m?(0,T.$sm)(le):le:(le.name=s.$m?(0,T.$sm)(le.name):le.name,le))}async function o(be){const le=await b(be),K=[];for(const B of le)await n.existsDirectory((0,v.$oc)(be,B))&&K.push(B);return K}function l(be,le=1e3){return new Promise(K=>{let B=!1;const j=setInterval(()=>{B||(B=!0,t.access(be,U=>{B=!1,U&&(clearInterval(j),K(void 0))}))},le)})}var n;(function(be){async function le(j){let U;try{if(U=await t.promises.lstat(j),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await t.promises.stat(j),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(s.$l&&ee.code==="EACCES")try{return{stat:await t.promises.stat(await t.promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw ae}throw ee}}be.stat=le;async function K(j){try{const{stat:U,symbolicLink:ee}=await be.stat(j);return U.isFile()&&ee?.dangling!==!0}catch{}return!1}be.existsFile=K;async function B(j){try{const{stat:U,symbolicLink:ee}=await be.stat(j);return U.isDirectory()&&ee?.dangling!==!0}catch{}return!1}be.existsDirectory=B})(n||(e.SymlinkSupport=n={}));const u=new P.$Th;function i(be,le,K){return u.queueFor(y.URI.file(be),()=>{const B=O(K);return new Promise((j,U)=>k(be,le,B,ee=>ee?U(ee):j()))},S.$ch)}let f=!0;function h(be){f=be}function k(be,le,K,B){if(!f)return t.writeFile(be,le,{mode:K.mode,flag:K.flag},B);t.open(be,K.flag,K.mode,(j,U)=>{if(j)return B(j);t.writeFile(U,le,ee=>{if(ee)return t.close(U,()=>B(ee));t.fdatasync(U,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),h(!1)),t.close(U,ye=>B(ye))))})})}function I(be,le,K){const B=O(K);if(!f)return t.writeFileSync(be,le,{mode:B.mode,flag:B.flag});const j=t.openSync(be,B.flag,B.mode);try{t.writeFileSync(j,le);try{t.fdatasyncSync(j)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),h(!1)}}finally{t.closeSync(j)}}function O(be){return be?{mode:typeof be.mode=="number"?be.mode:438,flag:typeof be.flag=="string"?be.flag:"w"}:{mode:438,flag:"w"}}async function C(be,le,K=6e4){if(be!==le)try{s.$l&&typeof K=="number"?await L(be,le,Date.now(),K):await t.promises.rename(be,le)}catch(B){if(be.toLowerCase()!==le.toLowerCase()&&B.code==="EXDEV"||be.endsWith("."))await R(be,le,{preserveSymlinks:!1}),await g(be,$.MOVE);else throw B}}async function L(be,le,K,B,j=0){try{return await t.promises.rename(be,le)}catch(U){if(U.code!=="EACCES"&&U.code!=="EPERM"&&U.code!=="EBUSY")throw U;if(Date.now()-K>=B)throw console.error(`[node.js fs] rename failed after ${j} retries with error: ${U}`),U;if(j===0){let ee=!1;try{const{stat:ae}=await n.stat(le);ae.isFile()||(ee=!0)}catch{}if(ee)throw U}return await(0,P.$Lh)(Math.min(100,j*10)),L(be,le,K,B,j+1)}}async function R(be,le,K){return G(be,le,{root:{source:be,target:le},options:K,handledSourcePaths:new Set})}const M=511;async function G(be,le,K){if(K.handledSourcePaths.has(be))return;K.handledSourcePaths.add(be);const{stat:B,symbolicLink:j}=await n.stat(be);if(j){if(K.options.preserveSymlinks)try{return await ve(be,le,K)}catch{}if(j.dangling)return}return B.isDirectory()?Q(be,le,B.mode&M,K):te(be,le,B.mode&M)}async function Q(be,le,K,B){await t.promises.mkdir(le,{recursive:!0,mode:K});const j=await b(be);for(const U of j)await G((0,v.$oc)(be,U),(0,v.$oc)(le,U),B)}async function te(be,le,K){await t.promises.copyFile(be,le),await t.promises.chmod(le,K)}async function ve(be,le,K){let B=await t.promises.readlink(be);(0,D.$Jg)(B,K.root.source,!s.$n)&&(B=(0,v.$oc)(K.root.target,B.substr(K.root.source.length+1))),await t.promises.symlink(B,le)}e.Promises=new class{get read(){return(be,le,K,B,j)=>new Promise((U,ee)=>{t.read(be,le,K,B,j,(ae,ye,se)=>ae?ee(ae):U({bytesRead:ye,buffer:se}))})}get write(){return(be,le,K,B,j)=>new Promise((U,ee)=>{t.write(be,le,K,B,j,(ae,ye,se)=>ae?ee(ae):U({bytesWritten:ye,buffer:se}))})}get fdatasync(){return(0,E.promisify)(t.fdatasync)}get open(){return(0,E.promisify)(t.open)}get close(){return(0,E.promisify)(t.close)}get realpath(){return(0,E.promisify)(t.realpath)}async exists(be){try{return await t.promises.access(be),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return o}get writeFile(){return i}get rm(){return g}get rename(){return C}get copy(){return R}}}),define(Te[194],Oe([1,0,23,8,3,16,26]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=T,e.$ur=v,e.$vr=s,e.$wr=S,t=Ve(t);function T($){if(E.$n)return $;const g=(0,r.$rc)($);if($===g)return $;const a=((0,r.$sc)($)||$).toLowerCase();try{const m=(0,D.readdirSync)(g).filter(b=>b.toLowerCase()===a);if(m.length===1){const b=T(g);if(b)return(0,r.$oc)(b,m[0])}else if(m.length>1){const b=m.indexOf(a);if(b>=0){const p=T(g);if(p)return(0,r.$oc)(p,m[b])}}}catch{}return null}async function v($,g){if(E.$n)return $;const a=(0,r.$rc)($);if($===a)return $;const c=((0,r.$sc)($)||$).toLowerCase();try{if(g?.isCancellationRequested)return null;const b=(await D.Promises.readdir(a)).filter(p=>p.toLowerCase()===c);if(b.length===1){const p=await v(a,g);if(p)return(0,r.$oc)(p,b[0])}else if(b.length>1){const p=b.indexOf(c);if(p>=0){const d=await v(a,g);if(d)return(0,r.$oc)(d,b[p])}}}catch{}return null}async function s($){try{return await D.Promises.realpath($)}catch{const a=y($);return await t.promises.access(a,t.constants.R_OK),a}}function S($){try{return t.realpathSync($)}catch{const a=y($);return t.accessSync(a,t.constants.R_OK),a}}function y($){return(0,P.$sf)((0,r.$mc)($),r.sep)}}),define(Te[114],Oe([1,0,31,8,26]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=p,e.$Cm=d,t=Ve(t),r=Ve(r),E=Ve(E);const P=/^\d+$/,D=/^Microsoft.PowerShell_.*/,T=/^Microsoft.PowerShellPreview_.*/;var v;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(v||(v={}));let s;switch(process.arch){case"ia32":s=v.x86;break;case"arm":case"arm64":s=v.ARM;break;default:s=v.x64;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?v.ARM:v.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=v.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=v.x86:S=v.x64;class y{constructor(o,l,n){this.exePath=o,this.displayName=l,this.a=n}async exists(){return this.a===void 0&&(this.a=await E.SymlinkSupport.existsFile(this.exePath)),this.a}}function $({useAlternateBitness:w=!1}={}){return w?s===v.x64?process.env["ProgramFiles(x86)"]||null:S===v.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:w=!1,findPreview:o=!1}={}){const l=$({useAlternateBitness:w});if(!l)return null;const n=r.$oc(l,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(n))return null;let u=-1,i=null;for(const k of await E.Promises.readdir(n)){let I=-1;if(o){const C=k.indexOf("-");if(C<0)continue;const L=k.substring(0,C);if(!P.test(L)||k.substring(C+1)!=="preview")continue;I=parseInt(L,10)}else{if(!P.test(k))continue;I=parseInt(k,10)}if(I<=u)continue;const O=r.$oc(n,k,"pwsh.exe");await E.SymlinkSupport.existsFile(O)&&(i=O,u=I)}if(!i)return null;const f=l.includes("x86")?" (x86)":"",h=o?" Preview":"";return new y(i,`PowerShell${h}${f}`,!0)}async function a({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const o=r.$oc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:l,pwshMsixName:n}=w?{pwshMsixDirRegex:T,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const u of await E.Promises.readdir(o))if(l.test(u)){const i=r.$oc(o,u,"pwsh.exe");return new y(i,n)}return null}function c(){const w=r.$oc(t.homedir(),".dotnet","tools","pwsh.exe");return new y(w,".NET Core PowerShell Global Tool")}function m(){const w=r.$oc(process.env.windir,s===v.x86&&S!==v.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(w,"Windows PowerShell",!0)}async function*b(){let w=await g();w&&(yield w),w=await g({useAlternateBitness:!0}),w&&(yield w),w=await a(),w&&(yield w),w=c(),w&&(yield w),w=await g({findPreview:!0}),w&&(yield w),w=await a({findPreview:!0}),w&&(yield w),w=await g({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=m(),w&&(yield w)}async function*p(){for await(const w of b())await w.exists()&&(yield w)}async function d(){for await(const w of p())return w;return null}}),define(Te[115],Oe([1,0,23,8,3,32,70,10,26]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Dm=s,e.$Em=S,r=Ve(r),E=Ve(E),P=Ve(P),T=Ve(T),v=Ve(v),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function s($=P.env){return $.comspec||"cmd.exe"}function S($){let g=[],a=!1;const c=function(m){if(a){g.push(m);return}(!$.send(m,p=>{if(p&&console.error(p),a=!1,g.length>0){const d=g.slice(0);g=[],d.forEach(w=>c(w))}})||E.$l)&&(a=!0)};return{send:c}}var y;(function($){async function g(a,c,m){if(r.$nc(a))return a;if(c===void 0&&(c=P.cwd()),r.$rc(a)!=="."||(m===void 0&&T.$jg(P.env.PATH)&&(m=P.env.PATH.split(r.$yc)),m===void 0||m.length===0))return r.$oc(c,a);async function p(d){if(await v.Promises.exists(d)){let w;try{w=await t.promises.stat(d)}catch(o){o.message.startsWith("EACCES")&&(w=await t.promises.lstat(d))}return w?!w.isDirectory():!1}return!1}for(const d of m){let w;if(r.$nc(d)?w=r.$oc(d,a):w=r.$oc(c,d,a),await p(w))return w;let o=w+".com";if(await p(o)||(o=w+".exe",await p(o)))return o}return r.$oc(c,a)}$.findExecutable=g})(y||(e.win32=y={}))}),define(Te[116],Oe([1,0,50,12]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=E;function E(D){return new Promise((T,v)=>{let s;const S=new Map;function y(g,a,c,m,b){const p=S.get(a);if(g===D||p){const d={name:$(c),cmd:c,pid:g,ppid:a,load:m,mem:b};S.set(g,d),g===D&&(s=d),p&&(p.children||(p.children=[]),p.children.push(d),p.children.length>1&&(p.children=p.children.sort((w,o)=>w.pid-o.pid)))}}function $(g){const a=/--utility-sub-type=network/i,c=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,b=/conhost\.exe.+--headless/i,p=/--type=([a-zA-Z-]+)/;if(c.exec(g))return"electron-crash-reporter";if(m.exec(g))return"winpty-agent";if(b.exec(g))return"conpty-agent";let d=p.exec(g);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?a.exec(g)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const w=/[a-zA-Z-]+\.js/g;let o="";do d=w.exec(g),d&&(o+=d+" ");while(d);return o&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${o})`:g}if(process.platform==="win32"){const g=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,c)=>{ue(["@vscode/windows-process-tree"],a,c)}).then(Ve).then(a=>{a.getProcessList(D,c=>{if(!c){v(new Error(`Root process ${D} not found`));return}a.getProcessCpuUsage(c,m=>{const b=new Map;m.forEach(p=>{const d=g(p.commandLine||"");b.set(p.pid,{name:$(d),cmd:d,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),s=b.get(D),s?(b.forEach(p=>{const d=b.get(p.ppid);d&&(d.children||(d.children=[]),d.children.push(p))}),b.forEach(p=>{p.children&&(p.children=p.children.sort((d,w)=>d.pid-w.pid))}),T(s)):v(new Error(`Root process ${D} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let g=function(){let a=[s];const c=[];for(;a.length;){const b=a.shift();b&&(c.push(b.pid),b.children&&(a=a.concat(b.children)))}let m=JSON.stringify(r.$5g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+c.join(" "),(0,t.exec)(m,{},(b,p,d)=>{if(b||d)v(b||new Error(d.toString()));else{const w=p.toString().split(`
`);for(let o=0;o<c.length;o++){const l=S.get(c[o]);l.load=parseFloat(w[o])}if(!s){v(new Error(`Root process ${D} not found`));return}T(s)}})};(0,t.exec)("which ps",{},(a,c,m)=>{if(a||m)if(process.platform!=="linux")v(a||new Error(m.toString()));else{const b=JSON.stringify(r.$5g.asFileUri("vs/base/node/ps.sh").fsPath);(0,t.exec)(b,{},(p,d,w)=>{p||w?v(p||new Error(w.toString())):(P(d,y),g())})}else{const b=c.toString().trim();(0,t.exec)(`${b} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,w,o)=>{d||o&&!o.includes("screen size is bogus")?v(d||new Error(o.toString())):(P(w,y),process.platform==="linux"?g():s?T(s):v(new Error(`Root process ${D} not found`)))})}})}})}function P(D,T){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,s=D.toString().split(`
`);for(const S of s){const y=v.exec(S.trim());y&&y.length===6&&T(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(Te[117],Oe([1,0,31,3,114,115]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=D,r=Ve(r),P=Ve(P);async function D(y,$){return y===r.OperatingSystem.Windows?r.$l?S():P.$Dm($):v(y,$)}let T=null;function v(y,$){if(r.$n&&y===r.OperatingSystem.Macintosh||r.$m&&y===r.OperatingSystem.Linux)return"/bin/bash";if(!T){let g;if(r.$l)g="/bin/bash";else{if(g=$.SHELL,!g)try{g=(0,t.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}T=g}return T}let s=null;async function S(){return s||(s=(await(0,E.$Cm)()).exePath),s}}),define(Te[87],Oe([1,0,23,13,8,10,26,7]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=void 0,e.zip=m,e.$Lq=b,e.$Mq=d,E=Ve(E),T=Ve(T),e.$Iq="end of central directory record signature not found";const v=new RegExp(e.$Iq);class s extends Error{constructor(o,l){let n=l.message;switch(o){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=o,this.cause=l}}e.$Jq=s;function S(w){const o=w.externalFileAttributes>>16||33188;return[448,56,7].map(l=>o&l).reduce((l,n)=>l+n,o&61440)}function y(w){if(w instanceof s)return w;let o;return v.test(w.message)&&(o="CorruptZip"),new s(o,w)}function $(w,o,l,n,u,i){const f=E.$rc(o),h=E.$oc(n,f);if(!h.startsWith(n))return Promise.reject(new Error(T.localize(142,null,o)));const k=E.$oc(n,o);let I;return i.onCancellationRequested(()=>{I?.destroy()}),Promise.resolve(t.promises.mkdir(h,{recursive:!0})).then(()=>new Promise((O,C)=>{if(!i.isCancellationRequested)try{I=(0,t.createWriteStream)(k,{mode:l}),I.once("close",()=>O()),I.once("error",C),w.once("error",C),w.pipe(I)}catch(L){C(L)}}))}function g(w,o,l,n){let u=(0,r.$xh)(()=>Promise.resolve()),i=0;const f=n.onCancellationRequested(()=>{u.cancel(),w.close()});return new Promise((h,k)=>{const I=new r.$Fh,O=C=>{C.isCancellationRequested||(i++,w.readEntry())};w.once("error",k),w.once("close",()=>u.then(()=>{n.isCancellationRequested||w.entryCount===i?h():k(new s("Incomplete",new Error(T.localize(143,null,i,w.entryCount))))},k)),w.readEntry(),w.on("entry",C=>{if(n.isCancellationRequested)return;if(!l.sourcePathRegex.test(C.fileName)){O(n);return}const L=C.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(L)){const G=E.$oc(o,L);u=(0,r.$xh)(Q=>t.promises.mkdir(G,{recursive:!0}).then(()=>O(Q)).then(void 0,k));return}const R=c(w,C),M=S(C);u=(0,r.$xh)(G=>I.queue(()=>R.then(Q=>$(Q,L,M,o,l,G).then(()=>O(G)))).then(null,k))})}).finally(()=>f.dispose())}async function a(w,o=!1){const{open:l}=await new Promise((n,u)=>{ue(["yauzl"],n,u)}).then(Ve);return new Promise((n,u)=>{l(w,o?{lazyEntries:!0}:void 0,(i,f)=>{i?u(y(i)):n((0,P.$ug)(f))})})}function c(w,o){return new Promise((l,n)=>{w.openReadStream(o,(u,i)=>{u?n(y(u)):l((0,P.$ug)(i))})})}async function m(w,o){const{ZipFile:l}=await new Promise((n,u)=>{ue(["yazl"],n,u)}).then(Ve);return new Promise((n,u)=>{const i=new l;o.forEach(h=>{h.contents?i.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&i.addFile(h.localPath,h.path)}),i.end();const f=(0,t.createWriteStream)(w);i.outputStream.pipe(f),i.outputStream.once("error",u),f.once("error",u),f.once("finish",()=>n(w))})}function b(w,o,l={},n){const u=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let i=a(w,!0);return l.overwrite&&(i=i.then(f=>D.Promises.rm(o).then(()=>f))),i.then(f=>g(f,o,{sourcePathRegex:u},n))}function p(w,o){return a(w).then(l=>new Promise((n,u)=>{l.on("entry",i=>{i.fileName===o&&c(l,i).then(f=>n(f),f=>u(f))}),l.once("close",()=>u(new Error(T.localize(144,null,o))))}))}function d(w,o){return p(w,o).then(l=>new Promise((n,u)=>{const i=[];l.once("error",u),l.on("data",f=>i.push(f)),l.on("end",()=>n(Buffer.concat(i)))}))}});var We=this&&this.__decorate||function(ue,e,t,r){var E=arguments.length,P=E<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,t):r,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(ue,e,t,r);else for(var T=ue.length-1;T>=0;T--)(D=ue[T])&&(P=(E<3?D(P):E>3?D(e,t,P):D(e,t))||P);return E>3&&P&&Object.defineProperty(e,t,P),P};define(Te[51],Oe([1,0,17,13,14,18,79,9,6,2,49,16,10]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.ProxyChannel=e.$si=e.$pi=e.$oi=e.$ni=e.RequestInitiator=e.$mi=e.$ji=e.$ii=void 0,e.$ki=h,e.$li=k,e.$qi=M,e.$ri=G,y=Ve(y);var g;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(g||(g={}));function a(j){switch(j){case g.Promise:return"req";case g.PromiseCancel:return"cancel";case g.EventListen:return"subscribe";case g.EventDispose:return"unsubscribe"}}var c;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(c||(c={}));function m(j){switch(j){case c.Initialize:return"init";case c.PromiseSuccess:return"reply:";case c.PromiseError:case c.PromiseErrorObj:return"replyErr:";case c.EventFire:return"event:"}}var b;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(b||(b={}));function p(j){let U=0;for(let ee=0;;ee+=7){const ae=j.read(1);if(U|=(ae.buffer[0]&127)<<ee,!(ae.buffer[0]&128))return U}}const d=u(0);function w(j,U){if(U===0){j.write(d);return}let ee=0;for(let ye=U;ye!==0;ye=ye>>>7)ee++;const ae=E.$Se.alloc(ee);for(let ye=0;U!==0;ye++)ae.buffer[ye]=U&127,U=U>>>7,U>0&&(ae.buffer[ye]|=128);j.write(ae)}class o{constructor(U){this.b=U,this.a=0}read(U){const ee=this.b.slice(this.a,this.a+U);return this.a+=ee.byteLength,ee}}e.$ii=o;class l{constructor(){this.a=[]}get buffer(){return E.$Se.concat(this.a)}write(U){this.a.push(U)}}e.$ji=l;var n;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(n||(n={}));function u(j){const U=E.$Se.alloc(1);return U.writeUInt8(j,0),U}const i={Undefined:u(n.Undefined),String:u(n.String),Buffer:u(n.Buffer),VSBuffer:u(n.VSBuffer),Array:u(n.Array),Object:u(n.Object),Uint:u(n.Int)},f=typeof Buffer<"u";function h(j,U){if(typeof U>"u")j.write(i.Undefined);else if(typeof U=="string"){const ee=E.$Se.fromString(U);j.write(i.String),w(j,ee.byteLength),j.write(ee)}else if(f&&Buffer.isBuffer(U)){const ee=E.$Se.wrap(U);j.write(i.Buffer),w(j,ee.byteLength),j.write(ee)}else if(U instanceof E.$Se)j.write(i.VSBuffer),w(j,U.byteLength),j.write(U);else if(Array.isArray(U)){j.write(i.Array),w(j,U.length);for(const ee of U)h(j,ee)}else if(typeof U=="number"&&(U|0)===U)j.write(i.Uint),w(j,U);else{const ee=E.$Se.fromString(JSON.stringify(U));j.write(i.Object),w(j,ee.byteLength),j.write(ee)}}function k(j){switch(j.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return j.read(p(j)).toString();case n.Buffer:return j.read(p(j)).buffer;case n.VSBuffer:return j.read(p(j));case n.Array:{const ee=p(j),ae=[];for(let ye=0;ye<ee;ye++)ae.push(k(j));return ae}case n.Object:return JSON.parse(j.read(p(j)).toString());case n.Int:return p(j)}}class I{constructor(U,ee,ae=null,ye=1e3){this.h=U,this.j=ee,this.k=ae,this.l=ye,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:c.Initialize})}registerChannel(U,ee){this.b.set(U,ee),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case c.Initialize:{const ee=this.o([U.type]);this.k?.logOutgoing(ee,0,O.OtherSide,m(U.type));return}case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:{const ee=this.o([U.type,U.id],U.data);this.k?.logOutgoing(ee,U.id,O.OtherSide,m(U.type),U.data);return}}}o(U,ee=void 0){const ae=new l;return h(ae,U),h(ae,ee),this.p(ae.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const ee=new o(U),ae=k(ee),ye=k(ee),se=ae[0];switch(se){case g.Promise:return this.k?.logIncoming(U.byteLength,ae[1],O.OtherSide,`${a(se)}: ${ae[2]}.${ae[3]}`,ye),this.s({type:se,id:ae[1],channelName:ae[2],name:ae[3],arg:ye});case g.EventListen:return this.k?.logIncoming(U.byteLength,ae[1],O.OtherSide,`${a(se)}: ${ae[2]}.${ae[3]}`,ye),this.t({type:se,id:ae[1],channelName:ae[2],name:ae[3],arg:ye});case g.PromiseCancel:return this.k?.logIncoming(U.byteLength,ae[1],O.OtherSide,`${a(se)}`),this.u({type:se,id:ae[1]});case g.EventDispose:return this.k?.logIncoming(U.byteLength,ae[1],O.OtherSide,`${a(se)}`),this.u({type:se,id:ae[1]})}}s(U){const ee=this.b.get(U.channelName);if(!ee){this.v(U);return}const ae=new P.$Be;let ye;try{ye=ee.call(this.j,U.name,U.arg,ae.token)}catch(X){ye=Promise.reject(X)}const se=U.id;ye.then(X=>{this.m({id:se,data:X,type:c.PromiseSuccess})},X=>{X instanceof Error?this.m({id:se,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split(`
`):void 0},type:c.PromiseError}):this.m({id:se,data:X,type:c.PromiseErrorObj})}).finally(()=>{ne.dispose(),this.d.delete(U.id)});const ne=(0,s.$Xc)(()=>ae.cancel());this.d.set(U.id,ne)}t(U){const ee=this.b.get(U.channelName);if(!ee){this.v(U);return}const ae=U.id,se=ee.listen(this.j,U.name,U.arg)(ne=>this.m({id:ae,data:ne,type:c.EventFire}));this.d.set(U.id,se)}u(U){const ee=this.d.get(U.id);ee&&(ee.dispose(),this.d.delete(U.id))}v(U){let ee=this.g.get(U.channelName);ee||(ee=[],this.g.set(U.channelName,ee));const ae=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===g.Promise&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:c.PromiseError})},this.l);ee.push({request:U,timeoutTimer:ae})}w(U){const ee=this.g.get(U);if(ee){for(const ae of ee)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case g.Promise:this.s(ae.request);break;case g.EventListen:this.t(ae.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,s.$Uc)(this.d.values()),this.d.clear()}}e.$mi=I;var O;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(O||(e.RequestInitiator=O={}));class C{constructor(U,ee=null){this.l=U,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.$qe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=ee}getChannel(U){const ee=this;return{call(ae,ye,se){return ee.a?Promise.reject(new T.$9):ee.m(U,ae,ye,se)},listen(ae,ye){return ee.a?v.Event.None:ee.o(U,ae,ye)}}}m(U,ee,ae,ye=P.CancellationToken.None){const se=this.g++,ne=g.Promise,X={id:se,type:ne,channelName:U,name:ee,arg:ae};if(ye.isCancellationRequested)return Promise.reject(new T.$9);let z;return new Promise((Y,pe)=>{if(ye.isCancellationRequested)return pe(new T.$9);const x=()=>{const ce=we=>{switch(we.type){case c.PromiseSuccess:this.f.delete(se),Y(we.data);break;case c.PromiseError:{this.f.delete(se);const Le=new Error(we.data.message);Le.stack=Array.isArray(we.data.stack)?we.data.stack.join(`
`):we.data.stack,Le.name=we.data.name,pe(Le);break}case c.PromiseErrorObj:this.f.delete(se),pe(we.data);break}};this.f.set(se,ce),this.p(X)};let ie=null;this.b===b.Idle?x():(ie=(0,r.$xh)(ce=>this.u()),ie.then(()=>{ie=null,x()}));const W=()=>{ie?(ie.cancel(),ie=null):this.p({id:se,type:g.PromiseCancel}),pe(new T.$9)},Z=ye.onCancellationRequested(W);z=(0,s.$Wc)((0,s.$Xc)(W),Z),this.d.add(z)}).finally(()=>{z.dispose(),this.d.delete(z)})}o(U,ee,ae){const ye=this.g++,se=g.EventListen,ne={id:ye,type:se,channelName:U,name:ee,arg:ae};let X=null;const z=new v.$qe({onWillAddFirstListener:()=>{X=(0,r.$xh)(Y=>this.u()),X.then(()=>{X=null,this.d.add(z),this.p(ne)})},onDidRemoveLastListener:()=>{X?(X.cancel(),X=null):(this.d.delete(z),this.p({id:ye,type:g.EventDispose}))}}),A=Y=>z.fire(Y.data);return this.f.set(ye,A),z.event}p(U){switch(U.type){case g.Promise:case g.EventListen:{const ee=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(ee,U.id,O.LocalSide,`${a(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case g.PromiseCancel:case g.EventDispose:{const ee=this.q([U.type,U.id]);this.j?.logOutgoing(ee,U.id,O.LocalSide,a(U.type));return}}}q(U,ee=void 0){const ae=new l;return h(ae,U),h(ae,ee),this.r(ae.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const ee=new o(U),ae=k(ee),ye=k(ee),se=ae[0];switch(se){case c.Initialize:return this.j?.logIncoming(U.byteLength,0,O.LocalSide,m(se)),this.t({type:ae[0]});case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:return this.j?.logIncoming(U.byteLength,ae[1],O.LocalSide,m(se),ye),this.t({type:ae[0],id:ae[1],data:ye})}}t(U){if(U.type===c.Initialize){this.b=b.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,s.$Uc)(this.d.values()),this.d.clear()}}e.$ni=C,We([D.$ci],C.prototype,"onDidInitializePromise",null);class L{get connections(){const U=[];return this.f.forEach(ee=>U.push(ee)),U}constructor(U,ee,ae){this.a=new Map,this.f=new Set,this.g=new v.$qe,this.onDidAddConnection=this.g.event,this.h=new v.$qe,this.onDidRemoveConnection=this.h.event,this.j=new s.$Yc,this.j.add(U(({protocol:ye,onDidClientDisconnect:se})=>{const ne=v.Event.once(ye.onMessage);this.j.add(ne(X=>{const z=new o(X),A=k(z),Y=new I(ye,A,ee,ae),pe=new C(ye,ee);this.a.forEach((ie,W)=>Y.registerChannel(W,ie));const x={channelServer:Y,channelClient:pe,ctx:A};this.f.add(x),this.g.fire(x),this.j.add(se(()=>{Y.dispose(),pe.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(U,ee){const ae=this;return{call(ye,se,ne){let X;if((0,$.$xg)(ee)){const A=(0,t.$7b)(ae.connections.filter(ee));X=A?Promise.resolve(A):v.Event.toPromise(v.Event.filter(ae.onDidAddConnection,ee))}else X=ee.routeCall(ae,ye,se);const z=X.then(A=>A.channelClient.getChannel(U));return M(z).call(ye,se,ne)},listen(ye,se){if((0,$.$xg)(ee))return ae.k(U,ee,ye,se);const ne=ee.routeEvent(ae,ye,se).then(X=>X.channelClient.getChannel(U));return M(ne).listen(ye,se)}}}k(U,ee,ae,ye){const se=this;let ne;const X=new v.$qe({onWillAddFirstListener:()=>{ne=new s.$Yc;const z=new v.$we,A=new Map,Y=x=>{const W=x.channelClient.getChannel(U).listen(ae,ye),Z=z.add(W);A.set(x,Z)},pe=x=>{const ie=A.get(x);ie&&(ie.dispose(),A.delete(x))};se.connections.filter(ee).forEach(Y),v.Event.filter(se.onDidAddConnection,ee)(Y,void 0,ne),se.onDidRemoveConnection(pe,void 0,ne),z.event(X.fire,X,ne),ne.add(z)},onDidRemoveLastListener:()=>{ne?.dispose(),ne=void 0}});return X.event}registerChannel(U,ee){this.a.set(U,ee);for(const ae of this.f)ae.channelServer.registerChannel(U,ee)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$oi=L;class R{constructor(U,ee,ae=null){const ye=new l;h(ye,ee),U.send(ye.buffer),this.a=new C(U,ae),this.d=new I(U,ee,ae)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,ee){this.d.registerChannel(U,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$pi=R;function M(j){return{call(U,ee,ae){return j.then(ye=>ye.call(U,ee,ae))},listen(U,ee){const ae=new v.$ze;return j.then(ye=>ae.input=ye.listen(U,ee)),ae.event}}}function G(j){let U=!1;return{call(ee,ae,ye){return U?j.call(ee,ae,ye):(0,r.$Lh)(0).then(()=>U=!0).then(()=>j.call(ee,ae,ye))},listen(ee,ae){if(U)return j.listen(ee,ae);const ye=new v.$ze;return(0,r.$Lh)(0).then(()=>U=!0).then(()=>ye.input=j.listen(ee,ae)),ye.event}}}class Q{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const ee of U.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await v.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$si=Q;var te;(function(j){function U(se,ne,X){const z=se,A=X&&X.disableMarshalling,Y=new Map;for(const pe in z)ae(pe)&&Y.set(pe,v.Event.buffer(z[pe],!0,void 0,ne));return new class{listen(pe,x,ie){const W=Y.get(x);if(W)return W;const Z=z[x];if(typeof Z=="function"){if(ye(x))return Z.call(z,ie);if(ae(x))return Y.set(x,v.Event.buffer(z[x],!0,void 0,ne)),Y.get(x)}throw new T.$fb(`Event not found: ${x}`)}call(pe,x,ie){const W=z[x];if(typeof W=="function"){if(!A&&Array.isArray(ie))for(let ce=0;ce<ie.length;ce++)ie[ce]=(0,S.$hi)(ie[ce]);let Z=W.apply(z,ie);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new T.$fb(`Method not found: ${x}`)}}}j.fromService=U;function ee(se,ne){const X=ne&&ne.disableMarshalling;return new Proxy({},{get(z,A){if(typeof A=="string")return ne?.properties?.has(A)?ne.properties.get(A):ye(A)?function(Y){return se.listen(A,Y)}:ae(A)?se.listen(A):async function(...Y){let pe;ne&&!(0,$.$sg)(ne.context)?pe=[ne.context,...Y]:pe=Y;const x=await se.call(A,pe);return X?x:(0,S.$hi)(x)};throw new T.$fb(`Property not found: ${String(A)}`)}})}j.toService=ee;function ae(se){return se[0]==="o"&&se[1]==="n"&&y.$Jf(se.charCodeAt(2))}function ye(se){return/^onDynamic/.test(se)&&y.$Jf(se.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ve=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function be(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const U=j.toString();if(U!=="[object Object]")return U}return j}function le(j){return Array.isArray(j)?j.map(be):be(j)}function K(j,U,ee,ae,ye,se,ne){ne=le(ne);const X=ve[ye],z=X[ae%X.length];let A=[`%c[${j}]%c[${String(U).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(se)?(A=A.concat(ne),A.push(")")):A.push(ne),console.log.apply(console,A)}class B{constructor(U,ee){this.d=U,this.f=ee,this.a=0,this.b=0}logOutgoing(U,ee,ae,ye,se){this.b+=U,K(this.d,this.b,U,ee,ae,ye,se)}logIncoming(U,ee,ae,ye,se){this.a+=U,K(this.f,this.a,U,ee,ae,ye,se)}}e.$ti=B}),define(Te[60],Oe([1,0,14,6,2,51]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.ProtocolConstants=e.$ui=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var T;(function(i){i.enableDiagnostics=!1,i.records=[];const f=new WeakMap;let h=0;function k(O,C){if(!f.has(O)){const L=String(++h);f.set(O,L)}return f.get(O)}function I(O,C,L,R){if(!i.enableDiagnostics)return;const M=k(O,C);if(R instanceof t.$Se||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const G=t.$Se.alloc(R.byteLength);G.set(R),i.records.push({timestamp:Date.now(),id:M,label:C,type:L,buff:G})}else i.records.push({timestamp:Date.now(),id:M,label:C,type:L,data:R})}i.traceSocketEvent=I})(T||(e.SocketDiagnostics=T={}));var v;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let s=null;function S(){return s||(s=t.$Se.alloc(0)),s}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(f){this.a.push(f),this.b+=f.byteLength}read(f){return this.c(f,!0)}peek(f){return this.c(f,!1)}c(f,h){if(f===0)return S();if(f>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===f){const C=this.a[0];return h&&(this.a.shift(),this.b-=f),C}if(this.a[0].byteLength>f){const C=this.a[0].slice(0,f);return h&&(this.a[0]=this.a[0].slice(f),this.b-=f),C}const k=t.$Se.alloc(f);let I=0,O=0;for(;f>0;){const C=this.a[O];if(C.byteLength>f){const L=C.slice(0,f);k.set(L,I),I+=f,h&&(this.a[O]=C.slice(f),this.b-=f),f-=f}else k.set(C,I),I+=C.byteLength,h?(this.a.shift(),this.b-=C.byteLength):O++,f-=C.byteLength}return k}}e.$ui=y;var $;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})($||($={}));function g(i){switch(i){case $.None:return"None";case $.Regular:return"Regular";case $.Control:return"Control";case $.Ack:return"Ack";case $.Disconnect:return"Disconnect";case $.ReplayRequest:return"ReplayRequest";case $.Pause:return"PauseWriting";case $.Resume:return"ResumeWriting";case $.KeepAlive:return"KeepAlive"}}var a;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(a||(e.ProtocolConstants=a={}));class c{constructor(f,h,k,I){this.type=f,this.id=h,this.ack=k,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends E.$Zc{constructor(f){super(),this.f=this.B(new r.$qe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:a.HeaderLength,messageType:$.None,id:0,ack:0},this.a=f,this.b=!1,this.c=new y,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(f){if(!(!f||f.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(f);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent(D.ProtocolHeaderRead,{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,I=this.g.id,O=this.g.ack;if(this.g.readHead=!0,this.g.readLen=a.HeaderLength,this.g.messageType=$.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(D.ProtocolMessageRead,h),this.f.fire(new c(k,I,O,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(f){this.k=null,this.a=!1,this.b=!1,this.c=f,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(f){if(this.a)return;f.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=t.$Se.alloc(a.HeaderLength);h.writeUInt8(f.type,0),h.writeUInt32BE(f.id,1),h.writeUInt32BE(f.ack,5),h.writeUInt32BE(f.data.byteLength,9),this.c.traceSocketEvent(D.ProtocolHeaderWrite,{messageType:g(f.type),id:f.id,ack:f.ack,messageSize:f.data.byteLength}),this.c.traceSocketEvent(D.ProtocolMessageWrite,f.data),this.j(h,f.data)}g(f,h){const k=this.f===0;return this.d.push(f,h),this.f+=f.byteLength+h.byteLength,k}h(){const f=t.$Se.concat(this.d,this.f);return this.d.length=0,this.f=0,f}j(f,h){this.g(f,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const f=this.h();this.c.traceSocketEvent(D.ProtocolWrite,{byteLength:f.byteLength}),this.c.write(f)}}class p extends E.$Zc{constructor(f){super(),this.f=new r.$qe,this.onMessage=this.f.event,this.g=new r.$qe,this.onDidDispose=this.g.event,this.a=f,this.b=this.B(new b(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(h=>{h.type===$.Regular&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(f){this.b.write(new c($.Regular,0,0,f))}}e.$vi=p;class d extends P.$pi{static fromSocket(f,h){return new d(new p(f),h)}get onDidDispose(){return this.b.onDidDispose}constructor(f,h,k=null){super(f,h,k),this.b=f}dispose(){super.dispose();const f=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),f.end()}}e.$wi=d;class w{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$qe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(f){this.b?this.d.length>0?this.d.push(f):this.a.fire(f):this.d.push(f)}flushBuffer(){this.d=[]}}e.$xi=w;class o{constructor(f){this.data=f,this.next=null}}class l{constructor(){this.a=null,this.b=null}length(){let f=0,h=this.a;for(;h;)h=h.next,f++;return f}peek(){return this.a?this.a.data:null}toArray(){const f=[];let h=0,k=this.a;for(;k;)f[h++]=k.data,k=k.next;return f}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(f){const h=new o(f);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const f=Date.now();for(let h=0;h<n.a;h++)this.c[h]=f-1e3*h;setInterval(()=>{for(let h=n.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const f=Date.now(),h=(1+n.a)*1e3;let k=0;for(let I=0;I<n.a;I++)f-this.c[I]<=h&&k++;return 1-k/n.a}hasHighLoad(){return this.d()>=.5}}class u{get unacknowledgedCount(){return this.d-this.f}constructor(f){this.v=new w,this.onControlMessage=this.v.event,this.w=new w,this.onMessage=this.w.event,this.x=new w,this.onDidDispose=this.x.event,this.y=new w,this.onSocketClose=this.y.event,this.z=new w,this.onSocketTimeout=this.z.event,this.t=f.loadEstimator??n.getInstance(),this.u=f.sendKeepAlive??!0,this.a=!1,this.c=new l,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new E.$Yc,this.p=f.socket,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(h=>this.A(h))),this.s.add(this.p.onClose(h=>this.y.fire(h))),f.initialChunk&&this.r.acceptChunk(f.initialChunk),this.u?this.m=setInterval(()=>{this.E()},a.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const f=new c($.Disconnect,0,0,S());this.q.write(f),this.q.flush()}}sendPause(){const f=new c($.Pause,0,0,S());this.q.write(f)}sendResume(){const f=new c($.Resume,0,0,S());this.q.write(f)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(f,h){this.a=!0,this.s.dispose(),this.s=new E.$Yc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=f,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(k=>this.A(k))),this.s.add(this.p.onClose(k=>this.y.fire(k))),this.r.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.j=this.h;const f=new c($.Ack,0,this.j,S());this.q.write(f);const h=this.c.toArray();for(let k=0,I=h.length;k<I;k++)this.q.write(h[k]);this.C()}acceptDisconnect(){this.x.fire()}A(f){if(f.ack>this.f){this.f=f.ack;do{const h=this.c.peek();if(h&&h.id<=f.ack)this.c.pop();else break}while(!0)}switch(f.type){case $.None:break;case $.Regular:{if(f.id>this.h)if(f.id!==this.h+1){const h=Date.now();h-this.n>1e4&&(this.n=h,this.q.write(new c($.ReplayRequest,0,0,S())))}else this.h=f.id,this.k=Date.now(),this.B(),this.w.fire(f.data);break}case $.Control:{this.v.fire(f.data);break}case $.Ack:break;case $.Disconnect:{this.x.fire();break}case $.ReplayRequest:{const h=this.c.toArray();for(let k=0,I=h.length;k<I;k++)this.q.write(h[k]);this.C();break}case $.Pause:{this.q.pause();break}case $.Resume:{this.q.resume();break}case $.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(f){const h=++this.d;this.j=this.h;const k=new c($.Regular,h,this.j,f);this.c.push(k),this.a||(this.q.write(k),this.C())}sendControl(f){const h=new c($.Control,0,0,f);this.q.write(h)}B(){if(this.h<=this.j||this.l)return;const f=Date.now()-this.k;if(f>=a.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},a.AcknowledgeTime-f+5)}C(){if(this.d<=this.f||this.g||this.a)return;const f=this.c.peek(),h=Date.now()-f.writtenTime,k=Date.now()-this.r.lastReadTime,I=Date.now()-this.o;if(h>=a.TimeoutTime&&k>=a.TimeoutTime&&I>=a.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:k});return}const O=Math.max(a.TimeoutTime-h,a.TimeoutTime-k,a.TimeoutTime-I,500);this.g=setTimeout(()=>{this.g=null,this.C()},O)}D(){if(this.h<=this.j)return;this.j=this.h;const f=new c($.Ack,0,this.j,S());this.q.write(f)}E(){this.j=this.h;const f=new c($.KeepAlive,0,this.j,S());this.q.write(f)}}e.$yi=u}),define(Te[118],Oe([1,0,50,13,14,18,191,9,6,2,20,115,70,51]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0,T=Ve(T);class a extends g.$mi{constructor(b){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",p=>E.$Se.wrap(Buffer.from(p,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.$pr=a;class c{constructor(b,p){this.i=b,this.j=p,this.c=new Set,this.g=new Map,this.h=new v.$qe,this.onDidProcessExit=this.h.event;const d=p&&p.timeout?p.timeout:6e4;this.b=new r.$Hh(d),this.d=null,this.f=null}getChannel(b){const p=this;return{call(d,w,o){return p.k(b,d,w,o)},listen(d,w){return p.l(b,d,w)}}}k(b,p,d,w=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(T.$0());this.b.cancel();const o=this.n(b),l=(0,r.$xh)(i=>o.call(p,d,i)),n=w.onCancellationRequested(()=>l.cancel()),u=(0,s.$Xc)(()=>l.cancel());return this.c.add(u),l.finally(()=>{n.dispose(),this.c.delete(u),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),l}l(b,p,d){if(!this.b)return v.Event.None;this.b.cancel();let w;const o=new v.$qe({onWillAddFirstListener:()=>{w=this.n(b).listen(p,d)(o.fire,o),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const b=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,S.$ko)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,$.$rm)(p.env),this.d=(0,t.fork)(this.i,b,p);const d=new v.$qe,o=v.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,D.$lr)(h)){(0,D.log)(h,`IPC Library: ${this.j.serverName}`);return}d.fire(E.$Se.wrap(Buffer.from(h,"base64")))}),l=this.j.useQueue?(0,y.$Em)(this.d):this.d,n=h=>this.d&&this.d.connected&&l.send(h.buffer.toString("base64")),u=d.event,i={send:n,onMessage:u};this.f=new g.$ni(i);const f=()=>this.o();process.once("exit",f),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,k)=>{process.removeListener("exit",f),o.dispose(),this.c.forEach(I=>(0,s.$Uc)(I)),this.c.clear(),h!==0&&k!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+k),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:k})})}return this.f}n(b){let p=this.g.get(b);return p||(p=this.m.getChannel(b),this.g.set(b,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$qr=c}),define(Te[195],Oe([1,0,13,6,2,49,10]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.StorageState=e.StorageHint=void 0,e.$jq=v;var T;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function v($){const g=$;return g?.changed instanceof Map||g?.deleted instanceof Set}var s;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(s||(e.StorageState=s={}));class S extends E.$Zc{static{this.a=100}constructor(g,a=Object.create(null)){super(),this.r=g,this.s=a,this.b=this.B(new r.$te),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new t.$Ih(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(g=>this.u(g)))}u(g){this.b.pause();try{g.changed?.forEach((a,c)=>this.w(c,a)),g.deleted?.forEach(a=>this.w(a,void 0))}finally{this.b.resume()}}w(g,a){if(this.c===s.Closed)return;let c=!1;(0,D.$sg)(a)?c=this.f.delete(g):this.f.get(g)!==a&&(this.f.set(g,a),c=!0),c&&this.b.fire({key:g,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(g,a){const c=this.f.get(g);return(0,D.$sg)(c)?a:c}getBoolean(g,a){const c=this.get(g);return(0,D.$sg)(c)?a:c==="true"}getNumber(g,a){const c=this.get(g);return(0,D.$sg)(c)?a:parseInt(c,10)}getObject(g,a){const c=this.get(g);return(0,D.$sg)(c)?a:(0,P.$gi)(c)}async set(g,a,c=!1){if(this.c===s.Closed)return;if((0,D.$sg)(a))return this.delete(g,c);const m=(0,D.$lg)(a)||Array.isArray(a)?(0,P.$fi)(a):String(a);if(this.f.get(g)!==m)return this.f.set(g,m),this.j.set(g,m),this.h.delete(g),this.b.fire({key:g,external:c}),this.D()}async delete(g,a=!1){if(!(this.c===s.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire({key:g,external:a}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(g).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(g){if(!(this.c===s.Closed||this.m))return this.D(g)}async D(g){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),g)}async whenFlushed(){if(this.z)return new Promise(g=>this.n.push(g))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$kq=S;class y{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((a,c)=>this.a.set(c,a)),g.delete?.forEach(a=>this.a.delete(a))}async optimize(){}async close(){}}e.$lq=y}),define(Te[196],Oe([1,0,57,4,183,48,187,7]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$1u=e.$Zu=e.$Yu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Xu=e.$Wu=e.SymbolKinds=e.SymbolTag=e.$Uu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Su=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Ru=e.$Qu=e.$Pu=void 0,e.$Tu=u,e.$Vu=f;class v{constructor(U,ee,ae){this.offset=U,this.type=ee,this.language=ae,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Pu=v;class s{constructor(U,ee){this.tokens=U,this.endState=ee,this._tokenizationResultBrand=void 0}}e.$Qu=s;class S{constructor(U,ee){this.tokens=U,this.endState=ee,this._encodedTokenizationResultBrand=void 0}}e.$Ru=S;var y;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(y||(e.HoverVerbosityAction=y={}));var $;(function(j){j[j.Method=0]="Method",j[j.Function=1]="Function",j[j.Constructor=2]="Constructor",j[j.Field=3]="Field",j[j.Variable=4]="Variable",j[j.Class=5]="Class",j[j.Struct=6]="Struct",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Event=10]="Event",j[j.Operator=11]="Operator",j[j.Unit=12]="Unit",j[j.Value=13]="Value",j[j.Constant=14]="Constant",j[j.Enum=15]="Enum",j[j.EnumMember=16]="EnumMember",j[j.Keyword=17]="Keyword",j[j.Text=18]="Text",j[j.Color=19]="Color",j[j.File=20]="File",j[j.Reference=21]="Reference",j[j.Customcolor=22]="Customcolor",j[j.Folder=23]="Folder",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue",j[j.Snippet=27]="Snippet"})($||(e.CompletionItemKind=$={}));var g;(function(j){const U=new Map;U.set($.Method,t.$0j.symbolMethod),U.set($.Function,t.$0j.symbolFunction),U.set($.Constructor,t.$0j.symbolConstructor),U.set($.Field,t.$0j.symbolField),U.set($.Variable,t.$0j.symbolVariable),U.set($.Class,t.$0j.symbolClass),U.set($.Struct,t.$0j.symbolStruct),U.set($.Interface,t.$0j.symbolInterface),U.set($.Module,t.$0j.symbolModule),U.set($.Property,t.$0j.symbolProperty),U.set($.Event,t.$0j.symbolEvent),U.set($.Operator,t.$0j.symbolOperator),U.set($.Unit,t.$0j.symbolUnit),U.set($.Value,t.$0j.symbolValue),U.set($.Enum,t.$0j.symbolEnum),U.set($.Constant,t.$0j.symbolConstant),U.set($.Enum,t.$0j.symbolEnum),U.set($.EnumMember,t.$0j.symbolEnumMember),U.set($.Keyword,t.$0j.symbolKeyword),U.set($.Snippet,t.$0j.symbolSnippet),U.set($.Text,t.$0j.symbolText),U.set($.Color,t.$0j.symbolColor),U.set($.File,t.$0j.symbolFile),U.set($.Reference,t.$0j.symbolReference),U.set($.Customcolor,t.$0j.symbolCustomColor),U.set($.Folder,t.$0j.symbolFolder),U.set($.TypeParameter,t.$0j.symbolTypeParameter),U.set($.User,t.$0j.account),U.set($.Issue,t.$0j.issues);function ee(se){let ne=U.get(se);return ne||(console.info("No codicon found for CompletionItemKind "+se),ne=t.$0j.symbolProperty),ne}j.toIcon=ee;const ae=new Map;ae.set("method",$.Method),ae.set("function",$.Function),ae.set("constructor",$.Constructor),ae.set("field",$.Field),ae.set("variable",$.Variable),ae.set("class",$.Class),ae.set("struct",$.Struct),ae.set("interface",$.Interface),ae.set("module",$.Module),ae.set("property",$.Property),ae.set("event",$.Event),ae.set("operator",$.Operator),ae.set("unit",$.Unit),ae.set("value",$.Value),ae.set("constant",$.Constant),ae.set("enum",$.Enum),ae.set("enum-member",$.EnumMember),ae.set("enumMember",$.EnumMember),ae.set("keyword",$.Keyword),ae.set("snippet",$.Snippet),ae.set("text",$.Text),ae.set("color",$.Color),ae.set("file",$.File),ae.set("reference",$.Reference),ae.set("customcolor",$.Customcolor),ae.set("folder",$.Folder),ae.set("type-parameter",$.TypeParameter),ae.set("typeParameter",$.TypeParameter),ae.set("account",$.User),ae.set("issue",$.Issue);function ye(se,ne){let X=ae.get(se);return typeof X>"u"&&!ne&&(X=$.Property),X}j.fromString=ye})(g||(e.CompletionItemKinds=g={}));var a;(function(j){j[j.Deprecated=1]="Deprecated"})(a||(e.CompletionItemTag=a={}));var c;(function(j){j[j.None=0]="None",j[j.KeepWhitespace=1]="KeepWhitespace",j[j.InsertAsSnippet=4]="InsertAsSnippet"})(c||(e.CompletionItemInsertTextRule=c={}));var m;(function(j){j[j.Word=0]="Word",j[j.Line=1]="Line",j[j.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var b;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b||(e.CompletionTriggerKind=b={}));var p;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(p||(e.InlineCompletionTriggerKind=p={}));class d{constructor(U,ee,ae,ye){this.range=U,this.text=ee,this.completionKind=ae,this.isSnippetText=ye}equals(U){return P.$Wt.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}e.$Su=d;var w;(function(j){j[j.Invoke=1]="Invoke",j[j.Auto=2]="Auto"})(w||(e.CodeActionTriggerType=w={}));var o;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(o||(e.DocumentPasteTriggerKind=o={}));var l;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var n;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function u(j){return j&&r.URI.isUri(j.uri)&&P.$Wt.isIRange(j.range)&&(P.$Wt.isIRange(j.originSelectionRange)||P.$Wt.isIRange(j.targetSelectionRange))}var i;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(i||(e.SymbolKind=i={})),e.$Uu={[i.Array]:(0,T.localize)(788,null),[i.Boolean]:(0,T.localize)(789,null),[i.Class]:(0,T.localize)(790,null),[i.Constant]:(0,T.localize)(791,null),[i.Constructor]:(0,T.localize)(792,null),[i.Enum]:(0,T.localize)(793,null),[i.EnumMember]:(0,T.localize)(794,null),[i.Event]:(0,T.localize)(795,null),[i.Field]:(0,T.localize)(796,null),[i.File]:(0,T.localize)(797,null),[i.Function]:(0,T.localize)(798,null),[i.Interface]:(0,T.localize)(799,null),[i.Key]:(0,T.localize)(800,null),[i.Method]:(0,T.localize)(801,null),[i.Module]:(0,T.localize)(802,null),[i.Namespace]:(0,T.localize)(803,null),[i.Null]:(0,T.localize)(804,null),[i.Number]:(0,T.localize)(805,null),[i.Object]:(0,T.localize)(806,null),[i.Operator]:(0,T.localize)(807,null),[i.Package]:(0,T.localize)(808,null),[i.Property]:(0,T.localize)(809,null),[i.String]:(0,T.localize)(810,null),[i.Struct]:(0,T.localize)(811,null),[i.TypeParameter]:(0,T.localize)(812,null),[i.Variable]:(0,T.localize)(813,null)};function f(j,U){return(0,T.localize)(814,null,j,e.$Uu[U])}var h;(function(j){j[j.Deprecated=1]="Deprecated"})(h||(e.SymbolTag=h={}));var k;(function(j){const U=new Map;U.set(i.File,t.$0j.symbolFile),U.set(i.Module,t.$0j.symbolModule),U.set(i.Namespace,t.$0j.symbolNamespace),U.set(i.Package,t.$0j.symbolPackage),U.set(i.Class,t.$0j.symbolClass),U.set(i.Method,t.$0j.symbolMethod),U.set(i.Property,t.$0j.symbolProperty),U.set(i.Field,t.$0j.symbolField),U.set(i.Constructor,t.$0j.symbolConstructor),U.set(i.Enum,t.$0j.symbolEnum),U.set(i.Interface,t.$0j.symbolInterface),U.set(i.Function,t.$0j.symbolFunction),U.set(i.Variable,t.$0j.symbolVariable),U.set(i.Constant,t.$0j.symbolConstant),U.set(i.String,t.$0j.symbolString),U.set(i.Number,t.$0j.symbolNumber),U.set(i.Boolean,t.$0j.symbolBoolean),U.set(i.Array,t.$0j.symbolArray),U.set(i.Object,t.$0j.symbolObject),U.set(i.Key,t.$0j.symbolKey),U.set(i.Null,t.$0j.symbolNull),U.set(i.EnumMember,t.$0j.symbolEnumMember),U.set(i.Struct,t.$0j.symbolStruct),U.set(i.Event,t.$0j.symbolEvent),U.set(i.Operator,t.$0j.symbolOperator),U.set(i.TypeParameter,t.$0j.symbolTypeParameter);function ee(ae){let ye=U.get(ae);return ye||(console.info("No codicon found for SymbolKind "+ae),ye=t.$0j.symbolProperty),ye}j.toIcon=ee})(k||(e.SymbolKinds=k={}));class I{static asEditOperation(U){return E.$Xt.replace(P.$Wt.lift(U.range),U.text)}}e.$Wu=I;class O{static{this.Comment=new O("comment")}static{this.Imports=new O("imports")}static{this.Region=new O("region")}static fromValue(U){switch(U){case"comment":return O.Comment;case"imports":return O.Imports;case"region":return O.Region}return new O(U)}constructor(U){this.value=U}}e.$Xu=O;var C;(function(j){j[j.AIGenerated=1]="AIGenerated"})(C||(e.NewSymbolNameTag=C={}));var L;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(L||(e.NewSymbolNameTriggerKind=L={}));var R;(function(j){function U(ee){return!ee||typeof ee!="object"?!1:typeof ee.id=="string"&&typeof ee.title=="string"}j.is=U})(R||(e.Command=R={}));var M;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(M||(e.CommentThreadCollapsibleState=M={}));var G;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(G||(e.CommentThreadState=G={}));var Q;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(Q||(e.CommentThreadApplicability=Q={}));var te;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(te||(e.CommentMode=te={}));var ve;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ve||(e.CommentState=ve={}));var be;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(be||(e.InlayHintKind=be={}));class le{constructor(U){this.b=U,this.a=null}dispose(){this.a&&this.a.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Yu=le,e.$Zu=new D.$Gu,e.$1u=new D.$Gu;var K;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(K||(e.ExternalUriOpenerPriority=K={}));var B;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(Te[197],Oe([1,0,34,9,7]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.TokenType=void 0;var P;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(P||(e.TokenType=P={}));function D(...S){switch(S.length){case 1:return(0,E.localize)(1693,null,S[0]);case 2:return(0,E.localize)(1694,null,S[0],S[1]);case 3:return(0,E.localize)(1695,null,S[0],S[1],S[2]);default:return}}const T=(0,E.localize)(1696,null),v=(0,E.localize)(1697,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case P.LParen:return"(";case P.RParen:return")";case P.Neg:return"!";case P.Eq:return y.isTripleEq?"===":"==";case P.NotEq:return y.isTripleEq?"!==":"!=";case P.Lt:return"<";case P.LtEq:return"<=";case P.Gt:return">=";case P.GtEq:return">=";case P.RegexOp:return"=~";case P.RegexStr:return y.lexeme;case P.True:return"true";case P.False:return"false";case P.In:return"in";case P.Not:return"not";case P.And:return"&&";case P.Or:return"||";case P.Str:return y.lexeme;case P.QuotedStr:return y.lexeme;case P.Error:return y.lexeme;case P.EOF:return"EOF";default:throw(0,r.$_)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",P.Not],["in",P.In],["false",P.False],["true",P.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case t.CharCode.OpenParen:this.k(P.LParen);break;case t.CharCode.CloseParen:this.k(P.RParen);break;case t.CharCode.ExclamationMark:if(this.h(t.CharCode.Equals)){const $=this.h(t.CharCode.Equals);this.f.push({type:P.NotEq,offset:this.d,isTripleEq:$})}else this.k(P.Neg);break;case t.CharCode.SingleQuote:this.o();break;case t.CharCode.Slash:this.q();break;case t.CharCode.Equals:if(this.h(t.CharCode.Equals)){const $=this.h(t.CharCode.Equals);this.f.push({type:P.Eq,offset:this.d,isTripleEq:$})}else this.h(t.CharCode.Tilde)?this.k(P.RegexOp):this.l(D("==","=~"));break;case t.CharCode.LessThan:this.k(this.h(t.CharCode.Equals)?P.LtEq:P.Lt);break;case t.CharCode.GreaterThan:this.k(this.h(t.CharCode.Equals)?P.GtEq:P.Gt);break;case t.CharCode.Ampersand:this.h(t.CharCode.Ampersand)?this.k(P.And):this.l(D("&&"));break;case t.CharCode.Pipe:this.h(t.CharCode.Pipe)?this.k(P.Or):this.l(D("||"));break;case t.CharCode.Space:case t.CharCode.CarriageReturn:case t.CharCode.Tab:case t.CharCode.LineFeed:case t.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(P.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?t.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const $=this.d,g=this.c.substring(this.d,this.e),a={type:P.Error,offset:this.d,lexeme:g};this.g.push({offset:$,lexeme:g,additionalInfo:y}),this.f.push(a)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const $=this.c.substring(this.d,this.e),g=s.b.get($);g?this.k(g):this.f.push({type:P.Str,lexeme:$,offset:this.d})}}o(){for(;this.j()!==t.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:P.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,$=!1,g=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(v);return}const c=this.c.charCodeAt(y);if($)$=!1;else if(c===t.CharCode.Slash&&!g){y++;break}else c===t.CharCode.OpenSquareBracket?g=!0:c===t.CharCode.Backslash?$=!0:c===t.CharCode.CloseSquareBracket&&(g=!1);y++}for(;y<this.c.length&&s.a.has(this.c.charCodeAt(y));)y++;this.e=y;const a=this.c.substring(this.d,this.e);this.f.push({type:P.RegexStr,lexeme:a,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fj=s}),define(Te[198],Oe([1,0,6,2]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=void 0;class E{constructor(){this.a=new t.$qe,this.b=new t.$qe,this.c=new t.$qe,this.d=new t.$qe}static{this.ChannelName="extensionhostdebugservice"}call(T,v,s){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:s[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:s[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:s[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:s[0],port:s[1],subId:s[2]}))}throw new Error("Method not implemented.")}listen(T,v,s){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$6o=E;class P extends r.$Zc{constructor(T){super(),this.b=T}reload(T){this.b.call("reload",[T])}get onReload(){return this.b.listen("reload")}close(T){this.b.call("close",[T])}get onClose(){return this.b.listen("close")}attachSession(T,v,s){this.b.call("attach",[T,v,s])}get onAttachSession(){return this.b.listen("attach")}terminateSession(T,v){this.b.call("terminate",[T,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(T,v){return this.b.call("openExtensionDevelopmentHostWindow",[T,v])}}e.$7o=P}),define(Te[199],Oe([1,0,4]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=void 0;class r{constructor(D){this.a=D}listen(D,T,v){throw new Error("Invalid listen")}call(D,T,v){switch(T){case"download":return this.a.download(t.URI.revive(v[0]),t.URI.revive(v[1]))}throw new Error("Invalid call")}}e.$9o=r;class E{constructor(D,T){this.a=D,this.b=T}async download(D,T){const v=this.b();v&&(D=v.transformOutgoingURI(D),T=v.transformOutgoingURI(T)),await this.a.call("download",[D,T])}}e.$0o=E}),define(Te[200],Oe([1,0,189,79,12,8,32,19,4]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=void 0,e.$an=S,e.$bn=y,e.$$m=/^([^.]+\..+)[:=](.+)$/;class s{get appRoot(){return(0,P.$rc)(E.$5g.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,P.$oc)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,T.$lh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,T.$lh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,t.$0m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.$oc)(this.userDataPath,"logs",g)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.$lh)(v.URI.file((0,P.$oc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,T.$lh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,T.$lh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,T.$lh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=D.env.VSCODE_PORTABLE;return g?v.URI.file((0,P.$oc)(g,"argv.json")):(0,T.$lh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,P.$oc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,P.$pc)(g):(0,P.$mc)((0,P.$oc)(E.$5g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?v.URI.file((0,P.$pc)(g)):v.URI.file((0,P.$oc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,P.$pc)(g);const a=D.env.VSCODE_EXTENSIONS;if(a)return a;const c=D.env.VSCODE_PORTABLE;return c?(0,P.$oc)(c,"extensions"):(0,T.$lh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(a=>/^[^:/?#]+?:\/\//.test(a)?v.URI.parse(a):v.URI.file((0,P.$mc)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?v.URI.parse(g):v.URI.file((0,P.$mc)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.$$m.test(g))}get extensionLogLevel(){const g=[];for(const a of this.args.log||[]){const c=e.$$m.exec(a);c&&c[1]&&c[2]&&g.push([c[1],c[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,T.$lh)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=D.env.VSCODE_PORTABLE;return g?v.URI.file((0,P.$oc)(g,"policy.json")):(0,T.$lh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,a,c){this.a=g,this.b=a,this.c=c,this.editSessionId=this.args.editSessionId}}e.$_m=s,We([r.$ci],s.prototype,"appRoot",null),We([r.$ci],s.prototype,"userHome",null),We([r.$ci],s.prototype,"userDataPath",null),We([r.$ci],s.prototype,"appSettingsHome",null),We([r.$ci],s.prototype,"tmpDir",null),We([r.$ci],s.prototype,"cacheHome",null),We([r.$ci],s.prototype,"stateResource",null),We([r.$ci],s.prototype,"userRoamingDataHome",null),We([r.$ci],s.prototype,"userDataSyncHome",null),We([r.$ci],s.prototype,"sync",null),We([r.$ci],s.prototype,"machineSettingsResource",null),We([r.$ci],s.prototype,"workspaceStorageHome",null),We([r.$ci],s.prototype,"localHistoryHome",null),We([r.$ci],s.prototype,"keyboardLayoutResource",null),We([r.$ci],s.prototype,"argvResource",null),We([r.$ci],s.prototype,"isExtensionDevelopment",null),We([r.$ci],s.prototype,"untitledWorkspacesHome",null),We([r.$ci],s.prototype,"builtinExtensionsPath",null),We([r.$ci],s.prototype,"extensionsPath",null),We([r.$ci],s.prototype,"extensionDevelopmentLocationURI",null),We([r.$ci],s.prototype,"extensionDevelopmentKind",null),We([r.$ci],s.prototype,"extensionTestsLocationURI",null),We([r.$ci],s.prototype,"debugExtensionHost",null),We([r.$ci],s.prototype,"logLevel",null),We([r.$ci],s.prototype,"extensionLogLevel",null),We([r.$ci],s.prototype,"serviceMachineIdResource",null),We([r.$ci],s.prototype,"disableTelemetry",null),We([r.$ci],s.prototype,"disableWorkspaceTrust",null),We([r.$ci],s.prototype,"useInMemorySecretStorage",null),We([r.$ci],s.prototype,"policyFile",null);function S($,g){return y($["inspect-extensions"],$["inspect-brk-extensions"],5870,g,$.debugId,$.extensionEnvironment)}function y($,g,a,c,m,b){const d=Number(g||$)||(c?null:a),w=d?!!g:!1;let o;if(b)try{o=JSON.parse(b)}catch{}return{port:d,break:w,debugId:m,env:o}}});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[71],Oe([1,0,290,3,7]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=void 0,e.$Im=T,e.$Jm=s,e.$Km=g,e.$Lm=a,t=$t(t);const P={o:(0,E.localize)(1713,null),e:(0,E.localize)(1714,null),t:(0,E.localize)(1715,null)};e.$Gm=["tunnel","serve-web"],e.$Hm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(1716,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(1717,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(1718,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(1719,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(1720,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(1721,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(1722,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(1723,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(1724,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(1725,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(1726,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(1727,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(1728,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(1729,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(1730,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(1731,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(1732,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(1733,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(1734,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(1735,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(1736,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(1737,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(1738,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(1739,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(1740,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(1741,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(1742,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(1743,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(1744,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(1745,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(1746,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(1747,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,E.localize)(1748,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(1749,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(1750,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(1751,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function T(c,m,b=D){const p=c.find(h=>h.length>0&&h[0]!=="-"),d={},w=["_"],o=[],l={};let n;for(const h in m){const k=m[h];k.type==="subcommand"?h===p&&(n=k):(k.alias&&(d[h]=k.alias),k.type==="string"||k.type==="string[]"?(w.push(h),k.deprecates&&w.push(...k.deprecates)):k.type==="boolean"&&(o.push(h),k.deprecates&&o.push(...k.deprecates)),k.global&&(l[h]=k))}if(n&&p){const h=l;for(const C in n.options)h[C]=n.options[C];const k=c.filter(C=>C!==p),I=b.getSubcommandReporter?b.getSubcommandReporter(p):void 0,O=T(k,h,I);return{[p]:O,_:[]}}const u=(0,t.default)(c,{string:w,boolean:o,alias:d}),i={},f=u;i._=u._.map(h=>String(h)).filter(h=>h.length>0),delete f._;for(const h in m){const k=m[h];if(k.type==="subcommand")continue;k.alias&&delete f[k.alias];let I=f[h];if(k.deprecates)for(const O of k.deprecates)f.hasOwnProperty(O)&&(I||(I=f[O],I&&b.onDeprecatedOption(O,k.deprecationMessage||(0,E.localize)(1752,null,h))),delete f[O]);if(typeof I<"u"){if(k.type==="string[]"){if(Array.isArray(I)||(I=[I]),!k.allowEmptyValue){const O=I.filter(C=>C.length>0);O.length!==I.length&&(b.onEmptyValue(h),I=O.length>0?O:void 0)}}else k.type==="string"&&(Array.isArray(I)?(I=I.pop(),b.onMultipleValues(h,I)):!I&&!k.allowEmptyValue&&(b.onEmptyValue(h),I=void 0));i[h]=I,k.deprecationMessage&&b.onDeprecatedOption(h,k.deprecationMessage)}delete f[h]}for(const h in f)b.onUnknownOption(h);return i}function v(c,m){let b="";return m.args&&(Array.isArray(m.args)?b=` <${m.args.join("> <")}>`:b=` <${m.args}>`),m.alias?`-${m.alias} --${c}${b}`:`--${c}${b}`}function s(c,m){const b=[];for(const p in c){const d=c[p],w=v(p,d);b.push([w,d.description])}return S(b,m)}function S(c,m){const p=c.reduce((o,l)=>Math.max(o,l[0].length),12)+2+1;if(m-p<25)return c.reduce((o,l)=>o.concat([`  ${l[0]}`,`      ${l[1]}`]),[]);const d=m-p-1,w=[];for(const o of c){const l=o[0],n=$(o[1],d),u=y(p-l.length-2);w.push("  "+l+u+n[0]);for(let i=1;i<n.length;i++)w.push(y(p)+n[i])}return w}function y(c){return" ".repeat(c)}function $(c,m){const b=[];for(;c.length;){const p=c.length<m?c.length:c.lastIndexOf(" ",m),d=c.slice(0,p).trim();c=c.slice(p),b.push(d)}return b}function g(c,m,b,p,d){const w=process.stdout.isTTY&&process.stdout.columns||80,o=d?.noInputFiles!==!0?`[${(0,E.localize)(1753,null)}...]`:"",l=[`${c} ${b}`];l.push(""),l.push(`${(0,E.localize)(1754,null)}: ${m} [${(0,E.localize)(1755,null)}]${o}`),l.push(""),d?.noPipe!==!0&&(r.$l?l.push((0,E.localize)(1756,null,m)):l.push((0,E.localize)(1757,null,m)),l.push(""));const n={},u=[];for(const i in p){const f=p[i];if(f.type==="subcommand")f.description&&u.push({command:i,description:f.description});else if(f.description&&f.cat){let h=n[f.cat];h||(n[f.cat]=h={}),h[i]=f}}for(const i in n){const f=i,h=n[f];h&&(l.push(P[f]),l.push(...s(h,w)),l.push(""))}return u.length&&(l.push((0,E.localize)(1758,null)),l.push(...S(u.map(i=>[i.command,i.description]),w)),l.push("")),l.join(`
`)}function a(c,m){return`${c||(0,E.localize)(1759,null)}
${m||(0,E.localize)(1760,null)}
${process.arch}`}});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[201],Oe([1,0,291,7,71]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=T,e.$Nm=v,e.$Om=s,e.$Pm=S,t=$t(t);function P(y,$){const g=(d,w)=>{console.warn((0,r.localize)(1761,null,d,w))},a=d=>{console.warn((0,r.localize)(1762,null,d))},c=(d,w)=>{console.warn((0,r.localize)(1763,null,d,w))},m=d=>({onUnknownOption:w=>{E.$Gm.includes(d)||console.warn((0,r.localize)(1764,null,w,d))},onMultipleValues:g,onEmptyValue:a,onDeprecatedOption:c,getSubcommandReporter:E.$Gm.includes(d)?m:void 0}),b={onUnknownOption:d=>{console.warn((0,r.localize)(1765,null,d))},onMultipleValues:g,onEmptyValue:a,onDeprecatedOption:c,getSubcommandReporter:m},p=(0,E.$Im)(y,E.$Hm,$?b:void 0);return p.goto&&p._.forEach(d=>(0,t.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(d),(0,r.localize)(1766,null))),p}function D(y){const $=y.findIndex(g=>!/^-/.test(g));if($>-1)return[...y.slice(0,$),...y.slice($+1)]}function T(y){let[,...$]=y;process.env.VSCODE_DEV&&($=D($)||[]);const g=!S(process.env);return P($,g)}function v(y){let[,,...$]=y;return process.env.VSCODE_DEV&&($=D($)||[]),P($,!0)}function s(y,...$){const g=y.indexOf("--");return g===-1?y.push(...$):y.splice(g,0,...$),y}function S(y){return y.VSCODE_CLI==="1"}}),function(){function ue(e,t,r){function E(D,T){const v=P(D,T),s=[v];return e.isAbsolute(v)||s.unshift(r),e.resolve(...s)}function P(D,T){process.env.VSCODE_DEV&&(T="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let s=process.env.VSCODE_APPDATA;if(s)return e.join(s,T);const S=D["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(s=process.env.APPDATA,!s){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");s=e.join(y,"AppData","Roaming")}break;case"darwin":s=e.join(t.homedir(),"Library","Application Support");break;case"linux":s=process.env.XDG_CONFIG_HOME||e.join(t.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(s,T)}return{getUserDataPath:E}}if(typeof define=="function")define(Te[202],Oe([68,31,32]),function(e,t,r){return ue(e,t,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),t=require("os");module.exports=ue(e,t,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Te[119],Oe([1,0,31,200,202]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$dn=D,e.$en=T;class P extends r.$_m{constructor(s,S){super(s,{homeDir:(0,t.homedir)(),tmpDir:(0,t.tmpdir)(),userDataDir:(0,E.getUserDataPath)(s,S.nameShort)},S)}}e.$cn=P;function D(v,s){return(0,r.$bn)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,s,v.extensionEnvironment)}function T(v,s){return(0,r.$bn)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,s,v.extensionEnvironment)}}),define(Te[203],Oe([1,0,10,7]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=E;function E(D,T,v,s){try{P(D,T,v,s)}catch(S){D.error(S?.message??S)}return T}function P(D,T,v,s){const S=(y,$,g)=>{const a=y[$];if((0,t.$jg)(a)){const c=a,m=c.length;if(m>1&&c[0]==="%"&&c[m-1]==="%"){const b=c.substr(1,m-2);let p=v[b];p===void 0&&s&&(p=s[b]);const d=typeof p=="string"?p:p?.message,w=s?.[b],o=typeof w=="string"?w:w?.message;if(!d){o||D.warn(`[${T.name}]: ${(0,r.localize)(1814,null,b)}`);return}if(g&&($==="title"||$==="category")&&o&&o!==d){const l={value:d,original:o};y[$]=l}else y[$]=d}}else if((0,t.$lg)(a))for(const c in a)a.hasOwnProperty(c)&&(c==="commands"?S(a,c,!0):S(a,c,g));else if(Array.isArray(a))for(let c=0;c<a.length;c++)S(a,c,g)};for(const y in T)T.hasOwnProperty(y)&&S(T,y)}}),define(Te[120],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const t={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribChatParticipantDetection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribChatParticipantDetection.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(t)}),define(Te[72],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=void 0;class t{constructor(E,P=[],D=!1){this.ctor=E,this.staticArguments=P,this.supportsDelayedInstantiation=D}}e.$Hi=t}),define(Te[121],Oe([1,0,72]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Zs=P,e.$1s=D;const r=[];var E;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(E||(e.InstantiationType=E={}));function P(T,v,s){v instanceof t.$Hi||(v=new t.$Hi(v,[],!!s)),r.push([T,v])}function D(){return r}}),define(Te[204],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;class t{constructor(P,D){this.key=P,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$Cr=t;class r{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const D of this.a.values())D.outgoing.size===0&&P.push(D);return P}insertEdge(P,D){const T=this.lookupOrInsertNode(P),v=this.lookupOrInsertNode(D);T.outgoing.set(v.key,v),v.incoming.set(T.key,T)}removeNode(P){const D=this.b(P);this.a.delete(D);for(const T of this.a.values())T.outgoing.delete(D),T.incoming.delete(D)}lookupOrInsertNode(P){const D=this.b(P);let T=this.a.get(D);return T||(T=new t(D,P),this.a.set(D,T)),T}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[D,T]of this.a)P.push(`${D}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,D]of this.a){const T=new Set([P]),v=this.c(D,T);if(v)return v}}c(P,D){for(const[T,v]of P.outgoing){if(D.has(T))return[...D,T].join(" -> ");D.add(T);const s=this.c(v,D);if(s)return s;D.delete(T)}}}e.$Dr=r}),define(Te[5],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e._util=void 0,e.$Ki=E,e.$Li=P;var t;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function T(v){return v[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=T})(t||(e._util=t={})),e.$Ji=E("instantiationService");function r(D,T,v){T[t.DI_TARGET]===T?T[t.DI_DEPENDENCIES].push({id:D,index:v}):(T[t.DI_DEPENDENCIES]=[{id:D,index:v}],T[t.DI_TARGET]=T)}function E(D){if(t.serviceIds.has(D))return t.serviceIds.get(D);const T=function(v,s,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(T,v,S)};return T.toString=()=>D,t.serviceIds.set(D,T),T}function P(D){return D}}),define(Te[28],Oe([1,0,10,4,5]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$ej=void 0,e.$fj=P,e.$gj=D,e.$hj=v,e.$ij=s,e.$jj=S,e.$kj=y,e.$lj=$,e.$mj=a,e.$nj=c,e.$oj=m,t=Ve(t),e.$ej=(0,E.$Ki)("configurationService");function P(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof r.URI)}function D(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||Array.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof r.URI)}var T;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.USER=2]="USER",b[b.USER_LOCAL=3]="USER_LOCAL",b[b.USER_REMOTE=4]="USER_REMOTE",b[b.WORKSPACE=5]="WORKSPACE",b[b.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",b[b.DEFAULT=7]="DEFAULT",b[b.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function v(b){switch(b){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function s(b){return b.applicationValue!==void 0||b.userValue!==void 0||b.userLocalValue!==void 0||b.userRemoteValue!==void 0||b.workspaceValue!==void 0||b.workspaceFolderValue!==void 0}function S(b,p){const d=Object.create(null);for(const w in b)y(d,w,b[w],p);return d}function y(b,p,d,w){const o=p.split("."),l=o.pop();let n=b;for(let u=0;u<o.length;u++){const i=o[u];let f=n[i];switch(typeof f){case"undefined":f=n[i]=Object.create(null);break;case"object":if(f===null){w(`Ignoring ${p} as ${o.slice(0,u+1).join(".")} is null`);return}break;default:w(`Ignoring ${p} as ${o.slice(0,u+1).join(".")} is ${JSON.stringify(f)}`);return}n=f}if(typeof n=="object"&&n!==null)try{n[l]=d}catch{w(`Ignoring ${p} as ${o.join(".")} is ${JSON.stringify(n)}`)}else w(`Ignoring ${p} as ${o.join(".")} is ${JSON.stringify(n)}`)}function $(b,p){const d=p.split(".");g(b,d)}function g(b,p){const d=p.shift();if(p.length===0){delete b[d];return}if(Object.keys(b).indexOf(d)!==-1){const w=b[d];typeof w=="object"&&!Array.isArray(w)&&(g(w,p),Object.keys(w).length===0&&delete b[d])}}function a(b,p,d){function w(n,u){let i=n;for(const f of u){if(typeof i!="object"||i===null)return;i=i[f]}return i}const o=p.split("."),l=w(b,o);return typeof l>"u"?d:l}function c(b,p,d){Object.keys(p).forEach(w=>{w!=="__proto__"&&(w in b?t.$lg(b[w])&&t.$lg(p[w])?c(b[w],p[w],d):d&&(b[w]=p[w]):b[w]=p[w])})}function m(b){return b.replace(/[\[\]]/g,"")}}),define(Te[41],Oe([1,0,34,3,16,197,5,7,9]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Ij=e.$Hj=e.ContextKeyExprType=void 0,e.$Gj=S,e.$Jj=u,e.$Kj=i,e.$4j=se;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",r.$m),s.set("isLinux",r.$n),s.set("isWindows",r.$l),s.set("isWeb",r.$r),s.set("isMacNative",r.$m&&!r.$r),s.set("isEdge",r.$K),s.set("isFirefox",r.$I),s.set("isChrome",r.$H),s.set("isSafari",r.$J);function S(z,A){if(s.get(z)!==void 0)throw(0,v.$$)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(z,A)}const y=Object.prototype.hasOwnProperty;var $;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})($||(e.ContextKeyExprType=$={}));const g={regexParsingWithErrorRecovery:!0},a=(0,T.localize)(1673,null),c=(0,T.localize)(1674,null),m=(0,T.localize)(1675,null),b=(0,T.localize)(1676,null),p=(0,T.localize)(1677,null),d=(0,T.localize)(1678,null),w=(0,T.localize)(1679,null),o=(0,T.localize)(1680,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=g){this.k=A,this.d=new P.$Fj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:a,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const Y=this.l();if(!this.E()){const pe=this.D(),x=pe.type===P.TokenType.Str?d:void 0;throw this.h.push({message:p,offset:pe.offset,lexeme:P.$Fj.getLexeme(pe),additionalInfo:x}),l.c}return Y}catch(Y){if(Y!==l.c)throw Y;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(P.TokenType.Or);){const Y=this.o();A.push(Y)}return A.length===1?A[0]:n.or(...A)}o(){const A=[this.s()];for(;this.y(P.TokenType.And);){const Y=this.s();A.push(Y)}return A.length===1?A[0]:n.and(...A)}s(){if(this.y(P.TokenType.Neg)){const A=this.D();switch(A.type){case P.TokenType.True:return this.z(),h.INSTANCE;case P.TokenType.False:return this.z(),k.INSTANCE;case P.TokenType.LParen:{this.z();const Y=this.l();return this.A(P.TokenType.RParen,b),Y?.negate()}case P.TokenType.Str:return this.z(),M.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case P.TokenType.True:return this.z(),n.true();case P.TokenType.False:return this.z(),n.false();case P.TokenType.LParen:{this.z();const Y=this.l();return this.A(P.TokenType.RParen,b),Y}case P.TokenType.Str:{const Y=A.lexeme;if(this.z(),this.y(P.TokenType.RegexOp)){const x=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),x.type!==P.TokenType.RegexStr)throw this.B("REGEX",x);const ie=x.lexeme,W=ie.lastIndexOf("/"),Z=W===ie.length-1?void 0:this.w(ie.substring(W+1));let ce;try{ce=new RegExp(ie.substring(1,W),Z)}catch{throw this.B("REGEX",x)}return le.create(Y,ce)}switch(x.type){case P.TokenType.RegexStr:case P.TokenType.Error:{const ie=[x.lexeme];this.z();let W=this.D(),Z=0;for(let qe=0;qe<x.lexeme.length;qe++)x.lexeme.charCodeAt(qe)===t.CharCode.OpenParen?Z++:x.lexeme.charCodeAt(qe)===t.CharCode.CloseParen&&Z--;for(;!this.E()&&W.type!==P.TokenType.And&&W.type!==P.TokenType.Or;){switch(W.type){case P.TokenType.LParen:Z++;break;case P.TokenType.RParen:Z--;break;case P.TokenType.RegexStr:case P.TokenType.QuotedStr:for(let qe=0;qe<W.lexeme.length;qe++)W.lexeme.charCodeAt(qe)===t.CharCode.OpenParen?Z++:x.lexeme.charCodeAt(qe)===t.CharCode.CloseParen&&Z--}if(Z<0)break;ie.push(P.$Fj.getLexeme(W)),this.z(),W=this.D()}const ce=ie.join(""),we=ce.lastIndexOf("/"),Le=we===ce.length-1?void 0:this.w(ce.substring(we+1));let ze;try{ze=new RegExp(ce.substring(1,we),Le)}catch{throw this.B("REGEX",x)}return n.regex(Y,ze)}case P.TokenType.QuotedStr:{const ie=x.lexeme;this.z();let W=null;if(!(0,E.$hf)(ie)){const Z=ie.indexOf("/"),ce=ie.lastIndexOf("/");if(Z!==ce&&Z>=0){const we=ie.slice(Z+1,ce),Le=ie[ce+1]==="i"?"i":"";try{W=new RegExp(we,Le)}catch{throw this.B("REGEX",x)}}}if(W===null)throw this.B("REGEX",x);return le.create(Y,W)}default:throw this.B("REGEX",this.D())}}if(this.y(P.TokenType.Not)){this.A(P.TokenType.In,m);const x=this.u();return n.notIn(Y,x)}switch(this.D().type){case P.TokenType.Eq:{this.z();const x=this.u();if(this.x().type===P.TokenType.QuotedStr)return n.equals(Y,x);switch(x){case"true":return n.has(Y);case"false":return n.not(Y);default:return n.equals(Y,x)}}case P.TokenType.NotEq:{this.z();const x=this.u();if(this.x().type===P.TokenType.QuotedStr)return n.notEquals(Y,x);switch(x){case"true":return n.not(Y);case"false":return n.has(Y);default:return n.notEquals(Y,x)}}case P.TokenType.Lt:return this.z(),ve.create(Y,this.u());case P.TokenType.LtEq:return this.z(),be.create(Y,this.u());case P.TokenType.Gt:return this.z(),Q.create(Y,this.u());case P.TokenType.GtEq:return this.z(),te.create(Y,this.u());case P.TokenType.In:return this.z(),n.in(Y,this.u());default:return n.has(Y)}}case P.TokenType.EOF:throw this.h.push({message:w,offset:A.offset,lexeme:"",additionalInfo:o}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case P.TokenType.Str:case P.TokenType.QuotedStr:return this.z(),A.lexeme;case P.TokenType.True:return this.z(),"true";case P.TokenType.False:return this.z(),"false";case P.TokenType.In:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,Y){if(this.C(A))return this.z();throw this.B(Y,this.D())}B(A,Y,pe){const x=(0,T.localize)(1681,null,A,P.$Fj.getLexeme(Y)),ie=Y.offset,W=P.$Fj.getLexeme(Y);return this.h.push({message:x,offset:ie,lexeme:W,additionalInfo:pe}),l.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===P.TokenType.EOF}}e.$Hj=l;class n{static false(){return h.INSTANCE}static true(){return k.INSTANCE}static has(A){return I.create(A)}static equals(A,Y){return O.create(A,Y)}static notEquals(A,Y){return R.create(A,Y)}static regex(A,Y){return le.create(A,Y)}static in(A,Y){return C.create(A,Y)}static notIn(A,Y){return L.create(A,Y)}static not(A){return M.create(A)}static and(...A){return j.create(A,null,!0)}static or(...A){return U.create(A,null,!0)}static greater(A,Y){return Q.create(A,Y)}static greaterEquals(A,Y){return te.create(A,Y)}static smaller(A,Y){return ve.create(A,Y)}static smallerEquals(A,Y){return be.create(A,Y)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.$Ij=n;function u(z){const A=new l({regexParsingWithErrorRecovery:!1});return z.map(Y=>(A.parse(Y),A.lexingErrors.length>0?A.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,T.localize)(1682,null,pe.additionalInfo):(0,T.localize)(1683,null),offset:pe.offset,length:pe.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function i(z,A){const Y=z?z.substituteConstants():void 0,pe=A?A.substituteConstants():void 0;return!Y&&!pe?!0:!Y||!pe?!1:Y.equals(pe)}function f(z,A){return z.cmp(A)}class h{static{this.INSTANCE=new h}constructor(){this.type=$.False}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return k.INSTANCE}}e.$Lj=h;class k{static{this.INSTANCE=new k}constructor(){this.type=$.True}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return h.INSTANCE}}e.$Mj=k;class I{static create(A,Y=null){const pe=s.get(A);return typeof pe=="boolean"?pe?k.INSTANCE:h.INSTANCE:new I(A,Y)}constructor(A,Y){this.key=A,this.c=Y,this.type=$.Defined}cmp(A){return A.type!==this.type?this.type-A.type:ae(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=s.get(this.key);return typeof A=="boolean"?A?k.INSTANCE:h.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Nj=I;class O{static create(A,Y,pe=null){if(typeof Y=="boolean")return Y?I.create(A,pe):M.create(A,pe);const x=s.get(A);return typeof x=="boolean"?Y===(x?"true":"false")?k.INSTANCE:h.INSTANCE:new O(A,Y,pe)}constructor(A,Y,pe){this.c=A,this.d=Y,this.f=pe,this.type=$.Equals}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=s.get(this.c);if(typeof A=="boolean"){const Y=A?"true":"false";return this.d===Y?k.INSTANCE:h.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Oj=O;class C{static create(A,Y){return new C(A,Y)}constructor(A,Y){this.d=A,this.f=Y,this.type=$.In,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const Y=A.getValue(this.f),pe=A.getValue(this.d);return Array.isArray(Y)?Y.includes(pe):typeof pe=="string"&&typeof Y=="object"&&Y!==null?y.call(Y,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=L.create(this.d,this.f)),this.c}}e.$Pj=C;class L{static create(A,Y){return new L(A,Y)}constructor(A,Y){this.d=A,this.f=Y,this.type=$.NotIn,this.c=C.create(A,Y)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qj=L;class R{static create(A,Y,pe=null){if(typeof Y=="boolean")return Y?M.create(A,pe):I.create(A,pe);const x=s.get(A);return typeof x=="boolean"?Y===(x?"true":"false")?h.INSTANCE:k.INSTANCE:new R(A,Y,pe)}constructor(A,Y,pe){this.c=A,this.d=Y,this.f=pe,this.type=$.NotEquals}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=s.get(this.c);if(typeof A=="boolean"){const Y=A?"true":"false";return this.d===Y?h.INSTANCE:k.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Rj=R;class M{static create(A,Y=null){const pe=s.get(A);return typeof pe=="boolean"?pe?h.INSTANCE:k.INSTANCE:new M(A,Y)}constructor(A,Y){this.c=A,this.d=Y,this.type=$.Not}cmp(A){return A.type!==this.type?this.type-A.type:ae(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=s.get(this.c);return typeof A=="boolean"?A?h.INSTANCE:k.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Sj=M;function G(z,A){if(typeof z=="string"){const Y=parseFloat(z);isNaN(Y)||(z=Y)}return typeof z=="string"||typeof z=="number"?A(z):h.INSTANCE}class Q{static create(A,Y,pe=null){return G(Y,x=>new Q(A,x,pe))}constructor(A,Y,pe){this.c=A,this.d=Y,this.f=pe,this.type=$.Greater}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=be.create(this.c,this.d,this)),this.f}}e.$Tj=Q;class te{static create(A,Y,pe=null){return G(Y,x=>new te(A,x,pe))}constructor(A,Y,pe){this.c=A,this.d=Y,this.f=pe,this.type=$.GreaterEquals}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ve.create(this.c,this.d,this)),this.f}}e.$Uj=te;class ve{static create(A,Y,pe=null){return G(Y,x=>new ve(A,x,pe))}constructor(A,Y,pe){this.c=A,this.d=Y,this.f=pe,this.type=$.Smaller}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Vj=ve;class be{static create(A,Y,pe=null){return G(Y,x=>new be(A,x,pe))}constructor(A,Y,pe){this.c=A,this.d=Y,this.f=pe,this.type=$.SmallerEquals}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Wj=be;class le{static create(A,Y){return new le(A,Y)}constructor(A,Y){this.d=A,this.f=Y,this.type=$.Regex,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const Y=this.f?this.f.source:"",pe=A.f?A.f.source:"";return Y<pe?-1:Y>pe?1:0}equals(A){if(A.type===this.type){const Y=this.f?this.f.source:"",pe=A.f?A.f.source:"";return this.d===A.d&&Y===pe}return!1}substituteConstants(){return this}evaluate(A){const Y=A.getValue(this.d);return this.f?this.f.test(Y):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Xj=le;class K{static create(A){return new K(A)}constructor(A){this.c=A,this.type=$.NotRegex}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new K(this.c.map(A))}negate(){return this.c}}e.$Yj=K;function B(z){let A=null;for(let Y=0,pe=z.length;Y<pe;Y++){const x=z[Y].substituteConstants();if(z[Y]!==x&&A===null){A=[];for(let ie=0;ie<Y;ie++)A[ie]=z[ie]}A!==null&&(A[Y]=x)}return A===null?z:A}class j{static create(A,Y,pe){return j.d(A,Y,pe)}constructor(A,Y){this.expr=A,this.c=Y,this.type=$.And}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let Y=0,pe=this.expr.length;Y<pe;Y++){const x=f(this.expr[Y],A.expr[Y]);if(x!==0)return x}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let Y=0,pe=this.expr.length;Y<pe;Y++)if(!this.expr[Y].equals(A.expr[Y]))return!1;return!0}return!1}substituteConstants(){const A=B(this.expr);return A===this.expr?this:j.create(A,this.c,!1)}evaluate(A){for(let Y=0,pe=this.expr.length;Y<pe;Y++)if(!this.expr[Y].evaluate(A))return!1;return!0}static d(A,Y,pe){const x=[];let ie=!1;for(const W of A)if(W){if(W.type===$.True){ie=!0;continue}if(W.type===$.False)return h.INSTANCE;if(W.type===$.And){x.push(...W.expr);continue}x.push(W)}if(x.length===0&&ie)return k.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(f);for(let W=1;W<x.length;W++)x[W-1].equals(x[W])&&(x.splice(W,1),W--);if(x.length===1)return x[0];for(;x.length>1;){const W=x[x.length-1];if(W.type!==$.Or)break;x.pop();const Z=x.pop(),ce=x.length===0,we=U.create(W.expr.map(Le=>j.create([Le,Z],null,pe)),null,ce);we&&(x.push(we),x.sort(f))}if(x.length===1)return x[0];if(pe){for(let W=0;W<x.length;W++)for(let Z=W+1;Z<x.length;Z++)if(x[W].negate().equals(x[Z]))return h.INSTANCE;if(x.length===1)return x[0]}return new j(x,Y)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const Y of this.expr)A.push(...Y.keys());return A}map(A){return new j(this.expr.map(Y=>Y.map(A)),null)}negate(){if(!this.c){const A=[];for(const Y of this.expr)A.push(Y.negate());this.c=U.create(A,this,!0)}return this.c}}e.$Zj=j;class U{static create(A,Y,pe){return U.d(A,Y,pe)}constructor(A,Y){this.expr=A,this.c=Y,this.type=$.Or}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let Y=0,pe=this.expr.length;Y<pe;Y++){const x=f(this.expr[Y],A.expr[Y]);if(x!==0)return x}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let Y=0,pe=this.expr.length;Y<pe;Y++)if(!this.expr[Y].equals(A.expr[Y]))return!1;return!0}return!1}substituteConstants(){const A=B(this.expr);return A===this.expr?this:U.create(A,this.c,!1)}evaluate(A){for(let Y=0,pe=this.expr.length;Y<pe;Y++)if(this.expr[Y].evaluate(A))return!0;return!1}static d(A,Y,pe){let x=[],ie=!1;if(A){for(let W=0,Z=A.length;W<Z;W++){const ce=A[W];if(ce){if(ce.type===$.False){ie=!0;continue}if(ce.type===$.True)return k.INSTANCE;if(ce.type===$.Or){x=x.concat(ce.expr);continue}x.push(ce)}}if(x.length===0&&ie)return h.INSTANCE;x.sort(f)}if(x.length!==0){if(x.length===1)return x[0];for(let W=1;W<x.length;W++)x[W-1].equals(x[W])&&(x.splice(W,1),W--);if(x.length===1)return x[0];if(pe){for(let W=0;W<x.length;W++)for(let Z=W+1;Z<x.length;Z++)if(x[W].negate().equals(x[Z]))return k.INSTANCE;if(x.length===1)return x[0]}return new U(x,Y)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const Y of this.expr)A.push(...Y.keys());return A}map(A){return new U(this.expr.map(Y=>Y.map(A)),null)}negate(){if(!this.c){const A=[];for(const Y of this.expr)A.push(Y.negate());for(;A.length>1;){const Y=A.shift(),pe=A.shift(),x=[];for(const ie of X(Y))for(const W of X(pe))x.push(j.create([ie,W],null,!1));A.unshift(U.create(x,null,!1))}this.c=U.create(A,this,!0)}return this.c}}e.$1j=U;class ee extends I{static{this.d=[]}static all(){return ee.d.values()}constructor(A,Y,pe){super(A,null),this.f=Y,typeof pe=="object"?ee.d.push({...pe,key:A}):pe!==!0&&ee.d.push({key:A,description:pe,type:Y!=null?typeof Y:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return O.create(this.key,A)}notEqualsTo(A){return R.create(this.key,A)}}e.$2j=ee,e.$3j=(0,D.$Ki)("contextKeyService");function ae(z,A){return z<A?-1:z>A?1:0}function ye(z,A,Y,pe){return z<Y?-1:z>Y?1:A<pe?-1:A>pe?1:0}function se(z,A){if(z.type===$.False||A.type===$.True)return!0;if(z.type===$.Or)return A.type===$.Or?ne(z.expr,A.expr):!1;if(A.type===$.Or){for(const Y of A.expr)if(se(z,Y))return!0;return!1}if(z.type===$.And){if(A.type===$.And)return ne(A.expr,z.expr);for(const Y of z.expr)if(se(Y,A))return!0;return!1}return z.equals(A)}function ne(z,A){let Y=0,pe=0;for(;Y<z.length&&pe<A.length;){const x=z[Y].cmp(A[pe]);if(x<0)return!1;x===0&&Y++,pe++}return Y===z.length}function X(z){return z.type===$.Or?z.expr:[z]}}),define(Te[205],Oe([1,0,41,5]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.$At=e.AccessibilitySupport=e.$zt=void 0,e.$Bt=P,e.$zt=(0,r.$Ki)("accessibilityService");var E;(function(D){D[D.Unknown=0]="Unknown",D[D.Disabled=1]="Disabled",D[D.Enabled=2]="Enabled"})(E||(e.AccessibilitySupport=E={})),e.$At=new t.$2j("accessibilityModeEnabled",!1);function P(D){return D&&typeof D=="object"&&typeof D.label=="string"&&(typeof D.role>"u"||typeof D.role=="string")}e.$Ct="ACCESSIBLE_VIEW_SHOWN_"}),define(Te[206],Oe([1,0,17,20,3,173,108,184,185,7,205]),function(ue,e,t,r,E,P,D,T,v,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=d,e.clampedInt=o,e.clampedFloat=n,e.stringSet=f,e.cursorStyleToString=G,e.filterValidationDecorations=Ne,t=Ve(t),r=Ve(r),E=Ve(E),s=Ve(s);var y;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class ${constructor(J){this.c=J}hasChanged(J){return this.c[J]}}e.ConfigurationChangedEvent=$;class g{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=g;class a{constructor(J,$e,Fe,He){this.id=J,this.name=$e,this.defaultValue=Fe,this.schema=He}applyUpdate(J,$e){return m(J,$e)}compute(J,$e,Fe){return Fe}}class c{constructor(J,$e){this.newValue=J,this.didChange=$e}}e.ApplyUpdateResult=c;function m(H,J){if(typeof H!="object"||typeof J!="object"||!H||!J)return new c(J,H!==J);if(Array.isArray(H)||Array.isArray(J)){const Fe=Array.isArray(H)&&Array.isArray(J)&&t.$yb(H,J);return new c(J,!Fe)}let $e=!1;for(const Fe in J)if(J.hasOwnProperty(Fe)){const He=m(H[Fe],J[Fe]);He.didChange&&(H[Fe]=He.newValue,$e=!0)}return new c(H,$e)}class b{constructor(J){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0}applyUpdate(J,$e){return m(J,$e)}validate(J){return this.defaultValue}}class p{constructor(J,$e,Fe,He){this.id=J,this.name=$e,this.defaultValue=Fe,this.schema=He}applyUpdate(J,$e){return m(J,$e)}validate(J){return typeof J>"u"?this.defaultValue:J}compute(J,$e,Fe){return Fe}}function d(H,J){return typeof H>"u"?J:H==="false"?!1:!!H}class w extends p{constructor(J,$e,Fe,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=Fe),super(J,$e,Fe,He)}validate(J){return d(J,this.defaultValue)}}function o(H,J,$e,Fe){if(typeof H>"u")return J;let He=parseInt(H,10);return isNaN(He)?J:(He=Math.max($e,He),He=Math.min(Fe,He),He|0)}class l extends p{static clampedInt(J,$e,Fe,He){return o(J,$e,Fe,He)}constructor(J,$e,Fe,He,xe,et=void 0){typeof et<"u"&&(et.type="integer",et.default=Fe,et.minimum=He,et.maximum=xe),super(J,$e,Fe,et),this.minimum=He,this.maximum=xe}validate(J){return l.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}function n(H,J,$e,Fe){if(typeof H>"u")return J;const He=u.float(H,J);return u.clamp(He,$e,Fe)}class u extends p{static clamp(J,$e,Fe){return J<$e?$e:J>Fe?Fe:J}static float(J,$e){if(typeof J=="number")return J;if(typeof J>"u")return $e;const Fe=parseFloat(J);return isNaN(Fe)?$e:Fe}constructor(J,$e,Fe,He,xe){typeof xe<"u"&&(xe.type="number",xe.default=Fe),super(J,$e,Fe,xe),this.validationFn=He}validate(J){return this.validationFn(u.float(J,this.defaultValue))}}class i extends p{static string(J,$e){return typeof J!="string"?$e:J}constructor(J,$e,Fe,He=void 0){typeof He<"u"&&(He.type="string",He.default=Fe),super(J,$e,Fe,He)}validate(J){return i.string(J,this.defaultValue)}}function f(H,J,$e,Fe){return typeof H!="string"?J:Fe&&H in Fe?Fe[H]:$e.indexOf(H)===-1?J:H}class h extends p{constructor(J,$e,Fe,He,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.enum=He,xe.default=Fe),super(J,$e,Fe,xe),this.c=He}validate(J){return f(J,this.defaultValue,this.c)}}class k extends a{constructor(J,$e,Fe,He,xe,et,it=void 0){typeof it<"u"&&(it.type="string",it.enum=xe,it.default=He),super(J,$e,Fe,it),this.c=xe,this.d=et}validate(J){return typeof J!="string"?this.defaultValue:this.c.indexOf(J)===-1?this.defaultValue:this.d(J)}}function I(H){switch(H){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class O extends a{constructor(){super(he.accessibilitySupport,"accessibilitySupport",S.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(302,null),s.localize(303,null),s.localize(304,null)],default:"auto",tags:["accessibility"],description:s.localize(305,null)})}validate(J){switch(J){case"auto":return S.AccessibilitySupport.Unknown;case"off":return S.AccessibilitySupport.Disabled;case"on":return S.AccessibilitySupport.Enabled}return this.defaultValue}compute(J,$e,Fe){return Fe===S.AccessibilitySupport.Unknown?J.accessibilitySupport:Fe}}class C extends a{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(he.comments,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:s.localize(306,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:s.localize(307,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{insertSpace:d($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function R(H){switch(H){case"blink":return L.Blink;case"smooth":return L.Smooth;case"phase":return L.Phase;case"expand":return L.Expand;case"solid":return L.Solid}}var M;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function G(H){switch(H){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function Q(H){switch(H){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class te extends b{constructor(){super(he.editorClassName)}compute(J,$e,Fe){const He=["monaco-editor"];return $e.get(he.extraEditorClassName)&&He.push($e.get(he.extraEditorClassName)),J.extraEditorClassName&&He.push(J.extraEditorClassName),$e.get(he.mouseStyle)==="default"?He.push("mouse-default"):$e.get(he.mouseStyle)==="copy"&&He.push("mouse-copy"),$e.get(he.showUnused)&&He.push("showUnused"),$e.get(he.showDeprecated)&&He.push("showDeprecated"),He.join(" ")}}class ve extends w{constructor(){super(he.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(308,null)})}compute(J,$e,Fe){return Fe&&J.emptySelectionClipboard}}class be extends a{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(he.find,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:s.localize(309,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[s.localize(310,null),s.localize(311,null),s.localize(312,null)],description:s.localize(313,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[s.localize(314,null),s.localize(315,null),s.localize(316,null)],description:s.localize(317,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:s.localize(318,null),included:E.$m},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:s.localize(319,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:s.localize(320,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{cursorMoveOnType:d($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":f($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":f($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d($e.loop,this.defaultValue.loop)}}}class le extends a{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(he.fontLigatures,"fontLigatures",le.OFF,{anyOf:[{type:"boolean",description:s.localize(321,null)},{type:"string",description:s.localize(322,null)}],description:s.localize(323,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"||J.length===0?le.OFF:J==="true"?le.ON:J:J?le.ON:le.OFF}}e.EditorFontLigatures=le;class K extends a{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(he.fontVariations,"fontVariations",K.OFF,{anyOf:[{type:"boolean",description:s.localize(324,null)},{type:"string",description:s.localize(325,null)}],description:s.localize(326,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?K.OFF:J==="true"?K.TRANSLATE:J:J?K.TRANSLATE:K.OFF}compute(J,$e,Fe){return J.fontInfo.fontVariationSettings}}e.EditorFontVariations=K;class B extends b{constructor(){super(he.fontInfo)}compute(J,$e,Fe){return J.fontInfo}}class j extends p{constructor(){super(he.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(327,null)})}validate(J){const $e=u.float(J,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp($e,6,100)}compute(J,$e,Fe){return J.fontInfo.fontSize}}class U extends a{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(he.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.d,maximum:U.e,errorMessage:s.localize(328,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(329,null)})}validate(J){return J==="normal"||J==="bold"?J:String(l.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,U.d,U.e))}}class ee extends a{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[s.localize(330,null),s.localize(331,null),s.localize(332,null)]},Fe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(he.gotoLocation,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(333,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(334,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(335,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:s.localize(336,null),...$e},"editor.gotoLocation.multipleImplementations":{description:s.localize(337,null),...$e},"editor.gotoLocation.multipleReferences":{description:s.localize(338,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Fe,description:s.localize(339,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Fe,description:s.localize(340,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Fe,description:s.localize(341,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Fe,description:s.localize(342,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Fe,description:s.localize(343,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{multiple:f($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??f($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??f($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??f($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??f($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??f($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:$e.multipleTests??f($e.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:i.string($e.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class ae extends a{constructor(){const J={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(he.hover,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:s.localize(344,null)},"editor.hover.delay":{type:"number",default:J.delay,minimum:0,maximum:1e4,description:s.localize(345,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:s.localize(346,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:J.hidingDelay,description:s.localize(347,null)},"editor.hover.above":{type:"boolean",default:J.above,description:s.localize(348,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{enabled:d($e.enabled,this.defaultValue.enabled),delay:l.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:d($e.sticky,this.defaultValue.sticky),hidingDelay:l.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:d($e.above,this.defaultValue.above)}}}var ye;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(ye||(e.RenderMinimap=ye={}));class se extends b{constructor(){super(he.layoutInfo)}compute(J,$e,Fe){return se.computeLayout($e,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio,glyphMarginDecorationLaneCount:J.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(J){const $e=J.height/J.lineHeight,Fe=Math.floor(J.paddingTop/J.lineHeight);let He=Math.floor(J.paddingBottom/J.lineHeight);J.scrollBeyondLastLine&&(He=Math.max(He,$e-1));const xe=(Fe+J.viewLineCount+He)/(J.pixelRatio*J.height),et=Math.floor(J.viewLineCount/xe);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Fe,extraLinesBeyondLastLine:He,desiredRatio:xe,minimapLineCount:et}}static c(J,$e){const Fe=J.outerWidth,He=J.outerHeight,xe=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:ye.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const et=$e.stableMinimapLayoutInput,it=et&&J.outerHeight===et.outerHeight&&J.lineHeight===et.lineHeight&&J.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&J.pixelRatio===et.pixelRatio&&J.scrollBeyondLastLine===et.scrollBeyondLastLine&&J.paddingTop===et.paddingTop&&J.paddingBottom===et.paddingBottom&&J.minimap.enabled===et.minimap.enabled&&J.minimap.side===et.minimap.side&&J.minimap.size===et.minimap.size&&J.minimap.showSlider===et.minimap.showSlider&&J.minimap.renderCharacters===et.minimap.renderCharacters&&J.minimap.maxColumn===et.minimap.maxColumn&&J.minimap.scale===et.minimap.scale&&J.verticalScrollbarWidth===et.verticalScrollbarWidth&&J.isViewportWrapping===et.isViewportWrapping,ft=J.lineHeight,gt=J.typicalHalfwidthCharacterWidth,Et=J.scrollBeyondLastLine,Rt=J.minimap.renderCharacters;let mt=xe>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const pt=J.minimap.maxColumn,wt=J.minimap.size,Wt=J.minimap.side,It=J.verticalScrollbarWidth,Ct=J.viewLineCount,Nt=J.remainingWidth,dt=J.isViewportWrapping,vt=Rt?2:3;let bt=Math.floor(xe*He);const Bt=bt/xe;let jt=!1,_t=!1,Ot=vt*mt,Ft=mt/xe,Vt=1;if(wt==="fill"||wt==="fit"){const{typicalViewportLineCount:qt,extraLinesBeforeFirstLine:Zt,extraLinesBeyondLastLine:Jt,desiredRatio:Yt,minimapLineCount:Mt}=se.computeContainedMinimapLineCount({viewLineCount:Ct,scrollBeyondLastLine:Et,paddingTop:J.paddingTop,paddingBottom:J.paddingBottom,height:He,lineHeight:ft,pixelRatio:xe});if(Ct/Mt>1)jt=!0,_t=!0,mt=1,Ot=1,Ft=mt/xe;else{let yt=!1,zt=mt+1;if(wt==="fit"){const Ut=Math.ceil((Zt+Ct+Jt)*Ot);dt&&it&&Nt<=$e.stableFitRemainingWidth?(yt=!0,zt=$e.stableFitMaxMinimapScale):yt=Ut>bt}if(wt==="fill"||yt){jt=!0;const Ut=mt;Ot=Math.min(ft*xe,Math.max(1,Math.floor(1/Yt))),dt&&it&&Nt<=$e.stableFitRemainingWidth&&(zt=$e.stableFitMaxMinimapScale),mt=Math.min(zt,Math.max(1,Math.floor(Ot/vt))),mt>Ut&&(Vt=Math.min(2,mt/Ut)),Ft=mt/xe/Vt,bt=Math.ceil(Math.max(qt,Zt+Ct+Jt)*Ot),dt?($e.stableMinimapLayoutInput=J,$e.stableFitRemainingWidth=Nt,$e.stableFitMaxMinimapScale=mt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const Gt=Math.floor(pt*Ft),St=Math.min(Gt,Math.max(0,Math.floor((Nt-It-2)*Ft/(gt+Ft)))+e.MINIMAP_GUTTER_WIDTH);let Lt=Math.floor(xe*St);const At=Lt/xe;Lt=Math.floor(Lt*Vt);const Kt=Rt?ye.Text:ye.Blocks,Qt=Wt==="left"?0:Fe-St-It;return{renderMinimap:Kt,minimapLeft:Qt,minimapWidth:St,minimapHeightIsEditorHeight:jt,minimapIsSampling:_t,minimapScale:mt,minimapLineHeight:Ot,minimapCanvasInnerWidth:Lt,minimapCanvasInnerHeight:bt,minimapCanvasOuterWidth:At,minimapCanvasOuterHeight:Bt}}static computeLayout(J,$e){const Fe=$e.outerWidth|0,He=$e.outerHeight|0,xe=$e.lineHeight|0,et=$e.lineNumbersDigitCount|0,it=$e.typicalHalfwidthCharacterWidth,ft=$e.maxDigitWidth,gt=$e.pixelRatio,Et=$e.viewLineCount,Rt=J.get(he.wordWrapOverride2),mt=Rt==="inherit"?J.get(he.wordWrapOverride1):Rt,pt=mt==="inherit"?J.get(he.wordWrap):mt,wt=J.get(he.wordWrapColumn),Wt=$e.isDominatedByLongLines,It=J.get(he.glyphMargin),Ct=J.get(he.lineNumbers).renderType!==qe.Off,Nt=J.get(he.lineNumbersMinChars),dt=J.get(he.scrollBeyondLastLine),vt=J.get(he.padding),bt=J.get(he.minimap),Bt=J.get(he.scrollbar),jt=Bt.verticalScrollbarSize,_t=Bt.verticalHasArrows,Ot=Bt.arrowSize,Ft=Bt.horizontalScrollbarSize,Vt=J.get(he.folding),Gt=J.get(he.showFoldingControls)!=="never";let St=J.get(he.lineDecorationsWidth);Vt&&Gt&&(St+=16);let Lt=0;if(Ct){const ln=Math.max(et,Nt);Lt=Math.round(ln*ft)}let At=0;It&&(At=xe*$e.glyphMarginDecorationLaneCount);let Kt=0,Qt=Kt+At,qt=Qt+Lt,Zt=qt+St;const Jt=Fe-At-Lt-St;let Yt=!1,Mt=!1,Ht=-1;mt==="inherit"&&Wt?(Yt=!0,Mt=!0):pt==="on"||pt==="bounded"?Mt=!0:pt==="wordWrapColumn"&&(Ht=wt);const yt=se.c({outerWidth:Fe,outerHeight:He,lineHeight:xe,typicalHalfwidthCharacterWidth:it,pixelRatio:gt,scrollBeyondLastLine:dt,paddingTop:vt.top,paddingBottom:vt.bottom,minimap:bt,verticalScrollbarWidth:jt,viewLineCount:Et,remainingWidth:Jt,isViewportWrapping:Mt},$e.memory||new g);yt.renderMinimap!==ye.None&&yt.minimapLeft===0&&(Kt+=yt.minimapWidth,Qt+=yt.minimapWidth,qt+=yt.minimapWidth,Zt+=yt.minimapWidth);const zt=Jt-yt.minimapWidth,Ut=Math.max(1,Math.floor((zt-jt-2)/it)),an=_t?Ot:0;return Mt&&(Ht=Math.max(1,Ut),pt==="bounded"&&(Ht=Math.min(Ht,wt))),{width:Fe,height:He,glyphMarginLeft:Kt,glyphMarginWidth:At,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:Lt,decorationsLeft:qt,decorationsWidth:St,contentLeft:Zt,contentWidth:zt,minimap:yt,viewportColumn:Ut,isWordWrapMinified:Yt,isViewportWrapping:Mt,wrappingColumn:Ht,verticalScrollbarWidth:jt,horizontalScrollbarHeight:Ft,overviewRuler:{top:an,width:jt,height:He-2*an,right:0}}}}e.EditorLayoutInfoComputer=se;class ne extends a{constructor(){super(he.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(349,null),s.localize(350,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(351,null)}})}validate(J){return f(J,"simple",["simple","advanced"])}compute(J,$e,Fe){return $e.get(he.accessibilitySupport)===S.AccessibilitySupport.Enabled?"advanced":Fe}}var X;(function(H){H.Off="off",H.OnCode="onCode",H.On="on"})(X||(e.ShowLightbulbIconMode=X={}));class z extends a{constructor(){const J={enabled:X.OnCode};super(he.lightbulb,"lightbulb",J,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[X.Off,X.OnCode,X.On],default:J.enabled,enumDescriptions:[s.localize(352,null),s.localize(353,null),s.localize(354,null)],description:s.localize(355,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:f(J.enabled,this.defaultValue.enabled,[X.Off,X.OnCode,X.On])}}}class A extends a{constructor(){const J={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(he.stickyScroll,"stickyScroll",J,{"editor.stickyScroll.enabled":{type:"boolean",default:J.enabled,description:s.localize(356,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:J.maxLineCount,minimum:1,maximum:20,description:s.localize(357,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:J.defaultModel,description:s.localize(358,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:J.scrollWithEditor,description:s.localize(359,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{enabled:d($e.enabled,this.defaultValue.enabled),maxLineCount:l.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:d($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Y extends a{constructor(){const J={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(he.inlayHints,"inlayHints",J,{"editor.inlayHints.enabled":{type:"string",default:J.enabled,description:s.localize(360,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(361,null),s.localize(362,null,E.$m?"Ctrl+Option":"Ctrl+Alt"),s.localize(363,null,E.$m?"Ctrl+Option":"Ctrl+Alt"),s.localize(364,null)]},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:s.localize(365,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:s.localize(366,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:J.padding,description:s.localize(367,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:f($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:l.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),padding:d($e.padding,this.defaultValue.padding)}}}class pe extends a{constructor(){super(he.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(J){return typeof J=="string"&&/^\d+(\.\d+)?ch$/.test(J)?-parseFloat(J.substring(0,J.length-2)):l.clampedInt(J,this.defaultValue,0,1e3)}compute(J,$e,Fe){return Fe<0?l.clampedInt(-Fe*J.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Fe}}class x extends u{constructor(){super(he.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>u.clamp(J,0,150),{markdownDescription:s.localize(368,null)})}compute(J,$e,Fe){return J.fontInfo.lineHeight}}class ie extends a{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(he.minimap,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:s.localize(369,null)},"editor.minimap.autohide":{type:"boolean",default:J.autohide,description:s.localize(370,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(371,null),s.localize(372,null),s.localize(373,null)],default:J.size,description:s.localize(374,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:s.localize(375,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:s.localize(376,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(377,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:s.localize(378,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:s.localize(379,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:J.showRegionSectionHeaders,description:s.localize(380,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:J.showMarkSectionHeaders,description:s.localize(381,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:J.sectionHeaderFontSize,description:s.localize(382,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:J.sectionHeaderLetterSpacing,description:s.localize(383,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{enabled:d($e.enabled,this.defaultValue.enabled),autohide:d($e.autohide,this.defaultValue.autohide),size:f($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:f($e.side,this.defaultValue.side,["right","left"]),showSlider:f($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d($e.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt($e.scale,1,1,3),maxColumn:l.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:d($e.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:d($e.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:u.clamp($e.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:u.clamp($e.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function W(H){return H==="ctrlCmd"?E.$m?"metaKey":"ctrlKey":"altKey"}class Z extends a{constructor(){super(he.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(384,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(385,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{top:l.clampedInt($e.top,0,0,1e3),bottom:l.clampedInt($e.bottom,0,0,1e3)}}}class ce extends a{constructor(){const J={enabled:!0,cycle:!0};super(he.parameterHints,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:s.localize(386,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:s.localize(387,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{enabled:d($e.enabled,this.defaultValue.enabled),cycle:d($e.cycle,this.defaultValue.cycle)}}}class we extends b{constructor(){super(he.pixelRatio)}compute(J,$e,Fe){return J.pixelRatio}}class Le extends a{constructor(){super(he.placeholder,"placeholder",void 0)}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J:this.defaultValue}}class ze extends a{constructor(){const J={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(388,null),s.localize(389,null),s.localize(390,null)]}];super(he.quickSuggestions,"quickSuggestions",J,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:J.strings,description:s.localize(391,null)},comments:{anyOf:$e,default:J.comments,description:s.localize(392,null)},other:{anyOf:$e,default:J.other,description:s.localize(393,null)}},default:J,markdownDescription:s.localize(394,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=J}validate(J){if(typeof J=="boolean"){const gt=J?"on":"off";return{comments:gt,strings:gt,other:gt}}if(!J||typeof J!="object")return this.defaultValue;const{other:$e,comments:Fe,strings:He}=J,xe=["on","inline","off"];let et,it,ft;return typeof $e=="boolean"?et=$e?"on":"off":et=f($e,this.defaultValue.other,xe),typeof Fe=="boolean"?it=Fe?"on":"off":it=f(Fe,this.defaultValue.comments,xe),typeof He=="boolean"?ft=He?"on":"off":ft=f(He,this.defaultValue.strings,xe),{other:et,comments:it,strings:ft}}}var qe;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(qe||(e.RenderLineNumbersType=qe={}));class Re extends a{constructor(){super(he.lineNumbers,"lineNumbers",{renderType:qe.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(395,null),s.localize(396,null),s.localize(397,null),s.localize(398,null)],default:"on",description:s.localize(399,null)})}validate(J){let $e=this.defaultValue.renderType,Fe=this.defaultValue.renderFn;return typeof J<"u"&&(typeof J=="function"?($e=qe.Custom,Fe=J):J==="interval"?$e=qe.Interval:J==="relative"?$e=qe.Relative:J==="on"?$e=qe.On:$e=qe.Off),{renderType:$e,renderFn:Fe}}}function Ne(H){const J=H.get(he.renderValidationDecorations);return J==="editable"?H.get(he.readOnly):J!=="on"}class De extends a{constructor(){const J=[],$e={type:"number",description:s.localize(400,null)};super(he.rulers,"rulers",J,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:s.localize(401,null),format:"color-hex"}}}]},default:J,description:s.localize(402,null)})}validate(J){if(Array.isArray(J)){const $e=[];for(const Fe of J)if(typeof Fe=="number")$e.push({column:l.clampedInt(Fe,0,0,1e4),color:null});else if(Fe&&typeof Fe=="object"){const He=Fe;$e.push({column:l.clampedInt(He.column,0,0,1e4),color:He.color})}return $e.sort((Fe,He)=>Fe.column-He.column),$e}return this.defaultValue}}class Ce extends a{constructor(){super(he.readOnlyMessage,"readOnlyMessage",void 0)}validate(J){return!J||typeof J!="object"?this.defaultValue:J}}function ge(H,J){if(typeof H!="string")return J;switch(H){case"hidden":return P.ScrollbarVisibility.Hidden;case"visible":return P.ScrollbarVisibility.Visible;default:return P.ScrollbarVisibility.Auto}}class Se extends a{constructor(){const J={vertical:P.ScrollbarVisibility.Auto,horizontal:P.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(he.scrollbar,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(403,null),s.localize(404,null),s.localize(405,null)],default:"auto",description:s.localize(406,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(407,null),s.localize(408,null),s.localize(409,null)],default:"auto",description:s.localize(410,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:s.localize(411,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:s.localize(412,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:s.localize(413,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:J.ignoreHorizontalScrollbarInContentHeight,description:s.localize(414,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J,Fe=l.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=l.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ge($e.vertical,this.defaultValue.vertical),horizontal:ge($e.horizontal,this.defaultValue.horizontal),useShadows:d($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:d($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Fe,horizontalSliderSize:l.clampedInt($e.horizontalSliderSize,Fe,0,1e3),verticalScrollbarSize:He,verticalSliderSize:l.clampedInt($e.verticalSliderSize,He,0,1e3),scrollByPage:d($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:d($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Pe extends a{constructor(){const J={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(he.unicodeHighlighting,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.nonBasicASCII,description:s.localize(415,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:J.invisibleCharacters,description:s.localize(416,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:J.ambiguousCharacters,description:s.localize(417,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeComments,description:s.localize(418,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeStrings,description:s.localize(419,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:J.allowedCharacters,description:s.localize(420,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:J.allowedLocales,description:s.localize(421,null)}})}applyUpdate(J,$e){let Fe=!1;$e.allowedCharacters&&J&&(r.$oo(J.allowedCharacters,$e.allowedCharacters)||(J={...J,allowedCharacters:$e.allowedCharacters},Fe=!0)),$e.allowedLocales&&J&&(r.$oo(J.allowedLocales,$e.allowedLocales)||(J={...J,allowedLocales:$e.allowedLocales},Fe=!0));const He=super.applyUpdate(J,$e);return Fe?new c(He.newValue,!0):He}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{nonBasicASCII:Xe($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Xe($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Xe($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(J.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(J.allowedLocales,this.defaultValue.allowedLocales)}}c(J,$e){if(typeof J!="object"||!J)return $e;const Fe={};for(const[He,xe]of Object.entries(J))xe===!0&&(Fe[He]=!0);return Fe}}class Ue extends a{constructor(){const J={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(he.inlineSuggest,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:s.localize(422,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(423,null),s.localize(424,null),s.localize(425,null)],description:s.localize(426,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:J.suppressSuggestions,description:s.localize(427,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:J.fontFamily,description:s.localize(428,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{enabled:d($e.enabled,this.defaultValue.enabled),mode:f($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:d($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:d($e.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily)}}}class Ge extends a{constructor(){const J={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(he.inlineEdit,"experimentalInlineEdit",J,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:J.enabled,description:s.localize(429,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(430,null),s.localize(431,null),s.localize(432,null)],description:s.localize(433,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:J.fontFamily,description:s.localize(434,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{enabled:d($e.enabled,this.defaultValue.enabled),showToolbar:f($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),keepOnBlur:d($e.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Qe extends a{constructor(){const J={enabled:T.$tt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$tt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(he.bracketPairColorization,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,markdownDescription:s.localize(435,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:J.independentColorPoolPerBracketType,description:s.localize(436,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{enabled:d($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ze extends a{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(he.guides,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(437,null),s.localize(438,null),s.localize(439,null)],default:J.bracketPairs,description:s.localize(440,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(441,null),s.localize(442,null),s.localize(443,null)],default:J.bracketPairsHorizontal,description:s.localize(444,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:s.localize(445,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:s.localize(446,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(447,null),s.localize(448,null),s.localize(449,null)],default:J.highlightActiveIndentation,description:s.localize(450,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{bracketPairs:Xe($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Xe($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:Xe($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Xe(H,J,$e){const Fe=$e.indexOf(H);return Fe===-1?J:$e[Fe]}class tt extends a{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(he.suggest,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(451,null),s.localize(452,null)],default:J.insertMode,description:s.localize(453,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:s.localize(454,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:s.localize(455,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:s.localize(456,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(457,null),s.localize(458,null),s.localize(459,null),s.localize(460,null)],default:J.selectionMode,markdownDescription:s.localize(461,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:s.localize(462,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:s.localize(463,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:s.localize(464,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:s.localize(465,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:s.localize(466,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(467,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(468,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(469,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(470,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(471,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(472,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(473,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(474,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(475,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(476,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(477,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(478,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(479,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(480,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(481,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(482,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(483,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(484,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(485,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(486,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(487,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(488,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(489,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(490,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(491,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(492,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(493,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(494,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(495,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(496,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(497,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(498,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{insertMode:f($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d($e.showIcons,this.defaultValue.showIcons),showStatusBar:d($e.showStatusBar,this.defaultValue.showStatusBar),preview:d($e.preview,this.defaultValue.preview),previewMode:f($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d($e.showMethods,this.defaultValue.showMethods),showFunctions:d($e.showFunctions,this.defaultValue.showFunctions),showConstructors:d($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:d($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d($e.showFields,this.defaultValue.showFields),showVariables:d($e.showVariables,this.defaultValue.showVariables),showClasses:d($e.showClasses,this.defaultValue.showClasses),showStructs:d($e.showStructs,this.defaultValue.showStructs),showInterfaces:d($e.showInterfaces,this.defaultValue.showInterfaces),showModules:d($e.showModules,this.defaultValue.showModules),showProperties:d($e.showProperties,this.defaultValue.showProperties),showEvents:d($e.showEvents,this.defaultValue.showEvents),showOperators:d($e.showOperators,this.defaultValue.showOperators),showUnits:d($e.showUnits,this.defaultValue.showUnits),showValues:d($e.showValues,this.defaultValue.showValues),showConstants:d($e.showConstants,this.defaultValue.showConstants),showEnums:d($e.showEnums,this.defaultValue.showEnums),showEnumMembers:d($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d($e.showKeywords,this.defaultValue.showKeywords),showWords:d($e.showWords,this.defaultValue.showWords),showColors:d($e.showColors,this.defaultValue.showColors),showFiles:d($e.showFiles,this.defaultValue.showFiles),showReferences:d($e.showReferences,this.defaultValue.showReferences),showFolders:d($e.showFolders,this.defaultValue.showFolders),showTypeParameters:d($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d($e.showSnippets,this.defaultValue.showSnippets),showUsers:d($e.showUsers,this.defaultValue.showUsers),showIssues:d($e.showIssues,this.defaultValue.showIssues)}}}class lt extends a{constructor(){super(he.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(499,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(500,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:d(J.selectSubwords,this.defaultValue.selectSubwords)}}}class ct extends a{constructor(){const J=[];super(he.wordSegmenterLocales,"wordSegmenterLocales",J,{anyOf:[{description:s.localize(501,null),type:"string"},{description:s.localize(502,null),type:"array",items:{type:"string"}}]})}validate(J){if(typeof J=="string"&&(J=[J]),Array.isArray(J)){const $e=[];for(const Fe of J)if(typeof Fe=="string")try{Intl.Segmenter.supportedLocalesOf(Fe).length>0&&$e.push(Fe)}catch{}return $e}return this.defaultValue}}var rt;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(rt||(e.WrappingIndent=rt={}));class ut extends a{constructor(){super(he.wrappingIndent,"wrappingIndent",rt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(503,null),s.localize(504,null),s.localize(505,null),s.localize(506,null)],description:s.localize(507,null),default:"same"}})}validate(J){switch(J){case"none":return rt.None;case"same":return rt.Same;case"indent":return rt.Indent;case"deepIndent":return rt.DeepIndent}return rt.Same}compute(J,$e,Fe){return $e.get(he.accessibilitySupport)===S.AccessibilitySupport.Enabled?rt.None:Fe}}class st extends b{constructor(){super(he.wrappingInfo)}compute(J,$e,Fe){const He=$e.get(he.layoutInfo);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class Je extends a{constructor(){const J={enabled:!0,showDropSelector:"afterDrop"};super(he.dropIntoEditor,"dropIntoEditor",J,{"editor.dropIntoEditor.enabled":{type:"boolean",default:J.enabled,markdownDescription:s.localize(508,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(509,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(510,null),s.localize(511,null)],default:"afterDrop"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{enabled:d($e.enabled,this.defaultValue.enabled),showDropSelector:f($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class me extends a{constructor(){const J={enabled:!0,showPasteSelector:"afterPaste"};super(he.pasteAs,"pasteAs",J,{"editor.pasteAs.enabled":{type:"boolean",default:J.enabled,markdownDescription:s.localize(512,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(513,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(514,null),s.localize(515,null)],default:"afterPaste"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const $e=J;return{enabled:d($e.enabled,this.defaultValue.enabled),showPasteSelector:f($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const V="Consolas, 'Courier New', monospace",_="Menlo, Monaco, 'Courier New', monospace",fe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:E.$m?_:E.$n?fe:V,fontWeight:"normal",fontSize:E.$m?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function re(H){return e.editorOptionsRegistry[H.id]=H,H}var he;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.ariaRequired=5]="ariaRequired",H[H.autoClosingBrackets=6]="autoClosingBrackets",H[H.autoClosingComments=7]="autoClosingComments",H[H.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",H[H.autoClosingDelete=9]="autoClosingDelete",H[H.autoClosingOvertype=10]="autoClosingOvertype",H[H.autoClosingQuotes=11]="autoClosingQuotes",H[H.autoIndent=12]="autoIndent",H[H.automaticLayout=13]="automaticLayout",H[H.autoSurround=14]="autoSurround",H[H.bracketPairColorization=15]="bracketPairColorization",H[H.guides=16]="guides",H[H.codeLens=17]="codeLens",H[H.codeLensFontFamily=18]="codeLensFontFamily",H[H.codeLensFontSize=19]="codeLensFontSize",H[H.colorDecorators=20]="colorDecorators",H[H.colorDecoratorsLimit=21]="colorDecoratorsLimit",H[H.columnSelection=22]="columnSelection",H[H.comments=23]="comments",H[H.contextmenu=24]="contextmenu",H[H.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",H[H.cursorBlinking=26]="cursorBlinking",H[H.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",H[H.cursorStyle=28]="cursorStyle",H[H.cursorSurroundingLines=29]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",H[H.cursorWidth=31]="cursorWidth",H[H.disableLayerHinting=32]="disableLayerHinting",H[H.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",H[H.domReadOnly=34]="domReadOnly",H[H.dragAndDrop=35]="dragAndDrop",H[H.dropIntoEditor=36]="dropIntoEditor",H[H.emptySelectionClipboard=37]="emptySelectionClipboard",H[H.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",H[H.extraEditorClassName=39]="extraEditorClassName",H[H.fastScrollSensitivity=40]="fastScrollSensitivity",H[H.find=41]="find",H[H.fixedOverflowWidgets=42]="fixedOverflowWidgets",H[H.folding=43]="folding",H[H.foldingStrategy=44]="foldingStrategy",H[H.foldingHighlight=45]="foldingHighlight",H[H.foldingImportsByDefault=46]="foldingImportsByDefault",H[H.foldingMaximumRegions=47]="foldingMaximumRegions",H[H.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=49]="fontFamily",H[H.fontInfo=50]="fontInfo",H[H.fontLigatures=51]="fontLigatures",H[H.fontSize=52]="fontSize",H[H.fontWeight=53]="fontWeight",H[H.fontVariations=54]="fontVariations",H[H.formatOnPaste=55]="formatOnPaste",H[H.formatOnType=56]="formatOnType",H[H.glyphMargin=57]="glyphMargin",H[H.gotoLocation=58]="gotoLocation",H[H.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",H[H.hover=60]="hover",H[H.inDiffEditor=61]="inDiffEditor",H[H.inlineSuggest=62]="inlineSuggest",H[H.inlineEdit=63]="inlineEdit",H[H.letterSpacing=64]="letterSpacing",H[H.lightbulb=65]="lightbulb",H[H.lineDecorationsWidth=66]="lineDecorationsWidth",H[H.lineHeight=67]="lineHeight",H[H.lineNumbers=68]="lineNumbers",H[H.lineNumbersMinChars=69]="lineNumbersMinChars",H[H.linkedEditing=70]="linkedEditing",H[H.links=71]="links",H[H.matchBrackets=72]="matchBrackets",H[H.minimap=73]="minimap",H[H.mouseStyle=74]="mouseStyle",H[H.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=76]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",H[H.multiCursorModifier=78]="multiCursorModifier",H[H.multiCursorPaste=79]="multiCursorPaste",H[H.multiCursorLimit=80]="multiCursorLimit",H[H.occurrencesHighlight=81]="occurrencesHighlight",H[H.overviewRulerBorder=82]="overviewRulerBorder",H[H.overviewRulerLanes=83]="overviewRulerLanes",H[H.padding=84]="padding",H[H.pasteAs=85]="pasteAs",H[H.parameterHints=86]="parameterHints",H[H.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",H[H.placeholder=88]="placeholder",H[H.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",H[H.quickSuggestions=90]="quickSuggestions",H[H.quickSuggestionsDelay=91]="quickSuggestionsDelay",H[H.readOnly=92]="readOnly",H[H.readOnlyMessage=93]="readOnlyMessage",H[H.renameOnType=94]="renameOnType",H[H.renderControlCharacters=95]="renderControlCharacters",H[H.renderFinalNewline=96]="renderFinalNewline",H[H.renderLineHighlight=97]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=99]="renderValidationDecorations",H[H.renderWhitespace=100]="renderWhitespace",H[H.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",H[H.roundedSelection=102]="roundedSelection",H[H.rulers=103]="rulers",H[H.scrollbar=104]="scrollbar",H[H.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=106]="scrollBeyondLastLine",H[H.scrollPredominantAxis=107]="scrollPredominantAxis",H[H.selectionClipboard=108]="selectionClipboard",H[H.selectionHighlight=109]="selectionHighlight",H[H.selectOnLineNumbers=110]="selectOnLineNumbers",H[H.showFoldingControls=111]="showFoldingControls",H[H.showUnused=112]="showUnused",H[H.snippetSuggestions=113]="snippetSuggestions",H[H.smartSelect=114]="smartSelect",H[H.smoothScrolling=115]="smoothScrolling",H[H.stickyScroll=116]="stickyScroll",H[H.stickyTabStops=117]="stickyTabStops",H[H.stopRenderingLineAfter=118]="stopRenderingLineAfter",H[H.suggest=119]="suggest",H[H.suggestFontSize=120]="suggestFontSize",H[H.suggestLineHeight=121]="suggestLineHeight",H[H.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",H[H.suggestSelection=123]="suggestSelection",H[H.tabCompletion=124]="tabCompletion",H[H.tabIndex=125]="tabIndex",H[H.unicodeHighlighting=126]="unicodeHighlighting",H[H.unusualLineTerminators=127]="unusualLineTerminators",H[H.useShadowDOM=128]="useShadowDOM",H[H.useTabStops=129]="useTabStops",H[H.wordBreak=130]="wordBreak",H[H.wordSegmenterLocales=131]="wordSegmenterLocales",H[H.wordSeparators=132]="wordSeparators",H[H.wordWrap=133]="wordWrap",H[H.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=136]="wordWrapColumn",H[H.wordWrapOverride1=137]="wordWrapOverride1",H[H.wordWrapOverride2=138]="wordWrapOverride2",H[H.wrappingIndent=139]="wrappingIndent",H[H.wrappingStrategy=140]="wrappingStrategy",H[H.showDeprecated=141]="showDeprecated",H[H.inlayHints=142]="inlayHints",H[H.editorClassName=143]="editorClassName",H[H.pixelRatio=144]="pixelRatio",H[H.tabFocusMode=145]="tabFocusMode",H[H.layoutInfo=146]="layoutInfo",H[H.wrappingInfo=147]="wrappingInfo",H[H.defaultColorDecorators=148]="defaultColorDecorators",H[H.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",H[H.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(he||(e.EditorOption=he={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:re(new w(he.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(516,null)})),acceptSuggestionOnEnter:re(new h(he.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(517,null),""],markdownDescription:s.localize(518,null)})),accessibilitySupport:re(new O),accessibilityPageSize:re(new l(he.accessibilityPageSize,"accessibilityPageSize",10,1,D.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(519,null),tags:["accessibility"]})),ariaLabel:re(new i(he.ariaLabel,"ariaLabel",s.localize(520,null))),ariaRequired:re(new w(he.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:re(new w(he.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(521,null),tags:["accessibility"]})),autoClosingBrackets:re(new h(he.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(522,null),s.localize(523,null),""],description:s.localize(524,null)})),autoClosingComments:re(new h(he.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(525,null),s.localize(526,null),""],description:s.localize(527,null)})),autoClosingDelete:re(new h(he.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(528,null),""],description:s.localize(529,null)})),autoClosingOvertype:re(new h(he.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(530,null),""],description:s.localize(531,null)})),autoClosingQuotes:re(new h(he.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(532,null),s.localize(533,null),""],description:s.localize(534,null)})),autoIndent:re(new k(he.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],I,{enumDescriptions:[s.localize(535,null),s.localize(536,null),s.localize(537,null),s.localize(538,null),s.localize(539,null)],description:s.localize(540,null)})),automaticLayout:re(new w(he.automaticLayout,"automaticLayout",!1)),autoSurround:re(new h(he.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(541,null),s.localize(542,null),s.localize(543,null),""],description:s.localize(544,null)})),bracketPairColorization:re(new Qe),bracketPairGuides:re(new Ze),stickyTabStops:re(new w(he.stickyTabStops,"stickyTabStops",!1,{description:s.localize(545,null)})),codeLens:re(new w(he.codeLens,"codeLens",!0,{description:s.localize(546,null)})),codeLensFontFamily:re(new i(he.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(547,null)})),codeLensFontSize:re(new l(he.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(548,null)})),colorDecorators:re(new w(he.colorDecorators,"colorDecorators",!0,{description:s.localize(549,null)})),colorDecoratorActivatedOn:re(new h(he.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(550,null),s.localize(551,null),s.localize(552,null)],description:s.localize(553,null)})),colorDecoratorsLimit:re(new l(he.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(554,null)})),columnSelection:re(new w(he.columnSelection,"columnSelection",!1,{description:s.localize(555,null)})),comments:re(new C),contextmenu:re(new w(he.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:re(new w(he.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(556,null)})),cursorBlinking:re(new k(he.cursorBlinking,"cursorBlinking",L.Blink,"blink",["blink","smooth","phase","expand","solid"],R,{description:s.localize(557,null)})),cursorSmoothCaretAnimation:re(new h(he.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(558,null),s.localize(559,null),s.localize(560,null)],description:s.localize(561,null)})),cursorStyle:re(new k(he.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],Q,{description:s.localize(562,null)})),cursorSurroundingLines:re(new l(he.cursorSurroundingLines,"cursorSurroundingLines",0,0,D.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(563,null)})),cursorSurroundingLinesStyle:re(new h(he.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(564,null),s.localize(565,null)],markdownDescription:s.localize(566,null)})),cursorWidth:re(new l(he.cursorWidth,"cursorWidth",0,0,D.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(567,null)})),disableLayerHinting:re(new w(he.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:re(new w(he.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:re(new w(he.domReadOnly,"domReadOnly",!1)),dragAndDrop:re(new w(he.dragAndDrop,"dragAndDrop",!0,{description:s.localize(568,null)})),emptySelectionClipboard:re(new ve),dropIntoEditor:re(new Je),stickyScroll:re(new A),experimentalWhitespaceRendering:re(new h(he.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(569,null),s.localize(570,null),s.localize(571,null)],description:s.localize(572,null)})),extraEditorClassName:re(new i(he.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:re(new u(he.fastScrollSensitivity,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:s.localize(573,null)})),find:re(new be),fixedOverflowWidgets:re(new w(he.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:re(new w(he.folding,"folding",!0,{description:s.localize(574,null)})),foldingStrategy:re(new h(he.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(575,null),s.localize(576,null)],description:s.localize(577,null)})),foldingHighlight:re(new w(he.foldingHighlight,"foldingHighlight",!0,{description:s.localize(578,null)})),foldingImportsByDefault:re(new w(he.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(579,null)})),foldingMaximumRegions:re(new l(he.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(580,null)})),unfoldOnClickAfterEndOfLine:re(new w(he.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(581,null)})),fontFamily:re(new i(he.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(582,null)})),fontInfo:re(new B),fontLigatures2:re(new le),fontSize:re(new j),fontWeight:re(new U),fontVariations:re(new K),formatOnPaste:re(new w(he.formatOnPaste,"formatOnPaste",!1,{description:s.localize(583,null)})),formatOnType:re(new w(he.formatOnType,"formatOnType",!1,{description:s.localize(584,null)})),glyphMargin:re(new w(he.glyphMargin,"glyphMargin",!0,{description:s.localize(585,null)})),gotoLocation:re(new ee),hideCursorInOverviewRuler:re(new w(he.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(586,null)})),hover:re(new ae),inDiffEditor:re(new w(he.inDiffEditor,"inDiffEditor",!1)),letterSpacing:re(new u(he.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>u.clamp(H,-5,20),{description:s.localize(587,null)})),lightbulb:re(new z),lineDecorationsWidth:re(new pe),lineHeight:re(new x),lineNumbers:re(new Re),lineNumbersMinChars:re(new l(he.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:re(new w(he.linkedEditing,"linkedEditing",!1,{description:s.localize(588,null)})),links:re(new w(he.links,"links",!0,{description:s.localize(589,null)})),matchBrackets:re(new h(he.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(590,null)})),minimap:re(new ie),mouseStyle:re(new h(he.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:re(new u(he.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:s.localize(591,null)})),mouseWheelZoom:re(new w(he.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:E.$m?s.localize(592,null):s.localize(593,null)})),multiCursorMergeOverlapping:re(new w(he.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(594,null)})),multiCursorModifier:re(new k(he.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],W,{markdownEnumDescriptions:[s.localize(595,null),s.localize(596,null)],markdownDescription:s.localize(597,null)})),multiCursorPaste:re(new h(he.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(598,null),s.localize(599,null)],markdownDescription:s.localize(600,null)})),multiCursorLimit:re(new l(he.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(601,null)})),occurrencesHighlight:re(new h(he.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(602,null),s.localize(603,null),s.localize(604,null)],markdownDescription:s.localize(605,null)})),overviewRulerBorder:re(new w(he.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(606,null)})),overviewRulerLanes:re(new l(he.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:re(new Z),pasteAs:re(new me),parameterHints:re(new ce),peekWidgetDefaultFocus:re(new h(he.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(607,null),s.localize(608,null)],description:s.localize(609,null)})),placeholder:re(new Le),definitionLinkOpensInPeek:re(new w(he.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(610,null)})),quickSuggestions:re(new ze),quickSuggestionsDelay:re(new l(he.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,D.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(611,null)})),readOnly:re(new w(he.readOnly,"readOnly",!1)),readOnlyMessage:re(new Ce),renameOnType:re(new w(he.renameOnType,"renameOnType",!1,{description:s.localize(612,null),markdownDeprecationMessage:s.localize(613,null)})),renderControlCharacters:re(new w(he.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(614,null),restricted:!0})),renderFinalNewline:re(new h(he.renderFinalNewline,"renderFinalNewline",E.$n?"dimmed":"on",["off","on","dimmed"],{description:s.localize(615,null)})),renderLineHighlight:re(new h(he.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(616,null)],description:s.localize(617,null)})),renderLineHighlightOnlyWhenFocus:re(new w(he.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(618,null)})),renderValidationDecorations:re(new h(he.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:re(new h(he.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(619,null),s.localize(620,null),s.localize(621,null),""],description:s.localize(622,null)})),revealHorizontalRightPadding:re(new l(he.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:re(new w(he.roundedSelection,"roundedSelection",!0,{description:s.localize(623,null)})),rulers:re(new De),scrollbar:re(new Se),scrollBeyondLastColumn:re(new l(he.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,D.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(624,null)})),scrollBeyondLastLine:re(new w(he.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(625,null)})),scrollPredominantAxis:re(new w(he.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(626,null)})),selectionClipboard:re(new w(he.selectionClipboard,"selectionClipboard",!0,{description:s.localize(627,null),included:E.$n})),selectionHighlight:re(new w(he.selectionHighlight,"selectionHighlight",!0,{description:s.localize(628,null)})),selectOnLineNumbers:re(new w(he.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:re(new h(he.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(629,null),s.localize(630,null),s.localize(631,null)],description:s.localize(632,null)})),showUnused:re(new w(he.showUnused,"showUnused",!0,{description:s.localize(633,null)})),showDeprecated:re(new w(he.showDeprecated,"showDeprecated",!0,{description:s.localize(634,null)})),inlayHints:re(new Y),snippetSuggestions:re(new h(he.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(635,null),s.localize(636,null),s.localize(637,null),s.localize(638,null)],description:s.localize(639,null)})),smartSelect:re(new lt),smoothScrolling:re(new w(he.smoothScrolling,"smoothScrolling",!1,{description:s.localize(640,null)})),stopRenderingLineAfter:re(new l(he.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,D.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:re(new tt),inlineSuggest:re(new Ue),inlineEdit:re(new Ge),inlineCompletionsAccessibilityVerbose:re(new w(he.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(641,null)})),suggestFontSize:re(new l(he.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(642,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:re(new l(he.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(643,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:re(new w(he.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(644,null)})),suggestSelection:re(new h(he.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(645,null),s.localize(646,null),s.localize(647,null)],description:s.localize(648,null)})),tabCompletion:re(new h(he.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(649,null),s.localize(650,null),s.localize(651,null)],description:s.localize(652,null)})),tabIndex:re(new l(he.tabIndex,"tabIndex",0,-1,D.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:re(new Pe),unusualLineTerminators:re(new h(he.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(653,null),s.localize(654,null),s.localize(655,null)],description:s.localize(656,null)})),useShadowDOM:re(new w(he.useShadowDOM,"useShadowDOM",!0)),useTabStops:re(new w(he.useTabStops,"useTabStops",!0,{description:s.localize(657,null)})),wordBreak:re(new h(he.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(658,null),s.localize(659,null)],description:s.localize(660,null)})),wordSegmenterLocales:re(new ct),wordSeparators:re(new i(he.wordSeparators,"wordSeparators",v.$ut,{description:s.localize(661,null)})),wordWrap:re(new h(he.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(662,null),s.localize(663,null),s.localize(664,null),s.localize(665,null)],description:s.localize(666,null)})),wordWrapBreakAfterCharacters:re(new i(he.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:re(new i(he.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:re(new l(he.wordWrapColumn,"wordWrapColumn",80,1,D.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(667,null)})),wordWrapOverride1:re(new h(he.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:re(new h(he.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:re(new te),defaultColorDecorators:re(new w(he.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(668,null)})),pixelRatio:re(new we),tabFocusMode:re(new w(he.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(669,null)})),layoutInfo:re(new se),wrappingInfo:re(new st),wrappingIndent:re(new ut),wrappingStrategy:re(new ne)}}),define(Te[207],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Ym=e.ID=void 0,e.$Zm=r,e.ID="diagnosticsService",e.$Ym=(0,t.$Ki)(e.ID);function r(P){return!!P.hostName&&!!P.errorMessage}class E{async getPerformanceInfo(D,T){return{}}async getSystemInfo(D,T){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,T){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$1m=E}),define(Te[88],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=void 0,e.$8o=(0,t.$Ki)("downloadService")}),define(Te[27],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=void 0,e.$Ri=(0,t.$Ki)("environmentService"),e.$Si=(0,t.$Li)(e.$Ri)}),define(Te[15],Oe([1,0,67,8,16,10,4,7,5,3,12,65]),function(ue,e,t,r,E,P,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Kl=e.FileKind=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.FileOperationResult=e.$Cl=e.$Bl=e.$Al=e.$yl=e.FileChangeType=e.$xl=e.FileOperation=e.$rl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$fl=void 0,e.$gl=$,e.$hl=m,e.$il=p,e.$jl=d,e.$kl=w,e.$ll=o,e.$ml=l,e.$nl=n,e.$ol=u,e.$pl=i,e.$ql=f,e.$sl=I,e.$tl=O,e.$ul=C,e.$vl=L,e.$wl=R,e.$zl=ve,e.$Ll=U,e.$Ml=ee,e.$Ol=ye,e.$fl=(0,v.$Ki)("fileService");function $(se){return se.create===!0}var g;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var a;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var c;(function(se){se[se.UPDATED=2]="UPDATED",se[se.ADDED=4]="ADDED",se[se.DELETED=8]="DELETED"})(c||(e.FileChangeFilter=c={}));function m(se){const ne=se;return!!ne&&typeof ne.onDidChange=="function"}var b;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function p(se){return!!(se.capabilities&b.FileReadWrite)}function d(se){return!!(se.capabilities&b.FileFolderCopy)}function w(se){return!!(se.capabilities&b.FileClone)}function o(se){return!!(se.capabilities&b.FileOpenReadWriteClose)}function l(se){return!!(se.capabilities&b.FileReadStream)}function n(se){return p(se)?!!(se.capabilities&b.FileAtomicRead):!1}function u(se){return p(se)?!!(se.capabilities&b.FileAtomicWrite):!1}function i(se){return!!(se.capabilities&b.FileAtomicDelete)}function f(se){return!!(se.capabilities&b.Readonly)}var h;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class k extends Error{static create(ne,X){const z=new k(ne.toString(),X);return C(z,X),z}constructor(ne,X){super(ne),this.code=X}}e.$rl=k;function I(se,ne){return k.create(se,ne)}function O(se){return se||I((0,T.localize)(1865,null),h.Unknown)}function C(se,ne){return se.name=ne?`${ne} (FileSystemError)`:"FileSystemError",se}function L(se){if(!se)return h.Unknown;if(se instanceof k)return se.code;const ne=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!ne)return h.Unknown;switch(ne[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function R(se){if(se instanceof be)return se.fileOperationResult;switch(L(se)){case h.FileNotFound:return B.FILE_NOT_FOUND;case h.FileIsADirectory:return B.FILE_IS_DIRECTORY;case h.FileNotADirectory:return B.FILE_NOT_DIRECTORY;case h.FileWriteLocked:return B.FILE_WRITE_LOCKED;case h.NoPermissions:return B.FILE_PERMISSION_DENIED;case h.FileExists:return B.FILE_MOVE_CONFLICT;case h.FileTooLarge:return B.FILE_TOO_LARGE;default:return B.FILE_OTHER_ERROR}}var M;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class G{constructor(ne,X,z){this.resource=ne,this.operation=X,this.target=z}isOperation(ne){return this.operation===ne}}e.$xl=G;var Q;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(Q||(e.FileChangeType=Q={}));class te{static{this.a=null}constructor(ne,X){this.c=X,this.b=void 0,this.d=new y.$Y(()=>{const z=t.$Qi.forUris(()=>this.c);return z.fill(this.rawAdded.map(A=>[A,!0])),z}),this.f=new y.$Y(()=>{const z=t.$Qi.forUris(()=>this.c);return z.fill(this.rawUpdated.map(A=>[A,!0])),z}),this.g=new y.$Y(()=>{const z=t.$Qi.forUris(()=>this.c);return z.fill(this.rawDeleted.map(A=>[A,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of ne){switch(z.type){case Q.ADDED:this.rawAdded.push(z.resource);break;case Q.UPDATED:this.rawUpdated.push(z.resource);break;case Q.DELETED:this.rawDeleted.push(z.resource);break}this.b!==te.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=te.a):this.b!==void 0&&(this.b=te.a))}}contains(ne,...X){return this.h(ne,{includeChildren:!1},...X)}affects(ne,...X){return this.h(ne,{includeChildren:!0},...X)}h(ne,X,...z){if(!ne)return!1;const A=z.length>0;return!!((!A||z.includes(Q.ADDED))&&(this.d.value.get(ne)||X.includeChildren&&this.d.value.findSuperstr(ne))||(!A||z.includes(Q.UPDATED))&&(this.f.value.get(ne)||X.includeChildren&&this.f.value.findSuperstr(ne))||(!A||z.includes(Q.DELETED))&&(this.g.value.findSubstr(ne)||X.includeChildren&&this.g.value.findSuperstr(ne)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ne){return this.b===ne}hasCorrelation(){return typeof this.b=="number"}}e.$yl=te;function ve(se,ne,X){return!se||!ne||se===ne||ne.length>se.length?!1:(ne.charAt(ne.length-1)!==r.sep&&(ne+=r.sep),X?(0,E.$Lf)(se,ne):se.indexOf(ne)===0)}class be extends Error{constructor(ne,X,z){super(ne),this.fileOperationResult=X,this.options=z}}e.$Al=be;class le extends be{constructor(ne,X,z,A){super(ne,X,A),this.fileOperationResult=X,this.size=z}}e.$Bl=le;class K extends be{constructor(ne,X,z){super(ne,B.FILE_NOT_MODIFIED_SINCE,z),this.stat=X}}e.$Cl=K;var B;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(B||(e.FileOperationResult=B={})),e.$Dl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$El={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Fl="files.associations",e.$Gl="files.exclude",e.$Hl="files.readonlyInclude",e.$Il="files.readonlyExclude",e.$Jl="files.readonlyFromPermissions";var j;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(j||(e.FileKind=j={})),e.$Kl="";function U(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}async function ee(se,ne){if(!ne.hasProvider(D.URI.from({scheme:se.scheme})))return new Promise(X=>{const z=ne.onDidChangeFileSystemProviderRegistrations(A=>{A.scheme===se.scheme&&A.added&&(z.dispose(),X())})})}class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(ne){return(0,P.$ng)(ne)||(ne=0),ne<ae.KB?(0,T.localize)(1866,null,ne.toFixed(0)):ne<ae.MB?(0,T.localize)(1867,null,(ne/ae.KB).toFixed(2)):ne<ae.GB?(0,T.localize)(1868,null,(ne/ae.MB).toFixed(2)):ne<ae.TB?(0,T.localize)(1869,null,(ne/ae.GB).toFixed(2)):(0,T.localize)(1870,null,(ne/ae.TB).toFixed(2))}}e.$Nl=ae;function ye(se){const ne=typeof se=="string"||se?.scheme===S.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===S.Schemas.file?1024*ae.MB:ne?10*ae.MB:s.$r?50*ae.MB:1024*ae.MB}}),define(Te[122],Oe([1,0,14,9,7,15]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=D;async function D(S,y,$,g,a,c){let m;try{await T(S,y,$,g,a,c)}catch(b){m=b}finally{m&&a.errorTransformer&&(m=a.errorTransformer(m)),typeof m<"u"&&$.error(m),$.end()}}async function T(S,y,$,g,a,c){v(c);const m=await S.open(y,{create:!1});try{v(c);let b=0,p=0,d=a&&typeof a.length=="number"?a.length:void 0,w=t.$Se.alloc(Math.min(a.bufferSize,typeof d=="number"?d:a.bufferSize)),o=a&&typeof a.position=="number"?a.position:0,l=0;do p=await S.read(m,o,w.buffer,l,w.byteLength-l),o+=p,l+=p,b+=p,typeof d=="number"&&(d-=p),l===w.byteLength&&(await $.write(g(w)),w=t.$Se.alloc(Math.min(a.bufferSize,typeof d=="number"?d:a.bufferSize)),l=0);while(p>0&&(typeof d!="number"||d>0)&&v(c)&&s(b,a));if(l>0){let n=l;typeof d=="number"&&(n=Math.min(l,d)),$.write(g(w.slice(0,n)))}}catch(b){throw(0,P.$tl)(b)}finally{await S.close(m)}}function v(S){if(S.isCancellationRequested)throw(0,r.$0)();return!0}function s(S,y){if(typeof y?.limits?.size=="number"&&S>y.limits.size)throw(0,P.$sl)((0,E.localize)(1898,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Te[52],Oe([1,0,86,2,8,3,4,15]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=void 0,e.$_q=v,e.$ar=s,e.$er=g,e.$fr=a,e.$gr=c,e.$hr=m,e.$ir=p,e.$jr=d;function v(w){return typeof w.correlationId=="number"}function s(w){return w.recursive===!0}class S extends r.$Zc{static{this.a=5}constructor(o,l,n,u){super(),this.h=o,this.j=l,this.m=n,this.n=u,this.c=this.B(new r.$1c),this.f=void 0,this.g=0}s(){const o=new r.$Yc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile(l=>this.h(l))),o.add(this.b.onDidLogMessage(l=>this.j(l))),o.add(this.b.onDidError(l=>this.t(l.error,l.request)))}t(o,l){this.u(o,l)?this.g<S.a&&this.f?(this.y(`restarting watcher after unexpected error: ${o}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${o}`):this.y(o)}u(o,l){return!(!this.n.restartOnError||l||o.indexOf("No space left on device")!==-1||o.indexOf("EMFILE")!==-1)}w(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}y(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}z(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$br=S;class y extends S{constructor(o,l,n){super(o,l,n,{type:"node.js",restartOnError:!1})}}e.$cr=y;class $ extends S{constructor(o,l,n){super(o,l,n,{type:"universal",restartOnError:!0})}}e.$dr=$;function g(w){return w.map(o=>({type:o.type,resource:D.URI.revive(o.resource),cId:o.cId}))}function a(w){const o=new b;for(const l of w)o.processEvent(l);return o.coalesce()}function c(w,o){return typeof o=="string"&&!o.startsWith(t.$Bk)&&!(0,E.$nc)(o)?{base:w,pattern:o}:o}function m(w,o){const l=[];for(const n of o)l.push((0,t.$Fk)(c(w,n)));return l}class b{constructor(){this.a=new Set,this.b=new Map}c(o){return P.$n?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const l=this.b.get(this.c(o));let n=!1;if(l){const u=l.type,i=o.type;l.resource.fsPath!==o.resource.fsPath&&(o.type===T.FileChangeType.DELETED||o.type===T.FileChangeType.ADDED)?n=!0:u===T.FileChangeType.ADDED&&i===T.FileChangeType.DELETED?(this.b.delete(this.c(o)),this.a.delete(l)):u===T.FileChangeType.DELETED&&i===T.FileChangeType.ADDED?l.type=T.FileChangeType.UPDATED:u===T.FileChangeType.ADDED&&i===T.FileChangeType.UPDATED||(l.type=i)}else n=!0;n&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],l=[];return Array.from(this.a).filter(n=>n.type!==T.FileChangeType.DELETED?(o.push(n),!1):!0).sort((n,u)=>n.resource.fsPath.length-u.resource.fsPath.length).filter(n=>l.some(u=>(0,T.$zl)(n.resource.fsPath,u,!P.$n))?!1:(l.push(n.resource.fsPath),!0)).concat(o)}}function p(w,o){if(typeof o=="number")switch(w.type){case T.FileChangeType.ADDED:return(o&T.FileChangeFilter.ADDED)===0;case T.FileChangeType.DELETED:return(o&T.FileChangeFilter.DELETED)===0;case T.FileChangeType.UPDATED:return(o&T.FileChangeFilter.UPDATED)===0}return!1}function d(w){if(typeof w=="number"){const o=[];return w&T.FileChangeFilter.ADDED&&o.push("Added"),w&T.FileChangeFilter.DELETED&&o.push("Deleted"),w&T.FileChangeFilter.UPDATED&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(Te[208],Oe([1,0,14,45,9,6,2,56,22,15,52]),function(ue,e,t,r,E,P,D,T,v,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VR=e.$UR=void 0,e.$UR="localFilesystem";class y extends D.$Zc{constructor(g,a){super(),this.a=g,this.b=a,this.onDidChangeCapabilities=P.Event.None,this.f=this.B(new P.$qe),this.onDidChangeFile=this.f.event,this.g=this.B(new P.$qe),this.onDidWatchError=this.g.event,this.h=(0,v.$7g)(),this.j()}get capabilities(){return this.c||(this.c=s.FileSystemProviderCapabilities.FileReadWrite|s.FileSystemProviderCapabilities.FileOpenReadWriteClose|s.FileSystemProviderCapabilities.FileReadStream|s.FileSystemProviderCapabilities.FileFolderCopy|s.FileSystemProviderCapabilities.FileWriteUnlock|s.FileSystemProviderCapabilities.FileAtomicRead|s.FileSystemProviderCapabilities.FileAtomicWrite|s.FileSystemProviderCapabilities.FileAtomicDelete|s.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=s.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=s.FileSystemProviderCapabilities.Trash)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,a){const{buffer:c}=await this.a.call("readFile",[g,a]);return c}readFileStream(g,a,c){const m=(0,T.$Ge)(p=>t.$Se.concat(p.map(d=>t.$Se.wrap(d))).buffer),b=new D.$Yc;return b.add(this.a.listen("readFileStream",[g,a])(p=>{if(p instanceof t.$Se)m.write(p.buffer);else{if(p==="end")m.end();else{let d;if(p instanceof Error)d=p;else{const w=p;d=(0,s.$sl)(w.message??(0,r.$vj)(w),w.code??s.FileSystemProviderErrorCode.Unknown)}m.error(d),m.end()}b.dispose()}})),b.add(c.onCancellationRequested(()=>{m.error((0,E.$0)()),m.end(),b.dispose()})),m}writeFile(g,a,c){return this.a.call("writeFile",[g,t.$Se.wrap(a),c])}open(g,a){return this.a.call("open",[g,a])}close(g){return this.a.call("close",[g])}async read(g,a,c,m,b){const[p,d]=await this.a.call("read",[g,a,b]);return c.set(p.buffer.slice(0,d),m),d}write(g,a,c,m,b){return this.a.call("write",[g,a,t.$Se.wrap(c),m,b])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,a){return this.a.call("delete",[g,a])}rename(g,a,c){return this.a.call("rename",[g,a,c])}copy(g,a,c){return this.a.call("copy",[g,a,c])}cloneFile(g,a){return this.a.call("cloneFile",[g,a])}j(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const a=g;this.f.fire((0,S.$er)(a))}else{const a=g;this.g.fire(a)}}))}watch(g,a){const c=(0,v.$7g)();return this.a.call("watch",[this.h,c,g,a]),(0,D.$Xc)(()=>this.a.call("unwatch",[this.h,c]))}}e.$VR=y}),define(Te[209],Oe([1,0,23,2,52,6,15,4,13]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class s extends r.$Zc{constructor(){super(),this.a=this.B(new P.$qe),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$qe),this.onDidLogMessage=this.b.event,this.c=this.B(new P.$qe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$9c),this.m=new Set,this.n=this.B(new v.$Ih(this.y())),this.r=5007,this.s=new v.$8h,this.R=!1,this.B(this.f(y=>this.t(y)))}t(y){this.u(y)&&this.z(y)}u(y){return(0,E.$_q)(y)}async watch(y){this.s.isSettled||this.s.complete(),this.s=new v.$8h;try{this.h.clear(),this.g.clear();for(const $ of y)this.u($)?this.h.set($.correlationId,$):this.g.add($);for(const[$]of this.j)this.h.has($)||(this.j.deleteAndDispose($),this.m.delete($));return await this.w(!1)}finally{this.s.complete()}}w(y){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter($=>!this.j.has($.correlationId))]),y?this.y():0)}y(){return 800}isSuspended(y){return typeof y.correlationId!="number"?!1:this.m.has(y.correlationId)?"polling":this.j.has(y.correlationId)}async z(y){if(this.j.has(y.correlationId))return;const $=new r.$Yc;this.j.set(y.correlationId,$),await this.s.p,!$.isDisposed&&(this.D(y,$),this.w(!0))}C(y){this.j.deleteAndDispose(y.correlationId),this.m.delete(y.correlationId),this.w(!1)}D(y,$){this.F(y,$)?(this.P(`reusing an existing recursive watcher to monitor ${y.path}`),this.m.delete(y.correlationId)):(this.G(y,$),this.m.add(y.correlationId))}F(y,$){const g=this.O?.subscribe(y.path,(a,c)=>{$.isDisposed||(a?this.D(y,$):c?.type===D.FileChangeType.ADDED&&this.H(y))});return g?($.add(g),!0):!1}G(y,$){let g=!1;const a=(c,m)=>{if($.isDisposed)return;const b=this.I(c),p=this.I(m),d=g;g=b,!b&&(p||d)&&this.H(y)};this.P(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,t.watchFile)(y.path,{persistent:!1,interval:this.r},a)}catch(c){this.Q(`fs.watchFile() failed with error ${c} on path ${y.path} (correlationId: ${y.correlationId})`)}$.add((0,r.$Xc)(()=>{this.P(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,t.unwatchFile)(y.path,a)}catch(c){this.Q(`fs.unwatchFile() failed with error ${c} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}H(y){this.P(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const $={resource:T.URI.file(y.path),type:D.FileChangeType.ADDED,cId:y.correlationId};this.a.fire([$]),this.J($,y),this.C(y)}I(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(y,$){if(this.R){const g=` >> normalized ${y.type===D.FileChangeType.ADDED?"[ADDED]":y.type===D.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.L(g,$)}}L(y,$){this.R&&this.P(`${y}${typeof $.correlationId=="number"?` <${$.correlationId}> `:""}`)}M(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,E.$jr)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.R=y}}e.$sr=s}),define(Te[210],Oe([1,0,23,13,18,36,2,106,8,3,19,4,194,26,15,52]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0,e.$yr=b;class m extends D.$Zc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(d,w,o,l,n,u){super(),this.s=d,this.t=w,this.u=o,this.w=l,this.y=n,this.z=u,this.c=this.B(new r.$Zh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.u(i))),this.f=this.B(new r.$Yh(i=>this.M(i),m.b)),this.g=(0,c.$hr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$hr)(this.s.path,this.s.includes):void 0,this.j=(0,c.$_q)(this.s)?this.s.filter:void 0,this.m=new E.$Be,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const d=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const w=await t.promises.stat(d);if(this.m.token.isCancellationRequested)return;this.B(await this.G(d,w.isDirectory()))}catch(d){d.code!=="ENOENT"?this.O(d):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${d})`),this.D()}}D(){this.r=!0,this.w?.()}async F(d){let w=d.path;try{w=await g.Promises.realpath(d.path),d.path===w&&(w=await(0,$.$ur)(d.path,this.m.token)??d.path),d.path!==w&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${w})`)}catch{}return w}async G(d,w){const o=new D.$Yc;return this.H(d,w,o)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(d,w,o)),o}H(d,w,o){if(w)return!1;const l=y.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(u,i)=>{if(!o.isDisposed)if(u){const f=await this.G(d,w);o.isDisposed?f.dispose():o.add(f)}else i&&(typeof i.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:l,type:i.type,cId:this.s.correlationId},!0)});return n?(o.add(n),!0):!1}async I(d,w,o){if(s.$m&&(0,P.$Jg)(d,"/Volumes/",!0)){this.O(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const l=new E.$Be(this.m.token);o.add((0,D.$Xc)(()=>l.dispose(!0)));const n=new D.$Yc;o.add(n);try{const u=y.URI.file(this.s.path),i=(0,v.$sc)(d),f=(0,t.watch)(d);n.add((0,D.$Xc)(()=>{f.removeAllListeners(),f.close()})),this.Q(`Started watching: '${d}'`);const h=new Set;if(w)try{for(const I of await g.Promises.readdir(d))h.add(I)}catch(I){this.O(I)}if(l.token.isCancellationRequested)return;const k=new Map;n.add((0,D.$Xc)(()=>{for(const[,I]of k)I.dispose();k.clear()})),f.on("error",(I,O)=>{l.token.isCancellationRequested||(this.O(`Failed to watch ${d} for changes using fs.watch() (${I}, ${O})`),this.D())}),f.on("change",(I,O)=>{if(l.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${I}"] ${O}`);let C="";if(O&&(C=O.toString(),s.$m&&(C=(0,T.$sm)(C))),!(!C||I!=="change"&&I!=="rename"))if(w)if(I==="rename"){k.get(C)?.dispose();const L=setTimeout(async()=>{if(k.delete(C),C===i&&!await g.Promises.exists(d)){this.J(u);return}if(l.token.isCancellationRequested)return;const R=await this.N((0,v.$oc)(d,C));if(l.token.isCancellationRequested)return;let M;R?h.has(C)?M=a.FileChangeType.UPDATED:(M=a.FileChangeType.ADDED,h.add(C)):(h.delete(C),M=a.FileChangeType.DELETED),this.L({resource:(0,S.$lh)(u,C),type:M,cId:this.s.correlationId})},m.a);k.set(C,(0,D.$Xc)(()=>clearTimeout(L)))}else{let L;h.has(C)?L=a.FileChangeType.UPDATED:(L=a.FileChangeType.ADDED,h.add(C)),this.L({resource:(0,S.$lh)(u,C),type:L,cId:this.s.correlationId})}else if(I==="rename"||C!==i){const L=setTimeout(async()=>{const R=await g.Promises.exists(d);l.token.isCancellationRequested||(R?(this.L({resource:u,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(d,!1))):this.J(u))},m.a);n.clear(),n.add((0,D.$Xc)(()=>clearTimeout(L)))}else this.L({resource:u,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(u){l.token.isCancellationRequested||this.O(`Failed to watch ${d} for changes using fs.watch() (${u.toString()})`),this.D()}}J(d){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:d,type:a.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(d,w=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${d.type===a.FileChangeType.ADDED?"[ADDED]":d.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!w&&this.g.some(o=>o(d.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${d.resource.fsPath}`):!w&&this.h&&this.h.length>0&&!this.h.some(o=>o(d.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}M(d){const w=(0,c.$fr)(d),o=[];for(const n of w){if((0,c.$ir)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}o.push(n)}if(o.length===0)return;if(this.z)for(const n of o)this.R(` >> normalized ${n.type===a.FileChangeType.ADDED?"[ADDED]":n.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(o)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(d){if(s.$n)return g.Promises.exists(d);try{const w=(0,v.$sc)(d);return(await g.Promises.readdir((0,v.$rc)(d))).some(l=>l===w)}catch(w){return this.Q(w),!1}}setVerboseLogging(d){this.z=d}O(d){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}P(d){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}Q(d){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}R(d){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${d}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$xr=m;async function b(p,d,w,o,l=512){const n=await g.Promises.open(p,"r"),u=Buffer.allocUnsafe(l),i=new E.$Be(o);let f,h=!1;const k={path:p,excludes:[],recursive:!1},I=new m(k,void 0,O=>{(async()=>{for(const{type:C}of O)if(C===a.FileChangeType.UPDATED){if(h)return;h=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:L}=await g.Promises.read(n,u,0,l,null);if(!L||i.token.isCancellationRequested)break;d(u.slice(0,L))}}catch(L){f=new Error(L),i.dispose(!0)}finally{h=!1}}})()});return await I.ready,w(),new Promise((O,C)=>{i.token.onCancellationRequested(async()=>{I.dispose();try{await g.Promises.close(n)}catch(L){f=new Error(L)}f?C(f):O()})})}}),define(Te[211],Oe([1,0,6,86,209,3,210,36]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class v extends E.$sr{constructor(S){super(),this.O=S,this.onDidError=t.Event.None,this.watchers=new Set}async N(S){S=this.Z(S);const y=[],$=new Set(Array.from(this.watchers));for(const g of S){const a=this.W(g);a&&(0,r.$Jk)(a.request.excludes,g.excludes)&&(0,r.$Jk)(a.request.includes,g.includes)?$.delete(a):y.push(g)}y.length&&this.P(`Request to start watching: ${y.map(g=>this.M(g)).join(",")}`),$.size&&this.P(`Request to stop watching: ${Array.from($).map(g=>this.M(g.request)).join(",")}`);for(const g of $)this.Y(g);for(const g of y)this.X(g)}W(S){for(const y of this.watchers)if(typeof S.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===S.correlationId)return y}else if((0,T.$Ig)(y.request.path,S.path,!P.$n))return y}X(S){const y=new D.$xr(S,this.O,g=>this.a.fire(g),()=>this.c.fire(S),g=>this.b.fire(g),this.R),$={request:S,instance:y};this.watchers.add($)}async stop(){await super.stop();for(const S of this.watchers)this.Y(S)}Y(S){this.P("stopping file watcher",S),this.watchers.delete(S),S.instance.dispose()}Z(S){const y=new Map;for(const $ of S){const g=P.$n?$.path:$.path.toLowerCase();let a=y.get($.correlationId);a||(a=new Map,y.set($.correlationId,a)),a.has(g)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M($)}`),a.set(g,$)}return Array.from(y.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(S){super.setVerboseLogging(S);for(const y of this.watchers)y.instance.setVerboseLogging(S)}P(S,y){this.R&&this.b.fire({type:"trace",message:this.bb(S,y)})}Q(S){this.b.fire({type:"warn",message:this.bb(S)})}bb(S,y){return y?`[File Watcher (node.js)] ${S} (${this.M(y.request)})`:`[File Watcher (node.js)] ${S}`}}e.$zr=v}),define(Te[212],Oe([1,0,52,211]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;class E extends t.$cr{constructor(D,T,v){super(D,T,v),this.s()}r(D){return D.add(new r.$zr(void 0))}}e.$Ar=E}),define(Te[213],Oe([1,0,12,51,118,52]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class D extends P.$dr{constructor(v,s,S){super(v,s,S),this.s()}r(v){const s=v.add(new E.$qr(t.$5g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(s.onDidProcessExit(({code:S,signal:y})=>this.t(`terminated by itself with code ${S}, signal: ${y} (ETERM)`))),r.ProxyChannel.toService((0,r.$ri)(s.getChannel("watcher")))}}e.$rr=D}),define(Te[89],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=void 0;class t{constructor(...E){this.a=new Map;for(const[P,D]of E)this.set(P,D)}set(E,P){const D=this.a.get(E);return this.a.set(E,P),D}has(E){return this.a.has(E)}get(E){return this.a.get(E)}}e.$Ii=t}),define(Te[123],Oe([1,0,13,9,2,72,204,5,89,81]),function(ue,e,t,r,E,P,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;const S=!1;class y extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class ${constructor(m=new v.$Ii,b=!1,p,d=S){this.i=m,this.j=b,this.k=p,this.l=d,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Ji,this),this._globalGraph=d?p?._globalGraph??new D.$Dr(w=>w):void 0}dispose(){if(!this.f){this.f=!0,(0,E.$Uc)(this.h),this.h.clear();for(const m of this.g)(0,E.$Tc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,b){this.m();const p=this,d=new class extends ${dispose(){p.h.delete(d),super.dispose()}}(m,this.j,this,this.l);return this.h.add(d),b?.add(d),d}invokeFunction(m,...b){this.m();const p=a.traceInvocation(this.l,m);let d=!1;try{return m({get:o=>{if(d)throw(0,r.$_)("service accessor is only valid during the invocation of its target method");const l=this.s(o,p);if(!l)throw new Error(`[invokeFunction] unknown service '${o}'`);return l}},...b)}finally{d=!0,p.stop()}}createInstance(m,...b){this.m();let p,d;return m instanceof P.$Hi?(p=a.traceCreation(this.l,m.ctor),d=this.o(m.ctor,m.staticArguments.concat(b),p)):(p=a.traceCreation(this.l,m),d=this.o(m,b,p)),p.stop(),d}o(m,b=[],p){const d=T._util.getServiceDependencies(m).sort((l,n)=>l.index-n.index),w=[];for(const l of d){const n=this.s(l.id,p);n||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${l.id}.`,!1),w.push(n)}const o=d.length>0?d[0].index:b.length;if(b.length!==o){console.trace(`[createInstance] First service dependency of ${m.name} at position ${o+1} conflicts with ${b.length} static arguments`);const l=o-b.length;l>0?b=b.concat(new Array(l)):b=b.slice(0,o)}return Reflect.construct(m,b.concat(w))}q(m,b){if(this.i.get(m)instanceof P.$Hi)this.i.set(m,b);else if(this.k)this.k.q(m,b);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const b=this.i.get(m);return!b&&this.k?this.k.r(m):b}s(m,b){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const p=this.r(m);return p instanceof P.$Hi?this.u(m,p,b.branch(m,!0)):(b.branch(m,!1),p)}u(m,b,p){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,b,p)}finally{this.t.delete(m)}}v(m,b,p){const d=new D.$Dr(n=>n.id.toString());let w=0;const o=[{id:m,desc:b,_trace:p}],l=new Set;for(;o.length;){const n=o.pop();if(!l.has(String(n.id))){if(l.add(String(n.id)),d.lookupOrInsertNode(n),w++>1e3)throw new y(d);for(const u of T._util.getServiceDependencies(n.desc.ctor)){const i=this.r(u.id);if(i||this.y(`[createInstance] ${m} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(u.id)),i instanceof P.$Hi){const f={id:u.id,desc:i,_trace:n._trace.branch(u.id,!0)};d.insertEdge(n,f),o.push(f)}}}}for(;;){const n=d.roots();if(n.length===0){if(!d.isEmpty())throw new y(d);break}for(const{data:u}of n){if(this.r(u.id)instanceof P.$Hi){const f=this.w(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.q(u.id,f)}d.removeNode(u)}}return this.r(m)}w(m,b,p=[],d,w){if(this.i.get(m)instanceof P.$Hi)return this.x(m,b,p,d,w,this.g);if(this.k)return this.k.w(m,b,p,d,w);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}x(m,b,p=[],d,w,o){if(d){const l=new $(void 0,this.j,this,this.l);l.c=String(m);const n=new Map,u=new t.$4h(()=>{const i=l.o(b,p,w);for(const[f,h]of n){const k=i[f];if(typeof k=="function")for(const I of h)I.disposable=k.apply(i,I.listener)}return n.clear(),o.add(i),i});return new Proxy(Object.create(null),{get(i,f){if(!u.isInitialized&&typeof f=="string"&&(f.startsWith("onDid")||f.startsWith("onWill"))){let I=n.get(f);return I||(I=new s.$0c,n.set(f,I)),(C,L,R)=>{if(u.isInitialized)return u.value[f](C,L,R);{const M={listener:[C,L,R],disposable:void 0},G=I.push(M);return(0,E.$Xc)(()=>{G(),M.disposable?.dispose()})}}}if(f in i)return i[f];const h=u.value;let k=h[f];return typeof k!="function"||(k=k.bind(h),i[f]=k),k},set(i,f,h){return u.value[f]=h,!0},getPrototypeOf(i){return b.prototype}})}else{const l=this.o(b,p,w);return o.add(l),l}}y(m,b){if(b&&console.warn(m),this.j)throw new Error(m)}}e.$Er=$;var g;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(g||(g={}));class a{static{this.all=new Set}static{this.c=new class extends a{constructor(){super(g.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,b){return m?new a(g.Invocation,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):a.c}static traceCreation(m,b){return m?new a(g.Creation,b.name):a.c}static{this.f=0}constructor(m,b){this.type=m,this.name=b,this.g=Date.now(),this.h=[]}branch(m,b){const p=new a(g.Branch,m.toString());return this.h.push([m,b,p]),p}stop(){const m=Date.now()-this.g;a.f+=m;let b=!1;function p(w,o){const l=[],n=new Array(w+1).join("	");for(const[u,i,f]of o.h)if(i&&f){b=!0,l.push(`${n}CREATES -> ${u}`);const h=p(w+1,f);h&&l.push(h)}else l.push(`${n}uses -> ${u}`);return l.join(`
`)}const d=[`${this.type===g.Creation?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${a.f.toFixed(2)}ms)`];(m>2||b)&&a.all.add(d.join(`
`))}}e.$Fr=a}),define(Te[214],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$Bw=void 0,e.$Bw=(0,t.$Ki)("labelService");var r;(function(E){E[E.SHORT=0]="SHORT",E[E.MEDIUM=1]="MEDIUM",E[E.LONG=2]="LONG"})(r||(e.Verbosity=r={}))}),define(Te[11],Oe([1,0,7,45,6,66,2,25,3,19,10,4,41,5]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$ik=e.LogLevel=e.$gk=e.$fk=void 0,e.$hk=c,e.log=b,e.$tk=k,e.$uk=I,e.$vk=O,e.$wk=C,t=Ve(t),e.$fk=(0,g.$Ki)("logService"),e.$gk=(0,g.$Ki)("loggerService");function a(){return new Date().toISOString()}function c(L){return(0,S.$ng)(L)}var m;(function(L){L[L.Off=0]="Off",L[L.Trace=1]="Trace",L[L.Debug=2]="Debug",L[L.Info=3]="Info",L[L.Warning=4]="Warning",L[L.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$ik=m.Info;function b(L,R,M){switch(R){case m.Trace:L.trace(M);break;case m.Debug:L.debug(M);break;case m.Info:L.info(M);break;case m.Warning:L.warn(M);break;case m.Error:L.error(M);break;case m.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function p(L,R=!1){let M="";for(let G=0;G<L.length;G++){let Q=L[G];if(Q instanceof Error&&(Q=(0,r.$vj)(Q,R)),typeof Q=="object")try{Q=JSON.stringify(Q)}catch{}M+=(G>0?" ":"")+Q}return M}class d extends D.$Zc{constructor(){super(...arguments),this.b=e.$ik,this.c=this.B(new E.$qe),this.onDidChangeLogLevel=this.c.event}setLevel(R){this.b!==R&&(this.b=R,this.c.fire(this.b))}getLevel(){return this.b}f(R){return this.b!==m.Off&&this.b<=R}}e.$kk=d;class w extends d{constructor(R){super(),this.h=R}f(R){return this.h||super.f(R)}trace(R,...M){this.f(m.Trace)&&this.g(m.Trace,p([R,...M],!0))}debug(R,...M){this.f(m.Debug)&&this.g(m.Debug,p([R,...M]))}info(R,...M){this.f(m.Info)&&this.g(m.Info,p([R,...M]))}warn(R,...M){this.f(m.Warning)&&this.g(m.Warning,p([R,...M]))}error(R,...M){if(this.f(m.Error))if(R instanceof Error){const G=Array.prototype.slice.call(arguments);G[0]=R.stack,this.g(m.Error,p(G))}else this.g(m.Error,p([R,...M]))}flush(){}}e.$lk=w;class o extends d{constructor(R=e.$ik){super(),this.setLevel(R),this.g=!v.$l}trace(R,...M){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,R,...M):console.log(`[main ${a()}]`,R,...M))}debug(R,...M){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,R,...M):console.log(`[main ${a()}]`,R,...M))}info(R,...M){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,R,...M):console.log(`[main ${a()}]`,R,...M))}warn(R,...M){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,R,...M):console.warn(`[main ${a()}]`,R,...M))}error(R,...M){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,R,...M):console.error(`[main ${a()}]`,R,...M))}flush(){}}e.$mk=o;class l extends d{constructor(R=e.$ik,M=!0){super(),this.g=M,this.setLevel(R)}trace(R,...M){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",R,...M):console.log(R,...M))}debug(R,...M){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",R,...M):console.log(R,...M))}info(R,...M){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",R,...M):console.log(R,...M))}warn(R,...M){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",R,...M):console.log(R,...M))}error(R,...M){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",R,...M):console.error(R,...M))}flush(){}}e.$nk=l;class n extends d{constructor(R,M=e.$ik){super(),this.g=R,this.setLevel(M)}trace(R,...M){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(R),...M])}debug(R,...M){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(R),...M])}info(R,...M){this.f(m.Info)&&this.g.log(m.Info,[this.h(R),...M])}warn(R,...M){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(R),...M])}error(R,...M){this.f(m.Error)&&this.g.log(m.Error,[this.h(R),...M])}h(R){return typeof R=="string"?R:(0,r.$vj)(R,this.f(m.Trace))}flush(){}}e.$ok=n;class u extends d{constructor(R){super(),this.g=R,R.length&&this.setLevel(R[0].getLevel())}setLevel(R){for(const M of this.g)M.setLevel(R);super.setLevel(R)}trace(R,...M){for(const G of this.g)G.trace(R,...M)}debug(R,...M){for(const G of this.g)G.debug(R,...M)}info(R,...M){for(const G of this.g)G.info(R,...M)}warn(R,...M){for(const G of this.g)G.warn(R,...M)}error(R,...M){for(const G of this.g)G.error(R,...M)}flush(){for(const R of this.g)R.flush()}dispose(){for(const R of this.g)R.dispose();super.dispose()}}e.$pk=u;class i extends D.$Zc{constructor(R,M,G){if(super(),this.h=R,this.j=M,this.b=new T.$Fc,this.c=this.B(new E.$qe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new E.$qe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new E.$qe),this.onDidChangeVisibility=this.g.event,G)for(const Q of G)this.b.set(Q.resource,{logger:void 0,info:Q})}m(R){return(0,S.$jg)(R)?[...this.b.values()].find(M=>M.info.id===R):this.b.get(R)}getLogger(R){return this.m(R)?.logger}createLogger(R,M){const G=this.n(R),Q=(0,S.$jg)(R)?R:M?.id??(0,P.$yj)(G.toString()).toString(16);let te=this.b.get(G)?.logger;const ve=M?.logLevel==="always"?m.Trace:M?.logLevel;te||(te=this.s(G,ve??this.getLogLevel(G)??this.h,{...M,id:Q}));const be={logger:te,info:{resource:G,id:Q,logLevel:ve,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(be.info),this.b.set(G,be),te}n(R){return(0,S.$jg)(R)?(0,s.$lh)(this.j,`${R}.log`):R}setLogLevel(R,M){if(y.URI.isUri(R)){const G=R,Q=M,te=this.b.get(G);te&&Q!==te.info.logLevel&&(te.info.logLevel=Q===this.h?void 0:Q,te.logger?.setLevel(Q),this.b.set(te.info.resource,te),this.f.fire([G,Q]))}else{this.h=R;for(const[G,Q]of this.b.entries())this.b.get(G)?.info.logLevel===void 0&&Q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(R,M){const G=this.m(R);G&&M!==!G.info.hidden&&(G.info.hidden=!M,this.b.set(G.info.resource,G),this.g.fire([G.info.resource,M]))}getLogLevel(R){let M;return R&&(M=this.b.get(R)?.info.logLevel),M??this.h}registerLogger(R){const M=this.b.get(R.resource);M?M.info.hidden!==R.hidden&&this.setVisibility(R.resource,!R.hidden):(this.b.set(R.resource,{info:R,logger:void 0}),this.c.fire({added:[R],removed:[]}))}deregisterLogger(R){const M=this.b.get(R);M&&(M.logger&&M.logger.dispose(),this.b.delete(R),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const R of this.b.values())yield R.info}getRegisteredLogger(R){return this.b.get(R)?.info}dispose(){this.b.forEach(R=>R.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qk=i;class f{constructor(){this.onDidChangeLogLevel=new E.$qe().event}setLevel(R){}getLevel(){return m.Info}trace(R,...M){}debug(R,...M){}info(R,...M){}warn(R,...M){}error(R,...M){}critical(R,...M){}dispose(){}flush(){}}e.$rk=f;class h extends f{}e.$sk=h;function k(L){if(L.verbose)return m.Trace;if(typeof L.logLevel=="string"){const R=C(L.logLevel.toLowerCase());if(R!==void 0)return R}return e.$ik}function I(L){switch(L){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function O(L){switch(L){case m.Trace:return{original:"Trace",value:t.localize(1959,null)};case m.Debug:return{original:"Debug",value:t.localize(1960,null)};case m.Info:return{original:"Info",value:t.localize(1961,null)};case m.Warning:return{original:"Warning",value:t.localize(1962,null)};case m.Error:return{original:"Error",value:t.localize(1963,null)};case m.Off:return{original:"Off",value:t.localize(1964,null)}}}function C(L){switch(L){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$xk=new $.$2j("logLevel",I(m.Info))});var je=this&&this.__param||function(ue,e){return function(t,r){e(t,r,ue)}};define(Te[124],Oe([1,0,50,68,64,12,43,27,5,11]),function(ue,e,t,r,E,P,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kS=e.$jS=void 0,e.$jS=(0,v.$Ki)("ICSSDevelopmentService");let S=class{constructor($,g){this.b=$,this.c=g}get isEnabled(){return!this.b.isBuilt&&E.$V}getCssModules(){return this.a??=this.d(),this.a}async d(){if(!this.isEnabled)return[];const $=await new Promise((g,a)=>{ue(["@vscode/ripgrep"],g,a)}).then(Ve);return await new Promise(g=>{const a=D.$ke.create(),c=[],m=new TextDecoder,b=P.$5g.asFileUri("").fsPath,p=(0,t.spawn)($.rgPath,["-g","**/*.css","--files","--no-ignore",b],{});p.stdout.on("data",d=>{const w=m.decode(d,{stream:!0});c.push(w.split(`
`).filter(Boolean))}),p.on("error",d=>{this.c.error("[CSS_DEV] FAILED to compute CSS data",d),g([])}),p.on("close",()=>{const d=c.flat().map(w=>(0,r.relative)(b,w).replace(/\\/g,"/")).filter(Boolean).sort();g(d),this.c.info(`[CSS_DEV] DONE, ${d.length} css modules (${Math.round(a.elapsed())}ms)`)})})}};e.$kS=S,e.$kS=S=We([je(0,T.$Ri),je(1,s.$fk)],S)}),define(Te[215],Oe([1,0,17,13,9,6,36,2,8,52,11]),function(ue,e,t,r,E,P,D,T,v,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class y extends T.$Zc{constructor(g,a){super(),this.a=g,this.b=a,this.c=this.B(new P.$qe),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$qe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Ih(0)),this.w=[],this.y=this.B(new r.$Ih(0))}watch(g,a){return a.recursive||this.b?.watcher?.forceUniversal?this.n(g,a):this.z(g,a)}n(g,a){const c={path:this.J(g),excludes:a.excludes,includes:a.includes,recursive:a.recursive,filter:a.filter,correlationId:a.correlationId},m=(0,t.$Xb)(this.j,c);return this.r(),(0,T.$Xc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,E.$4)(g))}s(){this.h||(this.h=this.B(this.t(a=>this.c.fire((0,s.$er)(a)),a=>this.G(a),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const a of this.j)(0,s.$ar)(a)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const a of this.j)(0,s.$ar)(a)&&g.includes(a.path)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,a){const c={path:this.J(g),excludes:a.excludes,includes:a.includes,recursive:!1,filter:a.filter,correlationId:a.correlationId},m=(0,t.$Xb)(this.w,c);return this.C(),(0,T.$Xc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,E.$4)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,s.$er)(g)),g=>this.G(g),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.H(g)}H(g){this.a[g.type](g.message)}I(g){return(0,v.$mc)(g.fsPath)}J(g){const a=this.I(g);return(0,D.$Mg)(a)}}e.$kr=y}),define(Te[125],Oe([1,0,17,13,14,18,6,66,39,2,67,12,44,19,56,7,15,122,11,9]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;let o=class extends s.$Zc{static{w=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new D.$qe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$qe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$qe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$qe),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$qe),this.Y=this.B(new D.$qe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$qe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Th)}registerProvider(n,u){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${n}`);const i=new s.$Yc;return this.h.set(n,u),this.c.fire({added:!0,scheme:n,provider:u}),i.add(u.onDidChangeFile(f=>{const h=new m.$yl(f,!this.S(u));this.X.fire(h),h.hasCorrelation()||this.Y.fire(h)})),typeof u.onDidWatchError=="function"&&i.add(u.onDidWatchError(f=>this.Z.fire(new Error(f)))),i.add(u.onDidChangeCapabilities(()=>this.g.fire({provider:u,scheme:n}))),(0,s.$Xc)(()=>{this.c.fire({added:!1,scheme:n,provider:u}),this.h.delete(n),(0,s.$Uc)(i)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const u=[];this.f.fire({scheme:n,join(i){u.push(i)}}),!this.h.has(n)&&await r.Promises.settled(u)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,u){const i=this.h.get(n.scheme);return!!(i&&i.capabilities&u)}listCapabilities(){return v.Iterable.map(this.h,([n,u])=>({scheme:n,capabilities:u.capabilities}))}async j(n){if(!(0,g.$ph)(n))throw new m.$Al((0,c.localize)(1871,null,this.sb(n)),m.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const u=this.h.get(n.scheme);if(!u){const i=new d.$fb;throw i.message=(0,c.localize)(1872,null,n.toString()),i}return u}async m(n){const u=await this.j(n);if((0,m.$ll)(u)||(0,m.$il)(u)||(0,m.$ml)(u))return u;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const u=await this.j(n);if((0,m.$ll)(u)||(0,m.$il)(u))return u;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,u){try{return await this.s(n,u)}catch(i){throw(0,m.$vl)(i)===m.FileSystemProviderErrorCode.FileNotFound?new m.$Al((0,c.localize)(1873,null,this.sb(n)),m.FileOperationResult.FILE_NOT_FOUND):(0,m.$tl)(i)}}async s(n,u){const i=await this.j(n),f=this.S(i),h=u?.resolveTo,k=u?.resolveSingleChildDescendants,I=u?.resolveMetadata,O=await i.stat(n);let C;return this.t(i,n,O,void 0,!!I,(L,R)=>(C||(C=S.$Qi.forUris(()=>!f),C.set(n,!0),h&&C.fill(!0,h)),C.get(L.resource)||C.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&k?R===1:!1))}async t(n,u,i,f,h,k){const{providerExtUri:I}=this.R(n),O={resource:u,name:I.basename(u),isFile:(i.type&m.FileType.File)!==0,isDirectory:(i.type&m.FileType.Directory)!==0,isSymbolicLink:(i.type&m.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&m.FilePermission.Readonly)||!!(n.capabilities&m.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&m.FilePermission.Locked),etag:(0,m.$Ll)({mtime:i.mtime,size:i.size}),children:void 0};if(O.isDirectory&&k(O,f)){try{const C=await n.readdir(u),L=await r.Promises.settled(C.map(async([R,M])=>{try{const G=I.joinPath(u,R),Q=h?await n.stat(G):{type:M};return await this.t(n,G,Q,C.length,h,k)}catch(G){return this.b.trace(G),null}}));O.children=(0,t.$Lb)(L)}catch(C){this.b.trace(C),O.children=[]}return O}return O}async resolveAll(n){return r.Promises.settled(n.map(async u=>{try{return{stat:await this.s(u.resource,u.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(n){const u=await this.j(n),i=await u.stat(n);return this.t(u,n,i,void 0,!0,()=>!1)}async exists(n){const u=await this.j(n);try{return!!await u.stat(n)}catch{return!1}}async canCreateFile(n,u){try{await this.u(n,u)}catch(i){return i}return!0}async u(n,u){if(!u?.overwrite&&await this.exists(n))throw new m.$Al((0,c.localize)(1874,null,this.sb(n)),m.FileOperationResult.FILE_MODIFIED_SINCE,u)}async createFile(n,u=E.$Se.fromString(""),i){await this.u(n,i);const f=await this.writeFile(n,u);return this.r.fire(new m.$xl(n,m.FileOperation.CREATE,f)),f}async writeFile(n,u,i){const f=this.qb(await this.n(n),n),{providerExtUri:h}=this.R(f);let k=i;if((0,m.$ol)(f)&&!k?.atomic){const I=f.enforceAtomicWriteFile?.(n);I&&(k={...i,atomic:I})}try{await this.w(f,n,k)||await this.U(f,h.dirname(n));let O;if((0,m.$il)(f)&&!(u instanceof E.$Se))if((0,a.$Ee)(u)){const C=await(0,a.$Le)(u,3);C.ended?O=E.$Se.concat(C.buffer):O=C}else O=(0,a.$Ie)(u,C=>E.$Se.concat(C),3);else O=u;!(0,m.$ll)(f)||(0,m.$il)(f)&&O instanceof E.$Se||(0,m.$il)(f)&&(0,m.$ol)(f)&&k?.atomic?await this.hb(f,n,k,O):await this.db(f,n,k,O instanceof E.$Se?(0,E.$4e)(O):O),this.r.fire(new m.$xl(n,m.FileOperation.WRITE))}catch(I){throw new m.$Al((0,c.localize)(1875,null,this.sb(n),(0,m.$tl)(I).toString()),(0,m.$wl)(I),k)}return this.resolve(n,{resolveMetadata:!0})}async w(n,u,i){const f=!!i?.unlock;if(f&&!(n.capabilities&m.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,c.localize)(1876,null,this.sb(u)));if(!!i?.atomic){if(!(n.capabilities&m.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,c.localize)(1877,null,this.sb(u)));if(!(n.capabilities&m.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,c.localize)(1878,null,this.sb(u)));if(f)throw new Error((0,c.localize)(1879,null,this.sb(u)))}let k;try{k=await n.stat(u)}catch{return}if(k.type&m.FileType.Directory)throw new m.$Al((0,c.localize)(1880,null,this.sb(u)),m.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.rb(u,k),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==m.$Kl&&typeof k.mtime=="number"&&typeof k.size=="number"&&i.mtime<k.mtime&&i.etag!==(0,m.$Ll)({mtime:i.mtime,size:k.size}))throw new m.$Al((0,c.localize)(1881,null),m.FileOperationResult.FILE_MODIFIED_SINCE,i);return k}async readFile(n,u,i){const f=await this.m(n);return u?.atomic?this.z(f,n,u,i):this.C(f,n,u,i)}async z(n,u,i,f){return new Promise((h,k)=>{this.cb.queueFor(u,async()=>{try{const I=await this.C(n,u,i,f);h(I)}catch(I){k(I)}},this.R(n).providerExtUri)})}async C(n,u,i,f){const h=await this.D(n,u,{...i,preferUnbuffered:!0},f);return{...h,value:await(0,E.$5e)(h.value)}}async readFileStream(n,u,i){const f=await this.m(n);return this.D(f,n,u,i)}async D(n,u,i,f){const h=new P.$Be(f);let k=i;(0,m.$nl)(n)&&n.enforceAtomicReadFile?.(u)&&(k={...i,atomic:!0});const I=this.J(u,k).then(C=>C,C=>{throw h.dispose(!0),C});let O;try{return typeof k?.etag=="string"&&k.etag!==m.$Kl&&await I,k?.atomic&&(0,m.$nl)(n)||!((0,m.$ll)(n)||(0,m.$ml)(n))||(0,m.$il)(n)&&k?.preferUnbuffered?O=this.I(n,u,k):(0,m.$ml)(n)?O=this.G(n,u,h.token,k):O=this.H(n,u,h.token,k),O.on("end",()=>h.dispose()),O.on("error",()=>h.dispose()),{...await I,value:O}}catch(C){throw O&&await(0,a.$Je)(O),this.F(C,u,k)}}F(n,u,i){const f=(0,c.localize)(1882,null,this.sb(u),(0,m.$tl)(n).toString());return n instanceof m.$Cl?new m.$Cl(f,n.stat,i):n instanceof m.$Bl?new m.$Bl(f,n.fileOperationResult,n.size,n.options):new m.$Al(f,(0,m.$wl)(n),i)}G(n,u,i,f=Object.create(null)){const h=n.readFileStream(u,f,i);return(0,a.$Pe)(h,{data:k=>k instanceof E.$Se?k:E.$Se.wrap(k),error:k=>this.F(k,u,f)},k=>E.$Se.concat(k))}H(n,u,i,f=Object.create(null)){const h=(0,E.$9e)();return(0,b.$0q)(n,u,h,k=>k,{...f,bufferSize:this.a,errorTransformer:k=>this.F(k,u,f)},i),h}I(n,u,i){const f=(0,a.$Ge)(h=>E.$Se.concat(h));return(async()=>{try{let h;i?.atomic&&(0,m.$nl)(n)?h=await n.readFile(u,{atomic:!0}):h=await n.readFile(u),typeof i?.position=="number"&&(h=h.slice(i.position)),typeof i?.length=="number"&&(h=h.slice(0,i.length)),this.L(u,h.byteLength,i),f.end(E.$Se.wrap(h))}catch(h){f.error(h),f.end()}})(),f}async J(n,u){const i=await this.resolve(n,{resolveMetadata:!0});if(i.isDirectory)throw new m.$Al((0,c.localize)(1883,null,this.sb(n)),m.FileOperationResult.FILE_IS_DIRECTORY,u);if(typeof u?.etag=="string"&&u.etag!==m.$Kl&&u.etag===i.etag)throw new m.$Cl((0,c.localize)(1884,null),i,u);return this.L(n,i.size,u),i}L(n,u,i){if(typeof i?.limits?.size=="number"&&u>i.limits.size)throw new m.$Bl((0,c.localize)(1885,null,this.sb(n)),m.FileOperationResult.FILE_TOO_LARGE,u,i)}async canMove(n,u,i){return this.M(n,u,"move",i)}async canCopy(n,u,i){return this.M(n,u,"copy",i)}async M(n,u,i,f){if(n.toString()!==u.toString())try{const h=i==="move"?this.qb(await this.n(n),n):await this.m(n),k=this.qb(await this.n(u),u);await this.Q(h,n,k,u,i,f)}catch(h){return h}return!0}async move(n,u,i){const f=this.qb(await this.n(n),n),h=this.qb(await this.n(u),u),k=await this.N(f,n,h,u,"move",!!i),I=await this.resolve(u,{resolveMetadata:!0});return this.r.fire(new m.$xl(n,k==="move"?m.FileOperation.MOVE:m.FileOperation.COPY,I)),I}async copy(n,u,i){const f=await this.m(n),h=this.qb(await this.n(u),u),k=await this.N(f,n,h,u,"copy",!!i),I=await this.resolve(u,{resolveMetadata:!0});return this.r.fire(new m.$xl(n,k==="copy"?m.FileOperation.COPY:m.FileOperation.MOVE,I)),I}async N(n,u,i,f,h,k){if(u.toString()===f.toString())return h;const{exists:I,isSameResourceWithDifferentPathCase:O}=await this.Q(n,u,i,f,h,k);if(I&&!O&&k&&await this.del(f,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(f)),h==="copy"){if(n===i&&(0,m.$jl)(n))await n.copy(u,f,{overwrite:k});else{const C=await this.resolve(u);C.isDirectory?await this.P(n,C,i,f):await this.O(n,u,i,f)}return h}else return n===i?(await n.rename(u,f,{overwrite:k}),h):(await this.N(n,u,i,f,"copy",k),await this.del(u,{recursive:!0}),"copy")}async O(n,u,i,f){if((0,m.$ll)(n)&&(0,m.$ll)(i))return this.jb(n,u,i,f);if((0,m.$ll)(n)&&(0,m.$il)(i))return this.pb(n,u,i,f);if((0,m.$il)(n)&&(0,m.$ll)(i))return this.nb(n,u,i,f);if((0,m.$il)(n)&&(0,m.$il)(i))return this.lb(n,u,i,f)}async P(n,u,i,f){await i.mkdir(f),Array.isArray(u.children)&&await r.Promises.settled(u.children.map(async h=>{const k=this.R(i).providerExtUri.joinPath(f,h.name);return h.isDirectory?this.P(n,await this.resolve(h.resource),i,k):this.O(n,h.resource,i,k)}))}async Q(n,u,i,f,h,k){let I=!1;if(n===i){const{providerExtUri:C,isPathCaseSensitive:L}=this.R(n);if(L||(I=C.isEqual(u,f)),I&&h==="copy")throw new Error((0,c.localize)(1886,null,this.sb(u),this.sb(f)));if(!I&&C.isEqualOrParent(f,u))throw new Error((0,c.localize)(1887,null,this.sb(u),this.sb(f)))}const O=await this.exists(f);if(O&&!I){if(!k)throw new m.$Al((0,c.localize)(1888,null,this.sb(u),this.sb(f)),m.FileOperationResult.FILE_MOVE_CONFLICT);if(n===i){const{providerExtUri:C}=this.R(n);if(C.isEqualOrParent(u,f))throw new Error((0,c.localize)(1889,null,this.sb(u),this.sb(f)))}}return{exists:O,isSameResourceWithDifferentPathCase:I}}R(n){const u=this.S(n);return{providerExtUri:u?g.$bh:g.$dh,isPathCaseSensitive:u}}S(n){return!!(n.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const u=this.qb(await this.j(n),n);await this.U(u,n);const i=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new m.$xl(n,m.FileOperation.CREATE,i)),i}async U(n,u){const i=[],{providerExtUri:f}=this.R(n);for(;!f.isEqual(u,f.dirname(u));)try{if(!((await n.stat(u)).type&m.FileType.Directory))throw new Error((0,c.localize)(1890,null,this.sb(u)));break}catch(h){if((0,m.$vl)(h)!==m.FileSystemProviderErrorCode.FileNotFound)throw h;i.push(f.basename(u)),u=f.dirname(u)}for(let h=i.length-1;h>=0;h--){u=f.joinPath(u,i[h]);try{await n.mkdir(u)}catch(k){if((0,m.$vl)(k)!==m.FileSystemProviderErrorCode.FileExists)throw k}}}async canDelete(n,u){try{await this.W(n,u)}catch(i){return i}return!0}async W(n,u){const i=this.qb(await this.j(n),n),f=!!u?.useTrash;if(f&&!(i.capabilities&m.FileSystemProviderCapabilities.Trash))throw new Error((0,c.localize)(1891,null,this.sb(n)));const h=u?.atomic;if(h&&!(i.capabilities&m.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,c.localize)(1892,null,this.sb(n)));if(f&&h)throw new Error((0,c.localize)(1893,null,this.sb(n)));let k;try{k=await i.stat(n)}catch{}if(k)this.rb(n,k);else throw new m.$Al((0,c.localize)(1894,null,this.sb(n)),m.FileOperationResult.FILE_NOT_FOUND);if(!!!u?.recursive){const O=await this.resolve(n);if(O.isDirectory&&Array.isArray(O.children)&&O.children.length>0)throw new Error((0,c.localize)(1895,null,this.sb(n)))}return i}async del(n,u){const i=await this.W(n,u);let f=u;if((0,m.$pl)(i)&&!f?.atomic){const O=i.enforceAtomicDelete?.(n);O&&(f={...u,atomic:O})}const h=!!f?.useTrash,k=!!f?.recursive,I=f?.atomic??!1;await i.delete(n,{recursive:k,useTrash:h,atomic:I}),this.r.fire(new m.$xl(n,m.FileOperation.DELETE))}async cloneFile(n,u){const i=await this.j(n),f=this.qb(await this.n(u),u);if(!(i===f&&this.R(i).providerExtUri.isEqual(n,u)))return i===f&&(0,m.$kl)(i)?i.cloneFile(n,u):(await this.U(f,this.R(f).providerExtUri.dirname(u)),i===f&&(0,m.$jl)(i)?this.cb.queueFor(n,()=>i.copy(n,u,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(n,()=>this.O(i,n,f,u),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(n,u){return this.watch(n,{...u,correlationId:w.ab++})}watch(n,u={recursive:!1,excludes:[]}){const i=new s.$Yc;let f=!1,h=()=>{f=!0};i.add((0,s.$Xc)(()=>h())),(async()=>{try{const I=await this.bb(n,u);f?(0,s.$Uc)(I):h=()=>(0,s.$Uc)(I)}catch(I){this.b.error(I)}})();const k=u.correlationId;if(typeof k=="number"){const I=i.add(new D.$qe);return i.add(this.X.event(C=>{C.correlates(k)&&I.fire(C)})),{onDidChange:I.event,dispose:()=>i.dispose()}}return i}async bb(n,u){const i=await this.j(n),f=(0,T.$yj)([this.R(i).providerExtUri.getComparisonKey(n),u]);let h=this.$.get(f);return h||(h={count:0,disposable:i.watch(n,u)},this.$.set(f,h)),h.count+=1,(0,s.$Xc)(()=>{h&&(h.count--,h.count===0&&((0,s.$Uc)(h.disposable),this.$.delete(f)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,s.$Uc)(n.disposable);this.$.clear()}async db(n,u,i,f){return this.cb.queueFor(u,async()=>{const h=await n.open(u,{create:!0,unlock:i?.unlock??!1});try{(0,a.$Ee)(f)||(0,a.$Fe)(f)?await this.eb(n,h,f):await this.fb(n,h,f)}catch(k){throw(0,m.$tl)(k)}finally{await n.close(h)}},this.R(n).providerExtUri)}async eb(n,u,i){let f=0,h;if((0,a.$Fe)(i)){if(i.buffer.length>0){const k=E.$Se.concat(i.buffer);await this.gb(n,u,k,k.byteLength,f,0),f+=k.byteLength}if(i.ended)return;h=i.stream}else h=i;return new Promise((k,I)=>{(0,a.$Ke)(h,{onData:async O=>{h.pause();try{await this.gb(n,u,O,O.byteLength,f,0)}catch(C){return I(C)}f+=O.byteLength,setTimeout(()=>h.resume())},onError:O=>I(O),onEnd:()=>k()})})}async fb(n,u,i){let f=0,h;for(;(h=i.read())!==null;)await this.gb(n,u,h,h.byteLength,f,0),f+=h.byteLength}async gb(n,u,i,f,h,k){let I=0;for(;I<f;){const O=await n.write(u,h+I,i.buffer,k+I,f-I);I+=O}}async hb(n,u,i,f){return this.cb.queueFor(u,()=>this.ib(n,u,i,f),this.R(n).providerExtUri)}async ib(n,u,i,f){let h;f instanceof E.$Se?h=f:(0,a.$Ee)(f)?h=await(0,E.$5e)(f):(0,a.$Fe)(f)?h=await(0,E.$6e)(f):h=(0,E.$3e)(f),await n.writeFile(u,h.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(n,u,i,f){return this.cb.queueFor(f,()=>this.kb(n,u,i,f),this.R(i).providerExtUri)}async kb(n,u,i,f){let h,k;try{h=await n.open(u,{create:!1}),k=await i.open(f,{create:!0,unlock:!1});const I=E.$Se.alloc(this.a);let O=0,C=0,L=0;do L=await n.read(h,O,I.buffer,C,I.byteLength-C),await this.gb(i,k,I,L,O,C),O+=L,C+=L,C===I.byteLength&&(C=0);while(L>0)}catch(I){throw(0,m.$tl)(I)}finally{await r.Promises.settled([typeof h=="number"?n.close(h):Promise.resolve(),typeof k=="number"?i.close(k):Promise.resolve()])}}async lb(n,u,i,f){return this.cb.queueFor(f,()=>this.mb(n,u,i,f),this.R(i).providerExtUri)}async mb(n,u,i,f){return i.writeFile(f,await n.readFile(u),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,u,i,f){return this.cb.queueFor(f,()=>this.ob(n,u,i,f),this.R(i).providerExtUri)}async ob(n,u,i,f){const h=await i.open(f,{create:!0,unlock:!1});try{const k=await n.readFile(u);await this.gb(i,h,E.$Se.wrap(k),k.byteLength,0,0)}catch(k){throw(0,m.$tl)(k)}finally{await i.close(h)}}async pb(n,u,i,f){const h=await(0,E.$5e)(this.H(n,u,P.CancellationToken.None));await this.hb(i,f,void 0,h)}qb(n,u){if(n.capabilities&m.FileSystemProviderCapabilities.Readonly)throw new m.$Al((0,c.localize)(1896,null,this.sb(u)),m.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,u){if((u.permissions??0)&m.FilePermission.Readonly)throw new m.$Al((0,c.localize)(1897,null,this.sb(n)),m.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===y.Schemas.file?n.fsPath:n.toString(!0)}};e.$$q=o,e.$$q=o=w=We([je(0,p.$fk)],o)}),define(Te[73],Oe([1,0,23,13,25,14,6,36,2,8,3,19,56,26,7,15,122,215,213,212]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;class w extends b.$kr{static{this.L=!1}constructor(l,n){super(l,n),this.onDidChangeCapabilities=D.Event.None,this.P=new E.$Fc(u=>y.$ch.getComparisonKey(u)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,S.$n&&(this.M|=c.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(l){try{const{stat:n,symbolicLink:u}=await g.SymlinkSupport.stat(this.I(l));return{type:this.O(n,u),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:c.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(l){try{return await this.stat(l)}catch{return}}async readdir(l){try{const n=await g.Promises.readdir(this.I(l),{withFileTypes:!0}),u=[];return await Promise.all(n.map(async i=>{try{let f;i.isSymbolicLink()?f=(await this.stat((0,y.$lh)(l,i.name))).type:f=this.O(i),u.push([i.name,f])}catch(f){this.a.trace(f)}})),u}catch(n){throw this.hb(n)}}O(l,n){let u;return n?.dangling?u=c.FileType.Unknown:l.isFile()?u=c.FileType.File:l.isDirectory()?u=c.FileType.Directory:u=c.FileType.Unknown,n&&(u|=c.FileType.SymbolicLink),u}async Q(l){const n=this.I(l);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let u;for(;u=this.P.get(l);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await u.wait();const i=new r.$Jh;return this.P.set(l,i),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,v.$Xc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(l)===i&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(l)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),i.open()})}async readFile(l,n){let u;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(l)})`),u=await this.Q(l));const i=this.I(l);return await t.promises.readFile(i)}catch(i){throw this.hb(i)}finally{u?.dispose()}}R(l){w.L&&this.a.trace(l)}readFileStream(l,n,u){const i=(0,$.$Ge)(f=>P.$Se.concat(f.map(h=>P.$Se.wrap(h))).buffer);return(0,m.$0q)(this,l,i,f=>f.buffer,{...n,bufferSize:256*1024},u),i}async writeFile(l,n,u){return u?.atomic!==!1&&u?.atomic?.postfix&&await this.S(l)?this.U(l,(0,y.$lh)((0,y.$kh)(l),`${(0,y.$ih)(l)}${u.atomic.postfix}`),n,u):this.W(l,n,u)}async S(l){try{const n=this.I(l),{symbolicLink:u}=await g.SymlinkSupport.stat(n);if(u)return!1}catch{}return!0}async U(l,n,u,i){const f=new v.$Yc;try{f.add(await this.Q(l)),f.add(await this.Q(n)),await this.W(n,u,i,!0);try{await this.rename(n,l,{overwrite:!0})}catch(h){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw h}}finally{f.dispose()}}async W(l,n,u,i){let f;try{const h=this.I(l);if(!u.create||!u.overwrite){if(await g.Promises.exists(h)){if(!u.overwrite)throw(0,c.$sl)((0,a.localize)(1901,null),c.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,c.$sl)((0,a.localize)(1902,null),c.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(l,{create:!0,unlock:u.unlock},i),await this.write(f,0,n,0,n.byteLength)}catch(h){throw await this.ib(l,h)}finally{typeof f=="number"&&await this.close(f)}}static{this.$=!0}static configureFlushOnWrite(l){w.$=l}async open(l,n,u){const i=this.I(l);let f;(0,c.$gl)(n)&&!u&&(f=await this.Q(l));let h;try{if((0,c.$gl)(n)&&n.unlock)try{const{stat:I}=await g.SymlinkSupport.stat(i);I.mode&128||await t.promises.chmod(i,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let k;if((0,c.$gl)(n)){if(S.$l)try{await t.promises.truncate(i,0),k="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}k||(k="w")}else k="r";h=await g.Promises.open(i,k)}catch(k){throw f?.dispose(),(0,c.$gl)(n)?await this.ib(l,k):this.hb(k)}if(this.X.set(h,0),(0,c.$gl)(n)&&this.Z.set(h,l),f){const k=this.Y.get(h);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${h} (${i})`),this.Y.set(h,f),k&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${h} (${i})`),k.dispose())}return h}async close(l){const n=this.Y.get(l);try{if(this.X.delete(l),this.Z.delete(l)&&w.$)try{await g.Promises.fdatasync(l)}catch(u){w.configureFlushOnWrite(!1),this.a.error(u)}return await g.Promises.close(l)}catch(u){throw this.hb(u)}finally{n&&(this.Y.get(l)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${l}`),this.Y.delete(l)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${l}`),n.dispose())}}async read(l,n,u,i,f){const h=this.ab(l,n);let k=null;try{k=(await g.Promises.read(l,u,i,f,h)).bytesRead}catch(I){throw this.hb(I)}finally{this.bb(l,h,k)}return k}ab(l,n){return n===this.X.get(l)?null:n}bb(l,n,u){const i=this.X.get(l);typeof i=="number"&&(typeof n=="number"||(typeof u=="number"?this.X.set(l,i+u):this.X.delete(l)))}async write(l,n,u,i,f){return(0,r.$5h)(()=>this.cb(l,n,u,i,f),100,3)}async cb(l,n,u,i,f){const h=this.ab(l,n);let k=null;try{k=(await g.Promises.write(l,u,i,f,h)).bytesWritten}catch(I){throw await this.ib(this.Z.get(l),I)}finally{this.bb(l,h,k)}return k}async mkdir(l){try{await t.promises.mkdir(this.I(l))}catch(n){throw this.hb(n)}}async delete(l,n){try{const u=this.I(l);if(n.recursive){let i;n?.atomic!==!1&&n.atomic.postfix&&(i=(0,s.$oc)((0,s.$rc)(u),`${(0,s.$sc)(u)}${n.atomic.postfix}`)),await g.Promises.rm(u,g.RimRafMode.MOVE,i)}else try{await t.promises.unlink(u)}catch(i){if(i.code==="EPERM"||i.code==="EISDIR"){let f=!1;try{const{stat:h,symbolicLink:k}=await g.SymlinkSupport.stat(u);f=h.isDirectory()&&!k}catch{}if(f)await t.promises.rmdir(u);else throw i}else throw i}}catch(u){throw this.hb(u)}}async rename(l,n,u){const i=this.I(l),f=this.I(n);if(i!==f)try{await this.db(l,n,"move",u.overwrite),await g.Promises.rename(i,f)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,a.localize)(1903,null,(0,s.$sc)(i),(0,s.$sc)((0,s.$rc)(f)),h.toString()))),this.hb(h)}}async copy(l,n,u){const i=this.I(l),f=this.I(n);if(i!==f)try{await this.db(l,n,"copy",u.overwrite),await g.Promises.copy(i,f,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,a.localize)(1904,null,(0,s.$sc)(i),(0,s.$sc)((0,s.$rc)(f)),h.toString()))),this.hb(h)}}async db(l,n,u,i){const f=this.I(l),h=this.I(n);let k=!1;if(!!(this.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive)||(k=(0,T.$Ig)(f,h,!0)),k){if(u==="copy")throw(0,c.$sl)((0,a.localize)(1905,null),c.FileSystemProviderErrorCode.FileExists);if(u==="move")return}const O=await this.N(l);if(!O)throw(0,c.$sl)((0,a.localize)(1906,null),c.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(n);if(C){if(!i)throw(0,c.$sl)((0,a.localize)(1907,null),c.FileSystemProviderErrorCode.FileExists);O.type&c.FileType.File&&C.type&c.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(l,n){return this.eb(l,n,!1)}async eb(l,n,u){const i=this.I(l),f=this.I(n),h=!!(this.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.$Ig)(i,f,!h))return;const k=new v.$Yc;try{k.add(await this.Q(l)),k.add(await this.Q(n)),u&&await t.promises.mkdir((0,s.$rc)(f),{recursive:!0}),await t.promises.copyFile(i,f)}catch(I){if(I.code==="ENOENT"&&!u)return this.eb(l,n,!0);throw this.hb(I)}finally{k.dispose()}}t(l,n,u){return new p.$rr(i=>l(i),i=>n(i),u)}F(l,n,u){return new d.$Ar(i=>l(i),i=>n(i),u)}hb(l){if(l instanceof c.$rl)return l;let n=l,u;switch(l.code){case"ENOENT":u=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,u=c.FileSystemProviderErrorCode.Unknown;break;default:u=c.FileSystemProviderErrorCode.Unknown}return(0,c.$sl)(n,u)}async ib(l,n){let u=this.hb(n);if(l&&u.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:i}=await g.SymlinkSupport.stat(this.I(l));i.mode&128||(u=(0,c.$sl)(n,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(i){this.a.trace(i)}return u}}e.$Br=w}),define(Te[216],Oe([1,0,6,73,2,14,56,18]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.$_s=void 0;class v extends E.$Zc{constructor(y,$){super(),this.a=y,this.b=$,this.F=new Map,this.G=new Map}call(y,$,g){const a=this.c(y);switch($){case"stat":return this.g(a,g[0]);case"readdir":return this.h(a,g[0]);case"open":return this.r(a,g[0],g[1]);case"close":return this.s(g[0]);case"read":return this.t(g[0],g[1],g[2]);case"readFile":return this.j(a,g[0],g[1]);case"write":return this.u(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.n(a,g[0],g[1],g[2]);case"rename":return this.z(a,g[0],g[1],g[2]);case"copy":return this.C(a,g[0],g[1],g[2]);case"cloneFile":return this.D(a,g[0],g[1]);case"mkdir":return this.w(a,g[0]);case"delete":return this.y(a,g[0],g[1]);case"watch":return this.I(a,g[0],g[1],g[2],g[3]);case"unwatch":return this.J(g[0],g[1])}throw new Error(`IPC Command ${$} not found`)}listen(y,$,g){const a=this.c(y);switch($){case"fileChange":return this.H(a,g[0]);case"readFileStream":return this.m(a,g[0],g[1])}throw new Error(`Unknown event ${$}`)}g(y,$){const g=this.f(y,$,!0);return this.a.stat(g)}h(y,$){const g=this.f(y,$);return this.a.readdir(g)}async j(y,$,g){const a=this.f(y,$,!0),c=await this.a.readFile(a,g);return P.$Se.wrap(c)}m(y,$,g){const a=this.f(y,$,!0),c=new T.$Be,m=new t.$qe({onDidRemoveLastListener:()=>{c.cancel()}}),b=this.a.readFileStream(a,g,c.token);return(0,D.$Ke)(b,{onData:p=>m.fire(P.$Se.wrap(p)),onError:p=>m.fire(p),onEnd:()=>{m.fire("end"),m.dispose(),c.dispose()}}),m.event}n(y,$,g,a){const c=this.f(y,$);return this.a.writeFile(c,g.buffer,a)}r(y,$,g){const a=this.f(y,$,!0);return this.a.open(a,g)}s(y){return this.a.close(y)}async t(y,$,g){const a=P.$Se.alloc(g),m=await this.a.read(y,$,a.buffer,0,g);return[a,m]}u(y,$,g,a,c){return this.a.write(y,$,g.buffer,a,c)}w(y,$){const g=this.f(y,$);return this.a.mkdir(g)}y(y,$,g){const a=this.f(y,$);return this.a.delete(a,g)}z(y,$,g,a){const c=this.f(y,$),m=this.f(y,g);return this.a.rename(c,m,a)}C(y,$,g,a){const c=this.f(y,$),m=this.f(y,g);return this.a.copy(c,m,a)}D(y,$,g){const a=this.f(y,$),c=this.f(y,g);return this.a.cloneFile(a,c)}H(y,$){const g=new t.$qe({onWillAddFirstListener:()=>{this.F.set($,this.L(y,g))},onDidRemoveLastListener:()=>{(0,E.$Uc)(this.F.get($)),this.F.delete($)}});return g.event}async I(y,$,g,a,c){const m=this.F.get($);if(m){const b=this.f(y,a),p=m.watch(g,b,c);this.G.set($+g,p)}}async J(y,$){const g=y+$,a=this.G.get(g);a&&((0,E.$Uc)(a),this.G.delete(g))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$_s=v;class s extends E.$Zc{constructor(y,$,g,a){super(),this.c=y,this.f=g,this.g=a,this.a=new Map,this.b=this.B(new r.$Br(this.f,{watcher:{recursive:this.j(this.g)}})),this.h($)}h(y){const $=this.B(new t.$qe);this.B($.event(g=>{y.fire(g.map(a=>({resource:this.c.transformOutgoingURI(a.resource),type:a.type,cId:a.cId})))})),this.B(this.b.onDidChangeFile(g=>$.fire(g))),this.B(this.b.onDidWatchError(g=>y.fire(g)))}j(y){}m(y){}watch(y,$,g){const a=this.m(this.g);return Array.isArray(a)&&(g.excludes=[...g.excludes,...a]),this.a.set(y,this.b.watch($,g)),(0,E.$Xc)(()=>{(0,E.$Uc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$at=s}),define(Te[126],Oe([1,0,4,6,11,2]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=e.$Cs=e.$Bs=void 0;class D extends E.$qk{constructor(y,$,g,a,c){super($,g,a),this.r=y,this.t=c,this.B(c.listen("onDidChangeLogLevel",y)(m=>{(0,E.$hk)(m)?super.setLogLevel(m):super.setLogLevel(t.URI.revive(m[0]),m[1])})),this.B(c.listen("onDidChangeVisibility",y)(([m,b])=>super.setVisibility(t.URI.revive(m),b))),this.B(c.listen("onDidChangeLoggers",y)(({added:m,removed:b})=>{for(const p of m)super.registerLogger({...p,resource:t.URI.revive(p.resource)});for(const p of b)super.deregisterLogger(p.resource)}))}createConsoleMainLogger(){return new E.$ok({log:(y,$)=>{this.t.call("consoleLog",[y,$])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,$){super.setLogLevel(y,$),this.t.call("setLogLevel",[y,$])}setVisibility(y,$){super.setVisibility(y,$),this.t.call("setVisibility",[this.n(y),$])}s(y,$,g){return new T(this.t,y,$,g,this.r)}static setLogLevel(y,$,g){return y.call("setLogLevel",[$,g])}}e.$Bs=D;class T extends E.$lk{constructor(y,$,g,a,c){super(a?.logLevel==="always"),this.r=y,this.s=$,this.m=!1,this.n=[],this.setLevel(g),this.r.call("createLogger",[$,a,c]).then(()=>{this.u(this.n),this.m=!0})}g(y,$){const g=[[y,$]];this.m?this.u(g):this.n.push(...g)}u(y){this.r.call("log",[this.s,y])}}class v{constructor(y,$){this.a=y,this.b=$}listen(y,$){const g=this.b(y);switch($){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,a=>({added:[...a.added].map(c=>this.c(c,g)),removed:[...a.removed].map(c=>this.c(c,g))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,a=>[g.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,a=>(0,E.$hk)(a)?a:[g.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${$}`)}async call(y,$,g){const a=this.b(y);switch($){case"setLogLevel":return(0,E.$hk)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(t.URI.revive(a.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(c=>this.c(c,a)))}throw new Error(`Call not found: ${$}`)}c(y,$){return{...y,resource:$.transformOutgoingURI(y.resource)}}}e.$Cs=v;class s extends P.$Zc{constructor(y,$){super(),$.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(g=>$.call("setLogLevel",[g]))),$.call("getRegisteredLoggers").then(g=>{for(const a of g)y.registerLogger({...a,resource:t.URI.revive(a.resource)})}),this.B($.listen("onDidChangeVisibility")(([g,a])=>y.setVisibility(t.URI.revive(g),a))),this.B($.listen("onDidChangeLoggers")(({added:g,removed:a})=>{for(const c of g)y.registerLogger({...c,resource:t.URI.revive(c.resource)});for(const c of a)y.deregisterLogger(c.resource)}))}}e.$Ds=s}),define(Te[127],Oe([1,0,2,11]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aS=void 0;class E extends t.$Zc{constructor(D,T=[]){super(),this.a=new r.$pk([D,...T]),this.B(D.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...T){this.a.trace(D,...T)}debug(D,...T){this.a.debug(D,...T)}info(D,...T){this.a.info(D,...T)}warn(D,...T){this.a.warn(D,...T)}error(D,...T){this.a.error(D,...T)}flush(){this.a.flush()}}e.$aS=E}),define(Te[217],Oe([1,0,15,11]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2R=void 0;var E;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(E||(E={}));async function P(s,S,y,$,g){try{const a=await new Promise((m,b)=>{ue(["@vscode/spdlog"],m,b)}).then(Ve);a.setFlushOn(E.Trace);const c=await a.createAsyncRotatingLogger(s,S,y,$);return g?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(a){console.error(a)}return null}function D(s,S,y){switch(S){case r.LogLevel.Trace:s.trace(y);break;case r.LogLevel.Debug:s.debug(y);break;case r.LogLevel.Info:s.info(y);break;case r.LogLevel.Warning:s.warn(y);break;case r.LogLevel.Error:s.error(y);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function T(s,S){switch(S){case r.LogLevel.Trace:s.setLevel(E.Trace);break;case r.LogLevel.Debug:s.setLevel(E.Debug);break;case r.LogLevel.Info:s.setLevel(E.Info);break;case r.LogLevel.Warning:s.setLevel(E.Warning);break;case r.LogLevel.Error:s.setLevel(E.Error);break;case r.LogLevel.Off:s.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class v extends r.$lk{constructor(S,y,$,g,a){super(),this.m=[],this.setLevel(a),this.n=this.s(S,y,$,g),this.B(this.onDidChangeLogLevel(c=>{this.r&&T(this.r,c)}))}async s(S,y,$,g){const a=$?6:1,c=30/a*t.$Nl.MB,m=await P(S,y,c,a,g);if(m){this.r=m,T(this.r,this.getLevel());for(const{level:b,message:p}of this.m)D(this.r,b,p);this.m=[]}}g(S,y){this.r?D(this.r,S,y):this.getLevel()<=S&&this.m.push({level:S,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$2R=v}),define(Te[128],Oe([1,0,22,11,217]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3R=void 0;class P extends r.$qk{s(T,v,s){return new E.$2R((0,t.$7g)(),T.fsPath,!s?.donotRotate,!!s?.donotUseFormatters,v)}}e.$3R=P});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[218],Oe([1,0,58,7,5]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ou=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,t=$t(t);var P;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var D;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(D||(e.MarkerSeverity=D={})),function(v){function s(a,c){return c-a}v.compare=s;const S=Object.create(null);S[v.Error]=(0,r.localize)(1965,null),S[v.Warning]=(0,r.localize)(1966,null),S[v.Info]=(0,r.localize)(1967,null);function y(a){return S[a]||""}v.toString=y;function $(a){switch(a){case t.default.Error:return v.Error;case t.default.Warning:return v.Warning;case t.default.Info:return v.Info;case t.default.Ignore:return v.Hint}}v.fromSeverity=$;function g(a){switch(a){case v.Error:return t.default.Error;case v.Warning:return t.default.Warning;case v.Info:return t.default.Info;case v.Hint:return t.default.Ignore}}v.toSeverity=g}(D||(e.MarkerSeverity=D={}));var T;(function(v){const s="";function S($){return y($,!0)}v.makeKey=S;function y($,g){const a=[s];return $.source?a.push($.source.replace("\xA6","\\\xA6")):a.push(s),$.code?typeof $.code=="string"?a.push($.code.replace("\xA6","\\\xA6")):a.push($.code.value.replace("\xA6","\\\xA6")):a.push(s),$.severity!==void 0&&$.severity!==null?a.push(D.toString($.severity)):a.push(s),$.message&&g?a.push($.message.replace("\xA6","\\\xA6")):a.push(s),$.startLineNumber!==void 0&&$.startLineNumber!==null?a.push($.startLineNumber.toString()):a.push(s),$.startColumn!==void 0&&$.startColumn!==null?a.push($.startColumn.toString()):a.push(s),$.endLineNumber!==void 0&&$.endLineNumber!==null?a.push($.endLineNumber.toString()):a.push(s),$.endColumn!==void 0&&$.endColumn!==null?a.push($.endColumn.toString()):a.push(s),a.push(s),a.join("\xA6")}v.makeKeyOptionalMessage=y})(T||(e.IMarkerData=T={})),e.$Ou=(0,E.$Ki)("markerService")}),define(Te[74],Oe([1,0,6,39,2,5]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=void 0,e.$zo=(0,P.$Ki)("policy");class D extends E.$Zc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new t.$qe),this.onDidChange=this.h.event}async updatePolicyDefinitions(s){const S=Object.keys(this.f).length;return this.f={...s,...this.f},S!==Object.keys(this.f).length&&await this.j(s),r.Iterable.reduce(this.g.entries(),(y,[$,g])=>({...y,[$]:g}),{})}getPolicyValue(s){return this.g.get(s)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(s,[S,y])=>({...s,[S]:{definition:y,value:this.g.get(S)}}),{})}}e.$Ao=D;class T{constructor(){this.onDidChange=t.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Bo=T}),define(Te[61],Oe([1,0,32]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const P=E.context.configuration();if(P)r=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:P.version})}}else r={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.3",sha256:"7380a890787452f14b2db7835dfa94de538caf358ebc263f9d46dd68ac52de93",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.93.0",sha256:"9339cb8e6b77f554df54d79e71f533279cb76b0f9b04c207f633bfd507442b6a",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"4.93.1",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.93.1",commit:"69df01185ce2f80e99c9e4f8c8de1907cc7a9bc5",date:"2024-10-08T06:39:42.021Z"},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(Te[29],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=void 0,e.$yk=(0,t.$Ki)("productService"),e.$zk="vscode://schemas/vscode-product"}),define(Te[219],Oe([1,0,13,18,2,5]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Kw=e.$Jw=e.$Iw=e.$Hw=e.ProgressLocation=e.$Gw=void 0,e.$Gw=(0,P.$Ki)("progressService");var D;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(D||(e.ProgressLocation=D={})),e.$Hw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$Iw=T;class v{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const g=this.d;this.d=()=>{g?.(),$()}}):Promise.resolve()}}e.$Jw=v;let s=class extends E.$Zc{constructor($,g){super(),this.a=new t.$8h,g.withProgress($,a=>(this.b=a,this.c&&a.report(this.c),this.a.p)),this.B((0,E.$Xc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$Kw=s,e.$Kw=s=We([je(1,e.$Gw)],s);class S extends E.$Zc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new E.$Yc)}start($){this.stop();const g=++this.a,a=new r.$Be;return this.f=setTimeout(()=>{g===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,E.$Xc)(()=>clearTimeout(this.f))),this.b.add((0,E.$Xc)(()=>a.cancel())),this.b.add((0,E.$Xc)(()=>this.c?this.c.done():void 0)),{id:g,token:a.token,stop:()=>this.h(g),isCurrent:()=>this.a===g}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$Lw=S,e.$Mw=(0,P.$Ki)("editorProgressService")}),define(Te[37],Oe([1,0,105,10]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=void 0,t=Ve(t),r=Ve(r);class E{constructor(){this.a=new Map}add(D,T){t.ok(r.$jg(D)),t.ok(r.$lg(T)),t.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,T)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$xo=new E}),define(Te[129],Oe([1,0,6,163,37]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=void 0,E=Ve(E),e.$yo={JSONContribution:"base.contributions.json"};function P(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class D{constructor(){this.b=new t.$qe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(s,S){this.a[P(s)]=S,this.b.fire(s)}notifySchemaChanged(s){this.b.fire(s)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(s){const S=this.a[s];return S?(0,r.$ak)(S):void 0}hasSchemaContent(s){return!!this.a[s]}}const T=new D;E.$xo.add(e.$yo.JSONContribution,T)}),define(Te[46],Oe([1,0,17,6,10,7,28,129,37]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ConfigurationScope=e.$Co=e.EditPresentationTypes=void 0,e.$No=c,e.$Oo=m,e.$Po=b,e.$Qo=d,e.$Ro=w,e.$So=o,e.$To=l,E=Ve(E),P=Ve(P);var s;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$Co={Configuration:"base.contributions.configuration"};var S;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho={properties:{},patternProperties:{}},e.$Io={properties:{},patternProperties:{}},e.$Jo="vscode://schemas/settings/resourceLanguage",e.$Ko="vscode://schemas/settings/configurationDefaults";const y=v.$xo.as(T.$yo.JSONContribution);class ${constructor(){this.a=[],this.i=new Set,this.j=new r.$qe,this.onDidSchemaChange=this.j.event,this.k=new r.$qe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:P.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},y.registerSchema(e.$Jo,this.h),this.z()}registerConfiguration(u,i=!0){this.registerConfigurations([u],i)}registerConfigurations(u,i=!0){const f=new Set;this.r(u,i,f),y.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:f})}deregisterConfigurations(u){const i=new Set;this.s(u,i),y.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:i})}updateConfigurations({add:u,remove:i}){const f=new Set;this.s(i,f),this.r(u,!1,f),y.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:f})}registerDefaultConfigurations(u){const i=new Set;this.l(u,i),this.j.fire(),this.k.fire({properties:i,defaultsOverrides:!0})}l(u,i){this.a.push(...u);const f=[];for(const{overrides:h,source:k}of u)for(const I in h){i.add(I);const O=this.b.get(I)??this.b.set(I,{configurationDefaultOverrides:[]}).get(I),C=h[I];if(O.configurationDefaultOverrides.push({value:C,source:k}),e.$Mo.test(I)){const L=this.o(I,C,k,O.configurationDefaultOverrideValue);if(!L)continue;O.configurationDefaultOverrideValue=L,this.n(I,L,k),f.push(...c(I))}else{const L=this.p(I,C,k,O.configurationDefaultOverrideValue);if(!L)continue;O.configurationDefaultOverrideValue=L;const R=this.e[I];R&&(this.A(I,R),this.w(I,R))}}this.q(f)}deregisterDefaultConfigurations(u){const i=new Set;this.m(u,i),this.j.fire(),this.k.fire({properties:i,defaultsOverrides:!0})}m(u,i){for(const f of u){const h=this.a.indexOf(f);h!==-1&&this.a.splice(h,1)}for(const{overrides:f,source:h}of u)for(const k in f){const I=this.b.get(k);if(!I)continue;const O=I.configurationDefaultOverrides.findIndex(C=>h?C.source?.id===h.id:C.value===f[k]);if(O!==-1){if(I.configurationDefaultOverrides.splice(O,1),I.configurationDefaultOverrides.length===0&&this.b.delete(k),e.$Mo.test(k)){let C;for(const L of I.configurationDefaultOverrides)C=this.o(k,L.value,L.source,C);C&&!E.$wg(C.value)?(I.configurationDefaultOverrideValue=C,this.n(k,C,h)):(this.b.delete(k),delete this.e[k],delete this.c.properties[k])}else{let C;for(const R of I.configurationDefaultOverrides)C=this.p(k,R.value,R.source,C);I.configurationDefaultOverrideValue=C;const L=this.e[k];L&&(this.A(k,L),this.w(k,L))}i.add(k)}}this.y()}n(u,i,f){const h={type:"object",default:i.value,description:P.localize(1663,null,(0,D.$oj)(u)),$ref:e.$Jo,defaultDefaultValue:i.value,source:f,defaultValueSource:f};this.e[u]=h,this.c.properties[u]=h}o(u,i,f,h){const k=h?.value||{},I=h?.source??new Map;if(!(I instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const O of Object.keys(i)){const C=i[O];if(E.$lg(C)&&(E.$qg(k[O])||E.$lg(k[O]))){if(k[O]={...k[O]??{},...C},f)for(const R in C)I.set(`${O}.${R}`,f)}else k[O]=C,f?I.set(O,f):I.delete(O)}return{value:k,source:I}}p(u,i,f,h){const k=this.e[u],I=h?.value??k?.defaultDefaultValue;let O=f;if(E.$lg(i)&&(k!==void 0&&k.type==="object"||k===void 0&&(E.$qg(I)||E.$lg(I)))){if(O=h?.source??new Map,!(O instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const L in i)f&&O.set(`${u}.${L}`,f);i={...E.$lg(I)?I:{},...i}}return{value:i,source:O}}deltaConfiguration(u){let i=!1;const f=new Set;u.removedDefaults&&(this.m(u.removedDefaults,f),i=!0),u.addedDefaults&&(this.l(u.addedDefaults,f),i=!0),u.removedConfigurations&&this.s(u.removedConfigurations,f),u.addedConfigurations&&this.r(u.addedConfigurations,!1,f),this.j.fire(),this.k.fire({properties:f,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...u){this.j.fire()}registerOverrideIdentifiers(u){this.q(u),this.j.fire()}q(u){for(const i of u)this.i.add(i);this.y()}r(u,i,f){u.forEach(h=>{this.u(h,i,h.extensionInfo,h.restrictedProperties,void 0,f),this.d.push(h),this.v(h)})}s(u,i){const f=h=>{if(h.properties)for(const k in h.properties){i.add(k);const I=this.e[k];I?.policy?.name&&this.f.delete(I.policy.name),delete this.e[k],this.x(k,h.properties[k])}h.allOf?.forEach(k=>f(k))};for(const h of u){f(h);const k=this.d.indexOf(h);k!==-1&&this.d.splice(k,1)}}u(u,i=!0,f,h,k=S.WINDOW,I){k=E.$sg(u.scope)?k:u.scope;const O=u.properties;if(O)for(const L in O){const R=O[L];if(i&&d(L,R)){delete O[L];continue}if(R.source=f,R.defaultDefaultValue=O[L].default,this.A(L,R),e.$Mo.test(L)?R.scope=void 0:(R.scope=E.$sg(R.scope)?k:R.scope,R.restricted=E.$sg(R.restricted)?!!h?.includes(L):R.restricted),O[L].hasOwnProperty("included")&&!O[L].included){this.g[L]=O[L],delete O[L];continue}else this.e[L]=O[L],O[L].policy?.name&&this.f.set(O[L].policy.name,L);!O[L].deprecationMessage&&O[L].markdownDeprecationMessage&&(O[L].deprecationMessage=O[L].markdownDeprecationMessage),I.add(L)}const C=u.allOf;if(C)for(const L of C)this.u(L,i,f,h,k,I)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const u=new Map;for(const[i,f]of this.b)f.configurationDefaultOverrideValue&&u.set(i,f.configurationDefaultOverrideValue);return u}v(u){const i=f=>{const h=f.properties;if(h)for(const I in h)this.w(I,h[I]);f.allOf?.forEach(i)};i(u)}w(u,i){switch(e.$Do.properties[u]=i,i.scope){case S.APPLICATION:e.$Eo.properties[u]=i;break;case S.MACHINE:e.$Fo.properties[u]=i;break;case S.MACHINE_OVERRIDABLE:e.$Go.properties[u]=i;break;case S.WINDOW:e.$Ho.properties[u]=i;break;case S.RESOURCE:e.$Io.properties[u]=i;break;case S.LANGUAGE_OVERRIDABLE:e.$Io.properties[u]=i,this.h.properties[u]=i;break}}x(u,i){switch(delete e.$Do.properties[u],i.scope){case S.APPLICATION:delete e.$Eo.properties[u];break;case S.MACHINE:delete e.$Fo.properties[u];break;case S.MACHINE_OVERRIDABLE:delete e.$Go.properties[u];break;case S.WINDOW:delete e.$Ho.properties[u];break;case S.RESOURCE:case S.LANGUAGE_OVERRIDABLE:delete e.$Io.properties[u],delete this.h.properties[u];break}}y(){for(const u of this.i.values()){const i=`[${u}]`,f={type:"object",description:P.localize(1664,null),errorMessage:P.localize(1665,null),$ref:e.$Jo};this.A(i,f),e.$Do.properties[i]=f,e.$Eo.properties[i]=f,e.$Fo.properties[i]=f,e.$Go.properties[i]=f,e.$Ho.properties[i]=f,e.$Io.properties[i]=f}}z(){const u={type:"object",description:P.localize(1666,null),errorMessage:P.localize(1667,null),$ref:e.$Jo};e.$Do.patternProperties[e.$Lo]=u,e.$Eo.patternProperties[e.$Lo]=u,e.$Fo.patternProperties[e.$Lo]=u,e.$Go.patternProperties[e.$Lo]=u,e.$Ho.patternProperties[e.$Lo]=u,e.$Io.patternProperties[e.$Lo]=u,this.j.fire()}A(u,i){const f=this.b.get(u)?.configurationDefaultOverrideValue;let h,k;f&&(!i.disallowConfigurationDefault||!f.source)&&(h=f.value,k=f.source),E.$qg(h)&&(h=i.defaultDefaultValue,k=void 0),E.$qg(h)&&(h=b(i.type)),i.default=h,i.defaultValueSource=k}}const g="\\[([^\\]]+)\\]",a=new RegExp(g,"g");e.$Lo=`^(${g})+$`,e.$Mo=new RegExp(e.$Lo);function c(n){const u=[];if(e.$Mo.test(n)){let i=a.exec(n);for(;i?.length;){const f=i[1].trim();f&&u.push(f),i=a.exec(n)}}return(0,t.$Qb)(u)}function m(n){return n.reduce((u,i)=>`${u}[${i}]`,"")}function b(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new $;v.$xo.add(e.$Co.Configuration,p);function d(n,u){return n.trim()?e.$Mo.test(n)?P.localize(1669,null,n):p.getConfigurationProperties()[n]!==void 0?P.localize(1670,null,n):u.policy?.name&&p.getPolicyConfigurations().get(u.policy?.name)!==void 0?P.localize(1671,null,n,u.policy?.name,p.getPolicyConfigurations().get(u.policy?.name)):null:P.localize(1668,null)}function w(){const n=[],u=p.getConfigurationProperties();for(const i of Object.keys(u))n.push([i,u[i].scope]);return n.push(["launch",S.RESOURCE]),n.push(["task",S.RESOURCE]),n}function o(n){const u={};for(const i of n){const f=i.properties;if(E.$lg(f))for(const h in f)u[h]=f[h];i.allOf&&Object.assign(u,o(i.allOf))}return u}function l(n){switch(n){case"application":return S.APPLICATION;case"machine":return S.MACHINE;case"resource":return S.RESOURCE;case"machine-overridable":return S.MACHINE_OVERRIDABLE;case"language-overridable":return S.LANGUAGE_OVERRIDABLE;default:return S.WINDOW}}}),define(Te[130],Oe([1,0,17,6,42,2,25,20,10,4,28,46,15,37]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0,e.$Yo=w,t=Ve(t),E=Ve(E),T=Ve(T),v=Ve(v);function a(u){return Object.isFrozen(u)?u:T.$lo(u)}class c{static createEmptyModel(i){return new c({},[],[],void 0,i)}constructor(i,f,h,k,I){this.b=i,this.c=f,this.d=h,this.raw=k,this.f=I,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(f=>{if(f instanceof c)return f;const h=new m("",this.f);return h.parseRaw(f),h.configurationModel});this.g=i.reduce((f,h)=>h===f?h:f.merge(h),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,S.$mj)(this.contents,i):this.contents}inspect(i,f){const h=this;return{get value(){return a(h.rawConfiguration.getValue(i))},get override(){return f?a(h.rawConfiguration.getOverrideValue(i,f)):void 0},get merged(){return a(f?h.rawConfiguration.override(f).getValue(i):h.rawConfiguration.getValue(i))},get overrides(){const k=[];for(const{contents:I,identifiers:O,keys:C}of h.rawConfiguration.overrides){const L=new c(I,C,[],void 0,h.f).getValue(i);L!==void 0&&k.push({identifiers:O,value:L})}return k.length?a(k):void 0}}}getOverrideValue(i,f){const h=this.j(f);return h?i?(0,S.$mj)(h,i):h:void 0}getKeysForOverrideIdentifier(i){const f=[];for(const h of this.overrides)h.identifiers.includes(i)&&f.push(...h.keys);return t.$Qb(f)}getAllOverrideIdentifiers(){const i=[];for(const f of this.overrides)i.push(...f.identifiers);return t.$Qb(i)}override(i){let f=this.a.get(i);return f||(f=this.h(i),this.a.set(i,f)),f}merge(...i){const f=T.$ko(this.contents),h=T.$ko(this.overrides),k=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const O of i)if(I.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.i(f,O.contents);for(const C of O.overrides){const[L]=h.filter(R=>t.$yb(R.identifiers,C.identifiers));L?(this.i(L.contents,C.contents),L.keys.push(...C.keys),L.keys=t.$Qb(L.keys)):h.push(T.$ko(C))}for(const C of O.keys)k.indexOf(C)===-1&&k.push(C)}return new c(f,k,h,I.every(O=>O instanceof c)?void 0:I,this.f)}h(i){const f=this.j(i);if(!f||typeof f!="object"||!Object.keys(f).length)return this;const h={};for(const k of t.$Qb([...Object.keys(this.contents),...Object.keys(f)])){let I=this.contents[k];const O=f[k];O&&(typeof I=="object"&&typeof O=="object"?(I=T.$ko(I),this.i(I,O)):I=O),h[k]=I}return new c(h,this.keys,this.overrides,void 0,this.f)}i(i,f){for(const h of Object.keys(f)){if(h in i&&v.$lg(i[h])&&v.$lg(f[h])){this.i(i[h],f[h]);continue}i[h]=T.$ko(f[h])}}j(i){let f=null,h=null;const k=I=>{I&&(h?this.i(h,I):h=T.$ko(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===i?f=I.contents:I.identifiers.includes(i)&&k(I.contents);return k(f),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,f){this.k(i,f,!0)}setValue(i,f){this.k(i,f,!1)}removeValue(i){const f=this.keys.indexOf(i);f!==-1&&(this.keys.splice(f,1),(0,S.$lj)(this.contents,i),y.$Mo.test(i)&&this.overrides.splice(this.overrides.findIndex(h=>t.$yb(h.identifiers,(0,y.$No)(i))),1))}k(i,f,h){if((0,S.$kj)(this.contents,i,f,k=>this.f.error(k)),h=h||this.keys.indexOf(i)===-1,h&&this.keys.push(i),y.$Mo.test(i)){const k=(0,y.$No)(i),I={identifiers:k,keys:Object.keys(this.contents[i]),contents:(0,S.$jj)(this.contents[i],C=>this.f.error(C))},O=this.overrides.findIndex(C=>t.$yb(C.identifiers,k));O!==-1?this.overrides[O]=I:this.overrides.push(I)}}}e.$Uo=c;class m{constructor(i,f){this.f=i,this.g=f,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,f){if(!v.$sg(i)){const h=this.h(i);this.parseRaw(h,f)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,f){this.a=i;const{contents:h,keys:k,overrides:I,restricted:O,hasExcludedProperties:C}=this.i(i,f);this.b=new c(h,k,I,C?[i]:void 0,this.g),this.c=O||[]}h(i){let f={},h=null,k=[];const I=[],O=[];function C(R){Array.isArray(k)?k.push(R):h!==null&&(k[h]=R)}const L={onObjectBegin:()=>{const R={};C(R),I.push(k),k=R,h=null},onObjectProperty:R=>{h=R},onObjectEnd:()=>{k=I.pop()},onArrayBegin:()=>{const R=[];C(R),I.push(k),k=R,h=null},onArrayEnd:()=>{k=I.pop()},onLiteralValue:C,onError:(R,M,G)=>{O.push({error:R,offset:M,length:G})}};if(i)try{E.$_n(i,L),f=k[0]||{}}catch(R){this.g.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return f}i(i,f){const h=g.$xo.as(y.$Co.Configuration).getConfigurationProperties(),k=this.j(i,h,!0,f);i=k.raw;const I=(0,S.$jj)(i,L=>this.g.error(`Conflict in settings file ${this.f}: ${L}`)),O=Object.keys(i),C=this.l(i,L=>this.g.error(`Conflict in settings file ${this.f}: ${L}`));return{contents:I,keys:O,overrides:C,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(i,f,h,k){let I=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:I};const O={},C=[];for(const L in i)if(y.$Mo.test(L)&&h){const R=this.j(i[L],f,!1,k);O[L]=R.raw,I=I||R.hasExcludedProperties,C.push(...R.restricted)}else{const R=f[L],M=R?typeof R.scope<"u"?R.scope:y.ConfigurationScope.WINDOW:void 0;R?.restricted&&C.push(L),!k.exclude?.includes(L)&&(k.include?.includes(L)||(M===void 0||k.scopes===void 0||k.scopes.includes(M))&&!(k.skipRestricted&&R?.restricted))?O[L]=i[L]:I=!0}return{raw:O,restricted:C,hasExcludedProperties:I}}l(i,f){const h=[];for(const k of Object.keys(i))if(y.$Mo.test(k)){const I={};for(const O in i[k])I[O]=i[k][O];h.push({identifiers:(0,y.$No)(k),keys:Object.keys(I),contents:(0,S.$jj)(I,f)})}return h}}e.$Vo=m;class b extends P.$Zc{constructor(i,f,h,k,I){super(),this.c=i,this.f=f,this.g=k,this.h=I,this.b=this.B(new r.$qe),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),I),this.B(this.g.watch(h.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,O=>O.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,O=>(O.isOperation($.FileOperation.CREATE)||O.isOperation($.FileOperation.COPY)||O.isOperation($.FileOperation.DELETE)||O.isOperation($.FileOperation.WRITE))&&h.isEqual(O.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Wo=b;class p{constructor(i,f,h,k,I,O,C,L,R,M,G,Q,te){this.a=i,this.b=f,this.c=h,this.overrideIdentifiers=k,this.d=I,this.f=O,this.g=C,this.h=L,this.i=R,this.j=M,this.k=G,this.l=Q,this.m=te}get value(){return a(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class d{constructor(i,f,h,k,I,O,C,L,R,M){this.j=i,this.l=f,this.m=h,this.n=k,this.p=I,this.q=O,this.r=C,this.s=L,this.t=R,this.u=M,this.h=null,this.i=new D.$Fc,this.v=null}getValue(i,f,h){return this.w(i,f,h).getValue(i)}updateValue(i,f,h={}){let k;h.resource?(k=this.t.get(h.resource),k||(k=c.createEmptyModel(this.u),this.t.set(h.resource,k))):k=this.s,f===void 0?k.removeValue(i):k.setValue(i,f),h.resource||(this.h=null)}inspect(i,f,h){const k=this.w(i,f,h),I=this.A(f.resource,h),O=f.resource?this.t.get(f.resource)||this.s:this.s,C=new Set;for(const L of k.overrides)for(const R of L.identifiers)k.getOverrideValue(i,R)!==void 0&&C.add(R);return new p(i,f,k.getValue(i),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,h?this.q:void 0,I||void 0,O)}keys(i){const f=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:f?f.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,f){this.r.set(i,f),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,f){const h=[];if(!f){const{added:k,updated:I,removed:O}=l(this.j,i);f=[...k,...I,...O]}for(const k of f)for(const I of(0,y.$No)(k)){const O=this.j.getKeysForOverrideIdentifier(I),C=i.getKeysForOverrideIdentifier(I),L=[...C.filter(R=>O.indexOf(R)===-1),...O.filter(R=>C.indexOf(R)===-1),...O.filter(R=>!T.$oo(this.j.override(I).getValue(R),i.override(I).getValue(R)))];h.push([I,L])}return this.updateDefaultConfiguration(i),{keys:f,overrides:h}}compareAndUpdatePolicyConfiguration(i){const{added:f,updated:h,removed:k}=l(this.l,i),I=[...f,...h,...k];return I.length&&this.updatePolicyConfiguration(i),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:f,updated:h,removed:k,overrides:I}=l(this.applicationConfiguration,i),O=[...f,...h,...k];return O.length&&this.updateApplicationConfiguration(i),{keys:O,overrides:I}}compareAndUpdateLocalUserConfiguration(i){const{added:f,updated:h,removed:k,overrides:I}=l(this.localUserConfiguration,i),O=[...f,...h,...k];return O.length&&this.updateLocalUserConfiguration(i),{keys:O,overrides:I}}compareAndUpdateRemoteUserConfiguration(i){const{added:f,updated:h,removed:k,overrides:I}=l(this.remoteUserConfiguration,i),O=[...f,...h,...k];return O.length&&this.updateRemoteUserConfiguration(i),{keys:O,overrides:I}}compareAndUpdateWorkspaceConfiguration(i){const{added:f,updated:h,removed:k,overrides:I}=l(this.workspaceConfiguration,i),O=[...f,...h,...k];return O.length&&this.updateWorkspaceConfiguration(i),{keys:O,overrides:I}}compareAndUpdateFolderConfiguration(i,f){const h=this.folderConfigurations.get(i),{added:k,updated:I,removed:O,overrides:C}=l(h,f),L=[...k,...I,...O];return(L.length||!h)&&this.updateFolderConfiguration(i,f),{keys:L,overrides:C}}compareAndDeleteFolderConfiguration(i){const f=this.folderConfigurations.get(i);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:h,updated:k,removed:I,overrides:O}=l(f,void 0);return{keys:[...h,...k,...I],overrides:O}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,f,h){let k=this.x(f,h);return f.overrideIdentifier&&(k=k.override(f.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(k=k.merge(this.l)),k}x({resource:i},f){let h=this.y();if(f&&i){const k=f.getFolder(i);k&&(h=this.z(k.uri)||h);const I=this.t.get(i);I&&(h=h.merge(I))}return h}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let f=this.i.get(i);if(!f){const h=this.y(),k=this.r.get(i);k?(f=h.merge(k),this.i.set(i,f)):f=h}return f}A(i,f){if(f&&i){const h=f.getFolder(i);if(h)return this.r.get(h.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,f)=>{const{contents:h,overrides:k,keys:I}=this.r.get(f);return i.push([f,{contents:h,overrides:k,keys:I}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(f=>i.add(f)),this.userConfiguration.keys.forEach(f=>i.add(f)),this.q.keys.forEach(f=>i.add(f)),this.r.forEach(f=>f.keys.forEach(h=>i.add(h))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(f=>i.add(f)),this.userConfiguration.getAllOverrideIdentifiers().forEach(f=>i.add(f)),this.q.getAllOverrideIdentifiers().forEach(f=>i.add(f)),this.r.forEach(f=>f.getAllOverrideIdentifiers().forEach(h=>i.add(h))),[...i.values()]}D(i){const f=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(h=>f.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(h=>f.add(h)),this.q.getKeysForOverrideIdentifier(i).forEach(h=>f.add(h)),this.r.forEach(h=>h.getKeysForOverrideIdentifier(i).forEach(k=>f.add(k))),[...f.values()]}static parse(i,f){const h=this.E(i.defaults,f),k=this.E(i.policy,f),I=this.E(i.application,f),O=this.E(i.user,f),C=this.E(i.workspace,f),L=i.folders.reduce((R,M)=>(R.set(s.URI.revive(M[0]),this.E(M[1],f)),R),new D.$Fc);return new d(h,k,I,O,c.createEmptyModel(f),C,L,c.createEmptyModel(f),new D.$Fc,f)}static E(i,f){return new c(i.contents,i.keys,i.overrides,void 0,f)}}e.$Xo=d;function w(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const i=new Set,f=new Map;for(const k of u)k.keys.forEach(I=>i.add(I)),k.overrides.forEach(([I,O])=>{const C=(0,D.$Cc)(f,I,new Set);O.forEach(L=>C.add(L))});const h=[];return f.forEach((k,I)=>h.push([I,[...k.values()]])),{keys:[...i.values()],overrides:h}}class o{constructor(i,f,h,k,I){this.change=i,this.f=f,this.g=h,this.h=k,this.i=I,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const O of i.keys)this.affectedKeys.add(O);for(const[,O]of i.overrides)for(const C of O)this.affectedKeys.add(C);this.d=this.a;for(const O of this.affectedKeys)this.d+=O+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=d.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,f){const h=this.a+i,k=this.d.indexOf(h);if(k<0)return!1;const I=k+h.length;if(I>=this.d.length)return!1;const O=this.d.charCodeAt(I);if(O!==this.b&&O!==this.c)return!1;if(f){const C=this.previousConfiguration?this.previousConfiguration.getValue(i,f,this.f?.workspace):void 0,L=this.g.getValue(i,f,this.h);return!T.$oo(C,L)}return!0}}e.$Zo=o;function l(u,i){const{added:f,removed:h,updated:k}=n(i?.rawConfiguration,u?.rawConfiguration),I=[],O=u?.getAllOverrideIdentifiers()||[],C=i?.getAllOverrideIdentifiers()||[];if(i){const L=C.filter(R=>!O.includes(R));for(const R of L)I.push([R,i.getKeysForOverrideIdentifier(R)])}if(u){const L=O.filter(R=>!C.includes(R));for(const R of L)I.push([R,u.getKeysForOverrideIdentifier(R)])}if(i&&u){for(const L of O)if(C.includes(L)){const R=n({contents:u.getOverrideValue(void 0,L)||{},keys:u.getKeysForOverrideIdentifier(L)},{contents:i.getOverrideValue(void 0,L)||{},keys:i.getKeysForOverrideIdentifier(L)});I.push([L,[...R.added,...R.removed,...R.updated]])}}return{added:f,removed:h,updated:k,overrides:I}}function n(u,i){const f=u?i?u.keys.filter(I=>i.keys.indexOf(I)===-1):[...u.keys]:[],h=i?u?i.keys.filter(I=>u.keys.indexOf(I)===-1):[...i.keys]:[],k=[];if(u&&i){for(const I of i.keys)if(u.keys.indexOf(I)!==-1){const O=(0,S.$mj)(i.contents,I),C=(0,S.$mj)(u.contents,I);T.$oo(O,C)||k.push(I)}}return{added:f,removed:h,updated:k}}}),define(Te[220],Oe([1,0,17,6,2,20,10,130,46,11,74,37]),function(ue,e,t,r,E,P,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=void 0;class $ extends E.$Zc{get configurationModel(){return this.b}constructor(m){super(),this.c=m,this.a=this.B(new r.$qe),this.onDidChangeConfiguration=this.a.event,this.b=T.$Uo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(y.$xo.as(v.$Co.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:b})=>this.f(Array.from(m),b))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(m,b){this.j(m,y.$xo.as(v.$Co.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}g(){return{}}h(){this.b=T.$Uo.createEmptyModel(this.c);const m=y.$xo.as(v.$Co.Configuration).getConfigurationProperties();this.j(Object.keys(m),m)}j(m,b){const p=this.g();for(const d of m){const w=p[d],o=b[d];w!==void 0?this.b.setValue(d,w):o?this.b.setValue(d,o.default):this.b.removeValue(d)}}}e.$1o=$;class g{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=T.$Uo.createEmptyModel(new s.$sk)}async initialize(){return this.configurationModel}}e.$2o=g;let a=class extends E.$Zc{get configurationModel(){return this.b}constructor(m,b,p){super(),this.c=m,this.f=b,this.g=p,this.a=this.B(new r.$qe),this.onDidChangeConfiguration=this.a.event,this.b=T.$Uo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const b={},p=[],d=y.$xo.as(v.$Co.Configuration).getConfigurationProperties();for(const w of m){const o=d[w];if(!o){p.push(w);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.g.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}p.push(w),b[o.policy.name]={type:o.type}}}return(0,D.$wg)(b)||await this.f.updatePolicyDefinitions(b),p}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const b=y.$xo.as(v.$Co.Configuration).getPolicyConfigurations(),p=(0,t.$Lb)(m.map(d=>b.get(d)));this.m(p,!0)}m(m,b){this.g.trace("PolicyConfiguration#update",m);const p=y.$xo.as(v.$Co.Configuration).getConfigurationProperties(),d=[],w=this.b.isEmpty();for(const o of m){const l=p[o]?.policy?.name;if(l){const n=this.f.getPolicyValue(l);(w?n!==void 0:!(0,P.$oo)(this.b.getValue(o),n))&&d.push([o,n])}else this.b.getValue(o)!==void 0&&d.push([o,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const o=this.b;this.b=T.$Uo.createEmptyModel(this.g);for(const l of o.keys)this.b.setValue(l,o.getValue(l));for(const[l,n]of d)n===void 0?this.b.removeValue(l):this.b.setValue(l,n);b&&this.a.fire(this.b)}}};e.$3o=a,e.$3o=a=We([je(1,S.$zo),je(2,s.$fk)],a)}),define(Te[131],Oe([1,0,17,13,14,6,42,162,2,25,20,3,19,28,130,46,220,15,74]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=void 0;class d extends v.$Zc{constructor(l,n,u,i){super(),this.m=l,this.n=i,this.h=this.B(new P.$qe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new m.$1o(i)),this.c=u instanceof p.$Bo?new m.$2o:this.B(new m.$3o(this.b,u,i)),this.f=this.B(new a.$Wo(this.m,{},$.$ch,n,i)),this.a=new a.$Xo(this.b.configurationModel,this.c.configurationModel,a.$Uo.createEmptyModel(i),a.$Uo.createEmptyModel(i),a.$Uo.createEmptyModel(i),a.$Uo.createEmptyModel(i),new s.$Fc,a.$Uo.createEmptyModel(i),new s.$Fc,i),this.j=new w(l,n,this),this.g=this.B(new r.$Wh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:h})=>this.s(f,h))),this.B(this.c.onDidChangeConfiguration(f=>this.t(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[l,n,u]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new a.$Xo(l,n,a.$Uo.createEmptyModel(this.n),u,a.$Uo.createEmptyModel(this.n),a.$Uo.createEmptyModel(this.n),new s.$Fc,a.$Uo.createEmptyModel(this.n),new s.$Fc,this.n)}getConfigurationData(){return this.a.toData()}getValue(l,n){const u=typeof l=="string"?l:void 0,i=(0,g.$fj)(l)?l:(0,g.$fj)(n)?n:{};return this.a.getValue(u,i,void 0)}async updateValue(l,n,u,i,f){const h=(0,g.$gj)(u)?u:(0,g.$fj)(u)?{resource:u.resource,overrideIdentifiers:u.overrideIdentifier?[u.overrideIdentifier]:void 0}:void 0,k=h?i:u;if(k!==void 0&&k!==g.ConfigurationTarget.USER_LOCAL&&k!==g.ConfigurationTarget.USER)throw new Error(`Unable to write ${l} to target ${k}.`);h?.overrideIdentifiers&&(h.overrideIdentifiers=(0,t.$Qb)(h.overrideIdentifiers),h.overrideIdentifiers=h.overrideIdentifiers.length?h.overrideIdentifiers:void 0);const I=this.inspect(l,{resource:h?.resource,overrideIdentifier:h?.overrideIdentifiers?h.overrideIdentifiers[0]:void 0});if(I.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,S.$oo)(n,I.defaultValue)&&(n=void 0),h?.overrideIdentifiers?.length&&h.overrideIdentifiers.length>1){const C=h.overrideIdentifiers.sort(),L=this.a.localUserConfiguration.overrides.find(R=>(0,t.$yb)([...R.identifiers].sort(),C));L&&(h.overrideIdentifiers=L.identifiers)}const O=h?.overrideIdentifiers?.length?[(0,c.$Oo)(h.overrideIdentifiers),l]:[l];await this.j.write(O,n),await this.reloadConfiguration()}inspect(l,n={}){return this.a.inspect(l,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const l=await this.f.loadConfiguration();this.r(l)}r(l){const n=this.a.toData(),u=this.a.compareAndUpdateLocalUserConfiguration(l);this.u(u,n,g.ConfigurationTarget.USER)}s(l,n){const u=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(l,n);this.u(i,u,g.ConfigurationTarget.DEFAULT)}t(l){const n=this.a.toData(),u=this.a.compareAndUpdatePolicyConfiguration(l);this.u(u,n,g.ConfigurationTarget.DEFAULT)}u(l,n,u){const i=new a.$Zo(l,{data:n},this.a,void 0,this.n);i.source=u,this.h.fire(i)}}e.$4o=d;class w{constructor(l,n,u){this.b=l,this.c=n,this.d=u,this.a=new r.$Rh}write(l,n){return this.a.queue(()=>this.e(l,n))}async e(l,n){let u;try{u=(await this.c.readFile(this.b)).value.toString()}catch(h){if(h.fileOperationResult===b.FileOperationResult.FILE_NOT_FOUND)u="{}";else throw h}const i=[];if((0,D.$5n)(u,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const f=this.f(u,l,n);u=(0,T.$jo)(u,f),await this.c.writeFile(this.b,E.$Se.fromString(u))}f(l,n,u){const{tabSize:i,insertSpaces:f,eol:h}=this.h;if(!n.length){const k=JSON.stringify(u,null,f?" ".repeat(i):"	");return[{content:k,length:k.length,offset:0}]}return(0,T.$go)(l,n,u,{tabSize:i,insertSpaces:f,eol:h})}get h(){if(!this.g){let l=y.OS===y.OperatingSystem.Linux||y.OS===y.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(l=n),this.g={eol:l,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(Te[90],Oe([1,0,9,5]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.RemoteAuthorityResolverErrorCode=e.$Yl=e.$Xl=e.RemoteConnectionType=e.$Wl=void 0,e.$1l=s,e.$Wl=(0,r.$Ki)("remoteAuthorityResolverService");var E;(function(S){S[S.WebSocket=0]="WebSocket",S[S.Managed=1]="Managed"})(E||(e.RemoteConnectionType=E={}));class P{constructor(y){this.id=y,this.type=E.Managed}toString(){return`Managed(${this.id})`}}e.$Xl=P;class D{constructor(y,$){this.host=y,this.port=$,this.type=E.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Yl=D;var T;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound",S.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class v extends t.$fb{static isNotAvailable(y){return y instanceof v&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof v&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof v&&y._code===T.NoResolverFound}static isInvalidAuthority(y){return y instanceof v&&y._code===T.InvalidAuthority}static isHandled(y){return y instanceof v&&y.isHandled}constructor(y,$=T.Unknown,g){super(y),this._message=y,this._code=$,this._detail=g,this.isHandled=$===T.NotAvailable&&g===!0,Object.setPrototypeOf(this,v.prototype)}}e.$Zl=v;function s(S){const y=S.indexOf("+");return y===-1?S:S.substring(0,y)}}),define(Te[221],Oe([1,0,13,14,18,9,6,2,12,44,43,22,60,90]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$6l=I,e.$7l=O,e.$8l=L,s=Ve(s);const a=30*1e3;var c;(function(X){X[X.Management=1]="Management",X[X.ExtensionHost=2]="ExtensionHost",X[X.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function m(X){switch(X){case c.Management:return"Management";case c.ExtensionHost:return"ExtensionHost";case c.Tunnel:return"Tunnel"}}function b(X){const z=new E.$Be;return setTimeout(()=>z.cancel(),X),z.token}function p(X,z){if(X.isCancellationRequested||z.isCancellationRequested)return E.CancellationToken.Cancelled;const A=new E.$Be;return X.onCancellationRequested(()=>A.cancel()),z.onCancellationRequested(()=>A.cancel()),A.token}class d{get didTimeout(){return this.c==="timedout"}constructor(z){this.c="pending",this.d=new T.$Yc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,t.$Dh)(),z.isCancellationRequested?this.h():this.d.add(z.onCancellationRequested(()=>this.h()))}registerDisposable(z){this.c==="pending"?this.d.add(z):z.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(z))}reject(z){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(z))}}function w(X,z){const A=new d(z);return A.registerDisposable(X.onControlMessage(Y=>{const pe=JSON.parse(Y.toString()),x=U(pe);x?A.reject(x):A.resolve(pe)})),A.promise}function o(X,z,A,Y,pe,x,ie,W){const Z=new d(W),ce=S.$ke.create(!1);return X.info(`Creating a socket (${ie})...`),s.mark(`code/willCreateSocket/${x}`),z.connect(A,Y,pe,ie).then(we=>{Z.didTimeout?(s.mark(`code/didCreateSocketError/${x}`),X.info(`Creating a socket (${ie}) finished after ${ce.elapsed()} ms, but this is too late and has timed out already.`),we?.dispose()):(s.mark(`code/didCreateSocketOK/${x}`),X.info(`Creating a socket (${ie}) was successful after ${ce.elapsed()} ms.`),Z.resolve(we))},we=>{s.mark(`code/didCreateSocketError/${x}`),X.info(`Creating a socket (${ie}) returned an error after ${ce.elapsed()} ms.`),X.error(we),Z.reject(we)}),Z.promise}function l(X,z){const A=new d(z);return X.then(Y=>{A.didTimeout||A.resolve(Y)},Y=>{A.didTimeout||A.reject(Y)}),A.promise}async function n(X,z,A,Y){const pe=se(X,z);X.logService.trace(`${pe} 1/6. invoking socketFactory.connect().`);let x;try{x=await o(X.logService,X.remoteSocketFactoryService,X.connectTo,v.$Xg.getServerRootPath(),`reconnectionToken=${X.reconnectionToken}&reconnection=${X.reconnectionProtocol?"true":"false"}`,m(z),`renderer-${m(z)}-${X.reconnectionToken}`,Y)}catch(we){throw X.logService.error(`${pe} socketFactory.connect() failed or timed out. Error:`),X.logService.error(we),we}X.logService.trace(`${pe} 2/6. socketFactory.connect() was successful.`);let ie,W;X.reconnectionProtocol?(X.reconnectionProtocol.beginAcceptReconnection(x,null),ie=X.reconnectionProtocol,W=!1):(ie=new $.$yi({socket:x}),W=!0),X.logService.trace(`${pe} 3/6. sending AuthRequest control message.`);const Z=await l(X.signService.createNewMessage((0,y.$7g)()),Y),ce={type:"auth",auth:X.connectionToken||"00000000000000000000",data:Z.data};ie.sendControl(r.$Se.fromString(JSON.stringify(ce)));try{const we=await w(ie,p(Y,b(1e4)));if(we.type!=="sign"||typeof we.data!="string"){const Re=new Error("Unexpected handshake message");throw Re.code="VSCODE_CONNECTION_ERROR",Re}if(X.logService.trace(`${pe} 4/6. received SignRequest control message.`),!await l(X.signService.validate(Z,we.signedData),Y)){const Re=new Error("Refused to connect to unsupported server");throw Re.code="VSCODE_CONNECTION_ERROR",Re}const ze=await l(X.signService.sign(we.data),Y),qe={type:"connectionType",commit:X.commit,signedData:ze,desiredConnectionType:z};return A&&(qe.args=A),X.logService.trace(`${pe} 5/6. sending ConnectionTypeRequest control message.`),ie.sendControl(r.$Se.fromString(JSON.stringify(qe))),{protocol:ie,ownsProtocol:W}}catch(we){throw we&&we.code==="ETIMEDOUT"&&(X.logService.error(`${pe} the handshake timed out. Error:`),X.logService.error(we)),we&&we.code==="VSCODE_CONNECTION_ERROR"&&(X.logService.error(`${pe} received error control message when negotiating connection. Error:`),X.logService.error(we)),W&&j(ie),we}}async function u(X,z,A,Y){const pe=Date.now(),x=se(X,z),{protocol:ie,ownsProtocol:W}=await n(X,z,A,Y),Z=new d(Y);return Z.registerDisposable(ie.onControlMessage(ce=>{const we=JSON.parse(ce.toString()),Le=U(we);Le?(X.logService.error(`${x} received error control message when negotiating connection. Error:`),X.logService.error(Le),W&&j(ie),Z.reject(Le)):(X.reconnectionProtocol?.endAcceptReconnection(),X.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${ne(pe)}!`),Z.resolve({protocol:ie,firstMessage:we}))})),Z.promise}async function i(X,z){const{protocol:A}=await u(X,c.Management,void 0,z);return{protocol:A}}async function f(X,z,A){const{protocol:Y,firstMessage:pe}=await u(X,c.ExtensionHost,z,A),x=pe&&pe.debugPort;return{protocol:Y,debugPort:x}}async function h(X,z,A){const Y=Date.now(),pe=se(X,c.Tunnel),{protocol:x}=await n(X,c.Tunnel,z,A);return X.logService.trace(`${pe} 6/6. handshake finished, connection is up and running after ${ne(Y)}!`),x}async function k(X,z,A){const{connectTo:Y,connectionToken:pe}=await X.addressProvider.getAddress();return{commit:X.commit,quality:X.quality,connectTo:Y,connectionToken:pe,reconnectionToken:z,reconnectionProtocol:A,remoteSocketFactoryService:X.remoteSocketFactoryService,signService:X.signService,logService:X.logService}}async function I(X,z,A){return C(X,async Y=>{const{protocol:pe}=await i(Y,E.CancellationToken.None);return new K(X,z,A,Y.reconnectionToken,pe)})}async function O(X,z){return C(X,async A=>{const{protocol:Y,debugPort:pe}=await f(A,z,E.CancellationToken.None);return new B(X,z,A.reconnectionToken,Y,pe)})}async function C(X,z){for(let Y=1;;Y++)try{const pe=(0,y.$7g)(),x=await k(X,pe,null);return await z(x)}catch(pe){if(Y<5)X.logService.error(`[remote-connection][attempt ${Y}] An error occurred in initial connection! Will retry... Error:`),X.logService.error(pe);else throw X.logService.error(`[remote-connection][attempt ${Y}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),X.logService.error(pe),le.triggerPermanentFailure(0,0,g.$Zl.isHandled(pe)),pe}}async function L(X,z,A){const Y=await k(X,(0,y.$7g)(),null);return await h(Y,{host:z,port:A},E.CancellationToken.None)}function R(X){return(0,t.$xh)(z=>new Promise((A,Y)=>{const pe=setTimeout(A,X*1e3);z.onCancellationRequested(()=>{clearTimeout(pe),A()})}))}var M;(function(X){X[X.ConnectionLost=0]="ConnectionLost",X[X.ReconnectionWait=1]="ReconnectionWait",X[X.ReconnectionRunning=2]="ReconnectionRunning",X[X.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",X[X.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class G{constructor(z,A){this.reconnectionToken=z,this.millisSinceLastIncomingData=A,this.type=M.ConnectionLost}}e.$9l=G;class Q{constructor(z,A,Y,pe){this.reconnectionToken=z,this.millisSinceLastIncomingData=A,this.durationSeconds=Y,this.c=pe,this.type=M.ReconnectionWait}skipWait(){this.c.cancel()}}e.$0l=Q;class te{constructor(z,A,Y){this.reconnectionToken=z,this.millisSinceLastIncomingData=A,this.attempt=Y,this.type=M.ReconnectionRunning}}e.$$l=te;class ve{constructor(z,A,Y){this.reconnectionToken=z,this.millisSinceLastIncomingData=A,this.attempt=Y,this.type=M.ConnectionGain}}e.$_l=ve;class be{constructor(z,A,Y,pe){this.reconnectionToken=z,this.millisSinceLastIncomingData=A,this.attempt=Y,this.handled=pe,this.type=M.ReconnectionPermanentFailure}}e.$am=be;class le extends T.$Zc{static triggerPermanentFailure(z,A,Y){this._permanentFailure=!0,this.f=z,this.g=A,this.h=Y,this.j.forEach(pe=>pe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(z=>z.y())}static debugPauseSocketWriting(){this.j.forEach(z=>z.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||le._permanentFailure}constructor(z,A,Y,pe,x){super(),this.t=z,this.u=A,this.reconnectionToken=Y,this.protocol=pe,this.w=x,this.m=this.B(new D.$qe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ve(this.reconnectionToken,0,0)),this.B(pe.onSocketClose(ie=>{const W=ye(this.t,this.reconnectionToken,!0);ie?ie.type===$.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${W} received socket close event (hadError: ${ie.hadError}).`),ie.error&&this.u.logService.error(ie.error)):(this.u.logService.info(`${W} received socket close event (wasClean: ${ie.wasClean}, code: ${ie.code}, reason: ${ie.reason}).`),ie.event&&this.u.logService.error(ie.event)):this.u.logService.info(`${W} received socket close event.`),this.y()})),this.B(pe.onSocketTimeout(ie=>{const W=ye(this.t,this.reconnectionToken,!0);this.u.logService.info(`${W} received socket timeout event (unacknowledgedMsgCount: ${ie.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ie.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ie.timeSinceLastReceivedSomeData}).`),this.y()})),le.j.push(this),this.B((0,T.$Xc)(()=>{const ie=le.j.indexOf(this);ie>=0&&le.j.splice(ie,1)})),this.n&&this.D(le.f,le.g,le.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const z=ye(this.t,this.reconnectionToken,!0);this.u.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const A=[0,5,5,10,10,10,10,10,30];let Y=-1;do{Y++;const pe=Y<A.length?A[Y]:A[A.length-1];try{if(pe>0){const ie=R(pe);this.m.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe,ie)),this.u.logService.info(`${z} waiting for ${pe} seconds before reconnecting...`);try{await ie}catch{}}if(this.n){this.u.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1)),this.u.logService.info(`${z} resolving connection...`);const x=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${z} connecting to ${x.connectTo}...`),await this.G(x,b(a)),this.u.logService.info(`${z} reconnected!`),this.m.fire(new ve(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1));break}catch(x){if(x.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(x),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(Y>360){this.u.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(x),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(g.$Zl.isTemporarilyNotAvailable(x)){this.u.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(x);continue}if((x.code==="ETIMEDOUT"||x.code==="ENETUNREACH"||x.code==="ECONNREFUSED"||x.code==="ECONNRESET")&&x.syscall==="connect"){this.u.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(x);continue}if((0,P.$8)(x)){this.u.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(x);continue}if(x instanceof g.$Zl){this.u.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(x),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,g.$Zl.isHandled(x));break}this.u.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(x),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}}while(!this.n&&!this.s)}C(z,A,Y){this.w?le.triggerPermanentFailure(z,A,Y):this.D(z,A,Y)}D(z,A,Y){this.m.fire(new be(this.reconnectionToken,z,A,Y)),j(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$bm=le;class K extends le{constructor(z,A,Y,pe,x){super(c.Management,z,pe,x,!0),this.client=this.B(new $.$wi(x,{remoteAuthority:A,clientId:Y},z.ipcLogger))}async G(z,A){await i(z,A)}}e.$cm=K;class B extends le{constructor(z,A,Y,pe,x){super(c.ExtensionHost,z,Y,pe,!1),this.H=A,this.debugPort=x}async G(z,A){await f(z,this.H,A)}}e.$dm=B;function j(X){try{X.acceptDisconnect();const z=X.getSocket();X.dispose(),z.dispose()}catch(z){(0,P.$4)(z)}}function U(X){if(X&&X.type==="error"){const z=new Error(`Connection error: ${X.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function ee(X,z){for(;X.length<z;)X+=" ";return X}function ae(X,z){return`[remote-connection][${ee(m(X),13)}][${z.substr(0,5)}\u2026]`}function ye(X,z,A){return`${ae(X,z)}[${A?"reconnect":"initial"}]`}function se(X,z){return`${ye(z,X.reconnectionToken,!!X.reconnectionProtocol)}[${X.connectTo}]`}function ne(X){return`${Date.now()-X} ms`}}),define(Te[222],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dS=e.$cS=void 0,e.$cS=(0,t.$Ki)("IRemoteExtensionsScannerService"),e.$dS="remoteExtensionsScanner"}),define(Te[91],Oe([1,0,12]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=r,e.$on=E,e.$pn=P,e.$qn=D;function r(v){return v.scheme===t.Schemas.vscodeRemote?v.authority:void 0}function E(v){if(!v)return;const s=v.indexOf("+");return s<0?v:v.substr(0,s)}function P(v){const{host:s,port:S}=T(v);if(typeof S>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:S}}function D(v,s){let{host:S,port:y}=T(v);return typeof y>"u"&&(y=s),{host:S,port:y}}function T(v){const s=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const S=v.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const y=v.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:v,port:void 0}}}),define(Te[21],Oe([1,0,16,5,91]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$zn=e.$yn=e.$xn=e.TargetPlatform=e.ExtensionType=e.$wn=e.$un=e.$tn=e.$sn=e.$rn=void 0,e.$vn=P,e.$An=y,e.$Bn=$,e.$Cn=g,e.$Dn=a,e.$En=c,e.$Fn=m,t=Ve(t),e.$rn="extensions.user.cache",e.$sn="extensions.builtin.cache",e.$tn="undefined_publisher",e.$un=["ui","workspace","web"];function P(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$wn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D||(e.ExtensionType=D={}));var T;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class v{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,d){if(typeof p>"u"||p===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof p=="string"||typeof d=="string"){const w=typeof p=="string"?p:p.value,o=typeof d=="string"?d:d.value;return t.$Kf(w,o)}return p._lower===d._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$xn=v;class s{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const d of p)this.add(d)}add(p){this.c.add(v.toKey(p))}delete(p){return this.c.delete(v.toKey(p))}has(p){return this.c.has(v.toKey(p))}}e.$yn=s;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(v.toKey(p))}get(p){return this.c.get(v.toKey(p))}has(p){return this.c.has(v.toKey(p))}set(p,d){this.c.set(v.toKey(p),d)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$zn=S;function y(b){return $(b)}function $(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function g(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function a(b,p){if(p){const d=`onResolveRemoteAuthority:${(0,E.$on)(p)}`;return!!b.activationEvents?.includes(d)}return!1}function c(b){return b.map(p=>{const[d,w]=p.split("@");return{proposalName:d,version:w?parseInt(w):void 0}})}function m(b){return b.map(p=>p.split("@")[0])}e.$Gn=(0,r.$Ki)("IBuiltinExtensionsScannerService")}),define(Te[30],Oe([1,0,3,7,21,5]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.ExtensionManagementErrorCode=e.$sp=e.ExtensionGalleryErrorCode=e.$rp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=void 0,e.$lp=T,e.$mp=v,e.$np=s,e.$op=S,e.$pp=y,e.$qp=$,e.$ep="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$fp=new RegExp(e.$ep),e.$gp="__web_extension",e.$hp="skipWalkthrough",e.$ip="extensionInstallSource",e.$jp="dependecyOrPackExtensionInstall",e.$kp="clientTargetPlatform";var D;(function(o){o.COMMAND="command",o.SETTINGS_SYNC="settingsSync"})(D||(e.ExtensionInstallSource=D={}));function T(o){switch(o){case E.TargetPlatform.WIN32_X64:return"Windows 64 bit";case E.TargetPlatform.WIN32_ARM64:return"Windows ARM";case E.TargetPlatform.LINUX_X64:return"Linux 64 bit";case E.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case E.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case E.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case E.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case E.TargetPlatform.DARWIN_X64:return"Mac";case E.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case E.TargetPlatform.WEB:return"Web";case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;case E.TargetPlatform.UNKNOWN:return E.TargetPlatform.UNKNOWN;case E.TargetPlatform.UNDEFINED:return E.TargetPlatform.UNDEFINED}}function v(o){switch(o){case E.TargetPlatform.WIN32_X64:return E.TargetPlatform.WIN32_X64;case E.TargetPlatform.WIN32_ARM64:return E.TargetPlatform.WIN32_ARM64;case E.TargetPlatform.LINUX_X64:return E.TargetPlatform.LINUX_X64;case E.TargetPlatform.LINUX_ARM64:return E.TargetPlatform.LINUX_ARM64;case E.TargetPlatform.LINUX_ARMHF:return E.TargetPlatform.LINUX_ARMHF;case E.TargetPlatform.ALPINE_X64:return E.TargetPlatform.ALPINE_X64;case E.TargetPlatform.ALPINE_ARM64:return E.TargetPlatform.ALPINE_ARM64;case E.TargetPlatform.DARWIN_X64:return E.TargetPlatform.DARWIN_X64;case E.TargetPlatform.DARWIN_ARM64:return E.TargetPlatform.DARWIN_ARM64;case E.TargetPlatform.WEB:return E.TargetPlatform.WEB;case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;default:return E.TargetPlatform.UNKNOWN}}function s(o,l){switch(o){case t.Platform.Windows:return l==="x64"?E.TargetPlatform.WIN32_X64:l==="arm64"?E.TargetPlatform.WIN32_ARM64:E.TargetPlatform.UNKNOWN;case t.Platform.Linux:return l==="x64"?E.TargetPlatform.LINUX_X64:l==="arm64"?E.TargetPlatform.LINUX_ARM64:l==="arm"?E.TargetPlatform.LINUX_ARMHF:E.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?E.TargetPlatform.ALPINE_X64:l==="arm64"?E.TargetPlatform.ALPINE_ARM64:E.TargetPlatform.UNKNOWN;case t.Platform.Mac:return l==="x64"?E.TargetPlatform.DARWIN_X64:l==="arm64"?E.TargetPlatform.DARWIN_ARM64:E.TargetPlatform.UNKNOWN;case t.Platform.Web:return E.TargetPlatform.WEB}}function S(o,l){return l===E.TargetPlatform.WEB&&!o.includes(E.TargetPlatform.WEB)}function y(o,l,n){return S(l,n)?!1:o===E.TargetPlatform.UNDEFINED||o===E.TargetPlatform.UNIVERSAL?!0:o===E.TargetPlatform.UNKNOWN?!1:o===n}function $(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}var g;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var a;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var c;(function(o){o.Install="install",o.Uninstall="uninstall"})(c||(e.StatisticType=c={}));var m;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$rp=(0,P.$Ki)("extensionGalleryService");var b;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed",o.DownloadFailedWriting="DownloadFailedWriting",o.Offline="Offline"})(b||(e.ExtensionGalleryErrorCode=b={}));class p extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.$sp=p;var d;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleApi="IncompatibleApi",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.DownloadFailedWriting="DownloadFailedWriting",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.ScanningExtension="ScanningExtension",o.ReadUninstalled="ReadUninstalled",o.UnsetUninstalled="UnsetUninstalled",o.Delete="Delete",o.Rename="Rename",o.IntializeDefaultProfile="IntializeDefaultProfile",o.AddToProfile="AddToProfile",o.InstalledExtensionNotFound="InstalledExtensionNotFound",o.PostInstall="PostInstall",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Cancelled="Cancelled",o.Unknown="Unknown",o.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));class w extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.$tp=w,e.$up=(0,P.$Ki)("extensionManagementService"),e.$vp="extensionsIdentifiers/disabled",e.$wp="extensionsIdentifiers/enabled",e.$xp=(0,P.$Ki)("IGlobalExtensionEnablementService"),e.$yp=(0,P.$Ki)("IExtensionTipsService"),e.$zp=(0,r.localize2)(1780,"Extensions"),e.$Ap=(0,r.localize2)(1781,"Preferences")}),define(Te[223],Oe([1,0,6,2,20,4,59,30]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=void 0;function v(m,b){return m?P.URI.revive(b?b.transformIncoming(m):m):void 0}function s(m,b){return b?b.transformOutgoingURI(m):m}function S(m,b){b=b||D.$Tn;const p=m.manifest;return{...(0,D.$Wn)({...m,manifest:void 0},b),manifest:p}}function y(m,b){return m?.profileLocation?(0,D.$Wn)(m,b??D.$Tn):m}function $(m,b){return b?(0,E.$mo)(m,p=>p instanceof P.URI?b.transformOutgoingURI(p):void 0):m}class g{constructor(b,p){this.a=b,this.b=p,this.onInstallExtension=t.Event.buffer(b.onInstallExtension,!0),this.onDidInstallExtensions=t.Event.buffer(b.onDidInstallExtensions,!0),this.onUninstallExtension=t.Event.buffer(b.onUninstallExtension,!0),this.onDidUninstallExtension=t.Event.buffer(b.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=t.Event.buffer(b.onDidUpdateExtensionMetadata,!0)}listen(b,p){const d=this.b(b);switch(p){case"onInstallExtension":return t.Event.map(this.onInstallExtension,w=>({...w,profileLocation:w.profileLocation?s(w.profileLocation,d):w.profileLocation}));case"onDidInstallExtensions":return t.Event.map(this.onDidInstallExtensions,w=>w.map(o=>({...o,local:o.local?$(o.local,d):o.local,profileLocation:o.profileLocation?s(o.profileLocation,d):o.profileLocation})));case"onUninstallExtension":return t.Event.map(this.onUninstallExtension,w=>({...w,profileLocation:w.profileLocation?s(w.profileLocation,d):w.profileLocation}));case"onDidUninstallExtension":return t.Event.map(this.onDidUninstallExtension,w=>({...w,profileLocation:w.profileLocation?s(w.profileLocation,d):w.profileLocation}));case"onDidUpdateExtensionMetadata":return t.Event.map(this.onDidUpdateExtensionMetadata,w=>({local:$(w.local,d),profileLocation:s(w.profileLocation,d)}))}throw new Error("Invalid listen")}async call(b,p,d){const w=this.b(b);switch(p){case"zip":{const o=S(d[0],w),l=await this.a.zip(o);return s(l,w)}case"install":return this.a.install(v(d[0],w),y(d[1],w));case"installFromLocation":return this.a.installFromLocation(v(d[0],w),v(d[1],w));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(d[0],v(d[1],w),v(d[2],w));case"getManifest":return this.a.getManifest(v(d[0],w));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],y(d[1],w));case"installGalleryExtensions":{const o=d[0];return this.a.installGalleryExtensions(o.map(({extension:l,options:n})=>({extension:l,options:y(n,w)??{}})))}case"uninstall":return this.a.uninstall(S(d[0],w),y(d[1],w));case"uninstallExtensions":{const o=d[0];return this.a.uninstallExtensions(o.map(({extension:l,options:n})=>({extension:S(l,w),options:y(n,w)})))}case"reinstallFromGallery":return this.a.reinstallFromGallery(S(d[0],w));case"getInstalled":return(await this.a.getInstalled(d[0],v(d[1],w),d[2])).map(l=>$(l,w));case"toggleAppliationScope":{const o=await this.a.toggleAppliationScope(S(d[0],w),v(d[1],w));return $(o,w)}case"copyExtensions":return this.a.copyExtensions(v(d[0],w),v(d[1],w));case"updateMetadata":{const o=await this.a.updateMetadata(S(d[0],w),d[1],v(d[2],w));return $(o,w)}case"resetPinnedStateForAllUserExtensions":return this.a.resetPinnedStateForAllUserExtensions(d[0]);case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1],d[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Fq=g;class a extends r.$Zc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(b){super(),this.m=b,this.c=this.B(new t.$qe),this.f=this.B(new t.$qe),this.g=this.B(new t.$qe),this.h=this.B(new t.$qe),this.j=this.B(new t.$qe),this.B(this.m.listen("onInstallExtension")(p=>this.n(this.c,{...p,source:this.r(p.source)?P.URI.revive(p.source):p.source,profileLocation:P.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(p=>this.n(this.f,p.map(d=>({...d,local:d.local?S(d.local,null):d.local,source:this.r(d.source)?P.URI.revive(d.source):d.source,profileLocation:P.URI.revive(d.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(p=>this.n(this.g,{...p,profileLocation:P.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(p=>this.n(this.h,{...p,profileLocation:P.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(p=>this.n(this.j,{profileLocation:P.URI.revive(p.profileLocation),local:S(p.local,null)})))}n(b,p){b.fire(p)}r(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(b){const p=await this.getTargetPlatform();return b.allTargetPlatforms.some(d=>(0,T.$pp)(d,b.allTargetPlatforms,p))}zip(b){return Promise.resolve(this.m.call("zip",[b]).then(p=>P.URI.revive(p)))}install(b,p){return Promise.resolve(this.m.call("install",[b,p])).then(d=>S(d,null))}installFromLocation(b,p){return Promise.resolve(this.m.call("installFromLocation",[b,p])).then(d=>S(d,null))}async installExtensionsFromProfile(b,p,d){return(await this.m.call("installExtensionsFromProfile",[b,p,d])).map(o=>S(o,null))}getManifest(b){return Promise.resolve(this.m.call("getManifest",[b]))}installFromGallery(b,p){return Promise.resolve(this.m.call("installFromGallery",[b,p])).then(d=>S(d,null))}async installGalleryExtensions(b){return(await this.m.call("installGalleryExtensions",[b])).map(d=>({...d,local:d.local?S(d.local,null):d.local,source:this.r(d.source)?P.URI.revive(d.source):d.source,profileLocation:P.URI.revive(d.profileLocation)}))}uninstall(b,p){if(b.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[b,p]))}uninstallExtensions(b){if(b.some(p=>p.extension.isWorkspaceScoped))throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstallExtensions",[b]))}reinstallFromGallery(b){return Promise.resolve(this.m.call("reinstallFromGallery",[b])).then(p=>S(p,null))}getInstalled(b=null,p,d){return Promise.resolve(this.m.call("getInstalled",[b,p,d])).then(w=>w.map(o=>S(o,null)))}updateMetadata(b,p,d){return Promise.resolve(this.m.call("updateMetadata",[b,p,d])).then(w=>S(w,null))}resetPinnedStateForAllUserExtensions(b){return this.m.call("resetPinnedStateForAllUserExtensions",[b])}toggleAppliationScope(b,p){return this.m.call("toggleAppliationScope",[b,p]).then(d=>S(d,null))}copyExtensions(b,p){return this.m.call("copyExtensions",[b,p])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(b,p,d){const w=await this.m.call("download",[b,p,d]);return P.URI.revive(w)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Gq=a;class c{constructor(b){this.a=b}listen(b,p){throw new Error("Invalid listen")}call(b,p,d){switch(p){case"getConfigBasedTips":return this.a.getConfigBasedTips(P.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Hq=c}),define(Te[132],Oe([1,0,9,21]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=e.$gH=void 0;class E{constructor(){this.a=new Map,this.b=new WeakMap}register(D,T){this.a.set(D,T)}readActivationEvents(D){return this.b.has(D)||this.b.set(D,this.c(D)),this.b.get(D)}createActivationEventsMap(D){const T=Object.create(null);for(const v of D){const s=this.readActivationEvents(v);s.length>0&&(T[r.$xn.toKey(v.identifier)]=s)}return T}c(D){if(typeof D.main>"u"&&typeof D.browser>"u")return[];const T=Array.isArray(D.activationEvents)?D.activationEvents.slice(0):[];for(let v=0;v<T.length;v++)T[v]==="onUri"&&(T[v]=`onUri:${r.$xn.toKey(D.identifier)}`);if(!D.contributes)return T;for(const v in D.contributes){const s=this.a.get(v);if(!s)continue;const S=D.contributes[v],y=Array.isArray(S)?S:[S];try{s(y,T)}catch($){(0,t.$4)($)}}return T}}e.$gH=E,e.$hH=new E}),define(Te[224],Oe([1,0,2,21,15]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;class P extends t.$Zc{constructor(T,v,s,S,y){super(),this.a=T,this.b=v,this.c=s,this.f=y,this.B(S.onDidInstallExtensions($=>this.g($))),this.B(S.onDidUninstallExtension($=>this.h($)))}g(T){for(const v of T)v.local&&this.invalidate(v.profileLocation)}h(T){T.error||this.invalidate(T.profileLocation)}async invalidate(T){if(T)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,T)&&await this.j(v);else await this.j(this.a.defaultProfile)}async j(T){try{await this.b.del(this.c.extUri.joinPath(T.cacheHome,r.$rn))}catch(v){(0,E.$wl)(v)!==E.FileOperationResult.FILE_NOT_FOUND&&this.f.error(v)}}}e.$5q=P});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[75],Oe([1,0,19,58,7,62,21,120]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=S,e.$7p=y,e.$8p=$,e.$9p=g,e.$0p=a,e.$$p=c,e.$_p=m,e.$aq=b,r=$t(r),E=Ve(E),P=Ve(P);const v=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function S(w){return w=w.trim(),w==="*"||v.test(w)}function y(w){if(!S(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const o=w.match(v);return o?{hasCaret:o[1]==="^",hasGreaterEquals:o[1]===">=",majorBase:o[2]==="x"?0:parseInt(o[2],10),majorMustEqual:o[2]!=="x",minorBase:o[4]==="x"?0:parseInt(o[4],10),minorMustEqual:o[4]!=="x",patchBase:o[6]==="x"?0:parseInt(o[6],10),patchMustEqual:o[6]!=="x",preRelease:o[8]||null}:null}function $(w){if(!w)return null;const o=w.majorBase,l=w.majorMustEqual,n=w.minorBase;let u=w.minorMustEqual;const i=w.patchBase;let f=w.patchMustEqual;w.hasCaret&&(o===0||(u=!1),f=!1);let h=0;if(w.preRelease){const k=s.exec(w.preRelease);if(k){const[,I,O,C]=k;h=Date.UTC(Number(I),Number(O)-1,Number(C))}}return{majorBase:o,majorMustEqual:l,minorBase:n,minorMustEqual:u,patchBase:i,patchMustEqual:f,isMinimum:w.hasGreaterEquals,notBefore:h}}function g(w,o,l){let n;typeof w=="string"?n=$(y(w)):n=w;let u;o instanceof Date?u=o.getTime():typeof o=="string"&&(u=new Date(o).getTime());let i;if(typeof l=="string"?i=$(y(l)):i=l,!n||!i)return!1;const f=n.majorBase,h=n.minorBase,k=n.patchBase;let I=i.majorBase,O=i.minorBase,C=i.patchBase;const L=i.notBefore;let R=i.majorMustEqual,M=i.minorMustEqual,G=i.patchMustEqual;return i.isMinimum?f>I?!0:f<I?!1:h>O?!0:h<O||u&&u<L?!1:k>=C:(f===1&&I===0&&(!R||!M||!G)&&(I=1,O=0,C=0,R=!0,M=!1,G=!1),f<I?!1:f>I?!R:h<O?!1:h>O?!M:k<C?!1:k>C?!G:!(u&&u<L))}function a(w,o,l,n,u,i){const f=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return f.push([r.default.Error,E.localize(1832,null)]),f;if(typeof n.name!="string")return f.push([r.default.Error,E.localize(1833,null,"name")]),f;if(typeof n.version!="string")return f.push([r.default.Error,E.localize(1834,null,"version")]),f;if(!n.engines)return f.push([r.default.Error,E.localize(1835,null,"engines")]),f;if(typeof n.engines.vscode!="string")return f.push([r.default.Error,E.localize(1836,null,"engines.vscode")]),f;if(typeof n.extensionDependencies<"u"&&!d(n.extensionDependencies))return f.push([r.default.Error,E.localize(1837,null,"extensionDependencies")]),f;if(typeof n.activationEvents<"u"){if(!d(n.activationEvents))return f.push([r.default.Error,E.localize(1838,null,"activationEvents")]),f;if(typeof n.main>"u"&&typeof n.browser>"u")return f.push([r.default.Error,E.localize(1839,null,"activationEvents","main","browser")]),f}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&f.push([r.default.Warning,E.localize(1840,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return f.push([r.default.Error,E.localize(1841,null,"main")]),f;{const I=(0,t.$lh)(l,n.main);(0,t.$fh)(I,l)||f.push([r.default.Warning,E.localize(1842,null,I.path,l.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return f.push([r.default.Error,E.localize(1843,null,"browser")]),f;{const I=(0,t.$lh)(l,n.browser);(0,t.$fh)(I,l)||f.push([r.default.Warning,E.localize(1844,null,I.path,l.path)])}}if(!P.valid(n.version))return f.push([r.default.Error,E.localize(1845,null)]),f;const h=[];if(!c(w,o,n,u,h))for(const I of h)f.push([r.default.Error,I]);if(i&&n.enabledApiProposals?.length){const I=[];if(!b([...n.enabledApiProposals],I))for(const O of I)f.push([r.default.Error,O])}return f}function c(w,o,l,n,u){return n||typeof l.main>"u"&&typeof l.browser>"u"?!0:p(w,o,l.engines.vscode,u)}function m(w,o,l){return w==="*"||p(o,l,w)}function b(w,o){if(w.length===0)return!0;const l=Array.isArray(o)?o:void 0,n=(l?void 0:o)??T.allApiProposals,u=[],i=(0,D.$En)(w);for(const{proposalName:f,version:h}of i){const k=n[f];k&&h&&k.version!==h&&u.push(E.localize(1846,null,f))}return l?.push(...u),u.length===0}function p(w,o,l,n=[]){const u=$(y(l));if(!u)return n.push(E.localize(1847,null,l)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return n.push(E.localize(1848,null,l)),!1}else if(!u.majorMustEqual)return n.push(E.localize(1849,null,l)),!1;return g(w,o,u)?!0:(n.push(E.localize(1850,null,w,l)),!1)}function d(w){if(!Array.isArray(w))return!1;for(let o=0,l=w.length;o<l;o++)if(typeof w[o]!="string")return!1;return!0}}),define(Te[92],Oe([1,0,18,2,3,7,30,5]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=void 0,e.$gs=v;function v(S){return S.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.$hs=(0,T.$Ki)("languagePackService");let s=class extends r.$Zc{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new t.$Be;setTimeout(()=>y.cancel(),1e3);let $;try{$=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const a=$.firstPage.filter(c=>c.properties.localizedLanguages?.length&&c.tags.some(m=>m.startsWith("lp-"))).map(c=>{const m=c.properties.localizedLanguages?.[0],b=v(c);return{...this.f(b,m,c),extensionId:c.identifier.id,galleryExtension:c}});return a.push(this.f("en","English")),a}f(y,$,g){const a=$??y;let c;if(a!==y&&(c=`(${y})`),y.toLowerCase()===E.$z.toLowerCase()&&(c??="",c+=(0,P.localize)(1928,null)),g?.installCount){c??="";const m=g.installCount;let b;m>1e6?b=`${Math.floor(m/1e5)/10}M`:m>1e3?b=`${Math.floor(m/1e3)}K`:b=String(m),c+=` $(cloud-download) ${b}`}return{id:y,label:a,description:c}}};e.$is=s,e.$is=s=We([je(0,D.$rp)],s)}),define(Te[47],Oe([1,0,14,9,2,7,46,5,11,37]),function(ue,e,t,r,E,P,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0,e.$dq=$,e.$eq=g,e.$fq=a,e.$gq=c,e.$hq=m,e.$iq=b,e.$bq=(0,T.$Ki)("requestService");class S{constructor(o){this.b=o}toJSON(){if(!this.a){const o=Object.create(null);for(const l in this.b)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?o[l]="*****":o[l]=this.b[l];this.a=o}return this.a}}class y extends E.$Zc{constructor(o){super(),this.b=0,this.a=o.createLogger("network",{name:(0,P.localize)(2050,null),when:v.$xk.isEqualTo((0,v.$uk)(v.LogLevel.Trace)).serialize()})}async c(o,l,n){const u=`${o} #${++this.b}: ${l.url}`;this.a.trace(`${u} - begin`,l.type,new S(l.headers??{}));try{const i=await n();return this.a.trace(`${u} - end`,l.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${u} - error`,l.type,(0,r.$bb)(i)),i}}}e.$cq=y;function $(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}function g(w){return w.res.statusCode===204}async function a(w){return g(w)?null:(await(0,t.$5e)(w.stream)).toString()}async function c(w){if(!$(w))throw new Error("Server returned "+w.res.statusCode);return a(w)}async function m(w){if(!$(w))throw new Error("Server returned "+w.res.statusCode);if(g(w))return null;const l=(await(0,t.$5e)(w.stream)).toString();try{return JSON.parse(l)}catch(n){throw n.message+=`:
`+l,n}}function b(w){d(w)}let p;function d(w){const o=s.$xo.as(D.$Co.Configuration),l=p;p={id:"http",order:15,title:(0,P.localize)(2051,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,P.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,P.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(2057,null),(0,P.localize)(2058,null),(0,P.localize)(2059,null),(0,P.localize)(2060,null)],default:"override",description:(0,P.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,P.localize)(2063,null),restricted:!0}}},o.updateConfigurations({add:[p],remove:l?[l]:[]})}d(D.ConfigurationScope.APPLICATION)}),define(Te[225],Oe([1,0,18,12,15,47]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rS=void 0;let D=class{constructor(v,s){this.a=v,this.b=s}async download(v,s,S=t.CancellationToken.None){if(v.scheme===r.Schemas.file||v.scheme===r.Schemas.vscodeRemote){await this.b.copy(v,s);return}const y={type:"GET",url:v.toString(!0)},$=await this.a.request(y,S);if($.res.statusCode===200)await this.b.writeFile(s,$.stream);else{const g=await(0,P.$gq)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${g}`)}}};e.$rS=D,e.$rS=D=We([je(0,P.$bq),je(1,E.$fl)],D)}),define(Te[226],Oe([1,0,14,18]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=void 0;class E{constructor(T){this.a=T}listen(T,v){throw new Error("Invalid listen")}call(T,v,s,S=r.CancellationToken.None){switch(v){case"request":return this.a.request(s[0],S).then(async({res:y,stream:$})=>{const g=await(0,t.$5e)($);return[{statusCode:y.statusCode,headers:y.headers},g]});case"resolveProxy":return this.a.resolveProxy(s[0]);case"lookupAuthorization":return this.a.lookupAuthorization(s[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(s[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$ks=E;class P{constructor(T){this.a=T}async request(T,v){const[s,S]=await this.a.call("request",[T],v);return{res:s,stream:(0,t.$7e)(S)}}async resolveProxy(T){return this.a.call("resolveProxy",[T])}async lookupAuthorization(T){return this.a.call("lookupAuthorization",[T])}async lookupKerberosAuthorization(T){return this.a.call("lookupKerberosAuthorization",[T])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$ls=P}),define(Te[227],Oe([1,0,93,10]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=P;function E(D,T){return D.protocol==="http:"?T.HTTP_PROXY||T.http_proxy||null:D.protocol==="https:"&&(T.HTTPS_PROXY||T.https_proxy||T.HTTP_PROXY||T.http_proxy)||null}async function P(D,T,v={}){const s=(0,t.parse)(D),S=v.proxyUrl||E(s,T);if(!S)return null;const y=(0,t.parse)(S);if(!/^https?:$/.test(y.protocol||""))return null;const $={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,r.$pg)(v.strictSSL)?v.strictSSL:!0};if(s.protocol==="http:"){const g=await new Promise((a,c)=>{ue(["http-proxy-agent"],a,c)}).then(Ve);return new g.HttpProxyAgent(S,$)}else{const g=await new Promise((a,c)=>{ue(["https-proxy-agent"],a,c)}).then(Ve);return new g.HttpsProxyAgent(S,$)}}}),define(Te[94],Oe([1,0,50,8,7,18,45,9,3,22,117,201,13,166]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=c;let a;async function c(b,p,d,w){return d["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.$l?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$Pm)(w)&&!d["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$Pm)(w)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),a||(a=$.Promises.withAsyncBody(async(o,l)=>{const n=new P.$Be;let u=1e4;const i=b.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(u=(0,g.$Qm)(i,1,120)*1e3);const f=setTimeout(()=>{n.dispose(!0),l(new Error((0,E.localize)(2064,null)))},u);try{o(await m(p,n.token))}catch(h){!(0,T.$8)(h)&&!n.token.isCancellationRequested?l(new Error((0,E.localize)(2065,null,(0,D.$vj)(h)))):o({})}finally{clearTimeout(f),n.dispose()}})),a)}async function m(b,p){const d=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",d);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",w);const o=(0,s.$7g)().replace(/-/g,"").substr(0,12),l=new RegExp(o+"({.*})"+o),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};b.trace("getUnixShellEnvironment#env",n);const u=await(0,S.$Fm)(v.OS,n);return b.trace("getUnixShellEnvironment#shell",u),new Promise((i,f)=>{if(p.isCancellationRequested)return f(new T.$9);const h=(0,r.$sc)(u);let k,I;const O="";/^pwsh(-preview)?$/.test(h)?(k=`& '${process.execPath}' ${O} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,I=["-Login","-Command"]):h==="nu"?(k=`^'${process.execPath}' ${O} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,I=["-i","-l","-c"]):h==="xonsh"?(k=`import os, json; print("${o}", json.dumps(dict(os.environ)), "${o}")`,I=["-i","-l","-c"]):(k=`'${process.execPath}' ${O} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,h==="tcsh"||h==="csh"?I=["-ic"]:I=["-i","-l","-c"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),k);const C=(0,t.spawn)(u,[...I,k],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});p.onCancellationRequested(()=>(C.kill(),f(new T.$9))),C.on("error",M=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,D.$vj)(M)),f(M)});const L=[];C.stdout.on("data",M=>L.push(M));const R=[];C.stderr.on("data",M=>R.push(M)),C.on("close",(M,G)=>{const Q=Buffer.concat(L).toString("utf8");b.trace("getUnixShellEnvironment#raw",Q);const te=Buffer.concat(R).toString("utf8");if(te.trim()&&b.trace("getUnixShellEnvironment#stderr",te),M||G)return f(new Error((0,E.localize)(2066,null,M,G)));const ve=l.exec(Q),be=ve?ve[1]:"{}";try{const le=JSON.parse(be);d?le.ELECTRON_RUN_AS_NODE=d:delete le.ELECTRON_RUN_AS_NODE,w?le.ELECTRON_NO_ATTACH_CONSOLE=w:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",le),i(le)}catch(le){b.error("getUnixShellEnvironment#errorCaught",(0,D.$vj)(le)),f(le)}})})}}),define(Te[228],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5R=e.$4R=void 0,e.$4R=(0,t.$Ki)("stateReadService"),e.$5R=(0,t.$Ki)("stateService")}),define(Te[229],Oe([1,0,13,14,2,10,27,15,11]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8R=e.$7R=e.$6R=e.SaveStrategy=void 0;var s;(function(g){g[g.IMMEDIATE=0]="IMMEDIATE",g[g.DELAYED=1]="DELAYED"})(s||(e.SaveStrategy=s={}));class S extends E.$Zc{constructor(a,c,m,b){super(),this.h=a,this.j=c,this.m=m,this.n=b,this.a=Object.create(null),this.b="",this.c=this.B(new t.$Ih(this.j===s.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(a){a.fileOperationResult!==T.FileOperationResult.FILE_NOT_FOUND&&this.m.error(a)}}getItem(a,c){const m=this.a[a];return(0,P.$sg)(m)?c:m}setItem(a,c){this.setItems([{key:a,data:c}])}setItems(a){let c=!1;for(const{key:m,data:b}of a)this.a[m]!==b&&((0,P.$sg)(b)?(0,P.$qg)(this.a[m])||(this.a[m]=void 0,c=!0):(this.a[m]=b,c=!0));c&&this.s()}removeItem(a){(0,P.$qg)(this.a[a])||(this.a[a]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const a=JSON.stringify(this.a,null,4);if(a!==this.b)try{await this.n.writeFile(this.h,r.$Se.fromString(a),{atomic:{postfix:".vsctmp"}}),this.b=a}catch(c){this.m.error(c)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$6R=S;let y=class extends E.$Zc{constructor(a,c,m,b){super(),this.a=this.B(new S(c.stateResource,a,m,b))}async init(){await this.a.init()}getItem(a,c){return this.a.getItem(a,c)}};e.$7R=y,e.$7R=y=We([je(1,D.$Ri),je(2,v.$fk),je(3,T.$fl)],y);class $ extends y{setItem(a,c){this.a.setItem(a,c)}setItems(a){this.a.setItems(a)}removeItem(a){this.a.removeItem(a)}close(){return this.a.close()}}e.$8R=$}),define(Te[133],Oe([1,0,3,32,22]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=D,e.$Cp=T;function P(v){if(t.$x===t.Platform.Linux&&/^penguin(\.|$)/i.test(v))return"chromebook"}function D(v,s,S,y,$,g,a,c,m,b){const p=Object.create(null);p["common.machineId"]=g,p["common.sqmId"]=a,p["common.devDeviceId"]=c,p.sessionID=(0,E.$7g)()+Date.now(),p.commitHash=y,p.version=$,p["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,t.$k)(t.$x),p["common.nodePlatform"]=r.$ic,p["common.nodeArch"]=S,p["common.product"]=b||"desktop",m&&(p["common.msftInternal"]=m);let d=0;const w=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),t.$o&&(p["common.snap"]="true");const o=P(s);return o&&(p["common.platformDetail"]=o),p}function T(v){const s=r.env.USERDNSDOMAIN;if(!s)return!1;const S=s.toLowerCase();return v.some(y=>S===y)}}),define(Te[230],Oe([1,0,17,9,2,20,15]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var T;(function(s){function S(y,$){return y.callstack<$.callstack?-1:y.callstack>$.callstack?1:0}s.compare=S})(T||(e.ErrorEvent=T={}));class v{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(S,y=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new E.$Yc,this.c=S,this.d=y;const $=r.$1.addListener(g=>this.j(g));this.h.add((0,E.$Xc)($)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(S){if(!S||S.code||(S.detail&&S.detail.stack&&(S=S.detail),r.$fb.isErrorNoTelemetry(S)||S instanceof D.$Al||typeof S?.message=="string"&&S.message.includes("Unable to read file")))return;const y=Array.isArray(S.stack)?S.stack.join(`
`):S.stack,$=S.message?S.message:(0,P.$po)(S);y&&this.k({msg:$,callstack:y})}k(S){const y=(0,t.$Ab)(this.g,S,T.compare);y<0?(S.count=1,this.g.splice(~y,0,S)):(this.g[y].count||(this.g[y].count=0),this.g[y].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const S of this.g)this.c.publicLogError2("UnhandledError",S);this.g.length=0}}e.default=v}),define(Te[24],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em=(0,t.$Ki)("telemetryService"),e.$fm=(0,t.$Ki)("customEndpointTelemetryService"),e.$gm="telemetry.currentSessionDate",e.$hm="telemetry.firstSessionDate",e.$im="telemetry.lastSessionDate",e.$jm="telemetry.machineId",e.$km="telemetry.sqmId",e.$lm="telemetry.devDeviceId",e.$mm="telemetry",e.$nm="telemetry.telemetryLevel",e.$om="telemetry.enableCrashReporter",e.$pm="telemetry.enableTelemetry";var r;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var E;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(E||(e.TelemetryConfiguration=E={}))}),define(Te[231],Oe([1,0,23,31,13,42,12,8,3,43,4,113,26,116,207,15,29,24]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0,e.$7s=d,e.$8s=o,e.$9s=l,t=Ve(t),r=Ve(r);const p=new Map;async function d(u,i){const f=`${u}::${i.join(":")}`,h=p.get(f);if(h)return h;const k=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i},{tag:"cursorrules",filePattern:/^\.cursorrules$/i}],I=new Map,O=new Map,C=2e4;function L(M,G,Q,te){const ve=G.substring(M.length+1);return E.Promises.withAsyncBody(async be=>{let le;te.readdirCount++;try{le=await $.Promises.readdir(G,{withFileTypes:!0})}catch{be();return}if(te.count>=C){te.count+=le.length,te.maxReached=!0,be();return}let K=le.length;if(K===0){be();return}let B=le;te.count+le.length>C&&(te.maxReached=!0,K=C-te.count,B=le.slice(0,K)),te.count+=le.length;for(const j of B)if(j.isDirectory()){if(Q.includes(j.name)||await L(M,(0,T.$oc)(G,j.name),Q,te),--K===0){be();return}}else{const U=j.name.lastIndexOf(".");if(U>=0){const ee=j.name.substring(U+1);ee&&I.set(ee,(I.get(ee)??0)+1)}for(const ee of k)ee.relativePathPattern?.test(ve)!==!1&&ee.filePattern.test(j.name)&&O.set(ee.tag,(O.get(ee.tag)??0)+1);if(--K===0){be();return}}})}const R=E.Promises.withAsyncBody(async M=>{const G={count:0,maxReached:!1,readdirCount:0},Q=new s.$ke(!0);await L(u,u,i,G);const te=await l(u);M({configFiles:w(O),fileTypes:w(I),fileCount:G.count,maxFilesReached:G.maxReached,launchConfigFiles:te,totalScanTime:Q.elapsed(),totalReaddirCount:G.readdirCount})});return p.set(f,R),R}function w(u){return Array.from(u.entries(),([i,f])=>({name:i,count:f})).sort((i,f)=>f.count-i.count)}function o(){const u={os:`${r.type()} ${r.arch()} ${r.release()}`,memory:`${(r.totalmem()/c.$Nl.GB).toFixed(2)}GB (${(r.freemem()/c.$Nl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.$Yn.value()*100)}%`},i=r.cpus();return i&&i.length>0&&(u.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),u}async function l(u){try{const i=new Map,f=(0,T.$oc)(u,".vscode","launch.json"),h=await t.promises.readFile(f),k=[],I=(0,P.$5n)(h.toString(),k);if(k.length)return console.log(`Unable to parse ${f}`),[];if((0,P.$ao)(I)==="object"&&I.configurations)for(const O of I.configurations){const C=O.type;C&&(i.has(C)?i.set(C,i.get(C)+1):i.set(C,1))}return w(i)}catch{return[]}}let n=class{constructor(i,f){this.c=i,this.d=f}f(i){const f=[];return f.push(`OS Version:       ${i.os}`),f.push(`CPUs:             ${i.cpus}`),f.push(`Memory (System):  ${i.memory}`),f.push(`VM:               ${i.vmHint}`),f.join(`
`)}g(i){const f=[];f.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),f.push(`OS Version:       ${r.type()} ${r.arch()} ${r.release()}`);const h=r.cpus();return h&&h.length>0&&f.push(`CPUs:             ${h[0].model} (${h.length} x ${h[0].speed})`),f.push(`Memory (System):  ${(r.totalmem()/c.$Nl.GB).toFixed(2)}GB (${(r.freemem()/c.$Nl.GB).toFixed(2)}GB free)`),v.$l||f.push(`Load (avg):       ${r.loadavg().map(k=>Math.round(k)).join(", ")}`),f.push(`VM:               ${Math.round(y.$Yn.value()*100)}%`),f.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),f.push(`Process Argv:     ${i.mainArguments.join(" ")}`),f.push(`GPU Status:       ${this.j(i.gpuFeatureStatus)}`),f.join(`
`)}async getPerformanceInfo(i,f){return Promise.all([(0,g.$6s)(i.mainPID),this.k(i)]).then(async h=>{let[k,I]=h,O=this.m(i,k);return f.forEach(C=>{if((0,a.$Zm)(C))O+=`
${C.errorMessage}`,I+=`
${C.errorMessage}`;else if(O+=`

Remote: ${C.hostName}`,C.processes&&(O+=`
${this.m(i,C.processes)}`),C.workspaceMetadata){I+=`
|  Remote: ${C.hostName}`;for(const L of Object.keys(C.workspaceMetadata)){const R=C.workspaceMetadata[L];let M=`${R.fileCount} files`;R.maxFilesReached&&(M=`more than ${M}`),I+=`|    Folder (${L}): ${M}`,I+=this.h(R)}}}),{processInfo:O,workspaceInfo:I}})}async getSystemInfo(i,f){const{memory:h,vmHint:k,os:I,cpus:O}=o(),C={os:I,memory:h,cpus:O,vmHint:k,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:f};return v.$l||(C.load=`${r.loadavg().map(L=>Math.round(L)).join(", ")}`),v.$n&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(i,f){const h=[];return(0,g.$6s)(i.mainPID).then(async k=>(h.push(""),h.push(this.g(i)),h.push(""),h.push(this.m(i,k)),i.windows.some(I=>I.folderURIs&&I.folderURIs.length>0&&!I.remoteAuthority)&&(h.push(""),h.push("Workspace Stats: "),h.push(await this.k(i))),f.forEach(I=>{if((0,a.$Zm)(I))h.push(`
${I.errorMessage}`);else if(h.push(`

`),h.push(`Remote:           ${I.hostName}`),h.push(this.f(I.machineInfo)),I.processes&&h.push(this.m(i,I.processes)),I.workspaceMetadata)for(const O of Object.keys(I.workspaceMetadata)){const C=I.workspaceMetadata[O];let L=`${C.fileCount} files`;C.maxFilesReached&&(L=`more than ${L}`),h.push(`Folder (${O}): ${L}`),h.push(this.h(C))}}),h.push(""),h.push(""),h.join(`
`)))}h(i){const f=[];let k=0;const I=(R,M)=>{const G=` ${R}(${M})`;k+G.length>60?(f.push(O),O="|                 ",k=O.length):k+=G.length,O+=G};let O="|      File types:";const C=10,L=i.fileTypes.length>C?C:i.fileTypes.length;for(let R=0;R<L;R++){const M=i.fileTypes[R];I(M.name,M.count)}if(f.push(O),i.configFiles.length>=0&&(O="|      Conf files:",k=0,i.configFiles.forEach(R=>{I(R.name,R.count)}),f.push(O)),i.launchConfigFiles.length>0){let R="|      Launch Configs:";i.launchConfigFiles.forEach(M=>{const G=M.count>1?` ${M.name}(${M.count})`:` ${M.name}`;R+=G}),f.push(R)}return f.join(`
`)}j(i){const f=Math.max(...Object.keys(i).map(h=>h.length));return Object.keys(i).map(h=>`${h}:  ${" ".repeat(f-h.length)}  ${i[h]}`).join(`
                  `)}k(i){const f=[],h=[];return i.windows.forEach(k=>{k.folderURIs.length===0||k.remoteAuthority||(f.push(`|  Window (${k.title})`),k.folderURIs.forEach(I=>{const O=S.URI.revive(I);if(O.scheme===D.Schemas.file){const C=O.fsPath;h.push(d(C,["node_modules",".git"]).then(L=>{let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),f.push(`|    Folder (${(0,T.$sc)(C)}): ${R}`),f.push(this.h(L))}).catch(L=>{f.push(`|      Error: Unable to collect workspace stats for folder ${C} (${L.toString()})`)}))}else f.push(`|    Folder (${O.toString()}): Workspace stats not available.`)}))}),Promise.all(h).then(k=>f.join(`
`)).catch(k=>`Unable to collect workspace stats: ${k}`)}m(i,f){const h=new Map;i.windows.forEach(I=>h.set(I.pid,`window [${I.id}] (${I.title})`)),i.pidToNames.forEach(({pid:I,name:O})=>h.set(I,O));const k=[];return k.push("CPU %	Mem MB	   PID	Process"),f&&this.n(i.mainPID,h,k,f,0),k.join(`
`)}n(i,f,h,k,I){const O=I===0;let C;O?C=k.pid===i?`${this.d.applicationName} main`:"remote agent":f.has(k.pid)?C=f.get(k.pid):C=`${"  ".repeat(I)} ${k.name}`;const L=process.platform==="win32"?k.mem:r.totalmem()*(k.mem/100);h.push(`${k.load.toFixed(0).padStart(5," ")}	${(L/c.$Nl.MB).toFixed(0).padStart(6," ")}	${k.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(k.children)&&k.children.forEach(R=>this.n(i,f,h,R,I+1))}async getWorkspaceFileExtensions(i){const f=new Set;for(const{uri:h}of i.folders){const k=S.URI.revive(h);if(k.scheme!==D.Schemas.file)continue;const I=k.fsPath;try{(await d(I,["node_modules",".git"])).fileTypes.forEach(C=>f.add(C.name))}catch{}}return{extensions:[...f]}}async reportWorkspaceStats(i){for(const{uri:f}of i.folders){const h=S.URI.revive(f);if(h.scheme!==D.Schemas.file)continue;const k=h.fsPath;try{const I=await d(k,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),I.fileTypes.forEach(O=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:O.name,count:O.count})}),I.launchConfigFiles.forEach(O=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:O.name,count:O.count})}),I.configFiles.forEach(O=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:O.name,count:O.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:I.totalScanTime,reachedLimit:I.maxFilesReached,fileCount:I.fileCount,readdirCount:I.totalReaddirCount})}catch{}}}};e.$0s=n,e.$0s=n=We([je(0,b.$em),je(1,m.$yk)],n)}),define(Te[95],Oe([1,0,111,9,5,11,24]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.ExtensionSignatureVerificationCode=e.$Bq=void 0,e.$Bq=(0,E.$Ki)("IExtensionSignatureVerificationService");var T;(function(S){S.Success="Success",S.RequiredArgumentMissing="RequiredArgumentMissing",S.InvalidArgument="InvalidArgument",S.PackageIsUnreadable="PackageIsUnreadable",S.UnhandledException="UnhandledException",S.SignatureManifestIsMissing="SignatureManifestIsMissing",S.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",S.SignatureIsMissing="SignatureIsMissing",S.SignatureIsUnreadable="SignatureIsUnreadable",S.CertificateIsUnreadable="CertificateIsUnreadable",S.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",S.FileAlreadyExists="FileAlreadyExists",S.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",S.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",S.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",S.SignatureIsInvalid="SignatureIsInvalid",S.SignatureManifestIsInvalid="SignatureManifestIsInvalid",S.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",S.EntryIsMissing="EntryIsMissing",S.EntryIsTampered="EntryIsTampered",S.Untrusted="Untrusted",S.CertificateRevoked="CertificateRevoked",S.SignatureIsNotValid="SignatureIsNotValid",S.UnknownError="UnknownError",S.PackageIsInvalidZip="PackageIsInvalidZip",S.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(T||(e.ExtensionSignatureVerificationCode=T={}));class v extends Error{constructor(y){super(y),this.code=y}}e.$Cq=v;let s=class{constructor(y,$){this.b=y,this.c=$}d(){return this.a||(this.a=this.f()),this.a}async f(){return(0,t.$zq)("@vscode/vsce-sign","src/main.js")}async verify(y,$,g,a){let c;const m=y.identifier.id;try{c=await this.d()}catch(w){return this.b.error("Could not load vsce-sign module",(0,r.$bb)(w)),this.b.info(`Extension signature verification is not done: ${m}`),!1}const b=new Date().getTime();let p;try{this.b.trace(`Verifying extension signature for ${m}...`),p=await c.verify($,g,this.b.getLevel()===P.LogLevel.Trace)}catch(w){p={code:T.UnknownError,didExecute:!1,output:(0,r.$bb)(w)}}const d=new Date().getTime()-b;if(this.b.info(`Extension signature verification result for ${m}: ${p.code}. Executed: ${p.didExecute}. Duration: ${d}ms.`),this.b.trace(`Extension signature verification output for ${m}:
${p.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:m,extensionVersion:y.version,code:p.code,internalCode:p.internalCode,duration:d,didExecute:p.didExecute,clientTargetPlatform:a}),p.code===T.Success)return!0;throw new v(p.code)}};e.$Dq=s,e.$Dq=s=We([je(0,P.$fk),je(1,D.$em)],s)}),define(Te[232],Oe([1,0,2,24]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=void 0;class E extends t.$Zc{constructor(D,T){super(),this.a=D,this.b=T}async call(D,T,v){switch(T){case"updateTelemetryLevel":{const{telemetryLevel:s}=v;return this.a.updateInjectedTelemetryLevel(s)}case"logTelemetry":{const{eventName:s,data:S}=v;return this.b?this.b.log(s,S):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${T} not found`)}listen(D,T,v){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(r.TelemetryLevel.NONE),super.dispose()}}e.$ft=E}),define(Te[40],Oe([1,0,20,10,91,133,24]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=void 0,e.$Kp=S,e.$Lp=y,e.$Mp=$,e.$Np=g,e.$Op=c,e.$Pp=b,e.$Qp=p,e.$Rp=o;class T{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$Dp=T;class v{constructor(){this.telemetryLevel=D.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ep=v,e.$Fp=new v;class s{async publicLog(n,u,i){}async publicLogError(n,u,i){}}e.$Gp=s,e.$Hp="telemetry",e.$Ip="extensionTelemetryLog",e.$Jp={log:()=>null,flush:()=>Promise.resolve(null)};function S(l,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!l.enableTelemetry)}function y(l,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function $(l){const n=l.getValue(D.$nm),u=l.getValue(D.$om);if(l.getValue(D.$pm)===!1||u===!1)return D.TelemetryLevel.NONE;switch(n??D.TelemetryConfiguration.ON){case D.TelemetryConfiguration.ON:return D.TelemetryLevel.USAGE;case D.TelemetryConfiguration.ERROR:return D.TelemetryLevel.ERROR;case D.TelemetryConfiguration.CRASH:return D.TelemetryLevel.CRASH;case D.TelemetryConfiguration.OFF:return D.TelemetryLevel.NONE}}function g(l){const n={},u={},i={};m(l,i);for(let f in i){f=f.length>150?f.substr(f.length-149):f;const h=i[f];typeof h=="number"?u[f]=h:typeof h=="boolean"?u[f]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${h.length}`),n[f]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(n[f]=h)}return{properties:n,measurements:u}}const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(l){if(!l)return"none";const n=(0,E.$on)(l);return a.has(n)?n:"other"}function m(l,n,u=0,i){if(l)for(const f of Object.getOwnPropertyNames(l)){const h=l[f],k=i?i+f:f;Array.isArray(h)?n[k]=(0,t.$po)(h):h instanceof Date?n[k]=h.toISOString():(0,r.$lg)(h)?u<2?m(h,n,u+1,k+"."):n[k]=(0,t.$po)(h):n[k]=h}}function b(l,n){const u=l.msftInternalDomains||[],i=n.getValue("telemetry.internalTesting");return(0,P.$Cp)(u)||i}function p(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function d(l,n){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let u=l;const i=[];for(const I of n)for(;;){const O=I.exec(l);if(!O)break;i.push([O.index,I.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(u="";;){const I=h.exec(l);if(!I)break;const O=i.some(([C,L])=>I.index<L&&C<h.lastIndex);!f.test(I[0])&&!O&&(u+=l.substring(k,I.index)+"<REDACTED: user-file-path>",k=h.lastIndex)}return k<l.length&&(u+=l.substr(k)),u}function w(l){if(!l)return l;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of n)if(u.regex.test(l))return`<REDACTED: ${u.label}>`;return l}function o(l,n){return(0,t.$mo)(l,u=>{if(u instanceof T||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let i=u.replaceAll("%20"," ");i=d(i,n);for(const f of n)i=i.replace(f,"");return i=w(i),i}})}}),define(Te[38],Oe([1,0,16,30,21,3,4,9,32,40]),function(ue,e,t,r,E,P,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$Tp=void 0,e.$Sp=S,e.$Up=a,e.$Vp=c,e.$Wp=m,e.$Xp=b,e.$Yp=p,e.$Zp=d,e.$1p=w,e.$3p=o,e.$4p=n;function S(u,i){return u.uuid&&i.uuid?u.uuid===i.uuid:u.id===i.id?!0:(0,t.$Ff)(u.id,i.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(i){const f=i.manifest?i.manifest.version:i.version,h=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new $(i.identifier,f,h)}static parse(i){const f=y.exec(i);return f&&f[1]&&f[2]?new $({id:f[1]},f[2],f[4]||void 0):null}constructor(i,f,h=E.TargetPlatform.UNDEFINED){this.identifier=i,this.version=f,this.targetPlatform=h,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==E.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof $?S(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Tp=$;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function a(u){const i=g.exec(u);return i&&i[1]?[m(i[1]),i[2]]:[m(u),void 0]}function c(u,i){return`${u}.${i}`}function m(u){return u.toLowerCase()}function b(u,i){return m(c(u??E.$tn,i))}function p(u,i){const f=[],h=k=>{for(const I of f)if(I.some(O=>S(i(O),i(k))))return I;return null};for(const k of u){const I=h(k);I?I.push(k):f.push([k])}return f}function d(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}function w(u){return{id:new s.$Dp(u.identifier.id),name:new s.$Dp(u.name),version:u.version,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$2p=new E.$xn("pprice.better-merge");function o(u,i){const f=[],h=i.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const k=h.shift();if(k&&f.every(I=>!S(I.identifier,{id:k}))){const I=u.filter(O=>S(O.identifier,{id:k}));I.length===1&&(f.push(I[0]),h.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}async function l(u,i){if(!P.$n)return!1;let f;try{f=(await u.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{f=(await u.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){i.debug("Error while getting the os-release file.",(0,T.$bb)(k))}}return!!f&&(f.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(u,i){const f=await l(u,i),h=(0,r.$np)(f?"alpine":P.$x,v.$jc);return i.debug("ComputeTargetPlatform:",h),h}}),define(Te[134],Oe([1,0,18,9,12,19,62,4,7,30,38,21]),function(ue,e,t,r,E,P,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;const $=c=>(0,v.localize)(1782,null,c),g=(0,v.localize)(1783,null,"ms-dotnettools.csharp");let a=class{constructor(m,b,p){this.a=m,this.b=b,this.d=p}get f(){}async listExtensions(m,b,p){let d=await this.b.getInstalled(y.ExtensionType.User,p);const w=y.$wn.map(l=>l.toLowerCase());if(b&&b!==""){if(w.indexOf(b.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}d=d.filter(l=>l.manifest.categories?l.manifest.categories.map(u=>u.toLowerCase()).indexOf(b.toLowerCase())>-1:!1)}else if(b===""){this.a.info("Possible Categories: "),w.forEach(l=>{this.a.info(l)});return}this.f&&this.a.info((0,v.localize)(1784,null,this.f)),d=d.sort((l,n)=>l.identifier.id.localeCompare(n.identifier.id));let o;for(const l of d)o!==l.identifier.id&&(o=l.identifier.id,this.a.info(m?`${o}@${l.manifest.version}`:o))}async installExtensions(m,b,p,d){const w=[];try{m.length&&this.a.info(this.f?(0,v.localize)(1785,null,this.f):(0,v.localize)(1786,null));const o=[],l=[],n=(i,f,h)=>{l.push({id:i,version:f!=="prerelease"?f:void 0,installOptions:{...p,isBuiltin:h,installPreReleaseVersion:f==="prerelease"||p.installPreReleaseVersion}})};for(const i of m)if(i instanceof T.URI)o.push({vsix:i,installOptions:p});else{const[f,h]=(0,S.$Up)(i);n(f,h,!1)}for(const i of b)if(i instanceof T.URI)o.push({vsix:i,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[f,h]=(0,S.$Up)(i);n(f,h,!0)}const u=await this.b.getInstalled(void 0,p.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:i,installOptions:f})=>{try{await this.h(i,f,d,u)}catch(h){this.a.error(h),w.push(i.toString())}})),l.length){const i=await this.g(l,u,d);w.push(...i)}}catch(o){throw this.a.error((0,v.localize)(1787,null,(0,r.$bb)(o))),o}if(w.length)throw new Error((0,v.localize)(1788,null,w.join(", ")))}async updateExtensions(m){const b=await this.b.getInstalled(y.ExtensionType.User,m),p=[];for(const l of b)l.identifier.uuid&&p.push({...l.identifier,preRelease:l.preRelease});this.a.trace((0,v.localize)(1789,null,p.length));const d=await this.d.getExtensions(p,{compatible:!0},t.CancellationToken.None),w=[];for(const l of d)for(const n of b)(0,S.$Sp)(n.identifier,l.identifier)&&(0,D.gt)(l.version,n.manifest.version)&&w.push({extension:l,options:{operation:s.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:m,isApplicationScoped:n.isApplicationScoped}});if(!w.length){this.a.info((0,v.localize)(1790,null));return}this.a.info((0,v.localize)(1791,null,w.map(l=>l.extension.identifier.id).join(", ")));const o=await this.b.installGalleryExtensions(w);for(const l of o)l.error?this.a.error((0,v.localize)(1792,null,l.identifier.id,(0,r.$bb)(l.error))):this.a.info((0,v.localize)(1793,null,l.identifier.id,l.local?.manifest.version))}async g(m,b,p){if(m=m.filter(({id:l,version:n})=>{const u=b.find(i=>(0,S.$Sp)(i.identifier,{id:l}));if(u){if(!p&&(!n||n==="prerelease"&&u.preRelease))return this.a.info((0,v.localize)(1794,null,l,u.manifest.version,l)),!1;if(n&&u.manifest.version===n)return this.a.info((0,v.localize)(1795,null,`${l}@${n}`)),!1}return!0}),!m.length)return[];const d=[],w=[],o=await this.j(m);if(await Promise.all(m.map(async({id:l,version:n,installOptions:u})=>{const i=o.get(l.toLowerCase());if(!i){this.a.error(`${$(n?`${l}@${n}`:l)}
${g}`),d.push(l);return}try{const h=await this.d.getManifest(i,t.CancellationToken.None);if(h&&!this.k(h))return}catch(h){this.a.error(h.message||h.stack||h),d.push(l);return}const f=b.find(h=>(0,S.$Sp)(h.identifier,i.identifier));if(f){if(i.version===f.manifest.version){this.a.info((0,v.localize)(1796,null,n?`${l}@${n}`:l));return}this.a.info((0,v.localize)(1797,null,l,i.version))}u.isBuiltin?this.a.info(n?(0,v.localize)(1798,null,l,n):(0,v.localize)(1799,null,l)):this.a.info(n?(0,v.localize)(1800,null,l,n):(0,v.localize)(1801,null,l)),w.push({extension:i,options:{...u,installGivenVersion:!!n,isApplicationScoped:u.isApplicationScoped||f?.isApplicationScoped}})})),w.length){const l=await this.b.installGalleryExtensions(w);for(const n of l)n.error?(this.a.error((0,v.localize)(1802,null,n.identifier.id,(0,r.$bb)(n.error))),d.push(n.identifier.id)):this.a.info((0,v.localize)(1803,null,n.identifier.id,n.local?.manifest.version))}return d}async h(m,b,p,d){const w=await this.b.getManifest(m);if(!w)throw new Error("Invalid vsix");if(await this.l(w,p,b.profileLocation,d))try{await this.b.install(m,{...b,installGivenVersion:!0}),this.a.info((0,v.localize)(1804,null,(0,P.$ih)(m)))}catch(l){if((0,r.$8)(l))this.a.info((0,v.localize)(1805,null,(0,P.$ih)(m)));else throw l}}async j(m){const b=new Map,p=m.some(o=>o.installOptions.installPreReleaseVersion),d=await this.b.getTargetPlatform(),w=[];for(const o of m)s.$fp.test(o.id)&&w.push({...o,preRelease:p});if(w.length){const o=await this.d.getExtensions(w,{targetPlatform:d},t.CancellationToken.None);for(const l of o)b.set(l.identifier.id.toLowerCase(),l)}return b}k(m){return!0}async l(m,b,p,d){if(!b){const w={id:(0,S.$Xp)(m.publisher,m.name)},o=d.find(l=>(0,S.$Sp)(w,l.identifier)&&(0,D.gt)(l.manifest.version,m.version));if(o)return this.a.info((0,v.localize)(1806,null,o.identifier.id,o.manifest.version,m.version)),!1}return this.k(m)}async uninstallExtensions(m,b,p){const d=async o=>{if(o instanceof T.URI){const l=await this.b.getManifest(o);return(0,S.$Vp)(l.publisher,l.name)}return o},w=[];for(const o of m){const l=await d(o),u=(await this.b.getInstalled(void 0,p)).filter(i=>(0,S.$Sp)(i.identifier,{id:l}));if(!u.length)throw new Error(`${this.m(l)}
${g}`);if(u.some(i=>i.type===y.ExtensionType.System)){this.a.info((0,v.localize)(1807,null,l));return}if(!b&&u.some(i=>i.isBuiltin)){this.a.info((0,v.localize)(1808,null,l));return}this.a.info((0,v.localize)(1809,null,l));for(const i of u)await this.b.uninstall(i,{profileLocation:p}),w.push(i);this.f?this.a.info((0,v.localize)(1810,null,l,this.f)):this.a.info((0,v.localize)(1811,null,l))}}async locateExtension(m){const b=await this.b.getInstalled();m.forEach(p=>{b.forEach(d=>{if(d.identifier.id===p&&d.location.scheme===E.Schemas.file){this.a.info(d.location.fsPath);return}})})}m(m){return this.f?(0,v.localize)(1812,null,m,this.f):(0,v.localize)(1813,null,m)}};e.$Eq=a,e.$Eq=a=We([je(1,s.$up),je(2,s.$rp)],a)}),define(Te[233],Oe([1,0,9,6,2,25,38,21,15]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class s extends E.$Zc{constructor(y,$,g,a,c,m,b){super(),this.f=y,this.g=$,this.h=g,this.j=a,this.m=c,this.n=m,this.r=b,this.a=this.B(new r.$qe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new E.$9c),this.s().then(null,p=>b.error("Error while initializing Extensions Watcher",(0,t.$bb)(p)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(y=>this.u(y.added))),this.B(this.j.onAddExtensions(y=>this.w(y))),this.B(this.j.onDidAddExtensions(y=>this.y(y))),this.B(this.j.onRemoveExtensions(y=>this.z(y))),this.B(this.j.onDidRemoveExtensions(y=>this.C(y))),this.B(this.n.onDidFilesChange(y=>this.D(y)))}async u(y){try{y.length&&await Promise.all(y.map($=>(this.c.set($.id,(0,E.$Wc)(this.n.watch(this.m.extUri.dirname($.extensionsResource)),this.n.watch($.extensionsResource))),this.G($.extensionsResource))))}catch($){throw this.r.error($),$}}async w(y){for(const $ of y.extensions)this.I(this.L($.identifier,$.version),y.profileLocation)}async y(y){for(const $ of y.extensions){const g=this.L($.identifier,$.version);y.error?this.J(g,y.profileLocation):this.I(g,y.profileLocation)}}async z(y){for(const $ of y.extensions)this.J(this.L($.identifier,$.version),y.profileLocation)}async C(y){const $=[],g=[];for(const a of y.extensions){const c=this.L(a.identifier,a.version);y.error?this.I(c,y.profileLocation):(this.J(c,y.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",a.identifier.id,a.version),g.push(this.f.scanInstalledExtensionAtLocation(a.location).then(m=>{m?$.push(m):this.r.info("Extension not found at the location",a.location.toString())},m=>this.r.error(m)))))}try{await Promise.all(g),$.length&&await this.H($)}catch(a){this.r.error(a)}}D(y){for(const $ of this.h.profiles)y.contains($.extensionsResource,v.FileChangeType.UPDATED,v.FileChangeType.ADDED)&&this.F($.extensionsResource)}async F(y){const $=[],g=[],a=await this.j.scanProfileExtensions(y),c=new Set,m=new Set;for(const[b,p]of this.b)p.has(y)&&m.add(b);for(const b of a){const p=this.L(b.identifier,b.version);c.add(p),m.has(p)||($.push(b.identifier),this.I(p,y))}for(const b of m)if(!c.has(b)){const p=this.M(b);p&&(g.push(p.identifier),this.J(b,y))}($.length||g.length)&&this.a.fire({added:$.length?{extensions:$,profileLocation:y}:void 0,removed:g.length?{extensions:g,profileLocation:y}:void 0})}async G(y){const $=await this.j.scanProfileExtensions(y);for(const g of $)this.I(this.L(g.identifier,g.version),y)}async H(y){y||(y=(await this.f.scanAllUserInstalledExtensions()).filter(g=>!this.b.has(this.L(g.identifier,g.manifest.version)))),y.length&&await this.f.markAsUninstalled(...y)}I(y,$){let g=this.b.get(y);g||this.b.set(y,g=new P.$Gc(a=>this.m.extUri.getComparisonKey(a))),g.add($)}J(y,$){const g=this.b.get(y);g&&g.delete($),g?.size||this.b.delete(y)}L(y,$){return`${T.$xn.toKey(y.id)}@${$}`}M(y){const[$,g]=(0,D.$Up)(y);return g?{identifier:{id:$},version:g}:void 0}}e.$6q=s}),define(Te[135],Oe([1,0,23,96,17,13,2,12,8,26,27,30,38,11,92,4]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0,t=Ve(t);let m=class extends a.$is{constructor(w,o,l,n){super(l),this.h=w,this.j=n,this.g=this.B(new b(o,n)),this.h.registerParticipant({postInstall:async u=>this.m(u),postUninstall:async u=>this.n(u)})}async getBuiltInExtensionTranslationsUri(w,o){const n=(await this.g.getLanguagePacks())[o];if(!n){this.j.warn(`No language pack found for ${o}`);return}const u=n.translations[w];return u?c.URI.file(u):void 0}async getInstalledLanguages(){const w=await this.g.getLanguagePacks(),o=Object.keys(w).map(l=>{const n=w[l];return{...this.f(l,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return o.push(this.f("en","English")),o.sort((l,n)=>l.label.localeCompare(n.label)),o}async m(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",w.identifier.id),await this.update())}async n(w){const o=await this.g.getLanguagePacks();Object.keys(o).some(l=>o[l]&&o[l].extensions.some(n=>(0,$.$Sp)(n.extensionIdentifier,w.identifier)))&&(this.j.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,o]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(o);return!(0,E.$yb)(Object.keys(w),Object.keys(l))}};e.$js=m,e.$js=m=We([je(0,y.$up),je(1,S.$Si),je(2,y.$rp),je(3,g.$fk)],m);let b=class extends D.$Zc{constructor(w,o){super(),this.j=o,this.c={},this.f=(0,v.$oc)(w.userDataPath,"languagepacks.json"),this.g=new P.$Rh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(w){return this.s(o=>{Object.keys(o).forEach(l=>delete o[l]),this.m(o,...w)}).then(()=>this.c)}m(w,...o){for(const l of o)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(w,l);Object.keys(w).forEach(l=>this.r(w[l]))}n(w,o){const l=o.identifier,n=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const u of n)if(o.location.scheme===T.Schemas.file&&p(u)){let i=w[u.languageId];i||(i={hash:"",extensions:[],translations:{},label:u.localizedLanguageName??u.languageName},w[u.languageId]=i);const f=i.extensions.filter(h=>(0,$.$Sp)(h.extensionIdentifier,l))[0];f?f.version=o.manifest.version:i.extensions.push({extensionIdentifier:l,version:o.manifest.version});for(const h of u.translations)i.translations[h.id]=(0,v.$oc)(o.location.fsPath,h.path)}}r(w){if(w){const o=(0,r.createHash)("md5");for(const l of w.extensions)o.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);w.hash=o.digest("hex")}}s(w=()=>null){return this.g.queue(()=>{let o=null;return t.promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(o=w(l),l)).then(l=>{for(const u of Object.keys(l))l[u]||delete l[u];this.c=l,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),s.Promises.writeFile(this.f,n)}).then(()=>o,l=>this.j.error(l))})}};b=We([je(0,S.$Si),je(1,g.$fk)],b);function p(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const w of d.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(Te[234],Oe([1,0,111,9,20,3,40]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZR=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0",v="https://mobile.events.data.microsoft.com/ping";async function s(y,$,g){P.$r;const a=await(0,t.$zq)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,t.$zq)("@microsoft/1ds-post-js","dist/ms.post.js"),m=new a.AppInsightsCore,b=new c.PostChannel,p={instrumentationKey:y,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(g){p.extensionConfig={};const d={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:g};p.extensionConfig[b.identifier]=d}return m.initialize(p,[]),m.addTelemetryInitializer(d=>{d.ext=d.ext??{},d.ext.web=d.ext.web??{},d.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',$&&(d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),m}class S{constructor($,g,a,c,m){this.e=$,this.f=g,this.g=a,this.h=m,this.c=T,this.d=v,this.g||(this.g={}),typeof c=="function"?this.a=c():this.a=c,this.b=null}i($){if(this.a){if(typeof this.a!="string"){$(this.a);return}this.b||(this.b=s(this.a,this.e,this.h)),this.b.then(g=>{$(g)},g=>{(0,r.$4)(g),console.error(g)})}}log($,g){if(!this.a)return;g=(0,E.$no)(g,this.g),g=(0,D.$Np)(g);const a=this.f+"/"+$;try{this.i(c=>{c.pluginVersionString=g?.properties.version??"Unknown",c.track({name:a,baseData:{name:a,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise($=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,$(void 0)})})}):Promise.resolve(void 0)}}e.$ZR=S});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[235],Oe([1,0,2,20,3,16,7,28,46,61,29,37,24,40]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0,s=$t(s);let a=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(b,p,d){this.k=p,this.l=d,this.d={},this.i=new t.$Yc,this.j=[],this.b=b.appenders,this.c=b.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=b.piiPaths||[],this.g=$.TelemetryLevel.USAGE,this.h=!!b.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,P.$mf)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,P.$mf)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration($.$nm)||w.affectsConfiguration($.$pm)||w.affectsConfiguration($.$om))&&this.m()}))}setExperimentProperty(b,p){this.d[b]=p}m(){let b=(0,g.$Mp)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const d=p.usage?$.TelemetryLevel.USAGE:p.error?$.TelemetryLevel.ERROR:$.TelemetryLevel.NONE;b=Math.min(b,d)}this.g=b}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(b,p,d){this.g<p||(d=(0,r.$no)(d,this.d),d=(0,g.$Rp)(d,this.j),d=(0,r.$no)(d,this.c),this.b.forEach(w=>w.log(b,d)))}publicLog(b,p){this.n(b,$.TelemetryLevel.USAGE,p)}publicLog2(b,p){this.publicLog(b,p)}publicLogError(b,p){this.h&&this.n(b,$.TelemetryLevel.ERROR,p)}publicLogError2(b,p){this.publicLogError(b,p)}};e.$ps=a,e.$ps=a=We([je(1,T.$ej),je(2,S.$yk)],a);function c(){const m=(0,D.localize)(2068,null,s.default.nameLong),b=s.default.privacyStatementUrl?(0,D.localize)(2070,null,"https://aka.ms/vscode-telemetry",s.default.privacyStatementUrl):(0,D.localize)(2069,null,"https://aka.ms/vscode-telemetry"),p=E.$r?"":(0,D.localize)(2071,null),d=(0,D.localize)(2072,null),w=(0,D.localize)(2073,null),o=(0,D.localize)(2074,null),l=(0,D.localize)(2075,null),n=`
|       | ${d} | ${w} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,u=(0,D.localize)(2076,null);return`
${m} ${b} ${p}

&nbsp;

${l}
${n}

&nbsp;

${u}
`}y.$xo.as(v.$Co.Configuration).registerConfiguration({id:$.$mm,order:1,type:"object",title:(0,D.localize)(2077,null),properties:{[$.$nm]:{type:"string",enum:[$.TelemetryConfiguration.ON,$.TelemetryConfiguration.ERROR,$.TelemetryConfiguration.CRASH,$.TelemetryConfiguration.OFF],enumDescriptions:[(0,D.localize)(2078,null),(0,D.localize)(2079,null),(0,D.localize)(2080,null),(0,D.localize)(2081,null)],markdownDescription:c(),default:$.TelemetryConfiguration.ON,restricted:!0,scope:v.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),y.$xo.as(v.$Co.Configuration).registerConfiguration({id:$.$mm,order:110,type:"object",title:(0,D.localize)(2082,null),properties:{[$.$pm]:{type:"boolean",markdownDescription:s.default.privacyStatementUrl?(0,D.localize)(2084,null,s.default.nameLong,s.default.privacyStatementUrl):(0,D.localize)(2083,null,s.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(2085,null,`\`#${$.$nm}#\``),scope:v.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(Te[236],Oe([1,0,28,5,29,24,235,40]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=void 0;let v=class extends D.$ps{constructor(S,y,$,g){super(S,$,g),this.o=y}publicLog(S,y){if(!(this.o<P.TelemetryLevel.USAGE))return super.publicLog(S,y)}publicLog2(S,y){return this.publicLog(S,y)}publicLogError(S,y){return this.o<P.TelemetryLevel.ERROR?Promise.resolve(void 0):super.publicLogError(S,y)}publicLogError2(S,y){return this.publicLogError(S,y)}async updateInjectedTelemetryLevel(S){if(S===void 0)throw this.o=P.TelemetryLevel.NONE,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,S):S,this.o===P.TelemetryLevel.NONE&&this.dispose()}};e.$ct=v,e.$ct=v=We([je(2,t.$ej),je(3,E.$yk)],v),e.$dt=new class extends T.$Ep{async updateInjectedTelemetryLevel(){}},e.$et=(0,r.$Li)(P.$em)}),define(Te[237],Oe([1,0,14,18,292,234]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1R=void 0,E=Ve(E);async function D(S,y){const $=await y.request(S,r.CancellationToken.None),g=(await(0,t.$5e)($.stream)).toString(),a=$.res.statusCode??200;return{headers:$.res.headers,statusCode:a,responseData:g}}async function T(S){const y={method:S.type,headers:S.headers};return new Promise((g,a)=>{const c=E.request(S.url??"",y,m=>{m.on("data",function(b){g({headers:m.headers,statusCode:m.statusCode??200,responseData:b.toString()})}),m.on("error",function(b){a(b)})});c.write(S.data,m=>{m&&a(m)}),c.end()})}async function v(S,y,$){const g=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),a={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:g};try{const c=S?await D(a,S):await T(a);$(c.statusCode,c.headers,c.responseData)}catch{$(0,{})}}class s extends P.$ZR{constructor(y,$,g,a,c){const m={sendPOST:(b,p)=>{v(y,b,p)}};super($,g,a,c,m)}}e.$1R=s});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[238],Oe([1,0,9,230]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=$t(r);class E extends r.default{i(){(0,t.setUnexpectedErrorHandler)(T=>console.error(T));const D=[];process.on("unhandledRejection",(T,v)=>{D.push(v),setTimeout(()=>{const s=D.indexOf(v);s>=0&&v.catch(S=>{D.splice(s,1),(0,t.$8)(S)||(console.warn(`rejected promise not handled within 1 second: ${S}`),S.stack&&console.warn(`stack trace: ${S.stack}`),T&&(0,t.$4)(T))})},1e3)}),process.on("rejectionHandled",T=>{const v=D.indexOf(T);v>=0&&D.splice(v,1)}),process.on("uncaughtException",T=>{(0,t.$3)(T)||(0,t.$4)(T)})}}e.default=E}),define(Te[136],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var t;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(t||(e.EnvironmentVariableMutatorType=t={}))}),define(Te[137],Oe([1,0,3,136]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;const E=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class P{constructor(S){this.collections=S,this.a=new Map,this.b=new Map,S.forEach((y,$)=>{this.d(y,$);const g=y.map.entries();let a=g.next();for(;!a.done;){const c=a.value[1],m=a.value[0];let b=this.a.get(m);if(b||(b=[],this.a.set(m,b)),b.length>0&&b[0].type===r.EnvironmentVariableMutatorType.Replace){a=g.next();continue}const p={extensionIdentifier:$,value:c.value,type:c.type,scope:c.scope,variable:c.variable,options:c.options};p.scope||delete p.scope,b.unshift(p),a=g.next()}})}async applyToProcessEnvironment(S,y,$){let g;t.$l&&(g={},Object.keys(S).forEach(a=>g[a.toLowerCase()]=a));for(const[a,c]of this.getVariableMap(y)){const m=t.$l&&g[a.toLowerCase()]||a;for(const b of c){const p=$?await $(b.value):b.value;if(b.options?.applyAtProcessCreation??!0)switch(b.type){case r.EnvironmentVariableMutatorType.Append:S[m]=(S[m]||"")+p;break;case r.EnvironmentVariableMutatorType.Prepend:S[m]=p+(S[m]||"");break;case r.EnvironmentVariableMutatorType.Replace:S[m]=p;break}if(b.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${E.get(b.type)}`;S[d]=(S[d]?S[d]+":":"")+a+"="+this.c(p)}}}}c(S){return S.replaceAll(":","\\x3a")}diff(S,y){const $=new Map,g=new Map,a=new Map;if(S.getVariableMap(y).forEach((c,m)=>{const b=this.getVariableMap(y).get(m),p=T(c,b);p&&$.set(m,p)}),this.getVariableMap(y).forEach((c,m)=>{const b=S.getVariableMap(y).get(m),p=T(c,b);p&&a.set(m,p)}),this.getVariableMap(y).forEach((c,m)=>{const b=S.getVariableMap(y).get(m),p=v(c,b);p&&g.set(m,p)}),!($.size===0&&g.size===0&&a.size===0))return{added:$,changed:g,removed:a}}getVariableMap(S){const y=new Map;for(const $ of this.a.values()){const g=$.filter(a=>D(a,S));g.length>0&&y.set(g[0].variable,g)}return y}getDescriptionMap(S){const y=new Map;for(const $ of this.b.values()){const g=$.filter(a=>D(a,S,!0));for(const a of g)y.set(a.extensionIdentifier,a.description)}return y}d(S,y){if(!S.descriptionMap)return;const $=S.descriptionMap.entries();let g=$.next();for(;!g.done;){const a=g.value[1],c=g.value[0];let m=this.b.get(c);m||(m=[],this.b.set(c,m));const b={extensionIdentifier:y,scope:a.scope,description:a.description};b.scope||delete b.scope,m.push(b),g=$.next()}}}e.$Ts=P;function D(s,S,y=!1){return s.scope?!!(s.scope.workspaceFolder&&S?.workspaceFolder&&s.scope.workspaceFolder.index===S.workspaceFolder.index):y?S===s.scope:!0}function T(s,S){if(!S)return s;const y=new Set;S.forEach(g=>y.add(g.extensionIdentifier));const $=[];return s.forEach(g=>{y.has(g.extensionIdentifier)||$.push(g)}),$.length===0?void 0:$}function v(s,S){if(!S)return;const y=new Map;S.forEach(g=>y.set(g.extensionIdentifier,g));const $=[];return s.forEach(g=>{const a=y.get(g.extensionIdentifier);a&&(g.type!==a.type||g.value!==a.value||g.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&$.push(a)}),$.length===0?void 0:$}}),define(Te[97],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=t,e.$Os=r,e.$Ps=E,e.$Qs=P,e.$Rs=D,e.$Ss=T;function t(v){return[...v.entries()]}function r(v){return v?[...v.entries()]:[]}function E(v){return new Map(v)}function P(v){return new Map(v??[])}function D(v){return Array.from(v.entries()).map(s=>[s[0],t(s[1].map),r(s[1].descriptionMap)])}function T(v){return new Map(v.map(s=>[s[0],{map:E(s[1]),descriptionMap:P(s[2])}]))}}),define(Te[239],Oe([1,0,13,18,6,2,11]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;let T=class extends P.$Zc{constructor(s,S){super(),this.h=S,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new E.$qe),this.onCreateRequest=this.g.event,this.b=s===void 0?15e3:s,this.B((0,P.$Xc)(()=>{for(const y of this.f.values())(0,P.$Uc)(y)}))}createRequest(s){return new Promise((S,y)=>{const $=++this.a;this.c.set($,S),this.g.fire({requestId:$,...s});const g=new r.$Be;(0,t.$Lh)(this.b,g.token).then(()=>y(`Request ${$} timed out (${this.b}ms)`)),this.f.set($,[(0,P.$Xc)(()=>g.cancel())])})}acceptReply(s,S){const y=this.c.get(s);y?(this.c.delete(s),(0,P.$Uc)(this.f.get(s)||[]),this.f.delete(s),y(S)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${s}`)}};e.$Es=T,e.$Es=T=We([je(1,D.$fk)],T)}),define(Te[53],Oe([1,0,5,41,37]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=e.$ys=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$xs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ws=void 0,e.$ws=new r.$2j("terminalTabFocusMode",!1,!0);var P;(function(l){l.AutomationProfile="terminal.integrated.automationProfile.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(P||(e.TerminalSettingPrefix=P={}));var D;(function(l){l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.TabStopWidth="terminal.integrated.tabStopWidth",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorStyleInactive="terminal.integrated.cursorStyleInactive",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.MiddleClickBehavior="terminal.integrated.middleClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.EnableVisualBell="terminal.integrated.enableVisualBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.TabFocusMode="terminal.integrated.tabFocusMode",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.HideOnStartup="terminal.integrated.hideOnStartup",l.CustomGlyphs="terminal.integrated.customGlyphs",l.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.EnableImages="terminal.integrated.enableImages",l.SmoothScrolling="terminal.integrated.smoothScrolling",l.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",l.FocusAfterRun="terminal.integrated.focusAfterRun",l.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",l.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",l.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var T;(function(l){l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh"})(T||(e.PosixShellType=T={}));var v;(function(l){l.CommandPrompt="cmd",l.Wsl="wsl",l.GitBash="gitbash"})(v||(e.WindowsShellType=v={}));var s;(function(l){l.PowerShell="pwsh",l.Python="python",l.Julia="julia",l.NuShell="nu"})(s||(e.GeneralShellType=s={}));var S;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})(S||(e.TitleEventSource=S={}));var y;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.PtyHostWindow="ptyHostWindow",l.Logger="logger",l.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var $;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})($||(e.ProcessPropertyType=$={})),e.$xs=(0,t.$Ki)("ptyService");var g;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(g||(e.HeartbeatConstants=g={}));var a;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(a||(e.TerminalLocation=a={}));var c;(function(l){l.TerminalView="view",l.Editor="editor"})(c||(e.TerminalLocationString=c={}));var m;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var b;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(b||(e.FlowControlConstants=b={}));var p;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(p||(e.ProfileSource=p={}));var d;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var w;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(w||(e.TerminalExitReason=w={})),e.$ys={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(n){const u=this.b(n.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,n)}getTerminalBackend(n){return this.a.get(this.b(n))}b(n){return n?.toLowerCase()??""}}E.$xo.add(e.$ys.Backend,new o),e.$zs=(0,t.$Ki)("localPtyService"),e.$As=(0,t.$Ki)("terminalLogService")}),define(Te[138],Oe([1,0,3]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=r,e.$DR=E,e.$ER=P,e.$FR=D;function r(T){let v=T;v.includes("\\")&&(v=v.replace(/\\/g,"\\\\"));const s=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return v=v.replace(s,""),`'${v}'`}function E(T,v,s){if(!T)return"";if(!v)return T;v.match(/[\/\\]$/)&&(v=v.slice(0,v.length-1));const S=T.replace(/\\/g,"/").toLowerCase(),y=v.replace(/\\/g,"/").toLowerCase();return S.includes(y)?`~${s}${T.slice(v.length+1)}`:T}function P(T){return T.match(/^['"].*['"]$/)&&(T=T.substring(1,T.length-1)),t.OS===t.OperatingSystem.Windows&&T&&T[1]===":"?T[0].toUpperCase()+T.substring(1):T}function D(T){return!T.strictEnv}}),define(Te[240],Oe([1,0,57,4,7,83]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=D,e.$Gs=s,e.$Hs=S,e.$Is=y;function D($,g){const a=[{name:null,description:(0,E.localize)(2118,null)}];return a.push(...$.map(c=>({name:c.profileName,description:T(c)}))),g&&a.push(...g.map(c=>({name:c.title,description:v(c)}))),{values:a.map(c=>c.name),markdownDescriptions:a.map(c=>c.description)}}function T($){let g=`$(${P.ThemeIcon.isThemeIcon($.icon)?$.icon.id:$.icon?$.icon:t.$0j.terminal.id}) ${$.profileName}
- path: ${$.path}`;return $.args&&(typeof $.args=="string"?g+=`
- args: "${$.args}"`:g+=`
- args: [${$.args.length===0?"":`'${$.args.join("','")}'`}]`),$.overrideName!==void 0&&(g+=`
- overrideName: ${$.overrideName}`),$.color&&(g+=`
- color: ${$.color}`),$.env&&(g+=`
- env: ${JSON.stringify($.env)}`),g}function v($){return`$(${P.ThemeIcon.isThemeIcon($.icon)?$.icon.id:$.icon?$.icon:t.$0j.terminal.id}) ${$.title}
- extensionIdentifier: ${$.extensionIdentifier}`}function s($,g){if(!$&&!g)return!0;if(typeof $=="string"&&typeof g=="string")return $===g;if(Array.isArray($)&&Array.isArray(g)){if($.length!==g.length)return!1;for(let a=0;a<$.length;a++)if($[a]!==g[a])return!1;return!0}return!1}function S($,g){if(!$&&!g)return!0;if(!$||!g)return!1;if(P.ThemeIcon.isThemeIcon($)&&P.ThemeIcon.isThemeIcon(g))return $.id===g.id&&$.color===g.color;if(typeof $=="object"&&"light"in $&&"dark"in $&&typeof g=="object"&&"light"in g&&"dark"in g){const a=$,c=g;if((r.URI.isUri(a.light)||y(a.light))&&(r.URI.isUri(a.dark)||y(a.dark))&&(r.URI.isUri(c.light)||y(c.light))&&(r.URI.isUri(c.dark)||y(c.dark)))return a.light.path===c.light.path&&a.dark.path===c.dark.path}if(r.URI.isUri($)&&r.URI.isUri(g)||y($)||y(g)){const a=$,c=g;return a.path===c.path&&a.scheme===c.scheme}return!1}function y($){return $?typeof $.path=="string"&&typeof $.scheme=="string":!1}}),define(Te[241],Oe([1,0,57,3,7,46,37,53,240]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=e.$Js=void 0,e.$Ls=a,e.$Ms=m,e.$Js={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Ks={type:"string",enum:Array.from((0,t.$8j)(),b=>b.id),markdownEnumDescriptions:Array.from((0,t.$8j)(),b=>`$(${b.id})`)};const s={args:{description:(0,E.localize)(2087,null),type:"array",items:{type:"string"}},overrideName:{description:(0,E.localize)(2088,null),type:"boolean"},icon:{description:(0,E.localize)(2089,null),...e.$Ks},color:{description:(0,E.localize)(2090,null),...e.$Js},env:{markdownDescription:(0,E.localize)(2091,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(2092,null),type:["string","array"],items:{type:"string"}},...s}},y={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(2093,null),type:["string"],items:{type:"string"}},...s}};function $(b){const p=b===r.Platform.Linux?"linux":b===r.Platform.Mac?"osx":"windows";return(0,E.localize)(2094,null,(0,r.$k)(b),'```json\n"terminal.integrated.profile.'+p+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const g={id:"terminal",order:100,title:(0,E.localize)(2095,null),type:"object",properties:{[T.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(2096,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[T.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(2097,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[T.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(2098,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[T.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:$(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,E.localize)(2099,null),enum:["PowerShell","Git Bash"]},...s}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(2100,null),type:"string"},id:{description:(0,E.localize)(2101,null),type:"string"},title:{description:(0,E.localize)(2102,null),type:"string"},...s}},{type:"null"},S]}},[T.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:$(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(2103,null),type:"string"},id:{description:(0,E.localize)(2104,null),type:"string"},title:{description:(0,E.localize)(2105,null),type:"string"},...s}},{type:"null"},S]}},[T.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:$(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(2106,null),type:"string"},id:{description:(0,E.localize)(2107,null),type:"string"},title:{description:(0,E.localize)(2108,null),type:"string"},...s}},{type:"null"},S]}},[T.TerminalSettingId.UseWslProfiles]:{description:(0,E.localize)(2109,null),type:"boolean",default:!0},[T.TerminalSettingId.InheritEnv]:{scope:P.ConfigurationScope.APPLICATION,description:(0,E.localize)(2110,null),type:"boolean",default:!0},[T.TerminalSettingId.PersistentSessionScrollback]:{scope:P.ConfigurationScope.APPLICATION,markdownDescription:(0,E.localize)(2111,null),type:"number",default:100},[T.TerminalSettingId.ShowLinkHover]:{scope:P.ConfigurationScope.APPLICATION,description:(0,E.localize)(2112,null),type:"boolean",default:!0},[T.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,E.localize)(2113,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function a(){D.$xo.as(P.$Co.Configuration).registerConfiguration(g),m()}let c;function m(b,p){const d=D.$xo.as(P.$Co.Configuration);let w;b&&(w=(0,v.$Fs)(b?.profiles,p));const o=c;c={id:"terminal",order:100,title:(0,E.localize)(2114,null),type:"object",properties:{[T.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(2115,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Linux?w?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Linux?w?.markdownDescriptions:void 0},[T.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(2116,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Macintosh?w?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Macintosh?w?.markdownDescriptions:void 0},[T.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(2117,null),type:["string","null"],default:null,enum:b?.os===r.OperatingSystem.Windows?w?.values:void 0,markdownEnumDescriptions:b?.os===r.OperatingSystem.Windows?w?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[c],remove:o?[o]:[]})}}),define(Te[242],Oe([1,0,2,12,118,27,119]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iS=void 0;let T=class extends t.$Zc{constructor(s,S){super(),this.a=s,this.b=S}start(){const s={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:r.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},S=(0,D.$dn)(this.b.args,this.b.isBuilt);S&&(S.break&&S.port?s.debugBrk=S.port:!S.break&&S.port&&(s.debug=S.port));const y=new E.$qr(r.$5g.asFileUri("bootstrap-fork").fsPath,s),$=new t.$Yc;return $.add(y),{client:y,store:$,onDidProcessExit:y.onDidProcessExit}}};e.$iS=T,e.$iS=T=We([je(1,P.$Ri)],T)}),define(Te[243],Oe([1,0,31,12,20,8,3,32,16,10,26,136,97,137]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=a,e.$Vs=c,e.$Ws=m,t=Ve(t),P=Ve(P),T=Ve(T),S=Ve(S);function a(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(t.release());let k=0;return h&&h.length===4&&(k=parseInt(h[3])),k}async function c(h,k,I,O=T.env,C=S.Promises.exists){if(P.$nc(h))return await C(h)?h:void 0;if(k===void 0&&(k=T.cwd()),P.$rc(h)!=="."){const G=P.$oc(k,h);return await C(G)?G:void 0}const R=(0,E.$ro)(O,"PATH");if(I===void 0&&(0,s.$jg)(R)&&(I=R.split(P.$yc)),I===void 0||I.length===0){const G=P.$oc(k,h);return await C(G)?G:void 0}for(const G of I){let Q;if(P.$nc(G)?Q=P.$oc(G,h):Q=P.$oc(k,G,h),await C(Q))return Q;if(D.$l){let te=Q+".com";if(await C(te)||(te=Q+".exe",await C(te)))return te}}const M=P.$oc(k,h);return await C(M)?M:void 0}function m(h,k,I,O,C){const L=D.$l&&(!k.windowsEnableConpty||a()<18309);if(!k.shellIntegration.enabled||!h.executable||h.isFeatureTerminal&&!h.forceShellIntegration||h.ignoreShellIntegration||L)return;const R=h.args,M=T.$ic==="win32"?P.$sc(h.executable).toLowerCase():P.$sc(h.executable),G=P.$rc(r.$5g.asFileUri("").fsPath);let Q;const te={VSCODE_INJECTION:"1"};if(k.shellIntegration.nonce&&(te.VSCODE_NONCE=k.shellIntegration.nonce),D.$l){if(M==="pwsh.exe"||M==="powershell.exe")return!R||i(R)?Q=d.get(p.WindowsPwsh):u(R)&&(Q=d.get(p.WindowsPwshLogin)),Q?(Q=[...Q],Q[Q.length-1]=(0,v.$if)(Q[Q.length-1],G,""),te.VSCODE_STABLE=C.quality==="stable"?"1":"0",k.shellIntegration.suggestEnabled&&(te.VSCODE_SUGGEST="1"),{newArgs:Q,envMixin:te}):void 0;if(M==="bash.exe")return!R||R.length===0?Q=d.get(p.Bash):f(R)&&(te.VSCODE_SHELL_LOGIN="1",b(k,te),Q=d.get(p.Bash)),Q?(Q=[...Q],Q[Q.length-1]=(0,v.$if)(Q[Q.length-1],G),te.VSCODE_STABLE=C.quality==="stable"?"1":"0",{newArgs:Q,envMixin:te}):void 0;O.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args);return}switch(M){case"bash":return!R||R.length===0?Q=d.get(p.Bash):f(R)&&(te.VSCODE_SHELL_LOGIN="1",b(k,te),Q=d.get(p.Bash)),Q?(Q=[...Q],Q[Q.length-1]=(0,v.$if)(Q[Q.length-1],G),te.VSCODE_STABLE=C.quality==="stable"?"1":"0",{newArgs:Q,envMixin:te}):void 0;case"fish":{const ve=I?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",be=P.$oc(G,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return te.XDG_DATA_DIRS=`${ve}:${be}`,b(k,te),{newArgs:void 0,envMixin:te}}case"pwsh":return!R||i(R)?Q=d.get(p.Pwsh):u(R)&&(Q=d.get(p.PwshLogin)),Q?(k.shellIntegration.suggestEnabled&&(te.VSCODE_SUGGEST="1"),Q=[...Q],Q[Q.length-1]=(0,v.$if)(Q[Q.length-1],G,""),te.VSCODE_STABLE=C.quality==="stable"?"1":"0",{newArgs:Q,envMixin:te}):void 0;case"zsh":{if(!R||R.length===0?Q=d.get(p.Zsh):f(R)?(Q=d.get(p.ZshLogin),b(k,te)):(R===d.get(p.Zsh)||R===d.get(p.ZshLogin))&&(Q=R),!Q)return;Q=[...Q],Q[Q.length-1]=(0,v.$if)(Q[Q.length-1],G);let ve;try{ve=t.userInfo().username}catch{ve="unknown"}const be=P.$oc(t.tmpdir(),`${ve}-${C.applicationName}-zsh`);te.ZDOTDIR=be;const le=I?.ZDOTDIR??t.homedir()??"~";te.USER_ZDOTDIR=le;const K=[];return K.push({source:P.$oc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:P.$oc(be,".zshrc")}),K.push({source:P.$oc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:P.$oc(be,".zprofile")}),K.push({source:P.$oc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:P.$oc(be,".zshenv")}),K.push({source:P.$oc(G,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:P.$oc(be,".zlogin")}),{newArgs:Q,envMixin:te,filesToCopy:K}}}O.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args)}function b(h,k){if(D.$m&&h.environmentVariableCollections){const I=(0,$.$Ss)(h.environmentVariableCollections),C=new g.$Ts(I).getVariableMap({workspaceFolder:h.workspaceFolder}).get("PATH"),L=[];if(C)for(const R of C)R.type===y.EnvironmentVariableMutatorType.Prepend&&L.push(R.value);L.length>0&&(k.VSCODE_PATH_PREFIX=L.join(""))}}var p;(function(h){h.WindowsPwsh="windows-pwsh",h.WindowsPwshLogin="windows-pwsh-login",h.Pwsh="pwsh",h.PwshLogin="pwsh-login",h.Zsh="zsh",h.ZshLogin="zsh-login",h.Bash="bash"})(p||(p={}));const d=new Map;d.set(p.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(p.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(p.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(p.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(p.Zsh,["-i"]),d.set(p.ZshLogin,["-il"]),d.set(p.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const w=["-login","-l"],o=["--login","-l"],l=["-i","--interactive"],n=["-nol","-nologo"];function u(h){return typeof h=="string"?w.includes(h.toLowerCase()):h.length===1&&w.includes(h[0].toLowerCase())||h.length===2&&(w.includes(h[0].toLowerCase())||w.includes(h[1].toLowerCase()))&&(n.includes(h[0].toLowerCase())||n.includes(h[1].toLowerCase()))}function i(h){return typeof h=="string"?n.includes(h.toLowerCase()):h.length===0||h?.length===1&&n.includes(h[0].toLowerCase())}function f(h){return typeof h!="string"&&(h=h.filter(k=>!l.includes(k.toLowerCase()))),h==="string"&&o.includes(h.toLowerCase())||typeof h!="string"&&h.length===1&&o.includes(h[0].toLowerCase())}}),define(Te[244],Oe([1,0,23,50,57,8,3,10,26,114,53,243,68]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=m,t=Ve(t),r=Ve(r),v=Ve(v);var g;(function(I){I.UnixShellsPath="/etc/shells"})(g||(g={}));let a,c=!0;function m(I,O,C,L,R=process.env,M,G,Q,te){return M=M||{existsFile:v.SymlinkSupport.existsFile,readFile:t.promises.readFile},D.$l?b(C,M,R,G,L.getValue(S.TerminalSettingId.UseWslProfiles)!==!1,I&&typeof I=="object"?{...I}:L.getValue(S.TerminalSettingId.ProfilesWindows),typeof O=="string"?O:L.getValue(S.TerminalSettingId.DefaultProfileWindows),te,Q):f(M,G,C,I&&typeof I=="object"?{...I}:L.getValue(D.$n?S.TerminalSettingId.ProfilesLinux:S.TerminalSettingId.ProfilesMacOs),typeof O=="string"?O:L.getValue(D.$n?S.TerminalSettingId.DefaultProfileLinux:S.TerminalSettingId.DefaultProfileMacOs),te,Q,R)}async function b(I,O,C,L,R,M,G,Q,te){const ve=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),be=`${process.env.windir}\\${ve?"Sysnative":"System32"}`;let le=!1;(0,y.$Us)()>=16299&&(le=!0),await o(Q);const K=new Map;if(I){K.set("PowerShell",{source:S.ProfileSource.Pwsh,icon:E.$0j.terminalPowershell,isAutoDetected:!0}),K.set("Windows PowerShell",{path:`${be}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:E.$0j.terminalPowershell,isAutoDetected:!0}),K.set("Git Bash",{source:S.ProfileSource.GitBash,isAutoDetected:!0}),K.set("Command Prompt",{path:`${be}\\cmd.exe`,icon:E.$0j.terminalCmd,isAutoDetected:!0}),K.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),K.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:E.$0j.terminalBash,isAutoDetected:!0});const j=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;K.set("Cmder",{path:`${be}\\cmd.exe`,args:["/K",j],requiresPath:process.env.CMDER_ROOT?j:{path:j,isUnsafe:!0},isAutoDetected:!0})}h(M,K);const B=await p(K.entries(),G,O,C,L,te);if(I&&R)try{const j=await u(`${be}\\${le?"wsl":"bash"}.exe`,G);for(const U of j)(!M||!(U.profileName in M))&&B.push(U)}catch{c&&(L?.trace("WSL is not installed, so could not detect WSL profiles"),c=!1)}return B}async function p(I,O,C,L=process.env,R,M){const G=[];for(const[Q,te]of I)G.push(d(Q,te,O,C,L,R,M));return(await Promise.all(G)).filter(Q=>!!Q)}async function d(I,O,C,L,R=process.env,M,G){if(O===null)return;let Q,te,ve;if("source"in O&&!("path"in O)){const B=a?.get(O.source);if(!B)return;Q=B.paths,te=O.args||B.args,O.icon?ve=w(O.icon):B.icon&&(ve=B.icon)}else Q=Array.isArray(O.path)?O.path:[O.path],te=D.$l||Array.isArray(O.args)?O.args:void 0,ve=w(O.icon);let be;if(G){const B=Q.map(U=>typeof U=="string"?U:U.path),j=await G(B);be=new Array(Q.length);for(let U=0;U<Q.length;U++)typeof Q[U]=="string"?be[U]=j[U]:be[U]={path:j[U],isUnsafe:!0}}else be=Q.slice();let le;if(O.requiresPath){let B;if((0,T.$jg)(O.requiresPath)?B=O.requiresPath:(B=O.requiresPath.path,O.requiresPath.isUnsafe&&(le=B)),!await L.existsFile(B))return}const K=await k(I,C,be,L,R,te,O.env,O.overrideName,O.isAutoDetected,le);if(!K){M?.debug("Terminal profile not validated",I,Q);return}return K.isAutoDetected=O.isAutoDetected,K.icon=ve,K.color=O.color,K}function w(I){return typeof I=="string"?{id:I}:I}async function o(I){if(a&&!I)return;const[O,C]=await Promise.all([l(),I||n()]);a=new Map,a.set(S.ProfileSource.GitBash,{profileName:"Git Bash",paths:O,args:["--login","-i"]}),a.set(S.ProfileSource.Pwsh,{profileName:"PowerShell",paths:C,icon:E.$0j.terminalPowershell})}async function l(){const I=new Set,O=await(0,y.$Vs)("git.exe");if(O){const R=(0,$.dirname)(O);I.add((0,$.resolve)(R,"../.."))}function C(R,M){M&&R.add(M)}C(I,process.env.ProgramW6432),C(I,process.env.ProgramFiles),C(I,process.env["ProgramFiles(X86)"]),C(I,`${process.env.LocalAppData}\\Program`);const L=[];for(const R of I)L.push(`${R}\\Git\\bin\\bash.exe`,`${R}\\Git\\usr\\bin\\bash.exe`,`${R}\\usr\\bin\\bash.exe`);return L.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),L.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),L}async function n(){const I=[];for await(const O of(0,s.$Bm)())I.push(O.exePath);return I}async function u(I,O){const C=[],L=await new Promise((G,Q)=>{r.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(te,ve)=>{if(te)return Q("Problem occurred when getting wsl distros");G(ve)})});if(!L)return[];const R=new RegExp(/[\r?\n]/),M=L.split(R).filter(G=>G.trim().length>0&&G!=="");for(const G of M){if(G===""||G.startsWith("docker-desktop"))continue;const Q=`${G} (WSL)`,te={profileName:Q,path:I,args:["-d",`${G}`],isDefault:Q===O,icon:i(G),isAutoDetected:!1};C.push(te)}return C}function i(I){return I.includes("Ubuntu")?E.$0j.terminalUbuntu:I.includes("Debian")?E.$0j.terminalDebian:E.$0j.terminalLinux}async function f(I,O,C,L,R,M,G,Q){const te=new Map;if(C&&await I.existsFile(g.UnixShellsPath)){const ve=(await I.readFile(g.UnixShellsPath)).toString(),be=(M||ve.split(`
`)).map(K=>{const B=K.indexOf("#");return B===-1?K:K.substring(0,B)}).filter(K=>K.trim().length>0),le=new Map;for(const K of be){let B=(0,P.$sc)(K),j=le.get(B)||0;j++,j>1&&(B=`${B} (${j})`),le.set(B,j),te.set(B,{path:K,isAutoDetected:!0})}}return h(L,te),await p(te.entries(),R,I,Q,O,G)}function h(I,O){if(I)for(const[C,L]of Object.entries(I))L===null||typeof L!="object"||!("path"in L)&&!("source"in L)?O.delete(C):(L.icon=L.icon||O.get(C)?.icon,O.set(C,L))}async function k(I,O,C,L,R,M,G,Q,te,ve){if(C.length===0)return Promise.resolve(void 0);const be=C.shift();if(be==="")return k(I,O,C,L,R,M,G,Q,te);const le=typeof be!="string"&&be.isUnsafe,K=typeof be=="string"?be:be.path,B={profileName:I,path:K,args:M,env:G,overrideName:Q,isAutoDetected:te,isDefault:I===O,isUnsafePath:le,requiresUnsafePath:ve};if((0,P.$sc)(K)===K){const U=R.PATH?R.PATH.split(P.$yc):void 0,ee=await(0,y.$Vs)(K,void 0,U,void 0,L.existsFile);return ee?(B.path=ee,B.isFromPath=!0,B):k(I,O,C,L,R,M)}return await L.existsFile((0,P.$mc)(K))?B:k(I,O,C,L,R,M,G,Q,te)}}),define(Te[245],Oe([1,0,6,2,3,51,28,11,126,94,239,53,241,244,117,43]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0;var m;(function(p){p[p.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let b=class extends r.$Zc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(d,w,o,l){super(),this.M=d,this.N=w,this.O=o,this.P=l,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new t.$qe),this.onPtyHostExit=this.u.event,this.w=this.B(new t.$qe),this.onPtyHostStart=this.w.event,this.y=this.B(new t.$qe),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new t.$qe),this.onPtyHostResponsive=this.z.event,this.C=this.B(new t.$qe),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new t.$qe),this.onProcessData=this.D.event,this.F=this.B(new t.$qe),this.onProcessReady=this.F.event,this.G=this.B(new t.$qe),this.onProcessReplay=this.G.event,this.H=this.B(new t.$qe),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new t.$qe),this.onDidRequestDetach=this.I.event,this.J=this.B(new t.$qe),this.onDidChangeProperty=this.J.event,this.L=this.B(new t.$qe),this.onProcessExit=this.L.event,(0,$.$Ls)(),this.B(this.M),this.B((0,r.$Xc)(()=>this.W())),this.j=this.B(new S.$Es(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(t.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(y.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(E.$l)return process.env;try{return await(0,s.$Wm)(this.N,this.O,{_:[]},process.env)}catch(d){return this.O.error("ptyHost was unable to resolve shell environment",d),{}}}U(){const d=this.M.start(),w=d.client;this.O.getLevel()===T.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),P.ProxyChannel.toService(w.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(d.onDidProcessExit(n=>{this.u.fire(n.code),!this.m&&!this.q.isDisposed&&(this.n<=m.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${n.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${n.code}, giving up`))}));const l=P.ProxyChannel.toService(w.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(l.onProcessData(n=>this.D.fire(n))),this.B(l.onProcessReady(n=>this.F.fire(n))),this.B(l.onProcessExit(n=>this.L.fire(n))),this.B(l.onDidChangeProperty(n=>this.J.fire(n))),this.B(l.onProcessReplay(n=>this.G.fire(n))),this.B(l.onProcessOrphanQuestion(n=>this.H.fire(n))),this.B(l.onDidRequestDetach(n=>this.I.fire(n))),this.B(new v.$Ds(this.P,w.getChannel(y.TerminalIpcChannels.Logger))),this.a=d,this.b=l,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async n=>{n.affectsConfiguration(y.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[d,l]}async createProcess(d,w,o,l,n,u,i,f,h,k,I){const O=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),C=await this.f.createProcess(d,w,o,l,n,u,i,f,h,k,I);return clearTimeout(O),C}updateTitle(d,w,o){return this.f.updateTitle(d,w,o)}updateIcon(d,w,o,l){return this.f.updateIcon(d,w,o,l)}attachToProcess(d){return this.f.attachToProcess(d)}detachFromProcess(d,w){return this.f.detachFromProcess(d,w)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(d){return this.f.start(d)}shutdown(d,w){return this.f.shutdown(d,w)}input(d,w){return this.f.input(d,w)}processBinary(d,w){return this.f.processBinary(d,w)}resize(d,w,o){return this.f.resize(d,w,o)}clearBuffer(d){return this.f.clearBuffer(d)}acknowledgeDataEvent(d,w){return this.f.acknowledgeDataEvent(d,w)}setUnicodeVersion(d,w){return this.f.setUnicodeVersion(d,w)}getInitialCwd(d){return this.f.getInitialCwd(d)}getCwd(d){return this.f.getCwd(d)}async getLatency(){const d=new c.$ke,w=await this.f.getLatency();return d.stop(),[{label:"ptyhostservice<->ptyhost",latency:d.elapsed()},...w]}orphanQuestionReply(d){return this.f.orphanQuestionReply(d)}installAutoReply(d,w){return this.f.installAutoReply(d,w)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(d){return this.f.uninstallAutoReply(d)}getDefaultSystemShell(d){return this.g?.getDefaultSystemShell(d)??(0,a.$Fm)(d??E.OS,process.env)}async getProfiles(d,w,o,l=!1){const n=await this.S();return(0,g.$Xs)(w,o,l,this.N,n,void 0,this.O,this.bb.bind(this,d))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(d,w){return this.f.getWslPath(d,w)}getRevivedPtyNewId(d,w){return this.f.getRevivedPtyNewId(d,w)}setTerminalLayoutInfo(d){return this.f.setTerminalLayoutInfo(d)}async getTerminalLayoutInfo(d){return this.g?.getTerminalLayoutInfo(d)}async requestDetachInstance(d,w){return this.f.requestDetachInstance(d,w)}async acceptDetachInstanceReply(d,w){return this.f.acceptDetachInstanceReply(d,w)}async freePortKillProcess(d){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(d)}async serializeTerminalState(d){return this.f.serializeTerminalState(d)}async reviveTerminalProcesses(d,w,o){return this.f.reviveTerminalProcesses(d,w,o)}async refreshProperty(d,w){return this.f.refreshProperty(d,w)}async updateProperty(d,w,o){return this.f.updateProperty(d,w,o)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(d){this.ab(),this.s=setTimeout(()=>this.Y(),d?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(d,w){return this.j.createRequest({workspaceId:d,originalText:w})}async acceptPtyHostResolvedVariables(d,w){this.j.acceptReply(d,w)}};e.$Ys=b,e.$Ys=b=We([je(1,D.$ej),je(2,T.$fk),je(3,T.$gk)],b)}),define(Te[35],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0,e.$Pl=(0,t.$Ki)("IUriIdentityService")}),define(Te[139],Oe([1,0,35,121,15,19,171,6,2]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=void 0;class s{static{this._clock=0}constructor($){this.uri=$,this.time=s._clock++}touch(){return this.time=s._clock++,this}}let S=class{constructor($){this.g=$,this.c=new v.$Yc,this.f=2**16;const g=new Map,a=c=>{let m=g.get(c.scheme);return m===void 0&&(m=$.hasProvider(c)&&!this.g.hasCapability(c,E.FileSystemProviderCapabilities.PathCaseSensitive),g.set(c.scheme,m)),m};this.c.add(T.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(c=>{g.delete(c.scheme)})),this.extUri=new P.$ah(a),this.d=new D.$2s((c,m)=>this.extUri.compare(c,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,P.$mh)($));const g=this.d.get($);return g?g.touch().uri.with({fragment:$.fragment}):(this.d.set($,new s($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((a,c)=>a[1].time<c[1].time?1:a[1].time>c[1].time?-1:0);s._clock=0,this.d.clear();const g=this.f*.5;for(let a=0;a<g;a++)this.d.set($[a][0],$[a][1].touch())}};e.$3s=S,e.$3s=S=We([je(0,E.$fl)],S),(0,r.$Zs)(t.$Pl,S,r.InstantiationType.Delayed)}),define(Te[98],Oe([1,0,7,8,67,19,4,5,12]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$0i=e.$9i=e.$8i=e.$7i=e.$5i=e.$4i=e.WorkbenchState=e.$Xi=e.$Wi=e.$Ti=void 0,e.$Ui=s,e.$Vi=S,e.$Yi=y,e.$Zi=$,e.$1i=g,e.$2i=c,e.$3i=m,e.$6i=d,e.$$i=w,e.$_i=o,e.$bj=l,e.$cj=n,e.$dj=u,e.$Ti=(0,T.$Ki)("contextService");function s(i){const f=i;return typeof f?.id=="string"&&D.URI.isUri(f.uri)}function S(i){return typeof i?.id=="string"&&!s(i)&&!$(i)}e.$Wi={id:"ext-dev"},e.$Xi={id:"empty-window"};function y(i,f){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,r.$sc)(i)}:f?e.$Wi:e.$Xi;const h=i;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}function $(i){const f=i;return typeof f?.id=="string"&&D.URI.isUri(f.configPath)}function g(i){const f=i;if(f?.uri)return{id:f.id,uri:D.URI.revive(f.uri)};const h=i;if(h?.configPath)return{id:h.id,configPath:D.URI.revive(h.configPath)};if(i?.id)return{id:i.id}}var a;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(a||(e.WorkbenchState=a={}));function c(i){const f=i;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}function m(i){const f=i;return!!(f&&typeof f=="object"&&D.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}class b{constructor(f,h,k,I,O){this.h=f,this.j=k,this.k=I,this.l=O,this.c=E.$Qi.forUris(this.l,()=>!0),this.folders=h}update(f){this.h=f.id,this.k=f.configuration,this.j=f.transient,this.l=f.l,this.folders=f.folders}get folders(){return this.g}set folders(f){this.g=f,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(f){this.k=f}getFolder(f){return f&&this.c.findSubstr(f)||null}n(){this.c=E.$Qi.forUris(this.l,()=>!0);for(const f of this.folders)this.c.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$4i=b;class p{constructor(f,h){this.raw=h,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,P.$lh)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$5i=p;function d(i){return new p({uri:i,index:0,name:(0,P.$hh)(i)},{uri:i.toString()})}e.$7i="code-workspace",e.$8i=`.${e.$7i}`,e.$9i=[{name:(0,t.localize)(2489,null),extensions:[e.$7i]}],e.$0i="workspace.json";function w(i,f){return P.$ch.isEqualOrParent(i,f.untitledWorkspacesHome)}function o(i){let f;return D.URI.isUri(i)?f=i:f=i.configuration,f?.scheme===v.Schemas.tmp}e.$aj="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(i){return i.id===e.$aj}function n(i,f){return!w(i,f)&&!o(i)}function u(i){return(typeof i=="string"?(0,r.$tc)(i):(0,P.$jh)(i))===e.$8i}}),define(Te[33],Oe([1,0,66,6,2,19,4,7,27,15,5,11,98,25,35,13,22,16,10]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Rl=e.ProfileResourceType=void 0,e.$Ql=w,e.$Sl=o,e.$Tl=l;var d;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function w(i){const f=i;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&typeof f.isDefault=="boolean"&&typeof f.name=="string"&&D.URI.isUri(f.location)&&D.URI.isUri(f.globalStorageHome)&&D.URI.isUri(f.settingsResource)&&D.URI.isUri(f.keybindingsResource)&&D.URI.isUri(f.tasksResource)&&D.URI.isUri(f.snippetsHome)&&D.URI.isUri(f.extensionsResource))}e.$Rl=(0,S.$Ki)("IUserDataProfilesService");function o(i,f){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:f}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:f}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:f}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:f}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:f}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:f}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:f}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:f}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function l(i,f,h,k,I,O){return{id:i,name:f,location:h,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:O&&I?.useDefaultFlags?.globalState?O.globalStorageHome:(0,P.$lh)(h,"globalStorage"),settingsResource:O&&I?.useDefaultFlags?.settings?O.settingsResource:(0,P.$lh)(h,"settings.json"),keybindingsResource:O&&I?.useDefaultFlags?.keybindings?O.keybindingsResource:(0,P.$lh)(h,"keybindings.json"),tasksResource:O&&I?.useDefaultFlags?.tasks?O.tasksResource:(0,P.$lh)(h,"tasks.json"),snippetsHome:O&&I?.useDefaultFlags?.snippets?O.snippetsHome:(0,P.$lh)(h,"snippets"),extensionsResource:O&&I?.useDefaultFlags?.extensions?O.extensionsResource:(0,P.$lh)(h,"extensions.json"),cacheHome:(0,P.$lh)(k,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}let n=class extends E.$Zc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(f,h,k,I){super(),this.t=f,this.u=h,this.w=k,this.y=I,this.f=!0,this.h=this.B(new r.$qe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$qe),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$qe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$qe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new g.$Fc,workspaces:new g.$Fc,emptyWindows:new Map},this.profilesHome=(0,P.$lh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$lh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(f){this.f!==f&&(this.z=void 0,this.f=f)}isEnabled(){return this.f}get C(){if(!this.z){const f=this.D(),h=[f];if(this.f)try{for(const O of this.O()){if(!O.name||!(0,p.$jg)(O.name)||!O.location){this.y.warn("Skipping the invalid stored profile",O.location||O.name);continue}h.push(l((0,P.$ih)(O.location),O.name,O.location,this.g,{shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags},f))}}catch(O){this.y.error(O)}const k=new g.$Fc,I=new Map;if(h.length)try{const O=this.Q();if(O.workspaces)for(const[C,L]of Object.entries(O.workspaces)){const R=D.URI.parse(C),M=h.find(G=>G.id===L);M&&k.set(R,M)}if(O.emptyWindows)for(const[C,L]of Object.entries(O.emptyWindows)){const R=h.find(M=>M.id===L);R&&I.set(C,R)}}catch(O){this.y.error(O)}this.z={profiles:h,workspaces:k,emptyWindows:I}}return this.z}D(){const f=l("__default__profile__",(0,T.localize)(2442,null),this.t.userRoamingDataHome,this.g);return{...f,extensionsResource:this.S()??f.extensionsResource,isDefault:!0}}async createTransientProfile(f){const h="Temp",k=new RegExp(`${(0,b.$mf)(h)}\\s(\\d+)`);let I=0;for(const C of this.profiles){const L=k.exec(C.name),R=L?parseInt(L[1]):0;I=R>I?R:I}const O=`${h} ${I+1}`;return this.createProfile((0,t.$yj)((0,m.$7g)()).toString(16),O,{transient:!0},f)}async createNamedProfile(f,h,k){return this.createProfile((0,t.$yj)((0,m.$7g)()).toString(16),f,h,k)}async createProfile(f,h,k,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const O=await this.F(f,h,k);return I&&await this.setProfileForWorkspace(I,O),O}async F(f,h,k){if(!(0,p.$jg)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(h);return I||(I=(async()=>{try{if(this.profiles.find(R=>R.name===h||R.id===f))throw new Error(`Profile with ${h} name already exists`);const C=l(f,h,(0,P.$lh)(this.profilesHome,f),this.g,k,this.defaultProfile);await this.u.createFolder(C.location);const L=[];return this.j.fire({profile:C,join(R){L.push(R)}}),await c.Promises.settled(L),this.I([C],[],[]),C}finally{this.r.delete(h)}})(),this.r.set(h,I)),I}async updateProfile(f,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(I=>I.id===f.id);if(!k)throw new Error(`Profile '${f.name}' does not exist`);return k=l(k.id,h.name??k.name,k.location,this.g,{shortName:h.shortName??k.shortName,icon:h.icon===null?void 0:h.icon??k.icon,transient:h.transient??k.isTransient,useDefaultFlags:h.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(f.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(I=>I.id===f.id);if(!h)throw new Error(`Profile '${f.name}' does not exist`);const k=[];this.m.fire({profile:h,join(I){k.push(I)}});try{await Promise.allSettled(k)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(I){(0,s.$wl)(I)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(I)}}async setProfileForWorkspace(f,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(I=>I.id===h.id);if(!k)throw new Error(`Profile '${h.name}' does not exist`);this.L(f,k)}unsetWorkspace(f,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(f,void 0,h)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const f=await this.u.resolve(this.profilesHome);await Promise.all((f.children||[]).filter(h=>h.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const f=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(f.map(h=>this.removeProfile(h)))}getProfileForWorkspace(f){const h=this.G(f),k=D.URI.isUri(h)?this.C.workspaces.get(h):this.C.emptyWindows.get(h);return k||((0,$.$Ui)(f)?this.s.folders.get(f.uri):(0,$.$Zi)(f)?this.s.workspaces.get(f.configPath):this.s.emptyWindows.get(f.id))}G(f){return(0,$.$Ui)(f)?f.uri:(0,$.$Zi)(f)?f.configPath:f.id}H(f){return!!([...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,f.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,f.location))||[...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,f.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,f.location))||[...this.s.folders.values()].some(h=>this.w.extUri.isEqual(h.location,f.location)))}I(f,h,k){const I=[...this.profiles,...f],O=[],C=this.s.profiles;this.s.profiles=[];for(let L of I){if(L.isDefault||h.some(M=>L.id===M.id))continue;L=k.find(M=>L.id===M.id)??L;const R=C.find(M=>L.id===M.id);if(L.isTransient)this.s.profiles.push(L);else{if(R){for(const[M,G]of this.s.emptyWindows.entries())if(L.id===G.id){this.L({id:M},L);break}for(const[M,G]of this.s.workspaces.entries())if(L.id===G.id){this.L({id:"",configPath:M},L);break}for(const[M,G]of this.s.folders.entries())if(L.id===G.id){this.L({id:"",uri:M},L);break}}O.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags})}}this.P(O),this.z=void 0,this.J(f,h,k)}J(f,h,k){this.h.fire({added:f,removed:h,updated:k,all:this.profiles})}L(f,h,k){if(k=h?.isTransient?!0:k,k)(0,$.$Ui)(f)?(this.s.folders.delete(f.uri),h&&this.s.folders.set(f.uri,h)):(0,$.$Zi)(f)?(this.s.workspaces.delete(f.configPath),h&&this.s.workspaces.set(f.configPath,h)):(this.s.emptyWindows.delete(f.id),h&&this.s.emptyWindows.set(f.id,h));else{this.L(f,void 0,!0);const I=this.G(f);D.URI.isUri(I)?(this.C.workspaces.delete(I),h&&this.C.workspaces.set(I,h)):(this.C.emptyWindows.delete(I),h&&this.C.emptyWindows.set(I,h)),this.M()}}M(){const f={};for(const[k,I]of this.C.workspaces.entries())f[k.toString()]=I.id;const h={};for(const[k,I]of this.C.emptyWindows.entries())h[k.toString()]=I.id;this.R({workspaces:f,emptyWindows:h}),this.z=void 0}N(f){const h={},k=this.D();if(f.workspaces)for(const[O,C]of Object.entries(f.workspaces)){const L=D.URI.parse(C);h[O]=this.w.extUri.isEqual(L,k.location)?k.id:this.w.extUri.basename(L)}const I={};if(f.emptyWindows)for(const[O,C]of Object.entries(f.emptyWindows)){const L=D.URI.parse(C);I[O]=this.w.extUri.isEqual(L,k.location)?k.id:this.w.extUri.basename(L)}return{workspaces:h,emptyWindows:I}}O(){return[]}P(f){throw new Error("not implemented")}Q(){return{}}R(f){throw new Error("not implemented")}S(){}};e.$Ul=n,e.$Ul=n=We([je(0,v.$Ri),je(1,s.$fl),je(2,a.$Pl),je(3,y.$fk)],n);class u extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(f){this.a=f}Q(){return this.X}R(f){this.X=f}}e.$Vl=u}),define(Te[99],Oe([1,0,17,13,18,9,6,2,25,3,10,4,7,30,38,21,75,11,29,24,35,33]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Nq=void 0,e.$Oq=n,$=Ve($);let l=class extends T.$Zc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(h,k,I,O,C,L){super(),this.z=h,this.C=k,this.D=I,this.F=O,this.G=C,this.H=L,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$qe),this.s=this.B(new D.$qe),this.t=this.B(new D.$qe),this.u=this.B(new D.$qe),this.w=this.B(new D.$qe),this.y=[],this.B((0,T.$Xc)(()=>{this.j.forEach(({task:R})=>R.cancel()),this.m.forEach(R=>R.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(h){const k=await this.getTargetPlatform();return h.allTargetPlatforms.some(I=>(0,g.$pp)(I,h.allTargetPlatforms,k))}async installFromGallery(h,k={}){try{const O=(await this.installGalleryExtensions([{extension:h,options:k}])).find(({identifier:C})=>(0,a.$Sp)(C,h.identifier));if(O?.local)return O?.local;throw O?.error?O.error:new g.$tp(`Unknown error while installing extension ${h.identifier.id}`,g.ExtensionManagementErrorCode.Unknown)}catch(I){throw n(I)}}async installGalleryExtensions(h){if(!this.z.isEnabled())throw new g.$tp($.localize(1767,null),g.ExtensionManagementErrorCode.NotAllowed);const k=[],I=[];return await Promise.allSettled(h.map(async({extension:O,options:C})=>{try{const L=await this.N(O,!!C?.installGivenVersion,!!C?.installPreReleaseVersion,C.productVersion??{version:this.G.version,date:this.G.date});I.push({...L,options:C})}catch(L){k.push({identifier:O.identifier,operation:g.InstallOperation.Install,source:O,error:L,profileLocation:C.profileLocation??this.W()})}})),I.length&&k.push(...await this.I(I)),k}async uninstall(h,k){return this.F.trace("ExtensionManagementService#uninstall",h.identifier.id),this.uninstallExtensions([{extension:h,options:k}])}async toggleAppliationScope(h,k){if((0,c.$An)(h.manifest)||h.isBuiltin)return h;if(h.isApplicationScoped){let I=await this.updateMetadata(h,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(k,this.H.defaultProfile.extensionsResource)||(I=await this.Z(h,this.H.defaultProfile.extensionsResource,k));for(const O of this.H.profiles){const C=(await this.getInstalled(c.ExtensionType.User,O.extensionsResource)).find(L=>(0,a.$Sp)(L.identifier,h.identifier));C?this.w.fire({local:C,profileLocation:O.extensionsResource}):this.u.fire({identifier:h.identifier,profileLocation:O.extensionsResource})}return I}else{const I=this.D.extUri.isEqual(k,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(h,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(h,k,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:I.identifier,operation:g.InstallOperation.Install,local:I,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),I}}getExtensionsControlManifest(){const h=new Date().getTime();return(!this.g||h-this.h>1e3*60*5)&&(this.g=this.U(),this.h=h),this.g}registerParticipant(h){this.y.push(h)}async resetPinnedStateForAllUserExtensions(h){try{await this.L(this.H.profiles.map(async k=>{const I=await this.getInstalled(c.ExtensionType.User,k.extensionsResource);await this.L(I.map(async O=>{O.pinned!==h&&await this.updateMetadata(O,{pinned:h},k.extensionsResource)}))}))}catch(k){throw this.F.error("Error while resetting pinned state for all user extensions",(0,P.$bb)(k)),k}}async I(h){const k=new Map,I=new Map,O=[],C=(R,M)=>`${a.$Tp.create(R).toString()}-${M.toString()}`,L=(R,M,G,Q)=>{const te=this.X(R,M,G),ve=`${(0,a.$Xp)(R.publisher,R.name)}-${G.profileLocation.toString()}`;I.set(ve,{task:te,root:Q}),this.n.fire({identifier:te.identifier,source:M,profileLocation:G.profileLocation}),this.F.info("Installing extension:",te.identifier.id,G),y.URI.isUri(M)||this.j.set(C(M,G.profileLocation),{task:te,waitingTasks:[]})};try{for(const{manifest:R,extension:M,options:G}of h){const Q=G.isApplicationScoped||G.isBuiltin||(0,c.$An)(R),te={...G,installOnlyNewlyAddedFromExtensionPack:G.installOnlyNewlyAddedFromExtensionPack??!y.URI.isUri(M),isApplicationScoped:Q,profileLocation:Q?this.H.defaultProfile.extensionsResource:G.profileLocation??this.W(),productVersion:G.productVersion??{version:this.G.version,date:this.G.date}},ve=y.URI.isUri(M)?void 0:this.j.get(C(M,te.profileLocation));ve?(this.F.info("Extension is already requested to install",ve.task.identifier.id,te.profileLocation.toString()),O.push(ve.task.waitUntilTaskIsFinished())):L(R,M,te,void 0)}return await Promise.all([...I.values()].map(async({task:R})=>{if(R.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",R.identifier.id);else try{const M=await this.M(R.identifier,R.manifest,!!R.options.installOnlyNewlyAddedFromExtensionPack,!!R.options.installPreReleaseVersion,R.options.profileLocation,R.options.productVersion),G=await this.getInstalled(void 0,R.options.profileLocation,R.options.productVersion),Q={...R.options,context:{...R.options.context,[g.$jp]:!0}};for(const{gallery:te,manifest:ve}of(0,t.$Qb)(M,({gallery:be})=>be.identifier.id)){if(I.has(`${te.identifier.id.toLowerCase()}-${Q.profileLocation.toString()}`))continue;const be=this.j.get(C(te,Q.profileLocation));if(be){if(this.J(R,be.task)){const le=be.task.identifier;this.F.info("Waiting for already requested installing extension",le.id,R.identifier.id,Q.profileLocation.toString()),be.waitingTasks.push(R),O.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,K=>K.some(B=>(0,a.$Sp)(B.identifier,le)))).then(K=>{if(this.F.info("Finished waiting for already requested installing extension",le.id,R.identifier.id,Q.profileLocation.toString()),!K.find(j=>(0,a.$Sp)(j.identifier,le))?.local)throw new Error(`Extension ${le.id} is not installed`)}))}}else G.some(({identifier:le})=>(0,a.$Sp)(le,te.identifier))||L(ve,te,Q,R)}}catch(M){if(y.URI.isUri(R.source))(0,t.$Pb)(R.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",R.identifier.id,M.message),(0,t.$Pb)(R.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",R.identifier.id,M.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",R.identifier.id),M}})),await this.L([...I.entries()].map(async([R,{task:M}])=>{const G=new Date().getTime();let Q;try{Q=await M.run(),await this.L(this.y.map(te=>te.postInstall(Q,M.source,M.options,E.CancellationToken.None)),g.ExtensionManagementErrorCode.PostInstall)}catch(te){const ve=n(te);throw y.URI.isUri(M.source)||u(this.C,M.operation===g.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,a.$1p)(M.source),error:ve,source:M.options.context?.[g.$ip]}),k.set(R,{error:ve,identifier:M.identifier,operation:M.operation,source:M.source,context:M.options.context,profileLocation:M.options.profileLocation,applicationScoped:M.options.isApplicationScoped}),this.F.error("Error while installing the extension",M.identifier.id,(0,P.$bb)(ve),M.options.profileLocation.toString()),ve}if(!y.URI.isUri(M.source)){const te=M.operation===g.InstallOperation.Update,ve=te?void 0:(new Date().getTime()-M.source.lastUpdated)/1e3;if(u(this.C,te?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,a.$1p)(M.source),verificationStatus:M.verificationStatus,duration:new Date().getTime()-G,durationSinceUpdate:ve,source:M.options.context?.[g.$ip]}),s.$r&&M.operation!==g.InstallOperation.Update)try{await this.z.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,g.StatisticType.Install)}catch{}}k.set(R,{local:Q,identifier:M.identifier,operation:M.operation,source:M.source,context:M.options.context,profileLocation:M.options.profileLocation,applicationScoped:Q.isApplicationScoped})})),O.length&&await this.L(O),[...k.values()]}catch(R){const M=(te,ve,be)=>{const le=[];te.manifest.extensionDependencies?.length&&le.push(...te.manifest.extensionDependencies),te.manifest.extensionPack?.length&&le.push(...te.manifest.extensionPack);for(const K of le){if(be.includes(K.toLowerCase()))continue;be.push(K.toLowerCase());const B=k.get(`${K.toLowerCase()}-${ve.toString()}`);B?.local&&(be=M(B.local,ve,be))}return be},G=te=>({identifier:te.identifier,operation:g.InstallOperation.Install,source:te.source,context:te.options.context,profileLocation:te.options.profileLocation,error:R}),Q=[];for(const[te,{task:ve,root:be}]of I){const le=k.get(te);le?le.local&&be&&!k.get(`${be.identifier.id.toLowerCase()}-${ve.options.profileLocation.toString()}`)?.local&&(Q.push(this.Y(le.local,{versionOnly:!0,profileLocation:ve.options.profileLocation})),k.set(te,G(ve))):(ve.cancel(),k.set(te,G(ve)))}for(const[te,{task:ve}]of I){const be=k.get(te);if(!be?.local||ve.options.donotIncludePackAndDependencies)continue;M(be.local,ve.options.profileLocation,[be.local.identifier.id.toLowerCase()]).slice(1).some(K=>I.has(`${K.toLowerCase()}-${ve.options.profileLocation.toString()}`)&&!k.get(`${K.toLowerCase()}-${ve.options.profileLocation.toString()}`)?.local)&&(Q.push(this.Y(be.local,{versionOnly:!0,profileLocation:ve.options.profileLocation})),k.set(te,G(ve)))}throw Q.length&&await Promise.allSettled(Q.map(async te=>{try{await te.run(),this.F.info("Rollback: Uninstalled extension",te.extension.identifier.id)}catch(ve){this.F.warn("Rollback: Error while uninstalling extension",te.extension.identifier.id,(0,P.$bb)(ve))}})),R}finally{for(const{task:R}of I.values())R.source&&!y.URI.isUri(R.source)&&this.j.delete(C(R.source,R.options.profileLocation));if(k.size){const R=[...k.values()];for(const M of R)M.local&&this.F.info("Extension installed successfully:",M.identifier.id,M.profileLocation.toString());this.s.fire(R)}}}J(h,k){for(const[,{task:I,waitingTasks:O}]of this.j.entries())if(I===h&&(O.includes(k)||O.some(C=>this.J(C,k)))||I===k&&O[0]&&!this.J(h,O[0]))return!1;return!0}async L(h,k){const I=[],O=[],C=await Promise.allSettled(h);for(const R of C)R.status==="fulfilled"?I.push(R.value):O.push(n(R.reason,k));if(!O.length)return I;if(O.length===1)throw O[0];let L=new g.$tp("",g.ExtensionManagementErrorCode.Unknown);for(const R of O)L=new g.$tp(L.message?`${L.message}, ${R.message}`:R.message,R.code!==g.ExtensionManagementErrorCode.Unknown&&R.code!==g.ExtensionManagementErrorCode.Internal?R.code:L.code);throw L}async M(h,k,I,O,C,L){if(!this.z.isEnabled())return[];const R=await this.getInstalled(void 0,C,L),M=[],G=[],Q=async(te,ve)=>{M.push(te);const be=ve.extensionDependencies||[],le=[...be];if(ve.extensionPack){const K=I?R.find(B=>(0,a.$Sp)(B.identifier,te)):void 0;for(const B of ve.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(j=>(0,a.$Sp)({id:j},{id:B}))||le.every(j=>!(0,a.$Sp)({id:j},{id:B}))&&le.push(B)}if(le.length){const K=le.filter(B=>M.every(j=>!(0,a.$Sp)(j,{id:B})));if(K.length){const B=await this.z.getExtensions(K.map(j=>({id:j,preRelease:O})),E.CancellationToken.None);for(const j of B){if(M.find(ae=>(0,a.$Sp)(ae,j.identifier)))continue;const U=be.some(ae=>(0,a.$Sp)({id:ae},j.identifier));let ee;try{ee=await this.N(j,!1,O,L)}catch(ae){if(U)throw ae;this.F.info("Skipping the packed extension as it cannot be installed",j.identifier.id,(0,P.$bb)(ae));continue}G.push({gallery:ee.extension,manifest:ee.manifest}),await Q(ee.extension.identifier,ee.manifest)}}}};return await Q(h,k),G}async N(h,k,I,O){let C;const L=await this.getExtensionsControlManifest();if(L.malicious.some(G=>(0,a.$Sp)(h.identifier,G)))throw new g.$tp($.localize(1768,null,h.identifier.id),g.ExtensionManagementErrorCode.Malicious);const R=L.deprecated[h.identifier.id.toLowerCase()];if(R?.extension?.autoMigrate){if(this.F.info(`The '${h.identifier.id}' extension is deprecated, fetching the compatible '${R.extension.id}' extension instead.`),C=(await this.z.getExtensions([{id:R.extension.id,preRelease:R.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:O},E.CancellationToken.None))[0],!C)throw new g.$tp($.localize(1769,null,h.identifier.id,R.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(h)){const G=await this.getTargetPlatform();throw new g.$tp($.localize(1770,null,h.identifier.id,this.G.nameLong,(0,g.$lp)(G)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(C=await this.O(h,k,I,O),!C){const G=[];throw(0,m.$aq)(h.properties.enabledApiProposals??[],G)?!I&&h.properties.isPreReleaseVersion&&(await this.z.getExtensions([h.identifier],E.CancellationToken.None))[0]?new g.$tp($.localize(1772,null,h.displayName??h.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$tp($.localize(1773,null,h.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible):new g.$tp($.localize(1771,null,h.displayName??h.identifier.id,G[0]),g.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",C.identifier.id);const M=await this.z.getManifest(C,E.CancellationToken.None);if(M===null)throw new g.$tp(`Missing manifest for extension ${C.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(M.version!==C.version)throw new g.$tp(`Cannot install '${C.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:C,manifest:M}}async O(h,k,I,O){const C=await this.getTargetPlatform();let L=null;return!k&&h.hasPreReleaseVersion&&h.properties.isPreReleaseVersion!==I&&(L=(await this.z.getExtensions([{...h.identifier,preRelease:I}],{targetPlatform:C,compatible:!0,productVersion:O},E.CancellationToken.None))[0]||null),!L&&await this.z.isExtensionCompatible(h,I,C,O)&&(L=h),L||(k?L=(await this.z.getExtensions([{...h.identifier,version:h.version}],{targetPlatform:C,compatible:!0,productVersion:O},E.CancellationToken.None))[0]||null:L=await this.z.getCompatibleExtension(h,I,C,O)),L}async uninstallExtensions(h){const k=(G,Q)=>`${G.identifier.id.toLowerCase()}${Q.versionOnly?`-${G.manifest.version}`:""}@${Q.profileLocation.toString()}`,I=(G,Q)=>{const te=this.Y(G,Q);return this.m.set(k(te.extension,Q),te),this.F.info("Uninstalling extension from the profile:",`${G.identifier.id}@${G.manifest.version}`,Q.profileLocation.toString()),this.t.fire({identifier:G.identifier,profileLocation:Q.profileLocation,applicationScoped:G.isApplicationScoped}),te},O=(G,Q,te)=>{te?this.F.error("Failed to uninstall extension from the profile:",`${G.identifier.id}@${G.manifest.version}`,Q.profileLocation.toString(),te.message):this.F.info("Successfully uninstalled extension from the profile",`${G.identifier.id}@${G.manifest.version}`,Q.profileLocation.toString()),u(this.C,"extensionGallery:uninstall",{extensionData:(0,a.$Zp)(G),error:te}),this.u.fire({identifier:G.identifier,error:te?.code,profileLocation:Q.profileLocation,applicationScoped:G.isApplicationScoped})},C=[],L=[],R=[],M=new v.$Fc;for(const{extension:G,options:Q}of h){const te={...Q,profileLocation:G.isApplicationScoped?this.H.defaultProfile.extensionsResource:Q?.profileLocation??this.W()},ve=this.m.get(k(G,te));ve?(this.F.info("Extensions is already requested to uninstall",G.identifier.id),R.push(ve.waitUntilTaskIsFinished())):C.push(I(G,te))}try{for(const G of C.slice(0)){let Q=M.get(G.options.profileLocation);if(Q||M.set(G.options.profileLocation,Q=await this.getInstalled(c.ExtensionType.User,G.options.profileLocation)),G.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${G.extension.identifier.id}@${G.extension.manifest.version}`);else{const te=this.R(G.extension,Q);for(const ve of te)this.m.has(k(ve,G.options))?this.F.info("Extensions is already requested to uninstall",ve.identifier.id):C.push(I(ve,G.options))}G.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${G.extension.identifier.id}@${G.extension.manifest.version}`):this.P(C.map(te=>te.extension),Q,G.extension)}await this.L(C.map(async G=>{try{if(await G.run(),await this.L(this.y.map(Q=>Q.postUninstall(G.extension,G.options,E.CancellationToken.None))),G.extension.identifier.uuid)try{await this.z.reportStatistic(G.extension.manifest.publisher,G.extension.manifest.name,G.extension.manifest.version,g.StatisticType.Uninstall)}catch{}}catch(Q){const te=n(Q);throw O(G.extension,G.options,te),te}finally{L.push(G)}})),R.length&&await this.L(R);for(const G of C)O(G.extension,G.options)}catch(G){const Q=n(G);for(const te of C){try{te.cancel()}catch{}L.includes(te)||O(te.extension,te.options,Q)}throw Q}finally{for(const G of C)this.m.delete(k(G.extension,G.options))||this.F.warn("Uninstallation task is not found in the cache",G.extension.identifier.id)}}P(h,k,I){for(const O of h){const C=this.S(O,k);if(C.length){const L=C.filter(R=>!h.some(M=>(0,a.$Sp)(M.identifier,R.identifier)));if(L.length)throw new Error(this.Q(O,L,I))}}}Q(h,k,I){return I===h?k.length===1?$.localize(1774,null,I.manifest.displayName||I.manifest.name,k[0].manifest.displayName||k[0].manifest.name):k.length===2?$.localize(1775,null,I.manifest.displayName||I.manifest.name,k[0].manifest.displayName||k[0].manifest.name,k[1].manifest.displayName||k[1].manifest.name):$.localize(1776,null,I.manifest.displayName||I.manifest.name,k[0].manifest.displayName||k[0].manifest.name,k[1].manifest.displayName||k[1].manifest.name):k.length===1?$.localize(1777,null,I.manifest.displayName||I.manifest.name,h.manifest.displayName||h.manifest.name,k[0].manifest.displayName||k[0].manifest.name):k.length===2?$.localize(1778,null,I.manifest.displayName||I.manifest.name,h.manifest.displayName||h.manifest.name,k[0].manifest.displayName||k[0].manifest.name,k[1].manifest.displayName||k[1].manifest.name):$.localize(1779,null,I.manifest.displayName||I.manifest.name,h.manifest.displayName||h.manifest.name,k[0].manifest.displayName||k[0].manifest.name,k[1].manifest.displayName||k[1].manifest.name)}R(h,k,I=[]){if(I.indexOf(h)!==-1)return[];I.push(h);const O=h.manifest.extensionPack?h.manifest.extensionPack:[];if(O.length){const C=k.filter(R=>!R.isBuiltin&&O.some(M=>(0,a.$Sp)({id:M},R.identifier))),L=[];for(const R of C)L.push(...this.R(R,k,I));return[...C,...L]}return[]}S(h,k){return k.filter(I=>I.manifest.extensionDependencies&&I.manifest.extensionDependencies.some(O=>(0,a.$Sp)({id:O},h.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(h){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,P.$bb)(h)),{malicious:[],deprecated:{},search:[]}}}};e.$Nq=l,e.$Nq=l=We([je(0,g.$rp),je(1,d.$em),je(2,w.$Pl),je(3,b.$fk),je(4,p.$yk),je(5,o.$Rl)],l);function n(f,h){if(f instanceof g.$tp)return f;let k;return f instanceof g.$sp?k=new g.$tp(f.message,f.code===g.ExtensionGalleryErrorCode.DownloadFailedWriting?g.ExtensionManagementErrorCode.DownloadFailedWriting:g.ExtensionManagementErrorCode.Gallery):k=new g.$tp(f.message,(0,P.$8)(f)?g.ExtensionManagementErrorCode.Cancelled:h??g.ExtensionManagementErrorCode.Internal),k.stack=f.stack,k}function u(f,h,{extensionData:k,verificationStatus:I,duration:O,error:C,source:L,durationSinceUpdate:R}){let M,G;(0,S.$rg)(I)&&(I===!0?I="Verified":(I===!1||(M=g.ExtensionManagementErrorCode.Signature,G=I),I="Unverified")),C&&(M=C.code,C.code===g.ExtensionManagementErrorCode.Signature&&(G=C.message)),f.publicLog(h,{...k,verificationStatus:I,success:!C,duration:O,errorcode:M,errorcodeDetail:G,durationSinceUpdate:R,source:L})}class i{constructor(){this.d=new r.$Jh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,r.$xh)(h=>this.h(h))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,r.$xh)(h=>new Promise((k,I)=>{const O=h.onCancellationRequested(()=>{O.dispose(),I(new P.$9)})})),this.d.open()),this.g.cancel()}}e.$Pq=i}),define(Te[54],Oe([1,0,13,14,2,6,25,4,30,38,15,5,11,33,35,10,9,24]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=e.$Qq=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class d extends Error{constructor(u,i){super(u),this.code=i}}e.$Qq=d,e.$Rq=(0,y.$Ki)("IExtensionsProfileScannerService");let w=class extends E.$Zc{constructor(u,i,f,h,k,I){super(),this.j=u,this.m=i,this.n=f,this.r=h,this.s=k,this.t=I,this.b=this.B(new P.$qe),this.onAddExtensions=this.b.event,this.c=this.B(new P.$qe),this.onDidAddExtensions=this.c.event,this.f=this.B(new P.$qe),this.onRemoveExtensions=this.f.event,this.g=this.B(new P.$qe),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Fc}scanProfileExtensions(u,i){return this.u(u,void 0,i)}async addExtensionsToProfile(u,i,f){const h=[],k=[];try{return await this.u(i,I=>{const O=[];if(f)O.push(...I);else for(const C of I)u.some(([L])=>(0,s.$Sp)(L.identifier,C.identifier)&&L.manifest.version!==C.version)?h.push(C):O.push(C);for(const[C,L]of u){const R=O.findIndex(G=>(0,s.$Sp)(G.identifier,C.identifier)&&G.version===C.manifest.version),M={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:L};R===-1?(k.push(M),O.push(M)):O.splice(R,1,M)}return k.length&&this.b.fire({extensions:k,profileLocation:i}),h.length&&this.f.fire({extensions:h,profileLocation:i}),O}),k.length&&this.c.fire({extensions:k,profileLocation:i}),h.length&&this.g.fire({extensions:h,profileLocation:i}),k}catch(I){throw k.length&&this.c.fire({extensions:k,error:I,profileLocation:i}),h.length&&this.g.fire({extensions:h,error:I,profileLocation:i}),I}}async updateMetadata(u,i){const f=[];return await this.u(i,h=>{const k=[];for(const I of h){const O=u.find(([C])=>(0,s.$Sp)(C.identifier,I.identifier)&&C.manifest.version===I.version);O&&(I.metadata={...I.metadata,...O[1]},f.push(I)),k.push(I)}return k}),f}async removeExtensionFromProfile(u,i){const f=[];try{await this.u(i,h=>{const k=[];for(const I of h)(0,s.$Sp)(I.identifier,u.identifier)?f.push(I):k.push(I);return f.length&&this.f.fire({extensions:f,profileLocation:i}),k}),f.length&&this.g.fire({extensions:f,profileLocation:i})}catch(h){throw f.length&&this.g.fire({extensions:f,error:h,profileLocation:i}),h}}async u(u,i,f){return this.F(u).queue(async()=>{let h=[],k;try{const I=await this.m.readFile(u);k=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,S.$wl)(I)!==S.FileOperationResult.FILE_NOT_FOUND)throw I;if(this.r.extUri.isEqual(u,this.n.defaultProfile.extensionsResource)&&(k=await this.D()),!k&&f?.bailOutWhenFileNotFound)throw new d((0,m.$bb)(I),p.ERROR_PROFILE_NOT_FOUND)}if(k){Array.isArray(k)||this.w(u);let I=!1;for(const O of k){o(O)||this.w(u);let C;if((0,c.$jg)(O.relativeLocation)&&O.relativeLocation)C=this.z(O.relativeLocation);else if((0,c.$jg)(O.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${O.location}`);continue}else{C=T.URI.revive(O.location);const L=this.y(C);L&&(I=!0,O.relativeLocation=L)}(0,c.$qg)(O.metadata?.hasPreReleaseVersion)&&O.metadata?.preRelease&&(I=!0,O.metadata.hasPreReleaseVersion=!0),h.push({identifier:O.identifier,location:C,version:O.version,metadata:O.metadata})}I&&await this.m.writeFile(u,r.$Se.fromString(JSON.stringify(k)))}if(i){h=i(h);const I=h.map(O=>({identifier:O.identifier,version:O.version,location:O.location.toJSON(),relativeLocation:this.y(O.location),metadata:O.metadata}));await this.m.writeFile(u,r.$Se.fromString(JSON.stringify(I)))}return h})}w(u){const i=new d(`Invalid extensions content in ${u.toString()}`,p.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(u){return this.r.extUri.isEqual(this.r.extUri.dirname(u),this.j)?this.r.extUri.basename(u):void 0}z(u){return this.r.extUri.joinPath(this.j,u)}async D(){return this.C||(this.C=(async()=>{const u=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let f;try{f=(await this.m.readFile(u)).value.toString()}catch(k){if((0,S.$wl)(k)===S.FileOperationResult.FILE_NOT_FOUND)return;throw k}this.t.info("Migrating extensions from old default profile location",u.toString());let h;try{const k=JSON.parse(f);Array.isArray(k)&&k.every(I=>o(I))?h=k:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",k)}catch(k){this.t.error(k)}if(h)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Se.fromString(JSON.stringify(h)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",u.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(k){if((0,S.$wl)(k)===S.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",u.toString(),this.n.defaultProfile.extensionsResource.toString());else throw k}try{await this.m.del(u)}catch(k){(0,S.$wl)(k)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(k)}try{await this.m.del(i)}catch(k){(0,S.$wl)(k)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(k)}return h})()),this.C}F(u){let i=this.h.get(u);return i||(i=new t.$Rh,this.h.set(u,i)),i}};e.$Sq=w,e.$Sq=w=We([je(1,S.$fl),je(2,g.$Rl),je(3,a.$Pl),je(4,b.$em),je(5,$.$fk)],w);function o(n){return(0,c.$lg)(n)&&(0,v.$qp)(n.identifier)&&(l(n.location)||(0,c.$jg)(n.location)&&n.location)&&((0,c.$qg)(n.relativeLocation)||(0,c.$jg)(n.relativeLocation))&&n.version&&(0,c.$jg)(n.version)}function l(n){return n?(0,c.$jg)(n.path)&&(0,c.$jg)(n.scheme):!1}});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[63],Oe([1,0,17,13,20,14,9,42,190,2,12,8,3,19,62,58,10,4,7,27,38,21,75,15,5,11,29,6,49,54,33,35,203]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d,w,o,l,n,u,i,f,h,k,I,O,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Xq=e.$Wq=e.$Vq=e.Translations=void 0,e.$Yq=ve,E=Ve(E),y=Ve(y),$=Ve($),a=Ve(a),c=$t(c);var R;(function(le){function K(B,j){if(B===j)return!0;const U=Object.keys(B),ee=new Set;for(const ae of Object.keys(j))ee.add(ae);if(U.length!==ee.size)return!1;for(const ae of U){if(B[ae]!==j[ae])return!1;ee.delete(ae)}return ee.size===0}le.equals=K})(R||(e.Translations=R={})),e.$Vq=(0,u.$Ki)("IExtensionsScannerService");let M=class extends s.$Zc{constructor(K,B,j,U,ee,ae,ye,se,ne,X,z,A){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=B,this.r=j,this.s=U,this.t=ee,this.u=ae,this.w=ye,this.y=se,this.z=ne,this.C=X,this.D=z,this.F=A,this.g=this.B(new h.$qe),this.onDidChangeCache=this.g.event,this.h=(0,g.$lh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(Q,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(o.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(o.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,w.$4p)(this.w,this.y)),this.G}async scanAllExtensions(K,B,j){const[U,ee]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(B)]),ae=j?await this.scanExtensionsUnderDevelopment(K,[...U,...ee]):[];return this.L(U,ee,ae,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const B=[];B.push(this.M(!!K.useCache,K.language)),B.push(this.N(K.language,!!K.checkControlFile));const[j,U]=await Promise.all(B);return this.J([...j,...U],o.ExtensionType.System,K,!1)}async scanUserExtensions(K){const B=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",B);const j=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(B,!!K.profileLocation,o.ExtensionType.User,!K.includeUninstalled,K.language,!0,j,K.productVersion??this.R()),ee=K.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let ae;try{ae=await ee.scanExtensions(U)}catch(ye){if(ye instanceof I.$Qq&&ye.code===I.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),ae=await ee.scanExtensions(U);else throw ye}return ae=await this.J(ae,o.ExtensionType.User,K,!0),this.y.trace("Scanned user extensions:",ae.length),ae}async scanExtensionsUnderDevelopment(K,B){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const j=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===S.Schemas.file).map(async U=>{const ee=await this.P(U,!1,o.ExtensionType.User,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ee)).map(ye=>(ye.type=B.find(se=>(0,w.$Sp)(se.identifier,ye.identifier))?.type??ye.type,this.n.validate(ye,ee)))}))).flat();return this.J(j,"development",K,!0)}return[]}async scanExistingExtension(K,B,j){const U=await this.P(K,!1,B,!0,j.language,!0,void 0,j.productVersion??this.R()),ee=await this.n.scanExtension(U);return!ee||!j.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(K,B,j){const U=await this.P(K,!1,B,!0,j.language,!0,void 0,j.productVersion??this.R()),ee=await this.n.scanOneOrMultipleExtensions(U);return this.J(ee,B,j,!0)}async scanMultipleExtensions(K,B,j){const U=[];return await Promise.all(K.map(async ee=>{const ae=await this.scanOneOrMultipleExtensions(ee,B,j);U.push(...ae)})),this.J(U,B,j,!0)}async scanMetadata(K){const B=(0,g.$lh)(K,"package.json"),j=(await this.w.readFile(B)).value.toString();return JSON.parse(j).__metadata}async updateMetadata(K,B){const j=(0,g.$lh)(K,"package.json"),U=(await this.w.readFile(j)).value.toString(),ee=JSON.parse(U);B.isMachineScoped===!1&&delete B.isMachineScoped,B.isBuiltin===!1&&delete B.isBuiltin,ee.__metadata={...ee.__metadata,...B},await this.w.writeFile((0,g.$lh)(K,"package.json"),P.$Se.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof I.$Qq&&K.code===I.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(B=>[B,B.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,P.$Se.fromString(JSON.stringify([])))}catch(B){(0,n.$wl)(B)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$bb)(B))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,B,j,U){return j.includeAllVersions||(K=this.L(B===o.ExtensionType.System?K:void 0,B===o.ExtensionType.User?K:void 0,B==="development"?K:void 0,await this.getTargetPlatform(),U)),j.includeInvalid||(K=K.filter(ee=>ee.isValid)),K.sort((ee,ae)=>{const ye=y.$sc(ee.location.fsPath),se=y.$sc(ae.location.fsPath);return ye<se?-1:ye>se?1:0})}L(K,B,j,U,ee){const ae=(se,ne,X)=>{if(se.isValid&&!ne.isValid)return!1;if(se.isValid===ne.isValid){if(ee&&a.gt(se.manifest.version,ne.manifest.version))return this.y.debug(`Skipping extension ${ne.location.path} with lower version ${ne.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(a.eq(se.manifest.version,ne.manifest.version)){if(se.type===o.ExtensionType.System)return this.y.debug(`Skipping extension ${ne.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===U)return this.y.debug(`Skipping extension ${ne.location.path} from different target platform ${ne.targetPlatform}`),!1}}return X?this.y.warn(`Overwriting user extension ${se.location.path} with ${ne.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${ne.location.path}.`),!0},ye=new o.$zn;return K?.forEach(se=>{const ne=ye.get(se.identifier.id);(!ne||ae(ne,se,!1))&&ye.set(se.identifier.id,se)}),B?.forEach(se=>{const ne=ye.get(se.identifier.id);if(!ne&&K&&se.type===o.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!ne||ae(ne,se,!1))&&ye.set(se.identifier.id,se)}),j?.forEach(se=>{const ne=ye.get(se.identifier.id);(!ne||ae(ne,se,!0))&&ye.set(se.identifier.id,se),ye.set(se.identifier.id,se)}),[...ye.values()]}async M(K,B){this.y.trace("Started scanning system extensions");const j=await this.P(this.systemExtensionsLocation,!1,o.ExtensionType.System,!0,B,!0,void 0,this.R()),ee=await(K&&!j.devMode?this.j:this.n).scanExtensions(j);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(K,B){const j=this.z.isBuilt?[]:this.C.builtInExtensions;if(!j?.length)return[];this.y.trace("Started scanning dev system extensions");const U=B?await this.O():{},ee=[],ae=b.URI.file(y.$mc(y.$oc(S.$5g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of j){const ne=U[se.name]||"marketplace";switch(ne){case"disabled":break;case"marketplace":ee.push((0,g.$lh)(ae,se.name));break;default:ee.push(b.URI.file(ne));break}}const ye=await Promise.all(ee.map(async se=>this.n.scanExtension(await this.P(se,!1,o.ExtensionType.System,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ye.length),(0,t.$Lb)(ye)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,B,j,U,ee,ae,ye,se){const ne=await this.f(ee??$.$z),X=await this.Q(K),z=B&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,A=z?await this.Q(z):void 0;return new G(K,X,z,A,B,ye,j,U,ae,se.version,se.date,this.C.commit,!this.z.isBuilt,ee,ne)}async Q(K){try{const B=await this.w.stat(K);if(typeof B.mtime=="number")return B.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Wq=M,e.$Wq=M=We([je(4,O.$Rl),je(5,I.$Rq),je(6,n.$fl),je(7,i.$fk),je(8,d.$Ri),je(9,f.$yk),je(10,C.$Pl),je(11,u.$Ji)],M);class G{constructor(K,B,j,U,ee,ae,ye,se,ne,X,z,A,Y,pe,x){this.location=K,this.mtime=B,this.applicationExtensionslocation=j,this.applicationExtensionslocationMtime=U,this.profile=ee,this.profileScanOptions=ae,this.type=ye,this.excludeObsolete=se,this.validate=ne,this.productVersion=X,this.productDate=z,this.productCommit=A,this.devMode=Y,this.language=pe,this.translations=x}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,B){return(0,g.$eh)(K.location,B.location)&&K.mtime===B.mtime&&(0,g.$eh)(K.applicationExtensionslocation,B.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&K.profile===B.profile&&E.$oo(K.profileScanOptions,B.profileScanOptions)&&K.type===B.type&&K.excludeObsolete===B.excludeObsolete&&K.validate===B.validate&&K.productVersion===B.productVersion&&K.productDate===B.productDate&&K.productCommit===B.productCommit&&K.devMode===B.devMode&&K.language===B.language&&R.equals(K.translations,B.translations)}}e.$Xq=G;let Q=class extends s.$Zc{constructor(K,B,j,U,ee,ae,ye){super(),this.g=K,this.h=B,this.j=j,this.m=U,this.n=ae,this.r=ye,this.f=ee.extensionsEnabledWithApiProposalVersion?.map(se=>se.toLowerCase())??[]}async scanExtensions(K){const B=K.profile?await this.t(K):await this.s(K);let j={};if(K.excludeObsolete&&K.type===o.ExtensionType.User)try{const U=(await this.m.readFile(this.g)).value.toString();j=JSON.parse(U)}catch{}return(0,m.$wg)(j)?B:B.filter(U=>!j[w.$Tp.create(U).toString()])}async s(K){const B=await this.m.resolve(K.location);if(!B.children?.length)return[];const j=await Promise.all(B.children.map(async U=>{if(!U.isDirectory||K.type===o.ExtensionType.User&&(0,g.$ih)(U.resource).indexOf(".")===0)return null;const ee=new G(U.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(ee)}));return(0,t.$Lb)(j).sort((U,ee)=>U.location.path<ee.location.path?-1:1)}async t(K){let B=await this.u(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.j.extUri.isEqual(K.location,K.applicationExtensionslocation)){B=B.filter(U=>!U.metadata?.isApplicationScoped);const j=await this.u(K.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,K);B.push(...j)}return B}async u(K,B,j){const U=await this.h.scanProfileExtensions(K,j.profileScanOptions);if(!U.length)return[];const ee=await Promise.all(U.map(async ae=>{if(B(ae)){const ye=new G(ae.location,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(ye,ae.metadata)}return null}));return(0,t.$Lb)(ee)}async scanOneOrMultipleExtensions(K){try{if(await this.m.exists((0,g.$lh)(K.location,"package.json"))){const B=await this.scanExtension(K);return B?[B]:[]}else return await this.scanExtensions(K)}catch(B){return this.r.error(`Error scanning extensions at ${K.location.path}:`,(0,D.$bb)(B)),[]}}async scanExtension(K,B){try{let j=await this.w(K.location);if(j){j.publisher||(j.publisher=o.$tn),B=B??j.__metadata,delete j.__metadata;const U=(0,w.$Xp)(j.publisher,j.name),ee=B?.id?{id:U,uuid:B.id}:{id:U},ae=B?.isSystem?o.ExtensionType.System:K.type,ye=ae===o.ExtensionType.System||!!B?.isBuiltin;j=await this.y(K.location,j,G.createNlsConfiguration(K));let se={type:ae,identifier:ee,manifest:j,location:K.location,isBuiltin:ye,targetPlatform:B?.targetPlatform??o.TargetPlatform.UNDEFINED,publisherDisplayName:B?.publisherDisplayName,metadata:B,isValid:!0,validations:[]};return K.validate&&(se=this.validate(se,K)),j.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(U.toLowerCase()))&&(j.originalEnabledApiProposals=j.enabledApiProposals,j.enabledApiProposals=(0,o.$Fn)([...j.enabledApiProposals])),se}}catch(j){K.type!==o.ExtensionType.System&&this.r.error(j)}return null}validate(K,B){let j=!0;const U=this.n.isBuilt&&this.f.includes(K.identifier.id.toLowerCase()),ee=(0,l.$0p)(B.productVersion,B.productDate,B.location,K.manifest,K.isBuiltin,U);for(const[ae,ye]of ee)ae===c.default.Error&&(j=!1,this.r.error(this.F(B.location,ye)));return K.isValid=j,K.validations=ee,K}async w(K){const B=(0,g.$lh)(K,"package.json");let j;try{j=(await this.m.readFile(B)).value.toString()}catch(ee){return(0,n.$wl)(ee)!==n.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(K,(0,p.localize)(1815,null,B.path,ee.message))),null}let U;try{U=JSON.parse(j)}catch{const ae=[];(0,T.$5n)(j,ae);for(const ye of ae)this.r.error(this.F(K,(0,p.localize)(1816,null,B.path,ye.offset,ye.length,(0,v.$Tq)(ye.error))));return null}return(0,T.$ao)(U)!=="object"?(this.r.error(this.F(K,(0,p.localize)(1817,null,B.path))),null):U}async y(K,B,j){const U=await this.z(K,B,j);if(U)try{const ee=[],ae=await this.C(U.default,ee);if(ee.length>0)return ee.forEach(se=>{this.r.error(this.F(K,(0,p.localize)(1818,null,U.default?.path,(0,v.$Tq)(se.error))))}),B;if((0,T.$ao)(U)!=="object")return this.r.error(this.F(K,(0,p.localize)(1819,null,U.default?.path))),B;const ye=U.values||Object.create(null);return(0,L.$Uq)(this.r,B,ye,ae)}catch{}return B}async z(K,B,j){const U=(0,g.$lh)(K,"package.nls.json"),ee=(ne,X)=>{X.forEach(z=>{this.r.error(this.F(K,(0,p.localize)(1820,null,ne?.path,(0,v.$Tq)(z.error))))})},ae=ne=>{this.r.error(this.F(K,(0,p.localize)(1821,null,ne?.path)))},ye=`${B.publisher}.${B.name}`,se=j.translations[ye];if(se)try{const ne=b.URI.file(se),X=(await this.m.readFile(ne)).value.toString(),z=[],A=(0,T.$5n)(X,z);return z.length>0?(ee(ne,z),{values:void 0,default:U}):(0,T.$ao)(A)!=="object"?(ae(ne),{values:void 0,default:U}):{values:A.contents?A.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.m.exists(U))return;let X;try{X=await this.D(K,j)}catch{return}if(!X.localized)return{values:void 0,default:X.original};try{const z=(await this.m.readFile(X.localized)).value.toString(),A=[],Y=(0,T.$5n)(z,A);return A.length>0?(ee(X.localized,A),{values:void 0,default:X.original}):(0,T.$ao)(Y)!=="object"?(ae(X.localized),{values:void 0,default:X.original}):{values:Y,default:X.original}}catch{return{values:void 0,default:X.original}}}}async C(K,B){if(K)try{const j=(await this.m.readFile(K)).value.toString();return(0,T.$5n)(j,B)}catch{}}D(K,B){return new Promise((j,U)=>{const ee=ae=>{const ye=(0,g.$lh)(K,`package.nls.${ae}.json`);this.m.exists(ye).then(se=>{se&&j({localized:ye,original:(0,g.$lh)(K,"package.nls.json")});const ne=ae.lastIndexOf("-");ne===-1?j({localized:(0,g.$lh)(K,"package.nls.json"),original:null}):(ae=ae.substring(0,ne),ee(ae))})};if(B.devMode||B.pseudo||!B.language)return j({localized:(0,g.$lh)(K,"package.nls.json"),original:null});ee(B.language)})}F(K,B){return`[${K.path}]: ${B}`}};Q=We([je(1,I.$Rq),je(2,C.$Pl),je(3,n.$fl),je(4,f.$yk),je(5,d.$Ri),je(6,i.$fk)],Q);let te=class extends Q{constructor(K,B,j,U,ee,ae,ye,se,ne){super(B,U,ee,ae,ye,se,ne),this.J=K,this.L=j,this.H=this.B(new r.$Ih(3e3)),this.I=this.B(new h.$qe),this.onDidChangeCache=this.I.event}async scanExtensions(K){const B=this.P(K),j=await this.M(B);if(this.G=K,j&&j.input&&G.equals(j.input,this.G))return this.r.debug("Using cached extensions scan result",K.type===o.ExtensionType.System?"system":"user",K.location.toString()),this.H.trigger(()=>this.O()),j.result.map(ee=>(ee.location=b.URI.revive(ee.location),ee));const U=await super.scanExtensions(K);return await this.N(B,{input:K,result:U}),U}async M(K){try{const B=await this.m.readFile(K),j=JSON.parse(B.value.toString());return{result:j.result,input:(0,k.$hi)(j.input)}}catch(B){this.r.debug("Error while reading the extension cache file:",K.path,(0,D.$bb)(B))}return null}async N(K,B){try{await this.m.writeFile(K,P.$Se.fromString(JSON.stringify(B)))}catch(j){this.r.debug("Error while writing the extension cache file:",K.path,(0,D.$bb)(j))}}async O(){if(!this.G)return;const K=this.P(this.G),B=await this.M(K);if(!B)return;const j=B.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!E.$oo(U,j))try{this.r.info("Invalidating Cache",j,U),await this.m.del(K),this.I.fire()}catch(ee){this.r.error(ee)}}P(K){const B=this.Q(K);return this.j.extUri.joinPath(B.cacheHome,K.type===o.ExtensionType.System?o.$sn:o.$rn)}Q(K){return K.type===o.ExtensionType.System?this.L.defaultProfile:K.profile?this.j.extUri.isEqual(K.location,this.J.extensionsResource)?this.J:this.L.profiles.find(B=>this.j.extUri.isEqual(K.location,B.extensionsResource))??this.J:this.L.defaultProfile}};te=We([je(2,O.$Rl),je(3,I.$Rq),je(4,C.$Pl),je(5,n.$fl),je(6,f.$yk),je(7,d.$Ri),je(8,i.$fk)],te);function ve(le,K){const B=(0,w.$Vp)(le.manifest.publisher,le.manifest.name);return{id:B,identifier:new o.$xn(B),isBuiltin:le.type===o.ExtensionType.System,isUserBuiltin:le.type===o.ExtensionType.User&&le.isBuiltin,isUnderDevelopment:K,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class be extends M{constructor(K,B,j,U,ee,ae,ye,se,ne,X,z,A){super(K,B,(0,g.$lh)(j,".vscode-oss-dev","extensions","control.json"),U,ee,ae,ye,se,ne,X,z,A),this.S=(async()=>{if($.$C)try{const Y=await this.w.readFile(b.URI.file($.$C));return JSON.parse(Y.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$Zq=be}),define(Te[246],Oe([1,0,50,13,45,6,2,12,8,26,11,33]),function(ue,e,t,r,E,P,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;let $=class extends D.$Zc{constructor(a,c){super(),this.b=a,this.f=c,this.a=new r.$Qh(5)}async postUninstall(a){const c=this.g(a,"uninstall");c&&(this.f.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(c.script,"uninstall",c.args,!0,a),this.f.info("Finished running post uninstall script",a.identifier.id,a.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",a.identifier.id,a.manifest.version),this.f.error(m)}}));try{await s.Promises.rm(this.m(a))}catch(m){this.f.error("Error while removing extension storage path",a.identifier.id),this.f.error(m)}}g(a,c){const m=`vscode:${c}`;if(a.location.scheme===T.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[m]=="string"){const b=a.manifest.scripts[m].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.f.warn(a.identifier.id,a.manifest.version,`${m} should be a node script`),null):{script:(0,v.$oc)(a.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}h(a,c,m,b,p){return new Promise((d,w)=>{const o=this.j(a,c,m,p);let l;const n=u=>{l&&(clearTimeout(l),l=null),u?w(u):d(void 0)};o.on("error",u=>{n((0,E.$vj)(u)||"Unknown")}),o.on("exit",(u,i)=>{n(u?`post-${c} process exited with code ${u}`:void 0)}),b&&(l=setTimeout(()=>{l=null,o.kill(),w("timed out")},5e3))})}j(a,c,m,b){const p={silent:!0,execArgv:void 0},d=(0,t.fork)(a,[`--type=extension-post-${c}`,...m],p);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const w=P.Event.fromNodeEventEmitter(d.stdout,"data"),o=P.Event.fromNodeEventEmitter(d.stderr,"data");this.B(w(u=>this.f.info(b.identifier.id,b.manifest.version,`post-${c}`,u))),this.B(o(u=>this.f.error(b.identifier.id,b.manifest.version,`post-${c}`,u)));const l=P.Event.any(P.Event.map(w,u=>({data:`%c${u}`,format:[""]}),this.q),P.Event.map(o,u=>({data:`%c${u}`,format:["color: red"]}),this.q));return P.Event.debounce(l,(u,i)=>u?{data:u.data+i.data,format:[...u.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(u=>{console.group(b.identifier.id),console.log(u.data,...u.format),console.groupEnd()}),d}m(a){return(0,v.$oc)(this.b.defaultProfile.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};e.$4q=$,e.$4q=$=We([je(0,y.$Rl),je(1,S.$fk)],$)}),define(Te[140],Oe([1,0,87,7,99,30]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=D,e.$2q=T;function D(v){let s=P.ExtensionManagementErrorCode.Extract;return v instanceof t.$Jq&&(v.type==="CorruptZip"?s=P.ExtensionManagementErrorCode.CorruptZip:v.type==="Incomplete"&&(s=P.ExtensionManagementErrorCode.IncompleteZip)),(0,E.$Oq)(v,s)}async function T(v){let s;try{s=await(0,t.$Mq)(v,"extension/package.json")}catch(S){throw D(S)}try{return JSON.parse(s.toString("utf8"))}catch{throw new P.$tp((0,r.localize)(1831,null),P.ExtensionManagementErrorCode.Invalid)}}}),define(Te[247],Oe([1,0,13,9,2,12,19,62,10,22,26,87,28,27,99,30,38,140,95,15,11,24]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d,w,o){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0,T=Ve(T);let n=class extends E.$Zc{static{l=this}static{this.c=".sigzip"}constructor(i,f,h,k,I,O,C){super(),this.h=f,this.j=h,this.m=k,this.n=I,this.r=O,this.t=C,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,f,h,k){await this.g;const I=await this.w(i,f);let O=!1;if(h&&this.u(i)){let C;try{C=await this.y(i)}catch(L){try{await this.delete(I)}catch(R){this.t.error(R)}throw L}try{O=await this.n.verify(i,I.fsPath,C.fsPath,k)}catch(L){if(O=L.code,O===p.ExtensionSignatureVerificationCode.PackageIsInvalidZip||O===p.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(I)}catch(R){this.t.error(R)}throw new c.$tp(y.$Iq,c.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(C)}catch(L){this.t.error(L)}}}return{location:I,verificationStatus:O}}u(i){if(!i.isSigned)return this.t.info(`Extension is not signed: ${i.identifier.id}`),!1;const f=this.m.getValue("extensions.verifySignature");return(0,v.$pg)(f)?f:!0}async w(i,f){try{const h=(0,D.$lh)(this.extensionsDownloadDir,this.G(i)),k=await this.C(i,"vsix",async()=>{await this.z(i,h,I=>this.j.download(i,I,f));try{await this.D(h.fsPath,"extension/package.json")}catch(I){try{await this.h.del(h)}catch(O){this.t.warn(`Error while deleting: ${h.path}`,(0,r.$bb)(O))}throw I}},2);return k>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:k}),h}catch(h){throw(0,a.$Oq)(h,c.ExtensionManagementErrorCode.Download)}}async y(i){try{const f=(0,D.$lh)(this.extensionsDownloadDir,`.${(0,s.$7g)()}`),h=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,f);try{await this.D(f.fsPath,".signature.p7s")}catch(k){try{await this.h.del(f)}catch(I){this.t.warn(`Error while deleting: ${f.path}`,(0,r.$bb)(I))}throw k}},2);return h>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:h}),f}catch(f){throw(0,a.$Oq)(f,c.ExtensionManagementErrorCode.DownloadSignature)}}async z(i,f,h){if(await this.h.exists(f))return;if(f.scheme!==P.Schemas.file){await h(f);return}const k=(0,D.$lh)(this.extensionsDownloadDir,`.${(0,s.$7g)()}`);try{await h(k)}catch(I){try{await this.h.del(k)}catch{}throw I}try{await S.Promises.rename(k.fsPath,f.fsPath,2*60*1e3)}catch(I){try{await this.h.del(k)}catch{}let O=!1;try{O=await this.h.exists(f)}catch{}if(O)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,f.path);else throw this.t.info(`Rename failed because of ${(0,r.$bb)(I)}. Deleted the file from downloaded location`,k.path),I}}async C(i,f,h,k){let I=1;for(;;)try{return await h(),I}catch(O){if(I++>k)throw O;this.t.warn(`Failed downloading ${f}. ${(0,r.$bb)(O)}. Retry again...`,i.identifier.id)}}async D(i,f){try{await(0,y.$Mq)(i,f)}catch(h){throw(0,b.$1q)(h)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const f=[],h=[],k=[];for(const C of i.children)if(C.name.endsWith(l.c))k.push(C.resource);else{const L=m.$Tp.parse(C.name);L&&h.push([L,C])}const I=(0,m.$Yp)(h,([C])=>C),O=[];for(const C of I)C.sort((L,R)=>T.rcompare(L[0].version,R[0].version)),f.push(...C.slice(1).map(L=>L[1].resource)),O.push(C[0][1]);O.sort((C,L)=>C.mtime-L.mtime),f.push(...O.slice(0,Math.max(0,O.length-this.f)).map(C=>C.resource)),f.push(...k),await t.Promises.settled(f.map(C=>(this.t.trace("Deleting from cache",C.path),this.h.del(C))))}}catch(i){this.t.error(i)}}G(i){return this.f?m.$Tp.create(i).toString().toLowerCase():(0,s.$7g)()}};e.$3q=n,e.$3q=n=l=We([je(0,g.$Si),je(1,d.$fl),je(2,c.$rp),je(3,$.$ej),je(4,p.$Bq),je(5,o.$em),je(6,w.$fk)],n)}),define(Te[141],Oe([1,0,23,13,14,18,45,9,6,66,2,25,12,8,19,62,10,4,22,26,87,7,88,27,99,30,38,54,63,247,246,140,224,233,21,75,15,5,11,29,24,35,33]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d,w,o,l,n,u,i,f,h,k,I,O,C,L,R,M,G,Q,te,ve,be,le,K,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=void 0,t=Ve(t),g=Ve(g),c=Ve(c),d=Ve(d),o=Ve(o),e.$7q=(0,te.$Li)(i.$up);const j=".vsctmp";let U=class extends u.$Nq{constructor(ne,X,z,A,Y,pe,x,ie,W,Z,ce,we){super(ne,X,ce,z,Z,we),this.db=Y,this.eb=pe,this.fb=x,this.gb=ie,this.hb=W,this.cb=new Map,this.sb=new y.$Gc;const Le=this.B(ie.createInstance(O.$4q));this.$=this.B(ie.createInstance(ee,qe=>Le.postUninstall(qe))),this.ab=this.B(new L.$5q(we,W,ce,this,this.F)),this.bb=this.B(ie.createInstance(I.$3q));const ze=this.B(new R.$6q(this,this.db,we,pe,ce,W,z));this.B(ze.onDidChangeExtensionsByAnotherSource(qe=>this.rb(qe))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,f.$4p)(this.hb,this.F)),this.ib}async zip(ne){this.F.trace("ExtensionManagementService#zip",ne.identifier.id);const X=await this.qb(ne),z=await(0,w.zip)((0,a.$lh)(this.bb.extensionsDownloadDir,(0,p.$7g)()).fsPath,X);return b.URI.file(z)}async getManifest(ne){const{location:X,cleanup:z}=await this.kb(ne),A=g.$pc(X.fsPath);try{return await(0,C.$2q)(A)}finally{await z()}}getInstalled(ne,X=this.H.defaultProfile.extensionsResource,z={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(ne??null,X,z)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(ne){return this.$.scanUserExtensionAtLocation(ne)}async install(ne,X={}){this.F.trace("ExtensionManagementService#install",ne.toString());const{location:z,cleanup:A}=await this.kb(ne);try{const Y=await(0,C.$2q)(g.$pc(z.fsPath)),pe=(0,f.$Xp)(Y.publisher,Y.name);if(Y.engines&&Y.engines.vscode&&!(0,G.$_p)(Y.engines.vscode,this.G.version,this.G.date))throw new Error(o.localize(1822,null,pe,this.G.version));const ie=(await this.I([{manifest:Y,extension:z,options:X}])).find(({identifier:W})=>(0,f.$Sp)(W,{id:pe}));if(ie?.local)return ie.local;throw ie?.error?ie.error:(0,u.$Oq)(new Error(`Unknown error while installing extension ${pe}`))}finally{await A()}}async installFromLocation(ne,X){this.F.trace("ExtensionManagementService#installFromLocation",ne.toString());const z=await this.$.scanUserExtensionAtLocation(ne);if(!z||!z.manifest.name||!z.manifest.version)throw new Error(`Cannot find a valid extension from the location ${ne.toString()}`);return await this.vb([[z,{source:"resource"}]],X),this.F.info("Successfully installed extension",z.identifier.id,X.toString()),z}async installExtensionsFromProfile(ne,X,z){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",ne,X.toString(),z.toString());const A=(await this.getInstalled(M.ExtensionType.User,X)).filter(Y=>ne.some(pe=>(0,f.$Sp)(pe,Y.identifier)));if(A.length){const Y=await Promise.all(A.map(pe=>this.$.scanMetadata(pe,X)));await this.vb(A.map((pe,x)=>[pe,Y[x]]),z),this.F.info("Successfully installed extensions",A.map(pe=>pe.identifier.id),z.toString())}return A}async updateMetadata(ne,X,z){return this.F.trace("ExtensionManagementService#updateMetadata",ne.identifier.id),X.isPreReleaseVersion&&(X.preRelease=!0,X.hasPreReleaseVersion=!0),X.isMachineScoped===!1&&(X.isMachineScoped=void 0),X.isBuiltin===!1&&(X.isBuiltin=void 0),X.pinned===!1&&(X.pinned=void 0),ne=await this.$.updateMetadata(ne,X,z),this.ab.invalidate(z),this.w.fire({local:ne,profileLocation:z}),ne}async reinstallFromGallery(ne){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",ne.identifier.id),!this.z.isEnabled())throw new Error(o.localize(1823,null));const X=await this.getTargetPlatform(),[z]=await this.z.getExtensions([{...ne.identifier,preRelease:ne.preRelease}],{targetPlatform:X,compatible:!0},P.CancellationToken.None);if(!z)throw new Error(o.localize(1824,null));await this.$.setUninstalled(ne);try{await this.$.removeUninstalledExtension(ne)}catch(A){throw new Error(o.localize(1825,null,(0,D.$vj)(A)))}return this.installFromGallery(z)}Z(ne,X,z,A){return this.$.copyExtension(ne,X,z,A)}copyExtensions(ne,X){return this.$.copyExtensions(ne,X,{version:this.G.version,date:this.G.date})}markAsUninstalled(...ne){return this.$.setUninstalled(...ne)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(ne){this.F.error(ne)}}async download(ne,X,z){const{location:A}=await this.bb.download(ne,X,!z);return A}async kb(ne){if(ne.scheme===$.Schemas.file)return{location:ne,async cleanup(){}};this.F.trace("Downloading extension from",ne.toString());const X=(0,a.$lh)(this.bb.extensionsDownloadDir,(0,p.$7g)());return await this.fb.download(ne,X),this.F.info("Downloaded extension to",X.toString()),{location:X,cleanup:async()=>{try{await this.hb.del(X)}catch(A){this.F.error(A)}}}}W(){return this.H.defaultProfile.extensionsResource}X(ne,X,z){const A=X instanceof b.URI?new f.$Tp({id:(0,f.$Xp)(ne.publisher,ne.name)},ne.version):f.$Tp.create(X);return this.gb.createInstance(ae,A,ne,X,z,(Y,pe)=>{if(X instanceof b.URI)return this.pb(A,X,z,pe);let x=this.cb.get(A.toString());return x||(this.cb.set(A.toString(),x=this.ob(A,X,Y,z,pe)),x.finally(()=>this.cb.delete(A.toString()))),x},this.$)}Y(ne,X){return new ye(ne,X,this.eb)}async ob(ne,X,z,A,Y){const{verificationStatus:pe,location:x}=await this.bb.download(X,z,!A.donotVerifySignature,A.context?.[i.$kp]);try{if(Y.isCancellationRequested)throw new T.$9;const ie=await(0,C.$2q)(x.fsPath);if(!new f.$Tp(X.identifier,X.version).equals(new f.$Tp({id:(0,f.$Xp)(ie.publisher,ie.name)},ie.version)))throw new i.$tp(o.localize(1826,null,X.identifier.id),i.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(ne,x.fsPath,{id:X.identifier.uuid,publisherId:X.publisherId,publisherDisplayName:X.publisherDisplayName,targetPlatform:X.properties.targetPlatform,isApplicationScoped:A.isApplicationScoped,isMachineScoped:A.isMachineScoped,isBuiltin:A.isBuiltin,isPreReleaseVersion:X.properties.isPreReleaseVersion,hasPreReleaseVersion:X.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:A.installGivenVersion?!0:!!A.pinned,preRelease:(0,m.$pg)(A.preRelease)?A.preRelease:A.installPreReleaseVersion||X.properties.isPreReleaseVersion,source:"gallery"},!1,Y),verificationStatus:pe}}catch(ie){try{await this.bb.delete(x)}catch(W){this.F.warn("Error while deleting the downloaded file",x.toString(),(0,T.$bb)(W))}throw(0,u.$Oq)(ie)}}async pb(ne,X,z,A){return{local:await this.$.extractUserExtension(ne,g.$pc(X.fsPath),{isApplicationScoped:z.isApplicationScoped,isMachineScoped:z.isMachineScoped,isBuiltin:z.isBuiltin,installedTimestamp:Date.now(),pinned:z.installGivenVersion?!0:!!z.pinned,source:"vsix"},z.keepExisting??!0,A)}}async qb(ne){const X=async A=>{let Y=await d.Promises.readdir(A);Y=Y.map(ie=>g.$oc(A,ie));const pe=await Promise.all(Y.map(ie=>t.promises.stat(ie)));let x=Promise.resolve([]);return pe.forEach((ie,W)=>{const Z=Y[W];ie.isFile()&&(x=x.then(ce=>[...ce,Z])),ie.isDirectory()&&(x=x.then(ce=>X(Z).then(we=>[...ce,...we])))}),x};return(await X(ne.location.fsPath)).map(A=>({path:`extension/${g.$qc(ne.location.fsPath,A)}`,localPath:A}))}async rb({added:ne,removed:X}){if(X){const z=ne&&this.D.extUri.isEqual(X.profileLocation,ne.profileLocation)?X.extensions.filter(A=>ne.extensions.every(Y=>!(0,f.$Sp)(Y,A))):X.extensions;for(const A of z)this.F.info("Extensions removed from another source",A.id,X.profileLocation.toString()),this.u.fire({identifier:A,profileLocation:X.profileLocation})}if(ne){const A=(await this.getInstalled(M.ExtensionType.User,ne.profileLocation)).filter(Y=>ne.extensions.some(pe=>(0,f.$Sp)(pe,Y.identifier)));this.s.fire(A.map(Y=>(this.F.info("Extensions added from another source",Y.identifier.id,ne.profileLocation.toString()),{identifier:Y.identifier,local:Y,profileLocation:ne.profileLocation,operation:i.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(X=>this.sb.add(X)));const ne=await this.hb.resolve(this.db.userExtensionsLocation);for(const X of ne.children??[])X.isDirectory&&this.sb.add(X.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(X=>this.ub(X)))}async ub(ne){if(!ne.affects(this.db.userExtensionsLocation,Q.FileChangeType.ADDED))return;const X=[];for(const z of ne.rawAdded){if(this.sb.has(z)||!this.D.extUri.isEqual(this.D.extUri.dirname(z),this.db.userExtensionsLocation)||this.D.extUri.isEqual(z,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(z).startsWith(".")||!(await this.hb.stat(z)).isDirectory)continue;const A=await this.$.scanUserExtensionAtLocation(z);A&&A.installedTimestamp===void 0&&(this.sb.add(z),X.push(A))}X.length&&(await this.vb(X.map(z=>[z,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",X.map(z=>z.identifier.id)))}async vb(ne,X){const z=ne.map(A=>A[0]);await this.wb(z),await this.eb.addExtensionsToProfile(ne,X),this.s.fire(z.map(A=>({local:A,identifier:A.identifier,operation:i.InstallOperation.None,profileLocation:X})))}async wb(ne){const X=await this.$.getUninstalledExtensions();for(const z of ne){const A=f.$Tp.create(z);X[A.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",A.id),await this.$.setInstalled(A),this.F.info("Removed the extension from uninstalled list:",A.id))}}};e.$8q=U,e.$8q=U=We([je(0,i.$rp),je(1,le.$em),je(2,ve.$fk),je(3,n.$Si),je(4,k.$Vq),je(5,h.$Rq),je(6,l.$8o),je(7,te.$Ji),je(8,Q.$fl),je(9,be.$yk),je(10,K.$Pl),je(11,B.$Rl)],U);let ee=class extends S.$Zc{constructor(ne,X,z,A,Y,pe,x){super(),this.n=ne,this.s=X,this.t=z,this.u=A,this.w=Y,this.y=pe,this.z=x,this.h=this.B(new v.$qe),this.onExtract=this.h.event,this.j=new y.$Fc,this.m=new y.$Fc,this.c=(0,a.$lh)(this.t.userExtensionsLocation,".obsolete"),this.g=new r.$Rh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(ne,X,z){try{const A={includeInvalid:!0,profileLocation:X,productVersion:z};let Y=[];if(ne===null||ne===M.ExtensionType.System){let pe=this.j.get(X);pe||(pe=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},A,!1).finally(()=>this.j.delete(X)),this.j.set(X,pe)),Y.push(...await pe)}else if(ne===M.ExtensionType.User){let pe=this.m.get(X);pe||(pe=this.t.scanUserExtensions(A).finally(()=>this.m.delete(X)),this.m.set(X,pe)),Y.push(...await pe)}return Y=ne!==null?Y.filter(pe=>pe.type===ne):Y,await Promise.all(Y.map(pe=>this.H(pe)))}catch(A){throw(0,u.$Oq)(A,i.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(ne){try{const X=await this.t.scanUserExtensions({includeAllVersions:!ne,includeInvalid:!0});return await Promise.all(X.map(z=>this.H(z)))}catch(X){throw(0,u.$Oq)(X,i.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(ne){try{const X=await this.t.scanExistingExtension(ne,M.ExtensionType.User,{includeInvalid:!0});if(X)return await this.H(X)}catch(X){this.z.error(X)}return null}async extractUserExtension(ne,X,z,A,Y){const pe=ne.toString(),x=b.URI.file(g.$oc(this.t.userExtensionsLocation.fsPath,`.${(0,p.$7g)()}`)),ie=b.URI.file(g.$oc(this.t.userExtensionsLocation.fsPath,pe));if(await this.s.exists(ie)){if(!A)try{return await this.scanLocalExtension(ie,M.ExtensionType.User)}catch(W){this.z.warn(`Error while scanning the existing extension at ${ie.path}. Deleting the existing extension and extracting it.`,(0,T.$bb)(W))}try{await this.D(ne.id,ie,"removeExisting")}catch{throw new i.$tp(o.localize(1827,null,ie.fsPath,ne.id),i.ExtensionManagementErrorCode.Delete)}}try{if(Y.isCancellationRequested)throw new T.$9;try{this.z.trace(`Started extracting the extension from ${X} to ${ie.fsPath}`),await(0,w.$Lq)(X,x.fsPath,{sourcePath:"extension",overwrite:!0},Y),this.z.info(`Extracted extension to ${ie}:`,ne.id)}catch(W){throw(0,C.$1q)(W)}try{await this.t.updateMetadata(x,z)}catch(W){throw this.y.publicLog2("extension:extract",{extensionId:ne.id,code:`${(0,Q.$wl)(W)}`}),(0,u.$Oq)(W,i.ExtensionManagementErrorCode.UpdateMetadata)}if(Y.isCancellationRequested)throw new T.$9;try{this.z.trace(`Started renaming the extension from ${x.fsPath} to ${ie.fsPath}`),await this.G(x.fsPath,ie.fsPath),this.z.info("Renamed to",ie.fsPath)}catch(W){if(W.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",ne.id);try{await this.s.del(x,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,T.$bb)(W)}. Deleted from extracted location`,x),W}this.h.fire(ie)}catch(W){try{await this.s.del(x,{recursive:!0})}catch{}throw W}return this.scanLocalExtension(ie,M.ExtensionType.User)}async scanMetadata(ne,X){return X?(await this.C(ne,X))?.metadata:this.t.scanMetadata(ne.location)}async C(ne,X){return(await this.u.scanProfileExtensions(X)).find(A=>(0,f.$Sp)(A.identifier,ne.identifier))}async updateMetadata(ne,X,z){try{z?await this.u.updateMetadata([[ne,X]],z):await this.t.updateMetadata(ne.location,X)}catch(A){throw this.y.publicLog2("extension:extract",{extensionId:ne.identifier.id,code:`${(0,Q.$wl)(A)}`,isProfile:!!z}),(0,u.$Oq)(A,i.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(ne.location,ne.type,z)}async getUninstalledExtensions(){try{return await this.F()}catch(ne){throw(0,u.$Oq)(ne,i.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...ne){const X=ne.map(z=>f.$Tp.create(z));await this.F(z=>X.forEach(A=>{z[A.toString()]=!0,this.z.info("Marked extension as uninstalled",A.toString())}))}async setInstalled(ne){try{await this.F(X=>delete X[ne.toString()])}catch(X){throw(0,u.$Oq)(X,i.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(ne,X){if(this.w.extUri.isEqualOrParent(ne.location,this.t.userExtensionsLocation))return this.D(ne.identifier.id,ne.location,X)}async removeUninstalledExtension(ne){await this.removeExtension(ne,"uninstalled"),await this.F(X=>delete X[f.$Tp.create(ne).toString()])}async copyExtension(ne,X,z,A){const Y=await this.C(ne,X),pe=await this.C(ne,z);if(A={...Y?.metadata,...A},pe)if(this.w.extUri.isEqual(pe.location,ne.location))await this.u.updateMetadata([[ne,{...pe.metadata,...A}]],z);else{const x=await this.scanLocalExtension(pe.location,ne.type,z);await this.u.removeExtensionFromProfile(x,z),await this.u.addExtensionsToProfile([[ne,{...pe.metadata,...A}]],z)}else await this.u.addExtensionsToProfile([[ne,A]],z);return this.scanLocalExtension(ne.location,ne.type,z)}async copyExtensions(ne,X,z){const A=await this.scanExtensions(M.ExtensionType.User,ne,z),Y=await Promise.all(A.filter(pe=>!pe.isApplicationScoped).map(async pe=>[pe,await this.scanMetadata(pe,ne)]));await this.u.addExtensionsToProfile(Y,X)}async D(ne,X,z){this.z.trace(`Deleting ${z} extension from disk`,ne,X.fsPath);const A=this.w.extUri.joinPath(this.w.extUri.dirname(X),`${this.w.extUri.basename(X)}.${(0,s.$yj)((0,p.$7g)()).toString(16)}${j}`);await this.G(X.fsPath,A.fsPath),await this.s.del(A,{recursive:!0}),this.z.info(`Deleted ${z} extension from disk`,ne,X.fsPath)}F(ne){return this.g.queue(async()=>{let X;try{X=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(A){if((0,Q.$wl)(A)!==Q.FileOperationResult.FILE_NOT_FOUND)throw A}let z={};if(X)try{z=JSON.parse(X)}catch{}return ne&&(ne(z),Object.keys(z).length?await this.s.writeFile(this.c,E.$Se.fromString(JSON.stringify(z))):await this.s.del(this.c)),z})}async G(ne,X){try{await d.Promises.rename(ne,X,2*60*1e3)}catch(z){throw(0,u.$Oq)(z,i.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(ne,X,z){try{if(z){const Y=(await this.t.scanUserExtensions({profileLocation:z})).find(pe=>this.w.extUri.isEqual(pe.location,ne));if(Y)return await this.H(Y)}else{const A=await this.t.scanExistingExtension(ne,X,{includeInvalid:!0});if(A)return await this.H(A)}throw new i.$tp(o.localize(1828,null,ne.path),i.ExtensionManagementErrorCode.ScanningExtension)}catch(A){throw(0,u.$Oq)(A,i.ExtensionManagementErrorCode.ScanningExtension)}}async H(ne){const X=await this.s.resolve(ne.location);let z,A;return X.children&&(z=X.children.find(({name:Y})=>/^readme(\.txt|\.md|)$/i.test(Y))?.resource,A=X.children.find(({name:Y})=>/^changelog(\.txt|\.md|)$/i.test(Y))?.resource),{identifier:ne.identifier,type:ne.type,isBuiltin:ne.isBuiltin||!!ne.metadata?.isBuiltin,location:ne.location,manifest:ne.manifest,targetPlatform:ne.targetPlatform,validations:ne.validations,isValid:ne.isValid,readmeUrl:z,changelogUrl:A,publisherDisplayName:ne.metadata?.publisherDisplayName,publisherId:ne.metadata?.publisherId||null,isApplicationScoped:!!ne.metadata?.isApplicationScoped,isMachineScoped:!!ne.metadata?.isMachineScoped,isPreReleaseVersion:!!ne.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!ne.metadata?.hasPreReleaseVersion,preRelease:!!ne.metadata?.preRelease,installedTimestamp:ne.metadata?.installedTimestamp,updated:!!ne.metadata?.updated,pinned:!!ne.metadata?.pinned,isWorkspaceScoped:!1,source:ne.metadata?.source??(ne.identifier.uuid?"gallery":"vsix")}}async I(){const ne=await this.getUninstalledExtensions();if(Object.keys(ne).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(ne));const X=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),z=new Set;for(const Y of X)ne[f.$Tp.create(Y).toString()]||z.add(Y.identifier.id.toLowerCase());try{const Y=(0,f.$Yp)(X,pe=>pe.identifier);await r.Promises.settled(Y.map(async pe=>{const x=pe.sort((ie,W)=>c.rcompare(ie.manifest.version,W.manifest.version))[0];z.has(x.identifier.id.toLowerCase())||await this.n(await this.H(x))}))}catch(Y){this.z.error(Y)}const A=X.filter(Y=>Y.metadata&&ne[f.$Tp.create(Y).toString()]);await Promise.allSettled(A.map(Y=>this.removeUninstalledExtension(Y)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let ne;try{ne=await this.s.resolve(this.t.userExtensionsLocation)}catch(X){(0,Q.$wl)(X)!==Q.FileOperationResult.FILE_NOT_FOUND&&this.z.error(X);return}if(ne?.children)try{await Promise.allSettled(ne.children.map(async X=>{if(!(!X.isDirectory||!X.name.endsWith(j))){this.z.trace("Deleting the temporarily deleted folder",X.resource.toString());try{await this.s.del(X.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",X.resource.toString())}catch(z){(0,Q.$wl)(z)!==Q.FileOperationResult.FILE_NOT_FOUND&&this.z.error(z)}}}))}catch{}}};e.$9q=ee,e.$9q=ee=We([je(1,Q.$fl),je(2,k.$Vq),je(3,h.$Rq),je(4,K.$Pl),je(5,le.$em),je(6,ve.$fk)],ee);let ae=class extends u.$Pq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(ne,X,z,A,Y,pe,x,ie,W,Z,ce,we){super(),this.l=ne,this.manifest=X,this.source=z,this.options=A,this.m=Y,this.n=pe,this.o=x,this.p=ie,this.q=W,this.s=Z,this.t=ce,this.u=we,this.j=i.InstallOperation.Install,this.identifier=this.l.identifier}async h(ne){const z=(await this.n.scanExtensions(M.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(x=>(0,f.$Sp)(x.identifier,this.identifier));z&&(this.j=i.InstallOperation.Update);const A={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,isSystem:z?.type===M.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned,source:this.source instanceof b.URI?"vsix":"gallery"};let Y;if(this.source instanceof b.URI){if(z&&this.l.equals(new f.$Tp(z.identifier,z.manifest.version)))try{await this.n.removeExtension(z,"existing")}catch{throw new Error(o.localize(1829,null,this.manifest.displayName||this.manifest.name))}const x=await this.w(this.l);if(x)try{await this.n.removeExtension(x,"existing")}catch{throw new Error(o.localize(1830,null,this.manifest.displayName||this.manifest.name))}}else{if(A.id=this.source.identifier.uuid,A.publisherId=this.source.publisherId,A.publisherDisplayName=this.source.publisherDisplayName,A.targetPlatform=this.source.properties.targetPlatform,A.updated=!!z,A.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,A.hasPreReleaseVersion=z?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,A.preRelease=(0,m.$pg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||z?.preRelease,z&&z.type!==M.ExtensionType.System&&z.manifest.version===this.source.version)return this.n.updateMetadata(z,A,this.options.profileLocation);Y=await this.w(this.l)}if(ne.isCancellationRequested)throw(0,u.$Oq)(new T.$9);if(!Y){const x=await this.m(this.operation,ne);Y=x.local,this.k=x.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(x){throw(0,u.$Oq)(x,i.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(ne.isCancellationRequested)throw(0,u.$Oq)(new T.$9);try{await this.t.addExtensionsToProfile([[Y,A]],this.options.profileLocation,!Y.isValid)}catch(x){throw(0,u.$Oq)(x,i.ExtensionManagementErrorCode.AddToProfile)}const pe=await this.n.scanLocalExtension(Y.location,M.ExtensionType.User,this.options.profileLocation);if(!pe)throw new i.$tp("Cannot find the installed extension",i.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof b.URI&&this.x(Y,ne),pe}async w(ne){return(await this.n.getUninstalledExtensions())[ne.toString()]?(this.u.trace("Removing the extension from uninstalled list:",ne.id),await this.n.setInstalled(ne),this.u.info("Removed the extension from uninstalled list:",ne.id),(await this.n.scanAllUserExtensions(!0)).find(A=>f.$Tp.create(A).equals(ne))):void 0}async x(ne,X){try{let[z]=await this.p.getExtensions([{id:ne.identifier.id,version:ne.manifest.version}],X);if(z||([z]=await this.p.getExtensions([{id:ne.identifier.id}],X)),z){const A={id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId,isPreReleaseVersion:z.properties.isPreReleaseVersion,hasPreReleaseVersion:ne.hasPreReleaseVersion||z.properties.isPreReleaseVersion,preRelease:z.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(ne,A,this.options.profileLocation)}}catch{}}};ae=We([je(6,K.$Pl),je(7,i.$rp),je(8,B.$Rl),je(9,k.$Vq),je(10,h.$Rq),je(11,ve.$fk)],ae);class ye extends u.$Pq{constructor(ne,X,z){super(),this.extension=ne,this.options=X,this.j=z}async h(ne){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(Te[142],Oe([1,0,11,33,35,24,54,15,27,4]),function(ue,e,t,r,E,P,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_R=void 0;let S=class extends D.$Sq{constructor($,g,a,c,m,b){super(s.URI.file($.extensionsPath),g,a,c,m,b)}};e.$_R=S,e.$_R=S=We([je(0,v.$Si),je(1,T.$fl),je(2,r.$Rl),je(3,E.$Pl),je(4,P.$em),je(5,t.$fk)],S)}),define(Te[100],Oe([1,0,13,6,2,44,10,195,5,33]),function(ue,e,t,r,E,P,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$qq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$oq=e.$nq=e.$mq=void 0,e.$pq=g,e.$rq=c,e.$tq=b,e.$mq="__$__isNewStorageMarker",e.$nq="__$__targetStorageMarker",e.$oq=(0,v.$Ki)("storageService");var S;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var y;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var $;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function g(p){const d=p.get(e.$nq);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}class a extends E.$Zc{static{this.a=60*1e3}constructor(d={flushInterval:a.a}){super(),this.m=d,this.b=this.B(new r.$te),this.c=this.B(new r.$te),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$qe),this.onWillSaveState=this.f.event,this.h=this.B(new t.$Wh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new E.$1c),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,w,o){return r.Event.filter(this.b.event,l=>l.scope===d&&(w===void 0||l.key===w),o)}n(){this.j.value=(0,t.$1h)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,E.$Uc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,w){const{key:o,external:l}=w;if(o===e.$nq){switch(d){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:o,target:this.J(d)[o],external:l})}w(d){this.f.fire({reason:d})}get(d,w,o){return this.P(w)?.get(d,o)}getBoolean(d,w,o){return this.P(w)?.getBoolean(d,o)}getNumber(d,w,o){return this.P(w)?.getNumber(d,o)}getObject(d,w,o){return this.P(w)?.getObject(d,o)}storeAll(d,w){this.y(()=>{for(const o of d)this.store(o.key,o.value,o.scope,o.target,w)})}store(d,w,o,l,n=!1){if((0,D.$sg)(w)){this.remove(d,o,n);return}this.y(()=>{this.z(d,o,l),this.P(o)?.set(d,w,n)})}remove(d,w,o=!1){this.y(()=>{this.z(d,w,void 0),this.P(w)?.delete(d,o)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,w){const o=[],l=this.J(d);for(const n of Object.keys(l))l[n]===w&&o.push(n);return o}z(d,w,o,l=!1){const n=this.J(w);typeof o=="number"?n[d]!==o&&(n[d]=o,this.P(w)?.set(e.$nq,JSON.stringify(n),l)):typeof n[d]=="number"&&(delete n[d],this.P(w)?.set(e.$nq,JSON.stringify(n),l))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(d){switch(d){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(d){const w=this.P(d);return w?g(w):Object.create(null)}isNew(d){return this.getBoolean(e.$mq,d)===!0}async flush(d=S.NONE){this.f.fire({reason:d});const w=this.P(y.APPLICATION),o=this.P(y.PROFILE),l=this.P(y.WORKSPACE);switch(d){case S.NONE:await t.Promises.settled([w?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await t.Promises.settled([w?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(y.APPLICATION)?.items??new Map,w=this.P(y.PROFILE)?.items??new Map,o=this.P(y.WORKSPACE)?.items??new Map;return b(d,w,o,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,w){return this.w(S.NONE),(0,s.$Ql)(d)?this.R(d,w):this.S(d,w)}M(d,w){return!(d.id===w.id||c(w)&&c(d))}N(d,w,o){this.y(()=>{const l=new Set;for(const[n,u]of d)l.add(n),w.get(n)!==u&&this.u(o,{key:n,external:!0});for(const[n]of w.items)l.has(n)||this.u(o,{key:n,external:!0})})}}e.$qq=a;function c(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class m extends a{constructor(){super(),this.U=this.B(new T.$kq(new T.$lq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$kq(new T.$lq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$kq(new T.$lq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(y.WORKSPACE,d))),this.B(this.W.onDidChangeStorage(d=>this.u(y.PROFILE,d))),this.B(this.U.onDidChangeStorage(d=>this.u(y.APPLICATION,d)))}P(d){switch(d){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(d){switch(d){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$sq=m;async function b(p,d,w,o,l,n){const u=R=>{try{return JSON.parse(R)}catch{return R}},i=new Map,f=new Map;p.forEach((R,M)=>{i.set(M,R),f.set(M,u(R))});const h=new Map,k=new Map;d.forEach((R,M)=>{h.set(M,R),k.set(M,u(R))});const I=new Map,O=new Map;w.forEach((R,M)=>{I.set(M,R),O.set(M,u(R))}),console.group(o!==l?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const C=[];if(i.forEach((R,M)=>{C.push({key:M,value:R})}),console.table(C),console.groupEnd(),console.log(f),o!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const R=[];h.forEach((M,G)=>{R.push({key:G,value:M})}),console.table(R),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${n})`);const L=[];I.forEach((R,M)=>{L.push({key:M,value:R})}),console.table(L),console.groupEnd(),console.log(O)}}),define(Te[248],Oe([1,0,14,22,100]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=P;async function P(D,T,v){let s=v&&v.get("storage.serviceMachineId",E.StorageScope.APPLICATION)||null;if(s)return s;try{const y=(await T.readFile(D.serviceMachineIdResource)).value.toString();s=(0,r.$6g)(y)?y:null}catch{s=null}if(!s){s=(0,r.$7g)();try{await T.writeFile(D.serviceMachineIdResource,t.$Se.fromString(s))}catch{}}return v?.store("storage.serviceMachineId",s,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE),s}}),define(Te[249],Oe([1,0,248,24,40]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=P;async function P(D,T,v,s,S,y,$){const g={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${T.nameShort})`};if((0,E.$Kp)(T,v)&&(0,E.$Mp)(s)===r.TelemetryLevel.USAGE){const a=await(0,t.$uq)(v,S,y);g["X-Market-User-Id"]=a,g["VSCode-SessionId"]=$.machineId||a}return g}}),define(Te[143],Oe([1,0,17,18,9,3,32,10,4,182,28,27,30,38,21,75,15,11,29,47,249,100,24,43]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d,w,o,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0,e.$wq=X;const u=P.$r?a.TargetPlatform.WEB:(0,$.$np)(P.$x,D.$jc),i="X-Market-Search-Activity-Id";var f;(function(ie){ie[ie.None=0]="None",ie[ie.IncludeVersions=1]="IncludeVersions",ie[ie.IncludeFiles=2]="IncludeFiles",ie[ie.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",ie[ie.IncludeSharedAccounts=8]="IncludeSharedAccounts",ie[ie.IncludeVersionProperties=16]="IncludeVersionProperties",ie[ie.ExcludeNonValidated=32]="ExcludeNonValidated",ie[ie.IncludeInstallationTargets=64]="IncludeInstallationTargets",ie[ie.IncludeAssetUri=128]="IncludeAssetUri",ie[ie.IncludeStatistics=256]="IncludeStatistics",ie[ie.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",ie[ie.Unpublished=4096]="Unpublished",ie[ie.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(f||(f={}));function h(...ie){return String(ie.reduce((W,Z)=>W|Z,0))}var k;(function(ie){ie[ie.Tag=1]="Tag",ie[ie.ExtensionId=4]="ExtensionId",ie[ie.Category=5]="Category",ie[ie.ExtensionName=7]="ExtensionName",ie[ie.Target=8]="Target",ie[ie.Featured=9]="Featured",ie[ie.SearchText=10]="SearchText",ie[ie.ExcludeWithFlags=12]="ExcludeWithFlags"})(k||(k={}));const I={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},O={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},L={pageNumber:1,pageSize:10,sortBy:$.SortBy.NoneOrRelevance,sortOrder:$.SortOrder.Default,flags:f.None,criteria:[],assetTypes:[]};class R{constructor(W=L){this.d=W}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(W,Z=this.d.pageSize){return new R({...this.d,pageNumber:W,pageSize:Z})}withFilter(W,...Z){const ce=[...this.d.criteria,...Z.length?Z.map(we=>({filterType:W,value:we})):[{filterType:W}]];return new R({...this.d,criteria:ce})}withSortBy(W){return new R({...this.d,sortBy:W})}withSortOrder(W){return new R({...this.d,sortOrder:W})}withFlags(...W){return new R({...this.d,flags:W.reduce((Z,ce)=>Z|ce,0)})}withAssetTypes(...W){return new R({...this.d,assetTypes:W})}withSource(W){return new R({...this.d,source:W})}get raw(){const{criteria:W,pageNumber:Z,pageSize:ce,sortBy:we,sortOrder:Le,flags:ze,assetTypes:qe}=this.d;return{filters:[{criteria:W,pageNumber:Z,pageSize:ce,sortBy:we,sortOrder:Le}],assetTypes:qe,flags:ze}}get searchText(){const W=this.d.criteria.filter(Z=>Z.filterType===k.SearchText)[0];return W&&W.value?W.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(W=>String(W.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function M(ie,W){const Z=(ie||[]).filter(ce=>ce.statisticName===W)[0];return Z?Z.value:0}function G(ie){const W="Microsoft.VisualStudio.Code.Translation.";return ie.files.filter(ce=>ce.assetType.indexOf(W)===0).reduce((ce,we)=>{const Le=ve(ie,we.assetType);return Le&&ce.push([we.assetType.substring(W.length),Le]),ce},[])}function Q(ie){if(ie.properties){const W=ie.properties.filter(we=>we.key===I.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ce=W.filter(we=>Z.test(we.value))[0];return ce?{uri:ce.value,fallbackUri:ce.value}:null}return ve(ie,I.Repository)}function te(ie){return{uri:`${ie.fallbackAssetUri}/${I.VSIX}?redirect=true${ie.targetPlatform?`&targetPlatform=${ie.targetPlatform}`:""}`,fallbackUri:`${ie.fallbackAssetUri}/${I.VSIX}${ie.targetPlatform?`?targetPlatform=${ie.targetPlatform}`:""}`}}function ve(ie,W){return ie.files.filter(ce=>ce.assetType===W)[0]?{uri:`${ie.assetUri}/${W}${ie.targetPlatform?`?targetPlatform=${ie.targetPlatform}`:""}`,fallbackUri:`${ie.fallbackAssetUri}/${W}${ie.targetPlatform?`?targetPlatform=${ie.targetPlatform}`:""}`}:null}function be(ie,W){const Z=ie.properties?ie.properties.filter(we=>we.key===W):[],ce=Z.length>0&&Z[0].value;return ce?ce.split(",").map(we=>(0,g.$Wp)(we)):[]}function le(ie){const W=ie.properties?ie.properties.filter(Z=>Z.key===O.Engine):[];return W.length>0&&W[0].value||""}function K(ie){const W=ie.properties?ie.properties.filter(Z=>Z.key===O.PreRelease):[];return W.length>0&&W[0].value==="true"}function B(ie){const W=ie.properties?ie.properties.filter(Z=>Z.key===O.ExecutesCode):[];return W.length>0?W[0].value==="true":void 0}function j(ie){const W=ie.properties?ie.properties.filter(ce=>ce.key===O.EnabledApiProposals):[],Z=W.length>0&&W[0].value||"";return Z?Z.split(","):[]}function U(ie){const W=ie.properties?ie.properties.filter(ce=>ce.key===O.LocalizedLanguages):[],Z=W.length>0&&W[0].value||"";return Z?Z.split(","):[]}function ee(ie){return ie.properties?.find(W=>W.key===O.SponsorLink)?.value}function ae(ie){return ie.properties?.find(W=>W.key===O.SupportLink)?.value}function ye(ie){return ie.indexOf("preview")!==-1}function se(ie){return ie.targetPlatform?(0,$.$mp)(ie.targetPlatform):a.TargetPlatform.UNDEFINED}function ne(ie){const W=(0,t.$Qb)(ie.versions.map(se)),Z=!!ie.tags?.includes($.$gp),ce=W.indexOf(a.TargetPlatform.WEB);return Z?ce===-1&&W.push(a.TargetPlatform.WEB):ce!==-1&&W.splice(ce,1),W}function X(ie,W){for(let Z=0;Z<ie.length;Z++){const ce=ie[Z];if(ce.version===ie[Z-1]?.version){let we=Z;if(se(ce)===W)for(;we>0&&ie[we-1].version===ce.version;)we--;we!==Z&&(ie.splice(Z,1),ie.splice(we,0,ce))}}return ie}function z(ie,W,Z){ie.telemetryData={index:W,querySource:Z,queryActivityId:ie.queryContext?.[i]}}function A(ie,W,Z,ce){const we=ie.versions[0],Le={manifest:ve(W,I.Manifest),readme:ve(W,I.Details),changelog:ve(W,I.Changelog),license:ve(W,I.License),repository:Q(W),download:te(W),icon:ve(W,I.Icon),signature:ve(W,I.Signature),coreTranslations:G(W)};return{type:"gallery",identifier:{id:(0,g.$Xp)(ie.publisher.publisherName,ie.extensionName),uuid:ie.extensionId},name:ie.extensionName,version:W.version,displayName:ie.displayName,publisherId:ie.publisher.publisherId,publisher:ie.publisher.publisherName,publisherDisplayName:ie.publisher.displayName,publisherDomain:ie.publisher.domain?{link:ie.publisher.domain,verified:!!ie.publisher.isDomainVerified}:void 0,publisherSponsorLink:ee(we),description:ie.shortDescription??"",installCount:M(ie.statistics,"install"),rating:M(ie.statistics,"averagerating"),ratingCount:M(ie.statistics,"ratingcount"),categories:ie.categories||[],tags:ie.tags||[],releaseDate:Date.parse(ie.releaseDate),lastUpdated:Date.parse(ie.lastUpdated),allTargetPlatforms:Z,assets:Le,properties:{dependencies:be(W,O.Dependency),extensionPack:be(W,O.ExtensionPack),engine:le(W),enabledApiProposals:j(W),localizedLanguages:U(W),targetPlatform:se(W),isPreReleaseVersion:K(W),executesCode:B(W)},hasPreReleaseVersion:K(we),hasReleaseVersion:!0,preview:ye(ie.flags),isSigned:!!Le.signature,queryContext:ce,supportLink:ae(we)}}let Y=class{constructor(W,Z,ce,we,Le,ze,qe,Re){this.l=Z,this.n=ce,this.o=we,this.q=Le,this.u=ze,this.w=qe,this.x=Re;const Ne=qe.extensionsGallery,De=Ne?.servicePPEUrl&&Re.getValue("_extensionsGallery.enablePPE");this.d=De?Ne.servicePPEUrl:Ne?.serviceUrl,this.g=De?void 0:Ne?.searchUrl,this.h=Ne?.controlUrl,this.k=qe.extensionsEnabledWithApiProposalVersion?.map(Ce=>Ce.toLowerCase())??[],this.j=(0,w.$vq)(qe.version,qe,this.o,this.x,this.u,W,this.q)}y(W=""){return`${this.d}${W}`}isEnabled(){return!!this.d}async getExtensions(W,Z,ce){const we=r.CancellationToken.isCancellationToken(Z)?{}:Z,Le=r.CancellationToken.isCancellationToken(Z)?Z:ce,ze=await this.z(W,we,Le),qe=ze.map(Ne=>Ne.identifier.uuid),Re=[];for(const Ne of W)Ne.uuid&&!qe.includes(Ne.uuid)&&Re.push({...Ne,uuid:void 0});if(Re.length){this.q.publicLog2("galleryService:additionalQueryByName",{count:Re.length});const Ne=await this.z(Re,we,Le);ze.push(...Ne)}return ze}async z(W,Z,ce){const we=[],Le=[],ze=[],qe=[];let Re=!0;for(const Ce of W){Ce.uuid?Le.push(Ce.uuid):we.push(Ce.id);const ge=!!(Ce.version||Ce.preRelease);ze.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:ge}),Ce.version&&qe.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),Re=Re&&!!Ce.hasPreRelease&&!ge}if(!Le.length&&!we.length)return[];let Ne=new R().withPage(1,W.length);Le.length&&(Ne=Ne.withFilter(k.ExtensionId,...Le)),we.length&&(Ne=Ne.withFilter(k.ExtensionName,...we)),(Z.queryAllVersions||Re)&&(Ne=Ne.withFlags(Ne.flags,f.IncludeVersions)),Z.source&&(Ne=Ne.withSource(Z.source));const{extensions:De}=await this.C(Ne,{targetPlatform:Z.targetPlatform??u,includePreRelease:ze,versions:qe,compatible:!!Z.compatible,productVersion:Z.productVersion??{version:this.w.version,date:this.w.date}},ce);return Z.source&&De.forEach((Ce,ge)=>z(Ce,ge,Z.source)),De}async getCompatibleExtension(W,Z,ce,we={version:this.w.version,date:this.w.date}){if((0,$.$op)(W.allTargetPlatforms,ce))return null;if(await this.isExtensionCompatible(W,Z,ce))return W;const Le=new R().withFlags(f.IncludeVersions).withPage(1,1).withFilter(k.ExtensionId,W.identifier.uuid),{extensions:ze}=await this.C(Le,{targetPlatform:ce,compatible:!0,includePreRelease:Z,productVersion:we},r.CancellationToken.None);return ze[0]||null}async isExtensionCompatible(W,Z,ce,we={version:this.w.version,date:this.w.date}){if(!(0,$.$pp)(W.properties.targetPlatform,W.allTargetPlatforms,ce)||!Z&&W.properties.isPreReleaseVersion)return!1;let Le=W.properties.engine;if(!Le){const ze=await this.getManifest(W,r.CancellationToken.None);if(!ze)throw new Error("Manifest was not found");Le=ze.engines.vscode}return!(!(0,c.$_p)(Le,we.version,we.date)||!this.A(W.identifier,W.properties.enabledApiProposals))}A(W,Z){return!Z||!this.k.includes(W.id.toLowerCase())?!0:(0,c.$aq)(Z)}async B(W,Z,ce,we,Le,ze,qe={version:this.w.version,date:this.w.date}){if(!(0,$.$pp)(se(Z),Le,ze)||ce!=="any"&&K(Z)!==(ce==="prerelease"))return!1;if(we)try{const Re=await this.H(W,Z);if(!(0,c.$_p)(Re,qe.version,qe.date))return!1}catch(Re){return this.n.error(`Error while getting the engine for the version ${Z.version}.`,(0,E.$bb)(Re)),!1}return!0}async query(W,Z){let ce=W.text||"";const we=W.pageSize??50;let Le=new R().withPage(1,we);ce?(ce=ce.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,Ce,ge)=>(Le=Le.withFilter(k.Category,ge||Ce),"")),ce=ce.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,Ce,ge)=>(Le=Le.withFilter(k.Tag,ge||Ce),"")),ce=ce.replace(/\bfeatured(\s+|\b|$)/g,()=>(Le=Le.withFilter(k.Featured),"")),ce=ce.trim(),ce&&(ce=ce.length<200?ce:ce.substring(0,200),Le=Le.withFilter(k.SearchText,ce)),Le=Le.withSortBy($.SortBy.NoneOrRelevance)):W.ids?Le=Le.withFilter(k.ExtensionId,...W.ids):W.names?Le=Le.withFilter(k.ExtensionName,...W.names):Le=Le.withSortBy($.SortBy.InstallCount),typeof W.sortBy=="number"&&(Le=Le.withSortBy(W.sortBy)),typeof W.sortOrder=="number"&&(Le=Le.withSortOrder(W.sortOrder)),W.source&&(Le=Le.withSource(W.source));const ze=async(De,Ce)=>{const{extensions:ge,total:Se}=await this.C(De,{targetPlatform:u,compatible:!1,includePreRelease:!!W.includePreRelease,productVersion:W.productVersion??{version:this.w.version,date:this.w.date}},Ce);return ge.forEach((Pe,Ue)=>z(Pe,(De.pageNumber-1)*De.pageSize+Ue,W.source)),{extensions:ge,total:Se}},{extensions:qe,total:Re}=await ze(Le,Z),Ne=async(De,Ce)=>{if(Ce.isCancellationRequested)throw new E.$9;const{extensions:ge}=await ze(Le.withPage(De+1),Ce);return ge};return{firstPage:qe,total:Re,pageSize:Le.pageSize,getPage:Ne}}async C(W,Z,ce){const we=W.flags;W.flags&f.IncludeLatestVersionOnly&&W.flags&f.IncludeVersions&&(W=W.withFlags(W.flags&~f.IncludeVersions,f.IncludeLatestVersionOnly)),!(W.flags&f.IncludeLatestVersionOnly)&&!(W.flags&f.IncludeVersions)&&(W=W.withFlags(W.flags,f.IncludeLatestVersionOnly)),Z.versions?.length&&(W=W.withFlags(W.flags&~f.IncludeLatestVersionOnly,f.IncludeVersions)),W=W.withFlags(W.flags,f.IncludeAssetUri,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeStatistics,f.IncludeVersionProperties);const{galleryExtensions:Le,total:ze,context:qe}=await this.E(W,ce);if(!(W.flags&f.IncludeLatestVersionOnly)){const Ce=[];for(const ge of Le){const Se=await this.D(ge,Z,qe);Se&&Ce.push(Se)}return{extensions:Ce,total:ze}}const Ne=[],De=new Map;for(let Ce=0;Ce<Le.length;Ce++){const ge=Le[Ce],Se={id:(0,g.$Xp)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},Pe=(0,T.$pg)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(Ge=>(0,g.$Sp)(Ge,Se))?.includePreRelease;if(Z.compatible&&(0,$.$op)(ne(ge),Z.targetPlatform))continue;const Ue=await this.D(ge,Z,qe);!Ue||Ue.properties.isPreReleaseVersion&&(!Pe||!Ue.hasReleaseVersion)||!Ue.properties.isPreReleaseVersion&&Ue.properties.targetPlatform!==Z.targetPlatform&&Ue.hasPreReleaseVersion?De.set(ge.extensionId,Ce):Ne.push([Ce,Ue])}if(De.size){const Ce=new n.$ke,ge=new R().withFlags(we&~f.IncludeLatestVersionOnly,f.IncludeVersions).withPage(1,De.size).withFilter(k.ExtensionId,...De.keys()),{extensions:Se}=await this.C(ge,Z,ce);this.q.publicLog2("galleryService:additionalQuery",{duration:Ce.elapsed(),count:De.size});for(const Pe of Se){const Ue=De.get(Pe.identifier.uuid);Ne.push([Ue,Pe])}}return{extensions:Ne.sort((Ce,ge)=>Ce[0]-ge[0]).map(([,Ce])=>Ce),total:ze}}async D(W,Z,ce){const we={id:(0,g.$Xp)(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},Le=Z.versions?.find(Ne=>(0,g.$Sp)(Ne,we))?.version,ze=(0,T.$pg)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(Ne=>(0,g.$Sp)(Ne,we))?.includePreRelease,qe=ne(W),Re=X(W.versions,Z.targetPlatform);if(Z.compatible&&(0,$.$op)(qe,Z.targetPlatform))return null;for(let Ne=0;Ne<Re.length;Ne++){const De=Re[Ne];if(!(Le&&De.version!==Le)){if(await this.B(we.id,De,ze?"any":"release",Z.compatible,qe,Z.targetPlatform,Z.productVersion)){if(Z.compatible&&!this.A(we,j(De)))continue;return A(W,De,qe,ce)}if(Le&&De.version===Le)return null}}return Le||Z.compatible?null:A(W,W.versions[0],qe)}async E(W,Z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");W=W.withFlags(W.flags,f.ExcludeNonValidated).withFilter(k.Target,"Microsoft.VisualStudio.Code").withFilter(k.ExcludeWithFlags,h(f.Unpublished));const ce=await this.j,we=JSON.stringify(W.raw),Le={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(we.length)},ze=new n.$ke;let qe,Re,Ne=0;try{if(qe=await this.l.request({type:"POST",url:this.g&&W.criteria.some(Ce=>Ce.filterType===k.SearchText)?this.g:this.y("/extensionquery"),data:we,headers:Le},Z),qe.res.statusCode&&qe.res.statusCode>=400&&qe.res.statusCode<500)return{galleryExtensions:[],total:Ne};const De=await(0,d.$hq)(qe);if(De){const Ce=De.results[0],ge=Ce.extensions,Se=Ce.resultMetadata&&Ce.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return Ne=Se&&Se.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:Ne,context:qe.res.headers.activityid?{[i]:qe.res.headers.activityid}:{}}}return{galleryExtensions:[],total:Ne}}catch(De){if((0,E.$8)(De))throw Re=$.ExtensionGalleryErrorCode.Cancelled,De;{const Ce=(0,E.$bb)(De);throw Re=(0,s.$cp)(De)?$.ExtensionGalleryErrorCode.Offline:Ce.startsWith("XHR timeout")?$.ExtensionGalleryErrorCode.Timeout:$.ExtensionGalleryErrorCode.Failed,new $.$sp(Ce,Re)}}finally{this.q.publicLog2("galleryService:query",{...W.telemetryData,requestBodySize:String(we.length),duration:ze.elapsed(),success:!!qe&&(0,d.$dq)(qe),responseBodySize:qe?.res.headers["Content-Length"],statusCode:qe?String(qe.res.statusCode):void 0,errorCode:Re,count:String(Ne)})}}async reportStatistic(W,Z,ce,we){if(!this.isEnabled())return;const Le=P.$r?this.y(`/itemName/${W}.${Z}/version/${ce}/statType/${we===$.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${W}/extensions/${Z}/${ce}/stats?statType=${we}`),ze=P.$r?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Re={...await this.j,Accept:ze};try{await this.l.request({type:"POST",url:Le,headers:Re},r.CancellationToken.None)}catch{}}async download(W,Z,ce){this.n.trace("ExtensionGalleryService#download",W.identifier.id);const we=(0,g.$1p)(W),Le=new Date().getTime(),ze=ce===$.InstallOperation.Install?"install":ce===$.InstallOperation.Update?"update":"",qe=ze?{uri:`${W.assets.download.uri}${v.URI.parse(W.assets.download.uri).query?"&":"?"}${ze}=true`,fallbackUri:`${W.assets.download.fallbackUri}${v.URI.parse(W.assets.download.fallbackUri).query?"&":"?"}${ze}=true`}:W.assets.download,Re=W.queryContext?.[i]?{[i]:W.queryContext[i]}:void 0,Ne=await this.G(W.identifier.id,qe,I.VSIX,Re?{headers:Re}:void 0);try{await this.u.writeFile(Z,Ne.stream)}catch(De){try{await this.u.del(Z)}catch(Ce){this.n.warn(`Error while deleting the file ${Z.toString()}`,(0,E.$bb)(Ce))}throw new $.$sp((0,E.$bb)(De),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...we,duration:new Date().getTime()-Le})}async downloadSignatureArchive(W,Z){if(!W.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",W.identifier.id);const ce=await this.G(W.identifier.id,W.assets.signature,I.Signature);try{await this.u.writeFile(Z,ce.stream)}catch(we){try{await this.u.del(Z)}catch(Le){this.n.warn(`Error while deleting the file ${Z.toString()}`,(0,E.$bb)(Le))}throw new $.$sp((0,E.$bb)(we),$.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(W,Z){if(W.assets.readme){const ce=await this.G(W.identifier.id,W.assets.readme,I.Details,{},Z);return await(0,d.$gq)(ce)||""}return""}async getManifest(W,Z){if(W.assets.manifest){const ce=await this.G(W.identifier.id,W.assets.manifest,I.Manifest,{},Z),we=await(0,d.$gq)(ce);return we?JSON.parse(we):null}return null}async F(W,Z,ce){const we=ve(Z,I.Manifest);if(!we)throw new Error("Manifest was not found");const Le={"Accept-Encoding":"gzip"},ze=await this.G(W,we,I.Manifest,{headers:Le});return await(0,d.$hq)(ze)}async getCoreTranslation(W,Z){const ce=W.assets.coreTranslations.filter(we=>we[0]===Z.toUpperCase())[0];if(ce){const we=await this.G(W.identifier.id,ce[1],ce[0]),Le=await(0,d.$gq)(we);return Le?JSON.parse(Le):null}return null}async getChangelog(W,Z){if(W.assets.changelog){const ce=await this.G(W.identifier.id,W.assets.changelog,I.Changelog,{},Z);return await(0,d.$gq)(ce)||""}return""}async getAllCompatibleVersions(W,Z,ce){let we=new R().withFlags(f.IncludeVersions,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1);W.uuid?we=we.withFilter(k.ExtensionId,W.uuid):we=we.withFilter(k.ExtensionName,W.id);const{galleryExtensions:Le}=await this.E(we,r.CancellationToken.None);if(!Le.length)return[];const ze=ne(Le[0]);if((0,$.$op)(ze,ce))return[];const qe=[];await Promise.all(Le[0].versions.map(async De=>{try{await this.B(W.id,De,Z?"any":"release",!0,ze,ce)&&this.A(W,j(De))&&qe.push(De)}catch{}}));const Re=[],Ne=new Set;for(const De of X(qe,ce))Ne.has(De.version)||(Ne.add(De.version),Re.push({version:De.version,date:De.lastUpdated,isPreReleaseVersion:K(De)}));return Re}async G(W,Z,ce,we={},Le=r.CancellationToken.None){const ze=await this.j,qe={type:"GET"},Re={...ze,...we.headers||{}};we={...we,...qe,headers:Re};const Ne=Z.uri,De=Z.fallbackUri,Ce={...we,url:Ne};try{const ge=await this.l.request(Ce,Le);if(ge.res.statusCode===200)return ge;const Se=await(0,d.$gq)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${Se}`)}catch(ge){if((0,E.$8)(ge))throw ge;const Se=(0,E.$bb)(ge);this.q.publicLog2("galleryService:cdnFallback",{extension:W,assetType:ce,message:Se});const Pe={...we,url:De};return this.l.request(Pe,Le)}}async H(W,Z){let ce=le(Z);if(!ce){this.q.publicLog2("galleryService:engineFallback",{extension:W,version:Z.version});const we=await this.F(W,Z,r.CancellationToken.None);if(!we)throw new Error("Manifest was not found");ce=we.engines.vscode}return ce}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const W=await this.l.request({type:"GET",url:this.h},r.CancellationToken.None);if(W.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,d.$hq)(W),ce=[],we={},Le=[],ze=[];if(Z){for(const qe of Z.malicious)ce.push({id:qe});if(Z.migrateToPreRelease)for(const[qe,Re]of Object.entries(Z.migrateToPreRelease))(!Re.engine||(0,c.$_p)(Re.engine,this.w.version,this.w.date))&&(we[qe.toLowerCase()]={disallowInstall:!0,extension:{id:Re.id,displayName:Re.displayName,autoMigrate:{storage:!!Re.migrateStorage},preRelease:!0}});if(Z.deprecated)for(const[qe,Re]of Object.entries(Z.deprecated))Re&&(we[qe.toLowerCase()]=(0,T.$pg)(Re)?{}:Re);if(Z.search)for(const qe of Z.search)Le.push(qe);if(Array.isArray(Z.extensionsEnabledWithPreRelease))for(const qe of Z.extensionsEnabledWithPreRelease)ze.push(qe.toLowerCase())}return{malicious:ce,deprecated:we,search:Le,extensionsEnabledWithPreRelease:ze}}};Y=We([je(1,d.$bq),je(2,b.$fk),je(3,y.$Ri),je(4,l.$em),je(5,m.$fl),je(6,p.$yk),je(7,S.$ej)],Y);let pe=class extends Y{constructor(W,Z,ce,we,Le,ze,qe,Re){super(W,Z,ce,we,Le,ze,qe,Re)}};e.$xq=pe,e.$xq=pe=We([je(0,o.$oq),je(1,d.$bq),je(2,b.$fk),je(3,y.$Ri),je(4,l.$em),je(5,m.$fl),je(6,p.$yk),je(7,S.$ej)],pe);let x=class extends Y{constructor(W,Z,ce,we,Le,ze,qe){super(void 0,W,Z,ce,we,Le,ze,qe)}};e.$yq=x,e.$yq=x=We([je(0,d.$bq),je(1,b.$fk),je(2,y.$Ri),je(3,l.$em),je(4,m.$fl),je(5,p.$yk),je(6,S.$ej)],x)}),define(Te[250],Oe([1,0,6,2,33,59]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hS=e.$gS=void 0;class D{constructor(s,S){this.a=s,this.b=S}listen(s,S){const y=this.b(s);switch(S){case"onDidChangeProfiles":return t.Event.map(this.a.onDidChangeProfiles,$=>({all:$.all.map(g=>(0,P.$Un)({...g},y)),added:$.added.map(g=>(0,P.$Un)({...g},y)),removed:$.removed.map(g=>(0,P.$Un)({...g},y)),updated:$.updated.map(g=>(0,P.$Un)({...g},y))}))}throw new Error(`Invalid listen ${S}`)}async call(s,S,y){const $=this.b(s);switch(S){case"createProfile":{const g=await this.a.createProfile(y[0],y[1],y[2]);return(0,P.$Un)({...g},$)}case"updateProfile":{let g=(0,E.$Sl)((0,P.$Vn)(y[0],$),this.a.profilesHome.scheme);return g=await this.a.updateProfile(g,y[1]),(0,P.$Un)({...g},$)}case"removeProfile":{const g=(0,E.$Sl)((0,P.$Vn)(y[0],$),this.a.profilesHome.scheme);return this.a.removeProfile(g)}}throw new Error(`Invalid call ${S}`)}}e.$gS=D;class T extends r.$Zc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(s,S,y){super(),this.profilesHome=S,this.f=y,this.a=[],this.b=this.B(new t.$qe),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=s.map($=>(0,E.$Sl)($,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")($=>{const g=$.added.map(m=>(0,E.$Sl)(m,this.profilesHome.scheme)),a=$.removed.map(m=>(0,E.$Sl)(m,this.profilesHome.scheme)),c=$.updated.map(m=>(0,E.$Sl)(m,this.profilesHome.scheme));this.a=$.all.map(m=>(0,E.$Sl)(m,this.profilesHome.scheme)),this.b.fire({added:g,removed:a,updated:c,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(s){this.c=s}isEnabled(){return this.c}async createNamedProfile(s,S,y){const $=await this.f.call("createNamedProfile",[s,S,y]);return(0,E.$Sl)($,this.profilesHome.scheme)}async createProfile(s,S,y,$){const g=await this.f.call("createProfile",[s,S,y,$]);return(0,E.$Sl)(g,this.profilesHome.scheme)}async createTransientProfile(s){const S=await this.f.call("createTransientProfile",[s]);return(0,E.$Sl)(S,this.profilesHome.scheme)}async setProfileForWorkspace(s,S){await this.f.call("setProfileForWorkspace",[s,S])}removeProfile(s){return this.f.call("removeProfile",[s])}async updateProfile(s,S){const y=await this.f.call("updateProfile",[s,S]);return(0,E.$Sl)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$hS=T}),define(Te[144],Oe([1,0,4,27,15,11,228,35,33,10,229]),function(ue,e,t,r,E,P,D,T,v,s,S){"use strict";var y,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$$R=e.$0R=e.$9R=void 0;let g=class extends v.$Ul{static{y=this}static{this.a="profileAssociationsMigration"}constructor(b,p,d,w,o){super(d,w,p,o),this.U=b,this.W=d}O(){return this.U.getItem(y.b,[]).map(p=>({...p,location:(0,s.$jg)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):t.URI.revive(p.location)}))}Q(){const b=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?b:this.N(b)}S(){return this.w.extUri.joinPath(t.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$9R=g,e.$9R=g=y=We([je(0,D.$4R),je(1,T.$Pl),je(2,r.$Si),je(3,E.$fl),je(4,P.$fk)],g);let a=$=class extends g{constructor(b,p,d,w,o){super(b,p,d,w,o),this.$=b}P(b){b.length?this.$.setItem($.b,b.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem($.b)}O(){const b=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(b),this.$.setItem("userDataProfilesMigration",!0)),b}R(b){b.emptyWindows||b.workspaces?this.$.setItem($.c,b):this.$.removeItem($.c)}Q(){const b="workspaceAndProfileInfo",p=this.$.getItem(b,void 0);if(p){this.$.removeItem(b);const w=p.reduce((o,{workspace:l,profile:n})=>(o[t.URI.revive(l).toString()]=t.URI.revive(n).toString(),o),{});this.$.setItem($.c,{workspaces:w})}const d=super.Q();return this.$.getItem($.a,!1)||(this.R(d),this.$.setItem($.a,!0)),d}};e.$0R=a,e.$0R=a=$=We([je(0,D.$5R),je(1,T.$Pl),je(2,r.$Si),je(3,E.$fl),je(4,P.$fk)],a);let c=class extends a{constructor(b,p,d,w){super(new S.$8R(S.SaveStrategy.IMMEDIATE,p,w,d),b,p,d,w)}async init(){return await this.$.init(),super.init()}};e.$$R=c,e.$$R=c=We([je(0,T.$Pl),je(1,r.$Si),je(2,E.$fl),je(3,P.$fk)],c)}),define(Te[145],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$4m=(0,t.$Ki)("extensionHostStatusService");class r{constructor(){this.a=new Map}setExitInfo(P,D){this.a.set(P,D)}getExitInfo(P){return this.a.get(P)||null}}e.$5m=r}),define(Te[251],Oe([1,0,60,6,13]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0;function P(T){let v=0,s=0,S=0;T>=1e3&&(S=Math.floor(T/1e3),T-=S*1e3),S>=60&&(s=Math.floor(S/60),S-=s*60),s>=60&&(v=Math.floor(s/60),s-=v*60);const y=v?`${v}h`:"",$=s?`${s}m`:"",g=S?`${S}s`:"",a=T?`${T}ms`:"";return`${y}${$}${g}${a}`}class D{constructor(v,s,S,y){this.i=v,this.j=s,this.a=new r.$qe,this.onClose=this.a.event,this.b=t.ProtocolConstants.ReconnectionGraceTime,this.c=t.ProtocolConstants.ReconnectionShortGraceTime,this.d=S,this.protocol=y,this.e=!1,this.f=new E.$Xh(()=>{this.k(`The reconnection grace time of ${P(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new E.$Xh(()=>{this.k(`The reconnection short grace time of ${P(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${P(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(v){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${v}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${P(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const v=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),v.end(),this.a.fire(void 0)}acceptReconnection(v,s,S){this.d=v,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(s,S),this.protocol.endAcceptReconnection()}}e.$Ln=D});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[146],Oe([1,0,12,8,180,26,61]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=S,D=$t(D);const T=(0,r.$oc)(t.$5g.asFileUri("").fsPath),v=(0,r.$oc)(T,"nls.messages.json"),s=new Map;async function S(y,$){if(!D.default.commit||!await P.Promises.exists(v))return{userLocale:"en",osLocale:"en",resolvedLanguage:"en",defaultMessagesFile:v,locale:"en",availableLanguages:{}};const g=`${y}||${$}`;let a=s.get(g);return a||(a=(0,E.resolveNLSConfiguration)({userLocale:y,osLocale:y,commit:D.default.commit,userDataPath:$,nlsMetadataPath:T}),s.set(g,a)),a}}),define(Te[147],Oe([1,0,19,4,27,54,63,15,5,11,29,35,33,146]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YR=void 0;let a=class extends D.$Wq{constructor(m,b,p,d,w,o,l,n){super(r.URI.file(w.builtinExtensionsPath),r.URI.file(w.extensionsPath),(0,t.$lh)(w.userHome,".vscode-oss-dev","extensions","control.json"),m.defaultProfile,m,b,p,d,w,o,l,n),this.S=w}async f(m){const b=await(0,g.$6m)(m,this.S.userDataPath);if(b.languagePack)try{const p=await this.w.readFile(r.URI.file(b.languagePack.translationsConfigFile));return JSON.parse(p.value.toString())}catch{}return Object.create(null)}};e.$YR=a,e.$YR=a=We([je(0,$.$Rl),je(1,P.$Rq),je(2,T.$fl),je(3,s.$fk),je(4,E.$Si),je(5,S.$yk),je(6,y.$Pl),je(7,v.$Ji)],a)}),define(Te[101],Oe([1,0,252,23,8,22,12,26]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=e.ServerConnectionTokenType=void 0,e.$Pn=g,e.$Qn=a,e.$Rn=c,t=Ve(t),r=Ve(r),E=Ve(E);const v=/^[0-9A-Za-z_-]+$/;var s;(function(m){m[m.None=0]="None",m[m.Optional=1]="Optional",m[m.Mandatory=2]="Mandatory"})(s||(e.ServerConnectionTokenType=s={}));class S{constructor(){this.type=s.None}validate(b){return!0}}e.$Mn=S;class y{constructor(b){this.value=b,this.type=s.Mandatory}validate(b){return b===this.value}}e.$Nn=y;class ${constructor(b){this.message=b}}e.$On=$;async function g(m,b){const p=m["without-connection-token"],d=m["connection-token"],w=m["connection-token-file"];if(p)return typeof d<"u"||typeof w<"u"?new $("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new S;if(typeof w<"u"){if(typeof d<"u")return new $("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let o;try{o=r.readFileSync(w).toString().replace(/\r?\n$/,"")}catch{return new $(`Unable to read the connection token file at '${w}'.`)}return v.test(o)?new y(o):new $(`The connection token defined in '${w} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof d<"u"?v.test(d)?new y(d):new $(`The connection token '${d} does not adhere to the characters 0-9, a-z, A-Z or -.`):new y(await b())}async function a(m){return g(m,async()=>{if(!m["user-data-dir"])return(0,P.$7g)();const p=E.$oc(m["user-data-dir"],"token");try{const o=(await r.promises.readFile(p)).toString().replace(/\r?\n$/,"");if(v.test(o))return o}catch{}const d=(0,P.$7g)();try{await T.Promises.writeFile(p,d,{mode:384})}catch{}return d})}function c(m,b,p){if(m.validate(p.query[D.$Wg]))return!0;const d=t.parse(b.headers.cookie||"");return m.validate(d[D.$Vg])}}),define(Te[55],Oe([1,0,7,119,71,5,27,79]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=void 0,t=Ve(t),e.$fn={host:{type:"string",cat:"o",args:"ip-address",description:t.localize(2504,null)},port:{type:"string",cat:"o",args:"port | port range",description:t.localize(2505,null)},"socket-path":{type:"string",cat:"o",args:"path",description:t.localize(2506,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:t.localize(2507,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:t.localize(2508,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:t.localize(2509,null)},"without-connection-token":{type:"boolean",cat:"o",description:t.localize(2510,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:t.localize(2511,null)},"server-data-dir":{type:"string",cat:"o",description:t.localize(2512,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:t.localize(2513,null)},"user-data-dir":E.$Hm["user-data-dir"],"enable-smoke-test-driver":E.$Hm["enable-smoke-test-driver"],"disable-telemetry":E.$Hm["disable-telemetry"],"disable-workspace-trust":E.$Hm["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:E.$Hm.log,logsPath:E.$Hm.logsPath,"force-disable-user-env":E.$Hm["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:t.localize(2514,null)},"default-workspace":{type:"string",description:t.localize(2515,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":E.$Hm["extensions-dir"],"extensions-download-dir":E.$Hm["extensions-download-dir"],"builtin-extensions-dir":E.$Hm["builtin-extensions-dir"],"install-extension":E.$Hm["install-extension"],"install-builtin-extension":E.$Hm["install-builtin-extension"],"update-extensions":E.$Hm["update-extensions"],"uninstall-extension":E.$Hm["uninstall-extension"],"list-extensions":E.$Hm["list-extensions"],"locate-extension":E.$Hm["locate-extension"],"show-versions":E.$Hm["show-versions"],category:E.$Hm.category,force:E.$Hm.force,"do-not-sync":E.$Hm["do-not-sync"],"pre-release":E.$Hm["pre-release"],"start-server":{type:"boolean",cat:"e",description:t.localize(2516,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:E.$Hm.help,version:E.$Hm.version,"locate-shell-integration-path":E.$Hm["locate-shell-integration-path"],compatibility:{type:"string"},_:E.$Hm._},e.$gn=(0,P.$Li)(D.$Ri);class v extends r.$cn{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$hn=v,We([T.$ci],v.prototype,"userRoamingDataHome",null)}),define(Te[253],Oe([1,0,23,68,93,252,96,36,69,3,11,55,8,12,22,29,101,47,18,4,14,10,34,64,124]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d,w,o,l,n,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pS=e.CacheControl=void 0,e.$nS=f,e.$oS=k,r=Ve(r),E=Ve(E),P=Ve(P),D=Ve(D);const i={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function f(C,L,R,M){L.writeHead(R,{"Content-Type":"text/plain"}),L.end(M)}var h;(function(C){C[C.NO_CACHING=0]="NO_CACHING",C[C.ETAG=1]="ETAG",C[C.NO_EXPIRY=2]="NO_EXPIRY"})(h||(e.CacheControl=h={}));async function k(C,L,R,M,G,Q){try{const te=await t.promises.stat(C);if(L===h.ETAG){const ve=`W/"${[te.ino,te.size,te.mtime.getTime()].join("-")}"`;if(M.headers["if-none-match"]===ve)return G.writeHead(304),void G.end();Q.Etag=ve}else L===h.NO_EXPIRY?Q["Cache-Control"]="public, max-age=31536000":L===h.NO_CACHING&&(Q["Cache-Control"]="no-store");Q["Content-Type"]=i[(0,$.$tc)(C)]||(0,v.$it)(C)||"text/plain",G.writeHead(200,Q),(0,t.createReadStream)(C).pipe(G)}catch(te){return te.code!=="ENOENT"?(R.error(te),console.error(te.toString())):console.error(`File not found: ${C}`),G.writeHead(404,{"Content-Type":"text/plain"}),void G.end("Not found")}}const I=(0,$.$rc)(g.$5g.asFileUri("").fsPath);let O=class{constructor(L,R,M,G,Q,te,ve,be){this.f=L,this.g=R,this.serverRootPath=M,this.h=G,this.i=Q,this.j=te,this.k=ve,this.l=be,this.a=this.k.extensionsGallery?.resourceUrlTemplate?d.URI.parse(this.k.extensionsGallery.resourceUrlTemplate):void 0,this.b=`${M}/static`,this.c=`${M}/callback`,this.d=`${M}/web-extension-resource`}async handle(L,R,M){try{const G=M.pathname;return G.startsWith(this.b)&&G.charCodeAt(this.b.length)===l.CharCode.Slash?this.m(L,R,M):G===this.g?this.p(L,R,M):G===this.c?this.r(R):G.startsWith(this.d)&&G.charCodeAt(this.d.length)===l.CharCode.Slash?this.o(L,R,M):f(L,R,404,"Not found.")}catch(G){return this.i.error(G),console.error(G.toString()),f(L,R,500,"Internal Server Error.")}}async m(L,R,M){const G=Object.create(null),te=decodeURIComponent(M.pathname).substring(this.b.length+1),ve=(0,$.$oc)(I,te);return(0,T.$Jg)(ve,I,!s.$n)?k(ve,this.h.isBuilt?h.NO_EXPIRY:h.ETAG,this.i,L,R,G):f(L,R,400,"Bad request.")}n(L){const R=L.authority.indexOf(".");return R!==-1?L.authority.substring(R+1):void 0}async o(L,R,M){if(!this.a)return f(L,R,500,"No extension gallery service configured.");const G=decodeURIComponent(M.pathname),Q=(0,$.$mc)(G.substring(this.d.length+1)),te=d.URI.parse(Q).with({scheme:this.a.scheme,authority:Q.substring(0,Q.indexOf("/")),path:Q.substring(Q.indexOf("/")+1)});if(this.n(this.a)!==this.n(te))return f(L,R,403,"Request Forbidden");const ve={},be=ee=>{const ae=L.headers[ee];ae&&((0,o.$jg)(ae)||ae[0])?ve[ee]=(0,o.$jg)(ae)?ae:ae[0]:ee!==ee.toLowerCase()&&be(ee.toLowerCase())};be("X-Client-Name"),be("X-Client-Version"),be("X-Machine-Id"),be("X-Client-Commit");const le=await this.j.request({type:"GET",url:te.toString(!0),headers:ve},p.CancellationToken.None),K=le.res.statusCode||500;if(K!==200){let ee=null;try{ee=await(0,b.$gq)(le)}catch{}return f(L,R,K,ee||`Request failed with status ${K}`)}const B=Object.create(null),j=ee=>{const ae=le.res.headers[ee];ae?B[ee]=ae:ee!==ee.toLowerCase()&&j(ee.toLowerCase())};j("Cache-Control"),j("Content-Type"),R.writeHead(200,B);const U=await(0,w.$5e)(le.stream);return void R.end(U.buffer)}async p(L,R,M){const G=M.query[g.$Wg];if(typeof G=="string"){const x=Object.create(null);x["Set-Cookie"]=P.serialize(g.$Vg,G,{sameSite:"lax",maxAge:60*60*24*7});const ie=Object.create(null);for(const Z in M.query)Z!==g.$Wg&&(ie[Z]=M.query[Z]);const W=E.format({pathname:M.pathname,query:ie});return x.Location=W,R.writeHead(302,x),void R.end()}const Q=x=>{const ie=L.headers[x];return Array.isArray(ie)?ie[0]:ie},te=!this.h.isBuilt&&this.h.args["use-test-resolver"],ve=te?"test+test":Q("x-original-host")||Q("x-forwarded-host")||L.headers.host;if(!ve)return f(L,R,400,"Bad request.");function be(x){return JSON.stringify(x).replace(/"/g,"&quot;")}let le;this.h.args["enable-smoke-test-driver"]&&(le=!1);const K=x=>x&&d.URI.file(r.resolve(x)).with({scheme:g.Schemas.vscodeRemote,authority:ve}),B=g.$5g.asFileUri(`vs/code/browser/workbench/workbench${this.h.isBuilt?"":"-dev"}.${n.$V?"esm.":""}html`).fsPath,j=!this.h.isBuilt&&this.h.args["github-auth"]?{id:(0,a.$7g)(),providerId:"github",accessToken:this.h.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,U={embedderIdentifier:"server-distro",extensionsGallery:this.a&&this.k.extensionsGallery?{...this.k.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:ve,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.h.isBuilt)try{const x=JSON.parse((await t.promises.readFile((0,$.$oc)(I,"product.overrides.json"))).toString());Object.assign(U,x)}catch{}const ee={remoteAuthority:ve,serverBasePath:this.g,_wrapWebWorkerExtHostInIframe:le,developmentOptions:{enableSmokeTestDriver:this.h.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.i.getLevel()},settingsSyncOptions:!this.h.isBuilt&&this.h.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.h.args["disable-workspace-trust"],folderUri:K(this.h.args["default-folder"]),workspaceUri:K(this.h.args["default-workspace"]),productConfiguration:U,callbackRoute:this.c},ye=P.parse(L.headers.cookie||"")["vscode.nls.locale"]||L.headers["accept-language"]?.split(",")[0]?.toLowerCase()||"en";let se,ne;!ye.startsWith("en")&&this.k.nlsCoreBaseUrl?(se=this.k.nlsCoreBaseUrl,ne=`${se}${this.k.commit}/${this.k.version}/${ye}/nls.messages.js`):ne="";const X={WORKBENCH_WEB_CONFIGURATION:be(ee),WORKBENCH_AUTH_SESSION:j?be(j):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_URL:ne,WORKBENCH_NLS_FALLBACK_URL:`${this.b}/out/nls.messages.js`};if(this.l.isEnabled){const x=await this.l.getCssModules();X.WORKBENCH_DEV_CSS_MODULES=JSON.stringify(x)}if(te){const x=[];for(const ie of["vscode-test-resolver","github-authentication"]){const W=JSON.parse((await t.promises.readFile(g.$5g.asFileUri(`${g.$Zg}/${ie}/package.json`).fsPath)).toString());x.push({extensionPath:ie,packageJSON:W})}X.WORKBENCH_BUILTIN_EXTENSIONS=be(x)}let z;try{z=(await t.promises.readFile(B)).toString().replace(/\{\{([^}]+)\}\}/g,(ie,W)=>X[W]??"undefined")}catch{return R.writeHead(404,{"Content-Type":"text/plain"}),void R.end("Not found")}const A=n.$V?"sha256-2Q+j4hfT09+1+imS46J2YlkCtHWQt0/BE79PXjJ0ZJ8=":"sha256-V28GQnL3aYxbwgpV3yW1oJ+VKKe/PBSzWntNyH8zVXA=",pe={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",n.$V?`script-src 'self' 'unsafe-eval' ${se??""} blob: 'nonce-1nline-m4p' ${this.q(z).join(" ")} '${A}' 'sha256-/r7rqQ+yrxt57sxLuQ6AMYcy/lUpvAIzHjIJt/OeLWU=' ${te?"":`http://${ve}`};`:`script-src 'self' 'unsafe-eval' ${se??""} ${this.q(z).join(" ")} '${A}' ${te?"":`http://${ve}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==m.ServerConnectionTokenType.None&&(pe["Set-Cookie"]=P.serialize(g.$Vg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),R.writeHead(200,pe),void R.end(z)}q(L){const R=/<script>([\s\S]+?)<\/script>/img,M=[];let G;for(;G=R.exec(L);){const Q=D.createHash("sha256"),te=G[1].replace(/\r\n/g,`
`),ve=Q.update(Buffer.from(te)).digest().toString("base64");M.push(`'sha256-${ve}'`)}return M}async r(L){const R=g.$5g.asFileUri("vs/code/browser/workbench/callback.html").fsPath,M=(await t.promises.readFile(R)).toString(),G=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.q(M).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return L.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":G}),void L.end(M)}};e.$pS=O,e.$pS=O=We([je(3,y.$gn),je(4,S.$fk),je(5,b.$bq),je(6,c.$yk),je(7,u.$jS)],O)}),define(Te[254],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Q=void 0,e.$3Q=(0,t.$Ki)("IExtHostInitDataService")}),define(Te[255],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NQ=e.$MQ=void 0,e.$MQ=(0,t.$Ki)("IExtHostRpcService");class r{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$NQ=r}),define(Te[76],Oe([1,0,59]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=E;function r(P){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:P,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function E(P){return new t.$Sn(r(P))}}),define(Te[256],Oe([1,0,3,44,4,76,59,116,231,8,101,19]),function(ue,e,t,r,E,P,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0,t=Ve(t),r=Ve(r);class ${static{this.a=1}constructor(a,c,m,b){this.b=a,this.c=c,this.d=m,this.e=b}async call(a,c,m){switch(c){case"getEnvironmentData":{const b=m,p=(0,P.$4s)(b.remoteAuthority);let d=await this.f(b.profile);return d=(0,D.$Un)(d,p),d}case"getExtensionHostExitInfo":{const b=m;return this.e.getExitInfo(b.reconnectionToken)}case"getDiagnosticInfo":{const b=m,p={machineInfo:(0,v.$8s)()},d=b.includeProcesses?(0,T.$6s)(process.pid):Promise.resolve();let w=[];const o={};if(b.folders){const l=(0,P.$4s)("");w=b.folders.map(u=>E.URI.revive(l.transformIncoming(u))).filter(u=>u.scheme==="file").map(u=>(0,v.$7s)(u.fsPath,["node_modules",".git"]).then(i=>{o[(0,s.$sc)(u.fsPath)]=i}))}return Promise.all([d,...w]).then(([l,n])=>(p.processes=l||void 0,p.workspaceMetadata=b.folders?o:void 0,p))}}throw new Error(`IPC Command ${c} not found`)}listen(a,c,m){throw new Error("Not supported")}async f(a){a&&!this.d.profiles.some(m=>m.id===a)&&await this.d.createProfile(a,a);let c=!1;if(process.platform==="linux"){const m=process.glibcVersion;c=(m?parseInt(m.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==S.ServerConnectionTokenType.None?this.b.value:"",appRoot:E.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,y.$lh)(this.c.logsHome,`exthost${$.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:t.OS,arch:process.arch,marks:r.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(m=>({...m}))},isUnsupportedGlibc:c}}}e.$$s=$}),define(Te[257],Oe([1,0,4,76,73,8,216]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=void 0;class T extends D.$_s{constructor(S,y){super(new E.$Br(S),S),this.N=y,this.M=new Map,this.B(this.a)}c(S){let y=this.M.get(S.remoteAuthority);return y||(y=(0,r.$4s)(S.remoteAuthority),this.M.set(S.remoteAuthority,y)),y}f(S,y,$=!1){if($&&y.path==="/vscode-resource"&&y.query){const g=JSON.parse(y.query).requestResourcePath;return t.URI.from({scheme:"file",path:g})}return t.URI.revive(S.transformIncoming(y))}L(S,y){return new v(S,y,this.b,this.N)}}e.$bt=T;class v extends D.$at{constructor(S,y,$,g){super(S,y,$,g)}j(S){const y=S.args["file-watcher-polling"];if(y){const $=y.split(P.$yc),g=Number($[0]);if(g>0)return{usePolling:$.length>1?$.slice(1):!0,pollingInterval:g}}}m(S){if(S.extensionsPath)return[P.$lc.join(S.extensionsPath,"**")]}}});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[102],Oe([1,0,7,10,4,2,5,37,15,12,45,188,58]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$HG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$xG=e.EditorInputCapabilities=e.$wG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=void 0,e.$nG=c,e.$oG=m,e.$pG=b,e.$qG=p,e.$rG=d,e.$sG=w,e.$tG=o,e.$uG=l,e.$vG=n,e.$yG=I,e.$zG=C,e.$AG=L,e.$BG=R,e.$CG=M,e.$DG=G,e.$EG=Q,e.$FG=te,e.$GG=j,e.$IG=ae,e.$JG=se,e.$KG=ne,e.$LG=X,$=$t($),e.$iG={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$jG={id:"default",displayName:(0,t.localize)(4055,null),providerDisplayName:(0,t.localize)(4056,null)},e.$kG="workbench.editor.sidebysideEditor",e.$lG="workbench.editors.textDiffEditor",e.$mG="workbench.editors.binaryResourceDiffEditor";var g;(function(z){z[z.PROGRAMMATIC=1]="PROGRAMMATIC",z[z.USER=2]="USER",z[z.EDIT=3]="EDIT",z[z.NAVIGATION=4]="NAVIGATION",z[z.JUMP=5]="JUMP"})(g||(e.EditorPaneSelectionChangeReason=g={}));var a;(function(z){z[z.IDENTICAL=1]="IDENTICAL",z[z.SIMILAR=2]="SIMILAR",z[z.DIFFERENT=3]="DIFFERENT"})(a||(e.EditorPaneSelectionCompareResult=a={}));function c(z){const A=z;return!!A&&typeof A.getSelection=="function"&&!!A.onDidChangeSelection}function m(z){const A=z;return!!A&&typeof A.getScrollPosition=="function"&&typeof A.setScrollPosition=="function"&&!!A.onDidChangeScroll}function b(z,A,Y){for(const pe of Y.visibleEditorPanes)if(pe.group.id===A&&z.matches(pe.input))return pe.getViewState()}function p(z){if(I(z))return!1;const A=z;return E.URI.isUri(A?.resource)}function d(z){if(I(z))return!1;const A=z;return A?.original!==void 0&&A.modified!==void 0}function w(z){if(I(z))return!1;const A=z;return!A||A.resources&&!Array.isArray(A.resources)?!1:!!A.resources||!!A.multiDiffSource}function o(z){if(I(z)||d(z))return!1;const A=z;return A?.primary!==void 0&&A.secondary!==void 0}function l(z){if(I(z))return!1;const A=z;return A?A.resource===void 0||A.resource.scheme===s.Schemas.untitled||A.forceUntitled===!0:!1}function n(z){if(I(z))return!1;const A=z;return E.URI.isUri(A?.base?.resource)&&E.URI.isUri(A?.input1?.resource)&&E.URI.isUri(A?.input2?.resource)&&E.URI.isUri(A?.result?.resource)}var u;(function(z){z[z.SHORT=0]="SHORT",z[z.MEDIUM=1]="MEDIUM",z[z.LONG=2]="LONG"})(u||(e.Verbosity=u={}));var i;(function(z){z[z.EXPLICIT=1]="EXPLICIT",z[z.AUTO=2]="AUTO",z[z.FOCUS_CHANGE=3]="FOCUS_CHANGE",z[z.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class f{constructor(){this.a=new Map}registerSource(A,Y){let pe=this.a.get(A);return pe||(pe={source:A,label:Y},this.a.set(A,pe)),pe.source}getSourceLabel(A){return this.a.get(A)?.label??A}}e.$wG=new f;var h;(function(z){z[z.None=0]="None",z[z.Readonly=2]="Readonly",z[z.Untitled=4]="Untitled",z[z.Singleton=8]="Singleton",z[z.RequiresTrust=16]="RequiresTrust",z[z.CanSplitInGroup=32]="CanSplitInGroup",z[z.ForceDescription=64]="ForceDescription",z[z.CanDropIntoEditor=128]="CanDropIntoEditor",z[z.MultipleEditors=256]="MultipleEditors",z[z.Scratchpad=512]="Scratchpad"})(h||(e.EditorInputCapabilities=h={}));class k extends P.$Zc{}e.$xG=k;function I(z){return z instanceof k}function O(z){const A=z;return E.URI.isUri(A?.preferredResource)}function C(z){const A=z;return I(A?.primary)&&I(A?.secondary)}function L(z){const A=z;return I(A?.modified)&&I(A?.original)}function R(z,A,Y,pe,x){return X(pe,[(0,y.$uj)({id:"workbench.action.openLargeFile",label:(0,t.localize)(4057,null),run:()=>{const ie={...Y,limits:{size:Number.MAX_VALUE}};z.openEditor(A,ie)}}),(0,y.$uj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,t.localize)(4058,null),run:()=>x.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}function M(z){return I(z?.editor)}function G(z){const A=z;return M(z)&&A?.group!==void 0}function Q(z){const A=z;return typeof A?.groupId=="number"&&I(A.editor)}function te(z){return typeof z?.groupId=="number"}var ve;(function(z){z[z.UNKNOWN=0]="UNKNOWN",z[z.REPLACE=1]="REPLACE",z[z.MOVE=2]="MOVE",z[z.UNPIN=3]="UNPIN"})(ve||(e.EditorCloseContext=ve={}));var be;(function(z){z[z.GROUP_ACTIVE=0]="GROUP_ACTIVE",z[z.GROUP_INDEX=1]="GROUP_INDEX",z[z.GROUP_LABEL=2]="GROUP_LABEL",z[z.GROUP_LOCKED=3]="GROUP_LOCKED",z[z.EDITORS_SELECTION=4]="EDITORS_SELECTION",z[z.EDITOR_OPEN=5]="EDITOR_OPEN",z[z.EDITOR_CLOSE=6]="EDITOR_CLOSE",z[z.EDITOR_MOVE=7]="EDITOR_MOVE",z[z.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",z[z.EDITOR_LABEL=9]="EDITOR_LABEL",z[z.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",z[z.EDITOR_PIN=11]="EDITOR_PIN",z[z.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",z[z.EDITOR_STICKY=13]="EDITOR_STICKY",z[z.EDITOR_DIRTY=14]="EDITOR_DIRTY",z[z.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(be||(e.GroupModelChangeKind=be={}));var le;(function(z){z[z.PRIMARY=1]="PRIMARY",z[z.SECONDARY=2]="SECONDARY",z[z.BOTH=3]="BOTH",z[z.ANY=4]="ANY"})(le||(e.SideBySideEditor=le={}));class K{getOriginalUri(A,Y){if(!A)return;if(n(A))return e.$HG.getOriginalUri(A.result,Y);if(Y?.supportSideBySide){const{primary:x,secondary:ie}=this.a(A);if(x&&ie){if(Y?.supportSideBySide===le.BOTH)return{primary:this.getOriginalUri(x,{filterByScheme:Y.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:Y.filterByScheme})};if(Y?.supportSideBySide===le.ANY)return this.getOriginalUri(x,{filterByScheme:Y.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:Y.filterByScheme});A=Y.supportSideBySide===le.PRIMARY?x:ie}}if(d(A)||w(A)||o(A)||n(A))return;const pe=O(A)?A.preferredResource:A.resource;return!pe||!Y||!Y.filterByScheme?pe:this.b(pe,Y.filterByScheme)}a(A){return C(A)||o(A)?{primary:A.primary,secondary:A.secondary}:L(A)||d(A)?{primary:A.modified,secondary:A.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(A,Y){if(!A)return;if(n(A))return e.$HG.getCanonicalUri(A.result,Y);if(Y?.supportSideBySide){const{primary:x,secondary:ie}=this.a(A);if(x&&ie){if(Y?.supportSideBySide===le.BOTH)return{primary:this.getCanonicalUri(x,{filterByScheme:Y.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:Y.filterByScheme})};if(Y?.supportSideBySide===le.ANY)return this.getCanonicalUri(x,{filterByScheme:Y.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:Y.filterByScheme});A=Y.supportSideBySide===le.PRIMARY?x:ie}}if(d(A)||w(A)||o(A)||n(A))return;const pe=A.resource;return!pe||!Y||!Y.filterByScheme?pe:this.b(pe,Y.filterByScheme)}b(A,Y){if(Array.isArray(Y)){if(Y.some(pe=>A.scheme===pe))return A}else if(Y===A.scheme)return A}}var B;(function(z){z[z.UNKNOWN=0]="UNKNOWN",z[z.KEYBOARD=1]="KEYBOARD",z[z.MOUSE=2]="MOUSE"})(B||(e.EditorCloseMethod=B={}));function j(z,A,Y,pe){if(!z.isSticky(A))return!1;switch(pe.preventPinnedEditorClose){case"keyboardAndMouse":return Y===B.MOUSE||Y===B.KEYBOARD;case"mouse":return Y===B.MOUSE;case"keyboard":return Y===B.KEYBOARD}return!1}e.$HG=new K;var U;(function(z){z[z.LEFT=0]="LEFT",z[z.RIGHT=1]="RIGHT"})(U||(e.CloseDirection=U={}));class ee{constructor(){this.c=new Map,this.d=new Map}start(A){const Y=this.a=A.get(D.$Ji);for(const[pe,x]of this.c)this.e(pe,x,Y);this.c.clear()}e(A,Y,pe){const x=pe.createInstance(Y);this.d.set(A,x)}registerFileEditorFactory(A){if(this.b)throw new Error("Can only register one file editor factory.");this.b=A}getFileEditorFactory(){return(0,r.$ug)(this.b)}registerEditorSerializer(A,Y){if(this.c.has(A)||this.d.has(A))throw new Error(`A editor serializer with type ID '${A}' was already registered.`);return this.a?this.e(A,Y,this.a):this.c.set(A,Y),(0,P.$Xc)(()=>{this.c.delete(A),this.d.delete(A)})}getEditorSerializer(A){return this.d.get(typeof A=="string"?A:A.typeId)}}T.$xo.add(e.$iG.EditorFactory,new ee);async function ae(z,A,Y){return!z||!z.length?[]:await Promise.all(z.map(async pe=>{const x=E.URI.revive(pe.fileUri);if(!x){Y.info("Cannot resolve the path because it is not valid.",pe);return}if(!await A.canHandleResource(x)){Y.info("Cannot resolve the path because it cannot be handled",pe);return}let W=pe.exists,Z=pe.type;if(typeof W!="boolean"||typeof Z!="number")try{Z=(await A.stat(x)).isDirectory?v.FileType.Directory:v.FileType.Unknown,W=!0}catch(we){Y.error(we),W=!1}if(!W&&pe.openOnlyIfExists){Y.info("Cannot resolve the path because it does not exist",pe);return}if(Z===v.FileType.Directory){Y.info("Cannot resolve the path because it is a directory",pe);return}const ce={...pe.options,pinned:!0};return W?{resource:x,options:ce}:{resource:x,options:ce,forceUntitled:!0}}))}var ye;(function(z){z[z.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",z[z.SEQUENTIAL=1]="SEQUENTIAL"})(ye||(e.EditorsOrder=ye={}));function se(z){const A=z;if(!A)return!1;const Y=A;if(Y.modified)return se(Y.modified);const pe=A;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}function ne(z){return(0,S.$wj)(z)}function X(z,A,Y){const pe=(0,S.$xj)(z,A);return pe.forceMessage=Y?.forceMessage,pe.forceSeverity=Y?.forceSeverity,pe.allowDialog=Y?.allowDialog,pe}}),define(Te[258],Oe([1,0,7,41]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=void 0,e.$XG=new r.$2j("chatSessionResponseVote","",{type:"string",description:(0,t.localize)(4716,null)}),e.$YG=new r.$2j("chatVoteUpEnabled",!1,{type:"boolean",description:(0,t.localize)(4717,null)}),e.$ZG=new r.$2j("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,t.localize)(4718,null)}),e.$1G=new r.$2j("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,t.localize)(4719,null)}),e.$2G=new r.$2j("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,t.localize)(4720,null)}),e.$3G=new r.$2j("chatSessionResponseError",!1,{type:"boolean",description:(0,t.localize)(4721,null)}),e.$4G=new r.$2j("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,t.localize)(4722,null)}),e.$5G=new r.$2j("chatResponse",!1,{type:"boolean",description:(0,t.localize)(4723,null)}),e.$6G=new r.$2j("chatRequest",!1,{type:"boolean",description:(0,t.localize)(4724,null)}),e.$7G=new r.$2j("chatEditApplied",!1,{type:"boolean",description:(0,t.localize)(4725,null)}),e.$8G=new r.$2j("chatInputHasText",!1,{type:"boolean",description:(0,t.localize)(4726,null)}),e.$9G=new r.$2j("chatInputHasFocus",!1,{type:"boolean",description:(0,t.localize)(4727,null)}),e.$0G=new r.$2j("inChatInput",!1,{type:"boolean",description:(0,t.localize)(4728,null)}),e.$$G=new r.$2j("inChat",!1,{type:"boolean",description:(0,t.localize)(4729,null)}),e.$_G=new r.$2j("chatIsEnabled",!1,{type:"boolean",description:(0,t.localize)(4730,null)}),e.$aH=new r.$2j("chatPanelParticipantRegistered",!1,{type:"boolean",description:(0,t.localize)(4731,null)}),e.$bH=new r.$2j("chatExtensionInvalid",!1,{type:"boolean",description:(0,t.localize)(4732,null)}),e.$cH=new r.$2j("chatCursorAtTop",!1),e.$dH=new r.$2j("chatInputHasAgent",!1),e.$eH=new r.$2j("chatLocation",void 0),e.$fH=new r.$2j("quickChatHasFocus",!1,{type:"boolean",description:(0,t.localize)(4733,null)})}),define(Te[259],Oe([1,0,104,13,18,6,39,2,49,169,16,41,21,5,11,29,47,100,258]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.ChatAgentLocation=void 0,e.$oI=u,e.$pI=i;var w;(function(f){f.Panel="panel",f.Terminal="terminal",f.Notebook="notebook",f.Editor="editor"})(w||(e.ChatAgentLocation=w={})),function(f){function h(k){switch(k){case"panel":return f.Panel;case"terminal":return f.Terminal;case"notebook":return f.Notebook;case"editor":return f.Editor}return f.Panel}f.fromRaw=h}(w||(e.ChatAgentLocation=w={})),e.$jI=(0,g.$Ki)("chatAgentService");let o=class{static{this.AGENT_LEADER="@"}constructor(h){this.g=h,this.b=new Map,this.d=new P.$qe,this.onDidChangeAgents=this.d.event,this.h=new Map,this.j=new Map,this.e=p.$_G.bindTo(this.g),this.f=p.$aH.bindTo(this.g)}registerAgent(h,k){if(this.getAgent(h))throw new Error(`Agent already registered: ${JSON.stringify(h)}`);k.isDefault&&this.f.set(!0);const O=this,C=k.slashCommands;k={...k,get slashCommands(){return C.filter(R=>!R.when||O.g.contextMatchesRules(y.$Ij.deserialize(R.when)))}};const L={data:k};return this.b.set(h,L),this.d.fire(void 0),(0,T.$Xc)(()=>{this.b.delete(h),k.isDefault&&this.f.set(!1),this.d.fire(void 0)})}registerAgentImplementation(h,k){const I=this.b.get(h);if(!I)throw new Error(`Unknown agent: ${JSON.stringify(h)}`);if(I.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(h)}`);return I.data.isDefault&&this.e.set(!0),I.impl=k,this.d.fire(new l(I.data,k)),(0,T.$Xc)(()=>{I.impl=void 0,this.d.fire(void 0),I.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(h,k){h.isDynamic=!0;const I={data:h,impl:k};return this.b.set(h.id,I),this.d.fire(new l(h,k)),(0,T.$Xc)(()=>{this.b.delete(h.id),this.d.fire(void 0)})}registerAgentCompletionProvider(h,k){return this.h.set(h,k),{dispose:()=>{this.h.delete(h)}}}async getAgentCompletionItems(h,k,I){return await this.h.get(h)?.(k,I)??[]}updateAgent(h,k){const I=this.b.get(h);if(!I?.impl)throw new Error(`No activated agent with id ${JSON.stringify(h)} registered`);I.data.metadata={...I.data.metadata,...k},this.d.fire(new l(I.data,I.impl))}getDefaultAgent(h){return(0,t.$jb)(this.getActivatedAgents(),k=>!!k.isDefault&&k.locations.includes(h))}getContributedDefaultAgent(h){return this.getAgents().find(k=>!!k.isDefault&&k.locations.includes(h))}getSecondaryAgent(){return D.Iterable.find(this.b.values(),h=>!!h.data.metadata.isSecondary)?.data}getAgent(h){if(this.i(h))return this.b.get(h)?.data}i(h){const k=this.b.get(h);return!k?.data.when||this.g.contextMatchesRules(y.$Ij.deserialize(k.data.when))}getAgentByFullyQualifiedId(h){const k=D.Iterable.find(this.b.values(),I=>u(I.data)===h)?.data;if(!(k&&!this.i(k.id)))return k}getAgents(){return Array.from(this.b.values()).map(h=>h.data).filter(h=>this.i(h.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(h=>!!h.impl).filter(h=>this.i(h.data.id)).map(h=>new l(h.data,h.impl))}getAgentsByName(h){return this.getAgents().filter(k=>k.name===h)}agentHasDupeName(h){const k=this.getAgent(h);return k?this.getAgentsByName(k.name).filter(I=>I.extensionId.value!==k.extensionId.value).length>0:!1}async invokeAgent(h,k,I,O,C){const L=this.b.get(h);if(!L?.impl)throw new Error(`No activated agent with id "${h}"`);return await L.impl.invoke(k,I,O,C)}async getFollowups(h,k,I,O,C){const L=this.b.get(h);if(!L?.impl)throw new Error(`No activated agent with id "${h}"`);return L.impl?.provideFollowups?L.impl.provideFollowups(k,I,O,C):[]}async getChatTitle(h,k,I){const O=this.b.get(h);if(!O?.impl)throw new Error(`No activated agent with id "${h}"`);if(O.impl?.provideChatTitle)return O.impl.provideChatTitle(k,I)}registerChatParticipantDetectionProvider(h,k){return this.j.set(h,k),(0,T.$Xc)(()=>{this.j.delete(h)})}hasChatParticipantDetectionProviders(){return this.j.size>0}async detectAgentOrCommand(h,k,I,O){const C=D.Iterable.first(this.j.values());if(!C)return;const L=this.getAgents().reduce((Q,te)=>{Q.push({participant:te.id,disambiguation:te.disambiguation??[]});for(const ve of te.slashCommands)Q.push({participant:te.id,command:ve.name,disambiguation:ve.disambiguation??[]});return Q},[]),R=await C.provideParticipantDetection(h,k,{...I,participants:L},O);if(!R)return;const M=this.getAgent(R.participant);if(!M)return;if(!R.command)return{agent:M};const G=M?.slashCommands.find(Q=>Q.name===R.command);if(G)return{agent:M,command:G}}};e.$kI=o,e.$kI=o=We([je(0,y.$3j)],o);class l{constructor(h,k){this.b=h,this.d=k}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}get disambiguation(){return this.b.disambiguation}async invoke(h,k,I,O){return this.d.invoke(h,k,I,O)}async provideFollowups(h,k,I,O){return this.d.provideFollowups?this.d.provideFollowups(h,k,I,O):[]}provideWelcomeMessage(h,k){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(h,k)}provideSampleQuestions(h,k){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(h,k)}toJSON(){return this.b}}e.$lI=l,e.$mI=(0,g.$Ki)("chatAgentNameService");let n=class{static{d=this}static{this.b="chat.participantNameRegistry"}constructor(h,k,I,O){if(this.g=k,this.h=I,this.i=O,this.e=(0,s.$$d)(this,Object.create(null)),this.f=!1,!h.chatParticipantRegistry)return;this.d=h.chatParticipantRegistry;const C=O.get(d.b,b.StorageScope.APPLICATION);try{this.e.set(JSON.parse(C??"{}"),void 0)}catch{O.remove(d.b,b.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(h=>this.h.warn("Failed to fetch chat participant registry",h)).then(()=>(0,r.$Lh)(5*60*1e3)).then(()=>this.j())}async k(){const h=await this.g.request({type:"GET",url:this.d},E.CancellationToken.None);if(h.res.statusCode!==200)throw new Error("Could not get extensions report.");const k=await(0,m.$hq)(h);if(!k||k.version!==1)throw new Error("Unexpected chat participant registry response.");const I=k.restrictedChatParticipants;this.e.set(I,void 0),this.i.store(d.b,JSON.stringify(I),b.StorageScope.APPLICATION,b.StorageTarget.MACHINE)}getAgentNameRestriction(h){const k=this.l(h.name,h).get(),I=!h.fullName||this.l(h.fullName.replace(/\s/g,""),h).get();return k&&I}l(h,k){return this.e.map(O=>O[h.toLowerCase()]).map(O=>O?O.some(C=>(0,S.$Kf)(C,C.includes(".")?k.extensionId.value:k.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$nI=n,e.$nI=n=d=We([je(0,c.$yk),je(1,m.$bq),je(2,a.$fk),je(3,b.$oq)],n);function u(f){return`${f.extensionId.value}.${f.id}`}function i(f){const h="name"in f?f:{...f,name:f.id};return"extensionPublisherId"in h||(h.extensionPublisherId=h.extensionPublisher??""),"extensionDisplayName"in h||(h.extensionDisplayName=""),"extensionId"in h||(h.extensionId=new $.$xn("")),(0,v.$hi)(h)}}),define(Te[260],Oe([1,0,4,7,41,5]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$aL=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$$K=e.MemoryRangeType=e.State=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=void 0,e.$0K=v,e.$_K=S,r=Ve(r),e.$XJ="workbench.view.debug",e.$YJ="workbench.debug.variablesView",e.$ZJ="workbench.debug.watchExpressionsView",e.$1J="workbench.debug.callStackView",e.$2J="workbench.debug.loadedScriptsView",e.$3J="workbench.debug.breakPointsView",e.$4J="workbench.debug.disassemblyView",e.$5J="workbench.panel.repl",e.$6J="workbench.panel.repl.view",e.$7J=new E.$2j("debugType",void 0,{type:"string",description:r.localize(5734,null)}),e.$8J=new E.$2j("debugConfigurationType",void 0,{type:"string",description:r.localize(5735,null)}),e.$9J=new E.$2j("debugState","inactive",{type:"string",description:r.localize(5736,null)}),e.$0J="debugUx",e.$$J=new E.$2j(e.$0J,"default",{type:"string",description:r.localize(5737,null)}),e.$_J=new E.$2j("hasDebugged",!1,{type:"boolean",description:r.localize(5738,null)}),e.$aK=new E.$2j("inDebugMode",!1,{type:"boolean",description:r.localize(5739,null)}),e.$bK=new E.$2j("inDebugRepl",!1,{type:"boolean",description:r.localize(5740,null)}),e.$cK=new E.$2j("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(5741,null)}),e.$dK=new E.$2j("inBreakpointWidget",!1,{type:"boolean",description:r.localize(5742,null)}),e.$eK=new E.$2j("breakpointsFocused",!0,{type:"boolean",description:r.localize(5743,null)}),e.$fK=new E.$2j("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(5744,null)}),e.$gK=new E.$2j("watchExpressionsExist",!1,{type:"boolean",description:r.localize(5745,null)}),e.$hK=new E.$2j("variablesFocused",!0,{type:"boolean",description:r.localize(5746,null)}),e.$iK=new E.$2j("expressionSelected",!1,{type:"boolean",description:r.localize(5747,null)}),e.$jK=new E.$2j("breakpointInputFocused",!1,{type:"boolean",description:r.localize(5748,null)}),e.$kK=new E.$2j("callStackItemType",void 0,{type:"string",description:r.localize(5749,null)}),e.$lK=new E.$2j("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(5750,null)}),e.$mK=new E.$2j("callStackItemStopped",!1,{type:"boolean",description:r.localize(5751,null)}),e.$nK=new E.$2j("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(5752,null)}),e.$oK=new E.$2j("watchItemType",void 0,{type:"string",description:r.localize(5753,null)}),e.$pK=new E.$2j("canViewMemory",void 0,{type:"boolean",description:r.localize(5754,null)}),e.$qK=new E.$2j("breakpointItemType",void 0,{type:"string",description:r.localize(5755,null)}),e.$rK=new E.$2j("breakpointItemBytes",void 0,{type:"boolean",description:r.localize(5756,null)}),e.$sK=new E.$2j("breakpointHasModes",!1,{type:"boolean",description:r.localize(5757,null)}),e.$tK=new E.$2j("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(5758,null)}),e.$uK=new E.$2j("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(5759,null)}),e.$vK=new E.$2j("loadedScriptsItemType",void 0,{type:"string",description:r.localize(5760,null)}),e.$wK=new E.$2j("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(5761,null)}),e.$xK=new E.$2j("focusedSessionIsNoDebug",!1,{type:"boolean",description:r.localize(5762,null)}),e.$yK=new E.$2j("stepBackSupported",!1,{type:"boolean",description:r.localize(5763,null)}),e.$zK=new E.$2j("restartFrameSupported",!1,{type:"boolean",description:r.localize(5764,null)}),e.$AK=new E.$2j("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(5765,null)}),e.$BK=new E.$2j("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(5766,null)}),e.$CK=new E.$2j("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(5767,null)}),e.$DK=new E.$2j("breakpointsExist",!1,{type:"boolean",description:r.localize(5768,null)}),e.$EK=new E.$2j("debuggersAvailable",!1,{type:"boolean",description:r.localize(5769,null)}),e.$FK=new E.$2j("debugExtensionAvailable",!0,{type:"boolean",description:r.localize(5770,null)}),e.$GK=new E.$2j("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(5771,null)}),e.$HK=new E.$2j("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(5772,null)}),e.$IK=new E.$2j("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:r.localize(5773,null)}),e.$JK=new E.$2j("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(5774,null)}),e.$KK=new E.$2j("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(5775,null)}),e.$LK=new E.$2j("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(5776,null)}),e.$MK=new E.$2j("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(5777,null)}),e.$NK=new E.$2j("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(5778,null)}),e.$OK=new E.$2j("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(5779,null)}),e.$PK=new E.$2j("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(5780,null)}),e.$QK=new E.$2j("variableIsReadonly",!1,{type:"boolean",description:r.localize(5781,null)}),e.$RK=new E.$2j("variableValue",!1,{type:"string",description:r.localize(5782,null)}),e.$SK=new E.$2j("variableType",!1,{type:"string",description:r.localize(5783,null)}),e.$TK=new E.$2j("variableInterfaces",!1,{type:"array",description:r.localize(5784,null)}),e.$UK=new E.$2j("variableName",!1,{type:"string",description:r.localize(5785,null)}),e.$VK=new E.$2j("variableLanguage",!1,{type:"string",description:r.localize(5786,null)}),e.$WK=new E.$2j("variableExtensionId",!1,{type:"string",description:r.localize(5787,null)}),e.$XK=new E.$2j("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(5788,null)}),e.$YK=new E.$2j("multiSessionRepl",!1,{type:"boolean",description:r.localize(5789,null)}),e.$ZK=new E.$2j("multiSessionDebug",!1,{type:"boolean",description:r.localize(5790,null)}),e.$1K=new E.$2j("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(5791,null)}),e.$2K=new E.$2j("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(5792,null)}),e.$3K=new E.$2j("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(5793,null)}),e.$4K=new E.$2j("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(5794,null)});const D=d=>r.localize(5795,null,d);e.$5K=D,e.$6K="editor.contrib.debug",e.$7K="editor.contrib.breakpoint",e.$8K="debug",e.$9K={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(5796,null)};var T;(function(d){d[d.Inactive=0]="Inactive",d[d.Initializing=1]="Initializing",d[d.Stopped=2]="Stopped",d[d.Running=3]="Running"})(T||(e.State=T={}));function v(d){switch(d){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var s;(function(d){d[d.Valid=0]="Valid",d[d.Unreadable=1]="Unreadable",d[d.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$$K="vscode-debug-memory";function S(d){const w=d.presentationHint??d.source.presentationHint;return w==="deemphasize"||w==="subtle"}var y;(function(d){d[d.Variable=0]="Variable",d[d.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var $;(function(d){d[d.Initial=1]="Initial",d[d.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var g;(function(d){d.UnverifiedBreakpoints="unverifiedBreakpoints"})(g||(e.DebuggerString=g={})),e.$aL=(0,P.$Ki)("debugService");var a;(function(d){d[d.CONDITION=0]="CONDITION",d[d.HIT_COUNT=1]="HIT_COUNT",d[d.LOG_MESSAGE=2]="LOG_MESSAGE",d[d.TRIGGER_POINT=3]="TRIGGER_POINT"})(a||(e.BreakpointWidgetContext=a={}));var c;(function(d){d[d.Command=0]="Command",d[d.Tree=1]="Tree"})(c||(e.DebugVisualizationType=c={}));var m;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var b;(function(d){d.deserialize=w=>w,d.serialize=w=>w})(b||(e.IDebugVisualizationTreeItem=b={}));var p;(function(d){d.deserialize=w=>({id:w.id,name:w.name,iconPath:w.iconPath&&{light:t.URI.revive(w.iconPath.light),dark:t.URI.revive(w.iconPath.dark)},iconClass:w.iconClass,visualization:w.visualization}),d.serialize=w=>w})(p||(e.IDebugVisualization=p={}))}),define(Te[261],Oe([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0,e.$dR=(0,t.$Ki)("environmentVariableService")}),define(Te[148],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelRequest=e.RemoteTerminalChannelEvent=e.$zR=void 0,e.$zR="remoteterminal";var t;(function(E){E.OnPtyHostExitEvent="$onPtyHostExitEvent",E.OnPtyHostStartEvent="$onPtyHostStartEvent",E.OnPtyHostUnresponsiveEvent="$onPtyHostUnresponsiveEvent",E.OnPtyHostResponsiveEvent="$onPtyHostResponsiveEvent",E.OnPtyHostRequestResolveVariablesEvent="$onPtyHostRequestResolveVariablesEvent",E.OnProcessDataEvent="$onProcessDataEvent",E.OnProcessReadyEvent="$onProcessReadyEvent",E.OnProcessExitEvent="$onProcessExitEvent",E.OnProcessReplayEvent="$onProcessReplayEvent",E.OnProcessOrphanQuestion="$onProcessOrphanQuestion",E.OnExecuteCommand="$onExecuteCommand",E.OnDidRequestDetach="$onDidRequestDetach",E.OnDidChangeProperty="$onDidChangeProperty"})(t||(e.RemoteTerminalChannelEvent=t={}));var r;(function(E){E.RestartPtyHost="$restartPtyHost",E.CreateProcess="$createProcess",E.AttachToProcess="$attachToProcess",E.DetachFromProcess="$detachFromProcess",E.ListProcesses="$listProcesses",E.GetLatency="$getLatency",E.GetPerformanceMarks="$getPerformanceMarks",E.OrphanQuestionReply="$orphanQuestionReply",E.AcceptPtyHostResolvedVariables="$acceptPtyHostResolvedVariables",E.Start="$start",E.Input="$input",E.AcknowledgeDataEvent="$acknowledgeDataEvent",E.Shutdown="$shutdown",E.Resize="$resize",E.ClearBuffer="$clearBuffer",E.GetInitialCwd="$getInitialCwd",E.GetCwd="$getCwd",E.ProcessBinary="$processBinary",E.SendCommandResult="$sendCommandResult",E.InstallAutoReply="$installAutoReply",E.UninstallAllAutoReplies="$uninstallAllAutoReplies",E.GetDefaultSystemShell="$getDefaultSystemShell",E.GetProfiles="$getProfiles",E.GetEnvironment="$getEnvironment",E.GetWslPath="$getWslPath",E.GetTerminalLayoutInfo="$getTerminalLayoutInfo",E.SetTerminalLayoutInfo="$setTerminalLayoutInfo",E.SerializeTerminalState="$serializeTerminalState",E.ReviveTerminalProcesses="$reviveTerminalProcesses",E.GetRevivedPtyNewId="$getRevivedPtyNewId",E.SetUnicodeVersion="$setUnicodeVersion",E.ReduceConnectionGraceTime="$reduceConnectionGraceTime",E.UpdateIcon="$updateIcon",E.UpdateTitle="$updateTitle",E.UpdateProperty="$updateProperty",E.RefreshProperty="$refreshProperty",E.RequestDetachInstance="$requestDetachInstance",E.AcceptDetachInstanceReply="$acceptDetachInstanceReply",E.AcceptDetachedInstance="$acceptDetachedInstance",E.FreePortKillProcess="$freePortKillProcess"})(r||(e.RemoteTerminalChannelRequest=r={}))}),define(Te[262],Oe([1,0,8,4,70,53,3,138,10]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HR=s,e.$IR=y,e.$JR=a,e.$KR=c,e.$LR=m,e.$MR=p,e.$NR=d,e.$OR=w,e.$PR=o,t=Ve(t);function s(l,n){if(n)if(D.$l)for(const u in n){let i=u;for(const h in l)if(u.toLowerCase()===h.toLowerCase()){i=h;break}const f=n[u];f!==void 0&&S(l,i,f)}else Object.keys(n).forEach(u=>{const i=n[u];i!==void 0&&S(l,u,i)})}function S(l,n,u){typeof u=="string"?l[n]=u:delete l[n]}function y(l,n,u,i){l.TERM_PROGRAM="vscode",n&&(l.TERM_PROGRAM_VERSION=n),a(l,i)&&(l.LANG=c(u)),l.COLORTERM="truecolor"}function $(l,n){if(n)for(const u of Object.keys(n)){const i=n[u];i!=null&&(l[u]=i)}}async function g(l,n){return await Promise.all(Object.entries(n).map(async([u,i])=>{if(typeof i=="string")try{n[u]=await l(i)}catch{n[u]=i}})),n}function a(l,n){if(n==="on")return!0;if(n==="auto"){const u=l.LANG;return!u||u.search(/\.UTF\-8$/)===-1&&u.search(/\.utf8$/)===-1&&u.search(/\.euc.+/)===-1}return!1}function c(l){const n=l?l.split("-"):[],u=n.length;if(u===0)return"en_US.UTF-8";if(u===1){const i={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in i&&n.push(i[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}async function m(l,n,u,i,f,h){if(l.cwd){const I=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,O=await b(I,u);return(0,T.$ER)(O||I)}let k;return!l.ignoreConfigurationCwd&&f&&(u&&(f=await b(f,u,h)),f&&(t.$nc(f)?k=f:i&&(k=t.$oc(i.fsPath,f)))),k||(k=i?i.fsPath:n||""),(0,T.$ER)(k)}async function b(l,n,u){if(n)try{return await n(l)}catch(i){u?.error("Could not resolve terminal cwd",i);return}return l}function p(l,n,u){if(u)return i=>u.resolveWithEnvironment(n,l,i)}async function d(l,n,u,i,f,h){const k={};if(l.strictEnv)$(k,l.env);else{$(k,h);const I={...n};u&&(I&&await g(u,I),l.env&&await g(u,l.env)),D.$m&&(k.VSCODE_NODE_OPTIONS&&(k.NODE_OPTIONS=k.VSCODE_NODE_OPTIONS,delete k.VSCODE_NODE_OPTIONS),k.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(k.NODE_REPL_EXTERNAL_MODULE=k.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete k.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,E.$qm)(k,"VSCODE_IPC_HOOK_CLI"),s(k,I),s(k,l.env),y(k,i,D.$z,f)}return k}async function w(l,n,u,i,f,h,k=D.$l){let I;if((0,v.$jg)(l)?I=l:(I=l.fsPath,k&&h!==D.OperatingSystem.Windows?I=I.replace(/\\/g,"/"):!k&&h===D.OperatingSystem.Windows&&(I=I.replace(/\//g,"\\"))),!n)return I;const O=I.includes(" "),C=I.includes("(")||I.includes(")"),L=t.$sc(n,".exe"),R=L==="pwsh"||u==="pwsh"||L==="powershell"||u==="powershell";if(R&&(O||I.includes("'")))return`& '${I.replace(/'/g,"''")}'`;if(C&&R)return`& '${I}'`;if(h===D.OperatingSystem.Windows){if(i!==void 0)return i===P.WindowsShellType.GitBash?(0,T.$CR)(I.replace(/\\/g,"/")):i===P.WindowsShellType.Wsl?f?.getWslPath(I,"win-to-unix")||I:O?`"${I}"`:I;const M=n.toLowerCase();return M.includes("wsl")||M.includes("bash.exe")&&!M.toLowerCase().includes("git")?f?.getWslPath(I,"win-to-unix")||I:O?`"${I}"`:I}return(0,T.$CR)(I)}function o(l,n,u){const i=typeof l=="string"?r.URI.parse(l):l;let f=i?n.getWorkspaceFolder(i)??void 0:void 0;if(!f){const h=u.getLastActiveWorkspaceRoot();f=h?n.getWorkspaceFolder(h)??void 0:void 0}return f}}),define(Te[77],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.TestPosition=e.TestIdPathParts=void 0;var t;(function(P){P.Delimiter="\0"})(t||(e.TestIdPathParts=t={}));var r;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(r||(e.TestPosition=r={}));class E{static fromExtHostTestItem(D,T,v=D.parent){if(D._isRoot)return new E([T]);const s=[D.id];for(let S=v;S&&S.id!==T;S=S.parent)s.push(S.id);return s.push(T),new E(s.reverse())}static isRoot(D){return!D.includes(t.Delimiter)}static root(D){const T=D.indexOf(t.Delimiter);return T===-1?D:D.slice(0,T)}static fromString(D){return new E(D.split(t.Delimiter))}static join(D,T){return new E([...D.path,T])}static joinToString(D,T){return D.toString()+t.Delimiter+T}static parentId(D){const T=D.lastIndexOf(t.Delimiter);return T===-1?void 0:D.slice(0,T)}static localId(D){const T=D.lastIndexOf(t.Delimiter);return T===-1?D:D.slice(T+t.Delimiter.length)}static isChild(D,T){return T[D.length]===t.Delimiter&&T.startsWith(D)}static compare(D,T){return D===T?r.IsSame:E.isChild(D,T)?r.IsChild:E.isChild(T,D)?r.IsParent:r.Disconnected}static getLengthOfCommonPrefix(D,T){if(D===0)return 0;let v=0;for(;v<D-1;){for(let s=1;s<D;s++){const S=T(s-1),y=T(s);if(S.path[v]!==y.path[v])return v}v++}return v}constructor(D,T=D.length){if(this.path=D,this.d=T,D.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new E(this.path,1)}get parentId(){return this.d>1?new E(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new E(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new E(this.path,D)}compare(D){if(typeof D=="string")return E.compare(this.toString(),D);for(let T=0;T<D.d&&T<this.d;T++)if(D.path[T]!==this.path[T])return r.Disconnected;return D.d>this.d?r.IsChild:D.d<this.d?r.IsParent:r.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+=t.Delimiter,this.c+=this.path[D]}return this.c}}e.$rJ=E}),define(Te[103],Oe([1,0,4,85,48,77]),function(ue,e,t,r,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$zJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$yJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$xJ=e.$wJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$vJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$uJ=e.$tJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$sJ=e.TestResultState=void 0;var D;(function(le){le[le.Unset=0]="Unset",le[le.Queued=1]="Queued",le[le.Running=2]="Running",le[le.Passed=3]="Passed",le[le.Failed=4]="Failed",le[le.Skipped=5]="Skipped",le[le.Errored=6]="Errored"})(D||(e.TestResultState=D={})),e.$sJ={[D.Unset]:"unset",[D.Queued]:"queued",[D.Running]:"running",[D.Passed]:"passed",[D.Failed]:"failed",[D.Skipped]:"skipped",[D.Errored]:"errored"};var T;(function(le){le[le.Run=1]="Run",le[le.Debug=2]="Debug",le[le.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var v;(function(le){le[le.Refresh=2]="Refresh",le[le.CodeRelatedToTest=4]="CodeRelatedToTest",le[le.TestRelatedToCode=8]="TestRelatedToCode"})(v||(e.TestControllerCapability=v={}));var s;(function(le){le[le.Run=2]="Run",le[le.Debug=4]="Debug",le[le.Coverage=8]="Coverage",le[le.HasNonDefaultProfile=16]="HasNonDefaultProfile",le[le.HasConfigurable=32]="HasConfigurable",le[le.SupportsContinuousRun=64]="SupportsContinuousRun"})(s||(e.TestRunProfileBitset=s={})),e.$tJ=[s.Run,s.Debug,s.Coverage,s.HasNonDefaultProfile,s.HasConfigurable,s.SupportsContinuousRun];const S=le=>"runId"in le;e.$uJ=S;var y;(function(le){le.serialize=K=>({range:K.range.toJSON(),uri:K.uri.toJSON()}),le.deserialize=(K,B)=>({range:E.$Wt.lift(B.range),uri:K.asCanonicalUri(t.URI.revive(B.uri))})})(y||(e.IRichLocation=y={}));var $;(function(le){le[le.Error=0]="Error",le[le.Output=1]="Output"})($||(e.TestMessageType=$={}));var g;(function(le){le.serialize=K=>({label:K.label,uri:K.uri?.toJSON(),position:K.position?.toJSON()}),le.deserialize=(K,B)=>({label:B.label,uri:B.uri?K.asCanonicalUri(t.URI.revive(B.uri)):void 0,position:B.position?r.$Vt.lift(B.position):void 0})})(g||(e.ITestMessageStackFrame=g={}));var a;(function(le){le.serialize=K=>({message:K.message,type:$.Error,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&y.serialize(K.location),stackTrace:K.stackTrace?.map(g.serialize)}),le.deserialize=(K,B)=>({message:B.message,type:$.Error,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&y.deserialize(K,B.location),stackTrace:B.stackTrace&&B.stackTrace.map(j=>g.deserialize(K,j))})})(a||(e.ITestErrorMessage=a={}));const c=(le,K)=>`${K?"s":"e"}${le}`;e.$vJ=c;var m;(function(le){le.serialize=K=>({message:K.message,type:$.Output,offset:K.offset,length:K.length,location:K.location&&y.serialize(K.location)}),le.deserialize=(K,B)=>({message:B.message,type:$.Output,offset:B.offset,length:B.length,location:B.location&&y.deserialize(K,B.location)})})(m||(e.ITestOutputMessage=m={}));var b;(function(le){le.serialize=K=>K.type===$.Error?a.serialize(K):m.serialize(K),le.deserialize=(K,B)=>B.type===$.Error?a.deserialize(K,B):m.deserialize(K,B),le.isDiffable=K=>K.type===$.Error&&K.actual!==void 0&&K.expected!==void 0})(b||(e.ITestMessage=b={}));var p;(function(le){le.serializeWithoutMessages=K=>({state:K.state,duration:K.duration,messages:[]}),le.serialize=K=>({state:K.state,duration:K.duration,messages:K.messages.map(b.serialize)}),le.deserialize=(K,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(j=>b.deserialize(K,j))})})(p||(e.ITestTaskState=p={}));const d="\0",w=(le,K)=>le+d+K;e.$wJ=w;const o=le=>{const K=le.indexOf(d);return{ctrlId:le.slice(0,K),tagId:le.slice(K+1)}};e.$xJ=o;var l;(function(le){le.serialize=K=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?.toJSON(),range:K.range?.toJSON()||null,description:K.description,error:K.error,sortText:K.sortText}),le.deserialize=(K,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?K.asCanonicalUri(t.URI.revive(B.uri)):void 0,range:B.range?E.$Wt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(l||(e.ITestItem=l={}));var n;(function(le){le[le.NotExpandable=0]="NotExpandable",le[le.Expandable=1]="Expandable",le[le.BusyExpanding=2]="BusyExpanding",le[le.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var u;(function(le){le.serialize=K=>({expand:K.expand,item:l.serialize(K.item)}),le.deserialize=(K,B)=>({controllerId:P.$rJ.root(B.item.extId),expand:B.expand,item:l.deserialize(K,B.item)})})(u||(e.InternalTestItem=u={}));var i;(function(le){le.serialize=K=>{let B;return K.item&&(B={},K.item.label!==void 0&&(B.label=K.item.label),K.item.tags!==void 0&&(B.tags=K.item.tags),K.item.busy!==void 0&&(B.busy=K.item.busy),K.item.uri!==void 0&&(B.uri=K.item.uri?.toJSON()),K.item.range!==void 0&&(B.range=K.item.range?.toJSON()),K.item.description!==void 0&&(B.description=K.item.description),K.item.error!==void 0&&(B.error=K.item.error),K.item.sortText!==void 0&&(B.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:B}},le.deserialize=K=>{let B;return K.item&&(B={},K.item.label!==void 0&&(B.label=K.item.label),K.item.tags!==void 0&&(B.tags=K.item.tags),K.item.busy!==void 0&&(B.busy=K.item.busy),K.item.range!==void 0&&(B.range=K.item.range?E.$Wt.lift(K.item.range):null),K.item.description!==void 0&&(B.description=K.item.description),K.item.error!==void 0&&(B.error=K.item.error),K.item.sortText!==void 0&&(B.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:B}}})(i||(e.ITestItemUpdate=i={}));const f=(le,K)=>{K.expand!==void 0&&(le.expand=K.expand),K.item!==void 0&&(le.item=le.item?Object.assign(le.item,K.item):K.item)};e.$yJ=f;var h;(function(le){le.serializeWithoutMessages=K=>({...u.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(p.serializeWithoutMessages)}),le.serialize=K=>({...u.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(p.serialize)}),le.deserialize=(K,B)=>({...u.deserialize(K,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(j=>p.deserialize(K,j)),retired:!0})})(h||(e.TestResultItem=h={}));var k;(function(le){le.empty=()=>({covered:0,total:0}),le.sum=(K,B)=>{K.covered+=B.covered,K.total+=B.total}})(k||(e.ICoverageCount=k={}));var I;(function(le){le.serialize=K=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,testIds:K.testIds,uri:K.uri.toJSON()}),le.deserialize=(K,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,testIds:B.testIds,uri:K.asCanonicalUri(t.URI.revive(B.uri))}),le.empty=(K,B)=>({id:K,uri:B,statement:k.empty()})})(I||(e.IFileCoverage=I={}));function O(le){return{...le,location:le.location?.toJSON()}}function C(le){return le.location=le.location?r.$Vt.isIPosition(le.location)?r.$Vt.lift(le.location):E.$Wt.lift(le.location):void 0,le}e.$zJ=3;var L;(function(le){le[le.Declaration=0]="Declaration",le[le.Statement=1]="Statement",le[le.Branch=2]="Branch"})(L||(e.DetailType=L={}));var R;(function(le){le.serialize=K=>K.type===L.Declaration?G.serialize(K):Q.serialize(K),le.deserialize=K=>K.type===L.Declaration?G.deserialize(K):Q.deserialize(K)})(R||(e.CoverageDetails=R={}));var M;(function(le){le.serialize=O,le.deserialize=C})(M||(e.IBranchCoverage=M={}));var G;(function(le){le.serialize=O,le.deserialize=C})(G||(e.IDeclarationCoverage=G={}));var Q;(function(le){le.serialize=K=>({...O(K),branches:K.branches?.map(M.serialize)}),le.deserialize=K=>({...C(K),branches:K.branches?.map(M.deserialize)})})(Q||(e.IStatementCoverage=Q={}));var te;(function(le){le[le.Add=0]="Add",le[le.Update=1]="Update",le[le.DocumentSynced=2]="DocumentSynced",le[le.Remove=3]="Remove",le[le.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",le[le.Retire=5]="Retire",le[le.AddTag=6]="AddTag",le[le.RemoveTag=7]="RemoveTag"})(te||(e.TestDiffOpType=te={}));var ve;(function(le){le.deserialize=(K,B)=>B.op===te.Add?{op:B.op,item:u.deserialize(K,B.item)}:B.op===te.Update?{op:B.op,item:i.deserialize(B.item)}:B.op===te.DocumentSynced?{op:B.op,uri:K.asCanonicalUri(t.URI.revive(B.uri)),docv:B.docv}:B,le.serialize=K=>K.op===te.Add?{op:K.op,item:u.serialize(K.item)}:K.op===te.Update?{op:K.op,item:i.serialize(K.item)}:K})(ve||(e.TestsDiffOp=ve={}));class be{constructor(K){this.l=K,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(K){const B=this.x();for(const j of K)switch(j.op){case te.Add:this.p(u.deserialize(this.l,j.item),B);break;case te.Update:this.q(i.deserialize(j.item),B);break;case te.Remove:this.v(j.itemId,B);break;case te.Retire:this.w(j.itemId);break;case te.IncrementPendingExtHosts:this.updatePendingRoots(j.amount);break;case te.AddTag:this.f.set(j.tag.id,j.tag);break;case te.RemoveTag:this.f.delete(j.id);break}B.complete?.()}p(K,B){const j=P.$rJ.parentId(K.item.extId)?.toString();let U;if(!j)U=this.y(K),this.h.add(U),this.g.set(K.item.extId,U);else if(this.g.has(j)){const ee=this.g.get(j);ee.children.add(K.item.extId),U=this.y(K,ee),this.g.set(K.item.extId,U)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(K)}`);return}return B.add?.(U),K.expand===n.BusyExpanding&&this.j++,U}q(K,B){const j=this.g.get(K.extId);if(j)return K.expand!==void 0&&(j.expand===n.BusyExpanding&&this.j--,K.expand===n.BusyExpanding&&this.j++),(0,e.$yJ)(j,K),B.update?.(j),j}v(K,B){const j=this.g.get(K);if(!j)return;const U=P.$rJ.parentId(j.item.extId)?.toString();U?this.g.get(U).children.delete(j.item.extId):this.h.delete(j);const ee=[[K]];for(;ee.length;)for(const ae of ee.pop()){const ye=this.g.get(ae);ye&&(ee.push(ye.children),this.g.delete(ae),B.remove?.(ye,ye!==j),ye.expand===n.BusyExpanding&&this.j--)}}w(K){}updatePendingRoots(K){this.k+=K}x(){return{}}}e.$AJ=be}),define(Te[149],Oe([1,0,13,6,2,105,103,77]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GQ=e.$FQ=e.$EQ=e.$DQ=e.$CQ=e.TestItemEventOp=void 0;var v;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const s=(p,d)=>p===d,y=Object.entries({range:(p,d)=>p===d?!0:!p||!d?!1:p.equalsRange(d),busy:s,label:s,description:s,error:s,sortText:s,tags:(p,d)=>!(p.length!==d.length||p.some(w=>!d.includes(w)))}),$=(p,d)=>{let w;for(const[o,l]of y)l(p[o],d[o])||(w?w[o]=d[o]:w={[o]:d[o]});return w};class g extends E.$Zc{get root(){return this.s.root}constructor(d){super(),this.s=d,this.f=this.B(new t.$Wh(()=>this.flushDiff(),200)),this.g=this.B(new r.$qe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(d){this.h=d;for(const w of this.tree.values())this.J(w)}get resolveHandler(){return this.h}collectDiff(){const d=this.m;return this.m=[],d}pushDiff(d){switch(d.op){case D.TestDiffOpType.DocumentSynced:{for(const w of this.m)if(w.op===D.TestDiffOpType.DocumentSynced&&w.uri===d.uri){w.docv=d.docv;return}break}case D.TestDiffOpType.Update:{const w=this.m[this.m.length-1];if(w){if(w.op===D.TestDiffOpType.Update&&w.item.extId===d.item.extId){(0,D.$yJ)(w.item,d.item);return}if(w.op===D.TestDiffOpType.Add&&w.item.item.extId===d.item.extId){(0,D.$yJ)(w.item,d.item);return}}break}}this.m.push(d),this.f.isScheduled()||this.f.schedule()}expand(d,w){const o=this.tree.get(d);if(o){if((o.expandLevels===void 0||w>o.expandLevels)&&(o.expandLevels=w),o.expand===D.TestItemExpandState.Expandable){const l=this.M(o);return l.isOpen()?this.L(o,w-1):l.wait().then(()=>this.L(o,w-1))}else if(o.expand===D.TestItemExpandState.Expanded)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,w-1)):this.L(o,w-1)}}dispose(){for(const d of this.tree.values())this.s.getApiFor(d.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(d,w){switch(w.op){case v.RemoveChild:this.O(T.$rJ.joinToString(d.fullId,w.id));break;case v.Upsert:this.z(w.item,d);break;case v.Bulk:for(const o of w.ops)this.w(d,o);break;case v.SetTags:this.C(w.new,w.old,d.fullId.toString());break;case v.UpdateCanResolveChildren:this.J(d);break;case v.SetProp:this.pushDiff({op:D.TestDiffOpType.Update,item:{extId:d.fullId.toString(),item:w.update}});break;case v.DocumentSynced:this.y(d.actual.uri);break;default:(0,P.$jd)(w)}}y(d){d&&this.pushDiff({op:D.TestDiffOpType.DocumentSynced,uri:d,docv:this.s.getDocumentVersion(d)})}z(d,w){const o=T.$rJ.fromExtHostTestItem(d,this.root.id,w?.actual),l=this.s.getApiFor(d);l.parent&&l.parent!==w?.actual&&this.s.getChildren(l.parent).delete(d.id);let n=this.tree.get(o.toString());if(!n){n={fullId:o,actual:d,expandLevels:w?.expandLevels?w.expandLevels-1:void 0,expand:D.TestItemExpandState.NotExpandable},d.tags.forEach(this.D,this),this.tree.set(n.fullId.toString(),n),this.G(d,w),this.pushDiff({op:D.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(d)}}),this.I(d,n,w);return}if(n.actual===d){this.H(d,n,w);return}if(n.actual.uri?.toString()!==d.uri?.toString())return this.O(o.toString()),this.z(d,w);const u=this.s.getChildren(n.actual),i=n.actual,f=$(this.s.toITestItem(i),this.s.toITestItem(d));this.s.getApiFor(i).listener=void 0,n.actual=d,n.resolveBarrier=void 0,n.expand=D.TestItemExpandState.NotExpandable,f&&(f.hasOwnProperty("tags")&&(this.C(d.tags,i.tags,o.toString()),delete f.tags),this.w(n,{op:v.SetProp,update:f})),this.I(d,n,w);for(const[k,I]of u)this.s.getChildren(d).get(I.id)||this.O(T.$rJ.joinToString(o,I.id));const h=n.expandLevels;h!==void 0&&queueMicrotask(()=>{n.expand===D.TestItemExpandState.Expandable&&(n.expandLevels=void 0,this.expand(o.toString(),h))}),this.y(n.actual.uri)}C(d,w,o){const l=new Set(w.map(n=>n.id));for(const n of d)l.delete(n.id)||this.D(n);this.pushDiff({op:D.TestDiffOpType.Update,item:{extId:o,item:{tags:d.map(n=>(0,D.$wJ)(this.s.controllerId,n.id))}}}),l.forEach(this.F,this)}D(d){const w=this.j.get(d.id);w?w.refCount++:(this.j.set(d.id,{refCount:1}),this.pushDiff({op:D.TestDiffOpType.AddTag,tag:{id:(0,D.$wJ)(this.s.controllerId,d.id)}}))}F(d){const w=this.j.get(d);w&&!--w.refCount&&(this.j.delete(d),this.pushDiff({op:D.TestDiffOpType.RemoveTag,id:(0,D.$wJ)(this.s.controllerId,d)}))}G(d,w){this.s.getApiFor(d).parent=w&&w.actual!==this.root?w.actual:void 0}H(d,w,o){this.G(d,o);const l=this.s.getApiFor(d);l.parent=o?.actual,l.listener=n=>this.w(w,n),this.J(w)}I(d,w,o){this.H(d,w,o);for(const[l,n]of this.s.getChildren(d))this.z(n,w)}J(d){let w;this.h?d.resolveBarrier?w=d.resolveBarrier.isOpen()?D.TestItemExpandState.Expanded:D.TestItemExpandState.BusyExpanding:w=d.actual.canResolveChildren?D.TestItemExpandState.Expandable:D.TestItemExpandState.NotExpandable:w=D.TestItemExpandState.NotExpandable,w!==d.expand&&(d.expand=w,this.pushDiff({op:D.TestDiffOpType.Update,item:{extId:d.fullId.toString(),expand:w}}),w===D.TestItemExpandState.Expandable&&d.expandLevels!==void 0&&this.M(d))}L(d,w){if(w<0)return;const o=[];for(const[l,n]of this.s.getChildren(d.actual)){const u=this.expand(T.$rJ.joinToString(d.fullId,n.id),w);(0,t.$wh)(u)&&o.push(u)}if(o.length)return Promise.all(o).then(()=>{})}M(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this.h){const n=new t.$Jh;return n.open(),n}d.expand=D.TestItemExpandState.BusyExpanding,this.N(d);const w=d.resolveBarrier=new t.$Jh,o=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let l;try{l=this.h(d.actual===this.root?void 0:d.actual)}catch(n){o(n)}return(0,t.$wh)(l)?l.catch(o).then(()=>{w.open(),this.J(d)}):(w.open(),this.J(d)),d.resolveBarrier}N(d){this.pushDiff({op:D.TestDiffOpType.Update,item:{extId:d.fullId.toString(),expand:d.expand}})}O(d){const w=this.tree.get(d);if(!w)throw new Error("attempting to remove non-existent child");this.pushDiff({op:D.TestDiffOpType.Remove,itemId:d});const o=[w];for(;o.length;){const l=o.pop();if(l){this.s.getApiFor(l.actual).listener=void 0;for(const n of l.actual.tags)this.F(n.id);this.tree.delete(l.fullId.toString());for(const[n,u]of this.s.getChildren(l.actual))o.push(this.tree.get(T.$rJ.joinToString(l.fullId,u.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.g.fire(d)}}e.$CQ=g;class a extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.$DQ=a;class c extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$EQ=c;class m extends Error{constructor(d,w,o){super(`TestItem with ID "${d}" is from controller "${w}" and cannot be added as a child of an item from controller "${o}".`)}}e.$FQ=m;const b=(p,d,w)=>{let o=new Map;return{get size(){return o.size},forEach(l,n){for(const u of o.values())l.call(n,u,this)},[Symbol.iterator](){return o.entries()},replace(l){const n=new Map,u=new Set(o.keys()),i={op:v.Bulk,ops:[]};for(const f of l){if(!(f instanceof w))throw new c(f.id);const h=d(f).controllerId;if(h!==p.controllerId)throw new m(f.id,h,p.controllerId);if(n.has(f.id))throw new a(f.id);n.set(f.id,f),u.delete(f.id),i.ops.push({op:v.Upsert,item:f})}for(const f of u.keys())i.ops.push({op:v.RemoveChild,id:f});p.listener?.(i),o=n},add(l){if(!(l instanceof w))throw new c(l.id);o.set(l.id,l),p.listener?.({op:v.Upsert,item:l})},delete(l){o.delete(l)&&p.listener?.({op:v.RemoveChild,id:l})},get(l){return o.get(l)},toJSON(){return Array.from(o.values())}}};e.$GQ=b}),define(Te[150],Oe([1,0,149]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=e.$HQ=void 0;const r=new WeakMap,E=(D,T)=>{const v={controllerId:T};return r.set(D,v),v};e.$HQ=E;const P=D=>{const T=r.get(D);if(!T)throw new t.$EQ(D?.id||"<unknown>");return T};e.$IQ=P}),define(Te[263],Oe([1,0,46,28,5]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=void 0,e.$DF=".vscode",e.$EF="settings",e.$FF=`${e.$DF}/${e.$EF}.json`,e.$GF="vscode://schemas/settings/default",e.$HF="vscode://schemas/settings/user",e.$IF="vscode://schemas/settings/profile",e.$JF="vscode://schemas/settings/machine",e.$KF="vscode://schemas/settings/workspace",e.$LF="vscode://schemas/settings/folder",e.$MF="vscode://schemas/launch",e.$NF="vscode://schemas/tasks",e.$OF=[t.ConfigurationScope.APPLICATION],e.$PF=[t.ConfigurationScope.MACHINE,t.ConfigurationScope.WINDOW,t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE,t.ConfigurationScope.MACHINE_OVERRIDABLE],e.$QF=[t.ConfigurationScope.WINDOW,t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE],e.$RF=[t.ConfigurationScope.APPLICATION,...e.$QF],e.$SF=[t.ConfigurationScope.MACHINE,t.ConfigurationScope.WINDOW,t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE,t.ConfigurationScope.MACHINE_OVERRIDABLE],e.$TF=[t.ConfigurationScope.WINDOW,t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE,t.ConfigurationScope.MACHINE_OVERRIDABLE],e.$UF=[t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE,t.ConfigurationScope.MACHINE_OVERRIDABLE],e.$VF="tasks",e.$WF="launch",e.$XF=Object.create(null),e.$XF[e.$VF]=`${e.$DF}/${e.$VF}.json`,e.$XF[e.$WF]=`${e.$DF}/${e.$WF}.json`,e.$YF=Object.create(null),e.$YF[e.$VF]=`${e.$VF}.json`,e.$ZF=(0,E.$Li)(r.$ej),e.$1F=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$2F="workbench.settings.applyToAllProfiles"}),define(Te[151],Oe([1,0,5,9]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BR=e.VariableKind=e.$AR=void 0,e.$AR=(0,t.$Ki)("configurationResolverService");var E;(function(D){D.Unknown="unknown",D.Env="env",D.Config="config",D.Command="command",D.Input="input",D.ExtensionInstallFolder="extensionInstallFolder",D.WorkspaceFolder="workspaceFolder",D.Cwd="cwd",D.WorkspaceFolderBasename="workspaceFolderBasename",D.UserHome="userHome",D.LineNumber="lineNumber",D.SelectedText="selectedText",D.File="file",D.FileWorkspaceFolder="fileWorkspaceFolder",D.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",D.RelativeFile="relativeFile",D.RelativeFileDirname="relativeFileDirname",D.FileDirname="fileDirname",D.FileExtname="fileExtname",D.FileBasename="fileBasename",D.FileBasenameNoExtension="fileBasenameNoExtension",D.FileDirnameBasename="fileDirnameBasename",D.ExecPath="execPath",D.ExecInstallFolder="execInstallFolder",D.PathSeparator="pathSeparator",D.PathSeparatorAlias="/"})(E||(e.VariableKind=E={}));class P extends r.$fb{constructor(T,v){super(v),this.variable=T}}e.$BR=P}),define(Te[264],Oe([1,0,8,32,10,20,3,192,7,151,16]),function(ue,e,t,r,E,P,D,T,v,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QR=void 0,t=Ve(t),r=Ve(r),E=Ve(E),P=Ve(P);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(g,a,c,m){this.h=new Map,this.a=g,this.b=a,this.g=c,m&&(this.c=m.then(b=>this.i(b)))}i(g){if(D.$l){const a=Object.create(null);return Object.keys(g).forEach(c=>{a[c.toLowerCase()]=g[c]}),a}return g}resolveWithEnvironment(g,a,c){return this.l({env:this.i(g),userHome:void 0},a?a.uri:void 0,c)}async resolveAsync(g,a){const c={env:await this.c,userHome:await this.g};return this.l(c,g?g.uri:void 0,a)}async j(g,a,c,m){const b=P.$ko(a);D.$l&&b.windows?Object.keys(b.windows).forEach(d=>b[d]=b.windows[d]):D.$m&&b.osx?Object.keys(b.osx).forEach(d=>b[d]=b.osx[d]):D.$n&&b.linux&&Object.keys(b.linux).forEach(d=>b[d]=b.linux[d]),delete b.windows,delete b.osx,delete b.linux;const p={env:await this.c,userHome:await this.g};return this.l(p,g?g.uri:void 0,b,c,m)}async resolveAnyAsync(g,a,c){return this.j(g,a,c)}async resolveAnyMap(g,a,c){const m=new Map;return{newConfig:await this.j(g,a,c,m),resolvedVariables:m}}resolveWithInteractionReplace(g,a,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(g,a,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(g,a){if(this.h.has(g))throw new Error("Variable "+g+" is contributed twice.");this.h.set(g,a)}async l(g,a,c,m,b){if(E.$jg(c))return this.m(g,a,c,m,b);if(Array.isArray(c))return Promise.all(c.map(p=>this.l(g,a,p,m,b)));if(E.$lg(c)){const p=Object.create(null),d=await Promise.all(Object.keys(c).map(async w=>[await this.m(g,a,w,m,b),await this.l(g,a,c[w],m,b)]));for(const[w,o]of d)p[w]=o;return p}return c}m(g,a,c,m,b){return(0,S.$Cf)(c,y.VARIABLE_REGEXP,async(p,d)=>{if(d.includes(y.VARIABLE_LHS))return p;let w=await this.o(g,p,d,a,m);return b?.set(d,w),w!==p&&E.$jg(w)&&w.match(y.VARIABLE_REGEXP)&&(w=await this.m(g,a,w,m,b)),w})}n(g){return this.b?this.b.getUriLabel(g,{noPrefix:!0}):g.fsPath}async o(g,a,c,m,b){let p;const d=c.split(":");d.length>1&&(c=d[0],p=d[1]);const w=n=>{const u=this.a.getFilePath();if(u)return(0,T.$0w)(u);throw new s.$BR(n,(0,v.localize)(12108,null,a))},o=n=>{const u=w(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,T.$0w)(i)}throw new s.$BR(n,(0,v.localize)(12109,null,a,t.$sc(u)))},l=n=>{if(p){const u=this.a.getFolderUri(p);if(u)return u;throw new s.$BR(n,(0,v.localize)(12110,null,a,p))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new s.$BR(n,(0,v.localize)(12111,null,a)):new s.$BR(n,(0,v.localize)(12112,null,a))};switch(c){case"env":if(p){if(g.env){const n=g.env[D.$l?p.toLowerCase():p];if(E.$jg(n))return n}return""}throw new s.$BR(s.VariableKind.Env,(0,v.localize)(12113,null,a));case"config":if(p){const n=this.a.getConfigurationValue(m,p);if(E.$sg(n))throw new s.$BR(s.VariableKind.Config,(0,v.localize)(12114,null,a,p));if(E.$lg(n))throw new s.$BR(s.VariableKind.Config,(0,v.localize)(12115,null,a,p));return n}throw new s.$BR(s.VariableKind.Config,(0,v.localize)(12116,null,a));case"command":return this.p(s.VariableKind.Command,a,p,b,"command");case"input":return this.p(s.VariableKind.Input,a,p,b,"input");case"extensionInstallFolder":if(p){const n=await this.a.getExtension(p);if(!n)throw new s.$BR(s.VariableKind.ExtensionInstallFolder,(0,v.localize)(12117,null,a,p));return this.n(n.extensionLocation)}throw new s.$BR(s.VariableKind.ExtensionInstallFolder,(0,v.localize)(12118,null,a));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,T.$0w)(this.n(l(s.VariableKind.WorkspaceFolder)));case"cwd":return m||p?(0,T.$0w)(this.n(l(s.VariableKind.Cwd))):r.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$0w)(t.$sc(this.n(l(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(g.userHome)return g.userHome;throw new s.$BR(s.VariableKind.UserHome,(0,v.localize)(12119,null,a))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new s.$BR(s.VariableKind.LineNumber,(0,v.localize)(12120,null,a))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new s.$BR(s.VariableKind.SelectedText,(0,v.localize)(12121,null,a))}case"file":return w(s.VariableKind.File);case"fileWorkspaceFolder":return o(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return t.$sc(o(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||p?t.$qc(this.n(l(s.VariableKind.RelativeFile)),w(s.VariableKind.RelativeFile)):w(s.VariableKind.RelativeFile);case"relativeFileDirname":{const n=t.$rc(w(s.VariableKind.RelativeFileDirname));if(m||p){const u=t.$qc(this.n(l(s.VariableKind.RelativeFileDirname)),n);return u.length===0?".":u}return n}case"fileDirname":return t.$rc(w(s.VariableKind.FileDirname));case"fileExtname":return t.$tc(w(s.VariableKind.FileExtname));case"fileBasename":return t.$sc(w(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=t.$sc(w(s.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-t.$tc(n).length)}case"fileDirnameBasename":return t.$sc(t.$rc(w(s.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||a}case"execInstallFolder":{const n=this.a.getAppRoot();return n||a}case"pathSeparator":case"/":return t.sep;default:try{const n=p?`${c}:${p}`:c;return this.p(s.VariableKind.Unknown,a,n,b,void 0)}catch{return a}}}}p(g,a,c,m,b){if(c&&m){const p=b===void 0?m[c]:m[b+":"+c];if(typeof p=="string")return p;throw new s.$BR(g,(0,v.localize)(12122,null,a))}return a}}e.$QR=y}),define(Te[265],Oe([1,0,5,102]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$ME=void 0,e.$NE=s,e.$OE=$,e.$PE=g,e.$ME=(0,t.$Ki)("editorGroupsService");var E;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(E||(e.GroupDirection=E={}));var P;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var D;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(D||(e.GroupLocation=D={}));var T;(function(a){a[a.MAXIMIZE=0]="MAXIMIZE",a[a.EXPAND=1]="EXPAND",a[a.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var v;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function s(a){const c=a;return(0,r.$yG)(c?.editor)&&(0,r.$yG)(c?.replacement)}var S;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(S||(e.GroupsOrder=S={}));var y;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function $(a){const c=a;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function g(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?E.DOWN:E.RIGHT}}),define(Te[152],Oe([1,0,5,265]),function(ue,e,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TE=e.$SE=e.$RE=e.$QE=void 0,e.$UE=E,e.$QE=(0,t.$Ki)("editorService"),e.$RE=-1,e.$SE=-2,e.$TE=-3;function E(P){const D=P;return typeof P=="number"||(0,r.$OE)(D)}}),define(Te[266],Oe([1,0,263,90,98,97,151,102,152,12,214,261,53,148]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TR=e.$SR=void 0,e.$SR="remoteterminal";let a=class{get onPtyHostExit(){return this.b.listen(g.RemoteTerminalChannelEvent.OnPtyHostExitEvent)}get onPtyHostStart(){return this.b.listen(g.RemoteTerminalChannelEvent.OnPtyHostStartEvent)}get onPtyHostUnresponsive(){return this.b.listen(g.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent)}get onPtyHostResponsive(){return this.b.listen(g.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent)}get onPtyHostRequestResolveVariables(){return this.b.listen(g.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent)}get onProcessData(){return this.b.listen(g.RemoteTerminalChannelEvent.OnProcessDataEvent)}get onProcessExit(){return this.b.listen(g.RemoteTerminalChannelEvent.OnProcessExitEvent)}get onProcessReady(){return this.b.listen(g.RemoteTerminalChannelEvent.OnProcessReadyEvent)}get onProcessReplay(){return this.b.listen(g.RemoteTerminalChannelEvent.OnProcessReplayEvent)}get onProcessOrphanQuestion(){return this.b.listen(g.RemoteTerminalChannelEvent.OnProcessOrphanQuestion)}get onExecuteCommand(){return this.b.listen(g.RemoteTerminalChannelEvent.OnExecuteCommand)}get onDidRequestDetach(){return this.b.listen(g.RemoteTerminalChannelEvent.OnDidRequestDetach)}get onDidChangeProperty(){return this.b.listen(g.RemoteTerminalChannelEvent.OnDidChangeProperty)}constructor(m,b,p,d,w,o,l,n,u,i){this.a=m,this.b=b,this.c=p,this.d=d,this.e=w,this.f=o,this.g=l,this.h=n,this.i=u,this.j=i}restartPtyHost(){return this.b.call(g.RemoteTerminalChannelRequest.RestartPtyHost,[])}async createProcess(m,b,p,d,w,o,l,n){await this.c.whenRemoteConfigurationLoaded();const u=Object.create(null),i=p?this.d.getWorkspaceFolder(p)??void 0:void 0;let f;try{f=(await this.e.resolveAnyMap(i,{shellLaunchConfig:m,configuration:b})).resolvedVariables}catch(G){this.h.error(G)}if(f)for(const[G,Q]of f.entries())(/^config:/.test(G)||G==="selectedText"||G==="lineNumber")&&(u[G]=Q);const h=[];for(const[G,Q]of this.f.collections.entries())h.push([G,(0,P.$Ns)(Q.map),(0,P.$Os)(Q.descriptionMap)]);const k=await this.g.resolveAuthority(this.a),I=k.options&&k.options.extensionHostEnv,O=this.d.getWorkspace(),C=O.folders,L=p?this.d.getWorkspaceFolder(p):null,R=T.$HG.getOriginalUri(this.i.activeEditor,{supportSideBySide:T.SideBySideEditor.PRIMARY,filterByScheme:[s.Schemas.file,s.Schemas.vscodeUserData,s.Schemas.vscodeRemote]}),M={configuration:b,resolvedVariables:u,envVariableCollections:h,shellLaunchConfig:m,workspaceId:O.id,workspaceName:this.j.getWorkspaceLabel(O),workspaceFolders:C,activeWorkspaceFolder:L,activeFileResource:R,shouldPersistTerminal:w,options:d,cols:o,rows:l,unicodeVersion:n,resolverEnv:I};return await this.b.call(g.RemoteTerminalChannelRequest.CreateProcess,M)}requestDetachInstance(m,b){return this.b.call(g.RemoteTerminalChannelRequest.RequestDetachInstance,[m,b])}acceptDetachInstanceReply(m,b){return this.b.call(g.RemoteTerminalChannelRequest.AcceptDetachInstanceReply,[m,b])}attachToProcess(m){return this.b.call(g.RemoteTerminalChannelRequest.AttachToProcess,[m])}detachFromProcess(m,b){return this.b.call(g.RemoteTerminalChannelRequest.DetachFromProcess,[m,b])}listProcesses(){return this.b.call(g.RemoteTerminalChannelRequest.ListProcesses)}getLatency(){return this.b.call(g.RemoteTerminalChannelRequest.GetLatency)}getPerformanceMarks(){return this.b.call(g.RemoteTerminalChannelRequest.GetPerformanceMarks)}reduceConnectionGraceTime(){return this.b.call(g.RemoteTerminalChannelRequest.ReduceConnectionGraceTime)}processBinary(m,b){return this.b.call(g.RemoteTerminalChannelRequest.ProcessBinary,[m,b])}start(m){return this.b.call(g.RemoteTerminalChannelRequest.Start,[m])}input(m,b){return this.b.call(g.RemoteTerminalChannelRequest.Input,[m,b])}acknowledgeDataEvent(m,b){return this.b.call(g.RemoteTerminalChannelRequest.AcknowledgeDataEvent,[m,b])}setUnicodeVersion(m,b){return this.b.call(g.RemoteTerminalChannelRequest.SetUnicodeVersion,[m,b])}shutdown(m,b){return this.b.call(g.RemoteTerminalChannelRequest.Shutdown,[m,b])}resize(m,b,p){return this.b.call(g.RemoteTerminalChannelRequest.Resize,[m,b,p])}clearBuffer(m){return this.b.call(g.RemoteTerminalChannelRequest.ClearBuffer,[m])}getInitialCwd(m){return this.b.call(g.RemoteTerminalChannelRequest.GetInitialCwd,[m])}getCwd(m){return this.b.call(g.RemoteTerminalChannelRequest.GetCwd,[m])}orphanQuestionReply(m){return this.b.call(g.RemoteTerminalChannelRequest.OrphanQuestionReply,[m])}sendCommandResult(m,b,p){return this.b.call(g.RemoteTerminalChannelRequest.SendCommandResult,[m,b,p])}freePortKillProcess(m){return this.b.call(g.RemoteTerminalChannelRequest.FreePortKillProcess,[m])}installAutoReply(m,b){return this.b.call(g.RemoteTerminalChannelRequest.InstallAutoReply,[m,b])}uninstallAllAutoReplies(){return this.b.call(g.RemoteTerminalChannelRequest.UninstallAllAutoReplies,[])}getDefaultSystemShell(m){return this.b.call(g.RemoteTerminalChannelRequest.GetDefaultSystemShell,[m])}getProfiles(m,b,p){return this.b.call(g.RemoteTerminalChannelRequest.GetProfiles,[this.d.getWorkspace().id,m,b,p])}acceptPtyHostResolvedVariables(m,b){return this.b.call(g.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables,[m,b])}getEnvironment(){return this.b.call(g.RemoteTerminalChannelRequest.GetEnvironment)}getWslPath(m,b){return this.b.call(g.RemoteTerminalChannelRequest.GetWslPath,[m,b])}setTerminalLayoutInfo(m){const p={workspaceId:this.d.getWorkspace().id,tabs:m?m.tabs:[]};return this.b.call(g.RemoteTerminalChannelRequest.SetTerminalLayoutInfo,p)}updateTitle(m,b,p){return this.b.call(g.RemoteTerminalChannelRequest.UpdateTitle,[m,b,p])}updateIcon(m,b,p,d){return this.b.call(g.RemoteTerminalChannelRequest.UpdateIcon,[m,b,p,d])}refreshProperty(m,b){return this.b.call(g.RemoteTerminalChannelRequest.RefreshProperty,[m,b])}updateProperty(m,b,p){return this.b.call(g.RemoteTerminalChannelRequest.UpdateProperty,[m,b,p])}getTerminalLayoutInfo(){const b={workspaceId:this.d.getWorkspace().id};return this.b.call(g.RemoteTerminalChannelRequest.GetTerminalLayoutInfo,b)}reviveTerminalProcesses(m,b,p){return this.b.call(g.RemoteTerminalChannelRequest.ReviveTerminalProcesses,[m,b,p])}getRevivedPtyNewId(m){return this.b.call(g.RemoteTerminalChannelRequest.GetRevivedPtyNewId,[m])}serializeTerminalState(m){return this.b.call(g.RemoteTerminalChannelRequest.SerializeTerminalState,[m])}};e.$TR=a,e.$TR=a=We([je(2,t.$ZF),je(3,E.$Ti),je(4,D.$AR),je(5,y.$dR),je(6,r.$Wl),je(7,$.$As),je(8,v.$QE),je(9,S.$Bw)],a)}),define(Te[267],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.ExtHostConnectionType=void 0,e.$ln=T,e.$mn=v;var t;(function(S){S[S.IPC=1]="IPC",S[S.Socket=2]="Socket",S[S.MessagePort=3]="MessagePort"})(t||(e.ExtHostConnectionType=t={}));class r{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(y){this.pipeName=y,this.type=t.IPC}serialize(y){y[r.ENV_KEY]=this.pipeName}}e.$in=r;class E{constructor(){this.type=t.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(y){y[E.ENV_KEY]="1"}}e.$jn=E;class P{constructor(){this.type=t.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(y){y[P.ENV_KEY]="1"}}e.$kn=P;function D(S){delete S[r.ENV_KEY],delete S[E.ENV_KEY],delete S[P.ENV_KEY]}function T(S,y){D(y),S.serialize(y)}function v(S){if(S[r.ENV_KEY])return s(S,new r(S[r.ENV_KEY]));if(S[E.ENV_KEY])return s(S,new E);if(S[P.ENV_KEY])return s(S,new P);throw new Error("No connection information defined in environment!")}function s(S,y){return D(S),y}}),define(Te[268],Oe([1,0,14]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Hn=D,e.$In=T;var r;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(r||(e.UIKind=r={}));var E;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(E||(e.ExtensionHostExitCode=E={}));var P;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function D(s){const S=t.$Se.alloc(1);switch(s){case P.Initialized:S.writeUInt8(1,0);break;case P.Ready:S.writeUInt8(2,0);break;case P.Terminate:S.writeUInt8(3,0);break}return S}function T(s,S){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return S===P.Initialized;case 2:return S===P.Ready;case 3:return S===P.Terminate;default:return!1}}var v;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(Te[269],Oe([1,0,5,6,24,11,254,268,91,40,20,4,2,7]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Q=e.$5Q=e.$4Q=void 0,e.$6Q=m;let a=class extends $.$Zc{constructor(p,d){super(),this.s=p,this.t=d,this.a=this.B(new r.$qe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new r.$qe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=E.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=d.createLogger(this.m,{id:s.$Ip,name:(0,g.localize)(2713,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(d.onDidChangeLogLevel(w=>{(0,P.$hk)(w)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===E.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=E.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=E.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=E.TelemetryLevel.USAGE:!1}}instantiateLogger(p,d,w){const o=this.getTelemetryDetails(),l=new c(d,w,p,this.n,this.j,this.getBuiltInCommonProperties(p),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),n=this.r.get(p.identifier.value)??[];return this.r.set(p.identifier.value,[...n,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(p,d,w){this.f=p,this.g=d,this.c=w??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(p){const d=Object.create(null);switch(d["common.extname"]=`${p.publisher}.${p.name}`,d["common.extversion"]=p.version,d["common.vscodemachineid"]=this.s.telemetryInfo.machineId,d["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,d["common.sqmid"]=this.s.telemetryInfo.sqmId,d["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,d["common.vscodeversion"]=this.s.version,d["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),d["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:d["common.uikind"]="web";break;case T.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,v.$on)((0,s.$Op)(this.s.remote.authority)),d}$onDidChangeTelemetryLevel(p){this.h=this.getTelemetryConfiguration(),this.f=p;const d=this.getTelemetryDetails();this.r.forEach((w,o)=>{const l=w.filter(n=>!n.isDisposed);l.length===0?this.r.delete(o):this.r.set(o,l)}),this.r.forEach(w=>{for(const o of w)o.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(p,d){const o=this.r.get(p.value)?.filter(n=>!n.isDisposed);if(!o)return this.r.delete(p.value),!1;let l=!1;for(const n of o)n.ignoreUnhandledExtHostErrors||(n.logError(d),l=!0);return l}};e.$4Q=a,e.$4Q=a=We([je(0,D.$3Q),je(1,P.$gk)],a);class c{static validateSender(p){if(typeof p!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof p.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof p.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof p.flush<"u"&&typeof p.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(p,d,w,o,l,n,u){this.g=w,this.h=o,this.i=l,this.j=n,this.a=new r.$qe,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.b=d?.ignoreBuiltInCommonProperties??!1,this.c=d?.additionalCommonProperties,this.f=p,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(p,d){this.e&&(this.d={isUsageEnabled:p,isErrorsEnabled:d},this.a.fire(this.e))}mixInCommonPropsAndCleanData(p){let d="properties"in p?p.properties??{}:p;return d=(0,s.$Rp)(d,[]),this.c&&(d=(0,S.$no)(d,this.c)),this.b||(d=(0,S.$no)(d,this.j)),"properties"in p?p.properties=d:p=d,p}k(p,d){this.f&&(this.g.publisher==="vscode"?p=this.g.name+"/"+p:p=this.g.identifier.value+"/"+p,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f?.sendEventData(p,d),this.h.trace(p,d))}logUsage(p,d){this.d.isUsageEnabled&&this.k(p,d)}logError(p,d){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof p=="string")this.k(p,d);else{const w={name:p.name,message:p.message,stack:p.stack,cause:p.cause},o=(0,s.$Rp)(w,[]),l=new Error(o.message,{cause:o.cause});l.stack=o.stack,l.name=o.name,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f.sendErrorData(l,d),this.h.trace("exception",d)}}get apiTelemetryLogger(){if(!this.e){const p=this,d={logUsage:p.logUsage.bind(p),get isUsageEnabled(){return p.d.isUsageEnabled},get isErrorsEnabled(){return p.d.isErrorsEnabled},logError:p.logError.bind(p),dispose:p.dispose.bind(p),onDidChangeEnableStates:p.a.event.bind(p)};this.e=Object.freeze(d)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let p=this.f;this.f=void 0,Promise.resolve(p.flush()).then(p=void 0),this.e=void 0}else this.f=void 0}}e.$5Q=c;function m(b){const p=Date.now()-new Date(b).getTime();return isNaN(p)?!1:p<1e3*60*60*24}e.$7Q=(0,t.$Ki)("IExtHostTelemetry")}),define(Te[270],Oe([1,0,6,4,38,132,21,5]),function(ue,e,t,r,E,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GH=e.ActivationKind=e.$DH=e.$CH=e.$zH=e.ExtensionHostStartup=e.$yH=e.$xH=e.$wH=e.$vH=void 0,e.$AH=$,e.$BH=g,e.$EH=b,e.$FH=p,e.$vH=Object.freeze({identifier:new D.$xn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:r.URI.parse("void:location"),isBuiltin:!1,targetPlatform:D.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$wH="extensions.webWorker",e.$xH=(0,T.$Ki)("extensionService");class v{constructor(o){this.dependency=o}}e.$yH=v;var s;(function(w){w[w.EagerAutoStart=1]="EagerAutoStart",w[w.EagerManualStart=2]="EagerManualStart",w[w.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class S{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,l,n){this.c=o,this.d=l.slice(0),this.e=n.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$hH.createActivationEventsMap(this.d)}}set(o,l,n){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const u=[],i=[],f=[],h=[],k=y(this.d),I=y(l),O=(G,Q)=>G.extensionLocation.toString()===Q.extensionLocation.toString()||G.isBuiltin===Q.isBuiltin||G.isUserBuiltin===Q.isUserBuiltin||G.isUnderDevelopment===Q.isUnderDevelopment;for(const G of this.d){const Q=I.get(G.identifier);if(!Q){u.push(G.identifier),k.delete(G.identifier);continue}if(!O(G,Q)){u.push(G.identifier),k.delete(G.identifier);continue}}for(const G of l){const Q=k.get(G.identifier);if(!Q){i.push(G);continue}if(!O(Q,G)){u.push(Q.identifier),k.delete(Q.identifier);continue}}const C=new D.$yn(this.e),L=new D.$yn(n);for(const G of this.e)L.has(G)||f.push(G);for(const G of n)C.has(G)||h.push(G);const R=P.$hH.createActivationEventsMap(i),M={versionId:o,toRemove:u,toAdd:i,addActivationEvents:R,myToRemove:f,myToAdd:h};return this.delta(M),M}delta(o){if(this.c>=o.versionId)return null;const{toRemove:l,toAdd:n,myToRemove:u,myToAdd:i}=o,f=new D.$yn(l),h=new D.$yn(u);for(let k=0;k<this.d.length;k++)f.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)h.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of n)this.d.push(k);for(const k of i)this.e.push(k);return this.f=null,o}containsExtension(o){for(const l of this.e)if(D.$xn.equals(l,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const l of this.d){if(!this.containsExtension(l.identifier))continue;const n=P.$hH.readActivationEvents(l);for(const u of n)o.add(u)}return o}}e.$zH=S;function y(w){const o=new D.$zn;for(const l of w)o.set(l.identifier,l);return o}function $(w,o){return w.enabledApiProposals?w.enabledApiProposals.includes(o):!1}function g(w,o){if(!$(w,o))throw new Error(`Extension '${w.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${w.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${w.identifier.value}`)}class a{constructor(o,l,n,u){this.codeLoadingTime=o,this.activateCallTime=l,this.activateResolvedTime=n,this.activationReason=u}}e.$CH=a;class c{constructor(o,l){this.description=o,this.value=l}}e.$DH=c;var m;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function b(w){return{type:w.isBuiltin?D.ExtensionType.System:D.ExtensionType.User,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,E.$Xp)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation,targetPlatform:w.targetPlatform,validations:[],isValid:!0}}function p(w,o){const l=(0,E.$Vp)(w.manifest.publisher,w.manifest.name);return{id:l,identifier:new D.$xn(l),isBuiltin:w.type===D.ExtensionType.System,isUserBuiltin:w.type===D.ExtensionType.User&&w.isBuiltin,isUnderDevelopment:!!o,extensionLocation:w.location,uuid:w.identifier.uuid,targetPlatform:w.targetPlatform,publisherDisplayName:w.publisherDisplayName,...w.manifest}}class d{constructor(){this.onDidRegisterExtensions=t.Event.None,this.onDidChangeExtensionsStatus=t.Event.None,this.onDidChangeExtensions=t.Event.None,this.onWillActivateByEvent=t.Event.None,this.onDidChangeResponsiveChange=t.Event.None,this.onWillStop=t.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,l){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,l){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$GH=d});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[271],Oe([1,0,7,9,58,30,129,37,21,29,132,120]),function(ue,e,t,r,E,P,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=void 0,t=Ve(t),E=$t(E);const $=T.$xo.as(D.$yo.JSONContribution);class g{constructor(o,l,n){this.a=o,this.b=l,this.c=n}d(o,l){this.a({type:o,message:l,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(E.default.Error,o)}warn(o){this.d(E.default.Warning,o)}info(o){this.d(E.default.Info,o)}}e.$pH=g;class a{static a(o){const l=new v.$yn;for(let n=0,u=o.length;n<u;n++)l.add(o[n].description.identifier);return l}static compute(o,l){if(!o||!o.length)return new a(l,[]);if(!l||!l.length)return new a([],o);const n=this.a(o),u=this.a(l),i=l.filter(h=>!n.has(h.description.identifier)),f=o.filter(h=>!u.has(h.description.identifier));return new a(i,f)}constructor(o,l){this.added=o,this.removed=l}}e.$qH=a;class c{constructor(o,l){this.name=o,this.defaultExtensionKind=l,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");return this.a=o,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(o){this.c=a.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,r.$4)(o)}}}e.$rH=c;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[t.localize(12277,null),t.localize(12278,null)]},b="vscode://schemas/vscode-extensions";e.$sH={properties:{engines:{type:"object",description:t.localize(12279,null),properties:{vscode:{type:"string",description:t.localize(12280,null),default:"^1.22.0"}}},publisher:{description:t.localize(12281,null),type:"string"},displayName:{description:t.localize(12282,null),type:"string"},categories:{description:t.localize(12283,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:v.$wn},{type:"string",const:"Languages",deprecationMessage:t.localize(12284,null)}]}},galleryBanner:{type:"object",description:t.localize(12285,null),properties:{color:{description:t.localize(12286,null),type:"string"},theme:{description:t.localize(12287,null),type:"string",enum:["dark","light"]}}},contributes:{description:t.localize(12288,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:t.localize(12289,null)},enableProposedApi:{type:"boolean",deprecationMessage:t.localize(12290,null)},enabledApiProposals:{markdownDescription:t.localize(12291,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(w=>w),markdownEnumDescriptions:Object.values(y.allApiProposals).map(w=>w.proposal)}},api:{markdownDescription:t.localize(12292,null),type:"string",enum:["none"],enumDescriptions:[t.localize(12293,null)]},activationEvents:{description:t.localize(12294,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:t.localize(12295,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:t.localize(12296,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:t.localize(12297,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:t.localize(12298,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:t.localize(12299,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:t.localize(12300,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:t.localize(12301,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:t.localize(12302,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:t.localize(12303,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:t.localize(12304,null),body:"onStartupFinished"},{label:"onTaskType",description:t.localize(12305,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:t.localize(12306,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:t.localize(12307,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:t.localize(12308,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:t.localize(12309,null)},{label:"onUri",body:"onUri",description:t.localize(12310,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:t.localize(12311,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:t.localize(12312,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:t.localize(12313,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:t.localize(12314,null)},{label:"onRenderer",description:t.localize(12315,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:t.localize(12316,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:t.localize(12317,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:t.localize(12318,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:t.localize(12319,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:t.localize(12320,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolId}",description:t.localize(12321,null)},{label:"*",description:t.localize(12322,null),body:"*"}]}},badges:{type:"array",description:t.localize(12323,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:t.localize(12324,null)},href:{type:"string",description:t.localize(12325,null)},description:{type:"string",description:t.localize(12326,null)}}}},markdown:{type:"string",description:t.localize(12327,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:t.localize(12328,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:t.localize(12329,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$ep}},extensionPack:{description:t.localize(12330,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$ep}},extensionKind:{description:t.localize(12331,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:t.localize(12332,null)},{body:["workspace"],description:t.localize(12333,null)},{body:["ui","workspace"],description:t.localize(12334,null)},{body:["workspace","ui"],description:t.localize(12335,null)},{body:[],description:t.localize(12336,null)}]},capabilities:{description:t.localize(12337,null),type:"object",properties:{virtualWorkspaces:{description:t.localize(12338,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:t.localize(12339,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[t.localize(12340,null),t.localize(12341,null),t.localize(12342,null)]},description:{type:"string",markdownDescription:t.localize(12343,null)}}},untrustedWorkspaces:{description:t.localize(12344,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:t.localize(12345,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[t.localize(12346,null),t.localize(12347,null),t.localize(12348,null)]},restrictedConfigurations:{description:t.localize(12349,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:t.localize(12350,null)}}}}},sponsor:{description:t.localize(12351,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:t.localize(12352,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:t.localize(12353,null),type:"string"},"vscode:uninstall":{description:t.localize(12354,null),type:"string"}}},icon:{type:"string",description:t.localize(12355,null)},l10n:{type:"string",description:t.localize(12356,null)},pricing:{type:"string",markdownDescription:t.localize(12357,null),enum:["Free","Trial"],default:"Free"}}};class p{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const l=new c(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,l),o.activationEventsGenerator&&S.$hH.register(o.extensionPoint,o.activationEventsGenerator),e.$sH.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,$.registerSchema(b,e.$sH),l}getExtensionPoints(){return Array.from(this.a.values())}}e.$tH=p;const d={ExtensionsRegistry:"ExtensionsRegistry"};T.$xo.add(d.ExtensionsRegistry,new p),e.$uH=T.$xo.as(d.ExtensionsRegistry),$.registerSchema(b,e.$sH),$.registerSchema(s.$zk,{properties:{extensionEnabledApiProposals:{description:t.localize(12358,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(w=>w.proposal)}}]}}}})}),define(Te[272],Oe([1,0,6,39,2,16,7,21,5,11,270,271]),function(ue,e,t,r,E,P,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JH=e.$IH=e.$HH=e.ChatMessageRole=void 0;var $;(function(c){c[c.System=0]="System",c[c.User=1]="User",c[c.Assistant=2]="Assistant"})($||(e.ChatMessageRole=$={})),e.$HH=(0,v.$Ki)("ILanguageModelsService");const g={type:"object",properties:{vendor:{type:"string",description:(0,D.localize)(4739,null)}}};e.$IH=y.$uH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,D.localize)(4740,null),oneOf:[g,{type:"array",items:g}]},activationEventsGenerator:(c,m)=>{for(const b of c)m.push(`onLanguageModelChat:${b.vendor}`)}});let a=class{constructor(m,b){this.e=m,this.f=b,this.a=new E.$Yc,this.b=new Map,this.c=new Set,this.d=this.a.add(new t.$qe),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$IH.setHandler(p=>{this.c.clear();for(const w of p){if(!(0,S.$AH)(w.description,"chatProvider")){w.collector.error((0,D.localize)(4741,null));continue}for(const o of r.Iterable.wrap(w.value)){if(this.c.has(o.vendor)){w.collector.error((0,D.localize)(4742,null,o.vendor));continue}if((0,P.$hf)(o.vendor)){w.collector.error((0,D.localize)(4743,null));continue}if(o.vendor.trim()!==o.vendor){w.collector.error((0,D.localize)(4744,null));continue}this.c.add(o.vendor)}}const d=[];for(const[w,o]of this.b)this.c.has(o.metadata.vendor)||(this.b.delete(w),d.push(w));d.length>0&&this.d.fire({removed:d})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const p=Array.from(this.c).map(d=>this.e.activateByEvent(`onLanguageModelChat:${d}`));await Promise.all(p)}const b=[];for(const[p,d]of this.b)(m.vendor===void 0||d.metadata.vendor===m.vendor)&&(m.family===void 0||d.metadata.family===m.family)&&(m.version===void 0||d.metadata.version===m.version)&&(m.identifier===void 0||d.metadata.id===m.identifier)&&(!d.metadata.targetExtensions||d.metadata.targetExtensions.some(w=>T.$xn.equals(w,m.extension)))&&b.push(p);return this.f.trace("[LM] selected language models",m,b),b}registerLanguageModelChat(m,b){if(this.f.trace("[LM] registering language model chat",m,b.metadata),!this.c.has(b.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${b.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,b),this.d.fire({added:[{identifier:m,metadata:b.metadata}]}),(0,E.$Xc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,b.metadata))})}async sendChatRequest(m,b,p,d,w){const o=this.b.get(m);if(!o)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return o.sendChatRequest(p,b,d,w)}computeTokenLength(m,b,p){const d=this.b.get(m);if(!d)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return d.provideTokenCount(b,p)}};e.$JH=a,e.$JH=a=We([je(0,S.$xH),je(1,s.$fk)],a)}),define(Te[273],Oe([1,0,21,7,62]),function(ue,e,t,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bS=P,E=Ve(E);function P(D,T,v,s,S){const y=new t.$zn;return D.forEach($=>{const g=y.get($.identifier);g&&S.warn((0,r.localize)(12359,null,g.extensionLocation.fsPath,$.extensionLocation.fsPath)),y.set($.identifier,$)}),T.forEach($=>{const g=y.get($.identifier);if(g)if(g.isBuiltin){if(E.gte(g.version,$.version)){S.warn(`Skipping extension ${$.extensionLocation.path} in favour of the builtin extension ${g.extensionLocation.path}.`);return}$.isBuiltin=!0}else S.warn((0,r.localize)(12360,null,g.extensionLocation.fsPath,$.extensionLocation.fsPath));else if($.isBuiltin){S.warn(`Skipping obsolete builtin extension ${$.extensionLocation.path}`);return}y.set($.identifier,$)}),v.forEach($=>{const g=y.get($.identifier);g&&S.warn((0,r.localize)(12361,null,g.extensionLocation.fsPath,$.extensionLocation.fsPath)),y.set($.identifier,$)}),s.forEach($=>{S.info((0,r.localize)(12362,null,$.extensionLocation.fsPath));const g=y.get($.identifier);g&&g.isBuiltin&&($.isBuiltin=!0),y.set($.identifier,$)}),Array.from(y.values())}}),define(Te[274],Oe([1,0,8,3,32,4,44,59,41,63,21,273,12]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fS=e.$eS=void 0,r=Ve(r),D=Ve(D);class g{constructor(m,b,p,d,w,o,l){this.c=m,this.d=p,this.f=d,this.g=w,this.h=o,this.i=l,this.a=Promise.resolve(),this.b=Promise.resolve();const n=b.args["install-builtin-extension"];if(n){w.trace("Installing builtin extensions passed via args...");const i={isMachineScoped:!!b.args["do-not-sync"],installPreReleaseVersion:!!b.args["pre-release"]};D.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=m.installExtensions([],this.j(n),i,!!b.args.force).then(()=>{D.mark("code/server/didInstallBuiltinExtensions"),w.trace("Finished installing builtin extensions")},f=>{w.error(f)})}const u=b.args["install-extension"];u&&(w.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>m.installExtensions(this.j(u),[],{isMachineScoped:!!b.args["do-not-sync"],installPreReleaseVersion:!!b.args["pre-release"],isApplicationScoped:!0},!!b.args.force)).then(()=>{w.trace("Finished installing extensions")},i=>{w.error(i)}))}j(m){return m.map(b=>/\.vsix$/i.test(b)?P.URI.file((0,t.$nc)(b)?b:(0,t.$oc)((0,E.cwd)(),b)):b)}whenExtensionsReady(){return this.b}async scanExtensions(m,b,p,d,w){D.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${m}`),await this.a;const o=d?d.filter(n=>n.scheme===$.Schemas.file).map(n=>n.fsPath):void 0;b=b??this.d.defaultProfile.extensionsResource;const l=await this.k(b,m??r.$z,p,o,w);return this.g.trace("Scanned Extensions",l),this.r(l),D.mark("code/server/didScanExtensions"),l}async k(m,b,p,d,w){await this.q(b,w);const[o,l,n,u]=await Promise.all([this.n(b),this.o(m,b),this.m(b,p),this.l(b,d)]);return(0,y.$bS)(o,l,n,u,this.g)}async l(m,b){return b?(await Promise.all(b.map(p=>this.f.scanOneOrMultipleExtensions(P.URI.file((0,t.$pc)(p)),S.ExtensionType.User,{language:m})))).flat().map(p=>(0,s.$Yq)(p,!0)):[]}async m(m,b){const p=[];if(b?.length){const d=await Promise.all(b.map(w=>this.f.scanExistingExtension(w,S.ExtensionType.User,{language:m})));for(const w of d)w&&p.push((0,s.$Yq)(w,!1))}return p}async n(m){return(await this.f.scanSystemExtensions({language:m,useCache:!0})).map(p=>(0,s.$Yq)(p,!1))}async o(m,b){return(await this.f.scanUserExtensions({profileLocation:m,language:b,useCache:!0})).map(d=>(0,s.$Yq)(d,!1))}async q(m,b){if(!(m===r.$j||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(d=>d.id===m)){this.g.trace(`Language Pack ${m} is already installed. Skipping language pack installation.`);return}}catch(p){this.g.error(p)}if(!b){this.g.trace(`No language pack id provided for language ${m}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${b} for language ${m} is not installed. It will be installed now.`);try{await this.c.installExtensions([b],[],{isMachineScoped:!0},!0)}catch(p){this.g.error(p)}}}r(m){const b=(n,u)=>n.replace(/file/g,"vscode-remote"),p=n=>{let u="";return u+=n.global?"g":"",u+=n.ignoreCase?"i":"",u+=n.multiline?"m":"",new RegExp(b(n.source,!0),u)},d=new class{mapDefined(n){return v.$Nj.create(n)}mapNot(n){return v.$Sj.create(n)}mapEquals(n,u){return n==="resourceScheme"&&typeof u=="string"?v.$Oj.create(n,b(u,!1)):v.$Oj.create(n,u)}mapNotEquals(n,u){return n==="resourceScheme"&&typeof u=="string"?v.$Rj.create(n,b(u,!1)):v.$Rj.create(n,u)}mapGreater(n,u){return v.$Tj.create(n,u)}mapGreaterEquals(n,u){return v.$Uj.create(n,u)}mapSmaller(n,u){return v.$Vj.create(n,u)}mapSmallerEquals(n,u){return v.$Wj.create(n,u)}mapRegex(n,u){return n==="resourceScheme"&&u?v.$Xj.create(n,p(u)):v.$Xj.create(n,u)}mapIn(n,u){return v.$Pj.create(n,u)}mapNotIn(n,u){return v.$Qj.create(n,u)}},w=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const u=v.$Ij.deserialize(n.when);if(!u)return;const i=u.map(d);n.when=i.serialize()},o=n=>{if(Array.isArray(n))for(const u of n)w(u);else w(n)},l=n=>{for(const u in n)o(n[u])};m.forEach(n=>{n.contributes&&(n.contributes.menus&&l(n.contributes.menus),n.contributes.keybindings&&o(n.contributes.keybindings),n.contributes.views&&l(n.contributes.views))})}}e.$eS=g;class a{constructor(m,b){this.a=m,this.b=b}listen(m,b){throw new Error("Invalid listen")}async call(m,b,p){const d=this.b(m);switch(b){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const w=p[0],o=p[1]?P.URI.revive(d.transformIncoming(p[1])):void 0,l=Array.isArray(p[2])?p[2].map(f=>P.URI.revive(d.transformIncoming(f))):void 0,n=Array.isArray(p[3])?p[3].map(f=>P.URI.revive(d.transformIncoming(f))):void 0,u=p[4];return(await this.a.scanExtensions(w,o,l,n,u)).map(f=>(0,T.$Un)(f,d))}}throw new Error("Invalid call")}}e.$fS=a}),define(Te[153],Oe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7w=e.$4w=void 0,e.$5w=E,e.$6w=P;class t{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++t.count}}e.$4w=t;const r=[];function E(T){const v=new t(T);return r[v.nid]=v,v}function P(T){return r[T].sid}class D{constructor(v){this.value=v}}e.$7w=D}),define(Te[275],Oe([1,0,153]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aO=e.$_N=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$$N=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var r;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(r||(e.TextEditorRevealType=r={}));var E;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput",c[c.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(E||(e.TabInputKind=E={}));var P;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var D;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(D||(e.WebviewEditorCapabilities=D={}));var T;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var v;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var s;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var S;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output",c[c.Hybrid=3]="Hybrid"})(S||(e.CandidatePortSource=S={}));class y{static{this.a=0}static mixin(m){return m._id=y.a++,m}}e.$$N=y;var $;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var g;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(g||(e.ISuggestResultDtoField=g={}));var a;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(a||(e.ExtHostTestingResource=a={})),e.$_N={MainThreadAuthentication:(0,t.$5w)("MainThreadAuthentication"),MainThreadBulkEdits:(0,t.$5w)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,t.$5w)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,t.$5w)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,t.$5w)("MainThreadChatAgents2"),MainThreadChatVariables:(0,t.$5w)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,t.$5w)("MainThreadChatSkills"),MainThreadClipboard:(0,t.$5w)("MainThreadClipboard"),MainThreadCommands:(0,t.$5w)("MainThreadCommands"),MainThreadComments:(0,t.$5w)("MainThreadComments"),MainThreadConfiguration:(0,t.$5w)("MainThreadConfiguration"),MainThreadConsole:(0,t.$5w)("MainThreadConsole"),MainThreadDebugService:(0,t.$5w)("MainThreadDebugService"),MainThreadDecorations:(0,t.$5w)("MainThreadDecorations"),MainThreadDiagnostics:(0,t.$5w)("MainThreadDiagnostics"),MainThreadDialogs:(0,t.$5w)("MainThreadDiaglogs"),MainThreadDocuments:(0,t.$5w)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,t.$5w)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,t.$5w)("MainThreadTextEditors"),MainThreadEditorInsets:(0,t.$5w)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,t.$5w)("MainThreadEditorTabs"),MainThreadErrors:(0,t.$5w)("MainThreadErrors"),MainThreadTreeViews:(0,t.$5w)("MainThreadTreeViews"),MainThreadDownloadService:(0,t.$5w)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,t.$5w)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,t.$5w)("MainThreadLanguages"),MainThreadLogger:(0,t.$5w)("MainThreadLogger"),MainThreadMessageService:(0,t.$5w)("MainThreadMessageService"),MainThreadOutputService:(0,t.$5w)("MainThreadOutputService"),MainThreadProgress:(0,t.$5w)("MainThreadProgress"),MainThreadQuickDiff:(0,t.$5w)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,t.$5w)("MainThreadQuickOpen"),MainThreadStatusBar:(0,t.$5w)("MainThreadStatusBar"),MainThreadSecretState:(0,t.$5w)("MainThreadSecretState"),MainThreadStorage:(0,t.$5w)("MainThreadStorage"),MainThreadSpeech:(0,t.$5w)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,t.$5w)("MainThreadTelemetry"),MainThreadTerminalService:(0,t.$5w)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,t.$5w)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,t.$5w)("MainThreadWebviews"),MainThreadWebviewPanels:(0,t.$5w)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,t.$5w)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,t.$5w)("MainThreadCustomEditors"),MainThreadUrls:(0,t.$5w)("MainThreadUrls"),MainThreadUriOpeners:(0,t.$5w)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,t.$5w)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,t.$5w)("MainThreadWorkspace"),MainThreadFileSystem:(0,t.$5w)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,t.$5w)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,t.$5w)("MainThreadExtensionService"),MainThreadSCM:(0,t.$5w)("MainThreadSCM"),MainThreadSearch:(0,t.$5w)("MainThreadSearch"),MainThreadShare:(0,t.$5w)("MainThreadShare"),MainThreadTask:(0,t.$5w)("MainThreadTask"),MainThreadWindow:(0,t.$5w)("MainThreadWindow"),MainThreadLabelService:(0,t.$5w)("MainThreadLabelService"),MainThreadNotebook:(0,t.$5w)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,t.$5w)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,t.$5w)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,t.$5w)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,t.$5w)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,t.$5w)("MainThreadInteractive"),MainThreadTheming:(0,t.$5w)("MainThreadTheming"),MainThreadTunnelService:(0,t.$5w)("MainThreadTunnelService"),MainThreadManagedSockets:(0,t.$5w)("MainThreadManagedSockets"),MainThreadTimeline:(0,t.$5w)("MainThreadTimeline"),MainThreadTesting:(0,t.$5w)("MainThreadTesting"),MainThreadLocalization:(0,t.$5w)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,t.$5w)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,t.$5w)("MainThreadAiEmbeddingVector")},e.$aO={ExtHostCommands:(0,t.$5w)("ExtHostCommands"),ExtHostConfiguration:(0,t.$5w)("ExtHostConfiguration"),ExtHostDiagnostics:(0,t.$5w)("ExtHostDiagnostics"),ExtHostDebugService:(0,t.$5w)("ExtHostDebugService"),ExtHostDecorations:(0,t.$5w)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,t.$5w)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,t.$5w)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,t.$5w)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,t.$5w)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,t.$5w)("ExtHostEditors"),ExtHostTreeViews:(0,t.$5w)("ExtHostTreeViews"),ExtHostFileSystem:(0,t.$5w)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,t.$5w)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,t.$5w)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,t.$5w)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,t.$5w)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,t.$5w)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,t.$5w)("ExtHostQuickDiff"),ExtHostStatusBar:(0,t.$5w)("ExtHostStatusBar"),ExtHostShare:(0,t.$5w)("ExtHostShare"),ExtHostExtensionService:(0,t.$5w)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,t.$5w)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,t.$5w)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,t.$5w)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,t.$5w)("ExtHostSCM"),ExtHostSearch:(0,t.$5w)("ExtHostSearch"),ExtHostTask:(0,t.$5w)("ExtHostTask"),ExtHostWorkspace:(0,t.$5w)("ExtHostWorkspace"),ExtHostWindow:(0,t.$5w)("ExtHostWindow"),ExtHostWebviews:(0,t.$5w)("ExtHostWebviews"),ExtHostWebviewPanels:(0,t.$5w)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,t.$5w)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,t.$5w)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,t.$5w)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,t.$5w)("ExtHostEditorTabs"),ExtHostProgress:(0,t.$5w)("ExtHostProgress"),ExtHostComments:(0,t.$5w)("ExtHostComments"),ExtHostSecretState:(0,t.$5w)("ExtHostSecretState"),ExtHostStorage:(0,t.$5w)("ExtHostStorage"),ExtHostUrls:(0,t.$5w)("ExtHostUrls"),ExtHostUriOpeners:(0,t.$5w)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,t.$5w)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,t.$5w)("ExtHostOutputService"),ExtHostLabelService:(0,t.$5w)("ExtHostLabelService"),ExtHostNotebook:(0,t.$5w)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,t.$5w)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,t.$5w)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,t.$5w)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,t.$5w)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,t.$5w)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,t.$5w)("ExtHostInteractive"),ExtHostChatAgents2:(0,t.$5w)("ExtHostChatAgents"),ExtHostChatVariables:(0,t.$5w)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,t.$5w)("ExtHostChatSkills"),ExtHostChatProvider:(0,t.$5w)("ExtHostChatProvider"),ExtHostSpeech:(0,t.$5w)("ExtHostSpeech"),ExtHostEmbeddings:(0,t.$5w)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,t.$5w)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,t.$5w)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,t.$5w)("ExtHostTheming"),ExtHostTunnelService:(0,t.$5w)("ExtHostTunnelService"),ExtHostManagedSockets:(0,t.$5w)("ExtHostManagedSockets"),ExtHostAuthentication:(0,t.$5w)("ExtHostAuthentication"),ExtHostTimeline:(0,t.$5w)("ExtHostTimeline"),ExtHostTesting:(0,t.$5w)("ExtHostTesting"),ExtHostTelemetry:(0,t.$5w)("ExtHostTelemetry"),ExtHostLocalization:(0,t.$5w)("ExtHostLocalization")}}),define(Te[276],Oe([1,0,14,25,12,121,5]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$OL=void 0,e.$PL=S,e.$QL=y,e.$RL=$,e.$SL=g,e.$OL=(0,D.$Ki)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${T.join("")}]+`),s=7;function S(c){if(c.scheme!==E.Schemas.vscodeNotebookCell)return;const m=c.fragment.indexOf("s");if(m<0)return;const b=parseInt(c.fragment.substring(0,m).replace(v,""),s),p=(0,t.$_e)(c.fragment.substring(m+1)).toString();if(!isNaN(b))return{handle:b,notebook:c.with({scheme:p,fragment:null})}}function y(c,m){const b=m.toString(s),d=`${b.length<T.length?T[b.length-1]:"z"}${b}s${(0,t.$af)(t.$Se.fromString(c.scheme),!0,!0)}`;return c.with({scheme:E.Schemas.vscodeNotebookCell,fragment:d})}function $(c){if(c.scheme!==E.Schemas.vscodeNotebookMetadata)return;const m=(0,t.$_e)(c.fragment).toString();return c.with({scheme:m,fragment:null})}function g(c){const m=`${(0,t.$af)(t.$Se.fromString(c.scheme),!0,!0)}`;return c.with({scheme:E.Schemas.vscodeNotebookMetadata,fragment:m})}class a{constructor(){this.a=new r.$Fc}getNotebook(m){if(m.scheme===E.Schemas.vscodeNotebookCell){const b=S(m);if(b){const p=this.a.get(b.notebook);if(p)return p}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$TL=a,(0,P.$Zs)(e.$OL,a,P.InstantiationType.Delayed)}),define(Te[154],Oe([1,0,14,86,39,69,12,8,3,41,276]),function(ue,e,t,r,E,P,D,T,v,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$_L=e.CellStatusbarAlignment=e.$$L=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$8L=e.$7L=e.$5L=e.CellUri=e.NotebookUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$4L=e.$3L=e.$2L=e.$1L=e.CellKind=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=void 0,e.$6L=u,e.$9L=h,e.$0L=k,e.$aM=C,e.$bM=R,r=Ve(r),e.$UL="workbench.editor.notebook",e.$VL="workbench.editor.notebookTextDiffEditor",e.$WL="workbench.editor.notebookMultiTextDiffEditor",e.$XL="workbench.editor.interactive",e.$YL="workbench.editor.repl",e.$ZL="replNotebook.input.execute";var y;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(y||(e.CellKind=y={})),e.$1L=["application/json","application/javascript","text/html","image/svg+xml",P.$gt.latex,P.$gt.markdown,"image/png","image/jpeg",P.$gt.text],e.$2L=[P.$gt.latex,P.$gt.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$gt.text],e.$3L=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$4L="_notAvailable";var $;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})($||(e.NotebookRunState=$={}));var g;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(g||(e.NotebookCellExecutionState=g={}));var a;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(a||(e.NotebookExecutionState=a={}));var c;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var b;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(b||(e.NotebookCellsChangeType=b={}));var p;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(p||(e.SelectionStateType=p={}));var d;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var w;(function(B){B.scheme=D.Schemas.vscodeNotebookMetadata;function j(ee){return(0,S.$SL)(ee)}B.generate=j;function U(ee){return(0,S.$RL)(ee)}B.parse=U})(w||(e.NotebookUri=w={}));var o;(function(B){B.scheme=D.Schemas.vscodeNotebookCell;function j(ne,X){return(0,S.$QL)(ne,X)}B.generate=j;function U(ne){return(0,S.$PL)(ne)}B.parse=U;function ee(ne,X){return ne.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${X??""},${ne.scheme!==D.Schemas.file?ne.scheme:""}`})}B.generateCellOutputUri=ee;function ae(ne){if(ne.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const X=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!X)return;const z=X[1]&&X[1]!==""?X[1]:void 0,A=X[2];return{outputId:z,notebook:ne.with({scheme:A||D.Schemas.file,fragment:null})}}B.parseCellOutputUri=ae;function ye(ne,X,z){return B.generate(ne,X).with({scheme:z})}B.generateCellPropertyUri=ye;function se(ne,X){if(ne.scheme===X)return B.parse(ne.with({scheme:B.scheme}))}B.parseCellPropertyUri=se})(o||(e.CellUri=o={}));const l=B=>v.$l?B.replace(/\//g,"\\"):B;class n{constructor(j=[],U=e.$1L){this.e=U,this.d=[...new Set(j)].map(ee=>({pattern:ee,matches:r.$Fk(l(ee))}))}sort(j){const U=new Map(E.Iterable.map(j,ae=>[ae,l(ae)]));let ee=[];for(const{matches:ae}of this.d)for(const[ye,se]of U)if(ae(se)){ee.push(ye),U.delete(ye);break}return U.size&&(ee=ee.concat([...U.keys()].sort((ae,ye)=>this.e.indexOf(ae)-this.e.indexOf(ye)))),ee}prioritize(j,U){const ee=this.f(j);if(ee===-1){this.d.unshift({pattern:j,matches:r.$Fk(l(j))});return}const ae=new Set(U.map(se=>this.f(se,ee)));ae.delete(-1);const ye=Array.from(ae).sort();this.d.splice(ee+1,0,...ye.map(se=>this.d[se]));for(let se=ye.length-1;se>=0;se--)this.d.splice(ye[se],1)}toArray(){return this.d.map(j=>j.pattern)}f(j,U=this.d.length){const ee=l(j);for(let ae=0;ae<U;ae++)if(this.d[ae].matches(ee))return ae;return-1}}e.$5L=n;function u(B,j,U,ee=(ae,ye)=>ae===ye){const ae=[];function ye(X,z,A){if(z===0&&A.length===0)return;const Y=ae[ae.length-1];Y&&Y.start+Y.deleteCount===X?(Y.deleteCount+=z,Y.toInsert.push(...A)):ae.push({start:X,deleteCount:z,toInsert:A})}let se=0,ne=0;for(;;){if(se===B.length){ye(se,0,j.slice(ne));break}if(ne===j.length){ye(se,B.length-se,[]);break}const X=B[se],z=j[ne];if(ee(X,z)){se+=1,ne+=1;continue}U(z)?(ye(se,1,[]),se+=1):(ye(se,0,[z]),ne+=1)}return ae}e.$7L=new s.$2j("notebookEditorCursorAtBoundary","none"),e.$8L=new s.$2j("notebookEditorCursorAtLineBoundary","none");var i;(function(B){B.default="default",B.option="option"})(i||(e.NotebookEditorPriority=i={}));var f;(function(B){B.Cells="cells",B.Text="text",B.None="none"})(f||(e.NotebookFindScopeType=f={}));function h(B){const j=B;return!!((typeof j.include=="string"||r.$Gk(j.include))&&(typeof j.exclude=="string"||r.$Gk(j.exclude)))}function k(B,j,U){if(Array.isArray(B.viewType)&&B.viewType.indexOf(j)>=0||B.viewType===j)return!0;if(B.filenamePattern){const ee=h(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,ae=h(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(r.$Ek(ee,(0,T.$sc)(U.fsPath).toLowerCase()))return!(ae&&r.$Ek(ae,(0,T.$sc)(U.fsPath).toLowerCase()))}return!1}e.$$L={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var I;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(I||(e.CellStatusbarAlignment=I={}));class O{static{this.d="notebook/"}static create(j){return`${O.d}${j}`}static parse(j){if(j.startsWith(O.d))return j.substring(O.d.length)}}e.$_L=O;function C(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const L=new TextDecoder;function R(B){const j=[];let U=!1;for(const se of B)(j.length===0||U)&&(j.push(se),U=!0);let ee=Q(j);const ae=t.$Se.concat(j.map(se=>t.$Se.wrap(se))),ye=K(ae);return ee=ee||ye.byteLength!==ae.byteLength,{data:ye,didCompression:ee}}e.$cM="\x1B[A";const M=e.$cM.split("").map(B=>B.charCodeAt(0)),G=10;function Q(B){let j=!1;return B.forEach((U,ee)=>{if(ee===0||U.length<e.$cM.length)return;const ae=B[ee-1],ye=U.subarray(0,e.$cM.length);if(ye[0]===M[0]&&ye[1]===M[1]&&ye[2]===M[2]){const se=ae.lastIndexOf(G);if(se===-1)return;j=!0,B[ee-1]=ae.subarray(0,se),B[ee]=U.subarray(e.$cM.length)}}),j}function te(B){let j=B;do B=j,j=B.replace(/[^\n]\x08/gm,"");while(j.length<B.length);return B}function ve(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const j=B.match(/^(.*)\r+/m)[1];let U=B.match(/\r+(.*)$/m)[1];U=U+j.slice(U.length,j.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,U)}return B}const be=8,le=13;function K(B){return!B.buffer.includes(be)&&!B.buffer.includes(le)?B:t.$Se.fromString(ve(te(L.decode(B.buffer))))}}),define(Te[155],Oe([1,0,17,9,112,25,69,16,10,4,22,21,15,90,154]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a){"use strict";var c,m,b,p,d,w,o,l,n,u,i,f,h,k,I,O,C;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$BQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$AQ=e.$zQ=e.$yQ=e.$xQ=e.$wQ=e.$vQ=e.$uQ=e.$tQ=e.LanguageModelChatMessageRole=e.$sQ=e.$rQ=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$qQ=e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=e.$iQ=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.$dQ=e.$cQ=e.$bQ=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$aQ=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.$3P=e.$2P=e.$1P=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$ZP=e.$YP=e.$XP=e.$WP=e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.TestRunProfileKind=e.TestResultState=e.$PP=e.$OP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$NP=e.NotebookVariablesRequestKind=e.$MP=e.$LP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$KP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.ColorThemeKind=e.$EP=e.$DP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$CP=e.QuickInputButtonLocation=e.$BP=e.DebugConsoleMode=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$vP=e.$uP=e.FileChangeType=e.$tP=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$sP=e.$rP=e.$qP=e.$pP=e.InlineCompletionTriggerKind=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$cP=e.ConfigurationTarget=e.$bP=e.$aP=e.$_O=e.$$O=e.DocumentPasteTriggerKind=e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$4O=e.ViewBadge=e.ProgressLocation=e.$3O=e.$2O=e.TaskScope=e.ShellQuoting=e.$1O=e.$ZO=e.$YO=e.TaskPanelKind=e.TaskRevealKind=e.$XO=e.TerminalLocation=e.$WO=e.$VO=e.$UO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$TO=e.$SO=e.$RO=e.$QO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$OO=e.$NO=e.$MO=e.$LO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$KO=e.$JO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.LanguageStatusSeverity=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.CodeActionTriggerKind=e.$xO=e.$wO=e.SymbolTag=e.SymbolKind=e.$vO=e.$uO=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.DiagnosticSeverity=e.DiagnosticTag=e.$oO=e.$nO=e.FileEditType=e.$mO=e.$lO=e.$kO=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$jO=e.$iO=e.$hO=e.$eO=e.$dO=e.$cO=e.$bO=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$fO=be,e.$gO=le,e.$PO=et,e.$dP=Pn,e.$VP=$i;function L(F){return Object.assign(F,{apply:function(...oe){if(oe.length===0)return Reflect.construct(F,[]);{const ke=oe.length===1?[]:oe[1];return Reflect.construct(F,ke,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(F,[]);{const[ke,...Ke]=oe;return Reflect.construct(F,Ke,ke.constructor)}}})}var R;(function(F){F[F.Top=0]="Top",F[F.Bottom=1]="Bottom"})(R||(e.TerminalOutputAnchor=R={}));var M;(function(F){F[F.TerminalCommand=0]="TerminalCommand",F[F.Opener=1]="Opener",F[F.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let G=c=class{static from(...N){let oe=N;return new c(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$bO=G,e.$bO=G=c=We([L],G);let Q=m=class{static Min(...N){if(N.length===0)throw new TypeError;let oe=N[0];for(let ke=1;ke<N.length;ke++){const Ke=N[ke];Ke.isBefore(oe)&&(oe=Ke)}return oe}static Max(...N){if(N.length===0)throw new TypeError;let oe=N[0];for(let ke=1;ke<N.length;ke++){const Ke=N[ke];Ke.isAfter(oe)&&(oe=Ke)}return oe}static isPosition(N){if(!N)return!1;if(N instanceof m)return!0;const{line:oe,character:ke}=N;return typeof oe=="number"&&typeof ke=="number"}static of(N){if(N instanceof m)return N;if(this.isPosition(N))return new m(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,oe){if(N<0)throw(0,r.$$)("line must be non-negative");if(oe<0)throw(0,r.$$)("character must be non-negative");this.c=N,this.e=oe}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,oe=0){if(N===null||oe===null)throw(0,r.$$)();let ke;return typeof N>"u"?ke=0:typeof N=="number"?ke=N:(ke=typeof N.lineDelta=="number"?N.lineDelta:0,oe=typeof N.characterDelta=="number"?N.characterDelta:0),ke===0&&oe===0?this:new m(this.line+ke,this.character+oe)}with(N,oe=this.character){if(N===null||oe===null)throw(0,r.$$)();let ke;return typeof N>"u"?ke=this.line:typeof N=="number"?ke=N:(ke=typeof N.line=="number"?N.line:this.line,oe=typeof N.character=="number"?N.character:this.character),ke===this.line&&oe===this.character?this:new m(ke,oe)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$cO=Q,e.$cO=Q=m=We([L],Q);let te=b=class{static isRange(N){return N instanceof b?!0:N?Q.isPosition(N.start)&&Q.isPosition(N.end):!1}static of(N){if(N instanceof b)return N;if(this.isRange(N))return new b(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,oe,ke,Ke){let _e,at;if(typeof N=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"?(_e=new Q(N,oe),at=new Q(ke,Ke)):Q.isPosition(N)&&Q.isPosition(oe)&&(_e=Q.of(N),at=Q.of(oe)),!_e||!at)throw new Error("Invalid arguments");_e.isBefore(at)?(this.c=_e,this.e=at):(this.c=at,this.e=_e)}contains(N){return b.isRange(N)?this.contains(N.start)&&this.contains(N.end):Q.isPosition(N)?!(Q.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const oe=Q.Max(N.start,this.c),ke=Q.Min(N.end,this.e);if(!oe.isAfter(ke))return new b(oe,ke)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const oe=Q.Min(N.start,this.c),ke=Q.Max(N.end,this.end);return new b(oe,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,oe=this.end){if(N===null||oe===null)throw(0,r.$$)();let ke;return N?Q.isPosition(N)?ke=N:(ke=N.start||this.start,oe=N.end||this.end):ke=this.start,ke.isEqual(this.c)&&oe.isEqual(this.end)?this:new b(ke,oe)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return be(this)}};e.$dO=te,e.$dO=te=b=We([L],te);let ve=p=class extends te{static isSelection(N){return N instanceof p?!0:N?te.isRange(N)&&Q.isPosition(N.anchor)&&Q.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,oe,ke,Ke){let _e,at;if(typeof N=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"?(_e=new Q(N,oe),at=new Q(ke,Ke)):Q.isPosition(N)&&Q.isPosition(oe)&&(_e=Q.of(N),at=Q.of(oe)),!_e||!at)throw new Error("Invalid arguments");super(_e,at),this.f=_e,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return le(this)}};e.$eO=ve,e.$eO=ve=p=We([L],ve);function be(F){return F.isEmpty?`[${F.start.line}:${F.start.character})`:`[${F.start.line}:${F.start.character} -> ${F.end.line}:${F.end.character})`}function le(F){let N=be(F);return F.isEmpty||(F.active.isEqual(F.start)?N=`|${N}`:N=`${N}|`),N}const K=F=>{if(typeof F!="string"||F.length===0||!/^[0-9A-Za-z_\-]+$/.test(F))throw(0,r.$$)("connectionToken")};class B{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,oe,ke){if(typeof N!="string"||N.length===0)throw(0,r.$$)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,r.$$)("port");typeof ke<"u"&&K(ke),this.host=N,this.port=Math.round(oe),this.connectionToken=ke}}e.$hO=B;class j{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,oe){this.makeConnection=N,this.connectionToken=oe,typeof oe<"u"&&K(oe)}}e.$iO=j;class U extends Error{static NotAvailable(N,oe){return new U(N,g.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(N){return new U(N,g.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,oe=g.RemoteAuthorityResolverErrorCode.Unknown,ke){super(N),this._message=N,this._code=oe,this._detail=ke,Object.setPrototypeOf(this,U.prototype)}}e.$jO=U;var ee;(function(F){F[F.LF=1]="LF",F[F.CRLF=2]="CRLF"})(ee||(e.EndOfLine=ee={}));var ae;(function(F){F[F.Replace=1]="Replace",F[F.Append=2]="Append",F[F.Prepend=3]="Prepend"})(ae||(e.EnvironmentVariableMutatorType=ae={}));let ye=d=class{static isTextEdit(N){return N instanceof d?!0:N?te.isRange(N)&&typeof N.newText=="string":!1}static replace(N,oe){return new d(N,oe)}static insert(N,oe){return d.replace(new te(N,N),oe)}static delete(N){return d.replace(N,"")}static setEndOfLine(N){const oe=new d(new te(new Q(0,0),new Q(0,0)),"");return oe.newEol=N,oe}get range(){return this.c}set range(N){if(N&&!te.isRange(N))throw(0,r.$$)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,r.$$)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,r.$$)("newEol");this.f=N}constructor(N,oe){this.c=N,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$kO=ye,e.$kO=ye=d=We([L],ye);let se=w=class{static isNotebookCellEdit(N){return N instanceof w?!0:N?un.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,oe){return new w(N,oe)}static insertCells(N,oe){return new w(new un(N,N),oe)}static deleteCells(N){return new w(N,[])}static updateCellMetadata(N,oe){const ke=new w(new un(N,N),[]);return ke.newCellMetadata=oe,ke}static updateNotebookMetadata(N){const oe=new w(new un(0,0),[]);return oe.newNotebookMetadata=N,oe}constructor(N,oe){this.range=N,this.newCells=oe}};e.$lO=se,e.$lO=se=w=We([L],se);class ne{static isSnippetTextEdit(N){return N instanceof ne?!0:N?te.isRange(N.range)&&A.isSnippetString(N.snippet):!1}static replace(N,oe){return new ne(N,oe)}static insert(N,oe){return ne.replace(new te(N,N),oe)}constructor(N,oe){this.range=N,this.snippet=oe}}e.$mO=ne;var X;(function(F){F[F.File=1]="File",F[F.Text=2]="Text",F[F.Cell=3]="Cell",F[F.CellReplace=5]="CellReplace",F[F.Snippet=6]="Snippet"})(X||(e.FileEditType=X={}));let z=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,oe,ke,Ke){this.c.push({_type:X.File,from:N,to:oe,options:ke,metadata:Ke})}createFile(N,oe,ke){this.c.push({_type:X.File,from:void 0,to:N,options:oe,metadata:ke})}deleteFile(N,oe,ke){this.c.push({_type:X.File,from:N,to:void 0,options:oe,metadata:ke})}e(N,oe,ke){this.c.push({_type:X.Cell,metadata:ke,uri:N,edit:{editType:a.CellEditType.DocumentMetadata,metadata:oe},notebookMetadata:oe})}f(N,oe,ke,Ke){const _e=oe.start,at=oe.end;(_e!==at||ke.length>0)&&this.c.push({_type:X.CellReplace,uri:N,index:_e,count:at-_e,cells:ke,metadata:Ke})}g(N,oe,ke,Ke){this.c.push({_type:X.Cell,metadata:Ke,uri:N,edit:{editType:a.CellEditType.Metadata,index:oe,metadata:ke}})}replace(N,oe,ke,Ke){this.c.push({_type:X.Text,uri:N,edit:new ye(oe,ke),metadata:Ke})}insert(N,oe,ke,Ke){this.replace(N,new te(oe,oe),ke,Ke)}delete(N,oe,ke){this.replace(N,oe,"",ke)}has(N){return this.c.some(oe=>oe._type===X.Text&&oe.uri.toString()===N.toString())}set(N,oe){if(oe)for(const ke of oe){if(!ke)continue;let Ke,_e;Array.isArray(ke)?(Ke=ke[0],_e=ke[1]):Ke=ke,se.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(N,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(N,Ke.newNotebookMetadata,_e):this.f(N,Ke.range,Ke.newCells,_e):ne.isSnippetTextEdit(Ke)?this.c.push({_type:X.Snippet,uri:N,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:X.Text,uri:N,edit:Ke,metadata:_e})}else{for(let ke=0;ke<this.c.length;ke++){const Ke=this.c[ke];switch(Ke._type){case X.Text:case X.Snippet:case X.Cell:case X.CellReplace:Ke.uri.toString()===N.toString()&&(this.c[ke]=void 0);break}}(0,t.$Mb)(this.c)}}get(N){const oe=[];for(const ke of this.c)ke._type===X.Text&&ke.uri.toString()===N.toString()&&oe.push(ke.edit);return oe}entries(){const N=new P.$Fc;for(const oe of this.c)if(oe._type===X.Text){let ke=N.get(oe.uri);ke||(ke=[oe.uri,[]],N.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$nO=z,e.$nO=z=We([L],z);let A=o=class{static isSnippetString(N){return N instanceof o?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=o.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,oe=this.e++){if(typeof N=="function"){const ke=new o;ke.e=this.e,N(ke),this.e=ke.e,N=ke.value}else N=o.c(N);return this.value+="${",this.value+=oe,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,oe=this.e++){const ke=N.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(N,oe){if(typeof oe=="function"){const ke=new o;ke.e=this.e,oe(ke),this.e=ke.e,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$oO=A,e.$oO=A=o=We([L],A);var Y;(function(F){F[F.Unnecessary=1]="Unnecessary",F[F.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var pe;(function(F){F[F.Hint=3]="Hint",F[F.Information=2]="Information",F[F.Warning=1]="Warning",F[F.Error=0]="Error"})(pe||(e.DiagnosticSeverity=pe={}));let x=l=class{static isLocation(N){return N instanceof l?!0:N?te.isRange(N.range)&&s.URI.isUri(N.uri):!1}constructor(N,oe){if(this.uri=N,oe)if(te.isRange(oe))this.range=te.of(oe);else if(Q.isPosition(oe))this.range=new te(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$pO=x,e.$pO=x=l=We([L],x);let ie=class{static is(N){return N?typeof N.message=="string"&&N.location&&te.isRange(N.location.range)&&s.URI.isUri(N.location.uri):!1}constructor(N,oe){this.location=N,this.message=oe}static isEqual(N,oe){return N===oe?!0:!N||!oe?!1:N.message===oe.message&&N.location.range.isEqual(oe.location.range)&&N.location.uri.toString()===oe.location.uri.toString()}};e.$qO=ie,e.$qO=ie=We([L],ie);let W=class{constructor(N,oe,ke=pe.Error){if(!te.isRange(N))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=N,this.message=oe,this.severity=ke}toJSON(){return{severity:pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,oe){return N===oe?!0:!N||!oe?!1:N.message===oe.message&&N.severity===oe.severity&&N.code===oe.code&&N.severity===oe.severity&&N.source===oe.source&&N.range.isEqual(oe.range)&&(0,t.$yb)(N.tags,oe.tags)&&(0,t.$yb)(N.relatedInformation,oe.relatedInformation,ie.isEqual)}};e.$rO=W,e.$rO=W=We([L],W);let Z=class{constructor(N,oe){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=oe}};e.$sO=Z,e.$sO=Z=We([L],Z);let ce=class extends Z{constructor(N,oe,ke,Ke){super(N,oe),this.canIncreaseVerbosity=ke,this.canDecreaseVerbosity=Ke}};e.$tO=ce,e.$tO=ce=We([L],ce);var we;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})(we||(e.HoverVerbosityAction=we={}));var Le;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(Le||(e.DocumentHighlightKind=Le={}));let ze=class{constructor(N,oe=Le.Text){this.range=N,this.kind=oe}toJSON(){return{range:this.range,kind:Le[this.kind]}}};e.$uO=ze,e.$uO=ze=We([L],ze);let qe=class{constructor(N,oe){this.uri=N,this.highlights=oe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(N=>N.toJSON())}}};e.$vO=qe,e.$vO=qe=We([L],qe);var Re;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(Re||(e.SymbolKind=Re={}));var Ne;(function(F){F[F.Deprecated=1]="Deprecated"})(Ne||(e.SymbolTag=Ne={}));let De=n=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,oe,ke,Ke,_e){this.name=N,this.kind=oe,this.containerName=_e,typeof ke=="string"&&(this.containerName=ke),Ke instanceof x?this.location=Ke:ke instanceof te&&(this.location=new x(Ke,ke)),n.validate(this)}toJSON(){return{name:this.name,kind:Re[this.kind],location:this.location,containerName:this.containerName}}};e.$wO=De,e.$wO=De=n=We([L],De);let Ce=u=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(u.validate)}constructor(N,oe,ke,Ke,_e){this.name=N,this.detail=oe,this.kind=ke,this.range=Ke,this.selectionRange=_e,this.children=[],u.validate(this)}};e.$xO=Ce,e.$xO=Ce=u=We([L],Ce);var ge;(function(F){F[F.Invoke=1]="Invoke",F[F.Automatic=2]="Automatic"})(ge||(e.CodeActionTriggerKind=ge={}));let Se=class{constructor(N,oe){this.title=N,this.kind=oe}};e.$yO=Se,e.$yO=Se=We([L],Se);let Pe=class{static{i=this}static{this.c="."}constructor(N){this.value=N}append(N){return new i(this.value?this.value+i.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+i.c)}};e.$zO=Pe,e.$zO=Pe=i=We([L],Pe),Pe.Empty=new Pe(""),Pe.QuickFix=Pe.Empty.append("quickfix"),Pe.Refactor=Pe.Empty.append("refactor"),Pe.RefactorExtract=Pe.Refactor.append("extract"),Pe.RefactorInline=Pe.Refactor.append("inline"),Pe.RefactorMove=Pe.Refactor.append("move"),Pe.RefactorRewrite=Pe.Refactor.append("rewrite"),Pe.Source=Pe.Empty.append("source"),Pe.SourceOrganizeImports=Pe.Source.append("organizeImports"),Pe.SourceFixAll=Pe.Source.append("fixAll"),Pe.Notebook=Pe.Empty.append("notebook");let Ue=class{constructor(N,oe){if(this.range=N,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$AO=Ue,e.$AO=Ue=We([L],Ue);class Ge{constructor(N,oe,ke,Ke,_e,at){this.kind=N,this.name=oe,this.detail=ke,this.uri=Ke,this.range=_e,this.selectionRange=at}}e.$BO=Ge;class Qe{constructor(N,oe){this.fromRanges=oe,this.from=N}}e.$CO=Qe;class Ze{constructor(N,oe){this.fromRanges=oe,this.to=N}}e.$DO=Ze;var Xe;(function(F){F[F.Information=0]="Information",F[F.Warning=1]="Warning",F[F.Error=2]="Error"})(Xe||(e.LanguageStatusSeverity=Xe={}));let tt=class{constructor(N,oe){this.range=N,this.command=oe}get isResolved(){return!!this.command}};e.$EO=tt,e.$EO=tt=We([L],tt);let lt=f=class{#e;static isMarkdownString(N){return N instanceof f?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,oe=!1){this.#e=new E.$9k(N,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,oe){return this.#e.appendCodeblock(oe??"",N),this}};e.$FO=lt,e.$FO=lt=f=We([L],lt);let ct=class{constructor(N,oe){this.label=N,this.documentation=oe}};e.$GO=ct,e.$GO=ct=We([L],ct);let rt=class{constructor(N,oe){this.label=N,this.documentation=oe,this.parameters=[]}};e.$HO=rt,e.$HO=rt=We([L],rt);let ut=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$IO=ut,e.$IO=ut=We([L],ut);var st;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var Je;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(Je||(e.InlayHintKind=Je={}));let me=class{constructor(N){this.value=N}};e.$JO=me,e.$JO=me=We([L],me);let V=class{constructor(N,oe,ke){this.position=N,this.label=oe,this.kind=ke}};e.$KO=V,e.$KO=V=We([L],V);var _;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_||(e.CompletionTriggerKind=_={}));var fe;(function(F){F[F.Text=0]="Text",F[F.Method=1]="Method",F[F.Function=2]="Function",F[F.Constructor=3]="Constructor",F[F.Field=4]="Field",F[F.Variable=5]="Variable",F[F.Class=6]="Class",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Unit=10]="Unit",F[F.Value=11]="Value",F[F.Enum=12]="Enum",F[F.Keyword=13]="Keyword",F[F.Snippet=14]="Snippet",F[F.Color=15]="Color",F[F.File=16]="File",F[F.Reference=17]="Reference",F[F.Folder=18]="Folder",F[F.EnumMember=19]="EnumMember",F[F.Constant=20]="Constant",F[F.Struct=21]="Struct",F[F.Event=22]="Event",F[F.Operator=23]="Operator",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue"})(fe||(e.CompletionItemKind=fe={}));var re;(function(F){F[F.Deprecated=1]="Deprecated"})(re||(e.CompletionItemTag=re={}));let he=class{constructor(N,oe){this.label=N,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&fe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$LO=he,e.$LO=he=We([L],he);let H=class{constructor(N=[],oe=!1){this.items=N,this.isIncomplete=oe}};e.$MO=H,e.$MO=H=We([L],H);let J=class{constructor(N,oe,ke){this.insertText=N,this.range=oe,this.command=ke}};e.$NO=J,e.$NO=J=We([L],J);let $e=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$OO=$e,e.$OO=$e=We([L],$e);var Fe;(function(F){F[F.Unknown=0]="Unknown",F[F.Word=1]="Word",F[F.Line=2]="Line",F[F.Suggest=3]="Suggest"})(Fe||(e.PartialAcceptTriggerKind=Fe={}));var He;(function(F){F[F.Active=-1]="Active",F[F.Beside=-2]="Beside",F[F.One=1]="One",F[F.Two=2]="Two",F[F.Three=3]="Three",F[F.Four=4]="Four",F[F.Five=5]="Five",F[F.Six=6]="Six",F[F.Seven=7]="Seven",F[F.Eight=8]="Eight",F[F.Nine=9]="Nine"})(He||(e.ViewColumn=He={}));var xe;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(xe||(e.StatusBarAlignment=xe={}));function et(F,N){return`${y.$xn.toKey(F)}.${N}`}var it;(function(F){F[F.Off=0]="Off",F[F.On=1]="On",F[F.Relative=2]="Relative",F[F.Interval=3]="Interval"})(it||(e.TextEditorLineNumbersStyle=it={}));var ft;(function(F){F[F.Manual=1]="Manual",F[F.AfterDelay=2]="AfterDelay",F[F.FocusOut=3]="FocusOut"})(ft||(e.TextDocumentSaveReason=ft={}));var gt;(function(F){F[F.Default=0]="Default",F[F.InCenter=1]="InCenter",F[F.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",F[F.AtTop=3]="AtTop"})(gt||(e.TextEditorRevealType=gt={}));var Et;(function(F){F[F.Keyboard=1]="Keyboard",F[F.Mouse=2]="Mouse",F[F.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Rt;(function(F){F[F.Undo=1]="Undo",F[F.Redo=2]="Redo"})(Rt||(e.TextDocumentChangeReason=Rt={}));var mt;(function(F){F[F.OpenOpen=0]="OpenOpen",F[F.ClosedClosed=1]="ClosedClosed",F[F.OpenClosed=2]="OpenClosed",F[F.ClosedOpen=3]="ClosedOpen"})(mt||(e.DecorationRangeBehavior=mt={})),function(F){function N(oe){switch(oe){case"keyboard":return F.Keyboard;case"mouse":return F.Mouse;case"api":return F.Command}}F.fromValue=N}(Et||(e.TextEditorSelectionChangeKind=Et={}));var pt;(function(F){F[F.Other=0]="Other",F[F.Comment=1]="Comment",F[F.String=2]="String",F[F.RegEx=3]="RegEx"})(pt||(e.SyntaxTokenType=pt={})),function(F){function N(oe){switch(oe){case F.Other:return"other";case F.Comment:return"comment";case F.String:return"string";case F.RegEx:return"regex"}return"other"}F.toString=N}(pt||(e.SyntaxTokenType=pt={}));let wt=class{constructor(N,oe){if(oe&&!s.URI.isUri(oe))throw(0,r.$$)("target");if(!te.isRange(N)||N.isEmpty)throw(0,r.$$)("range");this.range=N,this.target=oe}};e.$QO=wt,e.$QO=wt=We([L],wt);let Wt=class{constructor(N,oe,ke,Ke){this.red=N,this.green=oe,this.blue=ke,this.alpha=Ke}};e.$RO=Wt,e.$RO=Wt=We([L],Wt);let It=class{constructor(N,oe){if(oe&&!(oe instanceof Wt))throw(0,r.$$)("color");if(!te.isRange(N)||N.isEmpty)throw(0,r.$$)("range");this.range=N,this.color=oe}};e.$SO=It,e.$SO=It=We([L],It);let Ct=class{constructor(N){if(!N||typeof N!="string")throw(0,r.$$)("label");this.label=N}};e.$TO=Ct,e.$TO=Ct=We([L],Ct);var Nt;(function(F){F[F.RGB=0]="RGB",F[F.HEX=1]="HEX",F[F.HSL=2]="HSL"})(Nt||(e.ColorFormat=Nt={}));var dt;(function(F){F[F.Error=0]="Error",F[F.Warning=1]="Warning",F[F.Information=2]="Information"})(dt||(e.SourceControlInputBoxValidationType=dt={}));var vt;(function(F){F[F.Unknown=0]="Unknown",F[F.Shutdown=1]="Shutdown",F[F.Process=2]="Process",F[F.User=3]="User",F[F.Extension=4]="Extension"})(vt||(e.TerminalExitReason=vt={}));var bt;(function(F){F[F.Low=0]="Low",F[F.Medium=1]="Medium",F[F.High=2]="High"})(bt||(e.TerminalShellExecutionCommandLineConfidence=bt={}));class Bt{constructor(N,oe,ke){if(this.startIndex=N,this.length=oe,this.tooltip=ke,typeof N!="number"||N<0)throw(0,r.$$)("startIndex");if(typeof oe!="number"||oe<1)throw(0,r.$$)("length");if(ke!==void 0&&typeof ke!="string")throw(0,r.$$)("tooltip")}}e.$UO=Bt;class jt{constructor(N){this.uri=N}}e.$VO=jt;class _t{constructor(N){this.terminalCommand=N}}e.$WO=_t;var Ot;(function(F){F[F.Panel=1]="Panel",F[F.Editor=2]="Editor"})(Ot||(e.TerminalLocation=Ot={}));class Ft{constructor(N){if(this.options=N,typeof N!="object")throw(0,r.$$)("options")}}e.$XO=Ft;var Vt;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(Vt||(e.TaskRevealKind=Vt={}));var Gt;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(Gt||(e.TaskPanelKind=Gt={}));let St=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(N){switch(N){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(N,oe){if(this.label=oe,typeof N!="string"||typeof oe!="string")throw(0,r.$$)("name");this.c=N}get id(){return this.c}};e.$YO=St,e.$YO=St=h=We([L],St);function Lt(F){let N="";for(let oe=0;oe<F.length;oe++)N+=F[oe].replace(/,/g,",,")+",";return N}let At=class{constructor(N,oe,ke){if(typeof N!="string")throw(0,r.$$)("process");this.e=[],this.c=N,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=ke):this.f=oe)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,r.$$)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)N.push(oe);return Lt(N)}};e.$ZO=At,e.$ZO=At=We([L],At);let Kt=class{constructor(N,oe,ke){if(this.f=[],Array.isArray(oe)){if(!N)throw(0,r.$$)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,r.$$)("command");this.e=N,this.f=oe,this.g=ke}else{if(typeof N!="string")throw(0,r.$$)("commandLine");this.c=N,this.g=oe}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,r.$$)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,r.$$)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)N.push(typeof oe=="string"?oe:oe.value);return Lt(N)}};e.$1O=Kt,e.$1O=Kt=We([L],Kt);var Qt;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var qt;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace"})(qt||(e.TaskScope=qt={}));class Zt{constructor(N){this.c=N}computeId(){return"customExecution"+(0,S.$7g)()}set callback(N){this.c=N}get callback(){return this.c}}e.$2O=Zt;let Jt=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,oe,ke,Ke,_e,at){this.k=!1,this.l=this.definition=N;let ht;typeof oe=="string"?(this.o=this.name=oe,this.w=this.source=ke,this.execution=Ke,ht=_e,this.k=!0):oe===qt.Global||oe===qt.Workspace?(this.target=oe,this.o=this.name=ke,this.w=this.source=Ke,this.execution=_e,ht=at):(this.target=oe,this.o=this.name=ke,this.w=this.source=Ke,this.execution=_e,ht=at),typeof ht=="string"?(this.r=[ht],this.t=!0):Array.isArray(ht)?(this.r=ht,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(N){this.j=N}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof At?this.l={type:k.e,id:this.q.computeId()}:this.q instanceof Kt?this.l={type:k.f,id:this.q.computeId()}:this.q instanceof Zt?this.l={type:k.c,id:this.q.computeId()}:this.l={type:k.g,id:(0,S.$7g)()}}get definition(){return this.l}set definition(N){if(N==null)throw(0,r.$$)("Kind can't be undefined or null");this.B(),this.l=N}get scope(){return this.m}set target(N){this.B(),this.m=N}get name(){return this.o}set name(N){if(typeof N!="string")throw(0,r.$$)("name");this.B(),this.o=N}get execution(){return this.q}set execution(N){N===null&&(N=void 0),this.B(),this.q=N;const oe=this.l.type;(k.g===oe||k.e===oe||k.f===oe||k.c===oe)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(N){if(Array.isArray(N))this.B(),this.r=N,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.B(),this.u=N}get source(){return this.w}set source(N){if(typeof N!="string"||N.length===0)throw(0,r.$$)("source must be a string of length > 0");this.B(),this.w=N}get group(){return this.x}set group(N){N===null&&(N=void 0),this.B(),this.x=N}get detail(){return this.A}set detail(N){N===null&&(N=void 0),this.A=N}get presentationOptions(){return this.y}set presentationOptions(N){N==null&&(N=Object.create(null)),this.B(),this.y=N}get runOptions(){return this.z}set runOptions(N){N==null&&(N=Object.create(null)),this.B(),this.z=N}};e.$3O=Jt,e.$3O=Jt=k=We([L],Jt);var Yt;(function(F){F[F.SourceControl=1]="SourceControl",F[F.Window=10]="Window",F[F.Notification=15]="Notification"})(Yt||(e.ProgressLocation=Yt={}));var Mt;(function(F){function N(oe){const ke=oe;return(0,v.$ng)(ke.value)?ke.tooltip&&!(0,v.$jg)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}F.isViewBadge=N})(Mt||(e.ViewBadge=Mt={}));let Ht=I=class{static isTreeItem(N,oe){const ke=N;if(ke.checkboxState!==void 0){const Ke=(0,v.$ng)(ke.checkboxState)?ke.checkboxState:(0,v.$lg)(ke.checkboxState)&&(0,v.$ng)(ke.checkboxState.state)?ke.checkboxState.state:void 0,_e=!(0,v.$ng)(ke.checkboxState)&&(0,v.$lg)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==zt.Checked&&Ke!==zt.Unchecked||_e!==void 0&&!(0,v.$jg)(_e))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(N instanceof I)return!0;if(ke.label!==void 0&&!(0,v.$jg)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,v.$jg)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,v.$jg)(ke.iconPath)&&!s.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,v.$jg)(ke.iconPath.id))){const Ke=ke.iconPath;if(!Ke||!(0,v.$jg)(Ke.light)&&!s.URI.isUri(Ke.light)&&!(0,v.$jg)(Ke.dark)&&!s.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,v.$jg)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!s.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,v.$jg)(ke.tooltip)&&!(ke.tooltip instanceof lt)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<yt.None&&ke.collapsibleState>yt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,v.$jg)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(N,oe=yt.None){this.collapsibleState=oe,s.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$4O=Ht,e.$4O=Ht=I=We([L],Ht);var yt;(function(F){F[F.None=0]="None",F[F.Collapsed=1]="Collapsed",F[F.Expanded=2]="Expanded"})(yt||(e.TreeItemCollapsibleState=yt={}));var zt;(function(F){F[F.Unchecked=0]="Unchecked",F[F.Checked=1]="Checked"})(zt||(e.TreeItemCheckboxState=zt={}));let Ut=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$5O=Ut,e.$5O=Ut=We([L],Ut);class an extends Ut{}e.$6O=an;class ln extends an{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$7O=ln;class wn{constructor(N,oe,ke,Ke){this.name=N,this.uri=oe,this._itemId=ke,this.c=Ke}data(){return this.c()}}e.$8O=wn;let cn=class{#e=new Map;constructor(N){for(const[oe,ke]of N??[]){const Ke=this.#e.get(this.#t(oe));Ke?Ke.push(ke):this.#e.set(this.#t(oe),[ke])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,oe){this.#e.set(this.#t(N),[oe])}forEach(N,oe){for(const[ke,Ke]of this.#e)for(const _e of Ke)N.call(oe,_e,ke,this)}*[Symbol.iterator](){for(const[N,oe]of this.#e)for(const ke of oe)yield[N,ke]}#t(N){return N.toLowerCase()}};e.$9O=cn,e.$9O=cn=We([L],cn);let fn=class{constructor(N,oe,ke){this.insertText=N,this.title=oe,this.kind=ke}};e.$0O=fn,e.$0O=fn=We([L],fn);var yn;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(yn||(e.DocumentPasteTriggerKind=yn={}));class tn{static{this.c="."}constructor(N){this.value=N}append(...N){return new tn((this.value?[this.value,...N]:N).join(tn.c))}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+tn.c)}}e.$$O=tn,tn.Empty=new tn("");class vn{constructor(N,oe,ke){this.title=oe,this.insertText=N,this.kind=ke}}e.$_O=vn;let Xt=class{constructor(N,oe){this.id=N,this.color=oe}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$aP=Xt,e.$aP=Xt=We([L],Xt),Xt.File=new Xt("file"),Xt.Folder=new Xt("folder");let dn=class{constructor(N){this.id=N}};e.$bP=dn,e.$bP=dn=We([L],dn);var En;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.WorkspaceFolder=3]="WorkspaceFolder"})(En||(e.ConfigurationTarget=En={}));let mn=class{get base(){return this.c}set base(N){this.c=N,this.e=s.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,oe){if(typeof N!="string"&&(!N||!s.URI.isUri(N)&&!s.URI.isUri(N.uri)))throw(0,r.$$)("base");if(typeof oe!="string")throw(0,r.$$)("pattern");typeof N=="string"?this.baseUri=s.URI.file(N):s.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$cP=mn,e.$cP=mn=We([L],mn);const Sn=new WeakMap;function Pn(F,N){Sn.set(F,N)}let sn=class{constructor(N,oe,ke,Ke,_e){this.enabled=typeof N=="boolean"?N:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Ke=="string"&&(this.logMessage=Ke),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=Sn.get(this)??(0,S.$7g)()),this.c}};e.$eP=sn,e.$eP=sn=We([L],sn);let $n=class extends sn{constructor(N,oe,ke,Ke,_e,at){if(super(oe,ke,Ke,_e,at),N===null)throw(0,r.$$)("location");this.location=N}};e.$fP=$n,e.$fP=$n=We([L],$n);let gn=class extends sn{constructor(N,oe,ke,Ke,_e,at){super(oe,ke,Ke,_e,at),this.functionName=N}};e.$gP=gn,e.$gP=gn=We([L],gn);let pn=class extends sn{constructor(N,oe,ke,Ke,_e,at,ht,Tt){if(super(Ke,_e,at,ht,Tt),!oe)throw(0,r.$$)("dataId");this.label=N,this.dataId=oe,this.canPersist=ke}};e.$hP=pn,e.$hP=pn=We([L],pn);let bn=class{constructor(N,oe,ke){this.command=N,this.args=oe||[],this.options=ke}};e.$iP=bn,e.$iP=bn=We([L],bn);let Ee=class{constructor(N,oe){this.port=N,this.host=oe}};e.$jP=Ee,e.$jP=Ee=We([L],Ee);let Ae=class{constructor(N){this.path=N}};e.$kP=Ae,e.$kP=Ae=We([L],Ae);let de=class{constructor(N){this.implementation=N}};e.$lP=de,e.$lP=de=We([L],de);class q{constructor(N,oe,ke){this.session=N,this.threadId=oe,this.frameId=ke}}e.$mP=q;class Ie{constructor(N,oe){this.session=N,this.threadId=oe}}e.$nP=Ie;let Be=class{constructor(N,oe){this.range=N,this.expression=oe}};e.$oP=Be,e.$oP=Be=We([L],Be);var Ye;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Ye||(e.InlineCompletionTriggerKind=Ye={}));let Me=class{constructor(N,oe){this.range=N,this.text=oe}};e.$pP=Me,e.$pP=Me=We([L],Me);let nt=class{constructor(N,oe,ke=!0){this.range=N,this.variableName=oe,this.caseSensitiveLookup=ke}};e.$qP=nt,e.$qP=nt=We([L],nt);let ot=class{constructor(N,oe){this.range=N,this.expression=oe}};e.$rP=ot,e.$rP=ot=We([L],ot);let Dt=class{constructor(N,oe){this.frameId=N,this.stoppedLocation=oe}};e.$sP=Dt,e.$sP=Dt=We([L],Dt);var kt;(function(F){F[F.AIGenerated=1]="AIGenerated"})(kt||(e.NewSymbolNameTag=kt={}));var Pt;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Pt||(e.NewSymbolNameTriggerKind=Pt={}));class Rn{constructor(N,oe){this.newSymbolName=N,this.tags=oe}}e.$tP=Rn;var Vn;(function(F){F[F.Changed=1]="Changed",F[F.Created=2]="Created",F[F.Deleted=3]="Deleted"})(Vn||(e.FileChangeType=Vn={}));let Cn=O=class extends Error{static FileExists(N){return new O(N,$.FileSystemProviderErrorCode.FileExists,O.FileExists)}static FileNotFound(N){return new O(N,$.FileSystemProviderErrorCode.FileNotFound,O.FileNotFound)}static FileNotADirectory(N){return new O(N,$.FileSystemProviderErrorCode.FileNotADirectory,O.FileNotADirectory)}static FileIsADirectory(N){return new O(N,$.FileSystemProviderErrorCode.FileIsADirectory,O.FileIsADirectory)}static NoPermissions(N){return new O(N,$.FileSystemProviderErrorCode.NoPermissions,O.NoPermissions)}static Unavailable(N){return new O(N,$.FileSystemProviderErrorCode.Unavailable,O.Unavailable)}constructor(N,oe=$.FileSystemProviderErrorCode.Unknown,ke){super(s.URI.isUri(N)?N.toString(!0):N),this.code=ke?.name??"Unknown",(0,$.$ul)(this,oe),Object.setPrototypeOf(this,O.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$uP=Cn,e.$uP=Cn=O=We([L],Cn);let Nn=class{constructor(N,oe,ke){this.start=N,this.end=oe,this.kind=ke}};e.$vP=Nn,e.$vP=Nn=We([L],Nn);var Gn;(function(F){F[F.Comment=1]="Comment",F[F.Imports=2]="Imports",F[F.Region=3]="Region"})(Gn||(e.FoldingRangeKind=Gn={}));var Kn;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(Kn||(e.CommentThreadCollapsibleState=Kn={}));var Qn;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(Qn||(e.CommentMode=Qn={}));var Jn;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(Jn||(e.CommentState=Jn={}));var Xn;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(Xn||(e.CommentThreadState=Xn={}));var Zn;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(Zn||(e.CommentThreadApplicability=Zn={}));var Yn;(function(F){F[F.Reply=1]="Reply",F[F.Comment=2]="Comment"})(Yn||(e.CommentThreadFocus=Yn={}));class ji{constructor(N,oe=[]){this.tokenTypes=N,this.tokenModifiers=oe}}e.$wP=ji;function Fi(F){return typeof F>"u"||(0,v.$kg)(F)}class jn{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,N){this.m=!0;for(let oe=0,ke=N.tokenTypes.length;oe<ke;oe++)this.k.set(N.tokenTypes[oe],oe);for(let oe=0,ke=N.tokenModifiers.length;oe<ke;oe++)this.l.set(N.tokenModifiers[oe],oe)}}push(N,oe,ke,Ke,_e){if(typeof N=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(N,oe,ke,Ke,_e);if(te.isRange(N)&&typeof oe=="string"&&Fi(ke))return this.o(N,oe,ke);throw(0,r.$$)()}o(N,oe,ke){if(!this.m)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ke=N.start.line,_e=N.start.character,at=N.end.character-N.start.character,ht=this.k.get(oe);let Tt=0;if(ke)for(const xt of ke){if(!this.l.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const en=this.l.get(xt);Tt|=1<<en>>>0}this.q(Ke,_e,at,ht,Tt)}q(N,oe,ke,Ke,_e){if(this.f&&(N<this.c||N===this.c&&oe<this.e)){this.f=!1;const Tt=this.g.length/5|0;let xt=0,en=0;for(let rn=0;rn<Tt;rn++){let on=this.g[5*rn],kn=this.g[5*rn+1];on===0?(on=xt,kn+=en):on+=xt,this.g[5*rn]=on,this.g[5*rn+1]=kn,xt=on,en=kn}}let at=N,ht=oe;this.f&&this.j>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.j++]=at,this.g[this.j++]=ht,this.g[this.j++]=ke,this.g[this.j++]=Ke,this.g[this.j++]=_e,this.c=N,this.e=oe}static r(N){const oe=[],ke=N.length/5|0;for(let ht=0;ht<ke;ht++)oe[ht]=ht;oe.sort((ht,Tt)=>{const xt=N[5*ht],en=N[5*Tt];if(xt===en){const rn=N[5*ht+1],on=N[5*Tt+1];return rn-on}return xt-en});const Ke=new Uint32Array(N.length);let _e=0,at=0;for(let ht=0;ht<ke;ht++){const Tt=5*oe[ht],xt=N[Tt+0],en=N[Tt+1],rn=N[Tt+2],on=N[Tt+3],kn=N[Tt+4],Ai=xt-_e,jr=Ai===0?en-at:en,In=5*ht;Ke[In+0]=Ai,Ke[In+1]=jr,Ke[In+2]=rn,Ke[In+3]=on,Ke[In+4]=kn,_e=xt,at=en}return Ke}build(N){return this.f?new Fn(new Uint32Array(this.g),N):new Fn(jn.r(this.g),N)}}e.$xP=jn;class Fn{constructor(N,oe){this.resultId=oe,this.data=N}}e.$yP=Fn;class Mi{constructor(N,oe,ke){this.start=N,this.deleteCount=oe,this.data=ke}}e.$zP=Mi;class zi{constructor(N,oe){this.resultId=oe,this.edits=N}}e.$AP=zi;var xn;(function(F){F[F.Separate=0]="Separate",F[F.MergeWithParent=1]="MergeWithParent"})(xn||(e.DebugConsoleMode=xn={}));class Ui{constructor(N){this.name=N}}e.$BP=Ui;var _n;(function(F){F[F.Title=1]="Title",F[F.Inline=2]="Inline"})(_n||(e.QuickInputButtonLocation=_n={}));let Mn=class{static{this.Back={iconPath:new Xt("arrow-left")}}constructor(){}};e.$CP=Mn,e.$CP=Mn=We([L],Mn);var ei;(function(F){F[F.Separator=-1]="Separator",F[F.Default=0]="Default"})(ei||(e.QuickPickItemKind=ei={}));var ti;(function(F){F[F.Info=1]="Info",F[F.Warning=2]="Warning",F[F.Error=3]="Error"})(ti||(e.InputBoxValidationSeverity=ti={}));var ni;(function(F){F[F.UI=1]="UI",F[F.Workspace=2]="Workspace"})(ni||(e.ExtensionKind=ni={}));class Bi{static validate(N){if(typeof N.badge=="string"){let oe=(0,T.$Uf)(N.badge,0);if(oe<N.badge.length&&(oe+=(0,T.$Uf)(N.badge,oe)),N.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Xt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,oe,ke){this.badge=N,this.tooltip=oe,this.color=ke}}e.$DP=Bi;let zn=class{constructor(N){this.kind=N}};e.$EP=zn,e.$EP=zn=We([L],zn);var ii;(function(F){F[F.Light=1]="Light",F[F.Dark=2]="Dark",F[F.HighContrast=3]="HighContrast",F[F.HighContrastLight=4]="HighContrastLight"})(ii||(e.ColorThemeKind=ii={}));class un{static isNotebookRange(N){return N instanceof un?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,oe){if(N<0)throw(0,r.$$)("start must be positive");if(oe<0)throw(0,r.$$)("end must be positive");N<=oe?(this.c=N,this.e=oe):(this.c=oe,this.e=N)}with(N){let oe=this.c,ke=this.e;return N.start!==void 0&&(oe=N.start),N.end!==void 0&&(ke=N.end),oe===this.c&&ke===this.e?this:new un(oe,ke)}}e.$FP=un;class Dn{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(oe=>Dn.isNotebookCellData(oe))}static isNotebookCellData(N){return!0}constructor(N,oe,ke,Ke,_e,at,ht){this.kind=N,this.value=oe,this.languageId=ke,this.mime=Ke,this.outputs=_e??[],this.metadata=at,this.executionSummary=ht,Dn.validate(this)}}e.$GP=Dn;class qi{constructor(N){this.cells=N}}e.$HP=qi;class nn{static isNotebookCellOutputItem(N){return N instanceof nn?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const oe={name:N.name,message:N.message,stack:N.stack};return nn.json(oe,"application/vnd.code.notebook.error")}static stdout(N){return nn.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return nn.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,oe="application/octet-stream"){return new nn(N,oe)}static#e=new TextEncoder;static text(N,oe=D.$gt.text){const ke=nn.#e.encode(String(N));return new nn(ke,oe)}static json(N,oe="text/x-json"){const ke=JSON.stringify(N,void 0,"	");return nn.text(ke,oe)}constructor(N,oe){this.data=N,this.mime=oe;const ke=(0,D.$kt)(oe,!0);if(!ke)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$IP=nn;class Tn{static isNotebookCellOutput(N){return N instanceof Tn?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,oe=!1){const ke=new Set,Ke=new Set;for(let _e=0;_e<N.length;_e++){const at=N[_e],ht=(0,D.$kt)(at.mime);if(!ke.has(ht)||(0,a.$aM)(ht)){ke.add(ht);continue}Ke.add(_e),oe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?N:N.filter((_e,at)=>!Ke.has(at))}constructor(N,oe,ke){this.items=Tn.ensureUniqueMimeTypes(N,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,S.$7g)(),this.metadata=oe??ke)}}e.$JP=Tn;var ri;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(ri||(e.NotebookCellKind=ri={}));var si;(function(F){F[F.Idle=1]="Idle",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(si||(e.NotebookCellExecutionState=si={}));var oi;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(oi||(e.NotebookCellStatusBarAlignment=oi={}));var ai;(function(F){F[F.Default=0]="Default",F[F.InCenter=1]="InCenter",F[F.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",F[F.AtTop=3]="AtTop"})(ai||(e.NotebookEditorRevealType=ai={}));class Hi{constructor(N,oe){this.text=N,this.alignment=oe}}e.$KP=Hi;var li;(function(F){F[F.Default=1]="Default",F[F.Preferred=2]="Preferred"})(li||(e.NotebookControllerAffinity=li={}));var ci;(function(F){F[F.Default=1]="Default",F[F.Preferred=2]="Preferred",F[F.Hidden=-1]="Hidden"})(ci||(e.NotebookControllerAffinity2=ci={}));class Wi{constructor(N,oe=[]){this.uri=N,this.provides=(0,t.$6b)(oe)}}e.$LP=Wi;class Vi{constructor(N){this.label=N}}e.$MP=Vi;var ui;(function(F){F[F.Named=1]="Named",F[F.Indexed=2]="Indexed"})(ui||(e.NotebookVariablesRequestKind=ui={}));let Un=class{constructor(N,oe){this.label=N,this.timestamp=oe}};e.$NP=Un,e.$NP=Un=We([L],Un);var hi;(function(F){F[F.Production=1]="Production",F[F.Development=2]="Development",F[F.Test=3]="Test"})(hi||(e.ExtensionMode=hi={}));var fi;(function(F){F[F.Node=1]="Node",F[F.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var di;(function(F){F[F.Other=0]="Other",F[F.Comment=1]="Comment",F[F.String=2]="String",F[F.RegEx=3]="RegEx"})(di||(e.StandardTokenType=di={}));class Gi{constructor(N,oe){this.ranges=N,this.wordPattern=oe}}e.$OP=Gi;class Ki{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$PP=Ki;var mi;(function(F){F[F.Queued=1]="Queued",F[F.Running=2]="Running",F[F.Passed=3]="Passed",F[F.Failed=4]="Failed",F[F.Skipped=5]="Skipped",F[F.Errored=6]="Errored"})(mi||(e.TestResultState=mi={}));var gi;(function(F){F[F.Run=1]="Run",F[F.Debug=2]="Debug",F[F.Coverage=3]="Coverage"})(gi||(e.TestRunProfileKind=gi={}));let Bn=class{constructor(N=void 0,oe=void 0,ke=void 0,Ke=!1,_e=!0){this.include=N,this.exclude=oe,this.profile=ke,this.continuous=Ke,this.preserveFocus=_e}};e.$QP=Bn,e.$QP=Bn=We([L],Bn);let qn=C=class{static diff(N,oe,ke){const Ke=new C(N);return Ke.expectedOutput=oe,Ke.actualOutput=ke,Ke}constructor(N){this.message=N}};e.$RP=qn,e.$RP=qn=C=We([L],qn);let Hn=class{constructor(N){this.id=N}};e.$SP=Hn,e.$SP=Hn=We([L],Hn);class Qi{constructor(N,oe,ke){this.label=N,this.uri=oe,this.position=ke}}e.$TP=Qi;class On{constructor(N,oe){this.covered=N,this.total=oe,$i(this)}}e.$UP=On;function $i(F){if(F){if(F.covered>F.total)throw new Error(`The total number of covered items (${F.covered}) cannot be greater than the total (${F.total})`);if(F.total<0)throw new Error(`The number of covered items (${F.total}) cannot be negative`)}}class Wn{static fromDetails(N,oe){const ke=new On(0,0),Ke=new On(0,0),_e=new On(0,0);for(const ht of oe)if("branches"in ht){ke.total+=1,ke.covered+=ht.executed?1:0;for(const Tt of ht.branches)Ke.total+=1,Ke.covered+=Tt.executed?1:0}else _e.total+=1,_e.covered+=ht.executed?1:0;const at=new Wn(N,ke,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return at.detailedCoverage=oe,at}constructor(N,oe,ke,Ke,_e=[]){this.uri=N,this.statementCoverage=oe,this.branchCoverage=ke,this.declarationCoverage=Ke,this.fromTests=_e}}e.$WP=Wn;class Ji{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,oe,ke=[]){this.executed=N,this.location=oe,this.branches=ke}}e.$XP=Ji;class Xi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,oe,ke){this.executed=N,this.location=oe,this.label=ke}}e.$YP=Xi;class Zi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,oe,ke){this.name=N,this.executed=oe,this.location=ke}}e.$ZP=Zi;var pi;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(pi||(e.ExternalUriOpenerPriority=pi={}));var bi;(function(F){F[F.Untrusted=0]="Untrusted",F[F.Trusted=1]="Trusted",F[F.Unspecified=2]="Unspecified"})(bi||(e.WorkspaceTrustState=bi={}));var wi;(function(F){F[F.Notify=1]="Notify",F[F.OpenBrowser=2]="OpenBrowser",F[F.OpenPreview=3]="OpenPreview",F[F.Silent=4]="Silent",F[F.Ignore=5]="Ignore",F[F.OpenBrowserOnce=6]="OpenBrowserOnce"})(wi||(e.PortAutoForwardAction=wi={}));class Yi{constructor(N,oe,ke,Ke,_e,at){this.kind=N,this.name=oe,this.detail=ke,this.uri=Ke,this.range=_e,this.selectionRange=at}}e.$1P=Yi;class xi{constructor(N){this.uri=N}}e.$2P=xi;class _i{constructor(N,oe){this.original=N,this.modified=oe}}e.$3P=_i;class er{constructor(N,oe,ke,Ke){this.base=N,this.input1=oe,this.input2=ke,this.result=Ke}}e.$4P=er;class tr{constructor(N,oe){this.uri=N,this.viewType=oe}}e.$5P=tr;class nr{constructor(N){this.viewType=N}}e.$6P=nr;class ir{constructor(N,oe){this.uri=N,this.notebookType=oe}}e.$7P=ir;class rr{constructor(N,oe,ke){this.original=N,this.modified=oe,this.notebookType=ke}}e.$8P=rr;class sr{constructor(){}}e.$9P=sr;class or{constructor(N,oe){this.uri=N,this.inputBoxUri=oe}}e.$0P=or;class ar{constructor(){}}e.$$P=ar;class lr{constructor(N){this.textDiffs=N}}e.$_P=lr;var yi;(function(F){F[F.Down=0]="Down",F[F.Up=1]="Up"})(yi||(e.InteractiveSessionVoteDirection=yi={}));var vi;(function(F){F[F.Action=1]="Action",F[F.Toolbar=2]="Toolbar"})(vi||(e.ChatCopyKind=vi={}));var Ei;(function(F){F[F.Short=1]="Short",F[F.Medium=2]="Medium",F[F.Full=3]="Full"})(Ei||(e.ChatVariableLevel=Ei={}));class cr{constructor(N,oe,ke){this.id=N,this.label=oe,this.values=ke}}e.$aQ=cr;var Si;(function(F){F[F.Unhelpful=0]="Unhelpful",F[F.Helpful=1]="Helpful",F[F.Undone=2]="Undone",F[F.Accepted=3]="Accepted",F[F.Bug=4]="Bug"})(Si||(e.InteractiveEditorResponseFeedbackKind=Si={}));var ki;(function(F){F[F.Unhelpful=0]="Unhelpful",F[F.Helpful=1]="Helpful"})(ki||(e.ChatResultFeedbackKind=ki={}));class ur{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new lt(N):N}}e.$bQ=ur;class hr{constructor(N,oe){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new lt(N):N,this.vulnerabilities=oe}}e.$cQ=hr;class fr{constructor(N,oe){this.participant=N,this.command=oe}}e.$dQ=fr;class dr{constructor(N,oe,ke,Ke){this.title=N,this.message=oe,this.data=ke,this.buttons=Ke}}e.$eQ=dr;class mr{constructor(N,oe){this.value=N,this.baseUri=oe}}e.$fQ=mr;class gr{constructor(N,oe){this.value=N,this.title=oe}}e.$gQ=gr;class $r{constructor(N){this.value=N}}e.$hQ=$r;class pr{constructor(N,oe){this.value=N,this.task=oe}}e.$iQ=pr;class br{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new lt(N):N}}e.$jQ=br;class wr{constructor(N){this.value=N}}e.$kQ=wr;class yr{constructor(N,oe,ke){this.value=N,this.iconPath=oe,this.options=ke}}e.$lQ=yr;class vr{constructor(N,oe,ke){this.value=N,this.license=oe,this.snippet=ke}}e.$mQ=vr;class Er{constructor(N,oe){this.uri=N,this.range=oe}}e.$nQ=Er;class Sr{constructor(N,oe){this.uri=N,this.edits=Array.isArray(oe)?oe:[oe]}}e.$oQ=Sr;class kr{constructor(N,oe,ke,Ke){this.prompt=N,this.command=oe,this.references=ke,this.participant=Ke}}e.$pQ=kr;class Ir{constructor(N,oe,ke,Ke){this.response=N,this.result=oe,this.participant=ke,this.command=Ke}}e.$qQ=Ir;var Ii;(function(F){F[F.Panel=1]="Panel",F[F.Terminal=2]="Terminal",F[F.Notebook=3]="Notebook",F[F.Editor=4]="Editor"})(Ii||(e.ChatLocation=Ii={}));var Pi;(function(F){F[F.Complete=1]="Complete",F[F.Partial=2]="Partial",F[F.Omitted=3]="Omitted"})(Pi||(e.ChatResponseReferencePartStatusKind=Pi={}));class Pr{constructor(N,oe,ke){this.document=N,this.selection=oe,this.wholeRange=ke}}e.$rQ=Pr;class Rr{constructor(N){this.cell=N}}e.$sQ=Rr;var Ln;(function(F){F[F.User=1]="User",F[F.Assistant=2]="Assistant",F[F.System=3]="System"})(Ln||(e.LanguageModelChatMessageRole=Ln={}));class Dr{constructor(N,oe,ke){this.toolCallId=N,this.content=oe,this.isError=ke??!1}}e.$tQ=Dr;class An{static User(N,oe){const ke=new An(Ln.User,typeof N=="string"?N:"",oe);return ke.content2=[N],ke}static Assistant(N,oe){return new An(Ln.Assistant,N,oe)}constructor(N,oe,ke){this.role=N,this.content=oe,this.content2=[oe],this.name=ke}}e.$uQ=An;class Tr{constructor(N,oe,ke){this.name=N,this.toolCallId=oe,this.parameters=ke}}e.$vQ=Tr;class Or{constructor(N){this.value=N}}e.$wQ=Or;class Lr{constructor(N){this.content=N}}e.$xQ=Lr;class Ar{constructor(N,oe){this.content=N,this.name=oe}}e.$yQ=Ar;class Cr{constructor(N,oe){this.content=N,this.name=oe}}e.$zQ=Cr;class hn extends Error{static NotFound(N){return new hn(N,hn.NotFound.name)}static NoPermissions(N){return new hn(N,hn.NoPermissions.name)}static Blocked(N){return new hn(N,hn.Blocked.name)}constructor(N,oe,ke){super(N,{cause:ke}),this.name="LanguageModelError",this.code=oe??""}}e.$AQ=hn;var Ri;(function(F){F[F.SymbolInformation=1]="SymbolInformation",F[F.CommandInformation=2]="CommandInformation",F[F.SearchInformation=3]="SearchInformation",F[F.SettingInformation=4]="SettingInformation"})(Ri||(e.RelatedInformationType=Ri={}));var Di;(function(F){F[F.Started=1]="Started",F[F.Recognizing=2]="Recognizing",F[F.Recognized=3]="Recognized",F[F.Stopped=4]="Stopped",F[F.Error=5]="Error"})(Di||(e.SpeechToTextStatus=Di={}));var Ti;(function(F){F[F.Started=1]="Started",F[F.Stopped=2]="Stopped",F[F.Error=3]="Error"})(Ti||(e.TextToSpeechStatus=Ti={}));var Oi;(function(F){F[F.Recognized=1]="Recognized",F[F.Stopped=2]="Stopped"})(Oi||(e.KeywordRecognitionStatus=Oi={}));class Nr{constructor(N,oe){this.text=N,this.range=oe}}e.$BQ=Nr;var Li;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Li||(e.InlineEditTriggerKind=Li={}))}),define(Te[156],Oe([1,0,17,14,178,80,112,25,164,49,69,20,170,19,83,10,4,206,48,109,196,186,218,219,150,102,259,272,260,154,77,103,152,155]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d,w,o,l,n,u,i,f,h,k,I,O,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatLanguageModelToolReference=e.ChatPromptReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseMovePart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$JQ=ae,e.$KQ=se,e.$LQ=ne,D=Ve(D),v=Ve(v),p=Ve(p),d=Ve(d),w=Ve(w),h=Ve(h),I=Ve(I),R=Ve(R);var M;(function(Ee){function Ae(q){const{selectionStartLineNumber:Ie,selectionStartColumn:Be,positionLineNumber:Ye,positionColumn:Me}=q,nt=new R.$cO(Ie-1,Be-1),ot=new R.$cO(Ye-1,Me-1);return new R.$eO(nt,ot)}Ee.to=Ae;function de(q){const{anchor:Ie,active:Be}=q;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ee.from=de})(M||(e.Selection=M={}));var G;(function(Ee){function Ae(q){if(!q)return;const{start:Ie,end:Be}=q;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ee.from=Ae;function de(q){if(!q)return;const{startLineNumber:Ie,startColumn:Be,endLineNumber:Ye,endColumn:Me}=q;return new R.$dO(Ie-1,Be-1,Ye-1,Me-1)}Ee.to=de})(G||(e.Range=G={}));var Q;(function(Ee){function Ae(q){return{uri:q.uri,range:G.from(q.range)}}Ee.from=Ae;function de(q){return new R.$pO(m.URI.revive(q.uri),G.to(q.range))}Ee.to=de})(Q||(e.Location=Q={}));var te;(function(Ee){function Ae(de){switch(de){case d.StandardTokenType.Comment:return R.StandardTokenType.Comment;case d.StandardTokenType.Other:return R.StandardTokenType.Other;case d.StandardTokenType.RegEx:return R.StandardTokenType.RegEx;case d.StandardTokenType.String:return R.StandardTokenType.String}}Ee.to=Ae})(te||(e.TokenType=te={}));var ve;(function(Ee){function Ae(q){return new R.$cO(q.lineNumber-1,q.column-1)}Ee.to=Ae;function de(q){return{lineNumber:q.line+1,column:q.character+1}}Ee.from=de})(ve||(e.Position=ve={}));var be;(function(Ee){function Ae(Ie,Be,Ye){return(0,t.$Lb)((0,t.$6b)(Ie).map(Me=>de(Me,Be,Ye)))}Ee.from=Ae;function de(Ie,Be,Ye){if(typeof Ie=="string")return{$serialized:!0,language:Ie,isBuiltin:Ye?.isBuiltin};if(Ie)return{$serialized:!0,language:Ie.language,scheme:q(Ie.scheme,Be),pattern:He.from(Ie.pattern)??void 0,exclusive:Ie.exclusive,notebookType:Ie.notebookType,isBuiltin:Ye?.isBuiltin}}function q(Ie,Be){return Be&&typeof Ie=="string"?Be.transformOutgoingScheme(Ie):Ie}})(be||(e.DocumentSelector=be={}));var le;(function(Ee){function Ae(q){switch(q){case R.DiagnosticTag.Unnecessary:return l.MarkerTag.Unnecessary;case R.DiagnosticTag.Deprecated:return l.MarkerTag.Deprecated}}Ee.from=Ae;function de(q){switch(q){case l.MarkerTag.Unnecessary:return R.DiagnosticTag.Unnecessary;case l.MarkerTag.Deprecated:return R.DiagnosticTag.Deprecated;default:return}}Ee.to=de})(le||(e.DiagnosticTag=le={}));var K;(function(Ee){function Ae(q){let Ie;return q.code&&((0,c.$jg)(q.code)||(0,c.$ng)(q.code)?Ie=String(q.code):Ie={value:String(q.code.value),target:q.code.target}),{...G.from(q.range),message:q.message,source:q.source,code:Ie,severity:j.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(B.from),tags:Array.isArray(q.tags)?(0,t.$Lb)(q.tags.map(le.from)):void 0}}Ee.from=Ae;function de(q){const Ie=new R.$rO(G.to(q),q.message,j.to(q.severity));return Ie.source=q.source,Ie.code=(0,c.$jg)(q.code)?q.code:q.code?.value,Ie.relatedInformation=q.relatedInformation&&q.relatedInformation.map(B.to),Ie.tags=q.tags&&(0,t.$Lb)(q.tags.map(le.to)),Ie}Ee.to=de})(K||(e.Diagnostic=K={}));var B;(function(Ee){function Ae(q){return{...G.from(q.location.range),message:q.message,resource:q.location.uri}}Ee.from=Ae;function de(q){return new R.$qO(new R.$pO(q.resource,G.to(q)),q.message)}Ee.to=de})(B||(e.DiagnosticRelatedInformation=B={}));var j;(function(Ee){function Ae(q){switch(q){case R.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case R.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case R.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case R.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}Ee.from=Ae;function de(q){switch(q){case l.MarkerSeverity.Info:return R.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return R.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return R.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return R.DiagnosticSeverity.Hint;default:return R.DiagnosticSeverity.Error}}Ee.to=de})(j||(e.DiagnosticSeverity=j={}));var U;(function(Ee){function Ae(q){return typeof q=="number"&&q>=R.ViewColumn.One?q-1:q===R.ViewColumn.Beside?L.$SE:L.$RE}Ee.from=Ae;function de(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=de})(U||(e.ViewColumn=U={}));function ee(Ee){return typeof Ee.range<"u"}function ae(Ee){return Ee.length===0?!0:!!ee(Ee[0])}var ye;(function(Ee){function Ae(Me){return Me.map(Ee.from)}Ee.fromMany=Ae;function de(Me){return Me&&typeof Me=="object"&&typeof Me.language=="string"&&typeof Me.value=="string"}function q(Me){let nt;if(de(Me)){const{language:kt,value:Pt}=Me;nt={value:"```"+kt+`
`+Pt+"\n```\n"}}else R.$FO.isMarkdownString(Me)?nt={value:Me.value,isTrusted:Me.isTrusted,supportThemeIcons:Me.supportThemeIcons,supportHtml:Me.supportHtml,baseUri:Me.baseUri}:typeof Me=="string"?nt={value:Me}:nt={value:""};const ot=Object.create(null);nt.uris=ot;const Dt=({href:kt})=>{try{let Pt=m.URI.parse(kt,!0);Pt=Pt.with({query:Ie(Pt.query,ot)}),ot[kt]=Pt}catch{}return""};return v.marked.walkTokens(v.marked.lexer(nt.value),kt=>{kt.type==="link"?Dt({href:kt.href}):kt.type==="image"&&typeof kt.href=="string"&&Dt(D.$el(kt.href))}),nt}Ee.from=q;function Ie(Me,nt){if(!Me)return Me;let ot;try{ot=(0,s.$gi)(Me)}catch{}if(!ot)return Me;let Dt=!1;return ot=(0,y.$mo)(ot,kt=>{if(m.URI.isUri(kt)){const Pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[Pt]=kt,Dt=!0,Pt}else return}),Dt?JSON.stringify(ot):Me}function Be(Me){const nt=new R.$FO(Me.value,Me.supportThemeIcons);return nt.isTrusted=Me.isTrusted,nt.supportHtml=Me.supportHtml,nt.baseUri=Me.baseUri?m.URI.from(Me.baseUri):void 0,nt}Ee.to=Be;function Ye(Me){if(Me)return typeof Me=="string"?Me:Ee.from(Me)}Ee.fromStrict=Ye})(ye||(e.MarkdownString=ye={}));function se(Ee){return ae(Ee)?Ee.map(Ae=>({range:G.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?ye.fromMany(Ae.hoverMessage):Ae.hoverMessage?ye.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):Ee.map(Ae=>({range:G.from(Ae)}))}function ne(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?m.URI.file(Ee):Ee}var X;(function(Ee){function Ae(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?ne(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Ee.from=Ae})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var z;(function(Ee){function Ae(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?ne(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?X.from(de.before):void 0,after:de.after?X.from(de.after):void 0}}Ee.from=Ae})(z||(e.ThemableDecorationRenderOptions=z={}));var A;(function(Ee){function Ae(de){if(typeof de>"u")return de;switch(de){case R.DecorationRangeBehavior.OpenOpen:return o.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case R.DecorationRangeBehavior.ClosedClosed:return o.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case R.DecorationRangeBehavior.OpenClosed:return o.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case R.DecorationRangeBehavior.ClosedOpen:return o.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ee.from=Ae})(A||(e.DecorationRangeBehavior=A={}));var Y;(function(Ee){function Ae(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?A.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?z.from(de.light):void 0,dark:de.dark?z.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?ne(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?X.from(de.before):void 0,after:de.after?X.from(de.after):void 0}}Ee.from=Ae})(Y||(e.DecorationRenderOptions=Y={}));var pe;(function(Ee){function Ae(q){return{text:q.newText,eol:q.newEol&&he.from(q.newEol),range:G.from(q.range)}}Ee.from=Ae;function de(q){const Ie=new R.$kO(G.to(q.range),q.text);return Ie.newEol=typeof q.eol>"u"?void 0:he.to(q.eol),Ie}Ee.to=de})(pe||(e.TextEdit=pe={}));var x;(function(Ee){function Ae(q,Ie){const Be={edits:[]};if(q instanceof R.$nO){const Ye=new T.$Gc;for(const Me of q._allEntries())Me._type===R.FileEditType.File&&m.URI.isUri(Me.to)&&Me.from===void 0&&Ye.add(Me.to);for(const Me of q._allEntries())if(Me._type===R.FileEditType.File){let nt;Me.options?.contents&&(ArrayBuffer.isView(Me.options.contents)?nt={type:"base64",value:(0,r.$af)(r.$Se.wrap(Me.options.contents))}:nt={type:"dataTransferItem",id:Me.options.contents._itemId}),Be.edits.push({oldResource:Me.from,newResource:Me.to,options:{...Me.options,contents:nt},metadata:Me.metadata})}else Me._type===R.FileEditType.Text?Be.edits.push({resource:Me.uri,textEdit:pe.from(Me.edit),versionId:Ye.has(Me.uri)?void 0:Ie?.getTextDocumentVersion(Me.uri),metadata:Me.metadata}):Me._type===R.FileEditType.Snippet?Be.edits.push({resource:Me.uri,textEdit:{range:G.from(Me.range),text:Me.edit.value,insertAsSnippet:!0},versionId:Ye.has(Me.uri)?void 0:Ie?.getTextDocumentVersion(Me.uri),metadata:Me.metadata}):Me._type===R.FileEditType.Cell?Be.edits.push({metadata:Me.metadata,resource:Me.uri,cellEdit:Me.edit,notebookMetadata:Me.notebookMetadata,notebookVersionId:Ie?.getNotebookDocumentVersion(Me.uri)}):Me._type===R.FileEditType.CellReplace&&Be.edits.push({metadata:Me.metadata,resource:Me.uri,notebookVersionId:Ie?.getNotebookDocumentVersion(Me.uri),cellEdit:{editType:I.CellEditType.Replace,index:Me.index,count:Me.count,cells:Me.cells.map(mt.from)}})}return Be}Ee.from=Ae;function de(q){const Ie=new R.$nO,Be=new T.$Fc;for(const Ye of q.edits)if(Ye.textEdit){const Me=Ye,nt=m.URI.revive(Me.resource),ot=G.to(Me.textEdit.range),Dt=Me.textEdit.text,kt=Me.textEdit.insertAsSnippet;let Pt;kt?Pt=R.$mO.replace(ot,new R.$oO(Dt)):Pt=R.$kO.replace(ot,Dt);const Rn=Be.get(nt);Rn?Rn.push(Pt):Be.set(nt,[Pt])}else Ie.renameFile(m.URI.revive(Ye.oldResource),m.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Me]of Be)Ie.set(Ye,Me);return Ie}Ee.to=de})(x||(e.WorkspaceEdit=x={}));var ie;(function(Ee){const Ae=Object.create(null);Ae[R.SymbolKind.File]=w.SymbolKind.File,Ae[R.SymbolKind.Module]=w.SymbolKind.Module,Ae[R.SymbolKind.Namespace]=w.SymbolKind.Namespace,Ae[R.SymbolKind.Package]=w.SymbolKind.Package,Ae[R.SymbolKind.Class]=w.SymbolKind.Class,Ae[R.SymbolKind.Method]=w.SymbolKind.Method,Ae[R.SymbolKind.Property]=w.SymbolKind.Property,Ae[R.SymbolKind.Field]=w.SymbolKind.Field,Ae[R.SymbolKind.Constructor]=w.SymbolKind.Constructor,Ae[R.SymbolKind.Enum]=w.SymbolKind.Enum,Ae[R.SymbolKind.Interface]=w.SymbolKind.Interface,Ae[R.SymbolKind.Function]=w.SymbolKind.Function,Ae[R.SymbolKind.Variable]=w.SymbolKind.Variable,Ae[R.SymbolKind.Constant]=w.SymbolKind.Constant,Ae[R.SymbolKind.String]=w.SymbolKind.String,Ae[R.SymbolKind.Number]=w.SymbolKind.Number,Ae[R.SymbolKind.Boolean]=w.SymbolKind.Boolean,Ae[R.SymbolKind.Array]=w.SymbolKind.Array,Ae[R.SymbolKind.Object]=w.SymbolKind.Object,Ae[R.SymbolKind.Key]=w.SymbolKind.Key,Ae[R.SymbolKind.Null]=w.SymbolKind.Null,Ae[R.SymbolKind.EnumMember]=w.SymbolKind.EnumMember,Ae[R.SymbolKind.Struct]=w.SymbolKind.Struct,Ae[R.SymbolKind.Event]=w.SymbolKind.Event,Ae[R.SymbolKind.Operator]=w.SymbolKind.Operator,Ae[R.SymbolKind.TypeParameter]=w.SymbolKind.TypeParameter;function de(Ie){return typeof Ae[Ie]=="number"?Ae[Ie]:w.SymbolKind.Property}Ee.from=de;function q(Ie){for(const Be in Ae)if(Ae[Be]===Ie)return Number(Be);return R.SymbolKind.Property}Ee.to=q})(ie||(e.SymbolKind=ie={}));var W;(function(Ee){function Ae(q){switch(q){case R.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}Ee.from=Ae;function de(q){switch(q){case w.SymbolTag.Deprecated:return R.SymbolTag.Deprecated}}Ee.to=de})(W||(e.SymbolTag=W={}));var Z;(function(Ee){function Ae(q){return{name:q.name,kind:ie.from(q.kind),tags:q.tags&&q.tags.map(W.from),containerName:q.containerName,location:qe.from(q.location)}}Ee.from=Ae;function de(q){const Ie=new R.$wO(q.name,ie.to(q.kind),q.containerName,qe.to(q.location));return Ie.tags=q.tags&&q.tags.map(W.to),Ie}Ee.to=de})(Z||(e.WorkspaceSymbol=Z={}));var ce;(function(Ee){function Ae(q){const Ie={name:q.name||"!!MISSING: name!!",detail:q.detail,range:G.from(q.range),selectionRange:G.from(q.selectionRange),kind:ie.from(q.kind),tags:q.tags?.map(W.from)??[]};return q.children&&(Ie.children=q.children.map(Ae)),Ie}Ee.from=Ae;function de(q){const Ie=new R.$xO(q.name,q.detail,ie.to(q.kind),G.to(q.range),G.to(q.selectionRange));return(0,t.$Pb)(q.tags)&&(Ie.tags=q.tags.map(W.to)),q.children&&(Ie.children=q.children.map(de)),Ie}Ee.to=de})(ce||(e.DocumentSymbol=ce={}));var we;(function(Ee){function Ae(q){const Ie=new R.$BO(ie.to(q.kind),q.name,q.detail||"",m.URI.revive(q.uri),G.to(q.range),G.to(q.selectionRange));return Ie._sessionId=q._sessionId,Ie._itemId=q._itemId,Ie}Ee.to=Ae;function de(q,Ie,Be){if(Ie=Ie??q._sessionId,Be=Be??q._itemId,Ie===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Be,name:q.name,detail:q.detail,kind:ie.from(q.kind),uri:q.uri,range:G.from(q.range),selectionRange:G.from(q.selectionRange),tags:q.tags?.map(W.from)}}Ee.from=de})(we||(e.CallHierarchyItem=we={}));var Le;(function(Ee){function Ae(de){return new R.$CO(we.to(de.from),de.fromRanges.map(q=>G.to(q)))}Ee.to=Ae})(Le||(e.CallHierarchyIncomingCall=Le={}));var ze;(function(Ee){function Ae(de){return new R.$DO(we.to(de.to),de.fromRanges.map(q=>G.to(q)))}Ee.to=Ae})(ze||(e.CallHierarchyOutgoingCall=ze={}));var qe;(function(Ee){function Ae(q){return{range:q.range&&G.from(q.range),uri:q.uri}}Ee.from=Ae;function de(q){return new R.$pO(m.URI.revive(q.uri),G.to(q.range))}Ee.to=de})(qe||(e.location=qe={}));var Re;(function(Ee){function Ae(q){const Ie=q,Be=q;return{originSelectionRange:Ie.originSelectionRange?G.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Be.uri,range:G.from(Ie.targetRange?Ie.targetRange:Be.range),targetSelectionRange:Ie.targetSelectionRange?G.from(Ie.targetSelectionRange):void 0}}Ee.from=Ae;function de(q){return{targetUri:m.URI.revive(q.uri),targetRange:G.to(q.range),targetSelectionRange:q.targetSelectionRange?G.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?G.to(q.originSelectionRange):void 0}}Ee.to=de})(Re||(e.DefinitionLink=Re={}));var Ne;(function(Ee){function Ae(q){return{range:G.from(q.range),contents:ye.fromMany(q.contents),canIncreaseVerbosity:q.canIncreaseVerbosity,canDecreaseVerbosity:q.canDecreaseVerbosity}}Ee.from=Ae;function de(q){const Ie=q.contents.map(ye.to),Be=G.to(q.range),Ye=q.canIncreaseVerbosity,Me=q.canDecreaseVerbosity;return new R.$tO(Ie,Be,Ye,Me)}Ee.to=de})(Ne||(e.Hover=Ne={}));var De;(function(Ee){function Ae(q){return{range:G.from(q.range),expression:q.expression}}Ee.from=Ae;function de(q){return new R.$oP(G.to(q.range),q.expression)}Ee.to=de})(De||(e.EvaluatableExpression=De={}));var Ce;(function(Ee){function Ae(q){if(q instanceof R.$pP)return{type:"text",range:G.from(q.range),text:q.text};if(q instanceof R.$qP)return{type:"variable",range:G.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof R.$rP)return{type:"expression",range:G.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ae;function de(q){switch(q.type){case"text":return{range:G.to(q.range),text:q.text};case"variable":return{range:G.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:G.to(q.range),expression:q.expression}}}Ee.to=de})(Ce||(e.InlineValue=Ce={}));var ge;(function(Ee){function Ae(q){return{frameId:q.frameId,stoppedLocation:G.from(q.stoppedLocation)}}Ee.from=Ae;function de(q){return new R.$sP(q.frameId,G.to(q.stoppedLocation))}Ee.to=de})(ge||(e.InlineValueContext=ge={}));var Se;(function(Ee){function Ae(q){return{range:G.from(q.range),kind:q.kind}}Ee.from=Ae;function de(q){return new R.$uO(G.to(q.range),q.kind)}Ee.to=de})(Se||(e.DocumentHighlight=Se={}));var Pe;(function(Ee){function Ae(q){return{uri:q.uri,highlights:q.highlights.map(Se.from)}}Ee.from=Ae;function de(q){return new R.$vO(m.URI.revive(q.uri),q.highlights.map(Se.to))}Ee.to=de})(Pe||(e.MultiDocumentHighlight=Pe={}));var Ue;(function(Ee){function Ae(de){switch(de){case w.CompletionTriggerKind.TriggerCharacter:return R.CompletionTriggerKind.TriggerCharacter;case w.CompletionTriggerKind.TriggerForIncompleteCompletions:return R.CompletionTriggerKind.TriggerForIncompleteCompletions;case w.CompletionTriggerKind.Invoke:default:return R.CompletionTriggerKind.Invoke}}Ee.to=Ae})(Ue||(e.CompletionTriggerKind=Ue={}));var Ge;(function(Ee){function Ae(de){return{triggerKind:Ue.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Ee.to=Ae})(Ge||(e.CompletionContext=Ge={}));var Qe;(function(Ee){function Ae(q){switch(q){case R.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}Ee.from=Ae;function de(q){switch(q){case w.CompletionItemTag.Deprecated:return R.CompletionItemTag.Deprecated}}Ee.to=de})(Qe||(e.CompletionItemTag=Qe={}));var Ze;(function(Ee){const Ae=new Map([[R.CompletionItemKind.Method,w.CompletionItemKind.Method],[R.CompletionItemKind.Function,w.CompletionItemKind.Function],[R.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[R.CompletionItemKind.Field,w.CompletionItemKind.Field],[R.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[R.CompletionItemKind.Class,w.CompletionItemKind.Class],[R.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[R.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[R.CompletionItemKind.Module,w.CompletionItemKind.Module],[R.CompletionItemKind.Property,w.CompletionItemKind.Property],[R.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[R.CompletionItemKind.Value,w.CompletionItemKind.Value],[R.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[R.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[R.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[R.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[R.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[R.CompletionItemKind.Text,w.CompletionItemKind.Text],[R.CompletionItemKind.Color,w.CompletionItemKind.Color],[R.CompletionItemKind.File,w.CompletionItemKind.File],[R.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[R.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[R.CompletionItemKind.Event,w.CompletionItemKind.Event],[R.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[R.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[R.CompletionItemKind.Issue,w.CompletionItemKind.Issue],[R.CompletionItemKind.User,w.CompletionItemKind.User]]);function de(Be){return Ae.get(Be)??w.CompletionItemKind.Property}Ee.from=de;const q=new Map([[w.CompletionItemKind.Method,R.CompletionItemKind.Method],[w.CompletionItemKind.Function,R.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,R.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,R.CompletionItemKind.Field],[w.CompletionItemKind.Variable,R.CompletionItemKind.Variable],[w.CompletionItemKind.Class,R.CompletionItemKind.Class],[w.CompletionItemKind.Interface,R.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,R.CompletionItemKind.Struct],[w.CompletionItemKind.Module,R.CompletionItemKind.Module],[w.CompletionItemKind.Property,R.CompletionItemKind.Property],[w.CompletionItemKind.Unit,R.CompletionItemKind.Unit],[w.CompletionItemKind.Value,R.CompletionItemKind.Value],[w.CompletionItemKind.Constant,R.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,R.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,R.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,R.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,R.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,R.CompletionItemKind.Text],[w.CompletionItemKind.Color,R.CompletionItemKind.Color],[w.CompletionItemKind.File,R.CompletionItemKind.File],[w.CompletionItemKind.Reference,R.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,R.CompletionItemKind.Folder],[w.CompletionItemKind.Event,R.CompletionItemKind.Event],[w.CompletionItemKind.Operator,R.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,R.CompletionItemKind.TypeParameter],[w.CompletionItemKind.User,R.CompletionItemKind.User],[w.CompletionItemKind.Issue,R.CompletionItemKind.Issue]]);function Ie(Be){return q.get(Be)??R.CompletionItemKind.Property}Ee.to=Ie})(Ze||(e.CompletionItemKind=Ze={}));var Xe;(function(Ee){function Ae(de,q){const Ie=new R.$LO(de.label);return Ie.insertText=de.insertText,Ie.kind=Ze.to(de.kind),Ie.tags=de.tags?.map(Qe.to),Ie.detail=de.detail,Ie.documentation=D.$$k(de.documentation)?ye.to(de.documentation):de.documentation,Ie.sortText=de.sortText,Ie.filterText=de.filterText,Ie.preselect=de.preselect,Ie.commitCharacters=de.commitCharacters,p.$Wt.isIRange(de.range)?Ie.range=G.to(de.range):typeof de.range=="object"&&(Ie.range={inserting:G.to(de.range.insert),replacing:G.to(de.range.replace)}),Ie.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&w.CompletionItemInsertTextRule.KeepWhitespace),typeof de.insertTextRules<"u"&&de.insertTextRules&w.CompletionItemInsertTextRule.InsertAsSnippet?Ie.insertText=new R.$oO(de.insertText):(Ie.insertText=de.insertText,Ie.textEdit=Ie.range instanceof R.$dO?new R.$kO(Ie.range,Ie.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Ie.additionalTextEdits=de.additionalTextEdits.map(Be=>pe.to(Be))),Ie.command=q&&de.command?q.fromInternal(de.command):void 0,Ie}Ee.to=Ae})(Xe||(e.CompletionItem=Xe={}));var tt;(function(Ee){function Ae(q){if(typeof q.label!="string"&&!Array.isArray(q.label))throw new TypeError("Invalid label");return{label:q.label,documentation:ye.fromStrict(q.documentation)}}Ee.from=Ae;function de(q){return{label:q.label,documentation:D.$$k(q.documentation)?ye.to(q.documentation):q.documentation}}Ee.to=de})(tt||(e.ParameterInformation=tt={}));var lt;(function(Ee){function Ae(q){return{label:q.label,documentation:ye.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(tt.from):[],activeParameter:q.activeParameter}}Ee.from=Ae;function de(q){return{label:q.label,documentation:D.$$k(q.documentation)?ye.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(tt.to):[],activeParameter:q.activeParameter}}Ee.to=de})(lt||(e.SignatureInformation=lt={}));var ct;(function(Ee){function Ae(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(lt.from):[]}}Ee.from=Ae;function de(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(lt.to):[]}}Ee.to=de})(ct||(e.SignatureHelp=ct={}));var rt;(function(Ee){function Ae(de,q){const Ie=new R.$KO(ve.to(q.position),typeof q.label=="string"?q.label:q.label.map(ut.to.bind(void 0,de)),q.kind&&st.to(q.kind));return Ie.textEdits=q.textEdits&&q.textEdits.map(pe.to),Ie.tooltip=D.$$k(q.tooltip)?ye.to(q.tooltip):q.tooltip,Ie.paddingLeft=q.paddingLeft,Ie.paddingRight=q.paddingRight,Ie}Ee.to=Ae})(rt||(e.InlayHint=rt={}));var ut;(function(Ee){function Ae(de,q){const Ie=new R.$JO(q.label);return Ie.tooltip=D.$$k(q.tooltip)?ye.to(q.tooltip):q.tooltip,w.Command.is(q.command)&&(Ie.command=de.fromInternal(q.command)),q.location&&(Ie.location=qe.to(q.location)),Ie}Ee.to=Ae})(ut||(e.InlayHintLabelPart=ut={}));var st;(function(Ee){function Ae(q){return q}Ee.from=Ae;function de(q){return q}Ee.to=de})(st||(e.InlayHintKind=st={}));var Je;(function(Ee){function Ae(q){return{range:G.from(q.range),url:q.target,tooltip:q.tooltip}}Ee.from=Ae;function de(q){let Ie;if(q.url)try{Ie=typeof q.url=="string"?m.URI.parse(q.url,!0):m.URI.revive(q.url)}catch{}const Be=new R.$QO(G.to(q.range),Ie);return Be.tooltip=q.tooltip,Be}Ee.to=de})(Je||(e.DocumentLink=Je={}));var me;(function(Ee){function Ae(q){const Ie=new R.$TO(q.label);return q.textEdit&&(Ie.textEdit=pe.to(q.textEdit)),q.additionalTextEdits&&(Ie.additionalTextEdits=q.additionalTextEdits.map(Be=>pe.to(Be))),Ie}Ee.to=Ae;function de(q){return{label:q.label,textEdit:q.textEdit?pe.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ie=>pe.from(Ie)):void 0}}Ee.from=de})(me||(e.ColorPresentation=me={}));var V;(function(Ee){function Ae(q){return new R.$RO(q[0],q[1],q[2],q[3])}Ee.to=Ae;function de(q){return[q.red,q.green,q.blue,q.alpha]}Ee.from=de})(V||(e.Color=V={}));var _;(function(Ee){function Ae(q){return{range:G.from(q.range)}}Ee.from=Ae;function de(q){return new R.$AO(G.to(q.range))}Ee.to=de})(_||(e.SelectionRange=_={}));var fe;(function(Ee){function Ae(de){switch(de){case i.SaveReason.AUTO:return R.TextDocumentSaveReason.AfterDelay;case i.SaveReason.EXPLICIT:return R.TextDocumentSaveReason.Manual;case i.SaveReason.FOCUS_CHANGE:case i.SaveReason.WINDOW_CHANGE:return R.TextDocumentSaveReason.FocusOut}}Ee.to=Ae})(fe||(e.TextDocumentSaveReason=fe={}));var re;(function(Ee){function Ae(q){switch(q){case R.TextEditorLineNumbersStyle.Off:return b.RenderLineNumbersType.Off;case R.TextEditorLineNumbersStyle.Relative:return b.RenderLineNumbersType.Relative;case R.TextEditorLineNumbersStyle.Interval:return b.RenderLineNumbersType.Interval;case R.TextEditorLineNumbersStyle.On:default:return b.RenderLineNumbersType.On}}Ee.from=Ae;function de(q){switch(q){case b.RenderLineNumbersType.Off:return R.TextEditorLineNumbersStyle.Off;case b.RenderLineNumbersType.Relative:return R.TextEditorLineNumbersStyle.Relative;case b.RenderLineNumbersType.Interval:return R.TextEditorLineNumbersStyle.Interval;case b.RenderLineNumbersType.On:default:return R.TextEditorLineNumbersStyle.On}}Ee.to=de})(re||(e.TextEditorLineNumbersStyle=re={}));var he;(function(Ee){function Ae(q){if(q===R.EndOfLine.CRLF)return o.EndOfLineSequence.CRLF;if(q===R.EndOfLine.LF)return o.EndOfLineSequence.LF}Ee.from=Ae;function de(q){if(q===o.EndOfLineSequence.CRLF)return R.EndOfLine.CRLF;if(q===o.EndOfLineSequence.LF)return R.EndOfLine.LF}Ee.to=de})(he||(e.EndOfLine=he={}));var H;(function(Ee){function Ae(de){if(typeof de=="object")return de.viewId;switch(de){case R.ProgressLocation.SourceControl:return n.ProgressLocation.Scm;case R.ProgressLocation.Window:return n.ProgressLocation.Window;case R.ProgressLocation.Notification:return n.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ae})(H||(e.ProgressLocation=H={}));var J;(function(Ee){function Ae(q){const Ie={start:q.start+1,end:q.end+1};return q.kind&&(Ie.kind=$e.from(q.kind)),Ie}Ee.from=Ae;function de(q){const Ie={start:q.start-1,end:q.end-1};return q.kind&&(Ie.kind=$e.to(q.kind)),Ie}Ee.to=de})(J||(e.FoldingRange=J={}));var $e;(function(Ee){function Ae(q){if(q)switch(q){case R.FoldingRangeKind.Comment:return w.$Xu.Comment;case R.FoldingRangeKind.Imports:return w.$Xu.Imports;case R.FoldingRangeKind.Region:return w.$Xu.Region}}Ee.from=Ae;function de(q){if(q)switch(q.value){case w.$Xu.Comment.value:return R.FoldingRangeKind.Comment;case w.$Xu.Imports.value:return R.FoldingRangeKind.Imports;case w.$Xu.Region.value:return R.FoldingRangeKind.Region}}Ee.to=de})($e||(e.FoldingRangeKind=$e={}));var Fe;(function(Ee){function Ae(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?G.from(de.selection):void 0,override:typeof de.override=="boolean"?i.$jG.id:void 0}}Ee.from=Ae})(Fe||(e.TextEditorOpenOptions=Fe={}));var He;(function(Ee){function Ae(Be){return Be instanceof R.$cP?Be.toJSON():typeof Be=="string"?Be:de(Be)||q(Be)?new R.$cP(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ee.from=Ae;function de(Be){const Ye=Be;return Ye?m.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function q(Be){const Ye=Be;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Ie(Be){return typeof Be=="string"?Be:new R.$cP(m.URI.revive(Be.baseUri),Be.pattern)}Ee.to=Ie})(He||(e.GlobPattern=He={}));var xe;(function(Ee){function Ae(de){if(de){if(Array.isArray(de))return de.map(Ae);if(typeof de=="string")return de;{const q=de;return{language:q.language,scheme:q.scheme,pattern:He.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}Ee.from=Ae})(xe||(e.LanguageSelector=xe={}));var et;(function(Ee){function Ae(q){return!!q&&typeof q=="object"&&"documents"in q&&Array.isArray(q.documents)&&q.documents.every(Ie=>Array.isArray(Ie)&&Ie.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&m.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Ye=>Ye instanceof R.$dO)))}Ee.is=Ae;function de(q){return{documents:q.documents.map(Ie=>Ie.map(Be=>({uri:m.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Ye=>G.from(Ye))})))}}Ee.from=de})(et||(e.MappedEditsContext=et={}));var it;(function(Ee){function Ae(q){return{start:q.start,end:q.end}}Ee.from=Ae;function de(q){return new R.$FP(q.start,q.end)}Ee.to=de})(it||(e.NotebookRange=it={}));var ft;(function(Ee){function Ae(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}Ee.to=Ae;function de(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}Ee.from=de})(ft||(e.NotebookCellExecutionSummary=ft={}));var gt;(function(Ee){function Ae(de){if(de===I.NotebookCellExecutionState.Unconfirmed)return R.NotebookCellExecutionState.Pending;if(de===I.NotebookCellExecutionState.Pending)return;if(de===I.NotebookCellExecutionState.Executing)return R.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Ee.to=Ae})(gt||(e.NotebookCellExecutionState=gt={}));var Et;(function(Ee){function Ae(q){switch(q){case R.NotebookCellKind.Markup:return I.CellKind.Markup;case R.NotebookCellKind.Code:default:return I.CellKind.Code}}Ee.from=Ae;function de(q){switch(q){case I.CellKind.Markup:return R.NotebookCellKind.Markup;case I.CellKind.Code:default:return R.NotebookCellKind.Code}}Ee.to=de})(Et||(e.NotebookCellKind=Et={}));var Rt;(function(Ee){function Ae(q){const Ie={metadata:q.metadata??Object.create(null),cells:[]};for(const Be of q.cells)R.$GP.validate(Be),Ie.cells.push(mt.from(Be));return Ie}Ee.from=Ae;function de(q){const Ie=new R.$HP(q.cells.map(mt.to));return(0,c.$wg)(q.metadata)||(Ie.metadata=q.metadata),Ie}Ee.to=de})(Rt||(e.NotebookData=Rt={}));var mt;(function(Ee){function Ae(q){return{cellKind:Et.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:ft.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(wt.from):[]}}Ee.from=Ae;function de(q){return new R.$GP(Et.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(wt.to):void 0,q.metadata,q.internalMetadata?ft.to(q.internalMetadata):void 0)}Ee.to=de})(mt||(e.NotebookCellData=mt={}));var pt;(function(Ee){function Ae(q){return{mime:q.mime,valueBytes:r.$Se.wrap(q.data)}}Ee.from=Ae;function de(q){return new R.$IP(q.valueBytes.buffer,q.mime)}Ee.to=de})(pt||(e.NotebookCellOutputItem=pt={}));var wt;(function(Ee){function Ae(q){return{outputId:q.id,items:q.items.map(pt.from),metadata:q.metadata}}Ee.from=Ae;function de(q){const Ie=q.items.map(pt.to);return new R.$JP(Ie,q.outputId,q.metadata)}Ee.to=de})(wt||(e.NotebookCellOutput=wt={}));var Wt;(function(Ee){function Ae(Ie){return q(Ie)?{include:He.from(Ie.include)??void 0,exclude:He.from(Ie.exclude)??void 0}:He.from(Ie)??void 0}Ee.from=Ae;function de(Ie){return q(Ie)?{include:He.to(Ie.include),exclude:He.to(Ie.exclude)}:He.to(Ie)}Ee.to=de;function q(Ie){const Be=Ie;return Be?!(0,c.$sg)(Be.include)&&!(0,c.$sg)(Be.exclude):!1}})(Wt||(e.NotebookExclusiveDocumentPattern=Wt={}));var It;(function(Ee){function Ae(de,q,Ie){const Be=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===R.NotebookCellStatusBarAlignment.Left?I.CellStatusbarAlignment.Left:I.CellStatusbarAlignment.Right,command:q.toInternal(Be,Ie),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Ee.from=Ae})(It||(e.NotebookStatusBarItem=It={}));var Ct;(function(Ee){function Ae(de,q,Ie){const Be=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:q.toInternal(Be,Ie),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}Ee.from=Ae})(Ct||(e.NotebookKernelSourceAction=Ct={}));var Nt;(function(Ee){function Ae(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}Ee.from=Ae})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var dt;(function(Ee){function Ae(q){return{uri:q.uri,provides:q.provides}}Ee.from=Ae;function de(q){return new R.$LP(m.URI.revive(q.uri),q.provides)}Ee.to=de})(dt||(e.NotebookRendererScript=dt={}));var vt;(function(Ee){function Ae(q){return{message:ye.fromStrict(q.message)||"",type:C.TestMessageType.Error,expected:q.expectedOutput,actual:q.actualOutput,contextValue:q.contextValue,location:q.location&&{range:G.from(q.location.range),uri:q.location.uri},stackTrace:q.stackTrace?.map(Ie=>({label:Ie.label,position:Ie.position&&ve.from(Ie.position),uri:Ie.uri&&m.URI.revive(Ie.uri).toJSON()}))}}Ee.from=Ae;function de(q){const Ie=new R.$RP(typeof q.message=="string"?q.message:ye.to(q.message));return Ie.actualOutput=q.actual,Ie.expectedOutput=q.expected,Ie.contextValue=q.contextValue,Ie.location=q.location?qe.to(q.location):void 0,Ie}Ee.to=de})(vt||(e.TestMessage=vt={}));var bt;(function(Ee){Ee.namespace=C.$wJ,Ee.denamespace=C.$xJ})(bt||(e.TestTag=bt={}));var Bt;(function(Ee){function Ae(q){const Ie=(0,u.$IQ)(q).controllerId;return{extId:O.$rJ.fromExtHostTestItem(q,Ie).toString(),label:q.label,uri:m.URI.revive(q.uri),busy:q.busy,tags:q.tags.map(Be=>bt.namespace(Ie,Be.id)),range:p.$Wt.lift(G.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&ye.fromStrict(q.error)||null}}Ee.from=Ae;function de(q){return{parent:void 0,error:void 0,id:O.$rJ.fromString(q.extId).localId,label:q.label,uri:m.URI.revive(q.uri),tags:(q.tags||[]).map(Ie=>{const{tagId:Be}=bt.denamespace(Ie);return new R.$SP(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:G.to(q.range||void 0),canResolveChildren:!1,busy:q.busy,description:q.description||void 0,sortText:q.sortText||void 0}}Ee.toPlain=de})(Bt||(e.TestItem=Bt={})),function(Ee){function Ae(q){return{id:q.id}}Ee.from=Ae;function de(q){return new R.$SP(q.id)}Ee.to=de}(bt||(e.TestTag=bt={}));var jt;(function(Ee){const Ae=(q,Ie)=>{const Be=q.value;if(!Be)return;const Ye={...Bt.toPlain(Be.item),parent:Ie,taskStates:Be.tasks.map(Me=>({state:Me.state,duration:Me.duration,messages:Me.messages.filter(nt=>nt.type===C.TestMessageType.Error).map(vt.to)})),children:[]};if(q.children)for(const Me of q.children.values()){const nt=Ae(Me,Ye);nt&&Ye.children.push(nt)}return Ye};function de(q){const Ie=new $.$qJ;for(const Me of q.items)Ie.insert(O.$rJ.fromString(Me.item.extId).path,Me);const Be=[Ie.nodes],Ye=[];for(;Be.length;)for(const Me of Be.pop())Me.value?Ye.push(Me):Me.children&&Be.push(Me.children.values());return{completedAt:q.completedAt,results:Ye.map(Me=>Ae(Me)).filter(c.$rg)}}Ee.to=de})(jt||(e.TestResults=jt={}));var _t;(function(Ee){function Ae(Me){return{covered:Me.covered,total:Me.total}}function de(Me){return"line"in Me?ve.from(Me):G.from(Me)}function q(Me){if(Me)return"endLineNumber"in Me?G.to(Me):ve.to(Me)}function Ie(Me){if(Me.type===C.DetailType.Statement){const nt=[];if(Me.branches)for(const ot of Me.branches)nt.push({executed:ot.count,location:q(ot.location),label:ot.label});return new R.$XP(Me.count,q(Me.location),Me.branches?.map(ot=>new R.$YP(ot.count,q(ot.location),ot.label)))}else return new R.$ZP(Me.name,Me.count,q(Me.location))}Ee.to=Ie;function Be(Me){if(typeof Me.executed=="number"&&Me.executed<0)throw new Error(`Invalid coverage count ${Me.executed}`);return"branches"in Me?{count:Me.executed,location:de(Me.location),type:C.DetailType.Statement,branches:Me.branches.length?Me.branches.map(nt=>({count:nt.executed,location:nt.location&&de(nt.location),label:nt.label})):void 0}:{type:C.DetailType.Declaration,name:Me.name,count:Me.executed,location:de(Me.location)}}Ee.fromDetails=Be;function Ye(Me,nt,ot){return R.$VP(ot.statementCoverage),R.$VP(ot.branchCoverage),R.$VP(ot.declarationCoverage),{id:nt,uri:ot.uri,statement:Ae(ot.statementCoverage),branch:ot.branchCoverage&&Ae(ot.branchCoverage),declaration:ot.declarationCoverage&&Ae(ot.declarationCoverage),testIds:ot instanceof R.$WP&&ot.fromTests.length?ot.fromTests.map(Dt=>O.$rJ.fromExtHostTestItem(Dt,Me).toString()):void 0}}Ee.fromFile=Ye})(_t||(e.TestCoverage=_t={}));var Ot;(function(Ee){function Ae(de){switch(de){case w.CodeActionTriggerType.Invoke:return R.CodeActionTriggerKind.Invoke;case w.CodeActionTriggerType.Auto:return R.CodeActionTriggerKind.Automatic}}Ee.to=Ae})(Ot||(e.CodeActionTriggerKind=Ot={}));var Ft;(function(Ee){function Ae(q){const Ie=new R.$1P(ie.to(q.kind),q.name,q.detail||"",m.URI.revive(q.uri),G.to(q.range),G.to(q.selectionRange));return Ie._sessionId=q._sessionId,Ie._itemId=q._itemId,Ie}Ee.to=Ae;function de(q,Ie,Be){if(Ie=Ie??q._sessionId,Be=Be??q._itemId,Ie===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Be,kind:ie.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:G.from(q.range),selectionRange:G.from(q.selectionRange),tags:q.tags?.map(W.from)}}Ee.from=de})(Ft||(e.TypeHierarchyItem=Ft={}));var Vt;(function(Ee){function Ae(de){if(de)return{value:de.value,tooltip:de.tooltip}}Ee.from=Ae})(Vt||(e.ViewBadge=Vt={}));var Gt;(function(Ee){function Ae(Be,Ye,Me){const nt=Ye.fileData;return nt?new R.$7O(new R.$8O(nt.name,m.URI.revive(nt.uri),nt.id,(0,P.$hb)(()=>Me(nt.id)))):Be===S.$gt.uriList&&Ye.uriListData?new R.$6O(Ie(Ye.uriListData)):new R.$6O(Ye.asString)}Ee.to=Ae;async function de(Be,Ye){const Me=await Ye.asString();if(Be===S.$gt.uriList)return{asString:Me,fileData:void 0,uriListData:q(Me)};const nt=Ye.asFile();return{asString:Me,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Ee.from=de;function q(Be){return E.$Bu.split(Be).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return m.URI.parse(Ye)}catch{}return Ye})}function Ie(Be){return E.$Bu.create(Be.map(Ye=>typeof Ye=="string"?Ye:m.URI.revive(Ye)))}})(Gt||(e.DataTransferItem=Gt={}));var St;(function(Ee){function Ae(q,Ie){const Be=q.items.map(([Ye,Me])=>[Ye,Gt.to(Ye,Me,Ie)]);return new R.$9O(Be)}Ee.toDataTransfer=Ae;async function de(q){const Ie={items:[]},Be=[];for(const[Ye,Me]of q)Be.push((async()=>{Ie.items.push([Ye,await Gt.from(Ye,Me)])})());return await Promise.all(Be),Ie}Ee.from=de})(St||(e.DataTransfer=St={}));var Lt;(function(Ee){function Ae(q,Ie){return{kind:"reply",agentId:q.participant??Ie?.agentId??"",subCommand:q.command??Ie?.command,message:q.prompt,title:q.label}}Ee.from=Ae;function de(q){return{prompt:q.message,label:q.title,participant:q.agentId,command:q.subCommand}}Ee.to=de})(Lt||(e.ChatFollowup=Lt={}));var At;(function(Ee){function Ae(q){switch(q){case h.ChatMessageRole.System:return R.LanguageModelChatMessageRole.System;case h.ChatMessageRole.User:return R.LanguageModelChatMessageRole.User;case h.ChatMessageRole.Assistant:return R.LanguageModelChatMessageRole.Assistant}}Ee.to=Ae;function de(q){switch(q){case R.LanguageModelChatMessageRole.System:return h.ChatMessageRole.System;case R.LanguageModelChatMessageRole.User:return h.ChatMessageRole.User;case R.LanguageModelChatMessageRole.Assistant:return h.ChatMessageRole.Assistant}return h.ChatMessageRole.User}Ee.from=de})(At||(e.LanguageModelChatMessageRole=At={}));var Kt;(function(Ee){function Ae(q){const Ie=q.content.map(nt=>nt.type==="text"?nt.value:nt.type==="tool_result"?new R.$tQ(nt.toolCallId,nt.value,nt.isError):new R.$vQ(nt.name,nt.toolCallId,nt.parameters)),Be=Ie.find(nt=>typeof nt=="string")??"",Ye=At.to(q.role),Me=new R.$uQ(Ye,Be,q.name);return Me.content2=Ie,Me}Ee.to=Ae;function de(q){const Ie=At.from(q.role),Be=q.name,Ye=q.content2.map(Me=>{if(Me instanceof R.$tQ)return{type:"tool_result",toolCallId:Me.toolCallId,value:Me.content,isError:Me.isError};if(Me instanceof R.$vQ)return{type:"tool_use",toolCallId:Me.toolCallId,name:Me.name,parameters:Me.parameters};if(typeof Me!="string")throw new Error("Unexpected chat message content type");return{type:"text",value:Me}});return{role:Ie,name:Be,content:Ye}}Ee.from=de})(Kt||(e.LanguageModelChatMessage=Kt={}));var Qt;(function(Ee){function Ae(q){return{kind:"markdownContent",content:ye.from(q.value)}}Ee.from=Ae;function de(q){return new R.$bQ(ye.to(q.content))}Ee.to=de})(Qt||(e.ChatResponseMarkdownPart=Qt={}));var qt;(function(Ee){function Ae(q){return{kind:"markdownVuln",content:ye.from(q.value),vulnerabilities:q.vulnerabilities}}Ee.from=Ae;function de(q){return new R.$cQ(ye.to(q.content),q.vulnerabilities)}Ee.to=de})(qt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=qt={}));var Zt;(function(Ee){function Ae(q){return{kind:"agentDetection",agentId:q.participant,command:q.command}}Ee.from=Ae;function de(q){return new R.$dQ(q.agentId,q.command)}Ee.to=de})(Zt||(e.ChatResponseDetectedParticipantPart=Zt={}));var Jt;(function(Ee){function Ae(de){return{kind:"confirmation",title:de.title,message:de.message,data:de.data,buttons:de.buttons}}Ee.from=Ae})(Jt||(e.ChatResponseConfirmationPart=Jt={}));var Yt;(function(Ee){function Ae(q){const{value:Ie,baseUri:Be}=q;function Ye(Me,nt){return Me.map(ot=>{const Dt=m.URI.joinPath(nt,ot.name);return{label:ot.name,uri:Dt,children:ot.children&&Ye(ot.children,Dt)}})}return{kind:"treeData",treeData:{label:(0,g.$ih)(Be),uri:Be,children:Ye(Ie,Be)}}}Ee.from=Ae;function de(q){const Ie=(0,s.$hi)(q.treeData);function Be(nt){return nt.map(ot=>({name:ot.label,children:ot.children&&Be(ot.children)}))}const Ye=Ie.uri,Me=Ie.children?Be(Ie.children):[];return new R.$fQ(Me,Ye)}Ee.to=de})(Yt||(e.ChatResponseFilesPart=Yt={}));var Mt;(function(Ee){function Ae(q){const Ie=Be=>m.URI.isUri(Be);return{kind:"inlineReference",name:q.title,inlineReference:Ie(q.value)?q.value:Q.from(q.value)}}Ee.from=Ae;function de(q){const Ie=(0,s.$hi)(q);return new R.$gQ(m.URI.isUri(Ie.inlineReference)?Ie.inlineReference:Q.to(Ie.inlineReference),q.name)}Ee.to=de})(Mt||(e.ChatResponseAnchorPart=Mt={}));var Ht;(function(Ee){function Ae(q){return{kind:"progressMessage",content:ye.from(q.value)}}Ee.from=Ae;function de(q){return new R.$hQ(q.content.value)}Ee.to=de})(Ht||(e.ChatResponseProgressPart=Ht={}));var yt;(function(Ee){function Ae(q){return{kind:"warning",content:ye.from(q.value)}}Ee.from=Ae;function de(q){return new R.$jQ(q.content.value)}Ee.to=de})(yt||(e.ChatResponseWarningPart=yt={}));var zt;(function(Ee){function Ae(q){return{kind:"move",uri:q.uri,range:G.from(q.range)}}Ee.from=Ae;function de(q){return new R.$nQ(m.URI.revive(q.uri),G.to(q.range))}Ee.to=de})(zt||(e.ChatResponseMovePart=zt={}));var Ut;(function(Ee){function Ae(de){return{kind:"progressTask",content:ye.from(de.value)}}Ee.from=Ae})(Ut||(e.ChatTask=Ut={}));var an;(function(Ee){function Ae(de){return{kind:"progressTaskResult",content:typeof de=="string"?ye.from(de):void 0}}Ee.from=Ae})(an||(e.ChatTaskResult=an={}));var ln;(function(Ee){function Ae(q,Ie,Be){return{kind:"command",command:Ie.toInternal(q.value,Be)??{command:q.value.command,title:q.value.title}}}Ee.from=Ae;function de(q,Ie){return new R.$kQ(Ie.fromInternal(q.command)??{command:q.command.id,title:q.command.title})}Ee.to=de})(ln||(e.ChatResponseCommandButtonPart=ln={}));var wn;(function(Ee){function Ae(q){return{kind:"textEdit",uri:q.uri,edits:q.edits.map(Ie=>pe.from(Ie))}}Ee.from=Ae;function de(q){return new R.$oQ(m.URI.revive(q.uri),q.edits.map(Ie=>pe.to(Ie)))}Ee.to=de})(wn||(e.ChatResponseTextEditPart=wn={}));var cn;(function(Ee){function Ae(q){const Ie=a.ThemeIcon.isThemeIcon(q.iconPath)?q.iconPath:m.URI.isUri(q.iconPath)?{light:m.URI.revive(q.iconPath)}:q.iconPath&&"light"in q.iconPath&&"dark"in q.iconPath&&m.URI.isUri(q.iconPath.light)&&m.URI.isUri(q.iconPath.dark)?{light:m.URI.revive(q.iconPath.light),dark:m.URI.revive(q.iconPath.dark)}:void 0;return typeof q.value=="object"&&"variableName"in q.value?{kind:"reference",reference:{variableName:q.value.variableName,value:m.URI.isUri(q.value.value)||!q.value.value?q.value.value:Q.from(q.value.value)},iconPath:Ie,options:q.options}:{kind:"reference",reference:m.URI.isUri(q.value)||typeof q.value=="string"?q.value:Q.from(q.value),iconPath:Ie,options:q.options}}Ee.from=Ae;function de(q){const Ie=(0,s.$hi)(q),Be=Ye=>m.URI.isUri(Ye)?Ye:Q.to(Ye);return new R.$lQ(typeof Ie.reference=="string"?Ie.reference:"variableName"in Ie.reference?{variableName:Ie.reference.variableName,value:Ie.reference.value&&Be(Ie.reference.value)}:Be(Ie.reference))}Ee.to=de})(cn||(e.ChatResponseReferencePart=cn={}));var fn;(function(Ee){function Ae(de){return{kind:"codeCitation",value:de.value,license:de.license,snippet:de.snippet}}Ee.from=Ae})(fn||(e.ChatResponseCodeCitationPart=fn={}));var yn;(function(Ee){function Ae(Ie,Be,Ye){return Ie instanceof R.$bQ?Qt.from(Ie):Ie instanceof R.$gQ?Mt.from(Ie):Ie instanceof R.$lQ?cn.from(Ie):Ie instanceof R.$hQ?Ht.from(Ie):Ie instanceof R.$fQ?Yt.from(Ie):Ie instanceof R.$kQ?ln.from(Ie,Be,Ye):Ie instanceof R.$oQ?wn.from(Ie):Ie instanceof R.$cQ?qt.from(Ie):Ie instanceof R.$dQ?Zt.from(Ie):Ie instanceof R.$jQ?yt.from(Ie):Ie instanceof R.$eQ?Jt.from(Ie):Ie instanceof R.$mQ?fn.from(Ie):Ie instanceof R.$nQ?zt.from(Ie):{kind:"markdownContent",content:ye.from("")}}Ee.from=Ae;function de(Ie,Be){switch(Ie.kind){case"reference":return cn.to(Ie);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return q(Ie,Be)}}Ee.to=de;function q(Ie,Be){switch(Ie.kind){case"markdownContent":return Qt.to(Ie);case"inlineReference":return Mt.to(Ie);case"progressMessage":return;case"treeData":return Yt.to(Ie);case"command":return ln.to(Ie,Be)}}Ee.toContent=q})(yn||(e.ChatResponsePart=yn={}));var tn;(function(Ee){function Ae(de,q){const Ie=de.variables.variables.filter(Ye=>Ye.isTool),Be=de.variables.variables.filter(Ye=>!Ye.isTool);return{prompt:de.message,command:de.command,attempt:de.attempt??0,enableCommandDetection:de.enableCommandDetection??!0,isParticipantDetected:de.isParticipantDetected??!1,references:Be.map(Xt.to),toolReferences:Ie.map(dn.to),location:vn.to(de.location),acceptedConfirmationData:de.acceptedConfirmationData,rejectedConfirmationData:de.rejectedConfirmationData,location2:q}}Ee.to=Ae})(tn||(e.ChatAgentRequest=tn={}));var vn;(function(Ee){function Ae(q){switch(q){case f.ChatAgentLocation.Notebook:return R.ChatLocation.Notebook;case f.ChatAgentLocation.Terminal:return R.ChatLocation.Terminal;case f.ChatAgentLocation.Panel:return R.ChatLocation.Panel;case f.ChatAgentLocation.Editor:return R.ChatLocation.Editor}}Ee.to=Ae;function de(q){switch(q){case R.ChatLocation.Notebook:return f.ChatAgentLocation.Notebook;case R.ChatLocation.Terminal:return f.ChatAgentLocation.Terminal;case R.ChatLocation.Panel:return f.ChatAgentLocation.Panel;case R.ChatLocation.Editor:return f.ChatAgentLocation.Editor}}Ee.from=de})(vn||(e.ChatLocation=vn={}));var Xt;(function(Ee){function Ae(de){const q=de.value;if(!q)throw new Error("Invalid value reference");return{id:de.id,name:de.name,range:de.range&&[de.range.start,de.range.endExclusive],value:(0,m.$Ac)(q)?m.URI.revive(q):q&&typeof q=="object"&&"uri"in q&&"range"in q&&(0,m.$Ac)(q.uri)?Q.to((0,s.$hi)(q)):q,modelDescription:de.modelDescription}}Ee.to=Ae})(Xt||(e.ChatPromptReference=Xt={}));var dn;(function(Ee){function Ae(de){if(de.value)throw new Error("Invalid tool reference");return{id:de.id,range:de.range&&[de.range.start,de.range.endExclusive]}}Ee.to=Ae})(dn||(e.ChatLanguageModelToolReference=dn={}));var En;(function(Ee){function Ae(de,q,Ie){return{id:de.id,label:de.label,fullName:de.fullName,icon:de.icon?.id,value:de.values[0].value,insertText:de.insertText,detail:de.detail,documentation:de.documentation,command:q.toInternal(de.command,Ie)}}Ee.from=Ae})(En||(e.ChatAgentCompletionItem=En={}));var mn;(function(Ee){function Ae(de){return{errorDetails:de.errorDetails,metadata:de.metadata,nextQuestion:de.nextQuestion}}Ee.to=Ae})(mn||(e.ChatAgentResult=mn={}));var Sn;(function(Ee){function Ae(de,q,Ie){if(q.action.kind==="vote")return;const Be=mn.to(de);if(q.action.kind==="command"){const Ye=q.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ie.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:Be}}else return q.action.kind==="followUp"?{action:{kind:"followUp",followup:Lt.to(q.action.followup)},result:Be}:q.action.kind==="inlineChat"?{action:{kind:"editor",accepted:q.action.action==="accepted"},result:Be}:{action:q.action,result:Be}}Ee.to=Ae})(Sn||(e.ChatAgentUserActionEvent=Sn={}));var Pn;(function(Ee){function Ae(q){return{...q,string:q.toString()}}Ee.from=Ae;function de(q){const Ie={...q,toString:()=>q.string};return delete Ie.string,Ie}Ee.to=de})(Pn||(e.LanguageModelToolResult=Pn={}));var sn;(function(Ee){function Ae(de,q,Ie){return"terminalCommand"in de?{terminalCommand:de.terminalCommand,shouldExecute:de.shouldExecute}:"uri"in de?{uri:de.uri}:q.toInternal(de,Ie)}Ee.from=Ae})(sn||(e.TerminalQuickFix=sn={}));var $n;(function(Ee){function Ae(de){return{kind:gn.to(de.kind)}}Ee.to=Ae})($n||(e.PartialAcceptInfo=$n={}));var gn;(function(Ee){function Ae(de){switch(de){case w.PartialAcceptTriggerKind.Word:return R.PartialAcceptTriggerKind.Word;case w.PartialAcceptTriggerKind.Line:return R.PartialAcceptTriggerKind.Line;case w.PartialAcceptTriggerKind.Suggest:return R.PartialAcceptTriggerKind.Suggest;default:return R.PartialAcceptTriggerKind.Unknown}}Ee.to=Ae})(gn||(e.PartialAcceptTriggerKind=gn={}));var pn;(function(Ee){function Ae(de,q){return{id:q,label:de.label,description:de.description,canEdit:de.canEdit,collapsibleState:de.collapsibleState||k.DebugTreeItemCollapsibleState.None,contextValue:de.contextValue}}Ee.from=Ae})(pn||(e.DebugTreeItem=pn={}));var bn;(function(Ee){function Ae(de){return{id:de.id,modelDescription:de.modelDescription,parametersSchema:de.parametersSchema,displayName:de.displayName}}Ee.to=Ae})(bn||(e.LanguageModelToolDescription=bn={}))}),define(Te[277],Oe([1,0,48,150,77,149,103,156,4]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Q=e.$1Q=e.$ZQ=e.$YQ=void 0,t=Ve(t),T=Ve(T);const s=(d,w,o,l)=>{let n=w;return{enumerable:!0,configurable:!1,get(){return n},set(u){if(!o(n,u)){const i=n;n=u,d.listener?.(l(u,i))}}}},S=(d,w)=>d===w,y={range:(d,w)=>d===w?!0:!d||!w?!1:d.isEqual(w),label:S,description:S,sortText:S,busy:S,error:S,canResolveChildren:S,tags:(d,w)=>!(d.length!==w.length||d.some(o=>!w.find(l=>o.id===l.id)))},$=d=>w=>({op:P.TestItemEventOp.SetProp,update:d(w)}),g=(d,w)=>({range:(()=>{let o;const l=$(n=>({range:t.$Wt.lift(T.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return o},set(n){d.listener?.({op:P.TestItemEventOp.DocumentSynced}),y.range(o,n)||(o=n,d.listener?.(l(n)))}}})(),label:s(d,w,y.label,$(o=>({label:o}))),description:s(d,void 0,y.description,$(o=>({description:o}))),sortText:s(d,void 0,y.sortText,$(o=>({sortText:o}))),canResolveChildren:s(d,!1,y.canResolveChildren,o=>({op:P.TestItemEventOp.UpdateCanResolveChildren,state:o})),busy:s(d,!1,y.busy,$(o=>({busy:o}))),error:s(d,void 0,y.error,$(o=>({error:T.MarkdownString.fromStrict(o)||null}))),tags:s(d,[],y.tags,(o,l)=>({op:P.TestItemEventOp.SetTags,new:o.map(T.TestTag.from),old:l.map(T.TestTag.from)}))}),a=d=>{const w=E.$rJ.fromString(d.extId),o=new m(w.controllerId,w.localId,d.label,v.URI.revive(d.uri)||void 0);return o.range=T.Range.to(d.range||void 0),o.description=d.description||void 0,o.sortText=d.sortText||void 0,o.tags=d.tags.map(l=>T.TestTag.to({id:(0,D.$xJ)(l).tagId})),o},c=d=>{let w;for(const o of d.tests){const l=a(o.item);(0,r.$IQ)(l).parent=w,w=l}return w};e.$YQ=c;class m{constructor(w,o,l,n){if(o.includes(E.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const u=(0,r.$HQ)(this,w);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof b?void 0:u.parent}},children:{value:(0,P.$GQ)(u,r.$IQ,m),enumerable:!0,writable:!1},...g(u,l)})}}e.$ZQ=m;class b extends m{constructor(w,o){super(w,w,o,void 0),this._isRoot=!0}}e.$1Q=b;class p extends P.$CQ{constructor(w,o,l){super({controllerId:w,getDocumentVersion:n=>n&&l.getDocument(n)?.version,getApiFor:r.$IQ,getChildren:n=>n.children,root:new b(w,o),toITestItem:T.TestItem.from})}}e.$2Q=p}),define(Te[278],Oe([1,0,10,155,156,20,275,17,11,49,48,85,4,2,5,255,277,14,153,45,43,40,269,22]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d,w,o,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aR=e.$_Q=e.$$Q=e.$0Q=e.$9Q=e.$8Q=void 0,r=Ve(r),E=Ve(E);let u=class{#e;#t;#n;constructor(O,C,L){this.b=new Map,this.c=new Map,this.#e=O.getProxy(D.$_N.MainThreadCommands),this.d=C,this.#n=L,this.#t=O.getProxy(D.$_N.MainThreadTelemetry),this.converter=new i(this,R=>{const M=this.c.get(R);return M?.result===h.Void?M:void 0},C),this.f=[{processArgument(R){return(0,s.$hi)(R)}},{processArgument(R){return(0,P.$mo)(R,function(M){if(S.$Wt.isIRange(M))return E.Range.to(M);if(y.$Vt.isIPosition(M))return E.Position.to(M);if(S.$Wt.isIRange(M.range)&&$.URI.isUri(M.uri))return E.location.to(M);if(M instanceof b.$Se)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(O){this.f.push(O)}registerApiCommand(O){const C=this.registerCommand(!1,O.id,async(...L)=>{const R=O.args.map((G,Q)=>{if(!G.validate(L[Q]))throw new Error(`Invalid argument '${G.name}' when running '${O.id}', received: ${typeof L[Q]=="object"?JSON.stringify(L[Q],null,"	"):L[Q]} `);return G.convert(L[Q])}),M=await this.executeCommand(O.internalId,...R);return O.result.convert(M,L,this.converter)},void 0,{description:O.description,args:O.args,returns:O.result.description});return this.c.set(O.id,O),new r.$bO(()=>{C.dispose(),this.c.delete(O.id)})}registerCommand(O,C,L,R,M,G){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:L,thisArg:R,metadata:M,extension:G}),O&&this.#e.$registerCommand(C),new r.$bO(()=>{this.b.delete(C)&&O&&this.#e.$unregisterCommand(C)})}executeCommand(O,...C){return this.d.trace("ExtHostCommands#executeCommand",O),this.g(O,C,!0)}async g(O,C,L){if(this.b.has(O))return this.#e.$fireCommandActivationEvent(O),this.h(O,C,!1);{let R=!1;const M=(0,P.$mo)(C,function(G){if(G instanceof r.$cO)return E.Position.from(G);if(G instanceof r.$dO)return E.Range.from(G);if(G instanceof r.$pO)return E.location.from(G);if(r.$FP.isNotebookRange(G))return E.NotebookRange.from(G);if(G instanceof ArrayBuffer)return R=!0,b.$Se.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return R=!0,b.$Se.wrap(G);if(G instanceof b.$Se)return R=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(O,R?new p.$7w(M):M,L);return(0,s.$hi)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(O,C,!1);throw G}}}async h(O,C,L){const R=this.b.get(O);if(!R)throw new Error("Unknown command");const{callback:M,thisArg:G,metadata:Q}=R;if(Q?.args)for(let ve=0;ve<Q.args.length;ve++)try{(0,t.$Ag)(C[ve],Q.args[ve].constraint)}catch{throw new Error(`Running the contributed command: '${O}' failed. Illegal argument '${Q.args[ve].name}' - ${Q.args[ve].description}`)}const te=w.$ke.create();try{return await M.apply(G,C)}catch(ve){if(O===this.converter.delegatingCommandId){const be=this.converter.getActualCommand(...C);be&&(O=be.command)}if(this.d.error(ve,O,R.extension?.identifier),!L)throw ve;if(R.extension?.identifier){const be=this.#n.onExtensionError(R.extension.identifier,ve);this.d.trace("forwarded error to extension?",be,R.extension?.identifier)}throw new class extends Error{constructor(){super((0,d.$vj)(ve)),this.id=O,this.source=R.extension?.displayName??R.extension?.name}}}finally{this.j(R,O,te.elapsed())}}j(O,C,L){O.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:O.extension.identifier.value,id:new o.$Dp(C),duration:L})}$executeContributedCommand(O,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",O);const L=this.b.get(O);return L?(C=C.map(R=>this.f.reduce((M,G)=>G.processArgument(M,L.extension?.identifier),R)),this.h(O,C,!0)):Promise.reject(new Error(`Contributed command '${O}' does not exist.`))}getCommands(O=!1){return this.d.trace("ExtHostCommands#getCommands",O),this.#e.$getCommands().then(C=>(O&&(C=C.filter(L=>L[0]!=="_")),C))}$getContributedCommandMetadata(){const O=Object.create(null);for(const[C,L]of this.b){const{metadata:R}=L;R&&(O[C]=R)}return Promise.resolve(O)}};e.$8Q=u,e.$8Q=u=We([je(0,c.$MQ),je(1,v.$fk),je(2,l.$7Q)],u),e.$9Q=(0,a.$Ki)("IExtHostCommands");class i{constructor(O,C,L){this.d=O,this.f=C,this.g=L,this.delegatingCommandId=`__vsc${(0,n.$7g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(O,C){if(!O)return;const L={$ident:void 0,id:O.command,title:O.title,tooltip:O.tooltip};if(!O.command)return L;const R=this.f(O.command);if(R)L.id=R.internalId,L.arguments=R.args.map((M,G)=>M.convert(O.arguments&&O.arguments[G]));else if((0,T.$Pb)(O.arguments)){const M=`${O.command} /${++this.c}`;this.b.set(M,O),C.add((0,g.$Xc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),L.$ident=M,L.id=this.delegatingCommandId,L.arguments=[M],this.g.trace("CommandsConverter#CREATE",O.command,M)}return L}fromInternal(O){return typeof O.$ident=="string"?this.b.get(O.$ident):{command:O.id,title:O.title,arguments:O.arguments}}getActualCommand(...O){return this.b.get(O[0])}h(...O){const C=this.getActualCommand(...O);return this.g.trace("CommandsConverter#EXECUTE",O[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${O[0]}`)}}e.$0Q=i;class f{static{this.Uri=new f("uri","Uri of a text document",O=>$.URI.isUri(O),O=>O)}static{this.Position=new f("position","A position in a text document",O=>r.$cO.isPosition(O),E.Position.from)}static{this.Range=new f("range","A range in a text document",O=>r.$dO.isRange(O),E.Range.from)}static{this.Selection=new f("selection","A selection in a text document",O=>r.$eO.isSelection(O),E.Selection.from)}static{this.Number=new f("number","",O=>typeof O=="number",O=>O)}static{this.String=new f("string","",O=>typeof O=="string",O=>O)}static{this.StringArray=f.Arr(f.String)}static Arr(O){return new f(`${O.name}_array`,`Array of ${O.name}, ${O.description}`,C=>Array.isArray(C)&&C.every(L=>O.validate(L)),C=>C.map(L=>O.convert(L)))}static{this.CallHierarchyItem=new f("item","A call hierarchy item",O=>O instanceof r.$BO,E.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new f("item","A type hierarchy item",O=>O instanceof r.$1P,E.TypeHierarchyItem.from)}static{this.TestItem=new f("testItem","A VS Code TestItem",O=>O instanceof m.$ZQ,E.TestItem.from)}constructor(O,C,L,R){this.name=O,this.description=C,this.validate=L,this.convert=R}optional(){return new f(this.name,`(optional) ${this.description}`,O=>O==null||this.validate(O),O=>O===void 0?void 0:O===null?null:this.convert(O))}with(O,C){return new f(O??this.name,C??this.description,this.validate,this.convert)}}e.$$Q=f;class h{static{this.Void=new h("no result",O=>O)}constructor(O,C){this.description=O,this.convert=C}}e.$_Q=h;class k{constructor(O,C,L,R,M){this.id=O,this.internalId=C,this.description=L,this.args=R,this.result=M}}e.$aR=k}),define(Te[279],Oe([1,0,9,2,12,3,208]),function(ue,e,t,r,E,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XR=e.$WR=void 0,e.$WR="remoteFilesystem";class T extends D.$VR{static register(s,S,y){const $=s.getConnection();if(!$)return r.$Zc.None;const g=new r.$Yc,a=(async()=>{try{const c=await s.getRawEnvironment();c?S.registerProvider(E.Schemas.vscodeRemote,g.add(new T(c,$))):y.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(c){y.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,t.$bb)(c))}})();return g.add(S.onWillActivateFileSystemProvider(c=>{c.scheme===E.Schemas.vscodeRemote&&c.join(a)})),g}constructor(s,S){super(S.getChannel(e.$WR),{pathCaseSensitive:s.os===P.OperatingSystem.Linux})}}e.$XR=T}),define(Te[78],Oe([1,0,96,84,31,280,14,9,6,2,8,3,22,51,60]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Bi=e.$Ai=e.$zi=void 0,e.$Ci=i,e.$Di=f,e.$Fi=I,e.$Gi=O;const c=3e4;class m{traceSocketEvent(L,R){a.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,R)}constructor(L,R=""){this.f=!0,this.debugLabel=R,this.socket=L,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=G=>{if(this.traceSocketEvent(a.SocketDiagnosticsEventType.Error,{code:G?.code,message:G?.message}),G){if(G.code==="EPIPE")return;(0,T.$4)(G)}},this.socket.on("error",this.a);let M;this.b=G=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Close,{hadError:G}),this.f=!1,M&&clearTimeout(M)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,M=setTimeout(()=>L.destroy(),c)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(L){const R=M=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Read,M),L(D.$Se.wrap(M))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(L){const R=M=>{L({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(L){const R=()=>{L()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(L){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(a.SocketDiagnosticsEventType.Write,L),this.socket.write(L.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,T.$4)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,T.$4)(R)}}end(){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((L,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),L();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),L()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$zi=m;var b;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var p;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(p||(p={}));class d extends s.$Zc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(L,R){this.socket.traceSocketEvent(L,R)}constructor(L,R,M,G){super(),this.f=this.B(new v.$qe),this.g=this.B(new v.$qe),this.h=!1,this.j={state:p.PeekHeader,readLen:b.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=L,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:M?.byteLength||0,recordInflateBytes:G}),this.a=this.B(new w(this,R,M,G,this.f,(Q,te)=>this.m(Q,te))),this.B(this.a.onError(Q=>{console.error(Q),(0,T.$4)(Q),this.g.fire({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:Q})})),this.b=new a.$ui,this.B(this.socket.onData(Q=>this.n(Q))),this.B(this.socket.onClose(async Q=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(Q)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this.f.event(L)}onClose(L){return this.g.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){let R=0;for(;R<L.byteLength;)this.a.writeMessage(L.slice(R,Math.min(R+b.MaxWebSocketMessageLength,L.byteLength)),{compressed:!0,opcode:2}),R+=b.MaxWebSocketMessageLength}m(L,{compressed:R,opcode:M}){if(this.h)return;this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,L);let G=b.MinHeaderByteSize;L.byteLength<126?G+=0:L.byteLength<2**16?G+=2:G+=8;const Q=D.$Se.alloc(G),te=R?64:0,ve=M&15;if(Q.writeUInt8(128|te|ve,0),L.byteLength<126)Q.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){Q.writeUInt8(126,1);let be=1;Q.writeUInt8(L.byteLength>>>8&255,++be),Q.writeUInt8(L.byteLength>>>0&255,++be)}else{Q.writeUInt8(127,1);let be=1;Q.writeUInt8(0,++be),Q.writeUInt8(0,++be),Q.writeUInt8(0,++be),Q.writeUInt8(0,++be),Q.writeUInt8(L.byteLength>>>24&255,++be),Q.writeUInt8(L.byteLength>>>16&255,++be),Q.writeUInt8(L.byteLength>>>8&255,++be),Q.writeUInt8(L.byteLength>>>0&255,++be)}this.socket.write(D.$Se.concat([Q,L]))}end(){this.h=!0,this.socket.end()}n(L){if(L.byteLength!==0){for(this.b.acceptChunk(L);this.b.byteLength>=this.j.readLen;)if(this.j.state===p.PeekHeader){const R=this.b.peek(this.j.readLen),M=R.readUInt8(0),G=(M&128)>>>7,Q=(M&64)>>>6,te=M&15,ve=R.readUInt8(1),be=(ve&128)>>>7,le=ve&127;this.j.state=p.ReadHeader,this.j.readLen=b.MinHeaderByteSize+(be?4:0)+(le===126?2:0)+(le===127?8:0),this.j.fin=G,this.j.firstFrameOfMessage&&(this.j.compressed=!!Q),this.j.firstFrameOfMessage=!!G,this.j.mask=0,this.j.opcode=te,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===p.ReadHeader){const R=this.b.read(this.j.readLen),M=R.readUInt8(1),G=(M&128)>>>7;let Q=M&127,te=1;Q===126?Q=R.readUInt8(++te)*2**8+R.readUInt8(++te):Q===127&&(Q=R.readUInt8(++te)*0+R.readUInt8(++te)*0+R.readUInt8(++te)*0+R.readUInt8(++te)*0+R.readUInt8(++te)*2**24+R.readUInt8(++te)*2**16+R.readUInt8(++te)*2**8+R.readUInt8(++te));let ve=0;G&&(ve=R.readUInt8(++te)*2**24+R.readUInt8(++te)*2**16+R.readUInt8(++te)*2**8+R.readUInt8(++te)),this.j.state=p.ReadBody,this.j.readLen=Q,this.j.mask=ve,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===p.ReadBody){const R=this.b.read(this.j.readLen);this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,R),n(R,this.j.mask),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,R),this.j.state=p.PeekHeader,this.j.readLen=b.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(R,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(R,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$Ai=d;class w extends s.$Zc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$Se.alloc(0)}constructor(L,R,M,G,Q,te){super(),this.n=L,this.r=Q,this.s=te,this.a=this.B(new v.$qe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.$qe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new v.$qe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,R?(this.b=this.B(new o(this.n,G,M,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(ve=>this.a.fire(ve))),this.B(this.f.onError(ve=>this.a.fire(ve)))):(this.b=null,this.f=null)}writeMessage(L,R){this.g.push({data:L,options:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:L,options:R}=this.g.shift();if(this.f&&R.compressed){const M=await this.w(this.f,L);this.s(M,R)}else this.s(L,{...R,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(L,R){return new Promise((M,G)=>{L.write(R),L.flush(Q=>M(Q))})}acceptFrame(L,R,M){this.h.push({data:L,isCompressed:R,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const L=this.h.shift();if(this.b&&L.isCompressed){const R=await this.C(this.b,L.data,L.isLastFrameOfMessage);this.r.fire(R)}else this.r.fire(L.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(L,R,M){return new Promise((G,Q)=>{L.write(R),M&&L.write(D.$Se.fromByteArray([0,0,255,255])),L.flush(te=>G(te))})}}class o extends s.$Zc{get recordedInflateBytes(){return this.j?D.$Se.concat(this.f):D.$Se.alloc(0)}constructor(L,R,M,G){super(),this.h=L,this.j=R,this.a=this.B(new v.$qe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(G),this.b.on("error",Q=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateError,{message:Q?.message,code:Q?.code}),this.a.fire(Q)}),this.b.on("data",Q=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateData,Q),this.g.push(D.$Se.wrap(Q))}),M&&(this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(L){this.j&&this.f.push(L.clone()),this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateWrite,L),this.b.write(L.buffer)}flush(L){this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateFlushFired);const R=D.$Se.concat(this.g);this.g.length=0,L(R)})}}class l extends s.$Zc{constructor(L,R){super(),this.g=L,this.a=this.B(new v.$qe),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateData,M),this.f.push(D.$Se.wrap(M))})}write(L){this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateWrite,L.buffer),this.b.write(L.buffer)}flush(L){this.b.flush(2,()=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateFlushFired);let R=D.$Se.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),L(R)})}}function n(C,L){if(L===0)return;const R=C.byteLength>>>2;for(let be=0;be<R;be++){const le=C.readUInt32BE(be*4);C.writeUInt32BE(le^L,be*4)}const M=R*4,G=C.byteLength-M,Q=L>>>24&255,te=L>>>16&255,ve=L>>>8&255;G>=1&&C.writeUInt8(C.readUInt8(M)^Q,M),G>=2&&C.writeUInt8(C.readUInt8(M+1)^te,M+1),G>=3&&C.writeUInt8(C.readUInt8(M+2)^ve,M+2)}e.$Bi=process.env.XDG_RUNTIME_DIR;const u={[y.Platform.Linux]:107,[y.Platform.Mac]:103};function i(){const C=(0,$.$7g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const L=process.platform!=="darwin"&&e.$Bi?e.$Bi:(0,E.tmpdir)(),R=(0,S.$oc)(L,`vscode-ipc-${C}.sock`);return h(R),R}function f(C,L,R){const G=(0,t.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${G}-${R}-${L}-sock`;const Q=R.substr(0,4),te=L.substr(0,6);let ve;return process.platform!=="darwin"&&e.$Bi&&!process.env.VSCODE_PORTABLE?ve=(0,S.$oc)(e.$Bi,`vscode-${G}-${Q}-${te}.sock`):ve=(0,S.$oc)(C,`${Q}-${te}.sock`),h(ve),ve}function h(C){const L=u[y.$x];typeof L=="number"&&C.length>=L&&console.warn(`WARNING: IPC handle "${C}" is longer than ${L} chars, try a shorter --user-data-dir`)}class k extends g.$oi{static b(L){const R=v.Event.fromNodeEventEmitter(L,"connection");return v.Event.map(R,M=>({protocol:new a.$vi(new m(M,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(M,"close"))}))}constructor(L){super(k.b(L)),this.d=L}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ei=k;function I(C){return new Promise((L,R)=>{const M=(0,r.createServer)();M.on("error",R),M.listen(C,()=>{M.removeListener("error",R),L(new k(M))})})}function O(C,L){return new Promise((R,M)=>{const G=(0,r.createConnection)(C,()=>{G.removeListener("error",M),R(a.$wi.fromSocket(new m(G,`ipc-client${L}`),L))});G.once("error",M)})}}),define(Te[157],Oe([1,0,93,13,14,9,10,28,27,94,11,47,227,280]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0,e.$os=m;let a=class extends y.$cq{constructor(p,d,w,o){super(o),this.m=p,this.n=d,this.r=w,this.s(),this.B(p.onDidChangeConfiguration(l=>{l.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,d){const{f:w,g:o}=this;let l;try{l=await(0,s.$Wm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,P.$bb)(i)))}const n={...process.env,...l},u=p.agent?p.agent:await(0,$.$ms)(p.url||"",n,{proxyUrl:w,strictSSL:o});return p.agent=u,p.strictSSL=o,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>m(p,d))}async resolveProxy(p){}async lookupAuthorization(p){}async lookupKerberosAuthorization(p){try{const d=await new Promise((u,i)=>{ue(["kerberos"],u,i)}).then(Ve),w=new URL(p),o=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${w.hostname}`:`HTTP@${w.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${w}`,`spn:${o}`),"Negotiate "+await(await d.initializeClient(o)).step("")}catch(d){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",d);return}}async loadCertificates(){return(await new Promise((d,w)=>{ue(["@vscode/proxy-agent"],d,w)}).then(Ve)).loadSystemCertificates({log:this.r})}};e.$ns=a,e.$ns=a=We([je(0,T.$ej),je(1,v.$Si),je(2,S.$fk),je(3,S.$gk)],a);async function c(b){return((0,t.parse)(b.url).protocol==="https:"?await new Promise((w,o)=>{ue(["https"],w,o)}).then(Ve):await new Promise((w,o)=>{ue(["http"],w,o)}).then(Ve)).request}async function m(b,p){return r.Promises.withAsyncBody(async(d,w)=>{const o=(0,t.parse)(b.url),l=b.getRawRequest?b.getRawRequest(b):await c(b),n={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,D.$pg)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(n.auth=b.user+":"+b.password);const u=l(n,i=>{const f=(0,D.$ng)(b.followRedirects)?b.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&f>0&&i.headers.location)m({...b,url:i.headers.location,followRedirects:f-1},p).then(d,w);else{let h=i;!b.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(h=i.pipe((0,g.createGunzip)())),d({res:i,stream:(0,E.$8e)(h)})}});u.on("error",w),b.timeout&&u.setTimeout(b.timeout),b.isChromiumNetwork&&u.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&u.write(b.data),u.end(),p.onCancellationRequested(()=>{u.abort(),w(new P.$9)})})}}),define(Te[158],Oe([1,0,50,84,14,6,2,12,8,3,70,78,28,11,94,145,146,55,267]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0,e.$Jn=d,t=Ve(t),r=Ve(r);async function d(i={},f,h,k,I,O){const C=await(0,m.$6m)(h,k.userDataPath);let L={};if(f)try{L=await(0,a.$Wm)(O,I,k.args,process.env)}catch(ve){I.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ve)}const M={...process.env,...L,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(C),...i},G=k.isBuilt?(0,v.$oc)(k.appRoot,"bin"):(0,v.$oc)(k.appRoot,"resources","server","bin-dev"),Q=(0,v.$oc)(G,"remote-cli");let te=l(M,"PATH");return te?te=Q+v.$yc+te:te=Q,n(M,"PATH",te),k.args["without-browser-env-var"]||(M.BROWSER=(0,v.$oc)(G,"helpers",s.$l?"browser.cmd":"browser.sh")),u(M),M}class w{constructor(f,h){this.socket=f,this.initialDataChunk=h}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let f,h,k;return this.socket instanceof y.$zi?(f=!0,h=!1,k=E.$Se.alloc(0)):(f=!1,h=this.socket.permessageDeflate,k=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:f,permessageDeflate:h,inflateBytes:k.buffer.toString("base64")}}}let o=class extends D.$Zc{constructor(f,h,k,I,O,C,L,R){super(),this.m=f,this.n=O,this.r=C,this.s=L,this.t=R,this.b=new P.$qe,this.onClose=this.b.event,this.c=!s.$l||!this.n.args["socket-path"],this.f=!1,this.g=h,this.h=null,this.j=new w(k,I),this.w("New connection established.")}dispose(){this.D(),super.dispose()}get u(){return`[${this.g}][${this.m.substr(0,8)}][ExtensionHostConnection] `}w(f){this.r.info(`${this.u}${f}`)}y(f){this.r.error(`${this.u}${f}`)}async z(f,h){const k=new D.$Yc;k.add(h.socket),k.add((0,D.$Xc)(()=>{f.destroy()}));const I=()=>{k.dispose()};k.add(h.socket.onEnd(I)),k.add(h.socket.onClose(I)),k.add(P.Event.fromNodeEventEmitter(f,"end")(I)),k.add(P.Event.fromNodeEventEmitter(f,"close")(I)),k.add(P.Event.fromNodeEventEmitter(f,"error")(I)),k.add(h.socket.onData(O=>f.write(O.buffer))),k.add(P.Event.fromNodeEventEmitter(f,"data")(O=>{h.socket.write(E.$Se.wrap(O))})),h.initialDataChunk.byteLength>0&&f.write(h.initialDataChunk.buffer)}async C(f,h){await h.socketDrain();const k=h.toIExtHostSocketMessage();let I;h.socket instanceof y.$zi?I=h.socket.socket:I=h.socket.socket.socket,f.send(k,I)}shortenReconnectionGraceTimeIfNecessary(){if(!this.h)return;const f={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.h.send(f)}acceptReconnection(f,h,k){this.g=f,this.w("The client has reconnected.");const I=new w(h,k);if(!this.h){this.j=I;return}this.C(this.h,I)}D(){this.f||(this.f=!0,this.j&&(this.j.socket.end(),this.j=null),this.h&&(this.h.kill(),this.h=null),this.b.fire(void 0))}async start(f){try{let h=process.execArgv?process.execArgv.filter(Q=>!/^--inspect(-brk)?=/.test(Q)):[];f.port&&!process.pkg&&(h=[`--inspect${f.break?"-brk":""}=${f.port}`]);const k=await d(f.env,!0,f.language,this.n,this.r,this.t);(0,S.$rm)(k);let I;if(this.c)(0,p.$ln)(new p.$jn,k),I=null;else{const{namedPipeServer:Q,pipeName:te}=await this.F();(0,p.$ln)(new p.$in(te),k),I=Q}const O={env:k,execArgv:h,silent:!0};O.execArgv.unshift("--dns-result-order=ipv4first");const C=["--type=extensionHost","--transformURIs"],L=this.n.args["use-host-proxy"];C.push(`--useHostProxy=${L?"true":"false"}`),this.h=t.fork(T.$5g.asFileUri("bootstrap-fork").fsPath,C,O);const R=this.h.pid;this.w(`<${R}> Launched Extension Host Process.`),this.h.stdout.setEncoding("utf8"),this.h.stderr.setEncoding("utf8");const M=P.Event.fromNodeEventEmitter(this.h.stdout,"data"),G=P.Event.fromNodeEventEmitter(this.h.stderr,"data");if(this.B(M(Q=>this.w(`<${R}> ${Q}`))),this.B(G(Q=>this.w(`<${R}><stderr> ${Q}`))),this.h.on("error",Q=>{this.y(`<${R}> Extension Host Process had an error`),this.r.error(Q),this.D()}),this.h.on("exit",(Q,te)=>{this.s.setExitInfo(this.m,{code:Q,signal:te}),this.w(`<${R}> Extension Host Process exited with code: ${Q}, signal: ${te}.`),this.D()}),I)I.on("connection",Q=>{I.close(),this.z(Q,this.j)});else{const Q=te=>{te.type==="VSCODE_EXTHOST_IPC_READY"&&(this.h.removeListener("message",Q),this.C(this.h,this.j),this.j=null)};this.h.on("message",Q)}}catch(h){console.error("ExtensionHostConnection errored"),h&&console.error(h)}}F(){return new Promise((f,h)=>{const k=(0,y.$Ci)(),I=r.createServer();I.on("error",h),I.listen(k,()=>{I?.removeListener("error",h),f({pipeName:k,namedPipeServer:I})})})}};e.$Kn=o,e.$Kn=o=We([je(4,b.$gn),je(5,g.$fk),je(6,c.$4m),je(7,$.$ej)],o);function l(i,f){const h=Object.keys(i).filter(I=>I.toLowerCase()===f.toLowerCase()),k=h.length>0?h[0]:f;return i[k]}function n(i,f,h){const k=Object.keys(i).filter(O=>O.toLowerCase()===f.toLowerCase()),I=k.length>0?k[0]:f;i[I]=h}function u(i){for(const f of Object.keys(i))i[f]===null&&delete i[f]}});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[281],Oe([1,0,89,11,72,131,28,47,157,40,24,30,143,141,95,123,61,2,125,73,12,15,29,55,134,92,135,9,4,8,32,225,88,35,139,71,3,63,147,33,54,74,144,142,127,128,7,282]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d,w,o,l,n,u,i,f,h,k,I,O,C,L,R,M,G,Q,te,ve,be,le,K,B,j,U,ee,ae,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=X,m=$t(m);class se extends b.$Zc{constructor(A,Y){super(),this.a=A,this.b=Y,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const A=await this.f();await A.invokeFunction(async Y=>{const pe=Y.get(D.$ej),x=Y.get(r.$fk);Q.$l&&(pe.getValue("security.restrictUNCAccess")===!1?(0,ye.disableUNCAccessRestrictions)():(0,ye.addUNCHostToAllowlist)(pe.getValue("security.allowedUNCHosts")));try{await this.g(A.createInstance(u.$Eq,new r.$nk(x.getLevel(),!1)))}catch(ie){throw x.error(ie),console.error((0,h.$bb)(ie)),ie}})}async f(){const A=new t.$Ii,Y={_serviceBrand:void 0,...m.default};A.set(l.$yk,Y);const pe=new n.$hn(this.a,Y);A.set(n.$gn,pe);const x=new ee.$3R((0,r.$tk)(pe),pe.logsHome);A.set(r.$gk,x);const ie=new U.$aS(this.B(x.createLogger("remoteCLI",{name:(0,ae.localize)(2503,null)})));A.set(r.$fk,ie),ie.trace(`Remote configuration data at ${this.b}`),ie.trace("process arguments:",this.a);const W=this.B(new p.$$q(ie));A.set(o.$fl,W),W.registerProvider(w.Schemas.file,this.B(new d.$Br(ie)));const Z=new M.$3s(W);A.set(R.$Pl,Z);const ce=this.B(new B.$$R(Z,pe,W,ie));A.set(be.$Rl,ce);const we=this.B(new P.$4o(ce.defaultProfile.settingsResource,W,new K.$Bo,ie));return A.set(D.$ej,we),await Promise.all([we.initialize(),ce.init()]),A.set(T.$bq,new E.$Hi(v.$ns)),A.set(L.$8o,new E.$Hi(C.$rS)),A.set(S.$em,s.$Fp),A.set(y.$rp,new E.$Hi($.$yq)),A.set(le.$Rq,new E.$Hi(j.$_R)),A.set(te.$Vq,new E.$Hi(ve.$YR)),A.set(a.$Bq,new E.$Hi(a.$Dq)),A.set(g.$7q,new E.$Hi(g.$8q)),A.set(i.$hs,new E.$Hi(f.$js)),new c.$Er(A)}async g(A){if(this.a["list-extensions"])return A.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const Y={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return A.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),Y,!!this.a.force)}else{if(this.a["uninstall-extension"])return A.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return A.updateExtensions();if(this.a["locate-extension"])return A.locateExtension(this.a["locate-extension"])}}h(A){return A.map(Y=>/\.vsix$/i.test(Y)?k.URI.file((0,I.$nc)(Y)?Y:(0,I.$oc)((0,O.cwd)(),Y)):Y)}}function ne(z){setTimeout(()=>process.exit(z),0)}async function X(z,A,Y){if(z.help){const x=m.default.serverApplicationName+(Q.$l?".cmd":"");console.log((0,G.$Km)(m.default.nameLong,x,m.default.version,Y,{noInputFiles:!0,noPipe:!0}));return}if(z.version){console.log((0,G.$Lm)(m.default.version,m.default.commit));return}const pe=new se(z,A);try{await pe.run(),ne(0)}catch{ne(1)}finally{pe.dispose()}}}),define(Te[283],Oe([1,0,78,293,23,278,4,11,98]),function(ue,e,t,r,E,P,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=e.$bR=void 0,r=Ve(r),E=Ve(E);class s{constructor($,g,a){this.b=$,this.c=g,this.f=a,this.a=r.createServer((c,m)=>this.h(c,m)),this.g().catch(c=>(g.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,g){const a=(m,b)=>{g.writeHead(m,{"content-type":"application/json"}),g.end(JSON.stringify(b||null),p=>p&&this.c.error(p))},c=[];$.setEncoding("utf8"),$.on("data",m=>c.push(m)),$.on("end",async()=>{try{const m=JSON.parse(c.join(""));let b;switch(m.type){case"open":b=await this.i(m);break;case"openExternal":b=await this.j(m);break;case"status":b=await this.l(m);break;case"extensionManagement":b=await this.k(m);break;default:a(404,`Unknown message type: ${m.type}`);break}a(200,b)}catch(m){const b=m instanceof Error?m.message:JSON.stringify(m);a(500,b),this.c.error("Error while processing pipe request",m)}})}async i($){const{fileURIs:g,folderURIs:a,forceNewWindow:c,diffMode:m,mergeMode:b,addMode:p,forceReuseWindow:d,gotoLineMode:w,waitMarkerFilePath:o,remoteAuthority:l}=$,n=[];if(Array.isArray(a))for(const h of a)try{n.push({folderUri:D.URI.parse(h)})}catch{}if(Array.isArray(g))for(const h of g)try{(0,v.$dj)(h)?n.push({workspaceUri:D.URI.parse(h)}):n.push({fileUri:D.URI.parse(h)})}catch{}const u=o?D.URI.file(o):void 0,f={forceNewWindow:c,diffMode:m,mergeMode:b,addMode:p,gotoLineMode:w,forceReuseWindow:d,preferNewWindow:!d&&!u&&!p,waitMarkerFileURI:u,remoteAuthority:l};this.b.executeCommand("_remoteCLI.windowOpen",n,f)}async j($){for(const g of $.uris){const a=D.URI.parse(g),c=a.scheme==="file"?a:g;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k($){const g=c=>c?.map(m=>/\.vsix$/i.test(m)?D.URI.parse(m):m),a={list:$.list,install:g($.install),uninstall:g($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",a)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&E.existsSync(this.f)&&E.unlinkSync(this.f)}}e.$bR=s;let S=class extends s{constructor($,g){super($,g,(0,t.$Ci)())}};e.$cR=S,e.$cR=S=We([je(0,P.$9Q),je(1,T.$fk)],S)}),define(Te[284],Oe([1,0,31,6,20,2,8,3,4,78,76,283,137,97,148,262,264,158,13,138]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RR=void 0,t=Ve(t),D=Ve(D),T=Ve(T),c=Ve(c);class w extends m.$QR{constructor(n,u,i,f,h){super({getFolderUri:k=>{const I=u.filter(O=>O.name===k);if(I&&I.length>0)return I[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(k,I)=>f[`config:${I}`],getExecPath:()=>n.VSCODE_EXEC_PATH,getAppRoot:()=>n.VSCODE_CWD,getFilePath:()=>{if(i)return D.$mc(i.fsPath)},getSelectedText:()=>f.selectedText,getLineNumber:()=>f.lineNumber,getExtension:async k=>{const O=(await h.getInstalled()).find(C=>C.identifier.id===k);return O&&{extensionLocation:O.location}}},void 0,Promise.resolve(t.homedir()),Promise.resolve(n))}}class o extends P.$Zc{constructor(n,u,i,f,h,k){super(),this.g=n,this.h=u,this.j=i,this.m=f,this.n=h,this.r=k,this.a=0,this.b=new Map,this.c=this.B(new r.$qe),this.onExecuteCommand=this.c.event}async call(n,u,i){switch(u){case a.RemoteTerminalChannelRequest.RestartPtyHost:return this.j.restartPtyHost.apply(this.j,i);case a.RemoteTerminalChannelRequest.CreateProcess:{const f=(0,S.$4s)(n.remoteAuthority);return this.s(f,i)}case a.RemoteTerminalChannelRequest.AttachToProcess:return this.j.attachToProcess.apply(this.j,i);case a.RemoteTerminalChannelRequest.DetachFromProcess:return this.j.detachFromProcess.apply(this.j,i);case a.RemoteTerminalChannelRequest.ListProcesses:return this.j.listProcesses.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetLatency:return this.j.getLatency.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetPerformanceMarks:return this.j.getPerformanceMarks.apply(this.j,i);case a.RemoteTerminalChannelRequest.OrphanQuestionReply:return this.j.orphanQuestionReply.apply(this.j,i);case a.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables:return this.j.acceptPtyHostResolvedVariables.apply(this.j,i);case a.RemoteTerminalChannelRequest.Start:return this.j.start.apply(this.j,i);case a.RemoteTerminalChannelRequest.Input:return this.j.input.apply(this.j,i);case a.RemoteTerminalChannelRequest.AcknowledgeDataEvent:return this.j.acknowledgeDataEvent.apply(this.j,i);case a.RemoteTerminalChannelRequest.Shutdown:return this.j.shutdown.apply(this.j,i);case a.RemoteTerminalChannelRequest.Resize:return this.j.resize.apply(this.j,i);case a.RemoteTerminalChannelRequest.ClearBuffer:return this.j.clearBuffer.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetInitialCwd:return this.j.getInitialCwd.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetCwd:return this.j.getCwd.apply(this.j,i);case a.RemoteTerminalChannelRequest.ProcessBinary:return this.j.processBinary.apply(this.j,i);case a.RemoteTerminalChannelRequest.SendCommandResult:return this.u(i[0],i[1],i[2]);case a.RemoteTerminalChannelRequest.InstallAutoReply:return this.j.installAutoReply.apply(this.j,i);case a.RemoteTerminalChannelRequest.UninstallAllAutoReplies:return this.j.uninstallAllAutoReplies.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetDefaultSystemShell:return this.w.apply(this,i);case a.RemoteTerminalChannelRequest.GetProfiles:return this.y.apply(this,i);case a.RemoteTerminalChannelRequest.GetEnvironment:return this.z();case a.RemoteTerminalChannelRequest.GetWslPath:return this.C(i[0],i[1]);case a.RemoteTerminalChannelRequest.GetTerminalLayoutInfo:return this.j.getTerminalLayoutInfo(i);case a.RemoteTerminalChannelRequest.SetTerminalLayoutInfo:return this.j.setTerminalLayoutInfo(i);case a.RemoteTerminalChannelRequest.SerializeTerminalState:return this.j.serializeTerminalState.apply(this.j,i);case a.RemoteTerminalChannelRequest.ReviveTerminalProcesses:return this.j.reviveTerminalProcesses.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetRevivedPtyNewId:return this.j.getRevivedPtyNewId.apply(this.j,i);case a.RemoteTerminalChannelRequest.SetUnicodeVersion:return this.j.setUnicodeVersion.apply(this.j,i);case a.RemoteTerminalChannelRequest.ReduceConnectionGraceTime:return this.D();case a.RemoteTerminalChannelRequest.UpdateIcon:return this.j.updateIcon.apply(this.j,i);case a.RemoteTerminalChannelRequest.UpdateTitle:return this.j.updateTitle.apply(this.j,i);case a.RemoteTerminalChannelRequest.UpdateProperty:return this.j.updateProperty.apply(this.j,i);case a.RemoteTerminalChannelRequest.RefreshProperty:return this.j.refreshProperty.apply(this.j,i);case a.RemoteTerminalChannelRequest.RequestDetachInstance:return this.j.requestDetachInstance(i[0],i[1]);case a.RemoteTerminalChannelRequest.AcceptDetachedInstance:return this.j.acceptDetachInstanceReply(i[0],i[1]);case a.RemoteTerminalChannelRequest.FreePortKillProcess:return this.j.freePortKillProcess.apply(this.j,i);case a.RemoteTerminalChannelRequest.AcceptDetachInstanceReply:return this.j.acceptDetachInstanceReply.apply(this.j,i)}throw new Error(`IPC Command ${u} not found`)}listen(n,u,i){switch(u){case a.RemoteTerminalChannelEvent.OnPtyHostExitEvent:return this.j.onPtyHostExit||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostStartEvent:return this.j.onPtyHostStart||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent:return this.j.onPtyHostUnresponsive||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent:return this.j.onPtyHostResponsive||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent:return this.j.onPtyHostRequestResolveVariables||r.Event.None;case a.RemoteTerminalChannelEvent.OnProcessDataEvent:return this.j.onProcessData;case a.RemoteTerminalChannelEvent.OnProcessReadyEvent:return this.j.onProcessReady;case a.RemoteTerminalChannelEvent.OnProcessExitEvent:return this.j.onProcessExit;case a.RemoteTerminalChannelEvent.OnProcessReplayEvent:return this.j.onProcessReplay;case a.RemoteTerminalChannelEvent.OnProcessOrphanQuestion:return this.j.onProcessOrphanQuestion;case a.RemoteTerminalChannelEvent.OnExecuteCommand:return this.onExecuteCommand;case a.RemoteTerminalChannelEvent.OnDidRequestDetach:return this.j.onDidRequestDetach||r.Event.None;case a.RemoteTerminalChannelEvent.OnDidChangeProperty:return this.j.onDidChangeProperty}throw new Error(`IPC Command ${u} not found`)}async s(n,u){const i={name:u.shellLaunchConfig.name,executable:u.shellLaunchConfig.executable,args:u.shellLaunchConfig.args,cwd:typeof u.shellLaunchConfig.cwd=="string"||typeof u.shellLaunchConfig.cwd>"u"?u.shellLaunchConfig.cwd:v.URI.revive(n.transformIncoming(u.shellLaunchConfig.cwd)),env:u.shellLaunchConfig.env,useShellEnvironment:u.shellLaunchConfig.useShellEnvironment,reconnectionProperties:u.shellLaunchConfig.reconnectionProperties,type:u.shellLaunchConfig.type,isFeatureTerminal:u.shellLaunchConfig.isFeatureTerminal},f=await(0,b.$Jn)(u.resolverEnv,!!u.shellLaunchConfig.useShellEnvironment,T.$z,this.g,this.h,this.r);this.h.trace("baseEnv",f);const h=K=>({uri:v.URI.revive(n.transformIncoming(K.uri)),name:K.name,index:K.index,toResource:()=>{throw new Error("Not implemented")}}),k=u.workspaceFolders.map(h),I=u.activeWorkspaceFolder?h(u.activeWorkspaceFolder):void 0,O=u.activeFileResource?v.URI.revive(n.transformIncoming(u.activeFileResource)):void 0,C=new w(f,k,O,u.resolvedVariables,this.n),L=c.$MR(I,process.env,C),R=await c.$LR(i,t.homedir(),L,I?.uri,u.configuration["terminal.integrated.cwd"],this.h);i.cwd=R;const M=T.$l?"terminal.integrated.env.windows":T.$m?"terminal.integrated.env.osx":"terminal.integrated.env.linux",G=u.configuration[M],Q=await c.$NR(i,G,L,this.m.version,u.configuration["terminal.integrated.detectLocale"],f);if((0,d.$FR)(i)){const K=[];for(const[ee,ae,ye]of u.envVariableCollections)K.push([ee,{map:(0,g.$Ps)(ae),descriptionMap:(0,g.$Qs)(ye)}]);const B=new Map(K),j=new $.$Ts(B),U=I?I??void 0:void 0;await j.applyToProcessEnvironment(Q,{workspaceFolder:U},L)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:i,initialCwd:R,cols:u.cols,rows:u.rows,env:Q});const te=(0,s.$Ci)();Q.VSCODE_IPC_HOOK_CLI=te;const ve=await this.j.createProcess(i,R,u.cols,u.rows,u.unicodeVersion,Q,f,u.options,u.shouldPersistTerminal,u.workspaceId,u.workspaceName),be={executeCommand:(K,...B)=>this.t(ve,K,B,n)},le=new y.$bR(be,this.h,te);return this.j.onProcessExit(K=>K.id===ve&&le.dispose()),{persistentTerminalId:ve,resolvedShellLaunchConfig:i}}t(n,u,i,f){const{resolve:h,reject:k,promise:I}=(0,p.$Dh)(),O=++this.a;this.b.set(O,{resolve:h,reject:k,uriTransformer:f});const C=(0,E.$mo)(i,L=>{if(L&&L.$mid===1)return f.transformOutgoing(L);if(L&&L instanceof v.URI)return f.transformOutgoingURI(L)});return this.c.fire({reqId:O,persistentProcessId:n,commandId:u,commandArgs:C}),I}u(n,u,i){const f=this.b.get(n);if(!f)return;this.b.delete(n);const h=(0,E.$mo)(i,k=>{if(k&&k.$mid===1)return f.uriTransformer.transformIncoming(k)});u?f.reject(h):f.resolve(h)}w(n){return this.j.getDefaultSystemShell(n)}async y(n,u,i,f){return this.j.getProfiles(n,u,i,f)||[]}z(){return{...process.env}}C(n,u){return this.j.getWslPath(n,u)}D(){return this.j.reduceConnectionGraceTime()}}e.$RR=o});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[285],Oe([1,0,31,6,2,12,8,113,26,51,60,28,131,198,88,199,27,143,30,95,134,223,141,15,125,73,72,123,89,92,135,11,61,29,47,226,157,133,24,40,238,53,245,35,139,256,257,232,236,284,76,55,266,279,145,63,147,54,33,74,237,128,144,142,127,126,7,274,222,250,242,124]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d,w,o,l,n,u,i,f,h,k,I,O,C,L,R,M,G,Q,te,ve,be,le,K,B,j,U,ee,ae,ye,se,ne,X,z,A,Y,pe,x,ie,W,Z,ce,we,Le,ze,qe,Re,Ne,De,Ce,ge,Se,Pe,Ue){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mS=void 0,e.$lS=Qe,D=Ve(D),L=$t(L),le=$t(le);const Ge="monacoworkbench";async function Qe(st,Je,me,V){const _=new k.$Ii,fe=new tt,re={_serviceBrand:void 0,...L.default};_.set(R.$yk,re);const he=new z.$hn(Je,re);_.set(m.$Ri,he),_.set(m.$Si,he);const H=new Le.$3R((0,C.$tk)(he),he.logsHome);_.set(C.$gk,H),fe.registerChannel("logger",new Ne.$Cs(H,dt=>Xe(dt.remoteAuthority)));const J=H.createLogger("remoteagent",{name:(0,De.localize)(2517,null)}),$e=new Re.$aS(J,[new lt((0,C.$tk)(he))]);_.set(C.$fk,$e),setTimeout(()=>ut(he.logsHome.with({scheme:P.Schemas.file}).fsPath).then(null,dt=>$e.error(dt)),1e4),$e.onDidChangeLogLevel(dt=>(0,C.log)($e,dt,`Log level changed to ${(0,C.$uk)($e.getLevel())}`)),$e.trace(`Remote configuration data at ${me}`),$e.trace("process arguments:",he.args),Array.isArray(re.serverGreeting)&&$e.info(`

${re.serverGreeting.join(`
`)}

`),fe.registerChannel(g.$6o.ChannelName,new g.$6o);const Fe=new s.$si(dt=>dt.clientId==="renderer"),He=V.add(new u.$$q($e));_.set(n.$fl,He),He.registerProvider(P.Schemas.file,V.add(new i.$Br($e)));const xe=new U.$3s(He);_.set(j.$Pl,xe);const et=new $.$4o(he.machineSettingsResource,He,new ce.$Bo,$e);_.set(y.$ej,et);const it=new ze.$$R(xe,he,He,$e);_.set(Z.$Rl,it),fe.registerChannel("userDataProfiles",new Se.$gS(it,dt=>Xe(dt.remoteAuthority))),_.set(Ue.$jS,new f.$Hi(Ue.$kS,void 0,!0));const[,,ft,gt,Et]=await Promise.all([et.initialize(),it.init(),(0,T.$Zn)($e.error.bind($e)),(0,T.$1n)($e.error.bind($e)),(0,T.$2n)($e.error.bind($e))]),Rt=new pe.$5m;_.set(pe.$4m,Rt);const mt=new Q.$ns(et,he,$e,H);_.set(M.$bq,mt);let pt=be.$Jp;const wt=(0,be.$Pp)(re,et);if((0,be.$Kp)(re,he)){!(0,be.$Lp)(re,he)&&re.aiConfig?.ariaKey&&(pt=new we.$1R(mt,wt,Ge,null,re.aiConfig.ariaKey),V.add((0,E.$Xc)(()=>pt?.flush())));const dt={appenders:[pt],commonProperties:(0,te.$Bp)((0,t.release)(),(0,t.hostname)(),process.arch,re.commit,re.version+"-remote",ft,gt,Et,wt,"remoteAgent"),piiPaths:(0,be.$Qp)(he)},vt=he.args["telemetry-level"];let bt=ve.TelemetryLevel.USAGE;vt==="all"?bt=ve.TelemetryLevel.USAGE:vt==="error"?bt=ve.TelemetryLevel.ERROR:vt==="crash"?bt=ve.TelemetryLevel.CRASH:vt!==void 0&&(bt=ve.TelemetryLevel.NONE),_.set(se.$et,new f.$Hi(se.$ct,[dt,bt]))}else _.set(se.$et,se.$dt);_.set(p.$rp,new f.$Hi(b.$yq));const Wt=fe.getChannel("download",Fe);_.set(a.$8o,new c.$0o(Wt,()=>Xe("renderer"))),_.set(W.$Rq,new f.$Hi(qe.$_R)),_.set(x.$Vq,new f.$Hi(ie.$YR)),_.set(d.$Bq,new f.$Hi(d.$Dq)),_.set(l.$7q,new f.$Hi(l.$8q));const It=new h.$Er(_);_.set(I.$hs,It.createInstance(O.$js));const Ct=It.createInstance(Pe.$iS,{graceTime:S.ProtocolConstants.ReconnectionGraceTime,shortGraceTime:S.ProtocolConstants.ReconnectionShortGraceTime,scrollback:et.getValue(K.TerminalSettingId.PersistentSessionScrollback)??100}),Nt=It.createInstance(B.$Ys,Ct);return _.set(K.$xs,Nt),It.invokeFunction(dt=>{const vt=dt.get(l.$7q),bt=dt.get(x.$Vq),Bt=dt.get(p.$rp),jt=dt.get(I.$hs),_t=new ee.$$s(st,he,it,Rt);fe.registerChannel("remoteextensionsenvironment",_t);const Ot=new ye.$ft(dt.get(se.$et),pt);fe.registerChannel("telemetry",Ot),fe.registerChannel(A.$SR,new ne.$RR(he,$e,Nt,re,vt,et));const Ft=new Ce.$eS(It.createInstance(w.$Eq,$e),he,it,bt,$e,Bt,jt);fe.registerChannel(ge.$dS,new Ce.$fS(Ft,St=>Xe(St.remoteAuthority)));const Vt=V.add(new ae.$bt($e,he));fe.registerChannel(Y.$WR,Vt),fe.registerChannel("request",new G.$ks(dt.get(M.$bq)));const Gt=new o.$Fq(vt,St=>Xe(St.remoteAuthority));return fe.registerChannel("extensions",Gt),Ft.whenExtensionsReady().then(()=>vt.cleanUp()),V.add(new le.default(dt.get(ve.$em))),{telemetryService:dt.get(ve.$em)}}),{socketServer:fe,instantiationService:It}}const Ze=Object.create(null);function Xe(st){return Ze[st]||(Ze[st]=(0,X.$4s)(st)),Ze[st]}class tt extends s.$oi{constructor(){const Je=new r.$qe;super(Je.event),this.b=Je}acceptConnection(Je,me){this.b.fire({protocol:Je,onDidClientDisconnect:me})}}e.$mS=tt;class lt extends C.$kk{constructor(Je=C.$ik){super(),this.setLevel(Je),this.g=!!process.stdout.isTTY}trace(Je,...me){this.f(C.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${ct()}]\x1B[0m`,Je,...me):console.log(`[${ct()}]`,Je,...me))}debug(Je,...me){this.f(C.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${ct()}]\x1B[0m`,Je,...me):console.log(`[${ct()}]`,Je,...me))}info(Je,...me){this.f(C.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${ct()}]\x1B[0m`,Je,...me):console.log(`[${ct()}]`,Je,...me))}warn(Je,...me){this.f(C.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${ct()}]\x1B[0m`,Je,...me):console.warn(`[${ct()}]`,Je,...me))}error(Je,...me){this.f(C.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${ct()}]\x1B[0m`,Je,...me):console.error(`[${ct()}]`,Je,...me))}flush(){}}function ct(){const st=new Date;return`${rt(st.getHours())}:${rt(st.getMinutes())}:${rt(st.getSeconds())}`}function rt(st){return st<10?`0${st}`:String(st)}async function ut(st){const Je=D.$sc(st),me=D.$rc(st),fe=(await v.Promises.readdir(me)).filter(he=>/^\d{8}T\d{6}$/.test(he)).sort().filter(he=>he!==Je),re=fe.slice(0,Math.max(0,fe.length-9));await Promise.all(re.map(he=>v.Promises.rm(D.$oc(me,he))))}}),define(Te[286],Oe([1,0,96,23,84,287,93,64,14,34,9,36,2,12,8,44,3,16,4,22,193,181,282,60,78,28,5,11,29,221,24,158,251,101,55,285,253]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$,g,a,c,m,b,p,d,w,o,l,n,u,i,f,h,k,I,O,C,L,R,M,G,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qS=be,t=Ve(t),r=Ve(r),E=Ve(E),D=Ve(D),c=Ve(c),m=Ve(m);const te=5*60*1e3;let ve=class extends $.$Zc{constructor(B,j,U,ee,ae,ye,se,ne,X){super(),this.n=B,this.r=j,this.s=U,this.t=ye,this.u=se,this.w=ne,this.y=X,this.h=le.create(this.u),this.j=(0,g.$Yg)(se,ae),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=ee?this.y.createInstance(Q.$pS,this.r,ae??"/",this.j):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(B,j){if(B.method!=="GET")return(0,Q.$nS)(B,j,405,`Unsupported method ${B.method}`);if(!B.url)return(0,Q.$nS)(B,j,400,"Bad request.");const U=D.parse(B.url,!0);let ee=U.pathname;if(!ee)return(0,Q.$nS)(B,j,400,"Bad request.");if(ee.startsWith(this.j)&&ee.charCodeAt(this.j.length)===s.CharCode.Slash&&(ee=ee.substring(this.j.length)),ee==="/version")return j.writeHead(200,{"Content-Type":"text/plain"}),void j.end(this.u.commit||"");if(ee==="/delay-shutdown")return this.N(),j.writeHead(200),void j.end("OK");if(!(0,R.$Rn)(this.r,B,U))return(0,Q.$nS)(B,j,403,"Forbidden.");if(ee==="/vscode-remote-resource"){const ae=U.query.path;if(typeof ae!="string")return(0,Q.$nS)(B,j,400,"Bad request.");let ye;try{ye=p.URI.from({scheme:g.Schemas.file,path:ae}).fsPath}catch{return(0,Q.$nS)(B,j,400,"Bad request.")}const se=Object.create(null);this.t.isBuilt&&((0,y.$Jg)(ye,this.t.builtinExtensionsPath,!m.$n)||(0,y.$Jg)(ye,this.t.extensionsPath,!m.$n))&&(se["Cache-Control"]="public, max-age=31536000"),se.Vary="Origin";const ne=B.headers.origin;return ne&&this.h.matches(ne)&&(se["Access-Control-Allow-Origin"]=ne),(0,Q.$oS)(ye,Q.CacheControl.ETAG,this.w,B,j,se)}if(this.g){this.g.handle(B,j,U);return}return j.writeHead(404,{"Content-Type":"text/plain"}),void j.end("Not found")}handleUpgrade(B,j){let U=(0,d.$7g)(),ee=!1,ae=!1;if(B.url){const A=D.parse(B.url,!0).query;typeof A.reconnectionToken=="string"&&(U=A.reconnectionToken),A.reconnection==="true"&&(ee=!0),A.skipWebSocketFrames==="true"&&(ae=!0)}if(B.headers.upgrade===void 0||B.headers.upgrade.toLowerCase()!=="websocket"){j.end("HTTP/1.1 400 Bad Request");return}const ye=B.headers["sec-websocket-key"],se=t.createHash("sha1");se.update(ye+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const X=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${se.digest("base64")}`];let z=!1;if(!ae&&!this.t.args["disable-websocket-compression"]&&B.headers["sec-websocket-extensions"]){const A=Array.isArray(B.headers["sec-websocket-extensions"])?B.headers["sec-websocket-extensions"]:[B.headers["sec-websocket-extensions"]];for(const Y of A)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(Y)){if(/\b(permessage-deflate)\b/.test(Y)){z=!0,X.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(Y)){z=!0,X.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}j.write(X.join(`\r
`)+`\r
\r
`),j.setTimeout(0),j.setNoDelay(!0),ae?this.D(new u.$zi(j,`server-connection-${U}`),ee,U):this.D(new u.$Ai(new u.$zi(j,`server-connection-${U}`),z,null,!0),ee,U)}handleServerError(B){this.w.error("Error occurred in server"),this.w.error(B)}z(B){let j;return B instanceof u.$zi?j=B.socket:j=B.socket.socket,j.remoteAddress||"<unknown>"}async C(B,j,U){const ee=j.getSocket();this.w.error(`${B} ${U}.`);const ae={type:"error",reason:U};j.sendControl(v.$Se.fromString(JSON.stringify(ae))),j.dispose(),await ee.drain(),ee.dispose()}D(B,j,U){const ee=this.z(B),ae=`[${ee}][${U.substr(0,8)}]`,ye=new n.$yi({socket:B}),se=this.s?new this.s.validator:null,ne=this.s?new this.s.signer:null;let X;(function(pe){pe[pe.WaitingForAuth=0]="WaitingForAuth",pe[pe.WaitingForConnectionType=1]="WaitingForConnectionType",pe[pe.Done=2]="Done",pe[pe.Error=3]="Error"})(X||(X={}));let z=X.WaitingForAuth;const A=pe=>{z=X.Error,Y.dispose(),this.C(ae,ye,pe)},Y=ye.onControlMessage(pe=>{if(z===X.WaitingForAuth){let x;try{x=JSON.parse(pe.toString())}catch{return A("Malformed first message")}if(x.type!=="auth")return A("Invalid first message");if(this.r.type===R.ServerConnectionTokenType.Mandatory&&!this.r.validate(x.auth))return A("Unauthorized client refused: auth mismatch");let ie=(0,d.$7g)();if(ne)try{ie=ne.sign(x.data)}catch{}let W=(0,d.$7g)();if(se)try{W=se.createNewMessage(W)}catch{}const Z={type:"sign",data:W,signedData:ie};ye.sendControl(v.$Se.fromString(JSON.stringify(Z))),z=X.WaitingForConnectionType}else if(z===X.WaitingForConnectionType){let x;try{x=JSON.parse(pe.toString())}catch{return A("Malformed second message")}if(x.type!=="connectionType")return A("Invalid second message");if(typeof x.signedData!="string")return A("Invalid second message field type");const ie=x.commit,W=this.u.commit;if(ie&&W&&ie!==W)return A("Client refused: version mismatch");let Z=!1;if(!se)Z=!0;else if(this.r.validate(x.signedData))Z=!0;else try{Z=se.validate(x.signedData)==="ok"}catch{}if(!Z){if(this.t.isBuilt)return A("Unauthorized client refused");this.w.error(`${ae} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const ce in this.b)this.b[ce].shortenReconnectionGraceTimeIfNecessary();for(const ce in this.a)this.a[ce].shortenReconnectionGraceTimeIfNecessary();z=X.Done,Y.dispose(),this.F(ee,ae,ye,B,j,U,x)}})}async F(B,j,U,ee,ae,ye,se){const ne=se.desiredConnectionType===I.ConnectionType.Management?`${j}[ManagementConnection]`:se.desiredConnectionType===I.ConnectionType.ExtensionHost?`${j}[ExtensionHostConnection]`:j;if(se.desiredConnectionType===I.ConnectionType.Management)if(ae){if(!this.b[ye])return this.f.has(ye)?this.C(ne,U,"Unknown reconnection token (seen before)"):this.C(ne,U,"Unknown reconnection token (never seen)");U.sendControl(v.$Se.fromString(JSON.stringify({type:"ok"})));const X=U.readEntireBuffer();U.dispose(),this.b[ye].acceptReconnection(B,ee,X)}else{if(this.b[ye])return this.C(ne,U,"Duplicate reconnection token");U.sendControl(v.$Se.fromString(JSON.stringify({type:"ok"})));const X=new L.$Ln(this.w,ye,B,U);this.n.acceptConnection(X.protocol,X.onClose),this.b[ye]=X,this.f.add(ye),X.onClose(()=>{delete this.b[ye]})}else if(se.desiredConnectionType===I.ConnectionType.ExtensionHost){const X=se.args||{language:"en"},z=await this.I(X);if(z.port&&this.w.trace(`${ne} - startParams debug port ${z.port}`),this.w.trace(`${ne} - startParams language: ${z.language}`),this.w.trace(`${ne} - startParams env: ${JSON.stringify(z.env)}`),ae){if(!this.a[ye])return this.f.has(ye)?this.C(ne,U,"Unknown reconnection token (seen before)"):this.C(ne,U,"Unknown reconnection token (never seen)");U.sendPause(),U.sendControl(v.$Se.fromString(JSON.stringify(z.port?{debugPort:z.port}:{})));const A=U.readEntireBuffer();U.dispose(),this.a[ye].acceptReconnection(B,ee,A)}else{if(this.a[ye])return this.C(ne,U,"Duplicate reconnection token");U.sendPause(),U.sendControl(v.$Se.fromString(JSON.stringify(z.port?{debugPort:z.port}:{})));const A=U.readEntireBuffer();U.dispose();const Y=this.y.createInstance(C.$Kn,ye,B,ee,A);this.a[ye]=Y,this.f.add(ye),Y.onClose(()=>{Y.dispose(),delete this.a[ye],this.J()}),Y.start(z)}}else if(se.desiredConnectionType===I.ConnectionType.Tunnel){const X=se.args;this.G(U,X)}else return this.C(ne,U,"Unknown initial data received")}async G(B,j){const U=B.getSocket().socket,ee=B.readEntireBuffer();B.dispose(),U.pause();const ae=await this.H(j.host,j.port);ee.byteLength>0&&ae.write(ee.buffer),ae.on("end",()=>U.end()),ae.on("close",()=>U.end()),ae.on("error",()=>U.destroy()),U.on("end",()=>ae.end()),U.on("close",()=>ae.end()),U.on("error",()=>ae.destroy()),ae.pipe(U),U.pipe(ae)}H(B,j){return new Promise((U,ee)=>{const ae=E.createConnection({host:B,port:j,autoSelectFamily:!0},()=>{ae.removeListener("error",ee),ae.pause(),U(ae)});ae.once("error",ee)})}I(B){return typeof B.port=="number"?(0,o.$9g)(B.port,10,5e3).then(j=>(B.port=j,B)):(B.debugId=void 0,B.port=void 0,B.break=void 0,Promise.resolve(B))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(B=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!B?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},te))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};ve=We([je(5,M.$gn),je(6,k.$yk),je(7,h.$fk),je(8,f.$Ji)],ve);async function be(K,B,j){const U=await(0,R.$Qn)(B);U instanceof R.$On&&(console.warn(U.message),process.exit(1));function ee(ce){(0,S.setUnexpectedErrorHandler)(we=>{(0,S.$3)(we)&&we.stack&&/unexpectedErrorHandler/.test(we.stack)||ce(we)})}const ae=[];ee(ce=>{ae.push(ce),console.error(ce)});let ye=!1;process.on("SIGPIPE",()=>{ye||(ye=!0,(0,S.$4)(new Error("Unexpected SIGPIPE")))});const se=new $.$Yc,{socketServer:ne,instantiationService:X}=await(0,G.$lS)(U,B,j,se);X.invokeFunction(ce=>{const we=ce.get(h.$fk);ae.forEach(Le=>we.error(Le)),ae.length=0,ee(Le=>we.error(Le))}),X.invokeFunction(ce=>{const we=ce.get(i.$ej);m.$l&&(we.getValue("security.restrictUNCAccess")===!1?(0,l.disableUNCAccessRestrictions)():(0,l.addUNCHostToAllowlist)(we.getValue("security.allowedUNCHosts")))}),X.invokeFunction(ce=>{const we=ce.get(h.$fk);if(m.$l&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const Le=(0,a.$oc)(process.env.HOMEDRIVE,"node_modules"),ze=(0,a.$rc)((0,a.$oc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),qe=(0,a.$oc)(ze,"node_modules");if(r.existsSync(Le)||r.existsSync(qe)){const Re=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${Le}
* ${qe}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;we.warn(Re),console.warn(Re),process.exit(0)}}});const z=X.invokeFunction(ce=>{const we=ce.get(h.$fk);if(r.existsSync((0,a.$oc)(g.$5g.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(ze){we.error(ze)}return null});let A=B["server-base-path"];A&&!A.startsWith("/")&&(A=`/${A}`);const Y=r.existsSync(g.$5g.asFileUri(`vs/code/browser/workbench/workbench.${T.$V?"esm.":""}html`).fsPath);if(Y&&K&&typeof K!="string"){const ce=U.type!==R.ServerConnectionTokenType.None?`?${g.$Wg}=${U.value}`:"";console.log(`Web UI available at http://localhost${K.port===80?"":`:${K.port}`}${A??""}${ce}`)}const pe=X.createInstance(ve,ne,U,z,Y,A);c.mark("code/server/ready");const x=P.performance.now(),ie=global.vscodeServerStartTime,W=global.vscodeServerListenTime,Z=global.vscodeServerCodeLoadedTime;if(X.invokeFunction(async ce=>{const we=ce.get(O.$em);if(we.publicLog2("serverStart",{startTime:ie,startedTime:W,codeLoadedTime:Z,readyTime:x}),m.$n){const Le=ce.get(h.$fk),ze=await(0,w.$8g)(Le.error.bind(Le));ze&&we.publicLog2("serverPlatformInfo",{platformId:ze.id,platformVersionId:ze.version_id,platformIdLike:ze.id_like})}}),B["print-startup-performance"]){const ce=T.$X.get();let we="";we+=`

### Load AMD-module
`,we+=T.$X.toMarkdownTable(["Module","Duration"],ce.amdLoad),we+=`

### Load commonjs-module
`,we+=T.$X.toMarkdownTable(["Module","Duration"],ce.nodeRequire),we+=`

### Invoke AMD-module factory
`,we+=T.$X.toMarkdownTable(["Module","Duration"],ce.amdInvoke),we+=`

### Invoke commonjs-module
`,we+=T.$X.toMarkdownTable(["Module","Duration"],ce.nodeEval),we+=`Start-up time: ${W-ie}
`,we+=`Code loading time: ${Z-ie}
`,we+=`Initialized time: ${x-ie}
`,we+=`
`,console.log(we)}return pe}class le{static create(B){const j=B.webEndpointUrlTemplate,U=B.commit,ee=B.quality;if(!j||!U||!ee)return new le(null);const ae=(0,d.$7g)(),se=new URL(j.replace("{{uuid}}",ae).replace("{{commit}}",U).replace("{{quality}}",ee)).origin,ne=(0,b.$mf)(se).replace(ae,"[a-zA-Z0-9\\-]+");try{const X=(0,b.$vf)(`^${ne}$`,!0,{matchCase:!1});return new le(X)}catch{return new le(null)}}constructor(B){this.a=B}matches(B){return this.a?this.a.test(B):!1}}});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Te[294],Oe([1,0,31,23,12,281,286,71,8,287,55,61,44]),function(ue,e,t,r,E,P,D,T,v,s,S,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=n,e.createServer=u,t=Ve(t),r=Ve(r),y=$t(y),$=Ve($),$.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=s.performance.now();const g={onMultipleValues:(i,f)=>{console.error(`Option '${i}' can only be defined once. Using value ${f}.`)},onEmptyValue:i=>{console.error(`Ignoring option '${i}': Value must not be empty.`)},onUnknownOption:i=>{console.error(`Ignoring option '${i}': not supported for server.`)},onDeprecatedOption:(i,f)=>{console.warn(`Option '${i}' is deprecated: ${f}`)}},a=(0,T.$Im)(process.argv.slice(2),S.$fn,g),c=a["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.$oc)(t.homedir(),y.default.serverDataFolderName||".vscode-remote"),m=(0,v.$oc)(c,"data"),b=(0,v.$oc)(m,"User"),p=(0,v.$oc)(b,"globalStorage"),d=(0,v.$oc)(b,"History"),w=(0,v.$oc)(m,"Machine");a["user-data-dir"]=m;const o=(0,v.$rc)(E.$5g.asFileUri("").fsPath),l=(0,v.$oc)(o,"extensions");a["builtin-extensions-dir"]=l,a["extensions-dir"]=a["extensions-dir"]||(0,v.$oc)(c,"extensions"),[c,a["extensions-dir"],m,b,w,p,d].forEach(i=>{try{r.existsSync(i)||r.mkdirSync(i,{mode:448})}catch(f){console.error(f)}});function n(){(0,P.run)(a,c,S.$fn)}function u(i){return(0,D.$qS)(i,a,c)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/69df01185ce2f80e99c9e4f8c8de1907cc7a9bc5/core/vs/server/node/server.main.js.map
